(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)



























































BeginPackage["Personal`SurvPkg`","Statistics`DataManipulation`"]





SurvPkg::usage = "SurvPkg.m is a package that provides Survival Analysis tools for investigating Time to Event Data."



surv\[EmptyVerySmallSquare]data::usage = "surv\[EmptyVerySmallSquare]data[{t,\[Delta]}] inputs the data into the package and computes the Empirical Survival table."



event\[EmptyVerySmallSquare]time::usage = "event\[EmptyVerySmallSquare]time[t] returns the closest time of an event to the entered time t."



surv::usage = "surv[t] provides the Kaplan-Meier survival probability at the entered time t."



failCDF::"usage"="failCDF[t] provides the cumulative failure probability at \
the entered time t."



p\[EmptyVerySmallSquare]value::"usage"=
  "p\[EmptyVerySmallSquare]value[t] provides the plotting position for the \
entered time t."



se\[EmptyVerySmallSquare]surv::"usage"="se\[EmptyVerySmallSquare]surv[t] \
provides the standard error of survival probability at the entered time t by \
Greenwood's formula."





Censor::indicator = "The censor indicator is missing"









Begin["`Private`"]











i\[EmptyVerySmallSquare]t = 1;
i\[EmptyVerySmallSquare]n = 2;
i\[EmptyVerySmallSquare]d = 3;
i\[EmptyVerySmallSquare]S = 4;
i\[EmptyVerySmallSquare]p = 5;
i\[EmptyVerySmallSquare]se = 6;





\!\(surv\[EmptyVerySmallSquare]data[all\[EmptyVerySmallSquare]times_] := 
    Module[{tabledata = 
          Sort[all\[EmptyVerySmallSquare]times, 
            OrderedQ[{#1\[LeftDoubleBracket]1\[RightDoubleBracket], #2\
\[LeftDoubleBracket]1\[RightDoubleBracket]}] &], times, \[Delta], 
        failure\[EmptyVerySmallSquare]times, 
        event\[EmptyVerySmallSquare]times, \[CapitalDelta]n, n, d, Sa, p, 
        strunc, s, se, display\[EmptyVerySmallSquare]times, 
        set\[EmptyVerySmallSquare]data, EST}, \[IndentingNewLine]tabledata = 
        Select[tabledata, #\[LeftDoubleBracket]
                i\[EmptyVerySmallSquare]t\[RightDoubleBracket] > 
              0 &]; \[IndentingNewLine]times = 
        tabledata\[LeftDoubleBracket]All, 
          1\[RightDoubleBracket]; \n\[Delta] = 
        tabledata\[LeftDoubleBracket]All, 2\[RightDoubleBracket]; \n
      failure\[EmptyVerySmallSquare]times = 
        Select[times*\[Delta], # > 0 &]; \n
      event\[EmptyVerySmallSquare]times = 
        Complement[
          failure\[EmptyVerySmallSquare]times, {0}]; \n\[CapitalDelta]n = 
        RangeCounts[times, event\[EmptyVerySmallSquare]times]; \n
      n = Length[times] - FoldList[Plus, 0, \[CapitalDelta]n]; \n
      d = RangeCounts[failure\[EmptyVerySmallSquare]times, 
          event\[EmptyVerySmallSquare]times]; \n
      n = Take[n, {1, Length[d]}]; \nSa = 1 - d/n; \n
      S = N[Rest[FoldList[Times, 1, Sa]], 6]; \n
      p = 1 - ListCorrelate[{1/2, 1/2}, S]; \np = Prepend[p, 0]; \n
      strunc = Append[Drop[d, \(-1\)]/Drop[n*\((n - d)\), \(-1\)], 0]; \n
      s = N[If[Last[n - d] > 0, d/\((n*\((n - d)\))\), strunc], 8]; \n
      se = S*\@Rest[FoldList[Plus, 0, s]]; \n
      display\[EmptyVerySmallSquare]times = 
        Prepend[event\[EmptyVerySmallSquare]times, 0]; \n
      survivalTable = 
        Transpose[
          Partition[
            Join[display\[EmptyVerySmallSquare]times, n, d, S, p, se], 
            Length[display\[EmptyVerySmallSquare]times]]]\ ; \n
      ESHeadings = {"\<time\>", "\<n\>", "\<d\>", "\<S\>", "\<p\>", \
"\<se\>"}; \n
      OutputData = 
        TableForm[survivalTable, TableSpacing \[Rule] {1, 2}, 
          TableAlignments \[Rule] Center, 
          TableHeadings \[Rule] {None, ESHeadings}]; \nOutputData]\)



survEntry[t_,i\[EmptyVerySmallSquare]col_]:=
  Last[Select[
        survivalTable,#\[LeftDoubleBracket]
              i\[EmptyVerySmallSquare]t\[RightDoubleBracket]\[LessEqual]
            t&]]\[LeftDoubleBracket]
    i\[EmptyVerySmallSquare]col\[RightDoubleBracket]



event\[EmptyVerySmallSquare]time[t_]:=survEntry[t,i\[EmptyVerySmallSquare]t]



surv[t_]:=survEntry[t,i\[EmptyVerySmallSquare]S]



failCDF[t_]:=1-survEntry[t,i\[EmptyVerySmallSquare]S]



p\[EmptyVerySmallSquare]value[t_]:=survEntry[t,i\[EmptyVerySmallSquare]p]



se\[EmptyVerySmallSquare]surv[t_]:=survEntry[t,i\[EmptyVerySmallSquare]se]



End[ ]









(*Protect[ surv\[EmptyVerySmallSquare]data, survivalTable,event\[EmptyVerySmallSquare]time,surv,failCDF,p\[EmptyVerySmallSquare]value,se\[EmptyVerySmallSquare]surv]*)







EndPackage[ ]

























