(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1079221,      22227]*)
(*NotebookOutlinePosition[   1169399,      25174]*)
(*  CellTagsIndexPosition[   1169273,      25167]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000@F0000XB000`400?l00000o`00003o00CookYj
oonkN_oo^g[ookYj0ooo^gX00ooo^W[ook]joonjNP02oonjNP03oonkN_oo^W[ookYj00Gook]j00?o
okYjoonkN_oo^gX00ooo^WX2oonkNP03oonjN_oo^g[ookYj00Cook]j0_oo^WX01?oo^g[ookYjoonk
N_oo^gX2oonjNP03oonjNooo^g[ook]j00;ook]j00?ookYjoonkN_oo^gX01Ooo^gX2oonjNPGook]j
00KookYjoonkN_oo^W[ookYjoonkN_oo^WX3oonkNP03oonjN_oo^g[ook]j00?ook]j00CookYjoonk
N_oo^W[ookYj1Ooo^gX2oonjNPCook]j00?ookYjoonkN_oo^gX01Ooo^WX00ooo^g[ookYjoonjNP03
oonjNP03oonkN_oo^W[ook]j00;ookYj0_oo^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[o
ok]j00;ook]j00KookYjoonkN_oo^g[ookYjoonkN_oo^WX2oonkNP?ookYj0ooo^gX2oonjNP04oonk
N_oo^W[ook]joonjNP;ook]j00?ookYjoonkN_oo^gX00_oo^WX01?oo^g[ookYjoonjN_oo^WX2oonk
NP05oonjN_oo^g[ook]joonjN_oo^gX00_oo^WX9oonkNP03oonjN_oo^g[ookYj00;ook]j00SookYj
oonkN_oo^W[ookYjoonkN_oo^W[ook]joonjNP?ook]j0ooo^WX5oonkNP05oonjN_oo^g[ook]joonk
N_oo^WX01?oo^gX2oonjNPGook]j0_oo^WX2oonkNP05oonjN_oo^g[ook]joonjN_oo^gX01?oo^WX4
oonkNP;ookYj0_oo^gX3oonjNP?ook]j00Gook]koonkN_oo^g[ook]joonjNP05oonkNP03oonjN_oo
^g[ookYj00;ook]j00?ookYjoonkN_oo^WX00_oo^WX2oonkNP;ookYj01gook]joonjN_oo^W[ookai
ooC?K_oXh6;onNMCooo[A_oljDGon^E8ooSRBoojgdkon]m@oocJC_onf4SoomE2ooo???oobCKool4e
oojj=_on/3SooJ/noofW@_olXdConii5oo^MA_olW4Ooni]9ooZKB`03ooZLBP0<ooZLB?okW4Sonie8
oo^MB?ojW4SonYe8oo^LAoojW4Sonia7ooZLB?ojW4Oonia70_ojW4L05oojVdKonY]5ooZJA_ojVdWo
o9Y1oonN@_ooWDGooia3oonP?oooX43ooii4oonMA?ooWTCooie5oonNA_ooWTGooj56oonPB?ooX4Oo
oj56oonPA_ooWdOooim600;ooii51?ooWdH02OooWdOooYa4ooVKC?olVd_ookEFooo1Eoon/TGoo9dX
oofO:@02oobR:P;ooZ0Y00ooo:0ZoojO:oonVb[ooIhXoofS:ookXB[onZ0VoofY?ooo/f7ookIZoone
IOoo]6?ookI[ooniMOoo^WX00_oo^gX3oonjNP06oonkN_oo^W[ook]joonjN_oo^g[ookYj0ooo^gX0
1?oo^W[ook]joonkN_oo^WX3oonkNP09oonjN_oo_7[oo/1koog7NOoi`fcom[aQooNiHOog_6Con;eV
00Con;iV00?on;eVooRnI_oh_VH00ooh_FH2ooRnIP0;ooRmI_oh_VKon;eVooVoI_oka6Son/USoo6G
K_onOigoognNoon0WOooPIh01?ooPYd01_ooPYkooh:MoomnX_ooRi3ookIkoonjNPOook]j0_oo^WX5
oonkNP06oonjN_oo^g[ookYjoonjN_oo^g[ookYj0ooo^gX02Oog]X;oi[6FolVRZOnlV[7o_IZ_olBN
Z_o4WJ_oa9f/olBMZ`02ol>LZ@0>olBMZOo5WJSoaYjXolJNZ?o6WJSoaYfWolJMZ?o6WZOoaYfXolJN
Z?o4W:[oa9^XolFLZ?o4VjP2ol>JZ@0;ol:IZOo3V:So`iVWol:GYoo1UjSo_YJ[ol2GZonmUJko_I>]
oknEZOo1UZL00_o1UJL02_o0UZSo_YBXokZ@ZOnjT:Wo_i:Wok^?[Oo0UJ?obi^Fok>9YOn^PjT2ok66
Y`07ok25Z?n^QJSoZ86[ojAn[On[PjSo/8NTok>:XP03ok:9XP0:ok>9X_nbRJ;o[8FTojR3Y_nWPjSo
ZhVUojn:XOnbRJ;o/8VSok:9XP;o/h^R01ko/hZRok>=XOncSZ3o/XfOokF?V_nbS9go]8fLokF=Vone
SY_o]92Jok>@VoneSi_o]I6Kok>@W?ndTISo]Y6Gok6?V_ndTYGo/i>EokJCU_nfU9Ko]iBEok>BV?n/
SiWo]Y:HonB/Q?om^W_ookYjoonkN_oo^WX2oonkNP08oonjN_oo^g[ookYjoonjN_oo^g[ookYjoonk
N_oo^WX3oonkNP?ookYj1Ooo^gX01Ooo^W[ook]joonkN_oo^g[ookYj00Cook]j0_oo^WX5oonkNP;o
okYj0_oo^gX01Ooo^W[ook]joonkN_oo^W[ook]j00CookYj1?oo^gX2oonjNP;ook]j0ooo^WX3oonk
NP05oonkNooo^g[ook]joonkN_oo^WX01Ooo^gX00ooo^W[ook]joonjNP02oonkNP03oonjN_oo^g[o
okYj00;ookYj0_oo^gX2oonjNP03oonkN_oo^W[ookYj00?ookYj00?ook]joonjN_oo^gX02ooo^gX0
1?oo^W[ook]joonjN_oo^gX3oonjNPCook]j1_oo^WX01?oo^g[ookYjoonjN_oo^WX5oonkNP04oonj
N_oo^g[ookYjoonjNP;ook]j0_oo^WX00ooo^g[ookYjoonkNP02oonkNP?ookYj0_oo^gX01?oo^W[o
ok]joonkN_oo^WX2oonkNP03oonjN_oo^g[ook]j00Kook]j00?ookYjoonkN_oo^gX00_oo^gX2oonj
NP;ook]j0_oo^WX2oonkNP03oonjN_oo^g[ook]j00;ookYj0_oo^gX01?oo^W[ook]joonkN_oo^WX2
oonkNP?ookYj00Kook]joonjN_oo^g[ookYjoonkN_oo^WX3oonkNP;ookYj1Ooo^gX00ooo^W[ook]j
oonkNP02oonkNP;ookYj0_oo^gX01ooo^W[ook]joonjN_oo^g[ookYjoonkN_oo^WX01Ooo^gX01Ooo
^W[ook]joonjN_oo^g[ookYj00Cook]j0_oo^WX00ooo^g[ookYjoonjNP02oonjNPCook]j00CookYj
oonkN_oo^W[ookYj0ooo^gX00ooo^W[ook]joonjNP02oonjNPCook]j00?ookYjoonkN_oo^gX00_oo
^gX00ooo^W[ook]joonjNP02oonjNPGook]j00?ookYjoonkN_oo^WX01Ooo^gX2oonjNP;ook]j0_oo
^WX2oonkNP04oonjN_oo^g[ook]joonjNP;ook]j00?ookYjoonkN_oo^gX00_oo^gX00ooo^W[ook]j
oonkNP02oonkNP06oonjN_oo^g[ook]joonjN_oo^g[ookYj0_oo^gX3oonjNP?ook]j0_oo^WX00ooo
^g[ookYjoonkNP02oonkNP;ookYj0_oo^gX01ooo^W[ook]joonjN_oo^g[ookYjoonkN_oo^WX01Ooo
^gX01Ooo^W[ook]joonjN_oo^g[ookYj00Cook]j00?ookYjoonkN_oo^gX00_oo^WX2oonkNP07oonj
N_oo^g[ookYjoonkN_oo^W[ook]joonjNP05oonkNP05oonjN_oo^g[ookYjoonkN_oo^WX01?oo^gX2
oonjNP03oonkN_oo^W[ookYj00;ookYj1?oo^gX01?oo^W[ook]joonjN_oo^WX3oonkNP03oonjN_oo
^g[ookYj00;ookYj1?oo^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ookYj00;ookYj1Ooo
^gX00ooo^W[ook]joonjNP05oonkNP;ookYj0_oo^gX2oonjNP;ook]j00CookYjoonkN_oo^g[ookYj
0_oo^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ook]j00;ook]j00KookYjoonkN_oo^g[o
okYjoonkN_oo^WX2oonkNP?ookYj0ooo^gX2oonjNP04oonkN_oo^W[ook]joonjNP;ook]j0Ooo^WX1
oonkNP7ook]j003ooooFMPgoomIf01goomQdoo?RJooVjVGom>iGooo`BOoolTGooO55ooc`A?okkTKo
nna:oocZCookjE7ooNM?oogSC?ong4CoomDkoooC=Oooe3Coom<fooo>=_ooacSool4ioojk>ool]Cgo
oK4ooo^_@_ol[4Conja7oo^/B002ooZ[B00FooZ/Aook[4Konja5oo^/AOojZdConja4ooZ[A?ok[4Co
nZ]4oo^/A?oj[4Conja5oo^/A_oj[TSoo:]3oonY@_ooZdOoojQ4oonWAOoo[4;oojhloonZ@0;oojI3
00SoojI2oonV@oooZ4GoojY5oonYAOooZ4CoojU3oonYA@;oojQ400?oojM3oonXA?ooZ4D00oooZ4D0
2OooZ4KoojQ3ooZ/AoojZDOookI@ooo?DooocE?oo[HfoobW9P02ooj/:@0Boob/:OolZRSoo:PXoofY
:?ooZb[oojHYoofW9_om[2Woo:XXooVV9Oom[cGool1Hooo7J?ooaFCool=Pooo6IOoocVkoomEe6?oo
eWH01_oofWOooMedoo[BJoohbV7on<QPooS:H`;oml]U3Oohc6@02_ohbfCon]AQooJoI?ojU8gooiBM
oon?V?ooSI[oohnKoonAWOooTI`3oon@V`03oon<WoooUi;oolQi01KoomIf01Com]1lonG5S_o9/jCo
_J^^okn/[?o3[jWoaK2YolB_Z?o2[ZWo`jjZolB_Z?o4[jOo`jjWol>]Yoo3[ZOoa:nVolNaY?o7/:Go
aZnUolN_Y@;oaZnV01;oa[2VolF^Yoo2ZjOoa:fUol>/Y_o4[JGoaZjTol>/YOo2ZJGo`j^Uol:ZYOo1
ZJKo`:RXoknXZOnlYJ_o_JFYol2WYOo1Z:@2ol6XY@0:ol2WYOnmYJKo^Z:WokVPYonmXjGo^Z2Zol2W
X?o:/I?o/i^RojnFY@;o/IRU00Oo/9RUojjFY_nZU:SoYI6ZojVCYon^V:;o/Y^O00;o/Y^P00co/Y^O
ok6JX?naVZ3o/9ROojfFXOnVTJGoYYBTojjKXOnbW:3o/Y^Ook2JX?nbW9l2ok>MW`09ok:MWoncWigo
/j2LokFRV?ndX9[o/IfKokFPVOndWiWo/j6I00;o]::I00Go]J:IokBRVOneXiGo]jBDok:PUP02okBT
U009ok>ST_ngYi?o]JFDokNVTondY9Co[YnDok>TTOo=]H_ol/ek0?ooomIfk?ooeWH00?ooomIf3_oo
eWH08OonfG;ol>=YonCXIoo_jUkoo>m>ooo`A_oolTOoo_97oogbA?oml4Goo>e7oo[[C?ojj5;onnAD
ookQE?onge3oomU8oooE?_ooe3KoomDcoooF=?ooecGoomLhooo@>?oobCOool8fooji>ool/ckoo:m0
oob]@_ok[D?onja5oo^[B002ooZ[B@0=ooZ/B?ok[4Oonje7oo^/A_ok[DKonja5oo^]A_oj[TWoo:e5
oonX@OooZDKoojU5oonYA002oonXA@05oon/?_oo[c[oojTooonXA?ooYd<00_ooZ4@01?ooZDGoojU6
oonYAOooZD<3oonXA@03oonY@oooZ4CoojQ400GoojQ400[ooJU2ooV/BOolZT[oolEBooo@E?ooaD[o
oZXZoojX9oonZRWooJ/Y0_olZbP04?olYbKooJXWoojY:OooYBWooZHWooj/:OolZRSonjLUoof/<?oo
_E;oolMVooo7Iooo`f7oolARooo;Joooe7<HoooFMP09oooGM_oofgOoo]Ycoo_AJ?oibUoon/]MooW<
HOohc6?on<]T00_on<aT00[on<]Too[AHoohbUgomI^1oonKW_onViSooYBFoon=U_ooS9WoohnM0_oo
T9`01?ooT9_oohbOoon@Uooo_W`BoooFMP0=oogDN?odcgcoilJ6omVnTOo=]Yoo`Zn]okVZ/Oo1[Z[o
a[6VolB`Z?o5/:Soa;2Xol>^Z@02ol:^Z`0LolB_Z?o4[ZKo`jfVol:]Yoo3[JKoa:jVolJ_Y_o6[jGo
aZnVolF^Yoo5[jOoaJjWolJ_Y_o2ZjOoa:fUol>/Y_o4[JGoaJfUolB]YOo1ZJKo`ZVUoknXY_o0ZJOo
`ZZVokjWZOnmYJ_o_ZJXol2WY@Co`JRU00Wo_JBVokfRY_nlXJKo^j6VokbPZ_o0YZ;ob:nDokBKXOn^
UJH00onaV:D02?n^UZKo[9FWoj>?ZonXTZOo[YNRok:JX?ncVioo/Y^P0_nbVil0:OncVioo/YVOok:I
Won[U:;oXXnXojZGY?naWJ3o/YbOok:KWonaVj3o/YbPok>MWoncW9oo/ijNok>PW?neXIWo]J2Hok6M
VonbWI_o/inJok:OVondXYWo]:>IokFSV?ncXiWo]J>EokRUU?ndXIGo/Z6EokJVTonbXi?o]:BAokNV
TonfYI?o]JBDokBTTonZWiGoXiZJokfYT?oZbGcoo]If0?ooomIfj_ooeWH00?ooomIf3oooeWH06?om
fW7ok^EXonCXJOo/jF?omniDooo`BOonl4Woo?9:ookbB?onlDOoo_55ooc`@oomkDCoo>]9oocYDOom
iEOooN5GoogJDOondTSooldnooo==_ood3?oom8coooC=0;oomDf01?oom0eooo9=?ooaCKool4goojk
>_ol]Skoo;=2oo^_@ool[DGoo:e6oo^]B?oj[4[onZa9ooZ/B?oi[T[onje6oojX@?ooZDGoojU400Co
ojQ400KoojU2oon`??oo[S_ooj`noonY@_ooYd@2oonXA0;oojY50_ooZ4@00oooZ4GoojQ4oonXA@04
oonXA@;oojQ401koojM5oofX@_oj[DWonjM6ooniD_ooce;ooleEoonj??onYRKooZXYooj[:?onZbWo
oJ/Yoo^Y:?olZ2SooZXWoonZ:OooYROooJPWoof[:Oom[2WonZPUoob[:oon^4_oolETooo7Ioooa6?o
ol9Qooo8IooodG4>oooFMP04ookFMooedG_omM5koo_DN0OoomIf00OoomMfoooIM?ooefcoomEOoooC
FOoocecoo<iQ00;onLaS00?on/eSoo[<Hooic6@00_ohc6@05?ogbfCon<aTooS<I?ohc6Con<]TooS<
I?ogd5komjiioojGW_onWYcooIjJoojHU_onT9CoohbGoon=W?ooSYgooi6Loon=W_ooRYgookF33ooo
eWH07?omeGOomLmmonG5QooF_9Cob[BOolNbYoo5/J[oa;6ZolB`Z_o5/:Woa;6YolB`Z?o2[j[oa;2Y
olB_ZOo2[JWo`Zj[ol:]Zoo3[ZOoa:jVolF_Y_o4[ZKo`jfWol:]Z?o3[JWoa:jWolJ_Y_o5[ZL2olJ_
YP03olJ_YOo4[JGo`jbV00;oa:fU00[oa:fVolB]YOo3ZjGo`ZVUokjWYoo1ZJOo`j^VokfWZ_nkY:co
_jJW1?o1Z:D02onnYjKo_J>VoknSYOnnXZGo^j:Vok^PZonoYJ?ob[6CokFLX?n]TjOo/YRT00;o/IRU
00Ko[iRUoj^EYonTSj_oYY6ZojfEY?naVZ02ok:KX00/ok>KWonbVZ3o/Y^Ook6JX?ncVYoo[iJPojB?
YonUTZGo[9VSok6MX?nbW9oo/YbPok6KX?n`Vj7o/ifOok>NW_ncX9co]:6IokFOVOndWiWo/9bLokBO
VondX9_o]Z:HokFRVOndXiWo]::IokFSUOngXiGo]J:Eok6PU_nfYI;o]JBCok6RT_nfYY7o]ZJCok>S
U?ndY9?o[j:EojZOUOn[WY;o]ZJ=omVmP?ogdGOooooFM^WoomIf003ooooFMQ3oomIf01[ooM]_on_V
IOoVifWoj^MWoo7/F_omkdcooo58oogbBOollT[oo_9:ookbBOoolTSooo15ook^@oolkDKon^Y=oo[W
Eooli5cooN9LookLEoooeDcooli0ooo<=_oocS;oollaoooB=0;oom<f00ooom@goooC>?oodCSooldh
ooo7=ooo`SSoo[djoofj?_ol]47oo;13oo^_A_ok[TSooJTooonWA?ooYdD00_ooZ4@04_ooZDCoojQ4
oonXA?ooZ4Cooj`ooon`>ooo[c_ooj/koonY@_ooZDGoojQ5oonXA?ooZTGoojU4oonWA?ooYd?oojQ3
oonXA0KoojQ5023oojU6oojV@_okZTKonJ]8oon_C?oob5Koo/mFooo7D?om[Rgoo:PWooj/:OomZRWo
oZXYoofZ:Oom[2SooJ/YoofZ:?onZ2SooZ@VoobW9_omZbWoo:XYooZX9OojY2Koo[<oooo4Gooob6Wo
olETooo3H?ooaFCooli]oooEM@[oomIf00koomIgoooGN_omeGSoklf0om_2RooB_8koe[f<om_1ROoV
b8?ok<^0ono<OooccWcon=9joocEM`;oomIf00Sol/ilonC5Ooo^bVoon/iQook?Gooncf3ooLmPooc=
H0;onleR00Coo<eQoo_>HOolcV7onleQ0oojcF803ookdf3on;MVoobGUOooW9gooYjGoonOV?onWYKo
oYRCoon?TOooS9GoohnIoon?VoooRJ3ooj^8oooEMP0:oooFMP0JookEMoojdWWollinonG5R?oE^i?o
bkFOolJaY_o5/J[oa[:[olJbZOo7/ZKob;BUolVdYOo6/ZSoaK6YolB`ZOo2[jWo`ZjZol:^ZOo3[jWo
a:nZol:]Zoo3[ZWo`ZjXol>^Yoo4[ZL2ol:]Z@03ol6/ZOo2[JOoaZnV00;oak2U00Soa[2UolJ^YOo4
[JGo`jbVol:/Y_o4[JGoa:fVol>[YP;o`jZU00Oo_ZRXol2YZ?o2ZZOo_ZNZokZS[?nnYZOo`:NU00?o
`JRU01Co_ZFVokjRY_nnXjGo_J:VokbRYOnkX:_o_:>UolZaToniX9ko/9BVok2FYOn`UjGo/IRUok2G
YOn]UZKoYI6Zoj6>[?nYTZOo/9VPokBLW`?o/IZP00_o/Y^Pok2IXOnbVZ3o[iFQojfCX_n]UIooZ9BT
ojfJXon`W:3o/I^Pok>MW`02ok6KX008ok>MW_ncXI_o]:6HokJPV?ndWiWo/IfLok2LW_neX9X2okFR
V@0EokBRVOndXYSo]J:EokFRUOnfXiGo/Z6FokBSTonfYI?o]:>Dok>ST_naY9?o/Z:Eok>STon^XIGo
[j6DokBST?nYWICoYI^Eol^cPoo]bWSoo=Ag0?ooomIfioooeWH00?ooomIf4OooeWH01_ojg6koj^MW
onKWJ?oYiVSok^YPooW_D0;ooo1800?ooO5:oocaB?omlDP00_onl4T07oonl4Koo^m1ook_?_olkD?o
nnY=oo_XF?oliUoonn5PoogJFoooe53ooli5ooo=>_oocCCoolhboooA<ooodSGoom4foooA=ooodSOo
om@hoooE>?ooe3Woom0iooo<>OonaC_oo[Lkoon^@Ooo[DCooj]2oonY@oooZD@00_ooZ4@01OooZ4Go
ojM5oonZ@ooo[Sgoojll00;oojhk00Kooj]2oonYAoooZ4CoojU4oonZA?ooZD<4oonXA0GoojQ500co
ojU6oonV@_okZ4?onJe:oo^YAooo_5Coo/eFooo>E_on_d?oo:PWoofZ:?omZbT2oojZ:@0Cooj[:?om
ZbWoo:TYoobX:?onYbOooZHVoobW9_olZBWoo:/Yoo^W9_olYRGoo[0gooo0FOoob6SoolMWooo4H_oo
`f;ool]ZoooCLP09oooFMP12oooFNOooeXgoo=J?oo_DPoo`cH[ogL:FolZfX?ncYjGoYj>Vok6XX_nm
[ico`k>JolFcUoo;]Y;oe;f=on;6QOoXah?ohLB7olZhTOo4]9;oekanomnnLooR`77ohkmaonO2L?o[
aFcoklIYoo?:IoodbVKom<]UooS<I?okcF7onlePoogDG_od`Uoonin=oonMX?ooWISooifGoonNVooo
Wi[ooibDoonDT_ooT9?oohjGoon:V_ooXXSoo=5hoooFM_oneGOoo=Ahoo_CNOodcgcol<eoonk;P?o[
bH?oi/J7omk1RooG_I3oc[JIolRcXOo6/ZOoaK6ZolJbZ?o7/ZOob;>V1?o8/jD03?o8/jKoak:XolJb
ZOo6/JSoaK2Wol>_Z_o2[Z[o`Zj[ol>^Z_o3[Z_o`Zj[ol6]ZP;o`ZjX01;oa:jWol>^Yoo2[JOo`JbW
ol>]Y_o6[jGoak2UolJ_YOo5[ZGoaJfUolB]YOo2ZjKoa:bUolF^YOo4[:Go`jZUol:ZY_noZ:P2ol6Y
Y`04okjVZ_niXJgo_jNVol2XY@;o`JRU01Oo_jNUokjSY_o1Y:Go_Z:VokfRY_nlXZKo_:2ZokbQYOo9
/9Co^Z2Nok2CYon`UjGo/INTok6HYOn`V:Go[YNVojRCZOnPSJgoY8nZojjFX_neWIgo/YZPok:KW`02
ok:KX008ok:JX?n`V:7o[iFTojfDY?n`Uigo/9VMojVEY?n_Vj82ok2KX00Rok>MWonaVj3o/I^Pok:N
W?neXISo]9nIokBOV_ncWico/9bNok:NWOneXiWo]J>HokBRVOncXYSo]J>DokJSU?nfXiGo]:>Eok:R
UOnfYI;o]ZFCok:RUOn_XI?o/:6Eok:SUOnbXi;o/::Bok>ST_naXi;o[:2DojVLTonjZ8WocKF7onc9
O_ooomIfi_ooeWH00?ooomIf4_ooeWH08?ofgFooinQVonSWJ?oYiV[oj^QTooC]E_onl4Wooo18ooka
BoollD[oo?58oogaB?onl4Wooo5<ooo`COoolDWooo54ooc^@Ooik4Gon>UAooWWFoojiV7onn=SookM
G_ooee?oolm7ooo;>_oobS?ooldaooo?<ooodCGoom4f0_ooccP05oooccOoom<goooA>Oooa43ooke1
oonl?ooo^D3ookM1oonc@Ooo[d3ooje3oonZA?ooZDGoojM5oonX?ooo[S_oojdloon/>_oo[C_ooja1
oonZAOooYdCoojQ200;oojU300?oojU4oonYAOooZDD01OooZ4D03_ooYdGoojQ6oojX@?oj[TWon:Q6
ooj_C_oob5Soo/mEooo:Doon/S?oo:LVooj/:OomZBWooZTY0oonZbT04_olZRWooZXYoonW:OomYBKo
njHUooZ[:?ol[2SooZXXoojW9_on[S7ookeCooo6I_ooafOoolASooo3HOooafKoom1_oooFM@SoomIf
05[oom>8ooc1Z?oodiWoom^:ookJR?omf8kok/^IolneY_n_YJooYj6aojjU[oneZZco^ZbYokJZYonc
Z:So^jfVol6`Woo4/Y_o_[2Qok:YZonWWjooZYnXojfPX?n`Xioo/ZBMokJUV?nnZY?o`:f@ol>^Soo6
/8_obK67olbbQ_o?]X;od;N1omFIXOoOQ[Sohh^don></ooSRkGoi8fconF?/ooXSkCoihn[onV6ZOod
NjgojWfXomB/T_oO`XWoe[fAomBkUOoA^IOobKBMolJbX_o6/ZCoaK6UolBbYoo4/JWoaK:/ol>b[_o4
/Z[oaK6XolJaYoo7/ZKob;>UolRcY_o7/ZKoak>VolRcY_o7/jKoa[:WolJbZOo6/J[oa[:ZolJbZOo3
/:_o`Jj]ol6][?o1[J_o`Zj[ol>_Z_o3[ZWo`ZjWol>^Y_o4[ZKoaJnVol:]Yoo2[:Oo`ZfVol>]Y_o4
[ZH2olJ_Y@;oa:fU01_o`Z^VolB]YOo5[ZGo`j^Uol>ZYOo1ZJOo`:ZWol>[YOo1ZJKo_JF[okZR[?nn
YZKo`:NUol6XYOnoYjGo_ZFVoknTY_o0Y:Go_J:VokjSYOnnXZKo_9nZokfQYOo6[YKo^Z6Nok2CY_n`
UJD00_n`UjD02OnaV:Go[iRUojVDZ?nOS:goX8b/ojbEY?ndViko/i^Pok6KX002ok:KX00Ook:KWon`
V:;o[iFUojjDXon^UYko]9bKojjHWonZUjCo/9bQok2LX?n`Vj3o/YbPok6KX?n`WIko]J:GokFPV?nb
WY_o/ijLok>OW?n`W9ko/j2KokJSV?neXiWo]:>GokNTU?nfXiGo]j>DokFSUOndXiGo]ZNCokJVT`02
ok2QUP0=ok6RTonbXi?o/Z>CojfPU?n_XYCo/:>Cok2RT_n_XI7o[9nBojNLTon_XI?og/20oo_DMP3o
oooFM^CoomIf003ooooFMQ?oomIf023olmm^onSXI_oYifOoj>IYonWWJ?o_k5gonnm=ooo_Aoonl4[o
o_5;ookbBOollDOooO56ookaA_onlDWoo_1;ooo`B_oolDCoonlooo_/?oojjTOonNQBooOVGOohiF?o
nN5UoogMH_onf5Soom5:ooo;?_oocCOool`aooo<<P;oom4e01GoolXgoonn>_oo^3oook/moonm?Ooo
_3oookhooono?ooo_cgook`ooonh@?oo]D3ook51oon^@Ooo[c_oojljoon/?Ooo[Scoojhnoon/?ooo
ZD400oooZ4@3oonYA00YoonYAOooZ4CoojM4oonVA?ooZ4CoojM4oonYAoooYd;onj]5ooV/B?ojZ4Wo
okaFooo>EOoocUOool=9oofZ:?omZBOooJXYoofY:OonZRWooZ/YoojZ:Oon[2Woo:XYoofY:OooZ2Wo
oZHUoo^V9OokZbOoo:/Woon[:OooZBOooJT[oojhAoooaF7oolMWooo5Hooo`f7oolESooo<Joooe7@0
1oooeWH0@?ooeGWon;NPoo6K]_oj`j?oo]>EoooHSOoofX[ooMJ>ono<UooH^j;o^J^[ojfW[_n]YZoo
/jV^okb^[?nm[Zco_Zj[ol:`ZOo6/ZCoakBRol6`Y_naYK?oYYfjojBJ]onWVk?oZ9^aojNK/_nSUkGo
WiJhoj6J^?nTW;GoXi^doj6I]?nRW[CoXY2jojQha?n`Nl;o[G[3ojUk`onYN/?oZgW5ojika?n/OL?o
ZWk2okUdb?n/I/co]:6aolJhYoo1/:go`Jn/ol>`[?o5/Jgoa[:/olNcZoo6/j[oaK>YolJcZ_o6/jSo
ak>WolJcZOo6/jOoa[:WolBaZ?o6/JL3olNbY`0IolNcYoo8/jKoak:VolJcZ?o6/J[oaK6ZolJbZ?o6
/JWo`k2/ol:_Z_o2[ZWo`Jf[ol>^ZOo4[jOo`jjWolB^Y_o3[ZKoa:jVol:]Yoo2[:Oo`ZbVol6/Yoo2
[:OoaJnUolF^YP02olB]Y@0Kol>/YOo2[:KoaJfUol>[Y_o2ZJKo`JVVol6ZYoo4[:Go`JVWokbT[?nj
XZ_o_ZFVol2WYOo0Z:Go_ZBVokjSY_o0YJGo_jBUokjRYOnnXjGo_Z:VokbOZ_nmXJGoaZjFokNNWon_
TjOo[iFV00;o[iJV0_n`UjD01_nZU:OoXHj/oij;[_nWTZOo/YZOok>LWP;o/Y^P03;o/ibOok6JX?n^
UJCo[iFUojnFXon]U9ko/IVKokBLVon^V:3o[9VRok6LX?n_Vj7o/9ZPok>LX?n`W9oo]J6HokFPVOna
WIgo]9nKokBPVondWi_o[ifMok>RV_neXiWo]JBFokNTTonfXiGo]Z>DokFRUOncXYGo]JBDok>TU?na
XIGo/::Fok6RTon`XY3oZ9fGoj^OU_naXi;o[j6Bok6STOnbXi3o/::@ojnQT?nXWI;o[In@oljfPOoZ
b7SomLmgoogDMoooomIfhOooeWH00?ooi6l04ooTK`00:ooSLP;ogIPGomRa9_oIZb;oejLQomNV8OoL
]2GojlDTooK>8?ofcB7omLhRooC?9?odd2?olm0Poo;>7oodc1oom<`PooG=8ooecbCom]0SooK>7ood
aaSokl0Aon^g3_oV[Q3oi:LEonJU6ooYYB7okZHRoo6W8_odYQcomJHEooJY3_of[13onJXNoo^W:_oj
YbOonZLVooZV9_ojYbOonZHVooZX:?ojZ2L00_ojZBL02oojZbSonZXXooZY:OojZ2?onJPJooRP6_og
VQSomiDIooJ@5?ofRa;omHDG00;omH8K01GomH8JooF36ooeQ1_omX@KooJ56oofQAcomX@KooJ57?of
QA_omXHMooJ57_o^L`GojFh0onUZ0?o^M@col8hConj@3_o^S@golh`6ooB60?odQ@000_odQP005_oe
QP3om8H0ooB70?odQ`3olhT0ooF70?oeQ03om8<1oo>50OobQP3om8P0ooF70?odQP3olXH0oo:83Oo`
R1_okXLNonn87_o`Rb3ol8/Qonb25ooWM@L7onA_000aonMg7ooRH6cogeYeon9[J_oWNUOojH4monV3
:ooXPRCoiX4Yomf1=oo;Md[o[6aLoieXIOnJJ6WoX6YVojA[I?nWK6?oZVePoja/G_nbKEGo]Ve?ok5]
EonTKG3oXGJ1ojInQon[Q8?oZH:6ojEnR?nVOhSoYX28ojAoRonQOHooX82>oiiiTonQGigoYE^OojMM
X?nUGYooYUfOojUMWonWGIgoYUfOoj]NYOnNE:?oVe^2okEbFoniMESo]75KokE`F@02okE`F00>okI_
EOngKeCo]W1FokI`EonfKeKo]FmGokI`F?nfLE[o]W5IokIaF?neL5So]FmIokE^FOneKeP2okI_F0;o
]VmG00?o]VmHokE`G_neLV000_nfL5X01ondL5ko]71Mok=^G?naKV3o/FeOok5]G_nbK5/00_nbJeX0
2OnbJe_o/F]Lok5ZF_naJU[o/6YLok5ZG?naJU_o/VYKok=YF002ok=YE`03ok5YFOnaJE[o/FQJ00;o
/6MJ01oo/6MIok5WF?n_Ie_o[6ISojaSH?n/HUSo[VAGojiTF?n]HEWo[f5HojmQEon/GeSo[5mIojiO
Eon]GeOoZeiQoj]NF_nbGccoYEM;oie@G?nNDUSoWU=HoimCEonODeSoWUAHoi]CFOnCDF;oSDmYoi=@
HOnOEEKoXEQB00?oX5MB017oWeECoieBFOnPE5OoWUAHoiiGF?nNFEKoXUU@oj=ICOnLEUCoWEMDoiiH
E?nOFE?oWeQCoiiID_nRGDcoX5]?oj9KCP02oj9LC@06oj9KCOnPFe3oWUa@oj5NC?nTH4SoYF170_nU
GdL04?nTGdSoXf18oimOBOnPGd[oXV59oimOBOnQH4OoW69>oi9NEonIGdkoXF56oj1RAonOHTOoWV17
oiaPBOnOHTL2oj5RA006oj5RAOnVID?o]6/fol5/9oo>JQKogVh6<ooTK`000ooRK`7og6d6omm^103o
onA_0:Woi6l0003oonA_01Coi6l0017ohgL5om^P7?oH/BKofJ/SomRX8OoGYB7ofJhTonG09Oodc2Co
m/hQooG<8OodcR?omLhSoo?@8oocd27omLhNooG=7`02ooC=8@0CooC?8Oofcb;om]0RooK:7Ooc`QKo
kkd?on^d3OoVZQ3oi:DEonFT6ooXYB?ok:HToo2W8OofYRGonJ8]ooZU:OojYbGonZPWooZY9P02ooZX
9P06ooZX9oojYbKonZLVooZW9_ojYbOonZTW0_ojZBT04Ooj/2;on[8LooZa8Ooj/2ConJhPooVW6_oh
X1WomiHLooN=7oofQagomXDKooF26_oePQ_omH<JooF26_oePa[omH@K00;omXDL00comXLOoo5j3?oZ
K`3ojFd0ona_1Oo`Q1CokY8?onj=3_o`S@com8T1ooB50?odQP02ooF600?om8H000gom8L0oo>70?oc
Q`3omHD1ooF30_obP`7olXL1ooB70?oeQP3olhD0oo640?obQPWol8PJ00;okXLN00Gol8TOoo6<8_o_
QagojGX=onE`0P05onA_000eonEa1_oXMDKohEabommNK?oOHG3ohV]WonEeEOoXOT3ojH<`onV4:?oX
PbWoh80eolagAonaKUSoXFUSoi]XJ?nLJF[oXFYVoj9[I_nRJfOoYfaSojm]FOndKE7o[faHojA]K_nP
M83oYGf6ojR2P_nXP8?oYWj4ojAnQOnTOXKoYX64ojEnROnRIYWoY5ZKojILVonWGIcoZEfLojQLVonZ
Gico]EnVoj]DXonRG7Oo]fi?okUcDoneL5[o]W5HokEaF?neL5So]71HokA`FOneKeP00_nfKeL02?nf
L5Ko]VmFokI`EonfL5Wo]W5IokI`F?nfLESo]VmG0_neKeP2okI^E`0OokE^F?nfKUOo]fmFokEaGOne
LUoo]W1JokE`FoncL5oo]W5KokI`FonbKeoo/FeNok5]GonaK5co/V]Jok9/FOncK5[o/V]Jok9ZFOna
Je_o/FYKok1ZG?naJU_o/6ULok5XFOnbJESo/fUGok9YF?n`JUco/6QLok1WF`02ok1WF@0Eok5WF?n_
Ie_o[6ISojiSG?n]HeOo[69JojeQFOn^HESo[f5GojiPF?n/GeSo[EmIojiOEon^GeKoZeiPojYNFonc
Gc_oZEY8oimBFonMD5SoWe=G00?oWU=H00KoW5=Ioi=@H_n>CVSoUE1PoieDF?nQEe<2oj1GDP0BoimF
D_nME5KoWE9Koj1CEonNE5SoWUIGoimIE_nOFECoXUU?oj5HConLEUGoWEMDoimID_nNFECoWUUBoj5L
COnMFU;oXU]>0_nRG4d08onRFdgoXea=oj=NCOnOGDooXUm:ojEQAonUGdOoYEm6ojEOAonRH4WoWUm:
oiiNBonQH4SoX619oimPBOnLH4coUf1AoiYRC_nOHTOoWV17oi]PBonNH4SoWF19oiiQA_nTI47oZFHn
ojQU?_nTHT;oWf56oiiRBOnUID;o/VHdol1W9?oBJQ;oh6h302Woi6l000cohfl1on1^0ooPKP?offd6
omQ/2?o?JPoo`FHIokIS8onmIB3oeV`>on=`0ooTL0;oonA_0:Ooi6l0003oonA_01Goi6l002OohGd8
omZV7ooH/2GofJ/SomZZ8OoGYb7of:TRon2f9Oo^b2Gom/lRooK=8_oec2;om/dSooC?9?odd2;om=0P
ooC>7_odc1oomLdQooG=8?oecR3omLhSooG?9_ofcR?omLXKoo;24oo^^`coik4;on>X3ooSXACok:hT
ooF]=?ogYcKomjDbooRT;ooiY2conZDYooZV9oojYRH00_ojZBL0:?ojZ2OonZTXooZW9oojYbOonZHW
ooZV:?ojZ2ConZhMooZ_7ooj/2?on[@QooZ`7_oj/Akon[<PooZ]8ooiXbGon9`TooRF8_ogSb3omXTM
ooJ66ooeQ1comX@KooF36ooePa[omXHOooB05Oo[K`7ojFd0on]/0Oo_N@ookhlConj@3Oo^S@kolXd8
oo>60?odQ@3om8H0ooF70?odQ`02ooB6000EooF60?odR03om8T0oo>70?odPP7om841oo:50OoeRP3o
mXP1ooJ60OodR03olhL0ooB61OoaRAOokhLNonj77_o_R1gol8XPoo298?o[Oa?oiW<500Goi6l0037o
igLRonEZI?oSIF;ohV=Ton1TK?oOIV_oh6MUon=`F?oWO4GojX@gonV5:_oWPbWohGlaom1h@?nkLU7o
YFYOoiaXI_nPJVKoXV]Uoj=[IOnTJfKoZFaPok1^EondKE7o[VaHoj=]KonNLH7oXWZ8ojN1QOnXP8;o
YGj5ojIoQ?nVQ8OoYFjEojIJW?nUG9WoXebHoj=MVOnWGIco[EZSojAEX?nQH7Go]g1@okUbDoncKeko
/g1MokEaFonfLe_o]W9I00?o]75K0_neL5T01OndL5[o]G1IokI`F?nfL5So]W5J00;o]W5I00Ko]W1H
okIaEoneL5Wo]FiHokE_F?nfKeL2okE^F00;okE`FoneLEoo]W1KokE`FondLEko]W1KokIaG?ndL5ko
/fmMok5^G_naKEh00_naJe/06onbK5_o/F]Lok5ZG?naJego/FYKok1ZG?n`JUko/6ULojiXGOn_J5_o
/VUHok=YEonaJEco[fMMok1WF_naIeSo/6MIok5WF?n^IUkoZfEUojiTFon^HeOoZ61NojYOG?n_HUOo
[f9HojeOF002ojaOF@0:ojeOF?n]GeOoZeiOoj]NG?naGckoZUY6oimBF_nNDESoWU9HoiiCF0;oWe=G
00KoWE=HoiAAH?n>CVSoUE1Ooi]BF?nPEU@2oj1GDP0Coj1FDonNE5OoWU=IoimDF?nMDeWoWeEFoj1I
E_nOFUGoXEQAoj9IC_nOEe7oW5EDoieGE?nPFU;oWUUCoiiJDOnMFU?oXE]?oj=LC@02oj9LC@0Xoj9K
C_nSGDcoX5i=oj1NBonUGdKoYEm7ojEOA_nTGdOoWee;oiiOBonNGT_oXV17oj5PB?nNHD_oWf5:oieO
B_nMHd[oWF=;oiILD?nIGTcoWf57oieQBOnQHd?oZ6DmojQU?_nXICooZ6@oojQT?_nWI3ooYVA1ojEU
@onSID?oZ68mokAR;oo5IQkoeV/=om]/2?oNK@KohFh2on=_0A_oi6l001CohVl1on1^0ooOKPCoffd7
omM/2OoCJ`gocfX@ol]Y4oo2Ia[o^6DRok5S:?nZHBkoWehhoheHAOnCFdKo_VT]om]d5OoXNa7ojGLF
onE`1Oooi6l0YooTK`000?ooi6l05_oTK`00:_oPQ@gofJXRomR^9?oJZR7ofJXRomRX8OoHY23ofjhS
onW39OoecB?om/hQooG<8OodcB7omLhSooG@9?odd2?om<lOooG=7_odcB3omLdPooK=7ooecR3omLdQ
ooG>9?ofcRCom/dRooG76_oa_PgokkL=ooB`8?ofZbWomJl[ooF`<Ooe[SComZ/dooNV<oogY33on:@/
ooVU:OojYBKonZDUooZV9@;onZDT02;onZ@TooZS8oojXRGonZXQooZ_6ooj[aconZdLooZ/7?oj[Aco
n[8LooZd7?oj/AoonZdWooZX:OojYBOonJ8UooVP9OohVbCon9HRooN@8?ofRakomXTPooJ77_o_M@Ko
jF`0onQ[0?o/KPOokh@Donj@3_o^S@kokhd=oo>90oodQ03omHH00_oeQ`006?odQ`3om8H0ooB60?od
QP3om8L0oo:70?ocQP3om8<0oo:00?obQP3omH/0ooJ70?oeQP3olhX0ooB70?oeR07olXTAonn97Oo_
R1kokhLMoo2:7oo`Rb7okH@IonMg2@Coi6l002goiG45onMd@?oTIVWoiFUNon9UI?oPI6SogfIYommT
JooOI6GohfeIonMlA_oYPcKojH@ZonR29_oSObgodWY0ok]bD_nWJegoYFaOojE[HOnVJf;oY6]TojE/
I?nXK67o[FeJok5]E?n]K5_oXF]aoiU_Q_nPNHWoYX25ojEoQ?nUQ8GoY7F@ojQLVOnYFiOoZ5fIojIL
VonTFIkoXEbBojIWJongL4go]g5Eok9^FoncKeX00_ndL5X03_neLE_o]W9JokEaF_nfLEWo]G9KokEa
FoneLE[o]75Kok=aGOneL5[o]W1IokEbG?nfLE_o]W5H0_nfLEX05onfLEWo]W1IokE`FoneL5_o]W1J
okI_FOneL5[o]71Ook=aH?ncL5oo/g1PokI`G?neLEko]G5PokE`G_neL5go/FiPojm/Gon`K5ko/FaM
ok5[GOn`JUgo/6]N00;o/F]L00[o/F]MojmYGOn^J5co[FMMok1XF_ncJESo/VUJojmWGOn`IUWo/FMH
0_n`IeT04_n^IV3oZfEUojaSG?n^HUKo[61Joj]PFon^HUSo[f9HojeOFOn/GeWoZeiJojiOEon^GUOo
[EeNoj]NG?n`GT7oYUQ9oie@F`;oWe9G03SoWU9HoiiCF?nODeSoWU=HoiQBGOn=CfWoUDmPoiYAF?nP
EECoXEMBoj1GDOnMEEKoWU=GoimCEonOE5SoWU=HoimEEOnPF5GoWeUFoj1HDOnRF4koXEQ?oj1GD?nM
EUCoWUQCoieID_nKF5KoWUYCoj5JC_nRFdooXU]=oj9LCOnRFdgoXee=oj9OBonQGT[oXem8ojEOAonU
H4OoXEi:oi]LConOH4_oX659oj1PB?nQH4KoX6=8oimTBOnMH4WoWV57oiMPD?nDGU;oVem;oiiPAonQ
I4CoYfLnojUV?0;oZ6@n01SoZ6DoojMU@?nXI3ooZF@nojMT?onUID;oYFE4oimRBOnKGdWoYV4mojmR
<ondHbko^6@XokiT8_o8Ia[ocfTComEZ3_oHJ`[og6d7on1^0ooSK`7ohVh1on9_0OoSK`44on9^0@04
on5^0_oSK`7ohVl1on5^0P?oh6h301[ogFd5omQ/2OoCJ`gocVXAolUY5?o4J1[o_VHOokMU9?ncI2So
[f@]oj]S<_nXHcKoXf4loieO@OnIGdKoU61<oi1MCon4EeKoNe=LojeWAOoLMaoojGX<onYn3ooVM3_o
ef0hon=^0oooi6l0YooTK`000?ooi6l05_oTK`004ooTL03ogh`@omV/8ooH[B?ofJTRomV[8ooIZB;o
ej<NomRX8OoS^bGol//SooK=8_odcB;om<dQooG=8OoecRCom<lSooC@8OodcQl00_odcAl05_ofcAoo
m/`OooC=8OoecB;om<hTooG>9OogcBSonL0^ooZc;_oh/BOomj`SooJZ8Ooe[2GomJl[ooF];_oe[37o
mZPaooJR;_ogWb_on9lXooVO9?ojX242ooZR8P0SooZT9?ojY2KonZHUooZ^7?oj[a_onZ`MooZ^7Ooj
[agonZhMooZ^7?oj[a[onZlLooZY8_ojYbKonZTWooZZ:?ojZbSonZXXooZX:?oiY2OonIhTooVK9ooe
S1CokWd3on]f0OoZKP7okgL@onj:4_o/RPgokHT>oo6;2?ocPP3olh<0ooB60?odQ`000_odQP003Ooc
QP3olhD0ooB50?odQP3olhP0oo>60?ocPP3ol8<0oo:70?oeR03omHH0ooB80?odQ`000_obQ@002Oob
R0kol8TLonn77_o_R1gol8TNoo6;8_o`RAoojW/?onE`0@03onA_001fonId7?oUK63oi6QTonEZG?oS
IFGohFIWon1WI_oPIfSogf=XommSHOoSKEKoigQ:onV2??oYQ2coj8<Won>0;OoDNSko_g9=ojm]F?nX
K5goZ6aNojM/H?nUK6?oXf]VojE[I?n[KEco[faFoja/G?nPJW3oUfb4oiefROnSPhOoY7n@ojERVOn[
F9go[5^QoiiIUonOHWgo/6iKokUbC?nfLUGo/g1Iok9_F_naKe_o/VmLokA_FOnfL5Oo]W5HokIaFOnf
LEOo]g5GokIaFOneLE_o]75KokEaF_neLEWo]75JokAaG?neLUgo]W5IokIaF_neLE_o]g5HokIaF?nf
L5Wo]71KokE`F_neL5Wo]g1HokE`GOncLF3o/G1Sok9`H_neL5go]G5MokEaH?ndL5ko]G1LokA`GOnc
KU_o/FaKok1/GOn`Jeco/FYKok5[FonbJU[o/F]Kok5[GOn_JEco[FMMojiWGOn_J5co/6UKok9YF_n_
IUco[fIJok5XF?n`IeSo/FMGojeXH_nZIFKo[F5JojmQE_n_HESo[61KojeQFOn^HESo[V1GojeOF?n[
GU[o[EmGojeNF?n/GEoo[5mNojmN@onUEd[oWU1IoimBF0;oWU5H00coWU9IoiiCF?nODeOoVE9Kohm@
IonCD6?oVe9IoiiDE_nQEU?oWeIDoiaDF?nPE5D2oj1DEP0ZoiiCF?nOEEGoXEQCoiiIF?nOFECoXUQ?
oj9IC_nSFDkoXEQ?oiaEE?nJEUKoVeMFoiiJDOnSG4coXE]?oj9KC_nRG4goXU]=oj=LCOnSGd[oY616
oj5NBOnVH4CoY5m6oiiNBonJGDooWF5<oimQBOnLGTcoXEm8oj9QBOnOGe7oVEe@oiaOB?nJH4[oVV5=
oiYQBonNHTOoYfLnojQW?OnWICkoYf@o0_nXI3h06OnXICooZ6DnojQU?_nVI43oYV91ojAR@_nRHdCo
XVM3ojMX@_nXIT7oXV=5oiiSBOnQHdOoXf93oj9Q@OnVH3co[68fok5R<OnfHb[o_fHPokmU7onnIB7o
`6DOokiU8?nlI2800_nkI2<01?njHb?o^F@VokQS9_nfHbP2ok9R:`0Jok=T:_n_I2koZf<cojMR>?nY
I3SoZFDiojAT?_nSHd7oXV=4ojEU@_nXIT;oYVI2ojEVA?nNHTOoUf1<oi1ND?n7FeKoQ5MFoiIMC?o8
KR_oigP@onUi2ooXMQoogVIColM@IooGHa/`onA_00;oi6l10_oTK`02onA_0Oooi6l0L_oTK`000?oo
i6l05ooTK`001?oSLP;ogI8DomR^9OoI[2<3omVZ8P;of:LQ00Cog[@Uong69?ofcR;om/hR0_odcB80
7_odcR?omLlSoo?@9?odd2;ollhOooC>8?odcAoom/`OooK;7oodbQkomLXQooW2;Ooj^CKon[/cooZl
<Ooj^2oonK4WooRZ8OogYagomZHMooJZ8Ooe[BOomJl/ooF/<?oeYS3omZ4`ooNO;oohX2konJ0YooZS
9@;onZDT027onZXOooZ^6_oj[QconZdNooZ]7Ooj[AconZhOooZ_7ooj/1conZlKooZZ8?ojZ2GonZHV
ooZU9OojYbKonZPWooZY:?ojZbKonjXZooV]9?of[a;omJH<oo>G1OodSA;olYPLonnJ4?o^T@ookh`<
oo:60ooaOP3olh<0ooB40?ocQ0000_odQ0004_odQ@3omHD0ooF50?ocQP3olhD0ooB60?ocQ03ol840
oo:40?oeQ`3omHT0ooB80?odQ`3olhD0oo230?ocQ@Wol8LHonj77@;okhLL00Col8XPoo2:8Oo/PAKo
iW@50_oTK`006OoTL0?oj7E1onATJ_oUJekoi6UMonAWIOoPI6Soh6MUon5ZIooPIVWogfARon1UGOoR
JU_oiWIAonV1?ooYQ2goj88Uon>0;?oGNc_o`79=oje]F?nWJegoZFaLojY]G?nVK6400_nTJf@05onY
K5ko[6eJojY/GOnMJ77oUVj7oiahT_nQHj;oWUFLoi]MPon[K6;o^79>okUbCondLEOo/g1HokAaEonb
LEWo[g1Mok1_G?naKego/FmLok=_F_ncL5_o]W5H00?o]W5G0oneLEP02OnfLEOo]G5IokAaGOneL5_o
]G1IokEaFonfLE[o]W1IokE`FP02okIaF@0FokE`FOneKeWo]W1JokEaG_ndL63o/g5Qok=_G_ndL5go
]G1MokA`G_neL5co]FmLokI_F?ncKEWo/FaLok1[GOn`K5go/6]Mok5ZF_naJego/6]Nok1YG0;o[VML
05Ko[fQKojiXFon_Ieco[VIMojmWF_n`IeWo[fMIok5WF?n/IVCoZV9TojmQF?n_HEOo[V5IojmRFOn]
HEWo[5mIojeOF?n/GeWo[5iIojiOEon]GUOo[EeNojaNG_n_GT?oZEY6oimBFOnNDESoWe9GoiiAF?nN
DUWoWe=HoiiCF?nJDU[oTE1Toi9@I?nIDUcoWEEFoj9GD?nNEUCoWUEEoimDEOnPEEGoXEEDoiiDE_nO
EE?oXUM?oimIE_nNFEKoXUU>oj=JC?nSFTgoXeU<oimFDOnIE5GoVUICoieJD_nSGD[oX5a>oj9KCOnT
GD_oXea=oj9KCOnRGd[oYF=4oj5QB_nSH4[oX5i@oiYJEonIEe[oX5UIojQJFOn]Ef?o]EQQokQFGonh
DfOo[55XojAHF_nLFdooV5m;oiiUAOnTJD7oZ6PnojMV?_nWICooYfA0ojMU@0;oZ6@n01GoYf@oojAS
@_nSHTCoYF=2oj=S@OnSI3ooYfDnojYU?_nXICooXf=3ojIU@_n[IcooZFHoojMV@_nVIdCoY6I6oj9U
A_nQIDKoXfE5oj9QA?nRH4@00onUHd<2ojIS@P0=ojUT@?nXI3ooY692ojAU@onUJ4;oZ6XoojIW@?nT
ID?oYVI2ojYW@?nYId3oZfPnoj]X?@02ojaX?00AojYV?OnWICooXfA1oiQOB?n=Fe3oPUQFogeDEon;
Edko^FPeommg6?oYN@gojGPDon5Z=ooBE6co`DalolaJ>ooTK`408_oTK`001ooTK`7oi6l2onA_0ooU
KPCoiFh7onE^2?oVK@`00_oVK0l00ooVK@ooif`BonM/4P02onI/3`;oiV`@00WoiVd>onI]2ooVK@_o
iVd=onI]3?oUK@[oiFd8onE^1_oUKP@0oooTK`1]onA_0000oooTK`0HonA_000=on=d0ooLVQWof;4V
omV[8ooIZB;ofJXQomZ[8_oIZB7of:HPom^^8ooW`2Gom<dSooK>8@02ooG=8`10ooG<8_odcB?omLlT
ooG@8_ocd27om<lOooC=7oocbQgom</PooO4:_oj]2kon[H]ooVh;Ooj]bgon[X_ooZj;_oj^BkonKHZ
ooV_9?ohZ1komj@KooJU7oofZRComJlZooFa<?oe[S7omZTcooJS<_ogX2kon:0[ooVP:OoiXRGonZdL
ooZ^6Ooj[AconZ`LooV/7?oj[1gonZ/NooZ/7ooj[QkonZhLooZ/7oojZRConZLVooZU9OojYRKonZLV
ooVX9OojYRSonZHVooN_5_of/a?om[HBooN`4oog]R_om/LWooC17Ooc/Q[om:L?ooJA0_oeR@7omHP1
ooB400?olh4001;om8<0ooB40?odQ@3olXH0oo>60?oeQ`3olhD0oo210?ocPP3omHD0oo>80?ofRP3o
mXP0oo>60?obQ03olXD5oo665Oo^QA`2onn56`04onn67?o`R1kokX<IonQf2P;oi6l002OoiGDNon5P
HOoTIFCoiF]MonEZGOoTJF?ohFAXon1TIOoPIfKoh6QYon5XHooQIe_oh6ENon9YGOoVM57oj7lmonV4
;_oXPRKohh0[omQm>oo1Ldco[fiHoj]]F_n^KUSo[fiHoja]FonXK63oY6]TojE/HonXJekoXVUVoiAU
OonCH8KoY6M[okA`E?nhLToo]G5Fok9`F_ncL5T00oncL5P02OndLEOo/g5Hok5aFon_L5ko[g1Mok5_
G?nbL5co/g5LokEaF@02okIaF00>okEaF?neL5Wo]G5IokIaE_nfLESo]W5IokIaEoneL5So]G1IokE`
F_nfL5Wo]g1GokI`FOngLEP2okI`F006okE`GOndL5oo]W5NokAaGondL5oo]6mM0_ndL5h08_neL5go
]FmKokE^F?ndKU[o/FaLok1[GOn`JUco/6YKok5[FonaJeco/FUJojiWG?n^J5go[fMJojmXFon]IUoo
[6ENojmVFonaIeSo/FMGok1WF_nZIFWo[V=Qok1RE_n^HEOo[V5Iok1RF?n^HESo[EmIojeNF?n/GUWo
[EmGojmOE_n]GUL2oj]MG`03ojiNAOnZFdKoX59I00?oWe9G057oWE5IoieBFOnNDeSoWE=Hoi=@H_nB
D6CoVeAIoiiEDonREe;oWeIHoieCF_nNDU[oX5AIoj5DF_nPDe_oWeAJoj9EEOnREe[oXEQMoj5GEonR
EeGoXEMEoj9FEOnODe[oWU=LoieEF_nLE5goWUIHoj5GFOnOEE[oXUY?ojIOAonRGU?oYUiLojiOF_nb
GEco[UQQokIGJ_njDfko^55^okiAK_o7DVoob59_ol]EK_o8Ef_o_U1`okaAMOo7Efko/e5XoiYEF?nR
Hd;oZ6/mojMZ@?nVISooYf@oojUT?_nXICkoYfDoojIS@?nTHT?oY653ojIR@_nUID7oY6HnojIU?_nX
ICooZVDnojIS@OnTHd;oZVHnojYU?OnVHd3oYVA1ojMU@?nWI3koZVLlojaX>_nZICcoZF@nojaU?On[
IC`00_nZI3d03_n/ICcoZV@lojMS?_nXICkoZ6LmojUY??n[JC[oZfTkojUV?On[IccoZfPloj]W>_n[
IS_oZVHk0_nYIS`04OnVICkoX692oiMOBOn=G57oPEIGogYCFOn6EE3oZV<mom9c8ooWN@kojGP>onM`
:OoKHECob51^olA?N_o9EegogFTA01goi6l001;oi6l3onE^1ooUKPWoiVd>onM/5?oWK1Soj6/LonQ[
7_oXJR?ojFXVonUY:OoYJR[ojVT]onYY<?oZJ37ojVPconYX<_oZJC42onYY;P;ojVT_01;ojVT[onUY
:?oYJRCojFXTonUZ8_oXJQkoj6XKonM[5_oWJaCoiV`>onE]2OoUKPCoi6l1onA_0?oTL0;oiG04onE`
1OoTK`;oonA_06Coi6l0003oonA_01Woi6l000?ohWT5om^R7_oH/2D00_oIZB43omVZ8@0BomRV8?oH
Yb7oh;PToo798_ofcR7om/dRooC<8_oec2;om<`RooG=8oodcbColm0Too7>8OobcQoomlHVooZg;_oj
]Bgon[P^0_oi]bd2ooVg;00YooVg;Ooj^Boon[X_ooZi;ooj]2_onJdVooNX8?ofYQgomZPNooJ^9?of
/b_om[@aooJa=?ofZS7omZ<aooJN<?ogXR[on:PPooV[7?oj[1conZ/KooZ[6_ojZQ[onZ`LooZ]7_oj
[QkonZhMooZ^7_ojZR?onZHWooZX:?ojZBKonZLUooZX9oojZ2Somj`GooJ]3Oof[PoomZ/;ooJ[7oog
_Rd00_ofdBD07?ofcb;on;/BooZV1OoiY0Oon9h6ooJD1?oeS@;omHP1ooB70?oeQ03olh40oo:10?oc
Q03om8@0ooB70?oaQ@3olH00ooF30?odQP3om8L0ooJ70?ofR03omHL0oo>60?ocQ07olXHAonn56oo_
QA`2onn56`0Zoo277_o_QAcojWX;onE`0_oTL0?ogFU3omeEIooUJ5ooiFYNonEYFooTJF;ohVAVon1S
HOoPIFGoh6M/on5YI?oRJU_oh6MLon1UGooQIf3oi71EonMk@ooYPc7oj8<XonF2:ooIOC_o`WA;ok9^
E_n/KEWo[ViHok1`Eon`KeSoZfeMojQ/HOnYJekoZ6]MojQ/GOn[KE_o[W1Lojm`GOn`Ke_o/W1J0_nb
L5T03OncL5Wo/W1Iok9`FOnbLEWo/g5Hok9aF_naL5[o/71Kok5`FonaL5co/G1Mok9`FondL5X00_ne
LEP2okEaF@07okAaF_neLU[o]g9GokIaEoneL5So]G5HokE`FP03okI`E`0:okMaEonfL5Oo]6mKok=_
G_neL5co]W1MokA_G_neL5_o]VmJokA_G@;o]6mL0_neKUP01ondKEWo/VaJok5ZF_n`Je_o/FYKok1Z
GOn_JUd00_n_J5/03?n`IeWo[VQMojeWH?nZHeoo[6ELojmVF_n`IeSo[FENojaUJon]Hf;o/69FojiQ
E`;o[f9H00_o[F1JojePF?n/GeWoZUeJojiOEon]GeSo[EiGojaNGOn/GUko[Ui6ojQHA`02oimBF@0k
oimBEonODUSoWU9HoiiBFOnNDeWoWE=HoiEBG_n?D6CoW4iNojE7IonYBfooZTm_ojAAJOnRD6WoYe5[
ojUAK?nXDFkoZE5/ojaCJ?n]E6So[UI_ojeDKOn[DVSo[59Woja@J_n]Cfoo[4m/oj]?JonZCfkoYde^
oja>K?naCfcoYdmUoj5JDOn/GEkocEMcom9FLoo<E77o_didolE@M?o:Dg;o`e5aol9BKoo3E6co_eA[
ol1EJ?nlEfKo]e=ZokYCJoniEF_o^5A/ol9GI?neFEGoYF56ojIY?onWIcooZ6@nojMS?onVHd000_nV
Hd400onVHT;oYF92ojIT?`02ojIV?@0AojMV?_nYISooYf=0ojAR@_nYID3oZVHnojMT@?nVI47oYVE1
ojIU?onYIS_oZfHjojUU??nXI3koZV@mojUS?OnXHch00_nZI3`02_nYI3goYf@nojIU?_nXIcgoZfTk
oj]Y>_nZIccoZ6HmojYV??n[IS/2oj]W>`0EojYU??nWICkoYV@noj1S@onEGT[oRU]Boh9FEomlDeSo
PEEDoiYNAOo4K2_ohgLDonUi3OoWMQcoh6U9om=EJ?o9DFSobEA^oliJKOo?GSOohfh301Soi6l000co
i6l2onE^1OoUK@goif`EonQ[7ooYJROojFT[onYX<OoZJ3KojfPhonYX=_o[J3P2on]W>`;ojfPi00?o
jfPjon]X>Oo[J3T00_o[IcT01_oZJ3OojVPfonYX=ooZJ3SojfPionYX>0;ojVPg00KojVPfonYX=OoZ
J3GojVPdonYY<?oZJBd2onYY;00<onUY:_oYJ2Ooif/IonMa4?oWM13oig<BonMc4OoWLPgoiW48onE`
1OoUL0Coi6l1oooTK`1PonA_0000oooTK`0JonA_0003on5n2OoJYR3ofJhT00?ofJXR04oofJ/SomVZ
8_oHYb3oej@Oomb`8oo/aR?omlhQooK>8_odcB;om<dQooG=8OoecB;oll`Roo?>9OogaR_on[`]ooZj
:ooj^b_onKT/ooZi;Ooj^bcon[T/ooZh;Ooj^2conKL/ooVf;Ooj^Boon[`aooZo<Ooj^bgonK@YooR]
9OogYQoomZ8KooJU7_of[RGom[<ZooJe<?oe/3;omZXbooJZ;?ofZ2KomjHTooRW7ooiZ1gonZ`KooZ]
6ooj[Q_onZhLooZ^7Ooj[a_onZhMooZ[8OojYROonJDWooZV9oojYbKonZLZooR]7_of/13omZh?ooJ/
3?ofZ1;omk@/ooK9:?ofcR3om<dSooK:7ooj]@kon[0:ooZd3?oj/@_onZl;ooVY2OoiY@Oomid7ooJD
1?oeSP;omHT000;om8H000ColhH0oo220?obP03om8800_ocQ000=oodQ@3omHL0ooJ90?odR03om8H0
oo>73_o`QA_okXDLonn57?o_QA_ol8POoo697oo/OQ7oiG48on9_4_oFEEGofeQNonEWG_oUJF3oiFUN
onEZH?oRI6Coh6=SommSHooPIF[ohFUXon9[G_oRJeWohVQMon1UHOoPIEoohfaHonMjAooZPSCojH<Y
onJ2:_oJO3Oo`gE<oji]FOnWK5co[FiIok5_E_n`KeSo[FiKoje]F_nYK5koYF]Soj=ZI_nSK6OoZ6iS
oja^G_n_Keco/W1Jok=`F?ndL5L00_ncL5P00onbL5Wo/g5Iok=aF@02ok9aF@0;okAaF?ncLEWo/W5K
ok5`G?naKeco/G1LokA_FOndL5Wo]75IokAaFoneLU/00_nfLUP00ongLUOo]W5HokIaF@02okEaF@0>
okI`F?nfL5Oo]71Jok=`GOneL5co]G1NokE`G?ndKe_o]FmKokE`G?nfKe[o]FmKokA^FOndKEP2okE]
F02Gok=/F?naJe_o/FYJok1ZGOn^JEko[VMLojmXF_n`J5Wo[fUMoj]WHOnZI5oo[FELoj]UG_n]IE_o
/6IMojeVJ_n]Hf3o[f5FojiQEon_HEOo/69HojePF_n]GeWo[EmHojYNF_n/GeWo[UmFojiNEOn/GUgo
[EmNojiNAonVEd[oWU5IoimAF?nODUOoWe9HoieBFOnODUSoWe=HoimFEOnDD5coR3mgoj`mOOnm@Gko
_428okY6Pon[CW7oZTadok1;N?nbBgOo/TYiok=:N?njC7Go^daeokY@N?nlD7Wo^TecokU<L_nhBgCo
^4YfokQ9L_niBg;o]D]eok58Lon`BG3o]T]_okA<KonYCfWo_EA^om1CM_o<Dg;oa5A`okeALOnlDVoo
`5=_okeAL?o0Dfko`UEYokiDJ_nmDf[o_5AZokaEJ_nkDV[o/55YokYGI?o8GF7oc5YTokmIG_n[Gdgo
YFI2ojIW?onVHd7oYV90ojQR?onWHd7oY693ojAT@?nVICkoYF@nojMV?OnYIccoZFDoojAR@_nUHd7o
ZFDoojIT@OnTHd7oYVE0ojQU?OnZISco[6LjojYV>onXI3koZF@nojYT?OnXHckoZF<moj]T??nYISko
Z6LmojQW??nYJ3_oZfTkojaY>_nZIcgoZFLmojUW??n[IS_o[6Hkoj]V??nXICgoXf=1oieQAOnEGT[o
SEa@ohQIDOn6Ee;oREM>oi9IAonbISOofGHMonQi3_oYMa?oi6daom]JI?o>DW3obE=Xol]FJ?oAFfoo
cU]HomUV6@0DonA_0008onA_0OoUKPGoiFh9onI]3ooWK1Ooj6XRonUY;?oZJ3@5on]W>@03onYX=_oZ
J3GojVPf00;ojVPe00GojVPfonYX=?oZJ3?ojVPconYX=002onYY<`03onYY<_oZJC?ojVPd00;ojVPe
00?ojVTconYX<ooZJ3@00_oZJ3@2onYX=P0ConYX=OoZJ3KojVPfonYX=_o[Ic[ojfLkon]V>OoZJSGo
j7@]onQg:_oXMBOoj7DUonQd7ooXLQOoig8AonMb3ooVL@[oiG05onA_0@3oonA_05koi6l0003oonA_
01_oi6l001coh8H=omVZ8OoI[B?ofJXQomV[8OoIZb;of:/QomV/8_oIZb;of:HPomV[8_oT_bCom<`R
ooK@8_oecR;om<dQoo?<8Oodbb7on<<ZooZh<Ooj_37on/0^ooZm;Ooj^Rcon[/[ooZl:ooj^R[on[T/
0_oj^Bd2ooZi;P1HooZj;_oi^Rgon[/_ooZl<_oj_C;on[d`ooVf:_oh[B?omjHNooJS7?ofYakomZhU
ooJc;?of]c;om[HaooJa;oofZR[omZPVooNW9?ohYb3onJPMooV/7Ooj[1_onZ`MooZ_7?oj/1conZ/O
ooVV9?oiYBOonZHWooZV:ooiZbComZdBooJ/4?of[A7omZX?ooN/9oof`33om/hSooK>8?odcB?oml0H
ooZ]2Ooj[P_on[0;ooZb3?oj]0gon[D=ooZe3_oj/`_onZd:ooVX2OohXPKon9X4ooND0_odSP7olXD0
oo:20?odP`3olX<0oo>30?odPP3omHD0ooF80?odR@3om8P0oo>72OoaQaWokhDMonn57?o_QA_ol8HL
oo697oo^Q1?oigH=on5Y<_o?CeWofUYFon=SGooUJF3oiF]MonEYGooSIV?ogf9UomiQH_oPIFGohFQX
on5ZH`;ohV]J01[ohVYKon5XGooPIEoohV]EonMhBooYP3[ojH<ZonR2:?oMOCKoa7E;ok1]EonYK5_o
[ViHok1_F?n`KUSo[fiIoje]F_n/KE_oZ6aPojE[I?nTK6KoYFaUojU]HOn/Keko[fmKok9`F0;o/g1H
01Oo/g1Iok=`F_nbL5Wo/g1Hok9aFOndLUOo]G9HokAbFOndLESo/W5Kok5`G?naKe_o/W1Jok=`Fonb
LEgo]75IokEaF?nfLEOo]g5GokIbFOneLU[o]75JokA`FP02okE`F@0GokEaFoneLEco]75OokAaG_nf
L5[o/g1NokA`GoneKe_o]W1KokE^F?neKEOo/feJokA]F?neKEOo]6eHok9[FOn`JUgo[VUOojiWFon_
J5[o[fUKojmYGOn/IV000_n[I5d03?nXHf7oZV9NojmUHOn^IVWo[f=LojiPEon^HESo[f5GojiRFOn]
H5[o[5iJojaOF0;o[5iI00Wo[EiGojeME_n/GUko[EmOojiMB?nWF4WoWU5IoimBF?nODUL00_nNDeP0
F?nODeOoXUMBoieDE_nJAFgoXc>;ojXkR?na@Woo^SJ<okTlQ_nd@g_o^Sj2okI4O_nbB7[o/dQiok97
NoniBWSo_4YfokU=MonkD7Wo^deeokM;LongBGGo]TUeokI:LOniC73o]d]eok5:LOn^BFoo[TY_ok5<
K_ncC77oaDiholeEM?o3E73o`59bol=DKonlDVko_55_okiAL?o0E6oo`eE[okeCJ_nlDf_o_eE[ok]D
J?nhDFWo_EAXolIKH_o7G67o`eaQolUIIOo;EfWo]EYKojMSB?nXIckoZFHnojMS@?nVHT3oYF@oojMV
?OnVISkoY6@nojMU?OnYISkoYF=2ojAS@_nWI43oYfE0ojIT@OnVI43oZ6HmojUV??n[Ic_oZVHkojUU
??nYI3koZV<mojUS?OnZI3goZVHlojUW??nYJ3coZ6LlojYX>on/JC[oZfTkojYX??nYIcd2oj]W>`0H
ojaW>onZIS_oXf=1oiUPAonAGTgoS5aAoheKConCFdSoUE]6oiQLA?nXHc_ob6lWonAj4ooYNQ3oiG4R
omeSC_oDEfgocUA[ol]EIoo:EVWod5]Wom5JJoo@GC_ohFd64OoTK`003?oTK`;oiFh6onI]3ooWJa_o
jFXXonUY;_oZJ3GojfLlon]W>_o[IcSojVPgonYX=@;ojVPd00CojVTbonYX<OoZJ3;ojVPd0_oZJC<2
onYX=005onYY<ooZJC;ojVTconYY=?oZJ3@00_oZJC<00ooZJ3CojVPeonYY<`02onYX<`05onYX=?oZ
J3?ojVPconYX<ooZJ3@01_oZJ3<04?oZJ3;ojVHdonY/<ooWMS3oiWLbonIf<ooWMS3oigD^onMd:ooW
M2Koig@QonQb6ooXLA?oiW4<onE`1_oTK`7oonA_05coi6l0003oonA_01_oi6l000Coi741omj>4OoH
[BCofJ/R0_oIZB42omVZ8@0AomVZ8_oIZR7ofJPQomRY8OoN]R?okLPSooK@8Oodc23oll/RooS4:_oj
]C3on[P^ooZm;_oj_2oon[haooZn<?oj^bd00_oj^Rh01?oj^bkon[`^ooZm;_oj_2l2ooZl;P16ooVl
;_oj^c3on[X_ooVk;ooj_2oon[daooZm<?oi^RoonK8YooNV8?ofXAcomYlJooFT8?oeZbOom[@]ooJi
<_of]S7om[4^ooJ/:_ofYbOomjLTooNX8_ohZB3onJXOooZ/7ooj[a_onZ/KooZW8OojYRKonZ@XooVT
9OogZaComZ`>ooJ/4?ofZ`komZLIooJd<oofb2[om//NooK;8OofbR;onKH@ooZZ2Ooj[`con[0<ooZa
2ooj/0_on[4;ooZa3?oj/@_on[8;ooZc2ooj/P_onZl:ooV[2OoiY0Oomid3ooNF0_oeS@7olhL1ooB3
0?obP03om840ooF70?odR03om8L0ooB91?oaRAKokhPNonn77P;okhDK027ol8LKonj75?oZLbCofEAG
om9DD_oIF5?ohF1MonAXHOoTJUkoiFYKonAWH_oPHFWogV1RommTH_oQJ6[ohVYVon9ZG?oRJeWohfaJ
on5[G?oQJE_oh6EMon5WG?oULU7oj7hmonV4;ooWPR[og7heolQfBOn_K5SoYV]MojU]GOn_KeP00_n`
KeL01?n`KUOo[FeKoj]]G_nWKF<2ojE]I@0;ojM]HonZKF3o[6mOok1_G?ncL5So/g1Iok=aF_ncLEWo
/W1Jok5`FOncLEP00_neLUP00oneLUOo]G9Hok=aF@02ok9`F`0Bok9`GOnaL5go/FmKok=`F_neLESo
]g9GokIaF?ngLUOo]W5GokEaFOncL5Wo/g1LokEbG?nfLUco]79PokE`GOndL5go/g1P0_neL5`02One
Ke[o]FiIokA^FondKESo/feIok=/F?neKEOo/VaLojiYG`02ojiXF`1JojeXGon_JEoo[6IOojUSGonZ
HeooZF=PojQQGonXHfWoZfE[ojmRF_n^H5Ko[V5HojmQEon]HE[o[f5IojaNF_n[GUWo[EmGojaOFOn/
GESo[EeGojaMG?n]GV3o[ei9ojQHB?nNDEWoWe9HoimBEonNDUSoWe9Goj=GD?nQEECoXdQ/okHjQ_n/
>X_oXS^4okHdRoo7=8go`422okm3Ooo2?h7o`3n2okQ6OOndBWSo/TYfokE;MOniBgCo^4aeokQ@N?ng
CgKo]D]eokM;LondBWCo]D]`okU=LOniBgGo]DYboje8LOn`BG7o[Ta_ok1;K?nmC7Cob55golACL_o1
Dg3o`e9`okeALOnlDW3o`E=^ol1CK?nmE6_o_5AZokeEJOnmEFSo^UAWol1DIoo9EfOob5YSolIJHoo4
G6?o`UUTolEHIoo@EfgoaUQTojeNDOnVIT;oYfLnojIU?_nWICcoYVHm0_nWIcd06OnYISgoYVA1oj9R
A?nUI47oZ6I0ojQV?onWICooZ6DnojYW??n[IccoZVLkojUU>onYI3coZV@mojMT@?nWI3koZVPkoj]Y
>onYJ3coYfLmojUX??n/J3[oZfTkojYY?OnYISd00_n[Ic/06?nYICgoXV=1oiUPAon@GDgoSEa?ohmM
COnHGTOoWEi2oiUL@onJG4;o^6Taom]g6OoXNPkoj7HGon=[??oEFFKocU=`oliFJOo>EfKobeIZolmK
HOoCGF?oc5UKomUV6@ooi6l000Soi6l2onE^2?oVK17oj6/LonUY:_o[IcSojfHnon]V?@;ojfLh00Ko
jVLfonYX<ooZJ3;ojVPconYX=?oZJ3D3onYX<`04onYX=OoZJ3CojVPdonYY<P?ojVTc00WojVTbonYX
=?oZJC?ojVPdonYY<ooZJ3?ojVPdonYX<ooZJC400ooZJ3<01?oZJ3;ojVPconYX<_oZJ383onYX<`;o
jVPb00OojVPaonYW=?oXJ33oiFl[onMg;OoWMRgoigD]00;oigD/00WoiWH]onIe;ooUMBooiWD^onId
:_oWLbCoig8LonMa4OoVL0P0oooTK`1KonA_0000oooTK`0LonA_0005on=b0_oLUaOoejlTomV[8_oI
ZR400_oIZb805ooIZb7ofJ/RomV[8_oIZB;oejHPomV^8ooV`2;ollhRooS6:_oj^Bkon[P^ooZl;_oj
^bkonKL]ooZk;ooj_C3on[/_ooZj<?oj_2oon[/_ooZl;ooj_Boon[d`00Con[d_00Kon[`_ooZk;_oj
^bkon[`^ooVm;_oj_c02ooZo<P0PooVj;_oh/BOomjLPooJQ7?ofX1comZPRooJ^:_of]S3om[TdooJi
<oof/BkomJ//ooJW:?ofYBKomjHVooRY8ooiZakonZ`MooZY8?ojY2KonZDZooRZ6Oof[@oomZ`@ooF/
3_ofYPoomjP[ooJl<oofbR7om/`NooG<9Oog`a`2ooZ/2`;onZl=00[onZl;ooZ_3?oj[`conZl:ooZ_
2ooj/0_on[4:ooZa2ooj/P_on[<;0_oj/`T0<Ooj[0SonJD8ooNL1OofT`?omX`1ooJ:0OoeQP3om8@0
ooB50?ocQP;olXXConn97_o_R1kokhPLoo267Oo_R1cokhHGonYU@_oMEFKoeeMAomMGDooNG5goi6IO
onEZG_oUJU_oi6QPommPK?oMH6CogV9PommTJ_oQJF[ohV]Oon=[FOoRJeWohfaJon9/FOoQJE_ogfAM
on1VFooTLE;ojGhoonV3;_oWPRWogX0dol]gB?naKESoZ6]Koja]FOn_KUP00_n`KUL01_naKUKo[fmI
oji_Fon]KegoZViPojM]H`;oYVeT00WoZFmQoji_GOnaL5_o/W5Iok=`FOnbL5[o[g1Lok5`FoncLUT0
0_nfLUL01oneLUOo]G9HokAaF?ncLE_o/g1Lok=_F_nbL5/00_naL5`04_ndLEWo]G9HokIbEoneLESo
]W5FokA`F_ndLUgo]G5KokAbGoneLEco]W1IokA`G_ndKego]W1KokE`FondKU[o]6eIokA]E`?o]6eH
01Go]6iIojm[GOn^J5_o[fQLojiYGon/J67oZVEPojYRGOn[Heko[fAJojaTFonTHVkoYf9^ojeQFon_
HEKo[V5GojiQF?n]HEgo[V1JojeNFOn[GUX00_n]GeP01on/GESoZeeIojaNG?n]GUko[Ue;ojMGBOnL
DEX00_nODUP0AonNDUSoXeM@oj5DEOnXB6go`3n4ok`oR?n^>XSo]2nAok``SOnm@7ko_DIjoka6O?nm
A7ko`D20ol11OonlAGko^4UkokE:N?ngBWGo^T]eokU@MongCg[o]dafokQ<LondBgCo]T]aokY=L_ng
Bg?o^4]bok5:L?n]BFoo/D]^oje;JonaAg?o`4egolQDMOo6Dg7o`U5`ol9BLOnoDW7o_e=_okiCKOnm
Df_o`5EYokiFJ_niE6So_5MUolIIIOo9FFCoaEUUolAII_o5FVKoa5]VolAKI?o8FFGocUIZolaGJone
GE_oXf96ojEW?OnWIccoYVDmojET?OnWIScoYf@noj9RAOnUI47oZVHmojQV@?nTI47oYfHm00;oZfLk
02[oZVHkojUU>onYICcoZ6<mojMT?onXJ3koZVPkojaZ>OnYJ3coYVLnojUX??n/JC[oZfPjojYX??nZ
IccoZFHlojMU?_nRHd7oUUm9oheKD?n>G4ooUEe9oieN@onQH3ooX5lnoiQK@_nSHD7obG0Won=j4OoY
NA7oiW4YomYND_oBE6kocUEaoleGJ?o=EfKoc5MYolmJHooBGEgod5aRolmM>_oSKP<=onA_000>onE^
1ooVK17oj6/NonYY;oo[IcWojfLmon]V?oo[ISgojVLgonYX=OoZJ3CojVPbonYX=?oZJ3<2onYX=009
onYX<_oZJ3CojVPeonYX=?oZJ3GojVPdonYY<ooZJ3GojVPd00;ojVTc0_oZJ3@01ooZJ3KojVPdonYX
<ooZJ3CojVPeonYX=?oZJ3D00ooZJ3<3onYX<P0?onYX<OoZJ3;ojVPdonYX<ooZJ3;ojVLbon]W=Oo[
IcKoifT_on5/7_oRKaooj7D]onQf;OoWMRgoigD]00;oigD[0_oVMB/02?oVMBgoiWD^onEe<?oUMC3o
iGD_onIc9_oVLA;oiFl4oooTK`1IonA_0000oooTK`0MonA_0005on=g1OoLXQkoe[4UomR[8_oIZb80
0_oIZR82omRZ8P0@omVZ8_oIZR7oeJ@NomZW8Oo`_bcon[T^oo^i;?oj_2kon[X^ooVh;Ooi]bgonKT^
ooZk<?oj^Roon[X]ooZk;`;on[/^0_oj_2l02Ooj_C7on[/`ooZm<?oj_2kon[/^ooVk;_oi_2kon[`_
ooVl;`02ooVk;`0VooZn<?oj_c7on[h`ooZl;_oi]bWon:hTooNU7OofWa[omZ0LooJY8oof/b_om[P_
ooJi<_of]C7omK0_ooF[;?oeZ2[omZDXooNX9_ohZB?onJLSooZU:ooiZ1gomZ/>ooJ/3_of[@oomZT=
ooJS7?of/3Som/H[ooK<7?ofbb;omLXTooVi4oojZ@SonZd;ooZ_3?oj[P/3ooZ^3003ooZ^3Ooj/0co
n[0;00;onZl;04[on[0;ooZa2ooj/PWon[@7ooZ]2Ooj[PWon[8<ooZ^2_oiYPSon9l6ooNE1?ogT0;o
m8T0oo:70OobR@ookhPLonj77Oo_R1gol8PNonn;7?obP1ookF9JommMHooHF57oeUI?omaJF?oSI5go
iFUOonEZFooSJ67oh65[omiPIOoNHUkogf9Won5XJooRJfCohV]Jon9ZFooSK5_ohVeIon9[F_oQJEWo
h6IKon5VFooSKUCoj7]2onV2<OoXPR[ohH4aoleh@oneKeCoZf]Ioj]/FOn_KUOo/FmFok5^EOnaKeKo
/6mIok5`F?n_L5[o[FmMojU^HOnUK6GoY6]VojA]I_nZKf;o[W1Nok9`F_ncL5So/W1Iok=aF?ncLE[o
]79IokIbE`?o]G9G0_neLUT00oneLUSo]71Jok9`F`02ok9`F`05ok=aFonfLESo]W5GokIaEoneLE/0
0_neLU`0N_ndLUko]G5KokA`G?nbL5oo/VmNokE_FoneKUWo]6eHokE]EondKEWo]6eHokE]EondKEWo
/f]Jok5ZF?n^JEgoZfQQojIUI_n[Heoo[fAGoj]SG_n^I5[o/FEGojMSK?nSH6ooZUmMojmQE_n_HEOo
[V5JojiQG?n^H5Wo[EmGoj]NFOn]GeSo[EiHojeNEon[GEWoZUeOojaNGon]G4coYUI;oieAG?nODUSo
We9Goj5GD_nQDeSo[4Mbol0oPoo1?hGo`Cj7okh`Tone;Hoo/3^1ok93O?nkA7go_4Alok]5OOnlAGgo
_D=koki1OOnm@gko_4MmokI9N?njC7;o^4ifokI?NonhCGSo]dacokE;M?nfBW?o^DaaokU=L_nfBg?o
]4a_oja8Kon_BVoo[TaZoje5L_niAg[oaEAcolADL_o3DW7ob5AaolACLOnhD7;o_55_ol5DKOo0E6[o
^UAXok]FI_o4FV?oaEUSolEGIoo6EfOoaEUVolILHoo5Ff?oaEYUolQJIoo8F6KobUIVolYHI_noFV3o
Zf5;ojMW??nVIc_oYFDmojIV?OnUID7oY6=2ojYV?OnYISkoYFE1ojIU?_n[J3_oZfPloj]V>onYICco
Z6DlojUV??nWISkoZFLl0_n[JCX08_nWJ3koYVLnoj]Y>on]JS[oZfTlojQX?_nYISgoYfDmoiiQ@onE
GTWoSEa?ohiKC_nGGTOoXV4oojIR>onSGccoVEa4oiIKAOndJ3;og7PIonQl3ooXMQ_oh6I0omIHHooB
EfcodeUZom1HIOo=EVKocUMXolmKHooAGE[odUeSoliLEooHIA/;onA_0005onE^1?oVK@goif/HonUY
9_oZJ3<00_o[IS`02?o[Ic[ojfLionYW=OoZJ3;ojVPconYW=OoZJ3KojVPd0_oZJ3D2onYX=0;ojVPe
0_oZJ3@00ooZJ3?ojVTconYY<`03onYY<`0;onYX<ooZJ3CojVPdonYX<_oZJ3?ojVPeonYX=?oZJ3Go
jVPconYX=?oZJ3800_oZJ3@00ooZJ3?ojVPbonYX<`02onYW=00BonYW<ooZIc;ojVLdon]W=ooZJ3?o
i6/Xon5]7?oPKQKohVhMonQc;?oXMRgoigD/onMf;?oWMBcoigD[onMe;OoVMBcoiWDZ0_oUMB/01ooU
MBgoiGD^onAf=?oUMSCoiW<RonEa3_oTK`40oooTK`1GonA_0000oooTK`0NonA_0004onF13OoJZB;o
ejdQomVY8@GofJXQ00goeZHOomZZ8Oo[^B_om[H_ooNf;ooh^Bkon[T^ooZh;_oj]bkon[P^ooZi;Ooj
_2oon[X_00?onK/_00Won[X^ooZk;_oj^bkon[`_ooZm;ooj_2kon[/_ooZl;ooj_C001?oj_Bl0:Ooj
_2oonK`_ooVk;ooi^boon[`_ooZn<?oj_c3on[`_ooVf:_ohZb?omZ@MooJQ6oofXacomZ/TooJb:_of
]c3om[TbooJg<_oe/BoomJ`]ooFX:_ofYbKomjDZooNT:_oeZ1comJXFooJ[4OofZ`_omjD=ooNW;oof
_CSom/dPooK:8?oebRGom/HOooV_3?ojZ`[on[0<ooV]2ooj[@_onJd;00;onJh<00conZd=ooV_2ooj
[@_onZh;ooZ`2_oj[`[onZl8ooZ`1_oj[@SonZX9ooZ/2ooj/P/2ooZd300aooZ_3?oiZ`[onJP9ooRT
1OogW0;omID=oo2>7_o_RaookhPMonn67?o_QQWokVDaon]QFooVH6;ofUYGomAED?oIFE;ohV=LonAX
GooUJUcoi6QPon9SJOoOH6KogV9OomiQH_oPIf_ohVaWon9/G?oRJe_ohVaJon9[FooRJU_ohV]Ion9[
EooQIe_oh6IJon=/EOoWN4SojX4fonR3;OoQP3;oc7Q2okA`EOnVJUkoYf]Moji]FOn`KUOo/6iHok5_
E`03ok9aEP08ojm_F_n[KUooZFeRojI]IOnSKFSoYFeVojU^HOn^L5d2ok9`F@07okAaF?nfLeOo]W9G
okIbE_neLUOo]G=IokIdFP02okIcE`0UokIbEoncLE[o/FmLok=`F_ngLUOo]W5HokIaEondLE_o]W=K
okEcG?ndLeko]G9LokAbG?ndLUko/W1Ook=_GOneKU[o]FeGokE]F?ndKUWo]FeGokE]E_ncKEWo/F]K
ok5YFOnaJEco/6QLojeVGon[I5oo[6=KojeSG?n[I5go[VAJojYTJ_nSH6goZ5iNojePF@02ojiQF@21
ojeOFon]GeWo[UmGojeNF?n/GeSo[UmGojeNEon^GEKoZeeNoj]NHOn]G4coZ5M9oii@FonNDUWoXUI@
oiiAF_n]AGCo`T24oka0Q?o2>hSocS>?okd`T?n_>8Go/T5lok=0O_nf@7oo^D=mok]3OOnlAGgo^dIk
okU6Monk@W[o`d=mok]5O_niB7Wo^4]hokA>NongCWOo^4aeokM:MOnfBW7o^Teaoke=M?nfBg;o]De^
ok5;Kon_BFoo[D]/oje7L?nf@gco_E1dokmEL?o7E77obUE^ol9BKonhCW7o_59_ol9EK?nmEFSo]eAV
ol1GI_o8FVGo`EMVol9EJ?o:F6Oob5UWolILIOo6G6CoaeYUolIHJ?o6FFKoaUUPolEGHOo7FF?ob5eR
ok9LEonSH4?oZ6PgojMX??nUI47oYfE0ojUV?_nVICooYfDmoj]W>_n/Ic[oZVHlojUU??nWIcgoZFTk
ojUX??nYJ3goZfPjojYW>onXIccoZ6Pmoj]Y>on]JCWo[6TkojMW?_nSI43oWf92oiANB_n;FU3oT5a=
oi]OA?nTHCcoZV<hojQR>_nOGcooTeQ6oj5N?_o<Lb;oi7/@onUg4_oUKC;oeeeFom5EIooEFFcoeE]U
om1IHOo>EfOocEMXoliJH_oAGE[odeiKom1KJ?oAGT7oh6`800Ooi6l0013oi6l1onE^1OoVK@coif/E
onQZ8OoZJBoojVLgon]W>_oZIcSojVLgonYW<ooZJ3;ojVPconYX<OoZJ3;ojVPc0_oZJ3D4onYX<`04
onYX=?oZJ3GojVPeonYX=0CojVPe00?ojVPfonYX=?oZJ3@00_oZJ3D3onYX<`06onYX=OoZJ3;ojVPb
onYX<ooZJ3;ojVPc1?oZJ3802?oZJ3?ojVPaonYX<?oZIc?ojfLeonYX<ooVJR_ohVdN0_oPKQX01_oP
KAWohFdJonEb:?oYMbkoj7H^onMf;@;oigD/00goigD]onIe:ooVMB[oiGDZonEe;?oUMB_oiG@ZonEe
:_oTMBgoi7DaonEe;OoTLQGoi6l10?ooi6l0E_oTK`000?ooi6l07ooTK`004_oTSaSoejdSomR[8OoI
ZB7ofJXQomVZ8_oIZR7oeZHNomZZ8Oo/^bcomkL_ooJd;ooe]Room[@^ooNe;_oi^2kon[T]ooZj;P;o
n[/_00Gon[`_ooVk<?oj^boon[/_ooZj;P02ooZk;`04ooZk;_oj^Rkon[/^ooZk;P?onK/_0ooj_C00
:Ooj_Boon[d`ooZm<?oj_2oon[d`ooZm;ooi^bkon[d`ooZn<Ooj_33onKP]ooRa:?ogZB3omj<KooJO
6oofY1komZdUooNf;Oog^c?om[hfooJk=?of]37om[0/ooF^;_o`WRCol9dQoo:U8oodZAgomZ8@ooJQ
5oofZCCom/@VooK<7OofbbCom/`WooW06?okZ`WonZh<ooZ_3?oj/0conZl=00;onZl<02gonZl=ooZ`
3?oj[`WonZl:ooZ]2Ooj[P[onZl;ooZ_2_oj[P[onZ`;ooZY3?ojY@_onZT:ooZ^2_oj[@[onZl<ooZd
2ooj]0con[L@ooZd2ooh[A7omJ/Too>U:ooaVRSol94Oonmn9OoYH5KokV9Bon]QHOoLFU_oeUM@omQH
E?oPGegoi6QNonAYG?oTJ5gohVAUommRJ?oMH6CogF1Ron1UJ_oRK6SohVaOon9[FOoSJeT00_oRJe`0
:_oRJeSohV]Gon9ZF?oQJE[oh6MLon9ZEooVMT_ojH4jonR3;?oSPC7od7Y0okM`DonYJe_oZfaKok1]
F?naKUSo/VmGok9aEonbLEKo/g9Eok9aE_n`L5Wo/6mJoje`GonZKf;oYViVojA]J?nUKFGoZfmPojm_
G?naL5[o]79IokIbEongLUGo]W=FokEdF_neM5Wo]7=IokAcF?nbLU_o/W5KokAbF@;o]G5I00Co]g5G
okEaFOneLUco]W=K0_nfLe`03?nfLe_o]W9KokAbG_nbL5oo/ViNok=^F_neKUWo]FeGok=/F?ndJeOo
/VYJok5ZF`;o/VUJ02Co/fUHok9YFOn_IU_oZV=Moj]SGOn^I5[o[FALojYTK?nXHFOoZEmMojYOG?n/
H5[o[V5HojeOF_n]GU[o[EmGojiOEon]GeWo[5eHojeME_n]GUOo[5eMoj]MH_n[FdooZ5I:oj5BEonQ
EECoWe1Nojm5MOo0@H?o_Cn4ol@iROo?<Y7obS>=okLhQ_n]>h<2okI2O00@okA0P?ng@Wgo^4Anoka3
OonlA7go^4IhokI6MonnAGKo`4=iok]1OOnlAWko^TilokU?N_niCGSo]D]dokQ<L0;o^Tac02Ko^4a`
okI;LOndC6go[d]]ojY:KOnZB6oo_4=lol=>N?nnDg7o`EA_ol5CKonmDG7o^e1bokmALOo2EFgo_5EW
ok]EIoo6F6SoaeUVolMHIOo6EVSobEQVolUII_o7FVGoaeaVolIIIoo5EfKoaE]PolIJH?o4F6;oa5UP
ol9IH_o6FFGo_UYJojYPAonSHcooYVHnojUV?P;oYfDn02goZVLkoj]W>onZIccoYfLmojQX??nYJS_o
ZV/kojYX??n[Ic[oZVLjojQW??nXJ3go[6XjojaY>_nYJ3coXVA1oiUPAon@GDgoRE]BohYKDOnJGdGo
Yf8kojYS>?n[HcSoYF8loiIKAOnFFTGo]FPbom]g5?oYN@ooig<TomQOBooAEF;odUMXomQKJ_oEFf;o
dEYPolmHJ?o=EfSoceYQom5LGOoAGEOoe5iRoliJH?oIIB801OoTK`003?oTK`;oiFh5onE^2OoWK17o
j6XNonUY:ooZJ3;ojVPgon]W>OoZIcOojVLfonYX=0;ojVPc00CojVPaonYX<ooZJ3?ojVPb1?oZJ3<0
1?oZJ3;ojVPconYX<ooZJ383onYX<`04onYX=OoZJ3CojVPdonYX=0CojVPe0_oZJ3@01_oZIcGojVPd
onYX=?oZIc?ojVLdonYW=@;ojVLd00?ojVLconYW=?oZIc<00ooZIc<2onYW=@09onMZ;_oSK27ohFhH
on1^6_oQKQ[ohFdKon5^6_oPKASohg0U00;oj7H^00OoigD/onMe:ooWMB_oigD[onIe;OoVMB[oiWD/
00;oiGD/0_oTMB/2onAd:@04onAe;ooUMBooi78JonA`1?ooi6l0EOoTK`000?ooi6l07ooTK`001?oT
M0Coh9`OomN^8_oIZR42omVZ8P05omJV7_oIZR7okK`/ooNi;oof]Bl00oof]Bh02?oe]2kom[H_ooRk
<?oj_2oon[X_ooVk;ooj_2oon[X_0_oj^bl02_oj^Boon[/`ooZj;_oj^Rgon[X^ooZk;ooi^bkon[/^
ooZl;ooj_C03ooVk;`;on[`_02Kon[d_ooZm<?oj_2oon[d`ooZn<?oj_c7on[d`ooZo<Ooj`CCon/0d
ooZm<_oi^BkonK4XooNW8OofWQ[omITFooBE5_odVacom:@SooB];?oc[bkolJLXonjI8_o^V23okYXS
onnM9Oo`WB;olJ0Loo2I;?o^XC3ol[XFoo:k6?oa^acolKdJooN^2ooiX`GonJT9ooV/2@?onJX90_oi
[0X0FOojZ`WonJX:ooVY2_oi[0[onJh;ooV^2_oi[P_onZd;ooZ/2oojZ0konZ<=ooZT2ooj[@[on[0:
ooZ_2_oj[@_onZh<ooZa3Ook]P_onk/AooW59_ogaCOom[hcooBb:ooVOCoogee;onMP?Oo[He;oh5UQ
omMFDOoHEUGogUeJonAVH?oUJEooi6ULonAWH_oPHF_og5aXomaMHooOHF_ohVY]on9]IOoSK5WohV]H
on9ZG?oSJe_ohVaHon9ZEooRJUSohV]Hon5XF_oPIe[ohVUJonMeCooYOcWojH8^on60<?oBNcgo_79@
oje]FOn/KE_o[feIok9_FOnbL5So/g5Gok9`EonaL5So/W5Gok5aFOnbLESo/G1Ioje^G_nYKV;oZ6eT
ojI]IOnSKFOoYVeVoj]_H_n_L5go/W5Iok=bF_ndLe[o]G=Hok=cF_ndLeWo]7AIokEcF?ndLUWo]75I
00;o]G5I00co]79LokIcG?neLeco]W=MokEcG?neLE_o]79Mok=aG_naL63o/6eNok1[G?nbJUT2okA[
E`03okA[F?ncJUWo/VUK00?o/VUI00go/VIGojiTFOn[Heoo[VAJojeUG_nXI6koZF5Uoj]OFonZGeco
ZEiLojaOF_n^GeWo[EiJ00;o[UmG05?o[5iJoj]MFOn]GUKo[EiHoj]LG_n/G6;o[5a?ojQHB?nTEE7o
XDeSokA3Nono@H?o_D61olDgR_o><I3obCJ:ol@kQ?nk?8Co[3^3okI1O_nlA7_o]d5nokA1O_nh@gko
^d=nokY3NoniA7_o]dIhok]8MOnnAg?o^41jokU1OOnnBWgo_Dj0okU=N_neC7?o^4]cokU<LOnhC77o
^De`okM<LOndC6oo/4][ojU:K?nWAg3o_4=jolU=N_o1Dg?o_E9`okYAKonoDfoo`55aoki@K_o4Dfco
`5EZolEJJOo:FVOobUYUolUJI?o4EfOoaeMWolUII?o8FVGob5]WolEHI_o6FEooaUYNol9IH_o2FV7o
`eQQol5HGoo4FUkobE]PolIHIOncFE[oYV14ojQV>_nYIccoZFHlojUW?OnXJ3goZ6PlojUZ>`02oj][
>@0WojYZ??nZJ3coZFPkojUX??nZJCcoZfPjojQV??nQI47oU5i:ohYJDOn8Fe?oSEe>oiQNAOnTHSgo
[6Dgoj]T>?nWHS[oWem0ohiIB_nSH3god7<OonEk3ooYNQWohFLlom9FGOo>EFCoeU]XomULJOoFFf3o
d5UPoliHIoo=Ef[oceYPom1LGOoAGE_odUeGomANJ?o;FTOoh6`900;oi6l000ooi6l2onE^1ooVK@co
iV`@onM/5?oXJR3ojFT/onYX=_oZIc[ojVLhonYW=ooZIcGojVPeonYX<ooZJ3800_oZJ3401_oZJ3;o
jVPdonYX=OoZJ3?ojVPbonYX<`;ojVPd00?ojVPconYX<_oZJ3801?oZJ3<2onYX=0GojVPc00KojVPb
onYX<ooZJ3CojVLeonYW<_oZIc@2onYW<`;ojVPb0_oZIc<2onYX<`0Aon]W=Oo[IcKojFLconIZ;OoR
K27oh6hJon1^6?oQKQWohFdKon5]7?oPKAcohFhLon1]6_oRKR7oigD[onMf;?oWMB`00_oWMBd3onIe
;003onEe:ooUMBcoiGD[00;oi7@Z00Ooi7D[onAd:_oTM2[oi7D^onAe<_oTLaooi6l40?ooi6l0E?oT
K`000?ooi6l08?oTK`002OoUO`gofjHQomJ]8OoIZR;oeZ@MomVY8?o]_2comkL`ooJd;`02ooJe;P;o
m[H^00WomKH_ooFf;_of]c3omkT`ooVl<?oj_33on[d`ooVk;_oj^bl00_oj_3001Ooj_C3on[/_ooZk
;ooj_C3on[d_00?on[`_00Gon[d`ooZn<?oj_c7on[d`ooZl;`03ooZm<003ooZl<?oi^c3onK/`00;o
nKP^01oonKD/ooVe;Ooh/Rkon;0/ooRa:ooh[R[omjTWooJQ8OodSaCol7X6oni`0Oo^L@;okW/9onj7
4oo_TAcoki/SonnM9Oo_VbCokiXSonnJ9?o_VR7okYDSonjE;_o]ZQSojZX@onZY5?oYYQGokj`AooJQ
0oofV`3omY/400GomY`400ComY`5ooJN1?ofW@Comid30_ogW`D0C_ogXPKomj46ooNO1OogXPKomj88
ooRM2oohU`kon9T:ooRQ1oohYPKon:L7ooRT2?ohY@SonJP5ooVW1Oog/1Oom;D/oo:j<_o[ZCOodVm@
omA/DOoNMEKoeV]Oom=IGOoHEe?of5IBom]KF_oSI5koi6QPonEZG?oTJ63oh65/omaLL?oLFVWog5Y[
on1VK_oTKf[ohfiMon9[FOoRJUgohfaKon9[FOoRJUSohV]Fon9[EooRJeKohFQIon5UG_oRIe_oiG9@
onUn?_oYPBoohX0_om=l?_nkLE3oZVYIoj][Fon_KU[o/g1HokEaEondLEOo/W1Hok=aF?ncLUSo/g5G
ok9aF?nbL5So/71Joji`GOnZKV;oYFaUoj5[J_nSK6[o[6iQok9_FonbL5go]75JokEaF0;o]W9G02Ko
]G5HokEbF?neLESo]79Iok=aFonaKeko/W5Qok=`G_ndLEoo/g1Ook=_G?ncKego/FmRok9^H?naK5_o
/6]Kok1ZG?nbJU[o/f]HokAZF?ncJU_o/VYMok9YFOnbJE[o/VQHok5WF?naIUSo[VEKojiUFOn[I6?o
YfEbojQPI?n[GeWoZemKojYOG?nZGEcoZeeKojiOF@;o[f1G08Co[EiHoj]MFOn/GEOo[5eHoj]LGOn/
G5oo[Ue;ojYJAOnUCV;o^49ooki1Q?nk@8;o`cR9ol/bSoo9=HWo`c^4ol@mPonn?X3o[3^3ok=0Oonn
A7Wo_4=lokI0O_ne?goo^D=nokY3OOnh@g_o]dAioka7M_nkAgGo]dEfokI2Monm@goo`4Z2oka=O_ng
C7Ko]dYaokQ;K_niC73o^D]bokU<LOndC6oo[D]]oj]:JonYBVco^4=hol=6OOo3DW?ob5E^okmAL?nj
DFoo_U9]okmCJoo7E6gob5I[olUJJ?o7FVKobEYVolQJI?o2F6KoaUMVolUIIOo7FVGoaUYUolMKHOo6
FUko`eMSol5IHOo2Feko`eYOol=JH?o5Fego`UYNol9GJ?o:F6Wo`UUKoj]NBOnWIScoZFTjojY[>_nY
Jc_oZFXkoj]Z>On[JcWoZF/kojUY??nZJ3coZFPlojYX>onYIc_oWfA2oi5NC?moF5WoO5MLoi9MBonQ
HSooZ6<iojaT=_n]I3KoZF<ioj=Q?_nIFd?oT5Q8okIX;ooONA?oj7P?onM_;OoHH5CocUEPom1GHooG
G6OofEaUomELGooBFUood5UVoleGJOo>FV7odEaLom5MG?oBGUSodEeMoliKGooEHb7oi6l0onA^0ooV
KP_oifdBonM/5?oWJaSojFXSonYY;_oZJ3H2onYW=`05onYW=_oZJ3GojVLdonYX<_oZJ3<00_oZJ380
1_oZJ37ojVPconYX<ooZJ3?ojVPbonYX<`;ojVLc00GojVPdonYX=OoZJ3CojVPconYX=002onYX<`0;
onYX<_oZJ3CojVPconYX<_oZJ3?ojVPbonYX<ooZJ3CojVLconYW<_oZJ3<00_oZJ384onYX<@?ojVLb
0_oZIc@01ooZIc?ojFT`onE[:OoRKAooh6hHon1^6OoQKQT00ooQKA/02_oPKAgoh6dLon1]7?oPKA[o
h6dLonEd:ooXMRcoigH/onMf;_oVMRd2onIe:`06onId:_oVMB_oiGD[onEe:ooTMB[oi7@Z0ooTMB/0
1OoTM2_oi7D`on=e=?oVLAKoi6l20?ooi6l0DooTK`000?ooi6l08OoTK`00C_oSSAKofJdSomJZ7ooI
ZR3okKP/ooNd<_of/c3om[HaooJf<_of]S?om[LcooJg<_of]c7om[PdooJf<_of]C7omkPbooVi<Ook
^S3on[TaooZg<Ooj^C7on[PaooZe;_oi]RoonKL`ooVe;ooi/boonK@^ooVb;Ooi/bgonK0[ooR]:_oh
[R[on:dYooN/:?ogYbOomjHWooNU9OofYBKomZDUooJR9?ofXBComZ0RooJP8OoeWb7omYlSooFP8_oe
XB7omJ0QooFP8_ofXbComZDTooFR8OodUASolH4;onib0_o_L@3okGT3onj43_o`TQWol9/Qoo2O9?o`
XRGokj8TonnT8Oo`XbCol:POonf/5ooZZACojJLBonVW5?o_/1GomJX:ooNU0OoeY@?omZH3ooFT0`?o
mJ@200ComZD1ooFU0OofX@3omZ@10_oeY0<0COoeY@ComJD3ooFV0ooeY`?omJT3ooJV1oofX0_omY`:
ooJP1oofY`;omZl1ooJ]0_ofZ@7omJL0ooBT0?oe[Q;ol:lWonja;ooNUDCob7=Golj7F_o@T4_obX95
olmYCooHFEKoeeI@omYHE_oQHEkohfIOonAYFOoTJEcohF5]omaLKooKFFWofeQWommSK?oSKFOoi6mP
on9[G_oRJegohfeLon=[GOoRJe[ohV]Hon9[F_oRK5SohV]Jon=YGOoRIEkohFMLonEaDooYOSoojH4a
on>1<?oDO3ko^g=?oja]FOn[KE_o[fmJokAaEoneLEKo]G5GokAaF_neLUOo]G9FokAaEoncLEOo/g9G
ok5`FOn`Ke[oZfmOojE]I_nUKFOoYfiUojY^I?naL5ko^75D00?o]g5F0_nfL5L2okIaE`04ok=`Fonb
LF3o/g1OokE_G0;o]6mN0_ncKf003?ncKUoo/feIokA]EondK5So/F]Jok5ZF_nbJE[o/VYLok9ZGOnc
JESo/VUJok9XF@?o/FIH02;o/6IHojaUHonTHgCoZ61RojaOF?nZGUcoZUmKojYMG?nWG5ooZeiKojiO
Eon_GeOo[EiHoj]LFOn/GESo[5aIojYKGon/GEcoZe];oj19G_nl@H7o_T25okPnQ?o2<hcobS:>olTg
ROo4>hCo`c^5ol<mPono@7oo[cb3ojlnP_nmA7_o_4=l0_ni@Gd04one@Goo^T=mokY4Nond@g[o^TIg
okM6N?njAWGo^dIfokM2NonmAWko_T]ookU<NOngBg7o]da_okQ;LOniC77o^Da`ok9;Kon/BVd00_n[
Bf/0FonaA7Ko_d=ool=@Loo0EFko`E9_ol=BK_o5E6_o`5A[olADK_o:EFcobUQYolQKJ?o7FfOobE]V
olEHI_o6EfOobEQWolIHH_o5G67oaUYSol=HI?o3F67oa5]Lol=KG_o1FV3oa5aNolAKG_noEf;o`EQT
olQKHOo<F6Coa5UQok9NConWICooZf/foj]/>?nZJc[oZVXjojUZ>onZJSco[6TiojUX>onTICooWF93
ohmOC_moFUWoNEINohIIE?nQHT3o[6@gojiT=On^ICGoZV<hojIR>onMGT3oU5Y6oj=Q??oAM1goiWP>
onQf8OoKI4OodEEPom5HG?oDFf3ofEaWomQLHOoDFUkodUYOolmHI_o>F6SoceYPom1LFooAG5_odUiG
om9MF?o=FfCoeEi9on=/3ooUK@_oif`DonM/5ooWK1Koj6/OonYY;_o[J3SojfLionYX=_oZJ3OojVLe
onYX=?oZJ3800ooZJ3<04?oZJ3;ojVPconYX=?oZJ3?ojVPdonYX<_oZJ3?ojVPdonYX<OoZJ3?ojVPd
onYX=OoZJ3CojVPconYW=?oZIcD3onYW=007onYX<ooZIc;ojVPbonYW<_oZIc?ojVPbonYX<@02onYX
<P?ojVPa0_oZIc43onYW<P08onYW<ooZJ3?oj6T^onA[9OoRKAgoh6hHon1^5ooPKQT2on5]70;oh6dM
1OoPKA`03OoOKA[ohg0TonQf;?oWMRcoigD/onMe:ooVMB_oigD/onIe;?oVMB_oiGD[onEe;?oUMB/0
0_oTMB/02?oTMBcoi7@[onAd:_oTM2[ohgD_onEd:OoVL0coi6l1oooTK`1BonA_0000oooTK`0QonA_
000>onEd1?oQVb7oe;8TonK2<?oh]bkom[HZooJh;_of]BkomK4/ooFb:_oe/b[omK</ooFb;?od/2X2
ooB`:@0@oo>^:Ooc[bWomK0YooNe:_oh/2Kon;0UooNa9oog[RGomjlTooN^8oog[B?omZdSooJ]8_of
[R7omZdRooJ]80;omZlO00ComZhNooJ^7oof/23om[8Q0_of/Ql2ooJd7`?om[HP00ComKXPooJi7ooe
_27omKXQ0_of_B008oof_b7oml@RooO99Oogc2KomlLTooJl7?od[Q;okj<:onjJ0Oo^V@3ol:@6oo6_
3oo^/aSoj;8RonJb9OoX/B;ojZdNonb]7oo[[b?ojjhLon^X4ooYYQ3ol;<@ooBo0ooe_P3oml00ooNo
0?of_@7om[/3ooJg0oof^@;om[X2ooJg0oof]@;om[H300;om[D3027om[42ooJ_0Ooe[`;omJh1ooF_
0Oof[P?omZH7ooJN2oogX@comj/9ooNc1_og^PKon;l9ooRk2?oi_0Goml4BooC9:Oocac7oeYI0omJF
?ooFVSkobi8jolVC=_o?Ldcofe]GomQFD_oIF5KogeiLon=UGooTJEWoi6QJon1RJ_oKFG000_oIEVL0
3_oNGVOohV]WonA^I?oRJUgohf]Hon=[FooRJekohVaKon9/F?oSJeSohVaIon=/G?oUK5[ohfYK0_oP
Ied07?oTL5GojGe6onZ2=ooSPSGoeG`ookedCon[KEcoZFiNojm`F_nbLESo/g5IokEbFOnfLUOo]G9H
okEbEoneLUSo]G9GokEaEondLESo/G1Joj]_HOnVKVGoYFiWojI^J?n/Kf;o/W5KokEaFOnhLED2okMa
E`;o]W5H00[o]W5GokIcG?neM63o/g5Ook=aHOndL5oo]6mOokE^FoneKego]6eI0ondK5L06?nbJe[o
/6YMok5YG?nbJE_o/FQIok5YF_nbJ5Wo/FIHok5VEonaIUSo/VMFojeVH_nUHVooZ61QojYOFonYGUco
ZUiKojQMG?nWFeooZEaMojaNFOn^GeSo[UiGojeME`;oZeaI01Oo[EiJojULGOnUAf_o]CYlol8oQOnk
>hGo_c6=olHbS_o9=X[oac^6olDmQ?o3>hCo`d21ol52O_nc?H7o[3b4ok]3O?nnA7co^d9moke4N_nh
@H3o]T60okU3N`02okM4N00UokI5N?nkAgKo_4IhokY6MonfAG_o^TMnok]8O?ngBG?o^4]`okM=L?ng
C73o]T]_ok5:L?n]BVko[D]/ojQ:K?n`Ag;o`4Amokm;N?ngD7;o`U9^oleGJoo>F6[oa5E[ol1CK?o9
EVcobEMZol]HJOo8FVOob5]VolQJJOo4EV[oaEMTolAJG_o4FeooaEYRolEJH@02olEJGP11ol9HHOo0
FV3oa5aMol5HH?noEV?oa5]PolAKGoo1FF3o`UaKolIMF?nmG5;oZf95ojYY>_n[JcSoZF/jojYZ>onZ
J3_oXfDooiERBOn<GU3oQE]FohAMEon<G53oWf10ojaT=on^I3Go[F@foj]T=onXHc[oXF4noiEJAOnE
FTKo_Vh[ommg4ooYMaKoh6Peom=IH?o@Ef7ode]KomMLHOoHG6OoeeePomELGOoAFF7oceQTolaGJ?o>
FF?od5]Kom5MF_oBGUOodeiFom1KI?oBFF_oiVHionM/5OoWJaCoif`FonQ[7?oYJR[ojVLhon]W>OoZ
J3GojVPfonYW=_oZJ3@00ooZJ3803ooZIc?ojVPbonYX<ooZJ3?ojVPdonYX=OoZJ3;ojVPconYW<ooZ
J3?ojVPdonYX<_oZIcCojVPconYX<P02onYW=003onYW<_oZIc?ojVLb00?ojVLc00?ojVPaonYW<_oZ
Ic<00ooZIc<00ooZIc;ojVLaonYW<P03onYW<@0<onYW=?oZIc;ojVLbonUX<?oWJR_ohf`Ron5^6ooP
KQOoh6hIon1]7?oQKAgoh6dL0ooPKAd2on1]6`0?on1]7?oPKA_oh6dLon1]7?oOK1SohFhMonMe:ooX
MRgoiWH/onMe;OoVMRcoiWD]onIf;?oVMBcoiGD[00;oiG@Z00?oi7D[onAd:_oTMB`00_oTM2/01_oT
MB_ohg@`onAd:_oWLA?oiW08onA_0Oooi6l0DOoTK`000?ooi6l08_oTK`00<OoTMPOogXTHon>^<?od
`2Wom;TDoo>k4_oa_A;ok[hFonnk5_o^]QOokK<Ionj`5oo_/1[okK0Lonb^7Oo[[AgojZ/Mon^Z7_o]
/R7ol[/PooJm7Oof_aoom[lPooFm7_of`Qoom/8NooK27oof`Aoom/<NooK88?ofaR3om/<OooK37_of
aQkom/TOooK67oof`akom/@OooK77oofbB3om/PPooK68?ofab3om/XQooG:8Ooeb23omL/TooC:9?od
bB800_ofbR<0I_ofbb?om</TooK:9?ofcBOomm0[ooOD;_oge2oomLXRoo2b2?o/X`3okJ<0on^T0Oo[
Y@OojZ`JonJ^9ooU/1goj:lDonZ_6oo_/B?olJhQoo2U6Oo_WA?ol9P=oo6J2OocY0OomJh4ooJb0Oof
/P3omJd0ooB[0OoeZ`7omJX1ooFY0OoeZ@3omJX1ooJZ0OofZ@7omZP1ooJ/0oof[PGomk45ooRh1ooh
_`_onK/>ooVd5?oj/1Won[@JooZj5OojaA;on/T?oo[93OojaPWon/XBooSF:?oY]C[oeiM4olnB?oo<
T3goc9<nolZI=OoANdcofE]IomQEDOoHEeCogE]Mon=TG_oTJE[oi6QKon9SJ?oKFFkoee=/omUDIooM
GFCohVYVon=]IooSK67ohV]Gon9ZFOoRJe_ohVaHon9[E_oRJeGohV]Gon=[FOoUJeSoi6]Hon5YFOoO
IUcogfEMon=/F?oXNDSojX4ionF2=?oFO3go_G=@oja_Fon[Keco[g1Kok1aGOnbLU_o]79JokEaF@?o
]G9I0_ndLUT06?neLUSo]75Iok1bG_nXL6OoY6m[ojA_J_nWKfSo[g1PokEaF_ngLUSo]g9IokEbF_ne
LE_o]W9KokEcGondLUko/g1Mok=_G?ncKeko]6iKok=^G_neKU[o]FeGokA/F0;o/faH09Oo/F]Lok1Z
GOnaJE_o/VQHok1XF_naJ5[o/6IHok1VEonaIUOo/VIGojeVI?nYI6[oZf5LojQOGOnYGU_oZUiJojQM
GOnXG5koZEeLojYMFon/GE[o[UiGojeMF?n[FeWo[UiEoj]LFonUBG[o^cF>ol8gQOo1?8?o`cB9okh`
Soo3=hWob3^5ol<lQOo5>XKoaCf4ol92Ooo1@Woo]Cj0oj/lPonk@goo_D=lok]3O?nnAGco`4AnokU1
Oone@Gko]DAiokE4MoniAGWo_4Mjoka6N?nmAWSo^dEiokM6OOneAW_o^DMbokQ8L?nhCG7o^4e_okA;
L?n`BVoo[TY]oja9K?nTB6co/DQ`oke3O?ng@Gko^e1bolUFK?o>F6_oc5M[ol]GJoo3EF_ob5QYolEH
JOo:Ef[obUQXolQJI_o4FVOo`EMWol=GGoo3G5coaEYPolEJGoo5FeooaE]NolAIH?o0Ef7oa5YNol9I
H?nlEV7o`EYNol=LG?o1FUco`EaHol5ME_o2GESoaeYMolMJG?neGT_oYfHmojMZ>_nRIcooTf1;ohMN
E?n6GEGoS5mAoiMPB?nQH3oo[F<fok5U<_n]I3KoZV<hojQS>OnVHccoVUi3oi1IBOnWHSWoeGHJonMg
3ooWKbKofEmFolmFIOoAF5ooeE]KomMLH_oGFfOoeUaOomELGOoAFF?od5URolaGJ?o>FF;od5aIom5L
FooDGU[oeEiNomIKJ?oAFGWoh5eTonQZ8_oWK17oif`JonUZ9_oZJ3OojVLkonYW=ooZJ3KojVPd00;o
jVPc0_oZJ3401OoZJ3?ojVPbonYX<_oZJ3?ojVPf00;ojVLe0_oZJ3<01?oZJ3CojVPbonYW<ooZIc@2
onYW<`04onYW=OoZIc?ojVLbonYW<`CojVLb0_oZIc401_oZJ37ojVLaonYX<OoZJ37ojVLbonYW<@?o
jVP`0_oZIc<2onYW=00:onQY<?oUJbOohVdMon5^6?oPKQWoh6hJon5]7?oPKAgoh6dNon1]7@;oh6dL
1OoPKA/3on1]70;oh6dI00[oi74VonQg;_oWMRgoigH]onMe:ooVMB_oiWD/onIf;?oVMBcoiGD[0ooT
MB/2onAd:`;oi7@Z00GohgD^onAd9ooWLA;oig4=onI`203oonA_057oi6l0003oonA_02Coi6l003co
i7P8onjF8_obTAoolilRoo:X8?oa/b7olKhSoo;39?oaaBOok/TYon_<:ooXbbcoj<P/on_8;Oo/aRgo
j/8]onW0;Oo]a2komLl]ooS@;OohcRgon<`/ooS::oohbRcomlPYooO79oohb2Woml@WooO29_og`bKo
ml8VooNo9_og_RComk`QooJk8Oof_B?om[/SooJj8_of^23om[TQooJg8?of^27om[HQooFd7ooe]R3o
m[DQooFd7ooe/aoomK<PooFd7oof]B7omK<PooFd7ooe]23om[@PooJe8_og]bSom[XToo2[2Oo[VP02
on^K0003onbM0_o^Ya7okZ`N00;okJXL05SokJ/Nonf/8_o]ZBGokj@VonnJ8_o^T1[okX`Conn>3Ooa
U`Wom:85ooB[0Ood[@3omJh0ooNb0Oog/@?omk<5ooRh2?oh^@[onKh;ooW13?oi_`conL<>oo[33ooj
a@oon/H>oo[73_ojb0oon/<BooZh5Ooj[aWon[8IooZk5?oj``oon/L=oo[82_ojb@oon<8Qom>CAOo:
SCoobi8ool^=?oo:SCoobYTeom=mCOoHFeKoeeE@omMFDooKFE[ohVAMonAYG?oTJE_ohfESomiKKOoH
DfcofEIWomeMH_oPJ6GohfeZon9]HooRJe[ohVYJon9[FooRK5WohV]Hon5[E_oQJUWohfYJonA[EooS
JeSohVYHon5YF?oPIe[ogfIKon9[E_oXMdWojWlgonJ0<OoDO3go_gI?oji`F?n/Ke[o[g1Jok1aFOnb
LEWo/g5HokAaF?ncLEWo]79H0onfLUL05OneLUOo]7=Jok1cG_n[LF;oYFmWojE_J?nYKfGo[VmPok9a
G?neL5Wo]G5JokIaF?nfL5Oo]G5IokAaG?neLE[o/g5Nok=`G?ncKeko/fiLokA/F002okE]E`07okA]
F?nbK5go/V]Kok5ZFon`J5[o/FQIok5WFP02ok1UF029ok5VE_nbIeSoZfIYojYSJ?n^HeOoZf1IojUN
FonXGEcoZ5aNojULGOnYGEcoZEiKojULFonZGE[o[EeHojmODOnZFU[oYdImokDgUonk<I;o`CB2olDf
Qoo7=8co`CF=oklgR?o6?HCoaC^5olHiQ_o5@87o`T:0ol=1P?ni?h3oYcV4ok@oP?nn@gco^T9loke5
N_o1AGko`49ookY1O_n]@7go/4=iokY4NonmAW_o_4EiokY5MonlAWKo_4Mjok=4O?nhAg?o^dU]okY8
LOnhBG3o[TYaojm:L_n_BW3oZTU^ojM:K?n_BFoo^d9lokPoP?o4D7?ocUUZoleHJoo<F6_ocEQZolMF
K?o:FF[oaeYZolQIJOo9Ef[oa5EZokaGIOo0FF7oa5UMol=LGoo5FekoaE]LolIKG_o5Feoo`eUPol9G
H?o2F5oo_5IMokaIFOo1G5So`E]Iol9KF_o2GESo`EiFol5LFOo3Fe[o`eaLokmHH?n[EEKoTeQ>ohQM
DOn:Ge;oUF59oiiR@OnTHScoZV<hojiT=On/HcOoZF@iojQT>_nWHc_oXV8noi=KA_nHG4;oaVlVon=h
4?oXMa[ohFQ2om5FHOo?EV;oeEaJomILGOoFFfKoee]UomILG?oFG5godEYSoliIHoo<F6?ocUURom5L
GOoCG63oeeiUomUMJ?oIFfoof5]bomAIMooUICooif`GonU[8ooZJ3@00_o[Ic/01_oZJ3KojVPeonYX
<ooZJ3CojVPbonYX<`;ojVPa00?ojVPconYW=?oZJ3D00_oZJ3@00ooZJ3?ojVLeonYW=@03onYW=0?o
jVLc0_oZIc401?oZIc?ojVLaonYX<?oZIc83onYW<@03onYX<?oZJ37ojVLb00KojVLa00kojVLbonYW
=?oZIcCojFP`onIZ;?oSK2GohVdNon5^6?oPKQSoh6hJon1]7_oPKAgoh6dNomm]7@?oh6dL1_oPKA/0
2?oOKAcoh6dKon1]6_oPKA_ogf`Gon5_7ooWMBgoj7H]0_oVMR`01ooVMRgoiWH/onIf;?oVMB_oiGD[
onAe:_oTM2/00_oTM2X02OoTM2_oi7@ZonAd:_oSMBgoi7@WonMa4OoWL@goig4?onI`1`3oonA_053o
i6l0003oonA_02Goi6l002;oiWH4onYo2Oo^Q1SolH@Uoo679_o`Rb?ol90Soo6D9?oaVRKol:DYoo6b
;?ob_2oomL@`ooC:<_o`cCCokm8donkB=_o^dCKol]LfooSO=ookhcGonn4foo[L=OojfSGon]Pdoo[G
=OojecCon]LcooWF=?oieCConMDboo[H<oojec?on]@a0_oidS02ooWC<@04ooW?;_ohbbgonLd^ooW<
;P;on</]01Oon<T/ooS7:oohab[on<TZooS5:?ohb2Son<HYooS39oog`RKoml4TooNm8oog_R?omkhX
ooJk7_o`Z`GokjP3oo2Z0_o^Y@;okZ@6oo2Z6Oo^[27ok:TMonfX7@02on^W7@0Aon^W7oo[ZB7ok:hV
onn]:oo`YbKolJDOoo>/7?of]QWon;dDooW23_oja@_on/P<oo[53?ojb0oon/L@oo[53ooja0h00_oj
a@h0@Ooja0gon/@>oo[33_oj``kon/D>ooW63ooja13on[dAooZc5Ooj[A[on[8KooZj5ooj`a7on/D;
ooW53_oCSc;o`h92olb@?_o<S3oobXPnolV8?oo9TSWocX1:omIMF?oIEE7odeEDomQGF?oQH5goi6QM
onAYG?oTIUoogea/omQCK_oIEVGog5eQon1UI?oSKFKoi71Uon=]G_oRJUWohV]Ion=[F_oRJeSohV]G
on9ZFOoTJeSoi6]GonAZF?oRJUOohF]Gon9[EooQJEWogfIKon9YF?oWMDgojGlmonJ0=OoGOT3o`7Q>
oja`FonXKeko[G1JojmaFOn`LEWo/W5H00;o]75H1?neLUL05onfLeWo]WAGokAcEonaLU_oZg5RojI^
I_nWKfOoZVmToji^GondKeSo]W1EokMbEoneLUco]W9JokAaG?ndL5co/g1Lok=`GOndKUSo/feHokA]
EoncKEWo/VaL00;o/f]I05co[fYLok1YFonaIe[o/6AGok1UEonaIEKo/6MJojUUJonZHfKo[f=FojeQ
F?n/GeSoZ5eMojILGonXG5goZUeLojYNFonXG5coZ5]KojeNE?nYEe_oY3j4okDgVOnj<i_o_2n?ol4c
Q?o5=HWob3J<olHhR_nn>8Ko`CZ5olPjQoo6>hKo`D60ol91P?o3@H3o_D1oojDhPonW>hCo`4Amok]2
OOnlA7[o_TEnokm3O_no@Wgo/3mook11OOnhAG[o^TAlok]5NOnjAGOo^TAgok]4N_nfAGgo]TIfoka9
K_nkB77o/dAdoja3MOn`B77o[TY_oje;KOnXBV_oZDQ^oke6N_o0@g_obU1coleIJoo;Ef_oc5Q[oliH
J_o:Ef_ob5Q[olYKJ?o5Efcoa5E/olAHIoo2Ef;o`UUOolAIHOo2G6?o`eaOolAKG_o5FUoo`eQSokmF
H_nnEV3o^EMMokUHF?o0G5So`E]Jol5KF`;o`EaJ00ko`UeJol=LFonmFUgoZU9Ooj1?HOnNC6CoVTUT
oiADF?nOHT3oYf@gojMS>On[I3Oo[6@goj]T=`;oZF@j02CoYV8loi]N@OnDFDGo[6DgomQf5ooXN1Co
hfX[omYLFOoAF6;odUUNomELFOoGG67oee]WomIKHooFG5goeUaNom5JHOo>FF;ocEQUoliII_oBFfGo
eUaZom]MK?oKGFkofE]_omMKK_oHG73og5eWonQX;_oZJBoojVLkon]W>Oo[IcSojVLfonYX=?oZJ382
onYX<`04onYX<_oZJ37ojVPaonYX=0;ojfLe0_o[IcH02?o[IcGojfLdonYW<ooZIcCojVLconYW<_oZ
Ic7ojVL`0ooYIc001OoZJ33ojVLaonYW<?oZJ33ojVLb00CojVLa01;ojVLbonYW<OoZIc;ojVLaonYW
<?oZIc7ojVLbonYW=OoYIc?oifT_onA/9_oRKAgohFhJon5^6OoPKQ[oh6dMon1]7ooPKAd2on1]70;o
h6dK00?oh6dLon1]6ooPKA/00_oPKA`2on1]6`?ogfdL00?ogfdJomm]6ooPKAX00_oOKAX02?oTLRSo
j7H/onMf;?oVMRcoiWD[onIe;?oVMB_oiWD/0_oUMB/02_oTMB_oi7@ZonAd:_oTM2_oi7D[onAd:_oS
MBgoi7<UonM`4?oWL0`2onMa3P03onE`1_oTK`3oi6l00?ooi6l0COoTK`000?ooi6l09_oTK`007_oT
L03oigP3onZ22Oo^QQOol8<Too218oo_PAkokh@Monn57Oo_QQkokhPOoo2:8?o_S23ol9DSoo2P9_oa
ZBSol:dYoo6g:oodaC3on=@aoo[M<Ookh3;on^0coo[O<oojhC?onMlcoo[L<_ojfSCon]/coo[J=0;o
n]Db00Gon]Dcoo[G<oojfC?on]Tcoo[H<`02oo[G<P08oo[I=?ojfC?on]Tdoo[H=?ojfCKon]Tdoo[K
=?ojfSD2oo[I=0;on]/e027on]Tdoo[G=?ojf3Gon]Teoo[H=?ojecComm0UooC97?oebAcomLTIooG6
6_oeaRColLHZonfo9?o^^RCokK4RonbW7OoZXQ[okkDMooG67?occRcol=4ioo;B?_ofcSkomLDgooFn
;oog_BOomklMooS04ooja0kon/L:oo[62ooja0`00_oja0h00ooia0konL<>oo[53P02oo[43P0^oo[3
3_oj`PgonL<>oo[64?oj`a7on[dCooZc6_oj[akon[<LooZl5ooh``_oiZ@Bok]^@?o6QT3obh/oolb<
?_o:RCkob8I0olV>>_o=Q4GoeUiGomYFE?oFEEKof5EIommMG?oSIUkoi6ULon=WGOoOGF_of5=aomUG
I?oLGeooh6IQon=]H_oTL6CohfeSon9ZFooRJeSohf]Jon9/FOoRK5SohfYIonA[EooUJeOoi6YHon9Z
F0?ohF]G00_ohFUIommUG?oPIe_oiW=@onYm@?oVP3WofWlnol9hCon]LEWoZFeKoji_F@02ok9aEP0X
ok=bEoncLESo]79HokAaF?neLUOo]G9IokEdG?nfLeWo]G9GokAbF?naLU_o[G1OojU_HonVKFKoYfeU
oja]H?nbL5_o]G9MokIaFonfLEWo]71Mok=`G?nbL5oo/fiIokA^EoncKESo/VeKok9/F_ncJeSo]6aH
ok9/FOnaJU[o[fMLojmUFOnaI5Oo/FEGok1VFonZIFWoZF9UojaQF@;o[F1G00?oZemHojQMGOnWG5d0
0_nYGE`04OnZGE[oZUeGoj9BIOnZ>XSo^SBJok<gUonj<9So_2n?ol4dQ_o8=XcobCZ9olLjQ_nn>8So
`3N8ol@iQoo3?h7o`D6000;o`d6102ko`D20oj/kP_nQ>8Go_T=ooke3O?nmAG_o_DAnol14O_no@Woo
^D60ok=1O_ngA7_o]dAiokY4NOnkAGSo^dAhok]3N_njAWco]TMjoka7M?niAG?o[D9doja1M?nb@g?o
/dQaoji:K?nQB6_oXdM]ol58M?o;AgOobD]fol]GK?o;EfWoc5QZoliHJ_o<Ef_oaEI[olIGJoo8EVgo
aeQWolIMFoo5G5goa5QPolEHH?o4FF?oaEYS0_o6FV405_o2EfKo_5IOok]IFOnjFEWo_E]EokmLF?o1
FEco`5]Jol5MF?o2G5_o_e]MokAGGonRDEkoVdeOoiY=G_nMCUko]E9Sol=FG?n`GdSoZFDjoj]U=on/
ICP2oj]T>00`ojUS>OnRH3goU5U3oiiM?Oo6L2GoiGTConMa7ooLHDgodEESom=IHOoDFecoeEaJomIK
H_oGFfSoeU]OomILFooDG5codUYOoliIH_o=F6WodUU`omIJL?oIFfoofee^omYMKOoIG6cof5a^omML
K_oHFgOoi65MonYY=_oZJ3[ojfLionYX=_oZJ3CojVPconYX=?oZJ3?ojVTconYY<OoZJ3?ojfPhonaV
??o/IS_ojfHion]V=oo[ISGojVHc0_oZIc802ooYIc3ojFLaonUW<?oYJ33ojFL`onUX;ooYIboojFL`
onUW<OoYIc3ojVLb00;ojVLa00CojVLbonYW<ooZIc7ojVLa0_oZIc803?oZIc7ojVLbonYW<OoZIc;o
jFPaonMZ;OoTK2SohVdRon5]7?oPKQ[oh6hIon1]70;oh6dN0_oPKA`5on1]6`03on1]7?oOKAcogfdL
00?ogfdL00CogfdKomm]7?oOKA_ogfdL1?oOKA/01_oNK1SohVlRonQe:ooWMBcoigH/onIf;0CoiWD[
0_oUMB/2onAe:`0;onAd:ooTM2coi7D/on=e;ooTLbKoig0@onMa3?oWL0koig4>onM`3OoUK`D0oooT
K`1>onA_0000oooTK`0YonA_0007onIg0_oZP`[okXPHoo258_o`Q2?okh@Nonn57@02onn27@0Aonn1
7Oo_PQgokX8Monj37?o^PQgokh@Monn:7oo`TR;oli/UooJT9ooh/ROonKhZooW9;OoidRoon]Pboo[M
<oojh3@00_ojhSD2oo[P=005oo[O=OojgC?on]Xcoo[K<oojec400_ojeC82oo[G<P0;oo[F<?ojec;o
n]H`oo[E<OojeC;on]Pcoo[F<_oieS7on]Dboo[F<_ojeS<00_ojf3@08ooieS?on]Leoo[H=OofdBOo
mLhQooK?8OofcAoom/hWoo?C<Oo]dbgok]0]oo;<<?o``2cokkPXooK08Ooh]0_omK4;ooBj4ooe`aoo
m<X/oo;>=_occS_om<ThooC3<Ooe_b[omk`SooRo6Ooia1;on/@>oo[33?oj``gon/<>ooW33_oia@ko
n/L>00;on/@>02[on/<<oo[33Ooja@oon/DAoo[54?oj`Q;on[PFooZ`6ooj/1oomk0CooB^3?oANRco
^FM1olB1?Oo:S3kobh/oolR6?oo9R43obiHiolb5@OoGGeKofeIComMEEOoIEUKogEYJon=TG_oTJEco
hfMNommNJ_oIDg7ofEMTomaMH?oPI5kohfaLonA`IOoSKVOohV]Mon9[F?oRJe[ohVaIon9[F_oTJUT2
onE[E`1:onA[F?oRJUWohFYHon5[F?oQK5OohF]Gon5ZF?oPIe[ohFQIonIaDOoZNdGoiX4komb1?Oo6
NTSo/GAGojU_GOn]L5_o/G5Hok9aEonaLESo/W5Hok9aFOndLESo]79LokEcG?neLUSo]G9IokAbF?ne
LUGo]79Fok5aF_nZKf7oYVeUojA/J?nYKfOo[g5Sok=aGOneLEco]W5JokAbG_ncKe_o/fiHokA^F?nc
Ke[o/FeKok9/FOncK5Wo/FYJok9[FOn`JE_o[VIJojmUFOnaIEOo[fILoj]UJ?nZHV;oZemJoj]OF?n/
H5So[V1FojaOFOnXGEcoYeaMojUNFon[GeOoXDmZoj@dSonf;ico]3NEokLbV?nj<IGo^C6>ol@cROo9
>HP2olHjQ`04ol4gROo5=X_o`c^5okm0P@Co`d6106So/3b3oj0fQ_ni@X3o_D=noka4NonnAGgo_dEn
oki1P?nn@8Co^49mokQ3Nong@g[o]T9kok]4N_nk@gWo^dAiokY7N_niB7Wo]dIgok=3L_n^@g;o[d=b
okE4LOndA7;o/DI`oj=5K_nQB6[oa4e`om19N?o6AgWobeA_ol]HJ_o;FFWobEMZoleHJ_o5EFco`eI]
olMGIoo6G5koaUaLol=LGoo5FF3obEIPolIGH?o6F63oaeMTol5EIonoF63o_U]EokQHFOnjFUKo_EeC
okiLFOo0G5Woa5eIol=KG?nhEf3oZ55Qoj9>GonWCeoo/U9OokIDG_nlEUkoaEYIolQIF_o5GEco[VQ5
ojiV=On/I3OoZF@iojIR>_nLFcooTEM4ok9Y<?oKN1OoigHIonAZ>_oBEU_od5ASomAKGooDG5_oe5]K
omIKI?oGFfOoeEaLomELFOoEG5codUYPom1II_o@EW?oeEQfomQJLooHFg3ofee/om]MJooJGF[of5e[
omQKL?oFFGoofEUoonUUB_oZJC7ojVPdonYY=@;ojVTc00_ojVPdonYY=OoZJ3OojfPion]W?Oo/IT3o
k6Dnon]V>OoZISCojVHbonYW<@06onUW<007onUX<?oYJ2oojFLaonUX<?oYJ2oojFP`onUX;`02onUW
<00AonUX;ooZJ37ojVLbonYW<ooZIc;ojVLaonYW<_oZIS;ojVHaonUX;ooVJR_ohf/Von9]7ooPKAWo
h6hGon1]5ooPKAT00_oPKAX2on1]6`03on1]6OoPKA[oh6dJ00;oh6dK00CogfdMon1]6ooOKAgogfdL
1OoOKA/3omm]6P03omm]6ooOKA[ogfdJ00;ogfdJ00CogfdIon1]6_oVLb[oj7H/0_oWMB`03ooVMRco
iWH^onIe;OoVMBcoiGD]onEe;?oTMBcoi7D[on=e;?oSMB_ohgD/on=e;_oULaooig4=onM`3@02onM`
3P03onMa3_oWL0goiFl30?ooi6l0COoTK`000?ooi6l0:_oTK`002?oTL03oigP4onZ32_o^QaOol8DS
oo248oo`QAookhDM0_o_QQh2onn47P;okh<N01?okh<Monj27?o^PAcokh0Moo:17OoeQAgomhdNooJD
8?ofV27omj0SooNZ9_oh]2SonL8[ooW;;OoidboonMXaoo[Q<ooji3Gon^De00;onnHe00Gonn@eoo[O
=?ojg3?on]Xcoo[H<`02oo[G<P06oo[G<Oojec;on]Paoo[H<_ojf37onMHa0_ojeS809?oieS7onMDa
ooWF<oojecGon=<[ooG;7_ofbaoom/dPooK;8OofcBgokll`onK@:OoYdBcol]4booG=<oohcc3on/TQ
ooS16Oog]a;om[8<ooJc3Ooe^1;omL0Moo?8:_obccGom<liooC9=oof`boom[lWooNm8?oh_QOonL8>
oo[32ooja@gon/D>oo[43P?on/<>02_on/D?oo[63ooja@kon/H>oo[74?ojaA3on[lBooVc4_ofYa7o
mJXConfE6oo9HCKo`FXholAj??o9RcoobX/oolN5?oo9RSoocYTjolZ:??oFHESofUIAomQFE?oFEeCo
g5UHon9RG_oTJ5oohfQMon1OJooJDG?ofUMUomaNGOoNHUkohF]Lon=_HOoTKVKohfePon9[FOoSJe_o
hVaLon=[G?oTJUWoi6]G00;oiF]G00?ohVYIon5[FOoRK5L00_oQJeL03_oRJeSohFYJon1XF_oPIU_o
i6iIonUlC?oVPD3ofWloolEkB_naLeSoYfiNoja_Fon`L5So/W5G0_naLEL08onbLEOo/W=MokAdG?nf
LUOo]G9GokAbF?neLUOo]G=FokEbE_nbLUWo[FmNojI^J?nUKfkoZ6mXoji`HonaKeoo]75MokE_F_nd
KUSo/fmJok=^F_nbKE_o/VeJok=]F?naJe[o/FYKok5XFOnaIeOo[fIHojiVFon/I67o[6AWoj]RGon]
H5Oo[5mH00;oZemI00koZeiJoj]NFOn[H5OoZEmIoim=KonX<i7o]C6JojhcUOn_<9[o]C2GokPbT_o1
<9Cob3J8olLlQ@;oaSZ700GoaCN:ol<hR?o4@H7o`422ol50P@02ol=1P@1folA1P?nd?H?oWSJ6okHo
POnm@ggo_4Akoke4NonnA83o_d63okloQ?nl@Wgo^T=kokQ3O?nf@Gco]d5jokY3NOniA7So]dMeoke;
M_n_AGOo/TEbojm4LOna@g;o]TA`ok=3L_na@W;oZT9^oje8J?o7C77odDYholU5NOo9CW?ob5M[olMF
Joo9EfcocUQ]olYGKOo1E6WoaEUPolILGOo7FUgoaUUNolIHHOo:EV7oaUESolEFH_o2EV;o^eMMokeL
E_nlGEWo^5YKokYLEonnGUWo`EiLol=NF_nkEeooZE9Qoj=@HOn[D67o^5ANol5HFOo2FUSo`UUIolAK
FOo6G5OoaEYIol9OFOn`JDSoZF@kojYR=_nSGS_oTeQ3oi]M?_o9LR7oi7PFonI^9_oIG57od5ENomAH
HOoEG5goe5eJomEKG?oHFfKoeU]UomALF_oEGEKoeUaMomEKI?oFFf_odeMfomEHN?oHFW?of5]`omUM
JooKGF_ofeiYomULKOoGFgKoeUV1om5ESooSGfWojVPgonYY<_oZJCCojVTeonYY=_o[J3SojfPion]W
>_o[IS[ojfHion]V=oo[ISKojFLaonUX;_oYIc3ojVLaonUW;`GojFP_00GojFL`onUW<OoYIc3ojFL`
onUW<P02onUX;`03onUX<?oYIc7ojFLa00;ojVL`00kojVLaonYV<OoZIS?ojVLaonUW<?oWJRcoiF`W
on9]8OoQKQkoh6hLon1^6ooQKQgohFhOon5^80;ohFhO00CohFhPon5^7ooPKAkoh6dM0_oOKA`01OoO
KA_ogfdJomm]6_oOK1WogfdI00OogfdJ00CogfdKomm]7OoOKAgogfdJ1?oOKA/01_oNK1SohFlTonQf
;_oWMRgoigD/onIe;@;oiWH]00?oiWD]onEe;?oUMBX00ooTMB/01OoSM2[ohgD]on=d;?oVLAGoig4<
00Coig0>00?oig4?onI`2_oTK`40oooTK`1<onA_0000oooTK`0/onA_0007onA`0?oVN0;ojh<:onj6
6?o`QR7ol8DQonn47`02onn57@06onn67_o`QQookhHNonn67oo_QQkokhDN0_o^QAh07_oaQQoom8HN
ooJ67OofQAkomH8MooF47OoeRAkomX/OooJ=7oofTR3omi`SooNU9Oog[RKon;PYooW2:ooicRkon]Tb
oo[N<oojhC?on^@eoo[W=ooiiCKon^8eoo[P=?ojgCCon]dcoo[J<oojg3?on]`boo[J<P;on]Pa04co
n]TaooWH<Oojf37on]TaooKB8oobc1oom<dPooG=7oofcRSol/laonW@:OoTcBKoj=0[onk=;_ofdS;o
n]P]oo[E:_ojdRWonL`RooW56oog^Q?omkD?ooJe3_of^aCom<4Poo?9:ooecc?om</dooC5<_od`Bko
m[hVooRo7Ooi`QKon/@?oo[63?oja@con/D=oo[64?ojaA3on/D?oo[53_oja@oon/L?oo[63oojaa3o
ml08ooJe1oof[`comZTAomi`;?o?GSOobfDcolQc>?o:RCcobX`oolR:@?o:RckocIPkol^>?ooEHeSo
fEI?omUGE?oFFE?of5QGon1PFooTJ5goi6QOon5OJOoKDg3ofEMTomaMGOoOHUgohVUJon9/H?oSKfGo
hfeP0_oSK5h08?oRK5gohf]LonA[EooTJeOoiFaGonA[F?oRJUWohF]Hon5[EooQJeSohV]Hon5[EooR
K5SohF]Gon1XF_oPJ5gohfmIonMiCOoUOScofW`lolMjB?naLeKoYfiMoja_FonaL5So/W1Gok1`Eon`
LE[o/G=Kok9bF?ncLUWo]79G0_ndLUP03oncLUWo]79GokIcEOncLe[o[W=UojY`I_nVKVWoYfeXojY^
I_n`Keoo]6mIokI_EondKeSo/ViKok9]FP02ok9]F@0Kok5/G?n`JU[o/6MGok1WEon^IecoZF=QojYR
Hon/H5co[f1EojiPEon]H5Oo[5mIoj]NF_n_HECo[f9Boj1=LOnT<9Go/BnKojldU?na<YKo/S6Eoj/`
Tong;IWo`S>Bol@iPoo7>hKoaSZ600;ob3V801Ko`3f4ol51POo4@H;o`422ol50P?o3@H7oa461okXn
P_nQ=hGo/Sb4ol14O_nmAG_o_T>0okm2QOo0@HGo_Sn3ok]2O?nmAGWo^D=kokU2Nonf@GWo]D=h0_ni
AWH04?nhBGKo[TIkoje4Lon_A73o/TE`ok=5LOncA7?o/4A_ojm5J_ndB6OoaDIbom58N_o6AWOoaDQg
olUEK_o;EVh2oliFL013ol]GJOo7EFOobEQRolYIH?o:FEkoaeQPolEHH?o7EV?oaEMSolAIG_nmEeco
_5]GokeNE_niGEco^EmHokiOE_noGE_o^EUMoj]BG_nRCV7o[59OokUGFonoF5Wo`eYFol5KEOo1FeCo
`U]Fol9KF_o4Fe[oaUYLokiPE?nbJDOo[FI2oieK??nCF4?o/FLaom]f6?oVM1_oh6=3omAFG_o@EUoo
eUYNomELGOoEGUWoeE]QomIKIooGGEooeUiGomMMF_oIFfGoeeQ`omEGMOoDEgSoe5UfomQLL?oHFg3o
fUe[om]NJooKGVWof5a^omAIO_oEF8CoeER;omQJP_oZITSojVTcon]X=`02on]X>@06on]W>?o/ISco
jfHjon]V=ooZIcCojVLb0_oYJ3401OoYJ33ojFP_onUX;ooYJ33ojFP_00;ojFL`00?ojFL_onUW<?oY
Ic001OoYJ2l2onUW<0;ojFL_00oojFHaonYW<?oZIc7ojVTbonY[<_oYKc?oj70aonMb;?oWLc3oig@`
onMe<?oWMC;oigDconMe<OoWM3800_oWMC803_oWMS;oigDbonMe<ooWMC;oiWD`onEd;ooULbgoiG</
on=a:?oQKb;oh6hPon1]7_oOKAcogfdJ0_oNK1T02?oNK1[ogV`Iomi]6ooNK1cogVdLomi]7OoOKA_o
gVdK1?oNKAX01_oNK1WogfdJonEc:ooXMbgoiWD[onIf;0;oiWH]00CoiWH/onEf;?oUMBcoi7D]0_oT
M2`01OoSMB_ohg@`onEb8OoWL@koig4<00?oig0>0_oWL@h00ooWL@ooiW08onA_003oonA_04_oi6l0
003oonA_02koi6l000Coi700onIg1?o[P@cokXLH0_o`QB800oo_Q1kokh@Monn57@03onn57P;ol8HN
00[okhDOonj57_o_QQkolhTOooJ:7_ofRQgomXTNooJ97oofR1komHPN0_oeQ1h0H_oeQQkomXPNooJ7
7_ofRaoomY<PooNJ8_ogXBCon:hXooRi:_oi`bconL`_ooWD<OojfS;on]hdooWS=Ooii3Kon^<foo[Q
=_ojh3Gon]/coo[I<oojg3?on]`doo[K<oojgCConMX]oo??8?occQoom=0NooGA8_oddBoojm4/onC?
9OoScbGohlhVoncB9ooif2Gon]8Woo[C:_ojeBcon]T/oo[G:oojdbKonLPOooRn5oog]a?om[HBooJg
5_od_akollPZooG=<_oebc?omLD`ooJo:Oog^b3on;hHooW04?oj``_on/D;oo[53?oja@oon/<?oo[3
4?oja@oon/LAooW62oof`@Gom[l5ooJm1Oof_0SokI4HomIE>OoEICCodV8aolma=Oo:QCooahU1olV9
?oo:R43obi<kolZ:@?oDHEWofUI@omUGEOoGF5Cof5MFon1NFooTIU_ohfULon5QJ?oKDg?of55YomYI
G?oNH5_ohFMKon9/G?oSKV7ohfeR0ooSK5h00ooTJecoiF]HonA[E`02onA[E`03on=ZFOoQJUSohF]G
00CohF]G05kohF]Fon5[EooQJU_ohFUMon=/F?oUMTcoiWi0om]n?Oo9O4Oo]7ECoja`F_n^L5_o/W1H
okAaEonbLe[o/7=Jok1bF_naLEWo/g9GokAaEoneLUOo/g9IokAbF?neLeOo]WAIokEdF_naLUkoZVmT
ojM^J?nVKFWoYfaVoje/G_n`Keco/fiJokE]E_nbK5So/VeIok9]FonaJUSo/6UGok5YEon^IUcoZfAM
ojURH_nYGego[5mHojiPEon]H5Oo[EmHojiQEon]H5GoYDibojldU_nd<I[oZS6Goj``Uonc;iOo[RjF
oj`ZVonb;I[o^CF?ol8hQoo6>XKoaSV8olPhROo6?8Go_Cn2ol0oP_o4@H3o`D22okm0P?o3@H7oa422
okdoPonV=hOo[3V5ol13Ooo0AGoo_D>0oki2Oonn@X3o_T1ooke2O?nlAGSo_TAkokQ1N_njA7So]D=h
okM4MonfA7Ko[TAgoja5Non/@WKo/dAb0_naA780C_naAFoo]DM[okI9IoncBFGo`DE_omdnQ_o>A7go
bDAmoliBM?o?EVkoc5AaoleGJ?o:F6?ob5MWolUHHoo8FekoaeYNolAIH_o7F6GoaeISol=HG_nnFeSo
_5UIokmJEOnoF5So_E]GokiNEOncFUWoZ5=QojA?HonZD5oo]eMHol5KE?o1FUOo`UYGol5KEOo0FeCo
`UaEol5JFoo1FUcoa5UKolEJFOnoHe7o[VM8oi]NCOnJGD3ob70RonEd6?oWK2oodEIFom9EGOoEF63o
eUYNomELG?oFGU[oeUaRomMLHooFGE_oeE]NomQHJOoKE7CoeDb1olm6ROo9@X_obdJ6om=AN_oHFW7o
fEiZom]NJ?oJGV[oee]bomAHPOoEF8KofUZ0omUJR_oSGfSojVPdonYX<`;ojfLf00?ojVLdonYW<oo[
Ic@00_oZIc<01_oZJ3;ojVPconYX<_oYJ3?ojFPbonUX<@;ojFPb00GojFPaonUX<_oYIc;ojFLaonUX
<003onUX;`0GonUX;_oYIboojFH_onUV;ooYIboojFL`onUY;ooYK3;ojG0eonUc=?oYMCCojGPfonUi
=_oYN3GojGPgonYh>?oYNCSojWPhonUh>OoYMcGoj7LeonQg=_oYN3H00_oYN3L00ooYMcGoj7PeonUh
=P02onUi=@0?onUh=_oZN3OojGPeonUg=_oWMSCoiW@aonEc;_oTLBcohVlWon1^8_oOKAoogfdMomi]
7?oNK1[ogV`H00?ogV`I1?oNK1/01OoNK1[ogV`Hon1_8_oWMRgoiWH/00;oiWH]00coiWD]onIf;OoV
MBgoiWD]onAe;?oTM2_oi7@Zon=e;OoTLbGoig4AonMa3?oWL@h2onM`3PGoig4>00?oiG06onA_0?oT
K`00oooTK`19onA_0000oooTK`0`onA_0007onA`0?oVMPCojX<:onj76?o`QB7ol8@Qonn57P02onn4
70;okhDM013okhDNonn67_o`QaookhLNonn67_oaR23om8XOooJ:7OofRAkomHTNooF:7_ofRQoomXTN
ooF97_ofR1komHLN0_oeQQh09?ofQAgomX@MooJ37_ofQakomX/OooJB8?ofUb;omj0TooN[9ooh]2Wo
nL4/ooW:;ooid37on]Pcoo[N<oojhSCon^8foo[O=_ojgSGon]hfoo[L=_ofdbOoll`QooC?8ooed2;o
m]0]onkA<_oUdR_ohm0Yon7@:_oTdbOom=hPoo[L8?ojeBOon]<Zoo[D:@;on]HZ0_oje2/0<oojdBWo
nLXTooS26oog_AKomkTBooJh5_oe_B3omLHYooK;<OodbcGomLLbooO1:?oh_aconK`BooZo3Ooj`P_o
n/@<oo[33oojaA3on/D?ooK01Ooe_PCom[l6ooJo1oofaPGom;`:omEQ<ooJCcOofe`domMQ<_o?JcCo
bGdmolV:@?o:S43obhToolbD>_o:R4;oe5mKomYFD?oJEeGoeeQGomQFF?oNFeWohfEKon=YGOoRI6Co
gEIaomM?JooIEUgogEiNon1WGP02on=^G`06on=]HOoSKF;ohfePonA/G_oUK5goi6]H0_oTJeL00ooU
JeSohfYHon5[F006on5[E`2[on5/F?oPJe[ohFQMon1VGOoQJUSoiGE>on=k@ooJOCoobgY7ok=bE?nX
KecoZfiLojm`GOneLeWo]G=Gok=bFOnbLEWo/W5Gok9aF?nbLUWo/W9Kok9bF_ncLU[o]GAKokEcF_nd
Le[o/W=Moje`HonXKFKoYF]UojA[J?nWJfGo[VaMok9]F?ncKESo/VeKok9ZEonaJEKo[fUJojeVF_n/
IEcoZ6ARojUQGOnYGe[oZUmJojaOF_n_HUGo[5mEojA<K?na=ICo^c>KokLdT_n`=97oYbjEojH/U?n]
:iOo]BVMok@^Uonf<ICo`S>>olPfR_o9=HgobCN<olHoQOo1?XCo`3f6olE0Q?o6@8?o`D24ol0oPoo4
@H7o_cn2ojLgQOnV>8Co_T62ol94Ponl@Woo_49nokm3POno@X3o_D1ooke3NOno@Wgo^D=jokQ4NOnl
AGSo]d=ioj/oNOn[@WWo[dEmojm3N?n`@gCo[T5dok=4L?ndAVco^TM[okM8J_ndBFWo_4U]omlnQ_oR
@8OocDImoli<Noo=EG3obUEZol]HHoo9FV7oaEQVolIJHOo5FV3o`eaMolEJGoo8EfGo`eMPokiJEonm
FUSo`5YIol1KEOnoFESo^eMJojMAG_nOCFCo[E1Rok]IF?o1G5Go`EeCol1LE_o2FeOo`U]Fol1LE_o1
FeGo_eUKokmIG_o2FeWoaeaEolMJEon]GE?oV5m:ok9W>ooJMBSoiW4SomeP@oo=DF3odeMJomIIG?oF
FEkoe5]LomINFooGGV;oeEeRomEJHOoGDfkofDelomU<P?oBAHSobd2;olHmSoo6?Xcobd68om15QOoG
EGGofemWomYMJooGFWOoeUN4omQIQOoLFgkog5^1omaJP_oZI4SojVP[00;ojVLd00KojVLconYW<OoZ
Ic3ojVPaonYX<?oZJ2l2onYX<@;ojVP`00KojVPaonYX<_oZJ3;ojVPbonUX<?oZJ383onUX<P0;onYW
<OoZIc;ojFLbonUW<OoYIc3ojFPaonU/<OoYKc7oj7<bonUf<ooXN3<00_oYNC@02?oYN3KojGPhonUg
>?oYMc[oj7LjonUg=ooXMcKoj7Hg0_oXMSH00ooXMcGoj7HeonQg=@03onQf=@0GonQf=?oWMSCoigHc
onMf=OoXMSCoj7HeonQf<ooWMcCoj7LeonUg=OoYMcKojGPeonUg=_oXMS?oigD`onEd;_oTLRcohg4Y
on1^8ooNK1kogV`Iomi/6?oNK1T01?oNK1X2omi/6@03onAb:?oXMRcoiWH/00;oiWH[00[oiWH/onIe
;OoVMBgoiGD]onAd:ooTM2goi7@YonMa5?oWL@coig4>0ooWL0h4onMa3P03onM`3_oWL0goiFl40?oo
i6l0B_oTK`000?ooi6l0<_oTK`001ooTL03oigP4on^13Oo^QaWol8LQoo258_o_QAh00_o_Q1d00oo_
QAgokh@Monn57@02onn57P09onn57Oo`QaoolhXPooJ:7OogRQkomXTNooF:7_ofRAoomXXP00;omXXO
06KomXTNooJ:7oofRAoomXTNooJ87oofQakomXDNooF67ooeQAkomH4LooF27OoeQQgomX/PooJ@8Oof
UR;omj0TooR]:?oh]B[onL0]ooW:;_oidS3on]Xcoo_Q=OoigS3om=0SooC?9?ofdB?om]0Xoo?A=OoW
dRooh]4]on??;_oUdBgolmhToo[T7Oojgb7on]/Woo[F:OojebWon]LZoo[F:Ooje2Won]L[oo[I;_oj
fBoon]@/ooW@8ooicAKon<@BooNj4_of]aKom[`OooG4:Ooeb37om/PcooK6<?og`ROon<0LooVo4?oj
`@conl48ooRo1?oe^`;omK`3ooJm0oof_0Gom[l6ooK41ooPV1ooa58momaD<ooSCCGogeLbomAU<_o;
NSSobH`nol^@@?o<SCoocIHjolb9@ooGHE_ofUM@omUGEOoGEeSoeeQEom]KF?oQHe_oi6ULonAWH_oN
G6cof4m]omQCHooLG63oh6IQon=^G?oSKEcohVeQon=^HooSK5koi6aNonI/G?oTK5P3onA[E`03on=Z
EooQJUSohF]G00CohF]G07gohF]Hon5[FOoQJe[ohf]Lon1ZF_oOJU[ohVeFonEdC_oTNDGog7a1ol]i
A_neMU7o[7=Koj]aGOnbLUWo]79HokAbFOndLUSo]79Gok=bF?nbLe_o/G5Jok5bF_naLeoo/G=Pok9b
GOncLego/WEQok=bG?naL5WoZViRojE[J?nQJV[oY6YVoja/H?n`KEko/FYHok9XE_n_IeWo[FIJojYU
GonYI67oZf=KojYQFOnXHEco[69IojaNEOnTBfSo/3J:okXcW?nd=IKo/CJ?ok<eSOnd<93o[BjAoj//
U_n];IOo[bnEok4^UOnm<XoobSB?olXdT?o1>XSo`cf7olLmQoo3>hSo`cb6olPnQ_o7?hOo`Cf6olDo
Q?o6?hCo[CN8oj<eRonn?HWo`D25oka1QOno@HGo`D64ol10Q?o0?h;o`45nokm2P?nnAGgo^4=lokY3
OOnk@W_o[Cikoje0NonaA7go/T=loj/nN?nb@GKo^4IaokU7KonjAVko^DE_ok]6K_nbD6Co`De]ondj
SooH@HOoadQiolUDKOo9EfWobEUTolMKHOo0EfCoaEUQolEKGOo4GEWoaEUNol=GH_noFEWo_E]EokmL
EOo1GECo]eIIojU@GonJC5ooWTaQok]FG_o6Fe;oa5YBol9JEP02ol1LEP0/ol9ME?o0FeOo_EQIokaH
FOnnFUSoaEaEolQMDoo3F5[o/E5Soj=PBoo5L33oig0`oniXD_oHFF?oc5=Gom=HFOoGFU_oeUUPomEK
GOoFGe_oeeiRomEKI_oEE6[oedalomY:P_oGBH7od4:6olToRoo7?h_obD2<ole3Q_oBAh?odTN1omIB
MOoKGFkof5YjomQIQ?oIFHCofe]momaKOooJFHOoiEe]onYW<?oYJ2`2onYW<P;ojVPb00cojVPaonYW
<_oZIc7ojVLaonYX<_oZJ33ojFP`onYX<OoZJ33ojFPaonYX<?oZJ343onYW<P0>on]W=?oZIc;ojFL`
onQY;_oWJbooj6lbonQc=?oYMSOojGPionQi=ooXNSKoj7PhonUh>_oYMd02onUf@00;onUf?OoXMCWo
igHionQf>OoXMSOoj7HfonQf>?oXMSKoigHfonQf=OoXMS<00ooWMSD01OoWMSCoj7HdonMf<ooXMS;o
igLd00;oj7Hc01_oigHbonQf<ooWMS;oigHconMf=?oWMS?oj7LdonQf<ooXMc?oj7LeonUh=OoXN3Ko
igHeonId<?oTLRWohVlTon1]7ooNK1WogV`Fomi/5ooNK1SogV`Jomi/5ooOKAkoigD/onMf;?oVMR`0
0_oVMR/01_oVMB_oiWD/onIe;OoTMBkohgD_onIb70;oig4=1?oWL0h2onMa3P;oig0>00Coig0=onM`
3_oVL0_oi6l2oooTK`19onA_0000oooTK`0donA_0009onEa0OoWM`GojWh=onj66?o`QR3ol8DQonn5
7_o_QAgokh@M00CokhDM00KokXDMonn57OoaQakomHTOooN:7OofRAd3ooJ97P03ooJ:7oofRQkomXXN
00;omXXO00?omXXPooJ97_ofR1l00_ofRR007_ofRQoomHTNooJ87ooeR23omHLOooF47_oePakomHLN
ooJ:7_ofRaoomXlOooJE8?ogWR?omjLVooRe:_oe]Agom;DDooG26ooccBColM@eonSD<OoSdbcohm4^
on7A;Oo_gBSon^DPoo[S8?oihRCon]dVoo[H:0;on]HZ03kon]PXoo[F9ooje2Son]8Zoo[D:_oje2Wo
n]`Uoo[S7_oigaoonMDJooS85_og_QKom[/IooJk7ooe`BWomLD]ooG6;_ofa2com/0Too>l4_oe^@?o
m[/0ooJl0?of^`7om[/2ooFk0_oe`0?okK<Aol1Z>_o5ICSoeeLeonQ5=ooYCSCoh5D]om9W:_o9Qc_o
bi90ol^>@?o=UC[ocXY3omMQF_oJEdkofEQDomMGE_oGF5GofEYEon1OFOoTIegohfUOommMJooIDFoo
eU1VomYHH_oOHf?ohV]Jon=]F?oSKEgohfePon=/H?oUJegoiFeJonE/F0?oi6]G00?oi6YIon5[F?oQ
JeL01OoQJeL04ooPJeWohVYJonA/F?oRK5WogfYJommYFOoQJUWoi71Con=fBOoJNDCobGQ8okIhE?n/
Le[oZg5KojmaF_nbLE[o/g=Iok=bFOncLUX00_ncLUP04onaLeko[g=SojiaHOn_LV7o/7=Sok9bGOnc
L5So/75Lok1`G?n^KUgoYf]RojA[J?nTJV[oYfQSojUVH?n[IUco[6IKojYUHOn/IE`00_n/I5P0P?n_
IUOoZF=IoiQ7JOnR=X3o^CFHok<fV?na>97o/cJ@okLaTOnm<I7o^S:Aok@`UOn];YWo[RnGok8_V?nj
<I7oaC6BokXoPoni@goo`SZ7ol@lQOo3?HCo`Cf4ol@nQ?o7?h;oad23olDnQ?o8?h;o]cV8ojDbSono
>X[oaT23ol4oQ?o6?hSoaD26ol=1Q?o2?X;o`ceookm2Noo1@gco_T=iokQ1O?ni@7_o]d1iokI1NOnc
@Wgo[d9moje1M?na@foo]TA^okU7K_nlAfgo_4E_ok]7KOn]Deko[EIJom=3OOoW=i7obDEcol1CFoo5
F6Kob5YTolMIH_o4Ef?oaeYLolIMG?o2G5co`5YMokmHFoo0FeCo`e]EokeIE_nSD5_oUTYNoj=>Gonc
EUWo_Ua@olEOC_o4Fe?o`eUGol9JFOo1GEOo_eaGokiIFonlEe_o^eMFokeKDOo5GU;oaeYHokaFHOn`
CF7o_U52om]^<_oYLDGoi61[omiHOOoHFG;oeEYFomEHFOoFFF7oeUaNomQPGooIGfOoeUM`omE=NOoJ
BHCofDR5omA5POo?@HGobT68olM0S?o9@8_ocTB6om98PooDBgood4>1omA>O?oKG7cofEZ2omYIPooJ
FX3og5Yoom]IQ_oJFHGojV9@onUY:_oZJ33ojVLc0_oZJ3800ooZJ37ojVPbonYX<P02onUX<@0LonUX
<?oZJ37ojVPbonYX<_oZIc;ojfHconYW<_oZIc?ojVPbonUY<?oWJR_oiF/VonA/9?oUKRSoig8]onMf
<OoXNSSojG/jonUi>_oYN3[oj7LlonQg@?oWMT?oigE7onMeAOoWMD;oigDmonMe>@;oigDg00CoigDf
onMe=ooWMSGoigHf0_oWMSD02OoWMCGoigHeonMe=OoXMSKoigHeonMf<ooWMSGoigHconQf=@05onMf
=003onQf=?oWMSCoigHc00;oj7Hc00ooigHconMf=?oWMS?oj7HconMf=?oXMSCoj7LconQh=?oXMcCo
igDconAb;?oPKR?ogV`Komi/5ooNK1P00_oNK1T00ooSLBKoj7H/onIe:`03onIf:`06onIe:ooVMBko
iGHconIc8ooWLA3oig4=1OoWL0h00ooWL@koig0>onM`3@03onM`3@03onM`3_oVL0[oi6l10?ooi6l0
B?oTK`000?ooi6l0=ooTK`001_oVMPCojh0>onj46Oo`QR3ol8HOonn57P;okh@M1?o_QAd02?o^Q1co
l8HMoo>97oofRAcomhXMooJ97_ofRAgomXTN0_ofRQl01?ofRAoomXTNooJ;7oofRQh2ooJ97P;omXTO
03OomX/OooJ;8?ofRaoomX`QooJ;8?ofS23omX`OooJ;7oofRAoomHHNooF37OoeQQoomXXPooJ<9?oe
QAWokWP3onim0_o`R@KolYPHoo:]9Oo^^A_ojklMonS89?o^f2Gon^DOoo[U8_ohi2ConNDTooWR9Ooi
fbSon]L]oo[F;_ojebcon]PYoo[F:Oojeb[on]H[oo[G:ooigR7onN@Noo[Q8?ojgaoonMXMooWD6Ooh
bQKoml4DooJl5_of_Agom/4Uonnk9?oRZA_oi:/Hon^e5?ob^P_om[/200;om[/002Gom[d0ooBo0ooK
QRKo_5i1ol=d=?o<GcOohD`hoo16=_o_@RGogU8Rolei=oo9S43obhhoolbD>Oo<QDOoeemJomYFC_oG
EUKof5MGomQHE?oGF5CogEaLon=UGOoTJU_oh65VomUBK_oFCVSof5ASomiNH_oRJEcohfaIon=/G?oR
KF;oi6aQonE/GooVKEcoiFaH00?oi6]G00?oi6YIon9ZF?oQJeP00ooQJeL0ZooQJeSohFaHon5[F?oS
JU[oi6aGon9/FOoPJeSogfYHommXF_oQJUSoi6mBon9eB_oLNTCobWQ:okQfD_n[LUWoZg9LojibG?n`
LE_o/g5HokEbEoneLeOo]G=HokAeG_nbLeoo/79OojmbH_n`L63o/6mMok1`GOnbKeWo/fmFok1_F?n]
KegoZFeToj9VI_nOI6SoX6=Woj=TI?nYIF?o[FAJojeREon]I5Oo[fIEoimCIOnE>W7oV3MnojLdUOn_
=i?o]cNBokhaU?nj<97o]cB>okXcS_nj<i;o]S>Bojd_U_nb;YOo_C2?ok@kQOn[BWKo^DElolHjQ_o1
?8?o`Sf4ol0kQOo4?H?oaSj4olM0Poo8?hGob3f8okhjR_nV<h_o^c^7olU0Q_o6@8;ob3n4olI1QOo6
@H?oaSj3ol@nOoo1@W[o`T=lol95Nonn@W_o]3ikokLoN_nj@G[o^D9lojm2O_n^@GKo^4A_oke5L?no
Ag3o_TM_oki4L_ncC6OoZeEKojQFFOnZDegoadMcomE2L_o1CE?o`E=MolQKHoo7G5ooaUYPolMJH?o4
GEco_UaHokmIFOo3FUGo_5UHojM@G?n;AEooRdIOok5CF_nnG4oo_Ue7ol9MC?o3G5Go`UaIol=LE_o1
G5Go_eYIokeFFonnEUWo_UQFol1LD?o3GU;o`UQMokQBHoniDEGode8koneG?OoZHUcogUeeom]IN?oO
GGGohEieomUJIooDFEWoe5]OomMOHOoIFfgofE9momQ9PooHAXKof4J3omA3POo?@HCobd68olM1S?o:
@8_ocTB6om98Q?oCBX7od4:5om4nR?oHEH3ofU^0omUJOooJFWoog5]nom]JPOoEEh_ogU]conUV=_oY
JB_ojVPaonUX;`03onYX<003onYX<OoZJ33ojVP`00;ojVLa0_oZIc806?oZJ3;ojFT_onQZ;OoVJb[o
i6`Von=]8OoQKAgohFhLon9`8?oUM2coigPeonUk>_oYO3cojG/lonQh>ooXMc[oigHionIf>OoVMS[o
iWHgonIf=?oWMSCoigHconMf=PCoigHe0_oWMCD01_oWMCCoigHeonMe=?oWMCCoigHdonMf<`GoigHe
00?oigHdonMf=OoWMSD00ooWMSD00ooWMS?oigHeonMf=@02onMe=0GoigHe00ooigHdonMf=OoWMSCo
igHeonQf=OoXMcGoigDdonAc;OoPKbGogfdLomi/6?oMK1OogfdLonEd;?oWMbd00_oVMRd01ooVMR_o
iWH/onEf<OoWMBcoj78EonMa3OoWL@l00_oWL0h01?oWL@koig4?onMa3_oWL0h5onM`3@03onM`3_oW
L0ooiW070?ooi6l0B?oTK`000?ooi6l0>?oTK`001?oTL07oigH5onYn3_o^PaX2oo278003onn57_o_
QAgokhDM00GokhDM00OolHLNooF87?ofQa_omXPLooJ87OofRAgomXXN00;omXXP00ComXXNooJ97Oof
RAkomXXN0_ofRAl02oofRb7omX/PooJ;8?ofS27omXdPooJ<7oofS23omX/QooJ;8?ofS23omX/P00;o
mXXO05SomXTPooJ78?o_M0Sojfl0ona`0?o^MP[okh8Gonf93OoZS@gok9DAonnQ4OodZ@[om[8=ooS0
4_oibQKonMHIooWN7OojgR?on]d/oo[K;oojfbkon]X/oo[J;_ojfbgon]L[oo[J9oojhakonN4Loo[P
7_ojhAoon^4Poo[S8?ojgagonMLKooW?6oogaQ?okkH:onRX2ooUYA;ohjDFon>Y6OoX/1OokKHAoo>j
2?of^`7om/80onRS4?o3FS_o`VXkol1f=oo1JSWodePion]6<_oh<agol3TMomUV<oo9QD3obHloolVF
>?o<Q4Ooef1HomYFC_oHEUKofEQGomMHEOoFF5Kog5YLon9SF_oTJU[ohVERomYDK_oDC6Woee5SomaL
H_oQIekohfaKon=/G?oSK67oi6eSonI]GooUKE_oi6aIonA/EooTJeOoiF]GonAZF?oRJUWohF]H0ooQ
JeL2on5/F@2Xon5ZF_oSJUWohf]Gon9/F?oPK5Woh6]Gomm[EooPJUSohV]GonA_D_oTMdgofgQ6olYh
B_njNE7o[gIGojedFon`LUSo/G5Hok=aF?ndLUSo]7EMokAeH?ncLego/W=Nok5cGonaL5co/6mLok9]
F_naKEWo/FeHok5_F_n`KUgoZVQMojMVGonSIFCoWF=ZoieRK_nVH63o[65Hok1SE?nWEekoXT1^oj50
KOnQ@G3oYcR:ojTcV?nc;iSo^36AokHeS?ng<hgo^3:>okXeSonk=I3o^32Eok@^Uonc>hGoZdUdojE:
MOnaAGcoaSb7ol@jR?o1>hKo`C^7ol@lQ_o5?XGoaSf6olXnR_o;?hSo`3f5ojPeQonb>HGoad27olM0
Q?o4@H7oaT62olToR?o6?hGo`d9lol13NOo0A7Wo`4Ejok]3N_nc?gSo/Sihok<oN?ng@GWo^DIjokU6
M_nmAG7o`4Ebol=7LOo4AG?o^dU_oj]CHOnZEU_oZ5AMojIFF?n[EUWo[TaHokE;COo3Ce;obUQMolQL
HOo8FVGoaU]Nol5MEOnmGECo_EQIojeBG_n@B5ooRDANoii;FonjF57o`Ee=okiMAonnG4So`EaBol=K
FOo2FeWo`5YHokeGG?nnEeWo`EMFol5JE?o2GDko`e]BokeEGonbD5koaE=7on=D??obE5KokeB0omiH
O?oLG7Koh5eeommMMOoRGG[ohEahomMLHOoGGF;ofEMdomY=P?oHBHKoeTB8omI4PooDA83ocd>3ola3
Qoo9@Hcob42>ole3Q_oBB8;oddZ1om11Q_oA?8Wof4j3omaMOOoIFGoofER0omYJOooJFGoofEV4omEH
R?oVHEOojVP/onYX;ooZJ37ojVP`0_oZIc82onYW<`0@onYW<_oZJ3;ojFT`onQZ;OoUJbWohf`Ton9]
8?oQKB3ohFhMon1^6_oOKQSoh6hKon5`8ooTLbgoigPeonQj>0;oj7Th00?oigPionIf=_oVMS@00_oV
MSD01?oVMC;oiWHbonMf<ooWMS42onMf<P;oigHe0_oWMS<02OoWMSCoigHeonMe=?oWMSCoigHconMf
=?oWMCCoigHdonMf=@03onMf<`05onQf<ooWMS?oigHconMf<ooWMS@00ooWMS<01?oWMSCoigDdonMf
=?oWMS@2onMf=@?oigDd0ooWMSD01OoWMSCoigHeonMf=OoWMSGoj7Hf00;oj7Lf00OoiG@`on5_9OoN
K1gogF/Eon1^8OoXMbooigL^00;oiWH/00GoiGH_onIe:ooXMA[oj7DConQb4003onMa3P?oig0>1ooW
L0d00ooWL0koig0=onE_1@3oonA_04Ooi6l0003oonA_03_oi6l000?oiW85onYj4?o^Pa/00_o`QQl0
0oo`QQkokh@Lonn47@04onn57@0Hoo257OocR1komXPKooN96oofRAcomXTMooJ97oofRQoomXTOooJ:
7oofRR3omXXOooJ;7oofRb7omXXTooJ;8_ofS23omX/PooJ=7oofRakomXTOooJ97_ofRAoomXXM0_of
RAd07_ofRagomX/LooN?8_oeQAKokgH1oneb0?o]M@CokglFonf44OoXP`_oj8<>on^52oo^N`7okgT0
oo210?obQ`3oli<3ooBO1_oeY`Wom[4>ooRl5ooia27onL`Xoo[C:OojfR_on]d/oo[N;?ojhbOon>@O
ooOT8@;on>@Q03?onN<PooWS7oojh23onMhMoo3A5?o/b0koklD;onno2Oo[]P_oj:d?onBW4ooSYQKo
iJ`GonVc5Oo_^PgolkX7olea;?nkDccoa6heol1`>?noKcWobF@ioma<;?ob<A[omc4KonEB;ooALd3o
ahA4olRC??o?R4KofF5GomQFD?oGEeOofEUGomQIEOoFEeWofEMIon5QF_oUJE[ohfIOomaFKOoFBfco
ee5QomaLGooQIf;ohfaPon=/G_oSK63oiVeTonE]H?oUK5`00_oUK5T2onA[E`03onA[F?oRJUWohF]H
00?ohF]G08KohFaHon5/FOoRJU[ohf]HonA/EooRK5Wogf]Iomm[EooPJeOogfYGommXFooQJEcohVeG
on5aC_oGLd[obGM=okYfDon^M5So[7=Koji`F?n`L5Oo/G9Lok5dHOncLeko/gAMokAeG_nbLego[g1M
ok1^F_nbKUSo/FiIok5/F_n`Jego[VQKojiWF?n/Ie[oZFMNoj5SJ_nQHVGoYV=OoieHIOnI@G3oYCm^
ojE5J?nT@Vgo[SV7ok8cVOn[;i?o[c:=okDcSonf<Xko^CB>ok/fTOnn<IOo^c>Dok0oR_nYB7WoZTYc
ojY9MonVB7So]d63ol/lR_o4?8Oo`3^6oklkQ_o3?HGoacf7olLnQ_o9@8;o`Cj3ojdhQOnc>HGoacn6
olHoQoo3@8;oaSn4olXnROo4@H?o`d9lol52Noo0A7Wo_4=kokM2NOnc@7Oo[SehojlnNOnc@7So`TMf
ol=:MOnkAG7o^dE`ol94L_o3Afko/U5SojYEGonVDegoZ5=KojeEF_nSF4koWei2oj=L?oncDdCoae5B
olUFG?o7Feoo`f1EokMLE_nWDUcoWTYQoiI7HOnWCUco^UMDokmLCOnoGDco_Ee<okaLBOnnFe3o`EYI
ol5IF?o0FEKo_UMLokmGFOo2Fe7oa5aBolEMCoo1F5Co^59Lok]@D?oCED3ok5M?oo=AM?odC9Coje:9
omiLMP;ogeee03Ooh5agon9MNOoRGgoofeahomQAM_oKBXCof4R7omI5QooGAH;oeDF0om12Poo<@hKo
ad2;olU0S?o>A8KodDR0om=9POoA@HKod3^7omI9PooJFggofE]nomQHPOoIF87ofUR3omQHPooGFHSo
gU]lonYU?OoZJ2cojVLconYX<OoZJ3;ojFP`onQY;_oVJR_oiF/Xon=/9?oQKAoohFhLon5^7OoPKQ_o
h6hIon1^6_oOKAWogfdGomm]6ooRL2GoiG@^onQg=OoXN3Koj7PeonMf<ooVMS;oiWHd00CoiWHc00Wo
iWHdonIe<ooWMS?oigHconMf<_oWMS?oigHbonMf<ooWMS@01?oWMS<3onMf=@?oigHc00?oigHeonMf
<ooWMS@00_oWMS@00ooWMS?oigHdonMf<`06onMf<`08onMf<_oXMS?oigHconMf<_oWMS?oigHdonQf
=OoWMc@2onMf<`KoigHd0_oXMcH03OoXMcGoiW@aon1_:?oOKAcohg4WonMg;OoVMRooiGHaonIe:?oW
MAOoigD@onQf5OoXM1D00ooWL@h00ooWL0koig0=onM`3@04onM`3@Coig0>00?oig0?onM`3OoUK`<0
oooTK`16onA_0000oooTK`0lonA_000SonA_0OoVL`KojW/@onj26Oo`QQool8HPonn47Oo_Q1cokhDM
onn57?o_QAgokh@Lonn57OoaQakomHTMooN96oofR1comXPNooJ97OofQacomXTNooJ:7oofRR3omX/Q
ooN>9OofS2;omXTNooJ:7_ofRQoomXXNooJ87OofRAgomX/NooJ:7OofRQh00oofRah03?oeRQgomX`Q
ooJ<8?oaNPOokW<0oned0Oo_OA;okXLHonZ93OoYQ`kok8L<oo640P;ol7l00_o_N`00A_o_N@3okgL0
oo1l0?oaP`3olhP4ooJ>3_ogUaKomj0JooR[6Ooi^AgonLDRooSD7_ofh1gom>DRooGV9?ogiR?on^HS
ooOV8oo[fAkohlhIonG@6OoXdASojllEonk<4Oo`a`cokl0:onfh2ooY/0ooiJXConBY5OoW[ACogilU
ol9L@oo0HSWo`fTfol5Y=_o1KSWoa6/eoleG9ooR?Akol3PMoni7:?oMHc_ocgI5ol^:@?o?QTWof61H
omMFCOoGEeGofEYFomQHEooFEUOof5QGommNFooSIeWohfMNomeIK_oFCFcoee=Nom]JG_oPIFCohfaO
on=/GOoTJf7oiViTonI^HooUKEgoiFaHonA[F?oUK5T2onA[E`0Pon9ZFOoQJeSohF]Gon5[EooQJeSo
hFaHon5[F?oSJUWoi6]Gon=[E_oRJeWoh6]Jomm[EooPJeOoh6]Homm[FOoOJU_ogfUHon9]E_oRL5Go
f75=olYdC?nfM5Go[WEHojedFOn^LUco[G9Rok1cG_n`LUko/G=Ook9bG_nbLE/2ok5`F@2>ojm]FOn^
JeSo[V]KojiXFon_J5So[fMHojeWFon[IV3o[VQHojAQGon5@gSoNCB4oh/iO?nK?g3oYD1/ok0jQ_ni
=9Go/CB;oj/cR_n`<Hko^3:?okPbTOni<9So^3BFoji5Q?n[CG[o[Tagoja:LonZB7OoZDYeojY6NOo1
?HKobCb8ol0lQ_no>hKo`Cb8ol<lQOo6?HCoaCj5olDoPonk?8Go]3Z6olDoQ?o6@8KoaCn4olPmR?o3
?XOo`D62olA1Ooo3@W[o_d9iokY0OOnh@W_o]SmiojdnN?n^?WWo^dAcol97M?o1BGOo_DMbokm5L?o1
AW7o]4mUoj]DGOnVDV3oYE9KojaFE_nXFd[oYF10ojER?onTI3koYV8lok=J@Oo1Dd_o^e=@ojMDE_nE
C5ooVDURoji>G_nkF5Go_e]>okiKC_nlGDko_5a=ok]JConiFdko_E]Dol5KEOo2FUCo`EUFokmIFOo1
G5Coa5a?olEJCOnkEUGo/U5BolUCAOoUED_olEAVoo=AQOodC9?oldjAonYGPooNGGKogeeeon9NMooQ
GG[ohEf1on9KRooRDY?ofdN;omM5Q_oD@hGoeDF1omI5O_o@@h7obd:6olQ0Roo7?hgocTF4om58P?oA
B87od4:6om4lQooFAH;ofEMoomUKOooIF8?ofeR5omUHQ?oFEhCoeeV3omQJQ_oTGf?oj6XZonI[9ooT
JbWohf`Ton9/8_oQKAkohFhKon1^6P;oh6hI00cogfhIon1^6_oPKQ_oh6hKomm]6ooOKAWogfdMon5_
9OoUM2ooigLdonQh=?oWMc<2onIf<`CoiWHd1?oVMS<01?oWMS?oigHbonMf<ooWMS<3onMf<P07onMf
<ooWMS;oigHconMf<ooWMS;oigHconMf=@04onMf=0?oigHc00?oigHdonMf<ooWMS@00_oWMS@00ooW
MSGoigHdonMf=@02onMf=00;onQf=?oWMcCoigHconMf<ooXMS?oigHconQg=?oWMSGoigHconMf<_oX
MS@02?oWMS<03_oXMSCoj7LeonUg=_oSLB_ohFlTonAd;_oVMS3oigDUonQe5_oWMA3oigDBonMf5?oY
MQWoj78D0_oWL0h2onM`3@04onM`3_oWL0goig0=onM`3P;oig0=00Ooig0>onM`3ooWL0koig0>onMa
4?oVL0_oi6l10?ooi6l0AOoTK`000?ooi6l0?ooTK`000ooVL`GojGT=onj16002oo278003onn57_o_
Q1cokh@L00;okhDM01Gokh@Loo267_ocQagomXLKooJ76_ofQacomHPKooJ87?ofQa_omXPLooJ:7_of
RR7omh/RooN;7_ofRaoomXXPooJ97oofRAkomXXNooJ;7oofRQh01_ofRQl0FOofSB?olh0Aonid0?o^
L`3okWP;onn66?o/RPoojHP@onb83OocR@;olXH0oo:70?oaQ@3ol8@0oo230?o`P03okgh0onml0?o`
N`3olGT0ooAi0oofN@WomWd?ooJ03_ofQ0oomXd=ooJM1OodZPSomkL=ooW64_oie1Gom=@DonS>5?oY
dAOoj]8IonOB6_oUdQcoi]<LonGD6ooVdaSojm4Donk;3oo^``gojkX>onV^3ooYZaGoc7Pmol9RB?o4
Kc[o`V`jol9W>_o3KSGo`g@[olAP9OoCBBCoiShQonm08OoUESGofFi9olmn@ooEMdoofUaKomMGCooF
Ee?oeeQEomMHF?oFEUOoeeMEomiKFooSIE_ohfYOommOJooGCf_oee9OomYIG_oPHf3ohf]Lon=[G_oU
Jf7oiVeSonI^I_oUKF7oiFaIonA/F?oTJeSoi6]GonA[F?oSJeSohF]H00;ohF]G00SohVaGon5/EooR
Je[ohfYIon=[F?oSJeOohV]Iomm[F@;ogf]G09_oh6aHon1/F_oOJeWogVYJommYFooSJU[ohFiDomQa
C_o=M4ko^G5CojmeFOn]MV3o[GARok1bG_n_LEoo[g9Poji`G_n_Ke_o/6eIojm/F?n^K5Wo[V]IojeY
FOn]J5Wo[VQHoj]WGon^JEgo/FQCoiiBHonC@77oSSefohDgOOn5=WcoSCUfoj4gPonf<Y;o]SF;ok4e
R?n[<X_o/c6=okdaTonf=iCoZ4F4ojM<N?nZBgco/Defok9?K_n/BW?oZDUgojU9M_nb@gooaCZ9olHl
R_o0?8Wo`Cb7ol8lQOo2?HCo`cb6olLoQ?no?8Co]3Z5oklmQOo7?hGobSj7olPnQ_o0@8;o_d62olI1
POo5@Wgo_45jok<oNonf@G[o]41ioj`nMonf@W?o_TIaol16Loo1B7Ko_TIfol=5L?njC6So[5=PojIA
H?nVDF7oZeIHojIJB_nUH3koYf8loj=N@OnTHD3oZFPkojEY??nLFd?oUTE<oi]3DonYCEGo^eIFol9J
D_nmFU3o^UUDokYJDonjFU7o^EQCokYIC_nmFdco`UeAol=KDoo1FEOo_eYHol1KD_o3G4ko`EUAokMD
EOngD4_oe5A4oneGG?ocDggoldf=oo==R_oaDXOoieYnommMN?oOGGOohEehonANO?oTGHGogeN<omm>
UOoSB:3og4FDomA4P?oDAGkoeDEnom12P_o:@HKoad2;ol<nSoo=A8KodTR0om96PooA@HWoe3f8omM2
POoJDgkofE^0omQHPooJF87ofEQoom=HOOoAFG_odUYjom=JLOoNJ3KohVhDon1^6@02omm^6@05omm^
6?oOKQWoh6hIon1^6_oPKQ/00_oPKA/02_oOKAcogfdKomi/6?oNK1_ohFlTonEd<OoWMcCoj7PconMg
=?oVMS<2onIf=0CoiWHc00?oiWLdonIf<_oVMS<00_oWMc<01?oWMS;oigHconMf<ooWMS<2onMf<P0;
onMf<ooWMS;oigHdonMf<ooWMS;oigLconMg<_oWMS?oigHbonMg=?oWMSD00_oWMS<01?oXMSGoigHe
onMf<ooWMS<3onQf<`03onMf=?oWMSGoigHd00;oigHe1?oWMS@01OoWMSGoj7HdonMf=?oWMSGoigHd
00KoigHc0ooXMS<04OoWMSCoigDconMf<ooXMS?oj7LgonEc=_oUM2koj7DMonMe4ooWMQ;oigHConMf
5?oWMQ?oj7LFonUe6_oXL1;oig0=00;oig0>00Ooig4>onM`3OoWL0koig0>onM`3OoWL0koig0=00Co
ig0>00?oig0?onI`2?oTK`00oooTK`14onA_0000oooTK`11onA_0006onEb1?oZNPookX8Joo267oo`
QR3okh@M0oo_Q1`03_o^Q1cokh@Moo657OoeQa_omXLKooJ77?oeQacomXPLooJ77?ofR1gomHPNooJ:
8OofRAoomhXN1?ofRQl8ooJ:7P0=ooJ<8OoeQa_okgL4onab0?o_MPKokh8Gonb94_oYR0kojhT<oo>8
0oocQ@3olhH0oo:60002oo>60004oo:70?oaQ@3olH40oo6100;okh4001?olWl1ooEn2?ofO@komWT>
ooEg2oodN`Col800oo610?odQ@3oiXD1omn50?oTT07oj9X2onVU1_oY/PWoj;`>onS74OoZd1Cojm8G
00;ojM<J02cojM@Kon[C6OoZcQCok/H@omnP:Oo1H4[o`F`nol=e?_o3KCkoaFPmolM`<Oo4LBOo`6@V
ol]B9ooNA2GojSdQonY<<ooOIDKoe7E0omi[F?oTGEkogEe>omYIEOoHEeOoeUIGomEGE?oGEUKog5UH
on9TFooTJekoh65WomUBJOoFD67ofEMKomiOH?oRJF3oi6aMonE[GOoVK67oiViWonI]HooUK5coiFaI
onE/F0;oiF]G0:SohVYIon5ZF?oQJeOohV]Gon5/F?oQJeWohVYIon=[EooSJeSohf]Gon9[FOoOJe[o
gf]Hon1[EooPK5SogfaKomm[F_oNJeOogfUKon1XG?oPJESogV]DomU_E?o=KU;o^ViDojeeH?nZM6;o
Zg9QojicH_n/LF7oZfaKojeZEon]K5So[FaJojeZFOn/J5So[6UHojaXF?nZJF3o[F]LoimGH_nE@Foo
Vd=]oie4JonI@6koTce`ohXiLon:<GkoVbf?ojTbSOne=XSo^SJ8ok@aSOn^=Xko[DV0ojaAN?nZC7[o
YdQooja:NOnaCfoo/Tm`oja<LonXB7SoZdMkokXoQoo6>Xko`Sb9ol0mQ?o0?8Co_c^6ol@mQOo8?hCo
`3f4okDjQOnm?8KobCf8ol/mROo5@8Co`T61ol10POo5@X7oaT5ookHnOOn_?Ggo]d5lok50NOnd@W?o
_dEboka4Loo0AW;o`dUdol97N?njBFco[e5SojYBHOn/DF;oZe=IojMJB?nVH3koYV8mojUQ?OnTGd3o
Wem3oiUQAon@ID_oRf=9oi=K@On/Dd7o`598ol9CC?nnEU3o^UYFok]JE?nlFTko^eU>okeIB_nlG4Wo
_ee<ol9LE?noFUWo_UMIol=ID_o4FdWo^UQ>okEDE_o8DToohUABoo9EKoocDX_ole6;oo=BQ_ocEHOo
lUV7onMJO_oOG7Koh5ifonANNooUG8KohE>Aom]:TooMAiOohdNOomm7VOoGAXCoeDEmom93P_o<@8Ko
b3j;ol<lT_o8@H_odDN1omA5PooB?hWodd25omA3OOoEDg7oeE]eomEJN_oDFGKodeYbom1JL?o>FVoo
d5a`olmJM_oCGUSogf`Mon5_4ooOKQX2on1^6P04on1]6ooPKA[ogfdKomm]6`;ogfdL00_ogfdKomi/
6?oNK1SogfhNon=c:_oWMc?oigPeonMg=OoWMSCoiWHconIe<`03onIf<P;oiWHd00WoigHconMf=?oV
MS;oiWHbonIg<_oWMc?oigHbonMf=?oWMS<00_oWMS802_oWMc;oigLconMf<_oWMc?oigLdonMg<ooW
McGoigLdonQf<ooWMcD3onMf<`06onMf=OoWMSCoigHconMf<ooWMSGoigHd1OoWMS<02ooXMS?oigHc
onMf=?oWMSCoigHeonMf=?oWMCCoigDconMf<ooWMCCoigDc00GoigHd00koigHeonQf=?oXMSCoigHc
onMe<_oWMS?oigDdonMe=_oWMCSojGT`onQj8OoWMQCoigD@onMe4`;oigDB0_oWMQ<01?oXMaSoj7@F
onMa3ooWL0h2onMa3`;oig0>00?oig4?onMa3_oWL0h01OoWL0h00ooWL@ooig0?onE`1@3oonA_04Co
i6l0003oonA_04?oi6l001GoiW<5onUi3_o]PAWol8HPoo678_o`QQkokh@Lonn47Oo_Pagokh@Moo25
7OocQQgomXLKooJ66oofR1comHPLooJ87?ofR1gomXTOooJ98?ofR1h00_ofR1d00oofRakomX/OooJ;
7`07ooJ:7P0;ooJ;7oofSB;olWh<onac0?o]L`;okghDonj85?o[R`_ojhT;oo681_ocQP000oocQ`00
0oocQP3om8L0oo>60002oo:3000>oo220?o^PP3okh<0oo210?odP@ComX8;ooIn3oofO@colgl3oo63
0?oYN`3ofg40omQ`0?oILP02omYb003Pom]d0?oMN`3ohHD0onBA0OoWVP?oijH6onRc2OoX`a3oj]0D
on_D6?oZe1Sojm@Ool^H>Oo1Pccobh`folZ7=Oo8P3WobgdcolUg;?o5L2Wo`fXUolUS8ooBDAkogDHK
onA=:OoJHScoe890onAoFooXIVGohVACommOF?oIF5[oeUEGomAFE?oCEU?of5QGon5RG?oTJecohVAT
omYEJOoFD67oeU9Lom]IHOoRIekoi6aLonI/GOoVK63oiFaUonI/IooUJeooiF]IonE/EooUJeOoi6]H
on9ZFOoQJUSohF]Gon5/F?oPK5SohF]Ion=[F?oSJeOohfYHon=[F?oRJeWogf]Jomm/EooPK5Ooh6aK
omm[FooNJeOogV]Hon1[FOoOJUWogFYJomm[G?oPK5OogG1Com5aE_nkLUWo[WIOojQeIOnXL67oZf]K
ojm[E_n^JeOo[6]Ioj]ZF_nYJEcoZFQKoj]YFOn/JegoX5ePoi93J_nD?VooUd5`oiU1KonJ@6coVSm]
oi`mJ?nM>FkoV328ohh]S_nF;X_o[2n>ojhiROnVBGgoY4ekoj]<NonaCWOo[T]koje:N?n/C73o[deb
ok9=LOn^BgCoZDUfoji2P_nn>hgo`Sb9ol4nQ?no?HOo`C^7ol<lQOo6?XGoa3j4okLkQ?nn>hOobcf9
olTnQoo2?hCoa461ol=0POo4@H;o_Sn0ok8kOonf?Wgo/Cimojm0M_noAW3o`DIaoka4L_nnAW7oaDIf
oka7NOn]Cf_o[E9Qok1CH_n]De[oYEQ8ojMO?_nYHCgoZf8lojQQ?_nLGdKoT5]=oheMC_nDHTKoWVPm
ojM]=_nWJS?o[E/kol1@Aoo1D4_o^U=<ok]GC?nkFd_o_Ea7okeLB?nlGD_o_5YDokeEG?o1EeOob5U=
olAICOneEE?o_5=BomQFG?o^F6_ole>0oo=BR_ocE8KoleB4oo=EQoocF8SoleN8ooADROo_FH?oi5ik
on9IQOoNCICofDJDomU8S_oJC8Wog4Z?omi8U_oKAHgodT=oola1Q?o6?hgo_cfEol=1T?o=BXCocTN0
ola1Ooo=@GOocTQ]om1EI?oDGecodUaXom=KKooBFfcodEa/olmKKOo@FfkodE]dolmJL_oIIScoh6hG
on1^6OoOKA_oh6dKomm]6_oOKA`2omm]6`;ogVdK00OogV`Homi/5ooOKA_ohg8XonIg<OoWN3?oigLd
00?oiWHd00?oiWHconIf<_oVMS<00_oVMS<2onIf<P;oiWHc00WoiWHbonMf<OoVMc7oiWLbonMf<_oW
MS?oigLconMf<_oWMS<00_oWMc<01ooWMcCoigLconMf<ooWMS?oigLconMf<ooWMS@00_oWMS<2onMf
<P03onMg<ooWMS?oigHb00?oigHc0_oWMS@00ooWMS?oj7HdonQf<`04onMf<`03onMf=?oWMS?oigHc
00;oigHe0_oWMS@2onMe<`;oj7Hd00KoigHconMf=?oXMCCoigDeonMe=?oXMCH2onMe=`09onMg<?oX
N2;oigPGonMi5OoWNASoigHConMe4?oWMQ7oigDA00;oigHB00GoigLBonQg5?oXLa;oig4>onMa3@02
onMa30;oig4=1_oWL@h3onMa3`03onM`3_oUK`?oi6l00?ooi6l0@_oTK`000?ooi6l0AOoTK`006_oU
LPCojGT=onf16Oo`Qb3olHPQoo257_o_Q1gokhDLonj47?o_Q1colXHMooF77?ofQa[omXHKooJ87?of
QacomXPMooJ:8?ofRQoomXPMooJ66oofQacomXTNooJ:7oofRaoomXTO0oofRQl2ooJ:7P0<ooF97Oof
SR?omHPIonif0oo/L@3okgX?onn75Oo[RPcojXP<onn82OobQ03olXD00oocQ`001?odQ@3olhD0oo:4
0?obQ002oo23000:oo:70?oaQ`3ol8@0oo>50?oePPKomWh?ooN03_o[O`?ofgD0omUb00;ofW@000Ko
fG<0omQ`0?oHK`3ofFl0omYa0?oJLP02omYa000comaf0?oPPP3oi8l0onJG0ooSX@OojkX8on>j7_o7
WS7odJdYomJg9ooF]R[oek8ZomJU:OoBU2cobhTbolZ3=?o;NRgobfLTom1H7?oCEB3oe7/]omNU;_oV
Oe_oifMIonAYD_oSIU[ogeiJom]JFOoHEeKoeEEEomMFE_oNGe[ohfQKon=XH?oLFFSoeU1TomE@GooI
Eecoh6AOonE[H?oVK5koiFaOonE]I?oVKFWoiF]UonAZG?oUJUWoi6aHonA[EooSJUSohF]H00;ohFaH
0:3oh6]Hon9ZFOoTJeSohf]Gon=[F?oTJeOohV]Gon1[FOoOK5Woh6eKomm/FOoNJUOogf]Gomm[F?oP
JeOogf]KomaZF_oMJESogVYKomm^GooLKeoobVQOokIVG_nYJ5_oXfYJojY^F?n^K5Oo[6YIoja[F?n[
JE[oZFQKoje]F?nQHfCoSdI]oiE0J?nF@fWoTd9^oi=0L?nE?VkoVCa]oi`mIOnR?FSo[SV2ojXdROnM
;h[oTSF<oi94Q?nNCGcoY4]mojI:N_nZBgSo[dajokA>N?nbCG?o[TYfoji:MOn_BgGo[T]eojQ8M_nb
?XCo`CR=ol0lROo5?hOoa3j8ol@mQoo4?8Ko`Sf5okPiQoo0>hOobSf8olLoQ?o2?XGo`Sn4ol=0POno
@8;o]S^3ok8jPOnd?7ko/Cmkoke5M?o4Ag3o_4Abok]4Lonn@gGoa4AfokQ@LOnTDF[oZe1Qok1FF?nU
FTWoYeloojYP?OnWHCooWem4oiUMBOnDFdcoU5e9oj1T?OnVJSOoZFTdoje]<_nXKcGoXfLcoj]I>Onb
DSoo/e@jokUE@?nnEdKo_UY:okaIConkE5Ko`5=IolIFEOo;F57o`EECokE@E_o;DeOoieEYoo=FO_oc
DXWole27oo=DQ?ocE8?oleB8oo=GR_ocEhWoleN8oo=HQOodEX_oie6AomM:T?oHAY3of4V;omM<QooF
BhGoeT^6omY;TOoFBISob4J<ol55ROnm@Y7o`4J?olQ=QOo:BXGoc4J9ola6P_o<BW?od5MQomAOE_oE
H5Koe5eRom=KKooAG6cod5]]om1JL?oAG77od5Ygom9MHOoNJb;ogfdH0ooOKA/03?oNKA_ogfdIomi]
6ooOKA[ogVdIomi]5_oNK1Soh6lSonEe<?oWNCKoigLeonIf=0?oiWHb00CoigHdonIf<_oVMS;oiWHc
0_oVMS800ooVMSCoiWHconIf<`02onMg<`03onMg<_oVMc7oigHc00;oigHc00GoigLdonMf<ooWMS?o
igLdonMf<P02onMf<`;oigHb00CoigHconMf<_oWMS;oigLd0_oWMS<2onMg<`?oigHb0_oWMS<4onMf
=003onMf<ooWMSCoigHd00;oj7Hd0ooWMS<2onMf=003onMf<ooWMS;oigHe00;oigHe01koigHdonQe
=OoXMCGoigHdonMg=OoWMSGoigLdonMh<?oXNBSoj7TNonMi6?oWNQ_oj7XMonQj8OoXN23oj7LMonUf
8?oYMB7ojGDTonUe8ooXMB3ojGDQonUd9OoYLQkoj74FonMa4_oWLQ7oig8>onMa3OoWL@/3onIa2`03
onMa3OoWL@koig0>00;oig0?00?oig4?onI`2_oTK`40oooTK`12onA_0000DooTK`001?oVM@KojhHI
onjB9_obWS<2on^66@Soi6l000GojH4Conb<8?obWS?ok8`PonV14`08onA_0004onMk3Oo[QQWojhHI
onIe1PCoi6l000GoiWD6on^66Oo[QQWojhHIonIe1P03onA_0004onIe1_o[QQWojhHIonV14`Soi6l0
00?oig/=on^66Oo[QQT01_o[QQT4onA_0004onV14oo[QQWojhHIonIe1PCoi6l00oo[QQT3onA_0003
onMk3Oo[QQWojhHI00KojhHI1?oTK`001?oWN`gojhHIon^66OoVM@H4onA_0005onIe1_o[QQWojhHI
on^66OoVM@H02?oTK`001_oWN`gojhHIoo2H;?o`V2cojhHIonV14`?oi6l000?oiWD6on^66Oo[QQT0
1_o[QQT00ooVM@Koi6l0onA_0008onA_0003onV:<?o[Td3oji=000Ooji=01OoTK`001?o[Td3ol[N0
oo:gP?oYRS08onA_0004on^C@?ob]h3ol[N0onV:<0Soi6l000Gok9a@oo:gP?ob]h3ok9a@onIh400f
onA_0007onEb1?oYN@gokH4Hoo267oo`Qb3ol8HNonn47@02onj37003oo267_ocQagomXLK00;omXPK
00_omXPMooJ97_ofRAoomXXOooJ87OofQa[omXDJooJ87OofRAgomXXNooJ;7`02ooJ:7`;omX/O00co
mXXOooJ;8?ofSR?olG`:onaa0?o_MPSokh@FonV84?oYR0col8P8oo>30OocQ@03oo>6000@ooB50?ob
P`3olX@0oo620?o_PP3olH<0oo>60?ocR@3olXL0oo:60?obQ@3omhD4ooJ02_oZM@?of740omQc00?o
fg@00_oJM@00?OoJM03ofg<0omYc0?oILP3of700omM]0?oHKP3oef`0omI[0?oFJP3ofW<0omQ]4Oo<
GdWobfY:olif@?o>OSOobhDbolVF;?o>YBKodJHZolfL<OoAVcCod8ldol]e<oo@FR_oeDdSomE/8ooD
QBgohF]HonEWDOoUJeGoiFYIon=VF?oQHUWogU]IomMGEooEEeGofe]Ion9UF_oRJ5oog5UVomYEHooI
EF7ofEIOon1QGOoUJe[oiVaMonE/H?oVKFCoiViYonE]I_oTJeooiF]KonE[FOoTJeKohf]Eon5[FOoQ
K5SohFaGon5/FOoRJUT00_oSJeL0O_oSJeSohf]Gon9[FOoPK5cogfaIon1/F?oNJeSogVYHomi[EooO
JeWohVeKomm[F?oLJUOog6YIoma/HOoMJf;ogFULom]XFoo=IEWo^61IojMTFOnUKUOoZG5Ioja^F?n/
J5So[f]EojQXF_nBCW7oS3e`oi50JonB@fcoU4A^oiA1K?nB?V_oU3YYoi<jI_nG>VSoZ3Iook8fR_nZ
?h;oX4]joiQ;OOnBAHCoUDF4oia8OonSBG_oYdUlok=<N?nfCWCo/Tedok9=MOnbBgSo/4]doj]<LOn[
AWSo^3Z9oklhS?o8@8KobD27ol<nR?o3?XOo`Sb7ok/hR_o1?8Oob3j6ol<nQ?o4@87o`Sn3okdoP_nf
?H;o]S^5ok@lP?n^?7Wo^41folE7MOo1AGKo^D=coka3M_o1@gKo^da^ok5DJ_nYE6[oZEIFoj]M@_nW
GcooY5e2oiaKAonFG4_oV5e8oiaNA_nNGd;oYV<joj]W=OnYJcGoZF/fojQ[=OnSIcOoXf@dojEV<OnS
IbkoZEl`okiC?oo6CdKo`4m:okiAD_o3EUOobEUDolMHDOnoE5Co`e1MomiEI?oaEGKole68oo=AROoc
D8Kole:3oo=DQOocE8OoleJ8oo=HR?ocF8Wom5Z8ooAESoofB:3oid>MomI9R@;oed^501_oedb9omM=
SooICIKoeT^Nole:W_o1Ai7o_dF:olI9R_o;CXCobDV5olY4R?o=AhOod4f2omELM?oGIFKoef5KomIO
DooDGEgodE]^om1KK_o?FVkod5]_om5LL?o?F7GoeV=4on1^4ooOKAT00ooNKAX03?oOKAWogfdJomm]
6OoNK1SogV`Fomm^7OoSLR_oigHdonMg=OoVMSCoiWHbonMg<`;oiWHc00KoiWLdonIg<ooVMS?oiWHd
onMf<_oVMS82onIf<`09onIf<_oWMcCoiWLconMg<_oVMc;oiWHaonIf<ooWMS?oigHb00;oigHc00Co
igHbonMg<ooWMS;oigLc0ooWMS801_oWMcCoigHconMg<ooWMS;oigHconMf=@?oigHb00OoigHconMf
<_oWMS;oigHconMg=?oWMSCoj7Hb00;oj7Hc00?oigHdonMf=OoWMS@00_oWMS<2onQf<`;oigHd00Go
j7LdonQf<ooXMSCoj7HdonQe=002onMf<`08onIg<_oWMS?oj7DeonQe=OoXMS3oj7PZonQh:?oXMbd2
onUe<`06onUe=?oYM3Koj7<honUd>OoZM3[ojW<k0_oZLS`04_oZLSWojW8kon]b?_o[LSgojW4ionY`
=?oZL2kojG0YonU_8_oXKa[oj74EonMa5?oWLA;oig4>onMa2ooVL@_oiW4<onMa3P;oig0>00?oiG06
onA_0?oTK`00oooTK`10onA_0000DOoTK`000ooYPA?omjm5ooo<I@05ooo<I@03oo>S>OoTK`3oi6l0
00?oi6l000?ok8`Pooc0F?ooc6D01?ooc6D00ool`5Sok8`PonA_0005onA_0004oo:N<oooc6GoolaU
on^66@Coi6l000GomJToooo<IOooc6GoolaUon^66@03onA_0004on^66Oooc6GoolaUooReC0Soi6l0
00?olYhcooo<IOooc6D01_ooc6D4onA_0004ooReC?ooc6GoolaUon^66@?oi6l000CokY8Vooo<IOoo
c6Gon[YB0ooTK`000oobWS?oolaUooo<I@06ooo<I@Coi6l000ColYhcooo<IOooc6GojhHI1?oTK`00
1OoeZCooolaUooo<IOooc6GojhHI00Koi6l000?ok8`PooZjD_ooc6D01Oooc6D01?o/S23oi6l0onA_
0?o[QQT8ooo<I@03on^66OoTK`3oi6l000Soi6l000?on=^oooooooooool01oooool3onA_0003onIh
4?oji<oooooo00?ooooo00?on=^oonIh4?oTK`000ooTK`000ooVN13on^C?ooooo`03ooooo`03ooSK
_ooVN13oi6l000?oi6l000?ojHX`oo[Tcoooool00oooool00oomm^ook9a@onA_000fonA_000GonIb
1?oYN0cokH0Goo267ooaR2;ol8HPonn47Oo^Q1gokh@Moo677OoeRAgomXPKooJ87?ofR1gomXLNooJ8
7oofS1oomXXNooJ56_ofQ1WomXHLooJ97_ofRal00_ofRQh4ooJ:7`0:ooN?9OodQ1GokG@1oned0oo`
P1GojhTAonV93?o_R@Som8D0oo>500;olhH001Com8H0oo:40?obQ03olX<0oo210?oaPP3olX<0oo>5
0?ocR03om8T0oo>70?oeQ`3om8P0onIm0?oTM03ohG<0omQb0?oHL`3ofG@0omYc00;ofG<000?of780
omM`0?oHL0000ooGK`00e?oGKP3oeVd0omE[0?oEJ@3oe6T0omIV0ooGFDOoeE=WomEBFooFDU;odU=@
olaJCoo7GcOoaF8Rol1[8_noNBWoa8T/olF<<_o8OcOodFXhomEG<_o@KbSoeH0mon9/GOoTJE?oiF]G
onAZF?oUJUOoi6UGon9TFOoMGU[ofEMIom]HFOoQHeWohF=Mom]FH?oMFFCogUeTomiMH?oQI5coiFYJ
onI[FooUK5goiViRonM`I_oVKfGoiVePonE[G?oTJUcoi6UJon=YF?oRJUSohFaFon5/F?oQJe[ohf]H
on=/F?oSJeWohf]Jon=/FOoSJe[oh6]Homm/F_oOK5WogV]Gomm[F?oOK5_oh6aIon5/F?oNJU_og6UJ
om]WFOoKJ5_og6QJomeYG_oOJUooffAKolUOF_nhH5[oY61Moi]TG_nVKE[oZFUEoiEDI_nCA73oUD=Z
oi94J?n@AF[oSd9/oi0oJ_nC?FKoTSaSohllH_n=>VKoU3IhoidoQ?nQCG[oYDigojI;NonPBWcoVdQl
oiE6P?nEAX?oVdB2oj=7N_n/Bg;o]4aeokI=M_ncCG?o/4adoji<LonYCG3o[T=lokljROo5?XKobd25
olQ0Q_o5?hSoaSf9okhjRoni>H_oaCn3ol4nQ?o4@87oad23ok`nQ?nb>h?o]cb4ok4mOOnc?WOo`49g
olA4N?o3AWWo`TEfokm0N?niAWCo/E1Xok5DIOn`FU_oZUm4ojMP?OnJFTWoTUQ?oiEJC?nNGTGoYV4n
ojAQ?OnTHS[oZF@gojMU>_nSIS[oYFPhojMX<onVIC;oYFDboj=Y<OnWHS?o^E@oolE<B?o4CDKo`di3
ol=@AOo5E4_o`5IAokmCF?oFD6WojeIdoo=DP?ocCh[ole66oo=@P_ocDXColeB5oo=CR?ocEXSoleV5
oo=IQoodEhcomDnFooA4X_od@JKokDFLom]=ROoDCHSoedf@omQ?UOoHCiWoeTZOom1:XOo7B:3o`4F@
olI:Q?o:CHGobTR9olU4R_o>BHGodU1oomIMM?oIIVcofVM]omQTK?oEH5oodemFom5MH_o>FG;ocUQc
om5KKoo@FGCod5UXom]Y:?oPKQ7ogVdJ0ooOKAT02?oOKA[ogVdJomi/5_oMK1Woh6lUonIe<ooWN3Ko
iWPc0_oVMc43onIg<P05onIf<ooVMS;oiWLbonIf<OoVMc<00ooVMS<01?oVMS;oiWHconIg<ooWMc82
onMg<`09onIf<OoWMS?oigHbonMf<ooWMS;oigHconMg<_oWMS;oigHc00;oigHb00?oigHconMg<_oW
MS800_oWMc@01?oWMS?oigHbonMf=?oWMSD4onMg<`09onMg<_oWMc?oigHbonMf<_oXMSCoigLdonMg
<ooWMS?oj7Hc00;oigHc023oigHdonMf<ooWMS?oigHeonMf=?oXMS?oigHconQf=?oWMSCoiWLbonIf
<_oWMSCoj7DeonUc=ooYLSWojG<honYd=_oYM3Goj7<ionQa>ooYLS[ojG8ionUb>_oYLS_ojG<jonUc
>ooZLc_ojW<ionYc=ooZLcSojW8honYb>@;ojW8h00KojW4konY_??oZKS_ojVdmonY]>ooZKST2onY_
=005onY_<_oYKbSoj70LonMc5?oWLPl00_oWL@`00ooWL@koig0=onE_0`3oonA_047oi6l0001@onA_
0003onjB9_ooc6GoolaU00;oolaU00Goo<1HooReC?ol`5SoolaUoo:N<`04onA_0007oo2H;?ooc6Go
olaUooo<IOomaUoon;E<oog6G`03ooo<I@03onjB9_oTK`3oi6l000?oi6l000ColYhcooo<IOooc6Go
jhHI0ooTK`000ooWN`goolaUooo<I@02ooo<I@05on^66OoTK`3oi6l0onA_0?o[QQT00_ooc6D00ooh
]Dcoi6l0onA_0006onA_0003oo:N<oooc6GoolaU00KoolaU1?oTK`001?oh]DcoolaUooo<IOo[QQT3
onA_0004ooN_AOooc6GoolaUonjB9P?oi6l000?olYhcooo<IOooc6D01_ooc6D4onA_0004oo:N<ooo
c6GoolaUon^66@?oi6l000?oig/=ooo<IOooc6D00_ooc6D00oo[QQWoi6l0onA_0003onA_0003ooFY
?oooc6GoolaU00;oolaU00Gon[YBooReC?omaUooolaUon^66@02onA_0003on^66Oooc6GoolaU00Ko
olaU00?ojhHIonA_0?oTK`002?oTK`000oohfkooooooooooo`07ooooo`?oi6l000?on=^ooooooooo
ool00_oji<l2ooooo`03ooOB[ooTK`3oi6l000;oi6l000?on=^oooooooooool00_oji<l2ooooo`03
ooOB[ooTK`3oi6l000;oi6l000?on^C?ooooooooool00_oji<l2ooooo`03oogfkooWPB3oi6l003Oo
i6l000[oiG84onQh3?o/OaKol8HOoo278?o`QQookh@Lonj37?o`QAgolhLM0_ofQa/07OofR1gomXTO
ooJ;7ooeRb3omXTOooJ66OofQ1SomXDLooJ87_ofRQkomXXOooJ:7_ofRAkomXXNooJ:7OofSB;omX`O
onmj1_o/LP7ol7`Aonj74_oYR@cokXX8ooB50?obQ03olhH0ooB60?ocQP3olX@000;olH40017olH80
oo:30?ocQ03olhD0oo>70?odQ`3om8P0ooN;0?oWO`3ofWL0om]g0?oMN03ofWL0omQc0?oIL`3of780
omM`0002omM_0003omI_0?oFKP3of6h000?of6h01?oIK`00J?oJL@3oeelNomMFH?oHEE_ofEE@omQF
CooHEeGoe4m7oli0;_o;@2_oc4Ddole?>?o;ERkob5X[olUM<ooCEcWog54hom9a9OoHLTooiVMPonEZ
EOoUJUWoi6UHonAZEooUJUSoiFUJon9VFOoOGUSogUaHon5RFooKFEooeU1PomeJI?oQHVCohVAPon=W
FooTJEWoiFUIonE[G?oVKF7oiVmUonI_IooVKV?oi6aNonEZF_oTJEWohfUJon9ZFooQK5WohFeHon9[
F_oSK5WohfaHon=[FOoSJe[ohf]Hon9ZF?oPJe_ogfeJomm/E_oOK5SogV]KomiZF_oOJUWoh6UHomeW
F?oKIeKoffUJomYXFooKJ5gofVMPomaWF_oLIUSof69KolUJHOnfEF;oXeaRoiELG_moAW3oQT5`oi94
IonIAVOoXDEYoii1K_nS?fgoYc]YojHkJ?nS?FOoUDIRoiE>K?nHC7goUTYnoiY8P?nQBWgoY4]hojE;
M_nSBWWoWTMnoiM4OonEA7coVDAjojQ7NOneCW7o/Tia0_n`CW807On]Cg3o[4eboka2Ooo4?HOoa3n6
ola0Q_o:?XSob3f8okljS?nd>8_o`3j4ol4oPoo2?X?oaT23okdnQOna?8?o[S^1ok4mO_nn@GWoaT=g
olA3NOo5AG_oaT=kokU4M?n_CFco/U=Rok5ID_nVG4[oW5];00;oT5M@013oWEa5ojUP??nZHScoYV<l
ojIS>?nUHcWoXf8koj9R>onSHSSoYf<dojQV<_nUIS?oX6Pcoj5P=OniD47oade50_o5CT<0?_o3Cd3o
_e8lol5>A_o@BU_oidicoo=DO_ocDh?ole28oo=AQ_ocDH?ole62oo=BQ?ocE8SoleF:oo=IQ_ocFXGo
m5N;ooE;Vooe?jKolD6Poo56X?obB:Goh4fLomI?U_oIDIOofTjJomE;WOo>Aj3ob4NQolI6Y?o<BY[o
bDZ;olI6Qoo<AhOodDV5omAAO_oFGg3of6E[omUUJooGI6_oeVA`omESJooCH5SodUiHom1KIOo@FG3o
d5YcoliGM_oEGe3ogfdGon1^5?oNKA[ogVdIomi]6_oNKAWogF`Home/6OoNKB3ohg<^onMh=_oWMc?o
iWLb0_oVMc400ooVMc;oiWHbonIf<P02onIf<`04onIf<_oVMS?oiWLconIf<P;oiWHc00_oiWHbonIf
<ooVMS?oigHbonIg<_oWMc?oigLaonIf<OoWMS?oigHbonMf<`02onMf<P0:onMg<ooWMS;oigHconMf
<_oWMS?oigHbonMf<ooWMc?oigHconMf=0;oigLc00?oj7HconMf=?oWMc@01OoWMc<2onMf<P03onQf
<ooWMS;oigHc00;oigHd0_oWMS<02ooWMSCoigHconQe=?oWMCOoigDfonMf=?oWMS?oiWLbonMf<ooY
M3GojG@g00?ojG<h0_oYLcT01_oYLcSojG<jonUc>_oYM3[ojG<ionUc>P?ojG@j00KojG@lonM`=OoX
LC?ojWDfonYc=_oZLSL3onYc=`03onYb>OoZLCSojW0h00;ojVhg00kojVhhonY]??oZKCgojVdkonY]
??oZKS[ojW0donU`:ooXLA_oig4AonMa3OoWL@koiW09onA_0Oooi6l0@?oTK`0004ooi6l000KojhHI
ooo<IOooc6GoolaUooN_AOoWN`d3onA_0003onIe1_oYPA?oi6l000;oi6l000GojhHIooo<IOooc6Go
oLIOoo2H;003onA_0005oo2H;?omaUooolaUooo<IOo[QQT01?oTK`001?obWS?oolaUooo<IOo[QQT3
onA_0003ooFY?oooc6GoolaU00;oolaU00GojhHIonA_0?oTK`3oi6l0on^66@02ooo<I@03ooReC?oT
K`3oi6l000Koi6l000ColYhcooo<IOooc6GolYhc2OoTK`001?oh]DcoolaUooo<IOo[QQT2onA_0005
onMk3Oooc6GoolaUooo<IOoVM@H00ooTK`001?obWS?oolaUooo<IOobWS<9onA_0004oo:N<oooc6Go
olaUon^66@?oi6l000?omJToooo<IOooc6D00_ooc6D00oo[QQWoi6l0onA_0002onA_0006oo:N<ooo
c6GoolaUooo<IOobWS?oiWD60ooTK`02onMk3@;oi6l000CojhHIooo<IOooc6Gon;E<4?oTK`001Oo^
YF3oooooooooooooooookZEP00Ooi6l000CojHX`oooooooooooon=^o0_oTK`001?ohfkoooooooooo
oooYRS02onA_0004onV:<?ooooooooooooSK_`;oi6l000Con=^ooooooooooooojHX`0_oTK`001?o^
YF3oooooooooooob]h02onA_0004oo:gP?ooooooooooooG9Wc[oi6l001GoiG42onQg2oo/OaKokhDM
oo278?o`QQookh@Monn47?oaQakomHPMooJ87?ofR1gomXXOooF:7_oeRQoomXTPooJ76oofQ1SomX<I
ooJ56oofR1d00oofRAh04_ofRAgomXXOooN=9?ocP@ookG80onmg2oo^QACojHP>onf:2OocQP7olX@0
oo>60?odQP3olX@0oo210?o`P03ol840oo6300?olh@0013olhH0ooB70?ofR@3ok8<0omah0?oKM`3o
fgT0omYh0?oLM`3og7H0om]f0?oKM@3ofWD0omYc0?oJM03ofW<00_oIL`000ooILP3ofW40omYa0003
om]b000gomab0?oKM03ofV`6omQGAOoFDeWoeeA@omUDA_oKDdOofEE:omE7<_oD@2?oe3dSomQ0;_oH
AS;oeT8[om<o8OoC@R3ogSdSon]2<oo/HfOoiVQMonEYE?oVJe[oiFULonAYFOoTJEOoi6UHonEZFOoT
JUSohVEGon9UF?oPH5gof5=NomMAG_oLF6;ogf1Ron5TG_oRIUcoi6UJonEYFooUJEgoiF]PonI]HooW
KfKoiVmWonE^H_oUK5coiFYJonAZGOoQJUcoh6]Hon5[EooSJeSohf]Gon=/E`02on=[F@2Fon=[EooS
JeWohF]Momi/FooNJe_ogVUIomeXFooNJ5Woh6UFon1XEooNIeSoffQIom]YF_oJJ5kofVQPom]XF_oK
IeKofVIIom]SGooHGf7ocEmPol9IIondA8?oVS]lohhlK_n=?FgoVSm]ojE0Konf?GKo`C]eokllM?o3
>WSo[DUXoj1HH_nNCW[oW4QooiU9O_nJB7coW4Qkoim8OOnRB7coY4Ukoj98NOnQBW?oVTQgohe0POnJ
AGcoZDa`oj]=Kon^CVoo/Dm`ojm?K_neBWKo`cn3oklmQoo4?XSoccn8olm0R?o1>h_o/CV;ok`nQ?o2
?h?o_Sj4okm0POnn?h7o]cinok4oN_nc?Wko^d5kolA3NOo6A7Soad=jolA4NonfCFoo/E=SojaFD_nJ
EU3oT5IEoi5GE?nGFD_oXei0ojYP>onYH3coYV4nojIU>onUI3[oXF4kojAP>?nVHCKoZ6<dojIR=?nO
GSSoWF0foj=U;ondFCGob4i1olM@?oo5DSgo`U4kokY???o5BTooh4UVoni=K_o`Cg3olTajoo=>QOod
DXWole>4oo=BP_ocDH?ole>5oo=FR_ocF8Woleb5ooAGS_oeB9gom46Roo93XOo`Aj?okDVWoni9[OoW
C:OofU2JomY?VOoEBYcocDJPolY5Woo:Aj3ocDVPom5;X_o>AiOocTV2om=;P?oEDGooeUmaomQVJ_oI
IF_oeV=/omARJooEIF_oeVE]om=QH_oAGUSodUiIom=NGoo?FW7oceQcomUU>?oPKACogfdG0_oNKAX0
1ooNK1WogF`Gomi/6ooQL2SoiWLbonQi=?oWMc<01?oVMS800ooVMS7oiWHconIf<P02onIf<P07onIg
<_oVMS;oiWHbonIf=?oVMS;oiWLbonIf<`02onIf<P0>onMf<_oWMc?oiWLaonIg<_oWMc?oigLeonMg
=?oWMc?oigHconMg=OoWMc?oigHconMg<ooWMS<4onMg<`03onMf<ooWMcCoigHc00?oigHb0_oWMS@2
onMg<`04onMf<_oXMS;oigHconQf<`;oigHb0ooWMS<2onMf=@;oigDe00KoigDhonIe=_oVMc3oigL`
onUe=?oYLcL5onUc>00LonUc=ooYLcWojG<ionUc>?oYLc[ojG<lonUc>ooYM3cojG@jonUd>OoYLcSo
jG<ionYd??oVKc7oiF/XonUb=?oZM3WojW8fonYc=_oZLcGojW<honYc>OoZLSWojW4ionY`>?oZKcOo
jVhjonY]>@;ojVhf00[ojVhgonY]>OoZKS[ojVhkonY^>OoZKbkoj70KonMa3ooVLPgoiG05oooTK`10
onA_0000CooTK`001?oj^U;oolaUooo<IOog[dD:onA_0004ooReC?ooc6GoolaUoo2H;0Goi6l000Co
l9P/ooo<IOooc6Gon;E<1?oTK`001?obWS?oolaUooo<IOo[QQT2onA_0004onMk3Oooc6GoolaUoog6
G`;oolaU00GojhHIonA_0?oTK`3oi6l0on^66@02ooo<I@03ooReC?oTK`3oi6l000Koi6l000ColYhc
ooo<IOooc6GolYhc2OoTK`001?oh]DcoolaUooo<IOo[QQT2onA_0004oo2H;?ooc6GoolaUooFY?`Co
i6l000ColYhcooo<IOooc6GolYhc2OoTK`001?obWS?oolaUooo<IOo[QQT2onA_0004onMk3Oooc6Go
olaUoog6G`;oolaU00KojhHIonA_0?oTK`3oi6l0onMk3OomaUl2ooo<I@03oo2H;?oTK`3oi6l000Oo
i6l000CojhHIooo<IOooc6Gon;E<4OoTK`001Oo^YF3oooooooooooooooookZEP00Koi6l000Coll2?
ooooooooooook9a@0_oTK`001?o/W53oooooooooooob]h02onA_0004oo?0SoooooooooooonbLD0;o
i6l000Cok9a@ooooooooooool[N00_oTK`001?oebIoooooooooooooVN102onA_0004onIh4?oooooo
oooooo[Tcccoi6l000_oiG43onQg2oo/OQGol8DNoo288Oo_QQookX@Moo257OocQQoomXHLooN:7P02
ooJ:7P0KooJ:8OofRb3omXLKooJ45oofPaSomX@JooJ67?ofRQkomX/NooJ:7_oeRAkomX/QooJ:6_o^
M`;okW<4onn35OoZRQ3ok8X:oo670_obQ03olh@0oo:30?oaP`3ol880oo210?o`PP3olX@000;olh@0
00colhD0ooB60?ofR@3ol8@0ommi0?oKN@3og7`0omai0?oLMP3og7D0omef0?oLM`05omaf00?ofgD0
02cofWD0omYd0?oJL`3ofW@0omUc0?oJLP3ofW@0omYc0OoDGR_odeURomAGF?oDEe3oeEM<omMIDOoB
DdGoc4P]olU49oo:@bcoc4<Wola78OoABRgoe4/nom=ACOoSD67oif1NonAZE?oUJEOoiVUHonIZF_oU
JEcoiFUIonAYF?oTJEWoiFYIonE[F?oUJeKoiFYGomeMFooHE5_ofE=LomYEHOoNGFKohF=Qon9WG0;o
i6YH01Woi6UHonAZG?oUJeooiVeQonI`J?oVL6KoiFeKonE/F_oTJe[ohVUJon5ZFOoQJU_ohfYIon=/
FOoSK5Sohf]Hon=ZFOoSJESohfUJon1ZGooMJU_ogVUGomeXFOoNIe[ogfQG00;oh6UG00OogFQIom]X
FooKJ5goffUOom]XFooJIeOofVIJ00;ofF=L08coffEOonQOL_o^FHSofdj6olA4OOn/?7OoUCMaohTg
L_nG=WCoYCMcojPiM?nk>7[o_Cadoj1:JOnJBg[oWdUloie;N?nNBG[oVdMnoiY8O_nNB7_oXDQjojA7
NOn[CVgoZU9Yoj5=L?nMB7GoXDUfojI:L_nUBg;oZ4]aojY=LOn_Cfoo_TMlolHoQ?o0?8SoaSf<om=0
R?o;?hOo/cV;okTmQoo1?hCo^Sb5okPmPOnm@7co_d9kol13Monk@W[o]D1joke2Moo4@WSobDAiol5<
M?nbD6WoVdiMoi1BDonAE4ooW5U9oj5MBOnSGdCoZV0lojYQ?OnTH3ooXf0loj9P>onOGc_oYElfojUP
<onWHcCoYV8eoimN=onOGCOoY64^ojmN<?o7DSoobTi3ol9??ongCCoo]4A<oli0IOoZAW?ol4eeoo1>
L_o`Bg7olD]foo5>N_obD83ole:3oo=BQ?ocDXKoleF7oo=IQoodFhSom5FAooE6W_od?Z?olDBSonm8
Z?o]BZ_ojdZ/oni9[?o]BZOogDfKomE:W?o?AJ7oc4JPolY8Woo<BYood4ZNomE:X?oJBiWodd^4omEC
NooGHFoof6IXomUUJooHHfcoe6=[omATJ_oEIF[oeFA/om=RK?oBGe_odemHomAPE_oAGFKodUeFomaZ
8_oNKA[ogF`Mome/6ooMK1Sog6`Homi^8?oTM2koj7PeonMh<ooVMc3oiWHaonIf<P;oiWHa00GoiWHb
onIf<ooVMS;oiWHbonIf<`02onIf<P06onIg<_oVMS?oiWHbonIf<_oWMcGoigLd0_oVMc<2onIf<P0<
onIg<ooWMc?oigLdonMg=?oWMc?oigHconMf=?oWMcCoigHbonMg<ooWMS;oigLc0_oWMS801?oWMc?o
igHbonMg<ooWMS<3onMf<P07onMg<ooXMS;oj7LconMf<ooWMcCoigLconMf<`02onMe=0KoigDe00So
igHconQf<?oXMbkoj7PXonMj9?oYN2WojGHbonUc>@CojG<h00?ojG@honUd>OoYLcT00_oYM3/2onUc
>`03onUc>_oYLcWojG<i00;ojG<h01CojG<ionQc>?oZMC_ojG<fon=Y9?oUJRWojW@gonYc=ooZLcKo
jW<gonYb=ooZLcSojW8jonYb>Oo[LC_ojVlionY_>?oZKcOojVhgonY]=P?ojVhg00SojVdhonY]>OoZ
KCgojVdionU_;?oXLQcoig8>onE_0_ooi6l0?ooTK`0004koi6l000Goig/=ooo<IOooc6GooLIOonIe
1P09onA_0004onMk3Oooc6GoolaUooc0F0Ooi6l000CooLIOooo<IOooc6GoiWD60ooTK`001?obWS?o
olaUooo<IOo[QQT2onA_0004oo>S>Oooc6GooLIOoo>S>@;oolaU00GojhHIonA_0?oTK`3oi6l0on^6
6@02ooo<I@03ooReC?oTK`3oi6l000Koi6l000ColYhcooo<IOooc6GolYhc2OoTK`001?oh]DcoolaU
ooo<IOo[QQT2onA_0004ooc0F?ooc6GoolaUon^66@Coi6l000ColYhcooo<IOooc6GolYhc2OoTK`00
1?obWS?oolaUooo<IOo[QQT2onA_0004oo>S>Oooc6GooLIOoo>S>@;oolaU00GojhHIonA_0?oTK`3o
i6l0onjB9P02ooo<I@03ooReC?oTK`3oi6l000Soi6l000CojhHIooo<IOooc6Gon;E<4_oTK`001Oo^
YF3oooooooooooooooookZEP00Goi6l000Con=^oooooooooooooiWP@0_oTK`001?oVN13ooooooooo
ooohfkl2onA_0004ooSK_oooooooooooonIh40;oi6l000CoiWP@oooooooooooon=^o0_oTK`000ooj
i<ooooooooooo`04onA_00?ooooo?_oTK`001OoUL0;oj7H9onao5Oo_QAkol8HO00;okhDN01oolHLO
ooB97oofRAgomXPNooJ:7ooeRR3omXXPooJ86oofQ1SomX<HooJ26?ofQ1_omXPNooJ;7_ofRQgomXXO
ooJ>8OoaO@[okG42oo1n4Oo/RQ;ojXT<oo271?obQ@3olX@0oo610?o`P@3olH40oo220?oaPP3olhH0
00;olX@000OolXD0ooJ90?obQ`3ohgd0omai0?oKN`3og7X000Cog7D02ooLMP02om]f00;ofWD001[o
fW@0omYe0?oIJQ7oeEUGom=HGooDF5GoeEQ>omEJC_oCEdcobTT_olU49?o9B2KodTa2omMBE?oGFUSo
fEUFomUIDooHEe;ofeYCon1PEooTIeWoiFUHonEZEOoUJE[oiFUKonEZF@;oi6YJ02GoiFYIonEZEooV
JeOohVAIomUIFOoIEUWofUEJomYFG_oLFFCogf1Ton5UGOoSJ5Soi6YFonAZEooTJUSoiF]KonE/GooV
KfOoiW1WonI^H?oUKUkoi6]Jon9YF_oOJ5cohFQMon=YG?oRJESohfUHon9YF?oRJ5WohfUGon=ZF_oN
JE[ogFUHomiYEooMIeWogVMI00;ogfUG07gogfQIomeXGOoKJEgoffYOom]XFooJIUSofVIJomUUFooH
I5OofV9RonQNNoo]GXGokUb4on]IO?oTE7WocTEkok51MonU>g?oV3Eboi0fK_nC=VkoXSIboiXlM_n>
AGgoUDEnoi]5N_nMAg_oWDQloie:NOnLB7[oWDMloie6NOnTC6ooZe5ZojaAJonZD6_oZ4i^ojU=L_n[
BgCoZTadojI:MOnUC77o[4Ufol90Poo9?HOo_cb7ol@lROo>@HKo^Sf8okTmR?nl?XOo/S^6okPoO?nn
A7Ko`D=jol12N_o1@gWo_dAgoki3MOo1@7So_4EgojU<KOnDBUooS4iDoi]HBOnTG47oYe`ooj=KA_nU
GdGoZ610oj5N@OnPGSgoXUdjoj1K>_nUGSKoYeldojIN=?nXH3?oYf0cojEP<onWI2oo[64[okeB??o4
BTOo/4M6ojDmD?nf>FGofcYjoo13O_o`C7Col4eboo1<LOoaBgColDefoo1=MOo`CW;olDmhoo=AP?od
EXWole^8oo=LQooeDiKomTBQooA0Y?o`AJGokDZZone:[?o]BJ[okTVZonm9Zoo_AZ_oh4JPom56W_o;
A:?obdRPolY:X?o=B:7oeTZMome>VooMCYSoeeIoomQRK?oIIVSofFEZomISK002omETJP0JomIUJooE
I6codf=]om=SKooEHVKoe5mJomAPEooBGUooef@Won9^1_oPKQ7ogF`Homa[6?oMK1[ogflVonIe<ooW
N3GoigLconIg<_oVMc?oiWHconIf<OoVMS?oiWLconIf<ooVMS82onIg<P09onIf<_oWMS?oiWHconIf
<ooVMcCoigLconMf=?oVMc?oigLc00GoiWHb00?oigLconMg=?oWMS800ooWMS<02OoWMc?oigHbonMg
<ooWMS;oigLbonMf<_oWMS?oigLconMf<`02onMf<P;oigHd01KoigHconMf=?oWMCGoigDeonMf=_oW
MCOoigDhonMe=_oWMCGoigDconMf<OoXMbooj7P/onQh:OoXN2Goj7TQonQi7?oWNAWoigTKonQi9_oY
MRkojGDd0_oYLcP2onUc>@?ojG@j00GojW@konUd?OoYLc_ojG<jonUc>@02onUc>00<onUc>OoYLcSo
jG<ionUc>OoYLc[ojG<ionYe>ooYM3[ohfTVon9X7?oVK2_ojW@h0_oZLcL01ooZLSOojW<fonYc>?oZ
LS_ojg4lonYa>?oZL3L00_oZKcP00ooZKSWojVhgonY^>002onY^=`07onY^=_oZKCSojVdkonY]>ooZ
KSWojW0_onM`403oonA_03ooi6l0001>onA_0004on^66Oooc6GoolaUooN_A@[oi6l000CojhHIooo<
IOooc6GomJTo1ooTK`001?oeZCooolaUooo<IOo[QQT3onA_0008oo:N<oooc6GoolaUon^66OoTK`3o
iWD6oog6Goooc6D2oo:N<`;oolaU00GojhHIonA_0?oTK`3oi6l0on^66@02ooo<I@03ooReC?oTK`3o
i6l000Koi6l000ColYhcooo<IOooc6GolYhc2OoTK`001_oh]DcoolaUooo<IOo[QQWoi6l0oo2H;0;o
olaU00?oo<1HonA_0?oTK`000ooTK`001?obWS?oolaUooo<IOobWS<9onA_0008oo:N<oooc6GoolaU
on^66OoTK`3oiWD6oog6Goooc6D2oo:N<`;oolaU00GojhHIonA_0?oTK`3oi6l0oo:N<`02ooo<I@03
oo2H;?oTK`3oi6l000Soi6l000CojhHIooo<IOooc6Gon;E<4ooTK`001Oo^YF3oooooooooooomm^oo
jHX`00Coi6l000?oo>gOooooooooool01?oTK`02ooooo`04ooc]gooTK`3oi6l0ooc]g`;ooooo1?oT
K`02ooooo`03ooc]gooTK`3oi6l000?ooooo00Coih4PonA_0?oTK`3oih4P0ooooom0onA_0005onEa
0_oXM`[ok7hDonn47?o`Qb000_o`QQl06?ocQb3omHTPooJ97_ofRAkomHXPooJ:7oofR1comXHIooJ2
6?ofPaSomX@JooJ77?ofRQgomXPMooJ>8oodQaKokG<1onig2_o]R1?ojXT=oo261OoaP`3olXD0oo63
00;ol80000?olH<0oo:30?obQ@000_obQ@001_ofR07omXT1onF00?oLNP3ofgX0omah00;og7D000?o
g7H0omae0?oLMP001OoLMP000ooLM@3og7H0omaf0004omaf000Momeg0?oLM`3og7L0om]f0?oLN@3o
fW<0om=I>?oCEUoodUIEom=HC?oEETGof5M>omEGD_oIDUWoeeAFomYHFOoJEeOofUY@omYJDOoJF5Ko
fEMGomUEF?oJEUSogUaIon=UG?oVJUWoiFYHonEXFooUJE/00ooUJU/03?oUJUOoiF]HonAYF?oLGEOo
f5QGomYHFOoKEe[ofeILom]GH_oMFfGogf9Oon9WF@?oi6YG09?oi6YHonE[GOoVKVGoiFiWonE/H_oU
JU[ohfUGon5XF?oPJ5[ohFMLon9WF_oRJ5WohVUGon9XF?oRJE[ohfYHon5YF?oOJ5WogVUGomeXEooM
IeWogVQIommYEooPJ5Ooh6YKomeYG_oKJV7ofVQNomYVF?oKIeSofVIIomQUF?oLHfCoj5enonQKQOoY
G7oojUYmon]JNOoZFG[oiUMnonQ@O_oKAgWoaT=aokHlL_nT=G?oS3Acog4gP_m`=hgoP3^8oh]0P?nA
A7koVDEmoie7O?nNB7[oWDQdoj1=K_nSD6goY4m^ojM?KOnYD6coZTm^oj]=LOn_CG7o/Decoja<LOnW
Bg;o[DIkok]0P_nn?h?o]Sf3ok`nQOnm?HSo_3j5ok<lQ?nb?X3o^45hokY3M_ni@GSo^T1kokU1NOng
@7[o/Smhojm0N_nL@WOoST]MoiQGBOnPFDCoYE]2ojAM@onSGT;oWee7oiiNB_nOG43oX5dkojMN=_nR
G3WoXedhojIN=OnTGCGoZElboj]Q<OnUGc?oYF4doj5Q;_nSDCKo/Si>ojDkD_n^>F3oeCUgonY2N_oa
@g_olDMioo5;Loo`Bg;ol4]doo5=MooaCWOolDefoo1?L_o`CG3ol51goo9HOOocFHOomDnEooE5Y?od
@ZOokdJXone:Z_o/BJ_okDR[one9ZOo]B:[okdFZoo11[_oR@Z_obTBTolQ8XOo>CIgocDNQomI7WOoN
CYWogdnGon1JT_oLIG_of6IVomQUJOoFHfd00_oEI6X05OoFIFcoeVE]omATK_oDHfkoeFA_omMUKooD
HEcodeiNom=OE_oNJQ3oi6l0on=_0_oSK`Cohg0;onEe8?oWN2ooigLconIf=?oUMSCoiWHdonEg<`02
onEg<P?oiWLc00CoigHbonIg<_oVMS;oiWHc0ooVMS403ooVMc7oiWLconIf<ooWMS;oiWLbonIg<ooW
MS;oiWHbonIg<_oVMc?oigLdonMg<ooWMc;oigLconMf<`02onMf<PCoigHd00SoigDeonMe=_oWMCGo
igHfonMe=ooVM3KoigDeonMf=P;oigHe01goigHconQf<OoXMbgoj7L/onQg:OoXN2Ooj7TTonQi8?oX
N1_oigPJonMi6OoWNAOoigPEonMh5?oWNASoj7TRonQf<_oYLS_ojG8jonUc>OoYLc[ojG@ionUd>_oZ
M3_ojG@jonUc>OoYM3[ojG<ionUc>P02onUc>@0@onUc>?oYLcWojG<ionUd>_oYLcWojG<honUc>OoX
LcWojG<honUd>_oYLS[ohfTUon9X6OoRJ1goifh_onYd>0;ojW<f00GojW8gonYb>_oZLSWojW8gonYb
>002onY`>@04onY_=oo[KccojfllonY^>0;ojVhi00SojVhhonY]=ooZKCSojVdhonY]>_o[KCkojW0b
onI`2oooi6l0?_oTK`0004koi6l000ColYhcooo<IOooc6GolYhc2_oTK`001?obWS?oolaUooo<IOob
WS<7onA_0004oo:N<oooc6GoolaUoo:N<`?oi6l000[olYhcooo<IOooc6GojhHIonA_0?obWS?oolaU
oog6GooVM@KolYhc0_ooc6D01Oo[QQWoi6l0onA_0?oTK`3ojhHI00;oolaU00?ooLIOooReC?oh]D`0
0_oh]D`01Oo^TRKoi6l0onA_0?oTK`3olYhc00;oolaU00?oo<1HooReC?oh]D`00_oh]D`00oo^TRKo
i6l0onA_0002onA_0003ooReC?ooc6GoolaU00GoolaU00?ok8`PonA_0?oTK`000ooTK`001?obWS?o
olaUooo<IOol`5P4ooReC003onjB9_oTK`3oi6l000;oi6l000[olYhcooo<IOooc6GojhHIonA_0?ob
WS?oolaUoog6GooVM@KolYhc0_ooc6D01Oo[QQWoi6l0onA_0?oTK`3on;E<00;oolaU00?ojhHIonA_
0?oTK`002?oTK`001?o[QQWoolaUooo<IOomaUl4ooReC003oo>S>OoTK`3oi6l000goi6l000GomLVO
ooooooooooooo>gOonIh4003onA_00?ooooo1?oTK`03ooooo`;oi6l00oooool4onA_00?ooooo0_oT
K`03ooooo`04oo:gP?oTK`3oi6l0oo?0S`;ooooo00?on=^oonA_0?oTK`00@?oTK`002_oUL@;oj7H9
onam4oo_Q1gol8HQonn57ooaQb3om8XRooJ97oofRQh2ooJ:7`0EooJ97_ofQAWomX<HooF46OofPaWo
mX@JooJ77?ofRQoomXhRoo1i1_o^L`GokX@Bon^:3_o`QPKolX@0oo630?o`O`3okWl0oo210?oaQ03o
lXD000;om8H000SomHH0ooJ80?oYPP7ogG`0om]j0?oLMP3ogGD0omae00?og7H000GogGD0omaf0?oL
MP3og7H0omae0004omaf0003om]g0?oKMP3og7L000;ofgH00ooLMP003_oKM`3og7T0omMS7?oIDUWo
fE9TomACH?oLF6?ogEIQomUFFooHFE?ofUU@om]HDooJEUSofeIH0_oJEeT04?oJF5SofUIJomYFF?oI
EUKofUQJon5PG?oUJEOoiFUIonEXFooUJ5SoiFQIonEYGOoUJU[oiFYGonE[FOoQHUT2omYIF00EomYI
FOoKEe[ofeMLomaFH_oMFVGogf1Qon9VFooTJUKoi6]FonA[F?oTJe[oiFaMonA^HooSK63oi6YNonAY
FooTJESohVUHon5XFOoRJEWohVQH00;ohVQI06GohVQJon=XF?oRJUOohFUGommYFOoMJESogFQGomiV
FooOJ5[ogfQHommZFOoOJUgogFQRomYYG_oJIeOoffIHomYVEOoGIUKogF5YonYNO_oZGHCoieUnonQG
O?oWEg[oieQjonIFP?o]EH;ol5Ufoo1IM?o^DWSohTafoli6K_nS@7OoOC^3ofleQom`=HKoLCF:og`h
Qon6?X3oS45loi51MonMC6koYU9ZojEAK?nTD6coXdm^ojM@K?nYD6coZTi_ojm=L_ndCg;o/Tm_oja?
KoneAgcobS^<olLmQonm?8[o]CJBokHiRoni>h;o]Sb3okPmQ?nm?X?o_Sf2okllPono?8Go`CZ5okI1
POnUC73oVE9GoieMAOnSH4;oXem3oj9NA?nOGTKoX656oimQAOnOGTGoXedjojUO=?nZGc?oY5`gojMM
=?nUGCCoZ5haojMM<onKFC[oTE@loheJ>_n4E3CoVCY;ol4bJ_oD>g?ojD9foo56Moo^@W_okD9joo18
Loo`BG;olDQdoo5:MP02oo5=N00Zoo1=MOo`C7CokdifonmEM_oaEG_olTR>oni2V?o/A9kokDNXone9
Zoo]BJWokDN[one7[?o]AZ_okdBZoni0[?oW?[7og42dola8Xoo=C9god4JPomE5X?oPD9Ooge6FommL
T?oSJH_ogfQoomQTK?oFHfgoeFA]omITK?oFI6goeVA/omESKOoDHg3oeF=/omIUKOoFI77oe61SoliJ
I?oIICoohVd70_oTK`002OoTK`;oiWL@onMk6OoXNagoj7XQonQj9_oWNBcoigL^onMf<@03onIf<`?o
iWHb00CoiGHbonEf<ooUMS?oiGDd0_oVMCD02?oVMSKoiWHeonIe=_oVMCOoiWHeonIf=?oVMSGoiWDf
0_oVMSH06OoVMS?oigHeonMf=ooWMSKoiWHeonIe<ooWMSGoigHdonMe<ooXMC7oj7HbonMg<OoXMboo
j7P]onQh;?oXN2Woj7PWonQi9ooXNBCoj7TQonQi8?oXNAooj7TMonMh6_oWN1P00_oWNAP01?oWNAOo
igPFonMh5ooWN1L2onMh5@03onMi6_oXNBGojGHb00;ojG8l00?ojG<konUd>_oZM3X00_oYM3/00ooY
M3WojG<ionUc>002onUd>006onUc>_oYLcSojG<honUc>OoYLc[ojG<i0ooYLcP01ooYLcWojG<honQc
>?oYLcSojG@konQa=_oSJB800_oRJ1`02ooSJAooj70conYe>?oZLSOojW4ionYb>?oZLcSojW8ionYa
>ooZLC[ojW0i00;ojVlj00?ojg0lonY_>ooZKSL00_oZKSP02?oZKSWojVhhonY^=ooZKSOojVhhon]]
@OoYKb_oi6l4oooTK`0monA_0000C_oTK`001?obWS?oolaUooo<IOobWS<:onA_0004oo:N<oooc6Go
olaUoo:N<`Ooi6l000ColYhcooo<IOooc6GolYhc0ooTK`002_obWS?oolaUooo<IOo[QQWoiWD6oog6
Goooc6GolYhconA_0?obWS<2ooo<I@05on^66OoTK`3oi6l0onA_0?o[QQT01oooc6D01OobWS?oi6l0
onA_0?oTK`3olYhc00OoolaU00?olYhconA_0?oTK`000_oTK`000ooh]DcoolaUooo<I@04ooo<I@03
ooZjD_o`V2coi6l000Coi6l000?olYhcooo<IOooc6D01Oooc6D00oobWS?oi6l0onA_0002onA_000:
oo:N<oooc6GoolaUon^66OoVM@KooLIOooo<IOobWS?oi6l0oo:N<`;oolaU00GojhHIonA_0?oTK`3o
i6l0ooReC002ooo<I@03on^66OoTK`3oi6l000Soi6l000?ojhHIooo<IOooc6D01Oooc6D00ooh]Dco
i6l0onA_000>onA_0004oo[Tcooooooooooooo:gP0?oi6l00oooool4onA_00?ooooo0_oTK`03oooo
o`Coi6l00oooool2onA_00Cooooo0_oji<l3ooooo`03onbLD?oTK`3oi6l004;oi6l000goi701onMe
2?o/OA?okX8Jonj47Oo`Qb7olXXRooF;8?ofRQoomXTNooJ:7oofRAkomX@I00;omX<H00oomX<IooJ4
6_ofQQ[omhdRooB34_o^LP?okh0@on^94?o^Q@OolH40onj00?o^O`3okh40oo:60?obQ@000_odQP02
ooJ60005onV20?oMO03ofgT0omaf0?oLM@000_oLMP000ooMM@3og7H0omaf0002omaf0004omae0?oL
MP3ofgH0omaf00;ofgL00_oKMP003_oLMP3ofgL0om]f0?oKMP3og7H0om]f0?oLMP3ofg@0omig0?oT
LQ_ogeQQom]BIOoFCeoof5AH0_oIEe@01OoIE5SofUIIomYGF?oJEUWofEEI00?ofUMG073ofEIHomYF
FOoJEUOof5EFomUEF?oNG5SohfEHonEXFOoUJ5SoiFMGonEWFooUJE_oiFUHonEZF?oTJ5SogE]HomUG
EooJFEOofUQHomYGF_oKEUcog5INomaGIOoMG6Goh6=Mon=YFOoTJUWoi6YGonAZFOoTK5gohf]Lon=[
G_oTJf3ohfYMon=YFOoQJ5WohFQJon=ZEooSJUSohfUHon9XFOoRJ5[ohVUJon5YF?oRJESoh6UJomeY
FOoMIeWogVMIommYEooOJ5[oh6YNomm[H?oMJEooffMHomYVEooJIEKof6IEon5PK?oZGh?ojUj5onQG
P?oWEGgoj5MjonIGN_oUE8;ojE66onaFNOo]FWOokeUkoo5JN?oaEWWoieM]ol]LGOngDfcoXTEmoh]0
O_mg>WooK3B4of`eQ_mb=X;oOCaioha1M?nGAg3oXDa[oj==J_nSCfcoYDm/ojI?K?nXCVoo[dibokA@
KonlCWGodTB7on8lUOoI?ICob3b@ojleUOnb=XoobC^:ol8hS_o8>hkoecn<omToS?oI@8_ofCn<omlm
TOoH?h[oYe=Hoj=Q@?nUHD7oX5i50_nPGTH0>_nQGdKoWee6ojAN?OnXGS[o[68joj]O<onWG3?oYE/e
oj5I=onJEc_oTE8loh5=@_mmCT7oPe8oohmH@?nfB5?ogCU`onloNooaAGOol4Aeone2N_o/@7gol4Eg
oo59LOo`B7?ol4Ueoo1<M_oaBWSolD]foo5:MOo`C7Kol59foo5?Ooo`A9;ojd:HonM5UOoVAi[okD^Y
onm9Z_o[AZ_okDF/onm4[?oa@j_okd2/onI1[_oK@;CofT>comI8Y_o?AZ3oeDBRome=V_oREi?ohV:>
on9YROoTJX[oh6F8omMTLooEI6`2omETJ`0HomITJooEI6[odf=/omASK?oEI6WoeFA]omETL?o?GVWo
cEaOon9/9?oTK`3oi6l2onEb2ooWNQ_ojG`TonUj9OoYNROojGXXonUj:OoYNB_ojWP^onYf<_oZMS7o
jGHa0_oYMS803?oXMc;oj7LconQe=?oWMS7oigL]onMh:ooWN2[oigP]onMh<OoWMbkoigP^onMh;@Co
igP/00?oj7P/onQh:_oXN2T00_oXNBX03?oXNBOoj7TVonQi9OoXNB?oj7TRonQi8OoXNAooj7TLonQi
7OoXNA_oigTJonMi6@;oigTH00OoigTIonMi5ooWN1OoigTGonMh5ooWN1KoigPG00;oigTH00SoigTI
onMi6_oWNAWoigPGonMh5_oWNAWoj7TTonUf=0;ojG8l00WojW<lonYd>_oYM3[ojW@ionUc>OoYM3[o
jG<jonUd>OoYLcT00_oYLcP4onUc>@03onUc>?oYLcWojG<h00;ojG<h01[ojG<ionUc>?oYLcSojG<i
onQb>OoZM3_oj74eon=Y8OoRJ1_ohfTMon9X6OoSJB7ojG4fon]e?OoZLSSojW8fonYb>Oo[LScojW8k
onYb>?oZL3[ojW0ionY`=ooZKcSojg0lonY_>0;ojVhf00SojVhhonY^=ooZKSWojVhionY^>?oZKS_o
jVdkonI_5?ooi6l0?OoTK`0004koi6l000Cok8`Pooo<IOooc6Golj<i2_oTK`001?o^TRKoolaUooo<
IOobWS<7onA_0004oo:N<oooc6GoolaUonjB9P?oi6l000[olYhcooo<IOooc6GojhHIoo:N<oooc6Go
oLIOonIe1_oTK`3olYhc0_ooc6D01Oo[QQWoi6l0onA_0?oTK`3ojhHI00;oolaU00?oo<1Hoo:N<oob
WS<00_obWS<01Oo[QQWoi6l0onA_0?oTK`3olYhc00;oolaU00?on;E<oo:N<oobWS<00_obWS<00oo[
QQWoi6l0onA_0002onA_0007ooReC?ooc6GoolaUoo2H;?o[QQWok8`PooReC002ooo<I@03oo>S>OoT
K`3oi6l000;oi6l000ColYhcooo<IOooc6Gon;E<1?obWS<00oo[QQWoi6l0onA_0002onA_000:oo:N
<oooc6GoolaUon^66OobWS?oolaUoog6GooVM@Koi6l0oo:N<`;oolaU00GojhHIonA_0?oTK`3oi6l0
oo>S>@02ooo<I@03onb<8?oTK`3oi6l000Soi6l000CojhHIooo<IOooc6Goo<1H1?obWS<00oo^TRKo
i6l0onA_000>onA_0005onV:<?oooooooooooogfkooVN1000_oTK`000oomm^ooooooooooo`04onA_
00?ooooo0_oTK`000oomm^ooooooooooo`04onA_00?ooooo0_oTK`001?oji<oooooooo[Tcoohfkl4
ooooo`03oo?0SooTK`3oi6l004Goi6l000goiG02onMf2Oo[O1;okX<Koo288_oaRRCom8`SooJ:7oof
RAkomXXOooJ87_ofQa[omX<H00;omX<I01?omX<HooJ66oofR1[ol7H4onmj2_o[R13okHP6onn10?o^
P@3ol8<0oo:60?oeR03om8L0ooB60?ofQ`7omXL0onV20?oLN`3ofgP000Cog7H00_oMM@03omaf0008
omag0?oLMP3og7H0omag0?oLMP3ofgH0omaf0?oKMP02om]g000Com]f0?oLMP3ogGD0omid0?oOL`3o
hG80on9`0?oSL03oi704om]QBooDDUWoeU=IomI@G_oHE5[ofUIIomUEFooIEEWofEIHomUFE`02omUE
F0;ofUMG0<?ofEMGomUEFOoIEEWofUMFomUFE_oGE5WogEYGon=RF?oUIeWoiFUGonEWF?oUJ5[oiFQH
onEYEooUJeSohF5IomQGEooIEeOofUQGomUHF?oIEeSofeMIomeGGOoMEf;og5QWommOH_oSIeWoi6UF
onAZEooSJEWohfYJon9ZFOoSK5kohfaRon=ZG?oSJESohVMJon5UFooRJUSohfYGon=YF?oRJEOohfUJ
on5XFooQJEOohFQHommWG?oMJ5_ogFQGommXEooOJ5Woh6UNon1/HOoOJeoog6MJomYVF?oIIEKofFIG
onAQL?oZG8WojE^5onUGOOoYEGgoj5IlonEGN?oUDhGoje29onYDN_o[EWWok5Enon]DOOo/E7gokUQl
on5VJOoNKFgogVmiomA^L?o4I7;o[EMioiM=OOn1AgcoM4Qlog58POmhAWgoPdEjoh]6M_nDAg3oVTY]
oi]:K_nJB73oVdM`oj58LOno@GoofSVAom0hTOo6>8ko`cZ8olDmQOnm>hOobcf8olLkR_o7>H_oeCf:
oma0S?oJ@8_og3fAom/lS?oD@6oo/E5:oj=P?_nQGd?oX5e2oj5M@_nRGdCoX5e3oj9I?OnYFcOo[5hd
ojQO>_nQFcOoVELgoh]A?_mmBT?oMDM3ogi>@OnEFSgoZEdlokMO@?o@EeCol4Aboo50N?oa@gSokd9i
on]1NOoZ@G[okd=ioo57L_oaB7;ol4Ueonm;MOoaC7OolDYgoo19M?o`C7GolDmgoo1:Ooo^?i;ojD:N
onI8V_oVAiWojdZTone9[Oo]A:kokT>^oo13[Ooa@ZcokD6/onE0[_oM@[?ofD>don52/OoS?jooedFQ
omQ<W?oPF9CohVB=on9ZR_oRJH[ohVJ:ommVRooGIG?oeFAXomETJ_oEI6_oeF=YomASJOoCHfcoe6=Z
omIUK_oEI7;oe6=bolmNL_oHH5ooif`PonE^2_oWKQ_ojGL[onYi<_oZMc?ojWHdonYg<_oZMc7ojWPb
onYh<ooZN3800ooZN343onYh<006onYh<OoZMc;ojWP_onUh:_oYNRWoj7XP0_oWNAT01_oWNA[oigXL
onMi6_oWNAWoigXKonMi6P;oigXK00?oigPHonMi6?oWNQX00ooWNAP01ooWN1KoigTGonMi6?oWNAWo
igTGonMh5_oWNAL00_oWN1L6onMi60?oigTI0ooWNAX02OoWNAWoigPGonMi5ooWNA[oj7TUonUg<ooZ
M3_ojW8monYc>`02onYd>P03onYd>ooZLc_ojG<i00;ojW@i00?ojG<ionUc>?oYLcP00_oYLcP00ooY
Lc[ojG<honUc>@06onUc>00?onQc>OoYLcSojG<honQc>OoYLcSojWDlonM`=?oSJB7ohVPLon9X7ooR
Ib7ohVLOonAY9ooYLSKojWDi00;ojW8h00CojW8gonYb>_oZLSWojW4h0_oZLCL01ooZL3SojW0kon]`
??oZKcSojVlgonY^>?oZKSL00_oZKSX01OoZKSWojVhhon]^?_oXKRSoi6l20?ooi6l0??oTK`0004ko
i6l000CojH4Cooo<IOooc6Goo<1H2_oTK`001?o[QQWoolaUooo<IOoj^U87onA_0004ooZjD_ooc6Go
olaUon^66@?oi6l000OolYhcooo<IOooc6Gok8`Poog6Goooc6GomJTo00;oi6l000ColYhcooo<IOoo
c6GojhHI0ooTK`001?o[QQWoolaUooo<IOoh]D`8onA_0004oo:N<oooc6GoolaUoo:N<`Woi6l000Co
n;E<ooo<IOooc6GojhHI0ooTK`001?ol`5SoolaUooo<IOoVM@H3onA_0004oo:N<oooc6GoolaUoo:N
<`Woi6l000OolYhcooo<IOooc6Gok8`Poog6Goooc6GomJTo00;oi6l000ColYhcooo<IOooc6GojhHI
0ooTK`001?o`V2coolaUooo<IOoeZCl:onA_0004on^66Oooc6GoolaUooReC1Koi6l000Comm:_oooo
ooooooooji=00_oTK`000oohfkooooooooooo`04onA_00;ooooo00Con=^oonA_0?oTK`3on=^o0_oo
ool4onA_00;ooooo00_on=^oonA_0?oTK`3omm:_ooooooomm^ooi6l0onbLD?ob]h3ol:i`onN1801:
onA_0008onA`0OoWM0Oojg`Bonn57Oo`RB;olXXSooF:8OofRAh2ooJ:7`03ooJ76_ofPaSomX<I00;o
mX<I00GomXHKoo9k1oo_M0GokH@?onj:1`02oo230009oo640?ocQP3om8P0ooB70?ofQ`3omXP1onN2
0OoLN`3ofgL000;ogGH00ooLMP02omee0003omaf0?oMM@3og7H000;ofgL000Gog7H0omag0?oKM`3o
fgP0om]g0002omaf0005omee0?oNM03oh780on9a0?oSL0001OoTK`003?oQJSkoe4mOomMCG?oFDUko
ee=LomUEF?oJEESofUAJomYFFOoJEeSofUIHomQDF@;ofEIH01?ofUIGomUFF?oIEEWofUIHomYGEooI
EEOof5AGom]GF?oOGE[oiFMJonIZEooUJ5WoiFMIonEXEooUJUOoi6IIomaJF?oIEeOofUQG00;ofEQG
01OofUQHom]GFOoMF5_ogEMRomaGIooNG6?ohFAJonAZE_oTJeGohfUIon9YF?oRJUWohfaOon=]HOoS
JekohfUJommQGOoNHE[ohVUHon9ZF?oRJEOohfYGon9YF@02on5XF@1non5XF?oOJ5_og6MLomiWF_oO
JEKogfYKomm[H_oOJeoogVQJomaUF_oIIUOoffEMonQQMOo[FXCoieJ2onUFO_oYEWgojEMlonMHNooU
EH?oje29onYBPOo/EWookEIlonaEMoo/F7kolEfBonEWRooFKWgoefilomU_M_oLL7;og79bomMbM?oB
KgGobW1fok1/M_nHHW[oRE^0oh=FQ?n6EH?oTUUjoiIIM_nGEgCoU5IeoiICM?nbBX3ocd6@olY3R_o@
@hSoeTJ5omU8Q_o;@h_odTB9om=5R?o<@HcoeD6?onE4UOoSA9;ogD>7om19JooABeWo_U5;ojEN@?nR
GTCoYV10ojEO@?nRGD3oXeXkojUK=OnXFSCoX5LhohmB@On6D4?oRE0ooi1C@onKE4KoZeU7okeP?oo<
HT3ocUm8om1IC_oWBFWolCmionm0N_oa?gcol45lon/oOOo/@W[ol4Eeoo58LOoaB7Col4]eoo1<M?oa
BWSolDYeoo1;M?o`CgKokdV2ondoUOoZ@9coj4RHonE7UooYBJ;okTR]oni4[_o`@jkolD:/oo91Zoo^
@Jcohd6`oma2/_oLA;;ohD:aonTn/_o`@JoohDbOom]HU?oRIHcoi6V:on=XRooQIX[ogfJ:ommWR_oH
IGSoeF=W0_oEI6T03OoCHfcoe69aomISM?oII7GofV=iomQQO?oJHWkoe5j2on=RF_oWJacoj6lQonYg
<_oZN3@00_oZMc800ooZN3;ojWP`onYg<@02onYg<@GojWP`0_oZN342onYh<006onYh<OoZN3;ojWPa
onYi;ooYNRGoigTJ0_oWNAD00ooWNAKoigTGonMj6@02onMj6@04onMi6?oWNQWoigXIonMj6PGoigTI
00CoigTHonMi6OoWNAWoigTI0_oWNAP3onMi6@;oigTH0_oWNAT2onMi6P?oigTI00koigTHonMh5OoW
NAOoj7XTonUg=OoYLcgojW<lonYc>ooZM3[ojG@jonYc>ooZM3WojG@ionUc>P;ojG@h00?ojG<ionUc
>?oYLcP00_oYLcP2onUc>@03onUc>?oYLcWojG<h00CojG<h00?ojG<ionUc>?oXLcP00_oXLST03?oX
LcSojWDlonM`=OoSJB3ohVPMon9X8?oRIb?ohVPOon9X7?oTJROojW8ionYd>PGojW8g00WojW4gonY`
>_oZL3WojW0jon]`>ooZL3[ojVljonY_>OoZKSP00_oZKST01OoZKSSojVhgonY^>ooZKcSoiVl@0?oo
i6l0??oTK`0004ooi6l000Coo<1Hooo<IOooc6Gok8`P2_oTK`001?omaUooolaUooo<IOoWN`d5onA_
0004onMk3Oooc6GoolaUoog6G`Coi6l000ColYhcooo<IOooc6Gon;E<0_ooc6D01?oWN`goi6l0onA_
0?obWS<2ooo<I@05on^66OoTK`3oi6l0onA_0?o[QQT00_ooc6D00ooh]Dcoi6l0onA_0006onA_0004
oo:N<oooc6GoolaUoo:N<`Woi6l000Con;E<ooo<IOooc6GojhHI0ooTK`001?oh]DcoolaUooo<IOo[
QQT3onA_0004oo:N<oooc6GoolaUoo:N<`Woi6l000ColYhcooo<IOooc6Gon;E<0_ooc6D01?oWN`go
i6l0onA_0?obWS<2ooo<I@05on^66OoTK`3oi6l0onA_0?oWN`d00_ooc6D00oomaUooig/=onA_0008
onA_0004on^66Oooc6GoolaUooReC1Koi6l000Col[N0ooooooooooool[N00_oTK`001?oebIoooooo
oooooooYRS02onA_0004onV:<?ooooooooooooG9W`;oi6l000ComLVOoooooooooooojHX`0_oTK`00
1?oYRS3ooooooooooooebIl2onA_0004oo2^L?ooooooooooon^C@53oi6l001goiG01onMd2?o[NQ7o
kH4Joo288_odSBGomX/PooJ:7_ofRAkomXHJooJ36OofPaSomX<IooJ67OoeP@gol784on]k4?o^R`Wo
lHD0onn30?o`Q03olXH0ooB60?oeQP3om8D1onJ20OoKNP3ofgH0omef0004omaf00;ogGD000CofgH0
omaf0?oLMP3og7L00_oKM`001ooJN03ofgL0omaf0?oMM@3ogW@0on1b0?oQL@000_oSL008onA_0004
onE^:?oHEE_of5EIomQEFP;of5II00KofEEHomQDFOoIDe[ofUIIom]GEooIEUP2omUEF00ComUDFOoJ
EUSofEEHomUEF?oJEeOofUIGomUEF?oHEEOof5EFomaIFooSHeWoiFUJonEXF_oTIeOoiFUGonEXF?oO
GU[ofEIIomYHF002omYHE`;ofEQG017ofUQHomaHFooNF63og5IUom]HIOoPH5oohfMHon=ZF?oRJESo
hVUGon9ZFOoSJecohfaPonA/HOoQIekofeYJomaOF002on5YF00Ron9XF?oRJESohFQKon5YFOoQJEKo
hFQIommXFooMJ5_ogfQHon1ZF?oOJf?ogfYQommYG?oNIUcofVEJomaTG_oZGWGoje]nonMFO_oWEGko
jEF1onYGOooWFGoojEJ0oneCQ?oYDHKok5>3oneDNoo[EGSokUn:ooATVOo^I9;ofVYlomEZM`;oe6Yf
06koeV]gomM[MooKJg?ohVaeom]YN_oCIggod6N3olAVQon`HhcoX5j=oimPR_nTIXGoZF^1ojiZPOo3
GXcodU:JomUGUooUFYGoj5^FonQNUOoPF9[oi5VIoniJU_o]EY_ok5NHonaDT_oXDX_oh59komECIooI
DVGoeUEUokEOE?niHeCo]f9DojmMDon_EeKo/UIFok9EEon_DEcoYTaNojQ<H_nkE67oa5QFolQMC_o>
GT_odUe:oliHC_o<EE3oaEM?omA?G_o_@G?ol3mionloNooa@7_ol3moona0O_o_A7OolDMboo58MOoa
BWKol4edoo5;M_oaBGSol4acoo1>MOo_B8Oojd6GonU1VooXAYWoi4JFonE7Uoo]AZOol42_oo11Zoob
AJ_olT:/one0[OoR@K3og4Baomm7/?oT@K;ojSbboo12[oodBZgoj5RLommUROoRJ8WohfN:on5VROoN
IXOogFN6omiWR?oJIWkoeVAZomITKOoFHWCoef9jom]ROOoMHWoofV5oomUQOooJHWkofV:1omQNO_oV
ISooiflMonYg;_oZNC7ojWP`onYh<@;ojWP`00?ojWPaonYh<?oZN3001?oZN3000ooZN37ojWLaonYh
<P02onYh<@09onYh<_oZN3?ojWLbonYg<OoZN3?ojWPbonYi;ooYNRKoj7XM00;oigTG0_oWNQ/01_oW
NQ[oigXKonMj7?oWNAWoigXJonMj6`;oigTJ0_oWNAT00ooWNQ[oigTIonMi6@03onMi6006onMi6OoW
NASoigTHonMi6_oWNAWoigTJ0ooWNAT04OoWNA[oigTIonMi5ooWNAOoj7XOonUh;OoYM3[ojG4oonYc
>ooYLc[ojG<konYc>OoYM3[ojG<honUd>?oYLcSojG<i00;ojG<h00?ojG<ionUc>?oYLcP00_oYLcP0
1?oYLcWojG<honUc>?oYLcT3onUc>00FonUc>OoXLcWoj7<ionUc>OoYLc_ojG<jonQc>OoYLcWojWHl
onM_<_oSJ1oohVPPon9X8_oRJ23ohfTNon9X7ooRJ1goi6XWonYb=ooZM3SojW8eonYb=P?ojW8j00Ko
jW4jonY`>OoZL3SojW0ion]`>ooZL3X2onY_>008onY_=ooZKcKojVlhonY_=_oZKcGojfhoonQ_9_oT
K`;oonA_03_oi6l0001?onA_0005onjB9_ooc6GoolaUoog6GooYPA<02OoTK`001OocXcWoolaUooo<
IOoj^U;oiWD600?oi6l000GoiWD6ooZjD_ooc6GoolaUoo:N<`04onA_0003oo:N<oooc6GoolaU00;o
olaU00GomJToonA_0?oTK`3oi6l0oo:N<`02ooo<I@05on^66OoTK`3oi6l0onA_0?o[QQT00_ooc6D0
0ooh]Dcoi6l0onA_0006onA_0004oo:N<oooc6GoolaUoo:N<`Woi6l000Con;E<ooo<IOooc6GojhHI
0_oTK`001OoVM@KooLIOooo<IOooc6GojH4C00?oi6l000ColYhcooo<IOooc6GolYhc2OoTK`000oob
WS?oolaUooo<I@02ooo<I@05ooFY?ooTK`3oi6l0onA_0?obWS<00_ooc6D00oo[QQWoi6l0onA_0002
onA_0005ooFY?oooc6GoolaUooZjD_oVM@H02?oTK`001?o[QQWoolaUooo<IOoh]D`@onA_00;oih4P
1?oTK`001?oebIooooooooooooo`[W02onA_0004onjUH?oooooooooooo:gP0;oi6l000Col[N0oooo
ooooooookZEP0_oTK`001?o^YF3oooooooooooob]h02onA_0004oo:gP?ooooooooooonjUH0;oi6l0
00CoiWP@oooooooooooon^C?D_oTK`006OoUL07oig<7onYi4?o_PagolhhSooF@8_ogS1oomhTNooJ7
7?ofQ1WomH<HooJ57OofQAColG<4onYa5Oo]R@colHP0oo250?oaQ@3olXH0ooJ70?odQ`3oi7l0om]j
0?oKMP000_oMM@02omaf00;og7D000Cog7H0om]f0?oKM`3ofWP00_oKM`001OoKMP3og7D0omid0?oP
L`3ohG4000;ohg003?oTK`001OoULQ;ogEaComQEFOoHEEWofEMG00;ofEIH00KofEMGomQDFOoIE5So
fUEIomYFF?oIEEX2omUEF@;ofEAI00_of5AIomUFF?oJEeOofEIGomUEF?oIEUKoee=IomYEF_oQH5Wo
i6MJonEXF002onEYE`03on9SFOoJEeWofEMG00CofUQH00WofEQGomYGFOoLEecogEQNomaFI?oJEFSo
gEeRon9VFooSJUP00_oRJEL0POoRJEGohf]Ion=/H?oTKF7oh6AQomQGFOoKGUKoh6MHon5ZEooQJESo
h6UJon5XF?oQJ5WohFUHon5YEooOJ5WogVQKommXFOoPK6;ogf]UomiYH?oNIecog6EFommOHOoZFgSo
k5ekonUHNooXEG_ojEJ1onYFPooXF7oojeN1oneCQooZDHCojU20oniBNoo]Eh?okV:DonmSV?oaH9Co
hVR1omM/MOoFK7OoeFaeomI[M_oDJgGoef]_omiZLooMJGSog6QgomiYM_oMJ7Wof6EmoliNROo1E9Go
]e2Nok5=X_nbB:Wo`d2folHm^_o9@KSocDFdom98]_oKC[GogTnfoma?]_oQDK;ohdnhonA@/OoVFXKo
c4^0ok`iTOo1?8koaSfBol<oSonUAgcoVdIeoiU0NOnO?G_oY3akojTmP_nd@g[o^dMdol5<K?o8D6?o
cEAOom1EEoo<EE;obUI?olECD_o7DEGo`eI?olUED_oYAfoolCmjoo0oNoo`@GWol45jone0O_o/@gSo
l4Iaoo57MOoaBGWolDaeoo1<Loo`BWGol4acoo5<N?o^B8[ojT:JonQ1VooU@YSohTBJonA6U_oXAYSo
kCjZoo10/?o`@j_olD:/ona2[_oP@K7og4Faomm7[ooV@;7ojcb`onm2[OocCZKoleVSonmRVP02on9X
R00JomiVQooLIXGogFN6omiVR?oPIXgogfF<omURO?oIHGcoff9oomaRO_oKHGkofF20omUPOooJHWgo
ff=momQQP?oMGg7oj6lbonUg:?oZNS?ojWPaonYh<_oZN37ojWPbonYg<_oZMc42onYh<@05onYh<?oZ
N37ojWPaonYg<OoZN3801OoZN3403?oZN2oojWP^onYh;ooZN3;ojWPconYh<_oZMc;ojWP_onUj9ooX
NQcoigTFonMj6@;oig/K00KoigXKonMj6_oWNQ[oigXKonMi6OoWNAX2onMi6@07onMi6_oWNAWoigTH
onMi6OoWNA[oigTIonMi6003onMi6P03onMi6OoWN1SoigTI00;oigTJ00SoigTHonMh5OoXNQgojGTZ
onUe>?oYLScojG8konUc>P;ojG<h00?ojG<jonUc>?oYLcP00ooYLcP2onUc>@;ojG<h0_oYLcT01_oY
LcSojG<ionUc>_oYLcWojG<konUc?0?ojG<j00GojG<lonUc>ooYLc[ojG<ionUc>P02onUd>@06onUd
>?oZMC[oiF`[on9W7ooRJ27ohfPN0_oRJ2003_oSJ23ohVTMon9X7?oTJROojG4gonYd>_oZLSSojW4i
onYb>_oZLSWojW4honYa>OoZLCSojW0h0_oZLCX00ooZL3OojW0fonY_=`02onY_=P05onY_>?oZKSOo
jfhnonY`<_oUL0D0oooTK`0konA_0000D?oTK`002_og[dGoolaUooo<IOooc6GomJToonjB9_o[QQWo
kY8VooFY?oobWS<3onA_0009onIe1_ol`5SoolaUooo<IOol`5Sol9P/on^66Oo`V2coo<1H00;oolaU
00?on[YBonIe1_oTK`000ooTK`000oobWS?oolaUooo<I@02ooo<I@05onMk3OoTK`3oi6l0onA_0?ob
WS<00_ooc6D01Oo[QQWoi6l0onA_0?oTK`3ojhHI00;oolaU00?oo<1Hoo:N<oobWS<00_obWS<01Oo^
TRKoi6l0onA_0?oTK`3olYhc00;oolaU00?on;E<oo:N<oobWS<00oobWS<4onA_0007ooReC?ooc6Go
olaUooFY?oobWS?omJTooog6G`02ooo<I@03ooc0F?oTK`3oi6l000;oi6l000ColYhcooo<IOooc6Go
n;E<1OobWS<4onA_0003oo:N<oooc6GoolaU00;oolaU00Goig/=onA_0?oTK`3oi6l0oo:N<`02ooo<
I@03on^66OoTK`3oi6l000;oi6l000_oiWD6ooc0F?ooc6GoolaUoog6GoocXcWok8`Pon^66Oo`V2co
n;E<on^66@02onA_0004on^66Oooc6GoolaUooc0F0GolYhc00?oig/=onA_0?oTK`002?oTK`001_o[
Td3oooooooG9Woo^YF3ok9a@ooG9W`?ooooo00Ooih4PonA_0?oTK`3oi6l0ooc]gooooooooOK_00;o
k9a@00CooOK_ooooooomm^ooiWP@0ooTK`000oolkMoooooooogfk`02onbLD004oogfkooooooooOK_
onIh40?oi6l000Soll2?oooooooooooon^C?onjUH?o[Td3ol:i`oo[Tcdooi6l001Koi6l1onMb1_o[
Ma;ol88Poo>=8oofT1oomh`NooN66oofPQSomX8JooJ76OobNPKok6XDon^04oo]R`3olHL0oo:;0?od
R`3okhP0on9o0?oJM`3ofgH01?oLMP003?oLM`3ofgP0om]h0?oKN03ofgT0omYh0?oKMP3ogW@0ommc
0?oPLP3ohW40on=`013oi6l000Goi705on1TAooGDe_of5IHomMEF@02omUFF0;ofEMG00Oof5IHomUF
EooJEESofUEIomYFFOoJEUSofEIH00;ofEEH00oof5AIomUEF?oIEUSofEEIomYFF?oJEUOof5=IomUE
F?oNFe[ohf=JonEXF?oUJEOoiFMGomiLEooHEEL00_oJF5P06OoJFESofUQHomUGF?oJEeWofEMHom]H
F?oNFEcogEQRom]GJ?oMGFCoh6EIon9YF?oSJESohVQIon=YEooRJUOohfaLonA^IOoMHFGoeUIHom]M
E_oOIEOoh6UHon1YF_oOIeT00_oPJ5P07OoQJESohFUFommXF_oNIUgogfYRomm]IOoNJV;ogFEJomaS
D_oTGfCokEajon]LMooZFWOojUMlonUIO?oYEh3ojEQnonaGPoo]DXWoje60onY@O?o]Dh3ol5j>onmS
Uoo]HYGolEnConUSR_oIJgKoeF]h00;oeF]f03Woe6YfomIZL_oLJGGofVMkomMUN_oGIW[ofFMiom]X
M_oKJ7SofFEkomIRPOo?GXOocE>HomM2/_o;>K[o`3Bmol8`__nn<<7o`3;5ol4e`oo0=/GocC[6ol/d
aoo?>[cogf1loki7Q_nP8ZOoZRZOojL[WonX;9ooVC:?oi8cQOnM=H3oZCajoj/oLondA6co_T]Pol=@
FOo8E5?oae=Bol9@Eoo8DUSoae1DolEADoo6DUCob5ABolAIC?oMCFColD9foo4oO?o`@G[okd5jone0
N_o^@7gol4Adoo16LOoaBGH00_oaC7H0:?o`Bg?ol4acoo1;OOo]B8oojD:LonI1WOoU@9Oohd2FonA6
VOoWAISoicZRon/m[_o_A:colD>/ona2[_oO@K?og4Fbon55/?oW?[7okCbaoo16Z_obDZ?olejMoo9R
WOocHIgoiVB?omiVR?oPIXcohFJ<on9UT_oSI9Cohf>GonASV_oMHXSoff9momaROOoKHWkofF5oomUQ
O_oJHWd2om]RO@0;omENPOoSJ6WojWHconYh;?oZMboojWL^onYh;ooZN2kojWP_onUg;OoYN2`00ooY
N2d00ooYN2kojGL]onUh;@02onUg:`0EonUf:_oYMb_ojGLZonUf:?oYMR_ojGH/onUe:ooYMR[ojGHX
onUf:OoYMR_ojWHaonYf<_oYN2SoigLGonIg4_oWN1GoigTHonMi6OoWNa_oigXK00?oigXJ00OoigTI
onMj6_oWNAWoigTHonMi6OoWNA[oigTI00OoigTJ00SoigXKonMi6?oWNAOoigTIonQi9?oYMSCojG8l
onUb>`SojG<h00[ojG@ionUc>?oYM3SojW@jonUc>OoZM3WojW@konUd>_oZM3[ojW@k0_oYLc/01?oY
LcWojG<konUc>_oYLcX3onUc>@KojG<h00GojW@ionQb=ooSJBKohVPMon9X8002on9X8@;ohVPP00Ko
hfTNon9X7_oRJ1ooi6TXonUa=ooZM3T2onYb=`04onYb>OoZLS[ojW8ionYa>0;ojW4g00_ojW4honY`
=ooZKcGojVlhonY_>OoZKSSojVlionY_=ooZKc[ojW4donEa1`3oonA_03_oi6l0001AonA_0003oo>S
>Oooc6GoolaU00GoolaU00?olYhconA_0?oTK`000_oTK`000ooWN`gon[YBooo<I@06ooo<I@03ooZj
D_oVM@Koi6l000Coi6l000GolYhcooo<IOooc6GoolaUooFY?`04onA_0004oo:N<oooc6GoolaUon^6
6@?oi6l000?ojhHIooo<IOooc6D01Oooc6D01Ooh]Dcoi6l0onA_0?oTK`3olYhc00SoolaU1?oTK`00
0ooh]DcoolaUooo<I@05ooo<I@03oog6GooYPA?oi6l000?oi6l000?olYhcooo<IOooc6D01_ooc6D4
onA_0005oo:N<oooc6GoolaUooo<IOoeZCl01?oTK`001?obWS?oolaUooo<IOo[QQT5onA_0003onIe
1_oh]DcoolaU00KoolaU00CojhHIonA_0?oTK`3ojhHI2?ooc6D00oo[QQWoi6l0onA_0008onA_0003
onbLD?oooooooooo00Gooooo00?oll2?onA_0?oTK`000_oTK`000oo[Td3oooooooooo`04ooooo`03
onbLD?oTK`3oi6l000;oi6l000?oji=0ooooooooool01?ooool00oo/W53oi6l0onA_0003onA_0003
ooG9Wooooooooooo00Cooooo00?oiWP@onA_0?oTK`00C_oTK`008?oUK`7oig49onYg4oo_P1oomHlQ
ooRA7OogR1WomXLIooF;6OocQ0col6THoni[8?obL`ComW83ooN10oodRP7ohX@0omUh0?oJMP3og7H0
om]f0?oKM`3ofGP0omYj0?oJN@3og7L0omae0?oMLP3ogfh0on1^0OoRL@3ohg005?oTK`001OoTK`7o
iG4bomEAGooIEUOof5EI00?ofEIH0_oIEeL02_oHEUSofEIHomYFEooJEUOofeIHom]GF?oJEeOofUIH
omUFEooHEEP2omUFF003omQDFOoJEUOofEEI00;of5=J09WofeMJon1PF_oUIeOoiFYGon9SF?oJEUSo
fEMGomYHEooKF5SofUQIomYHF?oJFEWofUUGomYHEooJF5SogEUJommJHOoNF6KofUUSomeQFooRJ5So
hVQLon9WFooQIeSohVQGon9[FooTKFSofeiWomIFG?oIFE[ogV=Hon5ZFOoOJEWoh6QHommYEooPJEOo
h6QHon5XFOoOIecogVUSomm[I_oNIEoogF9HomaRE?oXGf_olEelonaLMoo[G7OojUUionUIN_oYF7go
j5MooniFQoo_DhKoje5oon]@OOo/Eh[ol6BFoo1RT_o`HI3okf6AoniRSooNJW_oe6aeomE[NOoCJ7[o
d6ImomAVMooJIgOoffQjomYWNOoKJGWoffYhom]ZM_oLJgKog6]come/LOoMKfkoiFQkoo9KSoo]EIOo
iU6MonE:X_oSAZWoed6bolTi]oo0<[ooccC1ol`__ooE?JcohF5bolm?S_nV::ko/bbJol<aUooI=Y;o
adIiol5>I?o3DE_oaE9Fol5@E?o4DU7oaU9Eol9@Eoo5DUGo`e5Gol9?Eoo8DeWobE9FolMADoo8D5Oo
aU=ColmBFOo^AW7olD5gonloNoo_@7[okT5jone0Nooa@WWolDAcoo57M?oaBgKol4eeoo1<LOoaC7;o
lTR6on]4V?oV@IgoiSjMonHmV_oW@9CoiTBFonE4W?oS>:3oiCZVonm5[?oa@j_ojd>`omi4/?oOAZko
hd>^onTk[_oa?jcolT^Voo5GW_obGi[olV6Moo9QX?odGj?okF2Non=UUOoTI9L00_oSHYP04?oRHiOo
i6BGonETUooOHhWoff=iom]SOOoIHgoofF=lomYRN?oJHGOofF9fomQPM_oFGWkojG9HonUg;?oYMbX2
onUg;@;ojWL`02;ojWL_onYg;_oZMc7ojWLbon]g=OoZMcCojgHgon]e=_o[MCSok7Hlonaf>oo/MSko
jWLoonMi?_oQOD3og8A5omJ7AooLPdGogX93omj2@?oROCgoi7/konIk>ooWNCWoj7PgonQj<ooXNB7o
igHConIf4ooVMQ7oiWHBonMh5OoWN1OoigTH0_oWNQX8onMi6P05onMj6ooWNA[oigTKonMj6ooWNAX0
0_oWN1H00ooWNAgojGH_onUc>P02onUb>`03onUc>OoYM3SojW@i00;ojW<i00GojG<jonYd>OoZM3[o
jG@ionYd>P02onYd>@04onYc>ooYLc[ojG@jonUc>POojG<i0ooYLcP01?oYLcWojG<honUc>OoYLcP2
onUc>@09onUc>?oYLcWojWDnonM_=OoRJ27ohVLOon9X8_oRJ27ohfTN00;ohfPO00OohVPPon9X8OoR
J1oohVTLonAZ9OoYLSKojW@i00;ojW8h00_ojW<jonYb>?oZLSOojW4fonYa=ooZL3[ojg4nonY`>_oZ
KcOojW0honY`=`02onY_=P03onY_>OoZL3KoiW0:0?ooi6l0>ooTK`0005;oi6l000Soig/=oo:N<ooh
]Dcoo<1Hooo<IOoj^U;omjm5on^66@Koi6l000OokY8VooN_AOoj^U;oolaUooZjD_og[dGokY8V00Oo
i6l000GokY8VooReC?oh]Dcon;E<onMk3@04onA_0004onjB9_oh]Dcon;E<onV14`?oi6l000?ojH4C
ooReC?oh]D`01Ooh]D`01OocXcWoi6l0onA_0?oTK`3okY8V00Son;E<1?oTK`000oocXcWon;E<ooRe
C003ooReC003oo:N<oo^TRKoiWD600Goi6l000?okY8VooReC?oh]D`01_oh]D`4onA_0005onjB9_oh
]Dcon;E<ooReC?oWN`d01?oTK`001?o^TRKon;E<ooReC?oYPA<7onA_0008on^66OocXcWon;E<oog6
Goooc6Gon;E<ooFY?ooWN`d2onA_0003onV14ooh]Dcon;E<00Kon;E<00?ojH4ConA_0?oTK`002OoT
K`001oo/W53omLVOooSK_ooooooooOK_ooSK_oo^YF001_oTK`001_oYRS3omm:_oooooooooooomm:_
on^C@0Koi6l000KojHX`ooOB[oooooooooooooOB[oo[Td07onA_0007onjUH?ogdZoooOK_oooooooh
fkoomLVOonN1801ConA_000JonI`2?o[MAKolH@KooJE7_ogTA_omglLooM^8OoeH2gomU/UooUK3Ooj
E1?on5DCooEN2_o[JPGohg02on5d0?oNMP3ofgH0omUe0?oKL`3ogG40omi`0?oOL03ohG00on=_0?oT
KP0HonA_0007onIb7?oIEU[oeeEJomQFFOoHEE[ofEMGomQFF@04omUGE`;ofEIH00SofUIGom]FEooK
EeOofeMGomYGF?oJEeOofEIGomUGE`?ofEIG02Gof5AJomUDF_oGDeWof5AHomiMFOoTIeSoiFQIomeL
F_oIEUSofeQIomYGF_oJEeWofeQHom]HFOoJF5WofUQGomUHEooJF5SogEYJommKG_oLEfKofEISomeO
GOoQIeWohVUHon9XFOoRIeWohVQHon=ZF_oRIVOof5QYomEFHOoHFEWogV9Ion1YF?oPJUKogfUG00;o
gfQH00cogfQIommWFOoNI5oogF=RomeSG?oMHUWogf9LonYNMOoaGWgokeegoneLN?oZFWH2onUINP18
onUGP?o_Dh[oke>4on]BOoo^DH7okEZEoniUV_o_HXookf2?onmPT_obH9?oiFN4omI/M?oEJgSoeV]g
omA[MooGJfkogV]don1/MooNJgKog6]eoma[M?oKJWGoffYfom]YM_oKJgGoffeconQUOoocG8colej9
oo=OROocG8Wole^<oo=JT?o_EiSok5:PonQ?X_oVD:3okUV8oo1QAoo]EW3ocSfTomPjQOoT@W_okdIj
omMBHoo6EUGoaU=IolECE_nmCeKo`E5FolIBE_o5DUGoa51Gol5?F_o2CUOoaU9EolUCEoo8D5Goae1F
olUAEOoTBVgolDAgoo51N_o_?W_okd1joni1N_o_@W_olD=eoo54MOoaBGOolDaf0_o`CG005?oaAX[o
j46Mon8oWOoV?YgojCjIonQ0UOoW@IOohcjMon8lWooS?IcokDBToo97ZooYA:cogdB`on15/OoU@[7o
jCbboo92[?odD:Gom5ZN0_odH9/0A?oeGj3omEjTooINZ_o_GjSoi6BHon=VTooVIY?oiVJBonQVTooW
I9?ojF>ConATR_oNHGKog5mhomiOM_oPH7OogV1mommQPOoOHhOogF:7on1TSoo/MEOojWHionUg?_oY
MT3ojGI1onUe@_oWMT?oigE1onY`@?o[Kd3ojW51onMc@ooVLT3oiWE3onEjAOoKOTCod8I6olj@Boo:
UDko`IQ<okFIAon`W4Ko/Im:ojZRB_nZY4[o/:1;okBMB_ngVT[o^IM;okRHB_nkUd[oaI5:olR=COo@
RdOofX`fon6;<?oWQ2coj7`PonMh6_oWN1WoigPHonMh5_oWMaCoigPEonMi6?oWNA[oigXJ0ooXNQ`0
2ooWNA[oigTKonMi6ooWNA_oigTIonMh5_oWNAWoj7XVonUe=_oZLSgojW<k00;ojW@i0ooZM3X01OoZ
LcWojG<honYc>ooYLcWojW<i00;ojG<j00?ojG<honUc>OoYLcX00ooYLcT3onUc>0;ojG<i00CojG<j
onUc>?oYLcWojG<h0_oYLcX01?oYLcWojG<jonUc>_oYLcX2onUc>@06onYd??oZMCkoiF/[on9X7_oR
J1oohfPO0_oSJAh00ooRJ23ohfPQon=X8002on=Y7P0<on=X7ooRJ1koi6XVonUa=OoZMCSojW8eonYb
=ooZLcSojW8ionYa>OoZLC[ojW0h0_o[LC`02?oZL3OojW0eonY`=ooZKcSojVlgonY^>_oZLCCoiW0;
oooTK`0konA_0000oooTK`1XonA_000ConMc4Oo^NRkomVP^ooYA;ook?2SonDa0ooUG=ookE0SonU@<
ooQ:3_og?0[omS`7ooI93_ocF1GokfPIonM`5ooVK@koiV/7onE^0P0MonA_0009onEa3OoOHDcoeU9M
omUGEooGE5[ofEIHomUGF?oIEUWofEMH00CofEMG00SofEIHomYFF?oJEESofUEHom]GEooJEeOofUIG
omYGE`?ofUMH00cofEIGomYFFOoIEU[oeU=IomQDF_oMFE[ohfAIon9SFOoJF5OofEIHomYFFOoJEeL2
omYHE`16om]HF?oJF5SofUUIomUIF?oIEeOog5UHomiJG_oLFF?ofEIWomYKG_oOIEOohfYFon9ZE_oR
J5SohVMGon9XFooNGVGof5QWomQJH_oHF5[og61IomiXEooOJUOogfQKommWFOoOIESogfAGomiRFOoN
HEkog69MomYRF?oOHF;ok5iloo1MO?o_GGGokUahon]KMooYFWcoj5QoonUGOooaDHcoke:5on]AOOo_
DhWol5bIoneRW?o^HY?okV6?oniPSoocH97okfB>om][MooEKGCoefegomI/MOoHJfgogf]eomm[N?oL
JWOoffUgom]ZM_oKJWGog6Yeoma[MOoLK7KoffagonURQOocFhooleb=oo=MR`;oleb:02Kolef<oo=Q
SOocH8oolEjCoo9OTOobIGSol6Dgoo9MH?oSCYKog464onE4M_o[AWcofDm[olAFF?o6E5_oaE9Ioka?
F_noDEKoaE5EolEBE_o6DeCoa55Gol1<FOo5D5Cob5AGolUAE_o7DE?oe4ePoo18MOoaAW[ol41oonm0
OOo^?ggokcmloo13MooaA7ColDIfoo5;M@;ol4ea03kokDJ:onHnXOoS?Ygoj3nFonXoU_oX?iKoiCjI
on4kWOoQ?IkoiD6IonU3V?o`A:GojTF/omi1/OoN@KKoh4>fom1:ZOoCEicofVBGomeWX?oQJ:?ohfRP
onEXWooUIjKohf:donQM]_oTGZKoi5nIonINVOoRHIOogf>Don1UUOoOIY7ofFf:omQYR_oBIGcoe6Ik
omI[O?o=KWooagMhom5iNoo/L9SokG2MonQdRooRMTWoh7@mon5_?_oSKSgoiFdmonA`?OoQLcgohW8l
on5b?OoINT7oehI7om6>B_o4SDKo`9I7okjOC?ncXT_oZj96oj^QAP;o[:9801_o[:58ojfPAon_X4So
[im7ojfQAon[XTOo[J19ojfPB_nYXd[oZ:E8ojNVBOnYY4WoZ:A9oj:UC?nRZT[oXk<kojn^=_o2WCGo
eI@gon>???oYRCcojh0donYl:_oYNb?oj7TMonMi6_oWN1L00_oWMaD01?oWN1KoigTHonMi6OoWNAX2
onMi600AonQj8?oYN33ojW@lonYb?_oZM3[ojW@ionYc>OoZM3SojW<ionUc>ooZLcWojW<jonUc>OoY
Lc[ojG<konUc>OoYLcX00_oYLcT01OoYLcSojG<ionUc>OoYLcSojG<i00;ojG<h0_oYLcT01ooYLc[o
j78ionUc>OoYLcSojG<jonUb>_oXLcT00_oXLST02?oXLcWojG<honUc>?oXLSSojW@lonM`=OoSJB7o
hfPM0_oSJAh03_oRJ23ohVPQon=X8?oRJ23ohfPOon=X8?oSJB3ohfTOon=Y7OoRJAWoi6XSonUa=_o[
MCcojW8i0_oZLSX01?oZLCWojW8honYa=ooZLCH2on]b>P;ojW0f00GojW0gonY`=_oZKc_ojG8ZonIa
2`3oonA_03_oi6l0003oonA_06Ooi6l001WoiW0>on]d=oo]KD;ol6A8ooAJBoohB3?on4e2ooUIEOok
BASon4L6ooI=3_ogBQ;omT4Coo=56_oaE2WolF0coo1X=?o`JbookVhYone_8oo[K1Ooj6dAonM_3?oV
K`Ooi6l201Soi6l000Woi703on9/??oECV3ofEMGomUFF?oHEE[ofUQFomQFFOoIEUP01?oIEeL01?oH
EeOof5IHomUFEooJEEP2omYFE`03om]GEooKEUWofUMI00;ofUMI00[ofUMGomYHEooJEe[ofEIJomUF
FOoGE5SofeQGon1NF_oKF5Wof5EI1OoJF5L06?oKF5SofeQIomYIF?oJF5SofUQGomYIFOoKFUgogEYR
omYFIOoHF6;ogF5Lon9YEooSJUCohVQHon9XFOoQIEWofUUMomYJI_oIFfCof5QLomULFooMI5[ogfEJ
omiTF0;ogf=G03_ogfAFomiRG?oNHUgofV9GommPHoo]GG[oke]joneKMoo^FgOokUahonYLO_oXF7oo
jUImoo9AS?o`DH;ok5=moo5GT_obGiKokV6IonmRUoo`HXookf6?oo1RSOocHI7ohFQoomA/LooDK7Wo
eF]gomMZK_oNJW?ogf]home[MOoLJWKog6]eomeZMOoMJWKoffYiom]/N?oMJWWojen9oo=KSoocG8go
lef;oo=LRoocFXgom5ZBoo=MTOo^FIKokeZFoo5LUOoaH83ol6@koo5KI?oLC9WoedBBomloOOoWA7go
fda_olEEEP02olMDF`03ol9BF_o1DESoaE5G00;oaU=E05Coa55Gol5>F?o5CeCoaU9FolQCE_o<D5So
iTU_oo57MooaA7cokD5oone2O_o^@Ggol49koo54MOoaAWColDQfoo1<L?oaBgSokTF@onDnX?oX?Igo
kSfLon`lV_oX?IWoiCbKon<jWooT?IcoiTBIonU4V?o[AISoid>Yomdm]ooD@;Sod4Z^olMFW?o1IH_o
b769olYbS_o>L9OocG2Eol]cToo3M9[o/WRSojYhZ?nfMZ[o`WFToliaWoo;KJ7o^7FDojZ2POnPSW3o
WY1WoinFHOnPVUkoWI]CoiZMBOnHWdWoTIe7oiBLAonVTe3odGmlonYgU_o^LW3ojfXlonM]?ooTLT?o
hWM3omai@OoCPT;od8U9olj@Boo4U4Wo^iU:okJNBoncXDco[Z59ojjQA_n^X4Ko[Ym6ok2OAonaWTKo
/Ye6ok:MAoncW4L2ok:NAP0Uok:MA_nbWDOo/Ii7ojnOAon`X4So/Im9ok6PB?n`X4So[j58ojnPBOn]
XD[oZ:=>oj6X@onF/S7oU[D_oije=onV]3co/:m0olBSA_oLV4OoiY15onR5?_o[OSKok7``onYk:OoY
NB7oj7PLonMg5ooVMQ;oiW@=onIf4_oXMR7oj7<aonUa=_oYLSSojG<honUc=`02onUc>@04onYc>OoY
LcWojG8jonUb>P;ojG<h0ooYLcT7onUc>0;ojG<i00_ojG<jonUb>_oXLSWojG8jonQb>OoYLcSoj78i
onUb>_oXLSWojG8honQc>002onUc>00:onQc>?oXLSWojG<konYd>ooTJbWohVPKon=Y7OoSJ1oohVPP
on=X7`;ohfTO00cohVPQon=Y8?oSJAoohfTNon=Y7OoSJAoohfPOon9X7_oTJBOojG4gon]e??oZLcL2
onYc>@0=onYb>?oZLS[ojW4honYa=oo[LS_ojW4honY`=OoZL3KojW0gonY_>OoYLAooiW8;onA_0P3o
onA_03[oi6l0000ZonA_0004onV14oo[QQWojhHIonIe1PKoi6l000?oig/=on^66Oo[QQT01_o[QQT0
0ooVM@Koi6l0onA_0005onA_0003onMk3Oo/S23olYhc00;olYhc00?ojhHIonIe1_oTK`000_oTK`03
on^66@Goi6l000CoiWD6on^66Oo[QQWojH4C1?oTK`02on^66@03onV14ooTK`3oi6l000?oi6l000Co
ig/=on^66Oo[QQWojhHI2?oTK`001_oWN`gol9P/oo:N<oobWS?okY8VonIe1PSoi6l02?o[QQT00ooY
PA?oi6l0onA_0004onA_0006onMk3Oo`V2colYhcoo:N<oo^TRKoiWD63?oTK`000ooYPA?okY8Voo:N
<`02oo:N<`03on^66OoVM@Koi6l000Soi6l00oo[QQVaonA_000NonM]3Oo`HCGolF92oniZ?_o]Jd3o
l6I4oo5S@ooaIDWom5]5ooEE<?obFRGolE/RooAF9?odDBGolU@Too1H9?o_GRWokf@_oo1Z<ooaKCOo
lVlgoo5^<oo`KB_okFhSon]^6ooZKQCoj6h>onI_2?oUK`?oi6l15?oTK`002?oULBSoeU5OomQEFOoJ
F5GoeeAKomQEFOoIEeKof5IH0_oIEeL02?oJEeOofEMGomUGF?oIEeOofEQHomYGF?oIEUWofUEI1?oK
EUP00ooKEeSofUIHomYGE`02omYGF006omUGEooJEeKof5EGomQDF_oHE5cof5EI0_oJEUP2omYGE`0H
omYHEooJFEOofeQGom]HF?oJF5SofUUHomYIFOoHF5WofUYHomiKG_oKF6Coee9WomUHHooOIE_ohVUG
on9ZEooSJUWogV1IomQFGOoKFfOoeeMWomA@GOoHEEOogEmH0_oOI5L08_oOHeOogfAGomiTGOoOHUoo
gF9Don9PJ?o]G7WokEYhonaKN?o]G7OokUajoneLOOoZF7[ojUIloo5AR?oaCh;ol5N2oo9LU_o`GIGo
kf2FonmPW?o_HI;okf2@onmQS_obH97ojFB9omIZM_oCJgWoeFahomQZKOoNJg;oh6afomi[M_oMJWL3
omaZM`1Yom]ZN?oKKGKoh6UkonmMROocFhcolef<oo=LS?ocGH[ole^?ooAJToo_FYKojERGoo5LT_o`
G9Cokemmoo1T>ooaFVKog4^Gom]:U?oK@8GoiT5kome:Loo7EE[oaUEHolICGOo1De[o`e=IolMBFOo7
DUCoaU5Gol5@F_o0DECo`U5Aol=ADoo4E5CoeDePonm7MOoaAWSokDAkon]1OOo/@g_okT=loo15O?oa
AgOolDQeoo99LoobB7cokd6EonLjX_oX?9_olCfKoo8kX?oZ>YkoiS^OonHnW_oW@IcojDFHonY7UooZ
AI;ohd:QomHl_oo:@K[oa4nVolALV?o:Ii7odVfDomI[V_oIJI[ofV^FomMXW?o=IJ_o_6R_okeY[oo7
Jjcod6fZom1bX?o8N9Go_7n6ok23L_nRTf_oW9iToi^VH_nKZVGoSJmHohNZBOn7Xd3oQYi1oh^K?on;
WC[oRi/jojB@F?nnR7;o`Xa:ol^8=_oBQTCoc8m>olRID_nmVdgo/ie9ok2OB_naXDco/:1<ok2MB_n^
WTSo[Yi700Co/Ye700ko/Ie7ok6NAon`WTOo[im7ojnOB?n`WTOo[im7ojnOB?n`WTOo/Ii8ok2OAon^
XTSo[j1:ok6NBP;o/Ii902Co/Ye;ok>MBonbX4_o]9a<ojnR@onR[S;oWjhaoi^_<_nI/C7oW;8cojBa
=_n][COo^:LlolZQAOoLUTSohhQ2onZ2@Oo/PcoojX<gonUn;_o[OC?ojgU3onYb@OoYLS[ojG8conQa
;ooXLS3ojG8`onUb<_oYLS?ojG<donUc=OoYLcKojG<honUc>OoYLcP3onUc>@;ojG<h00?ojG<ionUc
>?oYLSX01OoYLcT00ooYLSWojG<ionUb>@02onUc>006onUb>_oXLSWoj7<honQb>OoYLcSojG8i0_oY
LSX01ooXLSWojW@konM`=?oSJ23ohVPMon=X8?oRJ2400_oSJAl00ooRJ23ohfTOon=Y7`02on=Y7P0H
on=Y7ooSJB3ohfPRon=Y8OoSJB3ohVTLonAZ8ooXL3;ojWDionYd>_oZLc[ojW8gonYb>?oZLSKojW8g
onYb=_o[LS[ojW4gonY`=_oZL3OojW4fonQa6?oWL@_oiFl2oooTK`0jonA_0000:_oTK`001?oh]Dco
olaUooo<IOo[QQT6onA_0003oo:N<oooc6GoolaU00KoolaU00?ojhHIonA_0?oTK`000ooTK`000ooY
PA?on;E<ooo<I@05ooo<I@04ooReC?oTK`3oi6l0onA_00?oolaU1OoTK`001?o[QQWoolaUooo<IOoh
]D`4onA_00;oolaU00?on;E<onA_0?oTK`000ooTK`001?ol`5SoolaUooo<IOooc6D6onA_0003onV1
4ooh]DcoolaU00GoolaU00?omJToonIe1_oTK`001OoTK`08ooo<I@03ooReC?oTK`3oi6l000;oi6l0
00?ojH4CooReC?ooc6D01Oooc6D00ooeZCooiWD6onA_0007onA_0003onb<8?ol`5SoolaU00KoolaU
00?on[YBonA_0?oTK`001_oTK`03ooo<IK7oi6l001Ooi6l2on]Z8_oaHCCol6@_oniX>?o]J3gokFXn
one[>oo^K47olVe?oo=[A?o_J2gokV@Too9L9_oeDR?omT/QooE=9oobEB_olEh`oo1S<_o`IC3ol6L`
oo5Z;`02oo5]<@09oo5^<Oo`KBkokVdVona]7_oZKQOoj6h@onM^2OoUK`Coi6l1013oi6l000koiW8D
omeNDooFDEgofUQFomUFF?oGE5_ofEMGomQFFOoIEeWofUQIomUHF?oIEeOofUMIomYHF0;ofEQG00Co
fEMHomUFF?oJEUOofeIG0_oJEUL0:OoKEUOofeMGomYGEooJEeOofUMHomUGF?oIEeOofEIGomQEEooG
EESof5QHomQGF?oHEESofEIGomYFEooIEeSofUMJomYHF?oJEeOofUQGomYIF?oJFE[ofEUHomIHE_oI
FUOogUeLomeJI?oFD6koeE1^omePH?oRJUWohfYIon9WF?oLFE[of59OomMDI?oEDEcoeE1GomMDEooL
GUSogfAG00;ogfAI00GogVENomeRGOoNHUOoj61^onmLNP02oneLM`0BoneKMoo/G7cokEYkonaIN?o/
EWooke62oo5?P_ocFXgolenGoo1LUOo`GIKokEjMoneQU?o_H8kolV2AooAOToo`HY3og6Yl0_oCKGD0
L?oFJfWog6aaomi/M_oLJgSog6UjomaZN?oLJgOogF]foma[MOoKKG?ohVQloo5LSOocFh_olef;oo=L
S?ocFhgolU^Boo9IU_o^EI_okEVDoo9MT?o`Fi?ol5mhoo1S??o`GFKoh4jEomi=U_oIA8ooi3moon18
MOo8EEgoaeEJolICG?o1De[o`e=HolIBFoo6E5Go`E9EokiAEOnoD5;obDmIolm<H?o?D5gogTaZoo57
M_o_AgWojT=non]1OOo]@WgokT=monm8N_o`C7Kol4]doo97O?o`@I?oiCZOonDkVOoZ?YKok3^JonXj
W?oU?IcoiT:IonE5V?oV@iCoid:DonM4VOoL?jOob3Vlol57]Oo3F:?oc62MomAVV_oIJYcoffVNomiW
XOoNJ9ooeFRTolES[onoHKWobfBcom]VZooOIJKoffNKom9]Roo9LWkoaW9holMaN?o:M8God7B:olmj
ROo5PXGo^8Mlojj:N?nWSG?oW9M[ohnJGon7W5CoPJ9:ohNVH_n8[6OoO[8XohFa7onB[33oX:HkojbQ
AoncX4co/im<ok6OB_n_WdWo/9m:ok6NBOnaWTX2ok2OBP0:ok6NBOn`WT[o/Ie:ok6LB_n`WTSo/Ia8
ok6LAonaWDOo/Ye7ok:NA`;o/Ii700Ko/Ye8ok>MAonaWTOo/9m7ok6MB_ncW4X2ok:LBP0Mok>LBonb
WD[o/9i:ok:LC_n[Y43oXJhaoj:]<?nS[33oX:d_oib^;OnJ/2goVK8_oiZd<onP/CGo[JXhol>U@_oG
XDGog9=7onIlE_obN6_olGM_onmhI?o]NV3okGMKoneeD_o/MDkojgA6onYc?OoZLcL00ooYLS403?oY
Lc?ojG8eonUb=OoYLSKojG<honUc>_oYLS[ojG<ionUc>ooYLc[ojG<ionUc>PCojG<h01KojG<ionQb
>?oYLcSojG<ionUb>_oXLSWoj7<honUb>OoXLcSojG8jonQb>_oXLS_oj78honUd>OoYLcWoi6/Zon9X
7OoSJ1oohfPQon9X8?oSJAoohfTP0ooSJAh00ooSJAoohfTPon=X8@02on=Y800Eon=Y7_oSJAoohfTN
on9Y7_oSJB7oifd^onYc>?o[MC_ojW<honYb=_oZLSGojW8gonYa=_oZLSSojg8konYa=ooZKcSojW8a
onQb4ooWL@_oi6l20?ooi6l0>_oTK`0002[oi6l000Con;E<ooo<IOooc6GojhHI1_oTK`000oobWS?o
olaUooo<I@06ooo<I@03on^66OoTK`3oi6l000;oi6l000?okY8Vooo<IOooc6D01_ooc6D01?oh]Dco
i6l0onA_0?oTK`03ooo<I@Goi6l000CojhHIooo<IOooc6Gon;E<1?oTK`02ooo<I@03ooReC?oTK`3o
i6l000;oi6l000?okY8Vooo<IOooc6D00_ooc6D5onA_0003onV14oomaUooolaU00OoolaU00?on[YB
onIe1_oTK`001?oTK`08ooo<I@06ooReC?oTK`3oi6l0onA_0?oYPA?ooLIO2?ooc6D00ooj^U;oiWD6
onA_0005onA_0003ooFY?oooc6GoolaU00SoolaU2?oTK`03ooo<IK;oi6l002KoiflBonmW>Oo`HRoo
l6DXonmV<?o^ICWokVDnoniY?_o^K4?olfeGooE/D?o`JSKokFPVonmS9?obFR;om54PooI=9_ofC2co
m5<coo=K=ooaHCGol6Hboo1X;oo`J2golFX_oo5]<OoaKc;olFlaoo1_;oo`KBcokf`Wone/8?o[KAWo
jFhAonM^2ooVK`OoiFl4onA_0@_oi6l000koiG07on=Y@OoGDUoofEMIomYHFOoHEEcof5IKomUGEooI
Ee[ofUQHomUHEooIF5SofEMGomUHE`?ofEMH0_oIEeL0_ooJEUOofeIHom]FFOoJEESofUIHom]FF?oJ
EUWofUMJomYGF?oIEUSofEIJomUGF?oHEUOof5QIomQJFOoIF5[ofUMLom]GGOoJEUcofUIJomUEFooI
EE[ofUIIomYGF_oJEe_ofUQLomQGG?oGEUSof5MIomaJG?oNFFGof51^omA<K?oKFF7ohFEHon=XF_oQ
HEkofE9KomIBF?oEEE[oeE=MomE@FOoFDUSofeaJomiTFOoOIESogfEMomeRFooNHE_ojUmboo5MN?o^
G7CokEeeon]LNoo[FWgok5UkonaINOo]EGcokTmlonmAQoocGIOolUjGoo9LU_oaGYCok5nJonaPV?oa
HHgolf:@oo=QT_obHXkohVR0omUYO?oKJ8;ofVQbommZM_oNK7OogFafomYZMOoIJg?ofV]bom][M?oK
K7CofficonAVOoocFhkole^=oo=LSOocFhkolUZBoo1JToo]EiKokUBJoo9LT_o`GY3olUf@oo9QLoo`
I3_olEiWonEATooQCiKofdZFoma0P_oNAGCobEAJolQEF_o6Dego`EAHokmDDoo2E5OobEEGolUAG_o>
CFKof4YXonM9LOo]AgGojd]aone9M_oaAgOokdEnona2P_o]A7_okDAjone5O?o_BWKol4Y`oo57M_oa
?hoojc^Oon@lUooX?9Sok3bKonLlV_oU?Ycoid>KonE6UOoV@Y;oiT2Eomi1X?o;?[;o^CbgokU9[oo6
Fj;oe6FPomYZXOoMJZ?ogVNTon5UY_oMHj_od6:aol9P]_o1HK3ocFNSom9]T_o?Kh?oag5jolEbM_o6
LGGobG1ioli_Qoo@LHoodW6Bom=^U_oAL9Goc76FolQeV?nnNYCo/Gb8ok1oR_nVPhOoX8b3oiRJOOn;
ZiKoP;MoofZo9?mS`aKoIKlHog>i7?n4/2OoVJPeojbP@?neWT[o]Yi:ok>PB?naX4So/:17ojnPB?n`
X4So/:19ok6NBOnaWT[o/Ye800?o/ia:00Oo/i]9ok>KB_ncW4[o/ia8ok:LB_ncW4Wo/ia:00;o/Ya8
00?o/9i8ok2MB_nbWDX00onbW4/09onaWT[o[J1<ojnOBonSZSSoW;4]oj2_<?nP[S3oXJd`oj2];_nL
/2koWJl_oif];_nM[RcoX;0]ojZZ>onkVeCob8mXom>;J_oPQ6Koih1Von]nIoo]OFSokGeYonamIoo[
O6CojgaRonajGoo/MU[ok7EDon]eC?o[M4CojW<lonUb=ooXLSCojG8conUb=?oYLSKojG<donQb=002
onUc=`;ojG<i00CojG<jonUc>OoYLcWoj78h0_oYLcP02?oYLSWoj78ionQc>OoXLS[ojG8ionQb>OoY
LS[oj78i0_oYLcT01_oZMCgoifldon=X8_oRJ1kohfTOon=Y80CohfTO0_oSJB02on=Y7`0=on=Y8?oR
JB7ohfTOon=Y7_oSJAoohfXNon=Y7_oSJA_ohfXMonE/:OoYLSGojgHkonYc>@03onYb=`07onYa=oo[
Lc[ojW8jonY_>ooYLR[oig<?onIa2@3oonA_03_oi6l0000ZonA_0004ooReC?ooc6GoolaUon^66@Ko
i6l000ColYhcooo<IOooc6GomJTo1Oo[QQT01OoVM@Koi6l0onA_0?oTK`3ojhHI00?oolaU00?on[YB
onb<8?oTK`000_oTK`000ooWN`gok8`PonA_0002onA_00?oolaU1OoTK`001?o[QQWoolaUooo<IOoh
]D`4onA_00;oolaU00?on;E<onA_0?oTK`000_oTK`000ool`5SoolaUooo<I@02ooo<I@Coi6l000Ko
iWD6oog6Goooc6GoolaUooReC?oWN`d2onA_0005on^66Ool`5SoolaUooo<IOog[dD01OoTK`03ooo<
I@GojhHI00GojH4ConA_0?oTK`3oiWD6oog6G`02ooo<I@06ooReC?oWN`goi6l0onA_0?o[QQWoo<1H
0_ooc6D00oog[dGoi6l0onA_0003onA_0006oo:N<oooc6GoolaUooo<IOog[dGojH4C0ooTK`000ooh
]DcoolaUooo<I@08onA_00?oolaU/_oTK`00:_oUL0OokF/`oo1R>oo_I2kol6PVoo1Z:_o_IC;okV4h
oneS>_o^J47olfaEooI/EOobJd3okV/]oneY9Oo^IBKolEdUoo=?8?oeAagomTPSooI><?oeEc_olehl
oo9S=ooaIC;ol6H^oo1W;?o`JRcolF`_oo5^<_oaKc?olFlboo1^;oo`KBcokf`Xone/8_o/K1cojVhF
onQ^3ooVK`SoiFl4onA_0@Ooi6l000Soi6l2onE_=?oFDF7of5ALomYFFOoIEE[of59LomYEF0;ofEEI
0_oJEUP01_oIEUWofEIHomYFF?oJEUSofEIHomYFF0;ofEIH00CofUEIomYDF?oJDeSofeAF0_oJE5L0
3?oJE5WofE=JomUCF_oJE5[ofeEJom]EFooIEUkofUUMomYHGOoJF5oofUMOom]FG@;ofUEG0;7ofE=I
omUCFooJDe[ofE=HomUCG?oHE5gof5AJomMCF?oFDESofUIGommJG?oLDV[oeD][omUFI?oPHF;ohfIL
ommOFOoGDe[oe5=JomIDG_oFDeooeE5JomEBF_oJFE[ogV9JommVGOoMI5[ogf5PonaMM_oaGGKol5ed
oniKN?o/FWkojeQmonaHO?o/EgSokeEfoo1BNOoaF8com5bJooAKUoocG9Gol5fEonmNVOo^Gicol62C
oo5RS_o`HI3ol62@oneSS_o]HI?olUjEonmSQOo`IHGojfJ3onQWOooTIgoohFYjomi[MOoKJgGoffic
omU]L_oUI8?om5VAoo=KS_ocFhgole^>oo=JT_o`FI?oj5BKon]CWOodFi;olEn>oo=MTOocH7Gol6@n
oo5KK_oYDICoi4nComm=UooJ@HcogT=eolUBF_o2Ee;o`UAIol1CF?o4DU_odTmUon5?K?oXC7CokTYm
oo57NooaAgOolDUgoo59M_oaAgWol4Mjona5OOo]A7kokTAjona4N_o]AgSol4Y`oo58L_o]?hWojSbL
ondlW_oY?9SojCZKonPjW?oS?Y_oiD>IonM4UOoW@IGohdBGomA;W_nmA:go/Sfcoke:Z?o?FjKogFFY
on5WZ_oQIJgohUnbon9L]_oJG[Sob6>dolAT[?o8J9cobg2:ol]aO?o5LgGoaG=holQbP?o:LXKocG>C
olacVOo:MIcoaWFLolAhVoo0NI_o`7VJol5iVoo3N9_o_GZ?ok=mO_neO7ko]7enojYnOonRQ8OoV8:K
oij?R?nN[TSoT;50oh2f=_mb_BWoJ<0OofZo7?mh^2?oSZd_oj:U??n_WTCo]Ya:okNKB_neWD[o/ie9
ok:NB?nbWT[o/Im9ok6OB?nbWT[o/Yi;ok:NB_nbWDWo/Ie;ok6NBonbWDX00_nbW4`0;onbVd_o/i];
ok>JBonbW4_o[ii:ojjOB_n_WT_o/9a;ok6LBonaWD_o[Ym:ok2NC?n^X4CoXZ`aoj6];onS[37oXj``
oj6^;_nR[C3oXj`aoj:^;OnP[RgoYZLmojjME_n^Weko[J1Jok:MG?nmUegoaI9Ooln=HooIR6KohX5U
onYoJOo^O6OokWaXonamJOo[OFOojGiWonQnI_oYOF?ojWeSonehGoo]MU[ok7EBon]eB?oZM47ojG<j
00;ojG8d0_oYLcD00ooXLSCojG<donUc=P03onUc>@06onQc>OoXLS[oj78honUc>?oXLS[oj78i0_oY
LSX03?oYLcWojG8ionUc??oYLcgoi6XYon9X7OoSJAkohfTOon=Y7_oSJAgohVTNon=Y7`;ohfTP00Go
hfTOon=Y8?oRJB3ohVTPon9Y8@06on=Z7P;ohVTL00goi6XTonQ`<oo[MScojW@ionYb=ooZLSSojW4h
onYb>?o[LScojg4lonUb8_oWL`goiW070?ooi6l0>ooTK`0002[oi6l000Con;E<ooo<IOooc6GojhHI
1_oTK`001?obWS?oolaUooo<IOobWS<9onA_0005ooReC?ooc6GoolaUooZjD_oVM@H02OoTK`03ooo<
I@Goi6l000CojhHIooo<IOooc6Gon;E<1?oTK`02ooo<I@05ooReC?oTK`3oi6l0onA_0?o^TRH00_oo
c6D00oomaUooolaUooo<I@04onA_0004oo:N<oooc6GoolaUooReC0Goi6l000GoiWD6oog6Goooc6Go
olaUonV14`04onA_00?oolaU2?oTK`001?obWS?oolaUooo<IOoh]D`5onA_0005onIe1_omaUooolaU
ooo<IOoYPA<00ooTK`001OoVM@KooLIOooo<IOooc6GomJTo00Goi6l000?on;E<ooo<IOooc6D02?oT
K`03ooo<IK;oi6l001coi6l1onUa8Oo`HS[okfDionmU;oo`JBOokg0Yonm[<?o^HCCokEleoniR??oc
Ie3omfaIooAZB?o`JS?okF`[oniZ:oo_IB[ol5XRoo9<5oocAQKomD/SooIA<_ofECgomEY0ooAQ?_ob
ICOolFH`0_o`Ib/04Oo`JBgol6`^oo1^<?oaL37olG0boo5^<OoaK2ool6//oo1Z:Oo^Jb?ok6dNonY^
5ooXKQ7oifl<onI_1ooUK`Coi6l100?oi6l000WoiG4Tom=?H?oFDUcof5AJomUDF_oIE5Wof5=IomUD
EooJEEL00ooIEEL3omUDE`0GomUEE_oIE5OofEAGomUEE_oIEEOofEEFomUCF?oJDeWofeAIom]CFOoJ
DecofE=MomYDGOoKEEgog5EMom]DFooIE5_ofEMJomYHFOoIEe[ofEMHomUEF?oHDeT00_oJE5T01_oJ
E5SofU=IomYCF?oJDeWoee=JomQDF0;oee=I06Gof5AFomYFF?oOFf3ogEI[omI<K_oGD6SogUmMon=V
F_oLFegoe55IomECF?oEE5_oeE9OomA@FooED5Wof5IKomeQHOoMIE_ohF5SoniLN?oaG7SolEefoo5J
N?o_FGookEQnoneGNOo^EWOol5Aeoo9FO_odGY;om5bGooAIV?oaFYGol5^EonmLU_o^H9cokV2Hoo1P
Soo`HI3ol62@oo=QToocHISolEn?oo9QQOocHhOom66:oo=QR_ocH8colV:;oniTR?oZIHOoj6N2on=Y
NooUI87olUV?oo=LS?ocG8_olU^>oo5KTOoZEYKoh52OonEBWoocFI;olef=oo9LTOobHGOol6Hooo1K
KOoVDI;oiU>>on5>U?oLAIKoeCmmolE>GOo:EUGoe55Uom]=KOoVBgCokTagoo5<NOoaBg[olD]koo57
O?oaB7WolDUfoo1:LOoaBGCokDImonU5O?o[@ggojSmoone2O_o`BG;olDQ`oni0Q_oV?9WoiSfJondk
Voo]>IgoiSbJonA1U`02onE2T`1/onM0V_oOBYcobEFIokE5Z_nh?;Koc4bZom]MY_oSHK7oiVBeonIP
^_oTGkOog66bola[Yoo0LY[o`G>@olMfP_o9MGcoagV5olMhRoo;LiKocg>JolaeW?o;LYkocg6Rolab
X?o9MI_obg>Gol]eU_o9MI?obWF?olmcS_oCLhgoc7N7okUnOon[OH3oXgZ7oiaeQOnKMHKoVgF<ojZ5
NOnmUe3o^IMHokFJFOn_WeGoXjI>oi2b@omk^S;oL;lWog2n:?n0]BkoUZ/kojVRAOnbWDWo]I]8ok>M
B?nbWTSo/Im8ok2OAon`X4So/:1:ok2OB_n`WdSo/:19ok2PB_naWT[o/Ie:ok:MB_naWTWo/Ie:ok:M
B_naWDWo/9e9ojfOB_n_Wd[o]9]<ok:KBonaWD_o/Ya;ok:LC?nbVdcoZ:Hhoj6];_nQ[C3oWjh_oj:]
<OnS[2ooXJh[oj:[;on/XTSo]Y]Nok>MHOncWUco]Y]KokJJG?nfVe_o]IaJokBLG?ngVUgo_iANol^?
H_oERFCogh9TonQnI?o/O6CokG]SonamIOo[OFKojWmX0_oYOVL02_oXOVSoj7iUonUmI?o]NVCokWIM
oneeEoo/M4kojWA3onUb>_oYLSH2onQb<P04onQb=OoYLcWojG8monUc?0;ojG<j01CojG8konUb?OoY
LSWojG<jonUb>_oYLS_ojWDnonM_<_oSJAoohfTMon=Y8?oSJAkohVTJon=Z6OoSJQOohVXJon=Y8?oS
JAoohfTNon9Y80;ohfTP00GohfTOon=Z7_oSJQkohfXNon=Z7`03on=Z7P0>on=Y7OoRJA_ohfXPonI^
;_oZM3SojW@jonYc>?oZLSSojW8gonYa>OoZLcSoj7<HonMb3?oUL0CoonA_03_oi6l0000ZonA_0004
ooReC?ooc6GoolaUon^66@Koi6l000ColYhcooo<IOooc6GolYhc2?oTK`001OoWN`goolaUooo<IOoo
c6Goig/=00[oi6l00oooc6D5onA_0004on^66Oooc6GoolaUooReC0Coi6l00_ooc6D01_oh]Dcoi6l0
onA_0?oTK`3oo<1Hooo<I@;on;E<0_ooc6D4onA_0004ooZjD_ooc6GoolaUon^66@Koi6l000ColYhc
ooo<IOooc6Golj<i1?oTK`03ooo<I@Soi6l000Con[YBooo<IOooc6GojhHI1_oTK`001?obWS?oolaU
ooo<IOocXcT3onA_0004onjB9_ooc6GoolaUooc0F0Koi6l000?on;E<ooo<IOooc6D02?oTK`03ooo<
IK?oi6l0063oiW8AoniX=OoaHCcokVLgoniS;_o_J2Ookg4Xonm`;Oo_IS;okUlboniN=?ocGdSomVYG
ooE[C_oaJCGokV/Zoni/;?o^K37ol6@^oo1C6oo`B@oolTPAooA;7_ofCboome4jooIG?ooeG47om64k
oo=S=OobHc3olF@]oo5W:oo`JRcol6`]oo1_;oo`LC3ol70`oo5_<?oaK2oolFX]oo5Y:oo`JRWokf/U
one]8_o/KQgojVhFonQ^3_oVKPOoiG03on=^7?oDEEGodU5DomADD_oEE5KoeeIGomQFFOoIEUSofEEG
omUEE_oIEEOofEAFomUEEOoIEEKofEEGomUEF?oIEEWofUEIomYEFooJEEcofUILom]FGOoKEEgog5EN
om]DGooJDekofUEKomYDG?oIEEcofUEKom]EFooJEEoofUMPom]JH?oJF5kofUMFomQFEooHEESofEEK
omYDF_oKE5SofUEGom]EEooJEESoeeAIomICFOoGDeT3omQEFP0TomQEFooKEV3ogUMZomUAJ_oFD6Co
gEaNon1QGOoGEESoe55FomAAF?oDDUcoeU=OomEBFooEDEKoeeAMomUNGOoRH6Sokeajoo1LNoo`FgSo
lEYeoo5JNOo_F7[okEMgoniEN?oaE7coleb7ooAQT?odG9ColeZGoo1KU_o`GI?okebDoo1PVOoaI9So
l66@0_o_HY00PooaHXkolF:BonmPR_obHH?olf::oo=QR_ocH8Wolf2=oo=PS?ocH8_olf6<ooAQSOob
HX_ok6B6oo1LS?ocFXgole^?oo9JToo]F9GoiE6Kon=BWOoVEIWolEZ>oo=MS?ocGI7olf=eoo1W?oo_
FfoohdnCon]BSooUCYCogDRKolHnQ_o>B6_ojDmaoo5<NOoaBWcol4]ioo1=MOo_C7Ool4egoo5;N_oa
B7golDYioo5;Moo`Bg?ol4Qfona1Q?oY@X;ojCmoonToOOo_AWSolDMdonhmQooW>I[oiSbKonTkVOo`
>YcokCbKonI2U?oU@iGohd:Jon52X?oDD9_oaEBKokU1[onn?[Kof5:]onAM[?oUGk?oiF2mon5S^?oE
JjCobg:BolAgRonoOhOo`gj1olMiN_o7NWkob7N9olYcS_o8MHcobG>?ol]dS_o;MHkocWB@om5bSOoA
MHkod7F<om1eR_oCLhWodW:9oledQoo6MHko`7NGojegU?nMM8koUg6=oiIbR_nILXSoVG28oiUdRon^
Rg3o]iM;okNED?njU5?o_9AEokjEF?nmUUWo]IYGojNRDOnFZdWoQkDmog^l=Omm^cGoSKDmoif]AOnX
YTWo[J99ok6NBOndWDWo]Ia:okBLB_ncW4[o/Ye:ok:NB_nbWD[o/Yi;ok6OB_naWdSo/:1800;o/Ii;
01Oo/9i9ok:MB_naWT_o/Ii<ok:MC?naWT_o/Ie;ok:LBoncVd_o/I]<ojZT?onQ[BkoX:d`oj:/<OnS
[2ooX:l[oj:[<_n_WTgo]iUQok>NG_nbWU_o^9YNokVIGP03okNJG00?okBKFoncWE_o/YeJok6MF_ne
Veco^YINolJBHOo@Rf;ofXAQonB0Hoo[O6CokGYTonejHoo/NfCojWaS00;ojGeV02;ojWiWonYnJ?oZ
OFWojG]VonYkIOo/NVCokGQSonefFOo[LdCojG8honQa<_oWLC7oj78donUb>ooYLSgojG<lonUb>ooY
Lc[ojG<konUc>_oZMCgojG<jonAZ9OoRJAcohfTQon9Y6_oRJQSohfTUonQW=?oYIcCohfXPon9Z6OoS
JB3ohfXN0ooSJAl01OoSJB3ohfTOon=Z7_oSJAkohVXM00;ohVXL00SohVTLon=Y7OoSJAcohVTKon=Y
7OoUK2SojG0donYc>0;ojW<g00GojW8honYc:_oXM1?oiW8;onA_0@3oonA_03_oi6l0000ZonA_0004
ooReC?ooc6GoolaUon^66@Koi6l000ColYhcooo<IOooc6GolYhc2?oTK`001?o[QQWoolaUooo<IOoh
]D`;onA_00?oolaU1OoTK`001?o[QQWoolaUooo<IOoh]D`4onA_00;oolaU00Con;E<onA_0?oTK`3o
kY8V0_ooc6D01?o[QQWon;E<ooo<IOooc6D4onA_00;oolaU00?ooLIOonA_0?oTK`001OoTK`001?oY
PA?oolaUooo<IOoh]D`4onA_00?oolaU2?oTK`02ooo<I@03oog6GooTK`3oi6l000Goi6l000CojH4C
ooo<IOooc6Gon;E<0ooTK`001?obWS?oolaUooo<IOobWS<6onA_0003ooReC?ooc6GoolaU00Soi6l0
0oooc6FconA_001JonE`1Oo[LBkolEdgoo1V>oo^IcCokV<_onmT:?o_KRKokg</onm_<_o^I2ookE`^
oo9L@_ogIUComVQBoo9Y?_o_JRgokV/Zoni]<Oo_K3Ool60^oo1@6Oo_BPcol4/?oo==6ooeCbWome4k
ooMFAOofFDComUa0ooAO??ocHcSolVDboo5U;_oaIBgolFL/oo1[;Oo`Kbkol74^oo1a;oo`KboolFd_
oo5Y;_oaJBcolFT[oo1Z:Oo_K2OokV`Son]_6?oYL2Wohf1QomaHHooKFUWofUQEomQFE?oFE5;oeEAA
omEEDooFEECof5EHomUEFooJEEgofUINom]GGOoKEUgofUIMomYFG?oJEEgofUINomYEG?oJEE_ofUIK
omYEG?oJE5cofU=OomUDH?oIE5oofUAQom]EH_oLEV;ofeEQomUFH?oIF5kofEMJomUGE_oHEUOofEMH
omUHF?oIEUSofUEK0_oKEET00ooIEE[of5EKomIDF`02omMEFP0GomQEFooGDekoeE5MomE@FooIE5co
h5aNomiFIooFCfKofUQQomYHGOoEDESoeU9HomIDE_oFE5_oeUANomICF?oDDEWoe5AMomiIIoo^G7[o
kU]konmHN?o`F7D00_oaF7L0V_o_EgKokeAgoo9FPoocHHkolf:>oo=MTOodG9ColUfEoo1OToo`GYCo
l5jGoo5RToobHi3okf6@onmQSoo`HXookf6AoniOROobHHOom6:;oo=RR_ocHXOolf:;oo=QRoocHX[o
lf>;oo=RRoodH8oolf6=oo9MT?ocF8kom5ZBoo9IUOoXDY_ojU>Loo1HU_o^FY7olef<ooAKS_ocG97o
lf=eoo5UA?o`FGCoidfDon]AT?oVCi7oh4^Gom12U?oL@H;olD]jone<Moo[BgOokDieone<MOo_C7Oo
lDieoo1<N?o_BG[ol4afoo5=MOoaBgSokTIkon]0Q?oZ@8GojSn1onm5N_oaAWSokCb6onHiUooU?YWo
jCbHonljV_o_?9[ok3fKon93WOoDC9_oc5BLolaDVoo4Diko_T>_ol]5]ooJG:WofV:XomMO[_oCI;;o
d6f_olYeV?o3NX;o`WV1olUeQoo=Lh_obg>;olMfPoo5MWooaGQool9iN?nnNg;o_gifolQmOoo?OXCo
a8J1okF@P?neSXKo_XJ7okn<Q_nfT8Oo/XN?oj^7VOnOQI_oUh:UoiR<X_nNSIKoWXB@oiioS?nOOh_o
Vgj?oib4T_ncVg7o]Ii=ok:ND?neVUCo]iQCokJIE?ngV5Co^9MFokZEE_nmU5So^iIJok>NEonUYE3o
Vj];oiJ_BOnF/DWoV[1;oif^C?nTZ4coZj=;ok2OBOncW4[o]Ia:okJKB_neVdWo]9a:ok>MBonaWTco
/Ii;ok:MB_n`Wdco/Ii;ok2OBonbWd[o/ii;ojnPB_n]XDX2ok:NBP1Cok:MBOnbW4coZZA4oj2]<onQ
[3;oXj/aoj6_;OnTZSOo/9iBokNJI?nbWUko/YeJokRIFonhVUgo]iYKokNJG?ngVUgo]i]LokRJGOng
VEgo]I]MokBKG?ndW5co/YeLok6MG?nbWEko]iUOoknEHOo8Sf3oeHQPon22H_oWOV?ok7YSonijIOo]
NVKojg]SonYlI?oYOFCojGeUonUmI_oYOVKojH9_onmoNoo`NWGokGYYonadDooZLT3oj74fonMa<ooX
LCGojG8jonUb>OoYLS[oj7<ionYd>ooZMCcoiF`[on9Y6_oSJA[ohVXGon9Y6ooTJ3GokVThoo5N8?oa
F1Ooj6D]on9[5OoRJQ[ohfTPon=Y8OoSJB3ohVTOon=Z7OoRJAgohVXLon9Y6_oSJAgohfPPon=Y8OoS
JBCohfTUonAZ9ooUJB/00_oUJR/02?oVK33oig0bonU`=_oZLCWojW8honQd6ooWLPcoiG05oooTK`0l
onA_0000:_oTK`001?oh]DcoolaUooo<IOo[QQT6onA_0004oo:N<oooc6GoolaUooc0F0Con;E<00Go
lj<ionA_0?oTK`3oi6l0oo:N<`02ooo<I@03oo:N<ooTK`3oi6l000Woi6l00oooc6D5ooReC004ooZj
D_ooc6GoolaUooReC0Coi6l00_ooc6D02?oh]Dcoi6l0onA_0?ol`5SoolaUooReC?oTK`3on;E<0_oo
c6D3onA_0004on^66Oooc6GoolaUooReC0Soi6l00oooc6D4onA_00?oolaU1ooTK`001?o[QQWoolaU
ooo<IOoh]D`8onA_00?oolaU0ooTK`001?oh]DcoolaUooo<IOo[QQT3onA_00KoolaU1ooTK`001Oo^
TRKoolaUooo<IOooc6GokY8V0;?oi6l007Koj7@PonmS=?oaHCSokfPjoniX=Oo_I3;okf<Xonm[9Oo_
Lb[okg@_oni/;oo^Hc?olV55ooIRD?ofHe7om6Q6oo1Z<?o^JRKokV/[onm^>?o`Jc_ol5`/onm?5_o_
C@_okdd:oo9@4oodDBWomU8kooMD@oogEdComUU2ooEN@_odHCkom68joo=Q=OobHc?olFD_oo5X;?o`
K2cokfh/onma;Oo_LRool74_oo5^<?oaJRgolFP[oo5Y;Oo`JRKolF/ZooA`DoodLVKolViXoo1WK?oX
H6KofeYPomQIHOoKF5gofUQIomQGFOoFEESoeEEFomIEF?oGEE_of5ALomUEGOoIEEkofUINom]GGOoK
EUcog5INom]FGooKEekofeMQom]FHooIE6;of5=OomUBGOoGD5cof55JomQBF?oGDeWof5IIomUGF?oI
EUSof5EIomUGFOoIEe[ofEQHomUHFOoIEU[ofE=JomQAGOoHE5oof5IKomQFFOoHEESoeeAHomIBF_oG
E5[oeU5Lom==FooGE5Ooge]MomiGI_oDCFKoeE1RomI@G?oEDeKoeE=GomABE_oDDUcoeU=OomICG_oA
DUgof51[onmAP_o_EG[okeIi0_oaEWP06_o`EgWol5Mcoo5FM?obG8Som66Aoo=QSoocH8oolebDooAK
UOobGiGokefEoneIUoo]G9Col6:@oo1QTOo`H93ol66@onmQT?o/GhGol666ooARS?ocHX[olf:8oo=P
RoocH8kolf:<0_ocHh/0LoocHXcolf>;ooAPSOocFhcoleZ@onYEU_oTD9gol5RDoo=JU?ocFi7olej=
ooAJT?odFIKolf1eoo5QAOo`EgKoidjConUAS_oVChkoi4fCome9WOoA>i7oiTIjona=MOo/C7GokTag
on]:NOo_BgSolDiboo1<M_o]BGWokd]doo1=L_oaBgKokTMmone5POo/@HGokTAooo56M_o^?X3oj3VC
onLoUOoY?Y;oj3fFonPlWOoR?jCoeT^OolMGU_o1I93obEfIolQEX_noD:_oa4ndom5N[Oo<Hj_oaf:]
ol]WYoo9KiWoa7F1ol=eMoo5MGgob7F0olUeP?o7MX7oaWZ3olMiPOo<NX?od7j;om=nSooHO9SohgZR
onegZ_oLNJKo[hFGoiR@V_nJT9[oXHfJoj>CUonMWIgoVYRSoiZEY_nHSZSoVI2VojFVW?nYZICoZ::B
ojJJT_nUTY7oXXZDoj2>UOnc[Foo]JUDok>XEonbZEOo]:MGokFVF?neYEKo]JAGokFSE_neXUOo^9mG
ok^MFOnkW5Wo^IaGok>OEon/Y5GoYjYEoj2_D_nI/dkoU[I:oiReB?nN/4WoY:Y:ojVTB?n`WTT00_nc
W4T0D_neVT_o]9a7ok6NA_naWdOo[j19ojnQB_naWdWo/Im8ojnPBOn]XDWo/:58ok6PB?nbWTSo/Yi<
ojZTAOnQ[SCoXZd/oj6^:onWYc_o/iaKokBLI?naX5go]9iMokRJGOngVUco]YYMokNJG?nfVUco]Y]L
okJLG?nfVe_o/ieNokBMGOngVUko]i]NokNKGOnfVe_o/iaLok>MG_nbWUoo/YeOokBLG_nhVEgo`9AO
olb=G_oHQV3ohh5UonYmIOo]NVCokWYUoniiIOo[OFOojH1XoneeG?ocJE3olfiKonemKoo]Pg_okg]i
onifI_o[M4WojG4donQb<ooYLcWojG<konYd?OoZMSkoiVh_on=[6OoSJa3ohVXEon9Y:OoXJCkol6@/
oo9J5_oaFaoolE@Foo1@6ooVIRgohf`?on9Z6ooRJB02on9Y700Don=Y7_oTJB7oi6TTonAZ:?oSJR_o
i6//onE/;_oTKRkohfl/on9a;?oRLBgohW4_on9`;ooRKbkohFl]onA^;ooVK3OoiW0VonEa2?oTK`;o
onA_03goi6l0000ZonA_0004ooReC?ooc6GoolaUon^66@Koi6l000?olYhcooo<IOooc6D01Oooc6D0
1Ooh]Dcoi6l0onA_0?oTK`3olYhc00;oolaU00?olYhconA_0?oTK`002OoTK`0;ooo<I@03ooReC?oT
K`3oi6l000;oi6l00_ooc6D00ooh]Dcoi6l0onjB9P02ooo<I@03on^66OoTK`3on;E<00;oolaU0ooT
K`001?o[QQWoolaUooo<IOoh]D`8onA_00?oolaU1?oTK`03ooo<I@Ooi6l000CojhHIooo<IOooc6Go
n;E<2?oTK`03ooo<I@?oi6l000Con;E<ooo<IOooc6GojhHI0ooTK`06ooo<I@Koi6l000?oiWD6oog6
Goooc6D00_ooc6D00oomaUooiWD6onA_002aonA_0011onIb4Oo]Jc7ol60doo1T??o_IcOokVLdoniU
<Oo_HbOokfTUonmb:Oo_MbookW8_onm[=OocIDGomUm;ooIOCOoeHdSolFTgoniZ9oo^JRKokV``oo1^
?OoaIcool5TZoniB5?o^C`Kokdl3oo5A3oocDbComE<fooMA??ogD3gomU<looIH?_ofGD3omF4oooAS
??ocHSSolf4doo9Q<?oaIBcol6//onm`;?o_LRookg8aoo1b<_o`L3?ol6h/oo5]<?oeJE3omVQFooEZ
D_oeK5ComFmHooAaH?obL6SolFU^onaSJ_oUH6OogE]PomUIG?oHEeSoeeIGomMFFOoGEU/00_oGEU`0
1?oIEUgofUILomYFG?oJEE/2omYFF00=omYFE_oHEEKof5=GomQCEOoHDUSof59IomUBF?oHDeWof5II
omQGF?oHEU_of5EKomUFFP02omQFF@0DomQFF?oHEESof5AIomQCG?oGE5cof5EFomQEEOoFDUWoeU=I
omMDEooGEESoeU9LomE@GooEDE_oeeAGomaGG?oED6Cod4]Qom=;GooCCU`2omEAF00TomEBEooEDeWo
eE=Vom5@IooDBfSok4J9oo9:P?o^DgKokeQioo1GMoo_F7Gol5Mcoo9IN_ocHH_om62@oo=PSoocHXgo
lUn@oo=IV?odFY[olEnEoniKUoo/FYSokV2AonmRSoo`HI3ol6>@oo1RSOo_Gh;olF26ooART?odHHco
lf::oo=PR_ocH8oolf:;0_ocHhX0OoocI8_olf:;oo=RRoocH8kokeNConA@V_oYEIOolE^@onmIToob
G8oolef=ooAISoocEYOolF1foo5Q@_o^EGGoie6@onMASooVDHgoiU6Aon=?VooB@IKohTEmoni<NOo^
C7OojdYionQ8O?o]BG_ol4eboo1;M_o]AW_okdYeoo1<L_o`BWKokTQloni8OooaBHGolDMoonloN_oY
>8gojCfFonPnV?oS?YkofDNPolaEV_o3H93o`6B:olUMUOo=FYoo`EFUokE;/?niB[Wob5JeoliQZOo;
Ii_ocVj@olmaQ?o7L7GoaW9eolQeP?o<MXOocgR9om=jRooHOI;ogWfMon=jX_oVN:GojWR]onif/Oof
LkKon76homii/OnaPZOoVHNOoiV1WOnKQ9goVXVOoi^8X?nMQigoW8fNoib?XOnKSZ;oWiRMojJZU_nW
ZYGoYjREojRWUOnWX9CoXi2Eoin;TOn`ZfGo]ZYBokF[Eonb[5Ko/JiGok>]EondZeKo/jaHokB[E_nc
ZeKo/Z]Fok6/Eonb[5Ko]:YFokFXEongYUKo]jEGokJWF?nbZ5GoZZiFojBeEOnM^U3oUKm;oi31AonD
^d[oV;M:oibbB?nXYD_o[Z19ok6MAondW4So/Ye8ok>MBOnbWDWo/:18ok6OB?naWTP00_n`WdL0C_n`
WdWo/Ii:ojnPB?nR[3;oWjhYojVV?_ndVU_o/ieRok2QG_neWEco]iaLokJLFoneWEco]IaLokJLFonf
W5go]Y]LokJKFoncWEco/iiLokFLG?nfVeco]Y]KokJKG?nfVego]i]LokNKGOnfVego]YaNokFLGonb
WEgo/IeMok:MG_nfVeco_IMMolNAHOoCR6;ogh=Uon:5J?oXPfcokg9UooIG>oohCBComeDaooEO?_o`
KUCok7Y]onZ3N_o[Q7OokGYOonYc?_oXLB[oj78aonYe?OoUL2oohfXMonMY:?oWK33ohf/kon]/A?oa
HBKolETJoo1J8_o`GROol5PLoo531oo^DBKoiVL/on=Y7ooSJB?oi6PVonIY;?oTK2gohVh/onA^<?oT
Kc3ohW0_on5b;@;ohW4]00GohG4[on5`;?oQKbgohVl]on=_:`02on9`;@03on=^<OoQLB_oh7X=0?oo
i6l0?ooTK`0002[oi6l000Con;E<ooo<IOooc6GojhHI1_oTK`001?obWS?oolaUooo<IOol`5P4ooRe
C005oo>S>OoTK`3oi6l0onA_0?o^TRH00_ooc6D00oocXcWoi6l0onA_0009onA_00?oolaU1Ooh]D`0
1?oj^U;oolaUooo<IOoh]D`4onA_00;oolaU00Gon;E<onA_0?ol`5SoolaUooReC002onA_0003ooRe
C?ooc6GoolaU00?oi6l000CojH4Cooo<IOooc6Gon;E<2?oTK`02ooo<I@03oog6GooTK`3oi6l000;o
i6l00oooc6D7onA_0004onV14oooc6GoolaUooReC0Soi6l00_ooc6D01OomaUooi6l0onA_0?oTK`3o
mJTo00;oolaU00Cok8`PonA_0?oTK`3oi6l01_obWS<6onA_0004oo>S>Oooc6GoolaUoog6G`;oolaU
00?olYhconA_0?oTK`00/?oTK`00AooUL0Cojg8/onmS=?o`HSSol6HloniX=?o^IcCokVDbonmS:Oo_
IbCokfdXonma:Oo^LB[okfhboo=Z@_oeHdSomEi8ooEMAOobI3WokfXZoniZ9_o^JR_okf`foo1/@?o`
HccokePXoniC5?o^D0GokU42oo1C3_obEBSomEDhooIC??ofD3_omU8jooIF?OofG47omF11ooEP?ood
Gcgom5hjoo=O=oobHC7olF@]oo1Z:oo_KB[okg4/onib:_o`M3;omG9JooI^IOoeJe[omFYGooEYEOoe
JE?omFYBooE]EOoeKUWomFmOoo=^IOoaK6[okVIWonMSIOoTGfGoh5YNomUGE?oFEE3oeEE@omIED?oF
EE;oeeAE00;of5AF00cofEEHomQEF?oHEEOof5AHomUDF?oHDUWofE9IomUCF?oIEESof5MIomQFFooI
Ee/2omUGF008omUFF?oHEESoeeAJomUFF?oHEUWoeUALomICFOoGDeP2omIBF`2NomMEF_oGE5[oeU9J
omEAGOoGE5[oeeAGomMDE_oFE5godU=Jom9@G?oBBf3oddeKomEBEooFDeSoeU5KomM@JOoDC6Oodd]D
omm8N_ocAi3ol4UkoniBM_o^EWWol5Ifoo5HN?ocGXKom6B<oo=RRoodH8kolf6<oo=RR_ocG9KomERL
oo=MUoo`GY?okebFoniMToo_HHkokf:?oo1RT_o`HXkolF5noo9PPOodI8kom6>:ooAQRoocH8com5f@
oo=PT?ocHXkolf6?oo=QS_odH8golf6@oo9PT_oZEIWoie6Koo5HU?oaFY;ol5^Aoo9NSOobGHkoleZ>
oo=HU?oaIGOolF=5onaCM_oTDI3ojDn@onYBT?oZEXooj5>Fom]8VooM@hOojDQnon]9OOoZBGSojdMk
onm8N_o`BW;okdQhonm7Noo`BgColDaconm8NOo]Ag_okTaloo9=O_oa@h7ojSJ>onDkWOoRA:3of4VQ
ol]EVoo3HY7o`VB<olANU?o6FYko`eFVok]CZOndCjco^E6_olMNYOo=JhoobW1nolMcM_o3LfgoaGA`
olmfQ?oIN9Woh7ZOonQjYoo[Nj[okWZ]oo9h/OocMKGol7Ffonmd]OoaLKKomW6fonie/_o7P:KoW8NJ
oi>;VOnMRY[oWhBKoif4VonPQ9_oX8FJoif3V_nMPYcoWX>Ioj23T_nRTY;oZ:RBojRZTonXZICoYZ^G
ojJZUonVXiWoY::AojN^FOnaZ4_o]jQJokFXEoncZEKo/JaGok:[EOncZUKo/jUFok>ZE_ndZeKo]:YF
ok>[E_ncZeGo/ZaFok:]EOnc[5L2okBZE`0ZokFYFOneZUSo]:aHok2`EonY/eKoX;UDoiG2COn?aTSo
TL5;oiBlBOnJ]TSoXj]9ojbRBonbW4[o/i]8ok>MB?ndW4Wo/Ye7ok:MB?n_X4So[J99ok:MB_naWTKo
YJXdojFY?_nfVf;o/ieSok2PG?ngVego]i]NokJLG?neW5co]IaKokFMFoneWEco]YaKokFLFondW5_o
]9eLokNKFongVeco]IaL0_nfVe/0@oneVego]Y]MokJLGOnfW5go]YaNokNKGOngVUco^9]OokJLH?nd
W5go/iaLok6NGOnbWUoo/j5Rol:GIOoVK6ComdE=ooI<;?ogFB[ome@`ooM@;oogD2gom5`foni^AooV
OecoiHU]onV7K_o[NU3ojG<bonE_8_oSJakoif@Voo5]7?o`NSookFm0oo5L8Oo`F1col5`Soo1M9?o`
GRGol5TLoo192_oc<@Gom3HJonYQ<ooTKRcoi6haon=_;ooQLRgohG8^on9a;_oRL2_ohVhYon=]:_oR
KR[ohVl[on=_;OoSK2_ohVXXon=]9ooRKbWohW4[on=`;_oTKC;oh7`Jon5k1ooTL000oooTK`0nonA_
0000:_oTK`001?oh]DcoolaUooo<IOo[QQT6onA_0004oo:N<oooc6GoolaUoo:N<`Soi6l000CojH4C
ooo<IOooc6Gon[YB2ooTK`03ooo<I@Goi6l000CojhHIooo<IOooc6Gon;E<1?oTK`02ooo<I@05ooRe
C?o^TRKoolaUooo<IOo[QQT00_oTK`000ooh]DcoolaUooo<I@04onA_00?oolaU1ooTK`001?o[QQWo
olaUooo<IOoh]D`4onA_00?oolaU2?oTK`03ooo<I@Ooi6l000CojhHIooo<IOooc6Gon;E<0ooTK`00
1?o`V2coolaUooo<IOoeZCl>onA_0006onMk3Oooc6GoolaUooo<IOoWN`goo<1H0_ooc6D00ooWN`go
i6l0onA_002`onA_001NonQe7oo_IcKokf8doo5T?Oo_Ic_okVLboniW=Oo^IC;okf8ZonmU9Oo_JbOo
kg0Yonib:Oo_LBoolfm2ooEYC_oeHT[omEa5oo=N??o`I2cokVPToni[:Oo_K3;ol6`loo5X@_o`HCSo
kUXWoniC5?o]D0?okE<3onmD3_ocERGomEHgooID>_ofDSWomU8hooID>_ofF3comUXmooIM?_oeGcgo
mEhmooAL??odGCSolelcoo9S;oo`JBSokfdXoo=_CooeLFcomG9VooEaI_oeL6ComFiOooE[F?oeJECo
mFUAooEYD?oeJToomFaAooE]DooeL5Kom6eNoo9WHooZHV7oi65Pon5NHOoPFekog5QGomIFE?oEEE7o
eUEBomIDEOoFE5KoeeAFomQDF?oHEESof5AHomQAFooIDU_ofEAJomUGFOoIEeOof5MGomQFF?oHEUWo
f5EJomQDF_oIEUWofEMGomQGFOoFEUgoe5AKomIDF@;oeU9K08WoeeAIomICF?oFDUWoeE1KomMCF?oH
EESof5EGomEDFooBEUSodeIFom9@GOoBBf;odd]SomE=GooFCF3of4aPomI;GooCC5;oeTYOone:T?oc
AY3okTIkoni=Moo^E7SolE^2ooART?odHhkolf:9oo=QR?ocH8colf:=oo=OTOodFY[om5^Hoo5NU?o`
GI?okEbConiOSoo_HXookf:Boo1QS_oaH7golUn3ooAPTOodHY7om62>oo=PS?odGHkolen@oo=RSOoc
HHkolf:<oo=QS?ocGi;okEfHonUGVoo/EYKolUZAoo9KTOocG8oolej<oo9MSOocFXkom5VDoo9WM?oa
IDSokE=jon==U?o[DI3okUBAonaIS_oZEI;ohTfMomM1UOoV@ggokdQloo19Noo_AGcokdMfoo1:M?o_
BGSol4Yfoo1<L?o`BWGokDQione9N_oaC7[olDMnon`lTOoN@ioode>JolELUOo1FiSo`ebEokYRUOnf
HIWo^EfPokeIX_o3DZSoaEFSolQTT_o9LHOoaGQhol9fJ_nnM6Oo_GM_ol1jMoo4OWkobH6<om22SooB
PXgoeH>AomZ2V?oNPIkohGbPonEjYOoZMK;olG6moo5b^OoUNZoo^hJQoiN8V?nHQIWoWXBKoj24VonN
Q9coX8>Koj:3V_nPPY[oWH>Koij4UonQPi7oY8:>ojJCS_nZXXcoZZ:>ojRVTP02ojNXU00;ojRYV_nW
/H_oXK5<ojF/@?n^[EGo]:]IokFYE_ndZEKo/J]Eok:[EOndZUH00_ndZED2ok>YEP;o]:UF00Go/jYG
ok>ZF?ncZEKo/Z]Iok>ZF002okBZE`0YokFYEonfZ5Ko/j]Fojn]Eon^[eKoYkEEoijlDOnBa4[oT<E8
oi?0B_nH^DWoWk17ojVWBOn`Wd[o/ia8ok>LAonaWTOo/:18ok6OB_n_X4;oZj=3ojjQF_nbWf?o/ieK
okNKG?nfVeco]YaMokJKG?ngVeco]YYLokJLG?neW5go/ieKok>NF_ndWEco]YaKokJKF_neW5_o]Y]K
okNKGOnfW5h00_nfVe`2okJKF`0PokFKG?nfVe_o]iaNokRKG_nhVUko]iaPokNNHOneWf;o/J=Qok^D
G_oHHe7omCI:ooLb;_o^JBKokG``oo9Y;_ofFS7ome<booMB;oogDbgom5Xaone/?OoRQUKoh9M`onJ7
KooWKCkojFDWoo5T5OoeLR?olW@^oo1M8Oo`FAh2oo1K8P0Loo1L8_o`GBColU<GooA10oof9@3omaH0
one?:OoSL2[ohW0[on9_:OoTK2WoiFXYonAY:?oUJR_oiVXXonIV8OoVJAcoj70Konaf6Oo]NA?okWl:
onj40OoVMR7ohW0Yon=_<?oRM2Koh7l=on9g1_ooi6l0?ooTK`0002[oi6l000Con;E<ooo<IOooc6Go
jhHI1_oTK`001?obWS?oolaUooo<IOobWS<9onA_0004oog6Goooc6GoolaUon^66@[oi6l00oooc6D5
onA_0004on^66Oooc6GoolaUooReC0Coi6l00_ooc6D01?oh]Dcoo<1Hooo<IOoh]D`3onA_0003ooRe
C?ooc6GoolaU00Coi6l000Con[YBooo<IOooc6GokY8V1_oTK`001?oeZCooolaUooo<IOobWS<4onA_
00?oolaU2?oTK`001?oj^U;oolaUooo<IOo^TRH6onA_0004ooFY?oooc6GoolaUoo:N<`?oi6l000Go
jH4Cooo<IOooc6GooLIOonMk3@0=onA_0006ooReC?ooc6GoolaUoo:N<ooTK`3okY8V0_ooc6D00oog
[dGoi6l0onA_002`onA_000konEb3?o]K3;okf8coo1S=_oaID3okfPhoniV<_o^IcKokVDdonmR:Oo_
IRGokf`Yonm_:Oo^LBSokg8_ooA`@_ofK53omFMAooEOBooeFT3olE`[oniR8Oo^JBCokVd^oo1]=_oa
JCgol6@monmP=?o^FbOokU@Eone@1?o]D@7okU<<oo5G8OodEcGomEDkooIC??ofDS[omU@jooIH??oe
FcgomEdmooEN?_oeGSoomE`oooEJ?_odFSKoledbooEPB_ofI5oomFULooA]G?odL63om75SooEaI?oe
L6;omFiNooE]F_oeJUH00_oeJE@0GooeJE;omFY?ooE]D?oeL5?omG5GooA_G?ocK67okfERonAQH?oP
H63oh5]QommHG_oJEeSoeUIComADD_oCDe?oeEADomECE_oFDUOoee5JomMEFOoHEeOofEIHomQFFOoH
EU[of5EJomQGF_oJF5SofUMHomQFFOoFEEcoeEIHomIGE_oEEE[oeE9KomICF?oGE5SoeU=HomA@G?oF
DU[of5AHomQEF?oFDegodU9JomAEF?oDE5[oe51Oom=9H_oCA6?oeDMSomM<G?oFCEWoeDeIomA=D?oO
BGGom4bGoo58Soo^AGcokT]goo9KR?odI93om6:=oo=PSOodHHcolf6<oo=QSoocH8oom5bDooAKV?ob
G9Gol5fConiLU?o^Gi;okf6@onmPU_oaGi7olF1loo9PPOodHHkolf:>oo=SSOocHH[olej<oo=QS?oc
Hh_olf>:oo=RROocHX_olenBon]HW?oZFYSolEfCoo9KTOoaFi7oleb?00;olef=05coleV@ooAHUOob
IW3ol6I8oniFO?oUC9CokE6AoniGT?o^FXook5JBonE?VooOAYWok4Enoo58M_oaB7gokTIlonm8MOo`
Bg?ol4]eoo5<Loo`C7;ol4Ubonm7M_o^B83ojdZ5oma<R?o:EI7o`F6BokUTSOnjGICo_eZIokiQUone
JYCo]VRGol=MWOo=FYkod6BEoleaQ?o3MWgo_7aiokQnL_nkNFco`7Ucol20OOo3Ph7oa8:1ol:4Pono
QGco_X=iol24O?o2Q83o`HF3ol:6Qoo7PhoocGnFom=oV_oBPYWo/HZKoiF>W?nKQIooXHBMoin4W?nO
Pi_oXH>Joj63VonPPIgoWh:Joj:2U?nSPI7oX8:@oj67T_nWW93oZZ:=ojVLRonZWhgoZZ>?ojRUT?nV
XicoY[24ojB`AonR[ccoXK97ojRbDOn^[EKo/jUEokBXE_nbZUSo/ZYGok>YEondZ5Oo]:UFokBYE`;o
]:UH07;o]:YGokBYE_ndZUSo]:YFokBYEOndZ5Co/jUDok>ZEoncZeGo/JaFok:/F?ndZUOo]ZYJokFZ
Fon`[EOoZk9Eoj:iDonH`DkoTl9;oiBoBOnK]TWoXj]9ojNXB_n]XTWo/ie7ok:MAonbWE3o/iiMok:O
H?nbWUco]iYKokNJG_nfVeco^9]MokNLG_ngVeco]i]MokJKGOndW5go]9eLokFLFonfWE_o]YeLokFM
FoneW5_o]Y]JokJKG?nfW5co]Y]KokJLG?nfVego]Y]LokJJG?nfVeoo^9YQokNKH?nlV5co`Y1IokRK
G_ndX63obWmHoni2A_oh;3kombm3ooHn:oo[N2Soih/fonR4<Oo^O2kom6``ooIL<_ogE3;ome<aooMB
<OocEc;ojfTmonEmDooaM4Oolf@Yoo5M9?odHBSomVdUoo9K8Oo`FR;olEXQoo5H8OobER7omDhGooI=
1?odC0?omCd:ooH[3ooc=aOojeLTonMV9_oYIB3ok6DIoniT4Oo_I`col749oo5j2?oaP0KolXH7oo:9
2?ocR@Kolhd2oo:?1ooYOR[ohg4_on=_;OoRKbcoh7`Fon202ooRM`KoonA_03ooi6l0000ZonA_0004
ooReC?ooc6GoolaUon^66@Koi6l000ColYhcooo<IOooc6GolYhc2OoTK`001OobWS?oolaUooo<IOom
aUoojH4C00Woi6l00oooc6D5onA_0004on^66Oooc6GoolaUooReC0Coi6l01Oooc6D01Oo[QQWoi6l0
onA_0?oTK`3on;E<00;oolaU1?oTK`001Oo^TRKoolaUooo<IOomaUooiWD600Coi6l000GojhHIooo<
IOooc6GoolaUonMk3@04onA_00?oolaU2?oTK`001Oo^TRKoolaUooo<IOomaUooiWD600Coi6l000Go
jhHIooo<IOooc6GoolaUonMk3@04onA_0005ooReC?ooc6GoolaUooZjD_oVM@H02ooTK`001Oo/S23o
olaUooo<IOomaUooiWD600;oi6l000Con[YBooo<IOooc6GojhHI/OoTK`00T_oTK`;ojW<XonmU=Oo^
I33ol64ioo1W@?o^J3CokVLconiW=Oo^IS?okf<YonmT9?o_JbSokfhXoni_9_o_LBoom751ooI^COoe
JdkomFEAooELB?obEBWokUXHoniR7?o^JBOokfdaoo5Z>_oaICgol68honiQ<_o^GB[okU<FonaA1_o/
DP7oke@=oo5H8_ocFC?omEPlooEE>ooeE3[omE<iooEF>_ofFCcomU/mooEN?OoeGckomEhnooEK>oog
FD_on5QJooQJF_ogGUWomV=HooEYFoodKEgom6iOooA`H_odLF?omG5QooA_GOoeKUcom6eKooAZFOod
JUSom6UGooAZDooeJdoomFi?ooE`D_oeLeOom7=LooA^H?ocJF3okFQRonIUIOoQGfGoh5]RomiIGOoI
F5SoeUEEom=BEOoBDEKodeAFomIEEooFEEKoeUEGomMEFOoIEeOofUMFomYGFOoIEEcoeUAMomIFF?oG
EeOoeUIJomACGOoFE5[oeU=KomMBFooFCegoee5MomQCG?oIE5[oee5Mom=?G_oDDU_oeE=IomEAE_oE
CeKoddYRom95IooCAF?oe4YHomM=FOoECU7oeD]Hon];QoodCYSokdR=onm3N_obCh;om66<ooASSOod
HXkom66>oo=RSOocHHcolf6=ooANT_ocFiOom5^Eoo5LUOo_FYKokebEonmPT?o`HI?olF6>oo5RN?ob
HWgolf:9oo=SRoocI8colf6<oo=ORoocH8colf:;0_ocHhX0IOodHXkolUjEonYHW?oZFIOolEnBoo=M
T_o`FY3oleb>oo9MSOocFhoom5VAoo=HUOobIG7olFI<oneFO_oUC9?okE>@onaHS_o[F8kokERBonI?
V_oSBY_okdZ4oo59LooaBGWokdMloo19Moo`BWCol4]coo1;L_o`BG;ojTQmonE7SOoIE8_oaV20okYQ
Q_nlHY?o_ebGokaLVOo0H9[oa6FHolQ[TOo@I9OodEFRolaHX_o:JYCob7>;olIcSOo4MHko_X23okf2
O?o3OGooa7f3ol9oQoo4OXGoaGn3olB1QOo3Q8Koa8>4olB1Q_o3PhSo`8B8okj5ROnoQ8Oo_8N4okf8
OonlR8?oYHV@oiV8WonPQj7oWhFKoib2W?nOPicoXh>Loj22W_nQPYWoY8>DojF2T?nVPY?oYGnCojF8
TOnXX93oZZJ=ojVPS_nYWHcoZYj<ojZQS?nUW9SoYJmkojF_@onT[T3oXZm2oj:bAonV]5;oZ[5Aojj]
EonbZeWo/ZYGok6/EoncZUOo]:YG00;o/j]F00Go]:YGokBZE_ndZEGo]:UEokBZE@02okBYE@0MokBY
E_ncZUSo/J]Fok:[EOnbZeOo/:eHok6/F?nbZUWo]:YHokJXEoneZEOo/jYGok:[E_n[/eGoX[MBoibe
BonF]DKoVkE6oj:`A_nXYDcoZj9JojjSH?nfW5_o^IUJokJKFonfVeco]i]LokJKFoneW5`00_ngVe`0
1OneW5co/iaKokFLG?ngVego]YaL00;o]IeL0_neWE/2okFLF@12okFMF_neW5_o/iaMokBKGondW6;o
/iaRok>LHOnaWEoo[j9KoknCEOoGJT_og61>oo<nA_og=4;omS]>ooLbCOofAR[okG/YonV6=?oZQC7o
jhhdonZ2<_oeMbSon74YooQW:OohG2[on5DWooMA9oodDBOomEX]ooMQ@?oeFcSolVD/oo>5;?ocKB3o
lEHEoo9G5oocEQKome0:ooME0_odIPOolFd>oo9d3oobJ`[olU/2oo9S0?obLP7olWX3oo>01OocR0Wo
lh`;oo>;3?obRPcolXX=oo::3oobR0kolhX9onn74OoSN3GohFlaon9_9ooTKS7ohGHQomn23_oPOP_o
hg82oooTK`0oonA_00009_oTK`04oo:N<`04ooc0F?ooc6GoolaUooFY?`?olYhc00CojhHIonA_0?oT
K`3olYhc0_ooc6D00ooh]DcolYhcoo:N<`03oo:N<`06onMk3OoTK`3oi6l0onA_0?oVM@Kon[YB0_oo
c6D00oomaUoolj<ion^66@02on^66@;olYhc0ooTK`03ooo<I@Goi6l000CojhHIooo<IOooc6Gon;E<
1?oTK`04ooo<I@03ooReC?oTK`3oi6l000;oi6l000?on;E<ooo<IOooc6D01OoTK`001Ooj^U;oolaU
ooo<IOomaUool9P/00;ojhHI00Golj<iooo<IOooc6GoolaUoo>S>@05onA_00?oolaU2OoTK`001Ooj
^U;oolaUooo<IOomaUool9P/00;ojhHI00Golj<iooo<IOooc6GoolaUoo>S>@05onA_0006onV14oom
aUooolaUooo<IOomaUoolj<i0oo[QQT00oo^TRKomJTooo2H;004onA_0004ooc0F?ooc6GoolaUoo:N
<`?oi6l000CojhHIooo<IOooc6Gon[YB/_oTK`001_oWM1OokVTdoniU<_o_Hc;olF4nonmY?@;okVLc
03;okVLfoniV=?o_Hb[okfDVonmY:?o_JbKokVhTonma;?odLD7omW1;ooE^BooeK5;omVA@oo=H=?o_
E1KokUTBoniQ7_o^JB[ol6deoo5Z?Oo`Hc_okf<goniT=?o^GB[okU<Eone@1Oo^C`;okeD=oo1I7_ob
FRkom5XiooEG>ooeE3_omE<kooEE>_oeF3comE`mooEP?_oeH3[omf5;ooUOGOoiFeWonEMFooUFEOoh
F5KomeeGooISEooeJE[om6]LooA^G@?om71N01Oom6mMooA^GOodKEcom6]KooA[FOodK5_om6]JooE]
G?oeKEOomFa@ooE]COoeL53omG9FooAaFoodL63olfaQoniZI?oYJFOoiV9Xon5KIOoJF5oof5QHomIF
EP02omAED`0UomIEEOoGE5Sof5EGomMCFooEDUooeUAJomMFF_oHEU_oeU=NomMCG_oGDegoee5NomI=
HOoGCekof59LomUBFooGDEcoe4iLom=?F_oDD5OoeE1FomIBFOoEDEgoe4eLom97I?o?@f?odTQMomE;
FooDCd_og4Y`oo9<TooaC9?olDJ6oo97P?ocE8[om5j=oo=RR`02oo=QR`0Aoo=RRoocHH[om5n?ooAK
UoodFISole^Doo5LU?o`G9Cokf2?oo5STOobHhcolF9ioo9ROOocHXOolf:9oo=RRoodHXd00_ocHHX0
JoocHHcolf::oo=SR_odHI7okUbGon]IVOo]FiKolF2?oo9PT?oaFi7olU^?oo5LSoobFY;ole^@oo1I
TooaHWGolFA>onaCPOo/CYCokUFAoniFT?o/EXookUR>on]BUOoRBYgokTbAoo5:N?o`BWGokTUjoo59
NOo`BWCol4YconY:OOoHD8Coa5N<ol5NRoo6HhgoaVF@olQPU?o9HIWoaEnHolMOW_o@IJ3odF^ComEO
VOoDCZWobURTolU]Too:M8ooagFColAjS_o4OXCoaGj1olAoQ?o3OhKo`Gn1ol=mP_o5OHGoaGb4olEm
Q_o5PH[oaH6;olB1R_o4PHgo`h:;ol:3ROo2Phco`HB=ol>3Roo3PXKo_8B>ojB5V_nNQY_oX8FJoib3
VonNPYgoXh6Koj>0U_nTPY?oYH:CojB2TonUPi?oYh2Coj>7T?nWWHkoZ::>ojNQSonWWHkoYiV=ojJH
SOnTU9SoYZIcojJ[>onU[3coYJa1ojB^@_nT/TgoY[ECojJdD_nY/E?o[JmDojf_EOn^[UKo/j]FokFZ
EoncZeOo/jYE00;o]:YE06oo]:UFok>YEondZEKo]JUHokBYF?ncZEKo/jUEokBYE?ncZUOo/ZYGok6[
EonbZESo/ZYFok2/E_na[5Oo]:YGokNXEongZ5Ko]ZUGok6YEon]XTkoYZE6oj2]B_nK[UGoW:]Hoj>W
EonZY5[o/:5Kok:NG?neW5_o]i]JokJKFongVe_o]YaKokFLFondW5_o]I]LokJKFonfVeco]Y]KokJL
F_neWEco]YeLokFMFoneWE[o]YaJokFLGOnhWEoo`Z1MolBPG?o2X5ko`J1JokfVEoniY5Go/iYAolIk
B_of<33onALYooHb<_o`@ckok4mEonMKCooaN37olHh`onb8<_o[Qc?ojgL_onma8_ohVb3onZXSoo^O
8OojTQkonH@JooUk5oohKASon5TQooQD;_ohFC?olF`hoo6C>_ohSR7om6<4oo=L0oobI@7olg<1oo:1
2?oaQPkolH<>oo663?oaR`colH`<oo:?3OobSPkolXd?oo:<3oobR@oolXL>oo:83oobQ`kolXH>oo:7
3?obR0KokH<Eon5f<ooQL2gohVlTon=_;_oRKbkoh84Fomn33OoRM`H0oooTK`10onA_00009_oTK`0;
ooo<I@04oo:N<ooTK`3oi6l0oo:N<`SoolaU00?ojhHIonA_0?oTK`000_oTK`000ooWN`gon[YBooo<
I@06ooo<I@04ooReC?oTK`3oi6l0onA_00?oolaU1OoTK`001?o[QQWoolaUooo<IOoh]D`4onA_00Co
olaU00?ojhHIonA_0?oTK`000_oTK`000ooh]DcoolaUooo<I@05onA_0003onMk3Ooj^U;oolaU00Oo
olaU00?omJToonA_0?oTK`001?oTK`03ooo<I@Woi6l000?oig/=ooZjD_ooc6D01oooc6D00ooeZCoo
i6l0onA_0005onA_0003onV14oomaUooolaU00OoolaU00GolYhconA_0?oTK`3oi6l0oo:N<`02ooo<
I@03ooc0F?oTK`3oi6l000?oi6l000Con;E<ooo<IOooc6GokY8V/OoTK`00<?oUL0Gok70_onmS=Oo^
IS;ol60foo5T@Oo_J3SokVHboniW=?o^IcOokVLeonmT;oo_I2OokfPXonm/:?o^KRCokfl[ooAa@_og
LTkomFm9ooE[BoofIe;om5m3oo5C7oo^D@kokULBoniQ7oo_JbkolF`ioo5U??o`HSSokV@boniS<_o_
FbSoke8Foni<1Oo/D0;okUD;oo1H6oobFRcom5TiooEF>ooeECcomE@looED>_oeECWomEPgooMNB0;o
nF9O00conF5KooUNFooiFU[onEIFooUEE?oiEe?on5]CooIRE_oeIe[om6]LooA^G_odL5d2ooAaGP0;
ooA`G_odKUcom6eKooA[F?odJUOomFQFooAWEOodJUWom6aJooA/F?oeKEH00_oeKUH03ooeL5GomG1F
ooE^F_odKV;olFeUona/IooZJ6[oj69]onALJ?oMEfKof5AOomMEF?oFDeWode1Lom=AF002omEBF00O
omAAF_oEDEcoeU5LomIBGOoECf3oeDeQomM>GooHCUooeTiLomA;F_oDC5[oe4mHomA?FooED5ooe51I
omEAEooCCe_ocdMPola3I?o?@VWoddUIomA;F_oXB8[olDZEoo=6U?odAX_om4b;ooA@S?odF93om66>
oo=RR@02oo=PR`20oo=QR_odGY3oleZGoo=KU_ocG9Gol5bFoneMU?o_H9?olV6:oo5QNoobHWoolf:7
oo=PRoocH8com6:>oo=RRoocHHWolf::oo=QRoocHXgolUjGon]IV_o^GI?olEnCoo=QSoocHh_olen@
oo9KT?ocG8kole^?oo9KS_oaFY7olV9koo1PB_oYCh?oke:Coo9HT?o_EhookER=onmISOobEY3oiDVN
onU>V_o_CGookTYboo19L_oaB7SokTZ2ommFP_o5HH;o]627okUKSoo6G8_ocf2<omIQVooDI9oo_F^C
okE/S_o0Ii3ob6Z<olaPUoo2DZKo^F6LokelR?o4PHOoaGf?olEmRoo6OHCob7f0olMjOoo3O8?o`Gn1
ol9mOoo6NX7oaW^5olIlP_o6OH?oaGf6olAoRoo4P8ko`h6<okn4QOo0PhKoa7n>olF1T?o2Q8ko_8B7
olb0TOoFO:go/8>Roi^6VOnPPY[oXH2Goj5oT_nRPI7oXh6Coj>0T_nTPI7oY7nBojAoTonRSI3oYY^>
ojFIT?nUW97oYIjBoj>LTOnRUY7oY96KojRQM?nW[3SoYZdgojF/>onT[C_oY:i1ojNaCOnX]5;oYKA@
ojJdDOnZ/E?oZk1Fojj^EoncZe[o]ZQJokBYF?ncZEOo]:UFokBYEondZ5L2okFXF@03okBYEOnaZUKo
]:UH00;o/jUE05Ko/JYGok:ZEonfYeSo]:QEok2ZEOnaZeKo/ZYFok:[E_nbZeGo/Z]FokB/FonhY5Ko
]iM<ok>HDon]X5oo[J1Poj^PG?nSYUWoXJMJojJUFOnZXeWo/:5KokFMFOngW5_o]YeMokFMGOngVego
^9YNokJKGonfW5ko]YaMokFLGOngW5ko^9]OokNKGongW67o^9aPokBLH?nfXUoogjm?ooF_?ooa[3oo
kji0oo2a@?o/Z3ool8H`ooAc9oogKRGon6TPooMQ7_ogDQSokULNonEh;Oo^SC;olI/jonnR>OoZNbSo
kV4BooVG5?ok`2?onl<Soo[58Oojab;on/<QooZi7_oj]A[onYhGooY`5?ojH1GonGDPooR:;?olWboo
n94FooAm1_ocP`WolYD?oo6M4ooaVAColXdBoo624?ocQA3om8dAooB84?odO`kom7h=oo>43P;olXH>
00kolXL>oo:53_obQPcolXP6onj67OoRO4SohW<jon9`9_oSL2[ohfhaommi7OoOP0cohGP7onA`0Ooo
i6l0@?oTK`0002Koi6l02oooc6D01?obWS?oi6l0onA_0?obWS<8ooo<I@03on^66OoTK`3oi6l000Co
i6l000?okY8VooZjD_ooc6D01?ooc6D01?ocXcWoi6l0onA_0?oTK`03ooo<I@Goi6l000CojhHIooo<
IOooc6Gon;E<1?oTK`03ooo<I@03ooReC?oTK`3oi6l000?oi6l000?on;E<ooo<IOooc6D01_oTK`00
0ooVM@KolYhcooc0F004ooo<I@03ooZjD_o^TRKoi6l000Koi6l00oooc6D:onA_0003onIe1_obWS?o
o<1H00CoolaU00?on[YBonjB9_oTK`002?oTK`000ooVM@KolYhcooc0F005ooo<I@06oog6Goo^TRKo
i6l0onA_0?oVM@KooLIO0_ooc6D00oo^TRKoi6l0onA_0003onA_0005onMk3Oooc6GoolaUoog6GooV
M@H0/OoTK`00?ooYLb?okf@eoniV=?o^I37olElkoo1X@_o^IcCokVHconmW=Oo^J3KokfPhonmU;_o_
HbGokfLVonm[:?o^KRCokfhZooA`@_ogLdoomW18ooE[AOofJU7omFQCoo=K<oo_DQ?okU4;oniH4_o^
HR3ol6Taoo9W?OoaHS_okf4aoniS<?o^Hc?oke//oniC6_o^B`GokTh1oniD2_o_F1[olEXXooAJ=_oe
F3comELnooEE?OoeECSomUI3ooUHF?oiFegon5iKooQRGOohHeoonF5OooUNGOoiFeWonUIFooYEDooi
Ee7on5aEooMRF_ofIegomFYNooA]G002ooA^F`09ooA^G?odKE_om6]HooA[FOodJe_om6]LooE/GOod
Jecom6]K00;om6]L04;om6aLooA[FoodJeSomFiJooE`GOoeL5_omG1JooE_GooeKFGolV]Xone[JOoZ
J6_ojF9_onELKOoMF6CoeeEOomABFooCDESoe55FomA@F_oED5[oddiLom=<GOoDBUkoeDYMomE:G?oC
BU_odd]JomA>FooECf3oe4mLomA?F?oCCecodTmJom9>F?o@Be_ocD=Voli0Joo?Ae[og4Ihoo58UOod
A9Gom4JDooA<TOodCHkom4jAooAGTOocH8_olf>;oo=QS?ocHXcolf::ooAOS_odGY7olejBoo9LU_o_
GIKokUjGonmORooaH7colf63oo=QR?ocGhgolej@oo=PS_ocHh`2oo=QR`1:oo=TS?odHI7okERMonUF
W?o`H97olV6Boo9PT?ocHh[olf:=oo9NTOocG8oole^?oo1KSooaFi7olf9goo5PCOo/DHKojE:Coo1H
S_o_F8kokER=oneGSOodE9?oj4ZMonA<W?obD8Gol4Qdon]8OooKDHSob6F2oki]NonkHXGo`5>BolQG
TOo=HHSocfF3om=PToo;HjGo]FnFojabQOn]LGooZFR3oj9OWOnUPi?o[iemok>ONOndT7co]hF2okb3
P_nmPWko^X9nokf2OonoPX7o_H5ool1nOoo2OHCo`H66okn6POo2PHOoaWZ=olEmS_o2PHco_h:9okn2
Qoo3PHWoa82<ol:1Roo0Q8co_8B:omImW_ojM<CohgRjojn1WOnMPY02ojF1S@;oX86B04GoXX2Boj9n
TonRO9?oXgjBoj6@T?nTVY3oXiF@oj:GT_nSVY;oY9fCoj:JU?nTUI_oZZAfojN^??nV[SWoYj`lojF]
>_nT[C[oYJdoojR`C?nY/UCoZ;=DojJdE?nX/e?oZ;9BojRbEOn_[5So]:QGokFXEondZ5Oo]:UGok>Y
F?ndZESo]:QGok:YE_ncZEOo]:UHok:ZE_nbZUGo/JYFokFXEOneYeSo/jUGok:YEOneZ5Ko]JUGok:Z
Eon`[5Ko/JUDokBYE_na[UOo[JYIojjOGoneVf3o^iUQok^HH?ngVEoo/YaOoj^PG?nWXecoYZALojRR
FonYXe[o[j5Kok:PG?neWeco]YiMokNMGonfWEh00_nhVel0AonhVf3o^IYOokNLH?ncWUgo[j1IojfS
E_nYYU?o^Zi?on2iAOoh_Ccon;/jooRg>oog^3_omkloooO5@oogbTComlU5ooO8A?oha47on9`/ooQO
5?oZI1[ohh`YonN@:?o`OAGonZDDoo[@:?ojdR[on<`WooGD:_ofeR[oll`Yoo>h:OofXRGomjDOooB>
7OoaTB_okZ0doo:8<?ogS3SonZHjooVN9_oiUa_on9HJooJ<6?oePQSomGPHooEc5oofLAGomfXBooMW
4_ogIQ;on6HAooI`4?ocQPoolHX?oo:83oobR0golHP=onV8;ooRRVcoiHaionN8K_oUPVCoiGQKon5c
@ooMQacogh4<on=i2?oUMP?oi7000?ooi6l0?ooTK`0004Koi6l000CoiWD6on^66Oo[QQWojhHI:_oT
K`001?oYPA?ojhHIon^66OoWN`dIonA_0004onV14oo[QQWojhHIonMk3@koi6l000Goig/=on^66Oo[
QQWojhHIonIe1P34onA_001^onIb4Oo^JC?okf<doniX<_o_H37olV50onmY?Oo^IS;okVLconiW=?o_
IcOokVPgonmU;oo_HbGokfHVonm[:?o^KBGokfdYooA^@?ofLToomW19ooE/@_ofJd[omVeGooAUB?o`
FR;okU<>oniA2oo^F1?okf8Roo1W<_oaICcol64goniR<?o^IC;okf8eonmK:_o_DAWokdX8oni>0oo^
E0WokePHoo5K9_ocFS;omEPlooEF>oofETKonEMKooUFG?oiEUSonEUKooUNG?oiHEoon69PooQRHOoi
H63onEmOooYKFoojEUGonUABooYED_oiF5GomemIooIVG_oeJUkom6aKooA]FoodKUgom6iNooA^G?od
KEcomFiNooE]G_odKEcomFiOooE]GoodK5com6aKooE[G?oeK63omFiQooE^GooeKUkomFeKooE/F_oe
KU_omFmKooE`F_oeKU_omFiQoo9]Hoo]KFOojFM/onMOKOoTG6WohEUVom]EH?oECecoe4eGomA=E_oD
CEGoe4aFom=;E_oCC5Koe4mLomEAG?oDD5Ooe51HomA?G?oCCeX2om=?E`2@om9=FOo@AfSoc49[olm2
JooY@Xkom4B@ooA6TOodBi7om4f=oo=>R_odD8goleF=oo=NROocHh[olfB:oo=SQoocHXOom5j>ooAN
TOodGi;olV2@oo9QU_oaHH_olF9koo=PQOodHHSom62<ooAOTOocGHgolf2=ooAOS_ocGhgolf6>oo9M
U_o]Dj;ol5RKoo=QSoobH9;olUnAoo=RS?ocHh_olf:?oo5KT_ocF97olU^?onmKT?oaHg7olV1DoniD
ROoWDi?okeJ@oo=GS_oaEi7olUBEooACU_oXBi_ohTBKoneCT?oHEX7o^V9lok=[N_nkJW_o_fF3ol9I
TOo4F9;oc62:om1TQ_o>HXSo`V>2okYVR_nhKXoo/g::ojEXTOnFII_oWh^<ok2ZNoneZg_o/j9mojn>
Oon_R7[o[XUiojZ5O?nZRG_o[haiok:<NOnbR7So/XQgokB8N_nhS83o_XN5olAlS?o5O8go`h69ol:1
R?o2PXOo`X6=ol62ROo1PH[oaGj?olB0SOo2PHgogGVWooQe`OoiLkcojg>`okmlW?nQPX[oYH6:ojF1
SonTOi7oXGjCoiilU?nRO9?oX7jDoj6BT_nTVI7oY9JAoj:GT_nSUi7oXiRAojBMT_nUW9_oZJEgojN/
?_nW[3WoYZ`mojN[?OnVZccoYJ/jojJ[?OnX[TSoZ[5AojVbDonX/U?oYk9@ojJcDOnT]57oZK1Cok6[
EOncZESo]:QIokFXF?ndZ5Ko/jQE0_nbZUL2ok:YE@1Xok6ZE_ndZ5Ko]JUFok:ZF?ncZESo]:UFokFY
E_ndZEKo/JYFok>ZEOngYUOo]:MGojV`C_nW]U[o[j]Xok:MHOncW5go]YaMokRJG_njVEko^9YNokBL
H?naWV3o[J1QojfNG_n^WUgo[ImKojjQF_naXU_o/j5LokFPG?nfWUco^9eMokJNG_nbX5_o[Z=Ioj^T
E?nWYE7oZ:IAojRTD_nUYE?oZZMCol:`D_oT]D?omkPmooNk@?og_DComl15ooNn@oog_TComl54ooO5
AOoaYT?ol6H/onaM6?oTMaKoj8TKonfi;?oYfCcoj]Pjon?B>?oSdSWoi/Tdon^88oo[GQOoiUPHoo16
7ooeC33okV11onEgCOoSOE;okg==ooJ0A?ohTdGonY=6ooal=OolJ2ConV<HooYP4ooiHACon60CooQM
4OohGQ7omelAooMO4_ohGA?omV`Aoo674?o`S0kolX`=oo><2Oo^RPkoiH@`onN6Goo`SV;oki1Ionj@
E?o]QTOoji0gonVE8OoXQ13ojGh8onMk0ooULP3oonA_03ooi6l0003oonA_06goi6l000[oi703on]`
;?o_HcGokVLdoniV<?o`GCColFM4oniX=_o^IS7okVLc0_o^IcD0@?o^IcKokfH`onmR9Oo_IBKokfXX
oni]9Oo_KR[om6hnooI`C?ofL4SomFa1ooE[@oofK53omFeBoo9S=Oo_FAWokU8=oniA3?o^FA?okelS
oo5S=?o`HSKokf4`oniS;Oo^IC;okV8donmK:oo_DA_okd`9oni>1?o^D`SokUTDoo1L8oobFb[om5/m
ooMLG?ohFV3on5QMooUHGOoiFEoonEYLooUMGOohGUkon61NooQQG_ohHUoon61OooUMGOoiFUSonUEE
oo]DD_okDe;onUIEooQLEoofI5comF]LooA]FoodKUcom6iMooA^G_odK5Wom6eIooA]G?oeKEh2ooA]
FP06ooA]GOoeKEoom6iMooA^G_oeKV3omFeP0ooeKEl01?oeKEgomFaKooE]FoofKUX2ooI_FP0@ooE]
FooeKEkom6iRoo1]IOo[IfcojEi_onEHJ?oNEF?of59OomA?E_o@BeWodDeJom9?EOoCCeGoddmHom=>
F@;odTiG083oddmIom=@F?oDCeooddYZol]6G_oI?H;olT6CooA5SoodB8oom4b9oo=@R?ocDH[oldn<
oo=BR_ocG8Wolf>7ooAPS?oeEiGomTnJooEBYOoeFJ7om5jFoo=RToobIXKolVEiooASQOodHhSom66<
ooAOSoodGhkom5j>ooAPSoodH97olenAon]HVOo^F9_om5nBooAPS_odGi7om5nBoo=QSOodHXkom6B>
oo9OT_oaFI7ole^@onmIToo`Hg?olV5Foo1HR_o]E9CokUBDoo5FToodEYColUBBonmETOo[CY[o`4^N
okAUTOn_Lgoo[FYgokUSO_o1Hh?o`6:6ol=NSoo=Ghgodf:8olaSQ_njIGgo]FY`ojmaJ_nVKHGoY6BO
oi]/W_nVS8[o/j1hok:KNOncVgco/95nojf6P?n^QWkoZX>0ojZ7O_n^Rg_o[Xaiok2;N?n_RGWo[hQg
ojf8MOndRGko`gf:olAlROo1P8Oo`X6:ol:1R?nmQ8?o_X:9ol=mTOo4OHooaWb?ol9oQoo4OHSoiW:X
ooUa^ooiLKSonG6looAb^oo6NZ;oXgj=oj=lSonWOXooXWj@oj5nTonONiKoWX>Doj>FT?nSUY7oXiFA
oj>GT?nTUXooY9F?ojFISonTVIWoY:AkojJ[>onXZSGoZ:TjojNZ>@;oYZ/j02goYjXhojN[>_nX[D3o
ZJm9ojRbDOnW]5CoZ;=EojNcDonT]U;oYk=Aojb_E?na[5Ko]:UHokFYFOncZEOo/jYGok:ZE_naZUKo
/ZYEok>YEOndZ5Ko/ZYFok>YF?neZ5So]:QEokBYEOn`ZUCo/ZUFokFWF?ndZ5WoZ[1>ojBc@on_/E[o
^:i_okFUI_nbW5co/IiMok>NGondWEko]i]NokJKG_nbWUko/iiMokRJG?nfVUh00_ncVel0BonbW63o
/9iNojnQFon/YU_oYZUDojRYDOn[ZUGoZjUDojbWDon/YU?o[J=BojfTDon]Xe?oZ:EGoj>UEon/Ze;o
b[9:onNg@_og_47omkQ0ooRe?_oh[S_onJPeooV:;?oeLbGol7XSooMn7Oob[2Gok<`/onOC<_oSdSOo
hM4gomoA=ooW[b[ol5DDoo8L2_o_81;oiC4NonDn;?ocA4OomDiIooA?EOocCUColVIIoo66F?ocQdoo
mXE<ooR5B?okNSoong8dooU]:ooiK2?onFLKooMR4oogHA;on6<@ooQR4OohH1;omVP<ooAg2OodNPOo
mG<4ooA[0oocI`?olf@3ooEW2oofLAKomG8Hoo9`6oo_QAkoji`MonV23_oWL0;oiG81onA`003oonA_
043oi6l0003oonA_06koi6l004Soj7@OonmU=Oo_IC?okVPconmR<?oaGS[ol6]0oniW;oo^IS;okVLd
oniW<oo^Ic;okVLconmV;_o_HRKokf@WonmZ:Oo^KRGol6d[ooA^?_ofKdWomFi7ooE^A?oeKD;omVa8
ooI]E?ocK4Sol6@]onmH6_o_D13oke4?oo1F6_oaG2_olUhgoo5N>?o_HCCokf8eonmQ=_o`HCcol5`f
oo1?7Oo`B@col4X7onm=3?o_EQ?olE/ZooEQGOofH6ComUmNooMNGoogG67on5YOooQIGooiFEkonEYL
ooULGOoiGUgonEiNooUMGooiG5oonE]OooYLH?okF5ooo5EMooaBFoolDeOonUMGooUMF_ogIEkomFYM
ooA]GOodKEX2ooA]F@06ooE^GooeKEkomFaNooE[G_odK5com6iL0_odKEl3ooA^G`05ooA^HOodL67o
mFmSooA^HOoeKV400_oeKEl0:ooeKEcomFeJooE]F?oeKEOomViGooE`FooeL5kom75Soo5]J_o^IVoo
k65gonEIKooNEfKofeESomMBG_oCCeKod4mBom5?DOoACeCodTiDom9=E?oDCV;odTiJolm7IOoV?YKo
mCnHooA3ToodBh[oldj9oo=@RoocDX[ole66oo=?SOofD9con4^[ooQ6/?ohAZ_omDVdooA<^OogCKGo
meRWoo=SS?obIGX00_ocIH<0L?ocHhKom62<oo=RSOocHHkom6:Eoo=RU_o_GYGojUVLoo1NU_ocIHoo
m6:@ooAQTOocHY3olf>?ooASTOodHIColV>ConQWQooXJ8Gohf6:onY]M?oaJegolEV?onaEUooZEi?o
kUJBoo9GTOoYEI;oeF2>okm[R_nIFiOoW5jHok1`Q?nfIWco`626olAUQoo9HH_odEZBomQLSOo7HH3o
/fQdoji`KOnYPFkoVY5hohR0S_nDL9GoZXYook>JLon_TGWo[HilojnAO_n/SH?o[HV1oj^8POn[R83o
[Hf0ojj?O?n_SGWo/Xaiok6@N_n_Rg[o[HIgok>5P?o2OH[o`gf9ol=oS?o2PH[o_h69okj2QonoPXOo
a7n>olAoSOo5OXgo_X25olMkS_o_LK?onW32ooUa`ooiM<ConWC7ooIdaOo:O:goXh2Hoin3UOnTQ9Ko
Xh:Foin0V?nNSISoYj6CojJQTonUWYGoYYbDojJKU?nUVY;oYIZAojFFVonSXhOoXk92ojB^>?nW[3go
Yj/jojN[>OnUZcSoYZXhojNY=onVZCKoYjTiojF_@OnV/d_oY[AAojNdDonW]5@2ojNcD`1doj^aEOn]
[eKo[JiGok>ZEondZEWo/jYHok>YEondZEGo/jYGok:[EonbZEKo]JQGokFXF?ncZECo/ZYEok>XF?ne
Z5Wo/JaDojNaBonW/T3o[:m3okB]HOni[Foo]jaYokJQH_ndVUco/YeLok:NG?naWego/YiMok:MG?na
WUgo/ieOokNJGongW67o]9eOok2NF_n]WUWo[Z1HoinVE?me]dCoOK8hohf/>onA[47oUZ]3oi^[A_nQ
ZT_oYZQ@oj^UDon/YECoZjIFojJWF?nSY53odK93ooVU9oojVbGonZP`ooZZ<?ojTRWon7`QooZD7Ooj
WB3on[<Uoo3G;?oXeB[okmDXoo;B;?o_bbcolYXMooI=3?oa:A7oiSTRon59;OoLD3CoeE`homYT@?o^
GdoolemAon]YCooTL57oi7eKonR9IOo/REgokHaIoo69D_oiOd;onge0ooYe=?ohGAcom5XDoo=Q5?oe
HAKomElEooIR4_oeI@gomFD:ooER3?oeD`komT`?ooI>3?ofC`SomDl:ooE?5oodE2SolE/_oniY8_oZ
MQ[oj7<FonUc5OoXMacoigTFonMe4_oVLQCoiG4:onE]1?oUK@7oonA_03_oi6l0001VonA_00Gol[N0
00?oji=0onA_0?oTK`000ooTK`000oo[Td3ol[N0oo:gP002oo:gP003onjUH?oTK`3oi6l000Koi6l0
00?ojHX`oo:gP?ohfkl01?ohfkl00oo`[W3oih4PonA_0005onA_0003onjUH?ob]h3ol[N000Wol[N0
00?oi6l0onN18?ob]h000oob]h000oo[Td3oi6l0onA_0006onA_0003onjUH?ob]h3ol[N000;ol[N0
1?oTK`000ooWPB3ol[N0oo:gP002oo:gP003oo2^L?ob]h3ol[N000?ol[N02?oTK`000oo[Td3ol[N0
oo:gP002oo:gP0;okZEP0oob]h000oo^YF3oi6l0onA_0003onA_00Col[N000?ojHX`onA_0?oTK`00
0_oTK`04oo:gP003onjUH?oTK`3oi6l008Soi6l003WoiW8=one[<Oo_Hc?okVPaoniW<?o`GC7olf57
oo5VAoo`H3golF51oo5R?oo`Hccol6@moo1U@?oaHcWolF0_oo5Q;_oaIc;ol6T^oo9X<_ofJTKomf];
ooM/COogKDcomfY7ooMYB_ogJUKomViGoo=[B?oaH3?olEDVoo5<7?oaC1_ole0UooAD=OocFT7olUe2
oo5N@?oaGd;olF55oo9OAoobEcgolTd^oo957Oob@PooldHPooIAEOofFf;omUmOooIPHOofH6?omUmR
ooMOIoogGFOomeaWooQMJ_oiH6l00_oiHFl04OojH6conUmZooYOK?ojGFgonee^oo]KK?olEVGooE=P
ooe=F_omC5Koo59GooULF_ogHegomVQLooA]FoodKekom6mO00;om6eI00kom6eMooA^H?odKeoom6iO
ooA^G_odKeoom71QooA`GoodL63om71QooA`H?odL6;om75SooAbHP?om75R0<3omG5RooE_H?odLF7o
mG1NooE^FooeKeWomW9MooEeHOoeM63omGITooAbJOocJW;ol6AbonUPJ_oPFfOog5IVomUAGOoFCU;o
dTYNolm:H_o>CdkoeDAmoo@nXoob>ioolT>Eoo==R?ocDhCole>6ooE9V?og>Z[onC6eooPj^oodB;Oo
le2doo9B/oobCkComDZkooU<`?ohDZGomURCooEOToocI8GolfInoo=UPoocHhSolf::ooASSoocHYKo
jeVHoniJV_ocHY7olfB?oo9SSoodH97om5nDooAPTOodHI;om5nCoo=SS_oPKG[ofFmbomM/MooPMVKo
kg=JoneDTOoZE93okeF>on]CTooKFY?o_VR8oj]dPOn/M8?oXE^Doj9JUOneKX?o`FF4olUQROo:I8Co
dUR?oliERoo0IGcoZW=doib4L?nEX73oSJAoohBRVOnDXXOoYi]`ojj>Mon[TG[oZiMhojbINOn/VWko
[IZ0ojnHO_n`UH3o[IB1ojfGOon`Ug_o/9=kojnBO_n_UGoo[YAoojb@NOngQgooa7^:ol=mRonnPXOo
_X>4ol:0R?o1PhGo_hB4okn4Qoo1P93o`WjFokZ4Roo<OIcomW32ooYaaoojLlGonWG7ooYeb?ojM/So
nGK7omAm]?nQQYcoWHFGojF5UonUQYKoYIJEojZRTonXXiKoYjFHojRVV?nYYiWoYZBIojNRV?nVW9go
YZNDoj>jDOnP^CooXKM3oj>e@onU/d7oY;90ojBa?_nV[SkoYJdlojJ[>_nUZcWoYj`mojZ]@onX/4So
Y[5<ojBdDOnU]ECoYkADojRcD_nX/U7oZK5Bojf^E_n_[EWo]JUIokNXG?ncZUSo/Z]FokBYE_ndZ5Ko
]JQHok>YEoneZ5So]:UFojf_C?nX/TCoZ[51ojj^?on//4Go]:eSokN[J_nf[FSo]ZaXokNOGonfV5_o
]IYLok:MGOncWF3o]9aRok2PHonWY5koZZ=Koj^TFOnYYEP2ojZUE`1>oibWC?n2[SGoH[`bof2l=Ome
[R_oMZh/ogN`;Omh[c7oOJleohB_>On8[cgoRZhoohn]@onGZdOo[je<onJT;_oiL`7onFP3oo^;6?oi
T2;omWHQoo5g9OofO27omh4Ooo:g9_oYc2Woj<`Zoo79;?od^ROokhPQonYN7_oRE2[ofU8eomYD=_oI
FcWoeVm2om28C?o>YeCodZ=Gon=jE?oYL57oiFi=onI[C?oWO5[ojHUYonN:JOoSTFWojI=QooF2B_ok
KC;oneTSooEL8Oo`H1SolF4Foo9P5_oaHAOolUlGoo1L6?ocE1GomTX@ooM?3OohE0comD/Coo996_ob
BR7olTXNoo5>4Oo`C0WokdH:onm94oo`DB;ol58Oonm@8?o_Eb7okV0PoneQ7_o[FPkoifH3oooTK`0k
onA_0000IOoTK`000ooWPB3oooooooooo`03ooooo`03ooOB[ooTK`3oi6l000?oi6l000?omLVOoooo
ooooool00oooool6onA_0003onIh4?ogdZoooooo00Sooooo00?oll2?onIh4?oTK`000ooTK`000ooh
fkooooooooooo`09ooooo`03onA_0?o[Td3ooooo00?ooooo00?ol[N0onA_0?oTK`001_oTK`000ooh
fkooooooooooo`02ooooo`Coi6l000?okZEPooooooooool00_ooool2ooG9W`Cooooo00?ok9a@onA_
0?oTK`001OoTK`000ooji<ooooooooooo`02ooooo`03oo2^L?oebIoooooo00;ooooo00?oo>gOonA_
0?oTK`000_oTK`000ooYRS3oooooooooo`02ooooo`03oo?0SooTK`3oi6l000;oi6l01?ooool00oog
dZooi6l0onA_0028onA_001ConA_0OoZL2Kol68fonmS=_o`HScolU]5ooI>CoofFf?om5UIooAEE_od
EeKom5UBoo=JCoocFdoolee@oo=NAOocFSColedcoo9U>?oaIcColfLfooIYB?ohJDgomfY=ooM[Coog
JT_omfU9ooMXCoogJeOom6i@oo9Z@?obHCColUDYoo9>7oobC1coldhToo=C=?ocF3oolUdooo5M?ooa
GSoolEe1oo9M@_obFD3olU0]ooA5:_of@D_om4YJooM@H_ogEVOon5i_ooQSMOohHgWon69mooQQOooh
HGcon61jooQROoohIX3on6QnooUZN_oiJGWonFMfooUUM_oiI7GonF=cooYPL?okGVkoneYWooaCH_om
CEWooDaEooaAEoojFE_on69OooMXHOoeJe_om6eKooA^G_odL5kom71MooA^G?odKel00oodKUh3ooA]
G00=ooA]F?odK5Som6]GooAZFOodJeWolfeJooA[F_odIeGom6QGooAWE_odIE?om6MJooEWG002ooEU
E`0ZooETFOoeIegomFMNooEYI?oeJFOomFQ[ooETK?ocFW3olEMconUGLOoLD73oeDmDom1=F_oXAiGo
m42PondnVoobBhgom4b=ooI1Wooi=;KomcFioo8l/_o]?[7ojd>aoni=/OodEK7olE:conmA]_odBL3o
n3ZbooThY?oi@JKon4ZLooIET?odGX[olf:7oo=RROocHX[olf2ConeIW?o^FiColf:<0oocHXd0f_od
Gi?om5jEooANU?odH9;olFB<omi/NOoJKWCofVegon1gJ?o^NU[ol5:Bonm@UOoOF9;o`FF<ojUaQOnW
LHGo[Vj5okE^Q?nXGhgoZUnAol5XRoo9HHWobf:1olUTP?njHH;oZgIjoiZ@M_n=ZWSoP;MiohBdS?n1
[ikoO;5ioin[IonZYVWoZI]fojfDPon[WW_oZj5iojZPN?nZWgGo[9ebojnIM_n]VWWo[IUdok6CKona
TgCo[iAfojjALon]UVko[IQ]okJ;MonoPH;o_8J3okf5Q?o0PhSo`8>7okb5QOnoPh_o`h6Aol5mU_o0
OIOo_86:omAiX?ogK/?onFo3ooUa`_oiL/7onW74ooYb`_ojML3onW?4omeg]On/Pi_oW8FCoj>6U?nV
U9;oYiVBojRJTOnVW9CoYj2FojRTU_nWYYSoYZFJoj>MWOnTYJ3oYKUMoj6j@onN_4KoWk]5oj:iA_nS
^TKoX[Y5oj:hA_nS^4GoXkI4oj6gA?nS/d;oYK10ojR_@_nX/4KoZ;5;ojJcCOnQ]TkoY;A?ojRaD?nX
/U3oYk=AojZaDon_[5Go/:aIok>ZFOnfZ5So]ZQIokFYF_nfZ5go]JUJok6/DOn[/DOoYk=2oj^a@_n^
/4?o[K52oj^bA_nd[VGo]ja]okF/JOne[VWo]j]YokFOIOndVf7o]IaRokFLHOn`WekoZJ=Ioin[DonH
/57oWZaEoj^VF_nUYUCoSZe2og^b<Ome]2SoMk<[ofJm>_m]]CKoNZd/og>a;omb/BooLK4^ofjc;?mb
]RcoPKD`ohN`:on?YRWo_JDhomjD<_oOMb7ojV8EooYB3?oiDA[on5PUooIJ9?ogBBCol68TonR@:?oX
UB_oj8T/onF2<_oSN2kohg0^on1j=OoFJS[odFM2omEoBOoBUU7odJ]Hom2gGOoB^UkocK]Mom>NF_oX
Me?oig1@on9eC_oSM4koih9IonRCIOoRWg7oi9Y]oo9gBOojGb_oo5PZoo1U?OoXJBcokf@Coo5T4_ob
H1Gom5@Aoo985?od?A?omT4>ooM=3?ohD@[omDXCoo9<8OobBb3olD`?oo1>1_o^C@Ookd/9oo161Oo`
@`3okdD0one70?o]B@3ojdh0onYE0?oYH03oiF/1oooTK`0konA_0000IOoTK`000oo/W53ooooooooo
o`04ooooo`03onIh4?oTK`3oi6l000;oi6l000?ooOK_ooooooooool00oooool00ooYRS3oi6l0onA_
0002onA_0003onIh4?oji<oooooo00[ooooo00?on^C?onIh4?oTK`000_oTK`000oohfkoooooooooo
o`09ooooo`03onA_0?o[Td3ooooo00?ooooo00?ol[N0onA_0?oTK`001_oTK`000oohfkoooooooooo
o`02ooooo`Coi6l000?omm:_ooooooooool00_ooool00oo[Td3ok9a@ooooo`03ooooo`03ooG9WooT
K`3oi6l000Coi6l000?oih4Pooooooooool00oooool00ooVN13okZEPooooo`03ooooo`Coi6l000?o
l:i`ooooooooool00_ooool01Ooji<ooi6l0onA_0?oTK`3oji=000Cooooo00?ol[N0onA_0?oTK`00
QooTK`002_oOK@CogVd6om]X9Oo^GD;olUY6oo=GDOodF5WomE1>ooIAE?oeGF<2ooAGE@0]ooAGE?od
EUCom5ICooAEE_odEeWom5I>ooAD=oodF3Golf0koo5T=OocJ3SomVU8ooMYC?ogK4gomf]=ooMZBoog
JT[omfM9ooMXD?oeJdoolVe4oo5[>oobHSGolULXoo5?7?obBa_olddVoo=F>_obFd?olUm4oo9NAoob
H4_olf9Coo=REOoeG6Kon55eooI9K?ocBF[okdi_oo=?KoogEW3on5miooQROoohHh;on69n00;on61i
09gon61jooQRO?ohIGgon6YmooM^O?ogKWgon6ikooQ/NOohJg_on6alooQ[NOohJWSonFAeoo]MKOol
EFGooDmKooe<FOolCEOone=IooUKGOohGE_omF1Foo5QD_o_HU7okFA>onYUBOoZHdOok65:oniNBOo^
G4Sok5e8oo9GBOodE4[omE=>ooECD?ocEE7olUIAooEDEOoeCe7omTiEooE>EOoeD5gomEAWooEDI_oe
E6_omEMcooEGMOoeF7OomEEiooEDMOofE6_omU=OooIFG?ofGEWomVAMooEYIOodGFOoke5OomaBFooG
BgcokdjEoo55V?od>ZcomS6hoo<`^Ooa>KSojSndonQ1/?oY?K;ojcbcondo/oocB[;omDNeoo@k_Ooe
=;colcF[ooHkXOoh?j?onCfPooTnWOohA9oomUFMooAUS_obHXWolEfAoo9NV?o`GY?olV2>oo=QS_oc
HXkolV:=oo5PSoocGi?om5n?ooAPTOo_I8_offefomQ^MOoJK7[oi7YWonenHOo/D9cocUJJojaaQ?nX
MH7o[6j8ojmXR_nfKHGo^6j5oj]XQOnVGi7o_FJ>olQWP?o0KWOo[7=loi:BP_n4]8;oN/22ogc3Pon6
_I[oQKNVofbnK_n3/U7oZj=/ojfRLonZYfkoZIekojbEPon]Vgco[9edojZML_n[VgKo[9]boj^IKon_
Ufoo/9A_ojnBKon]UFWo[9EYoj^HK?n]VWCo]8inok^8R?nmQhko_H6Dokj1TonnPY3o_8>>ol61T?o3
P93o`82?ol9mU?o1OI3og7JVooUaa?oiL<3onG7000;onG:o03?onW?2ooYb_oojLkoonG;2onMg]ond
P9koVhVBojJGT?nWUi7oYYF@ojJDTOnWUi3oYiV@ojRNTOnXYYKoY::IojJRX_nU/fGoY[I6oj>hBOnP
^DOoWkY7oj:gA_nT^4GoX[U7oj:iA_nS^DGoXK]6oj:jAonR^TKoX[Q3oj>hAOnU]dOoYKE6ojFeAonS
]T_oXKE@ojNcDOnX/U7oZ[1@ojNdDOnW/e7o[:mDok2/F?ncZUWo/jQJok6/E_n//4_oYk=4ojNc@_nZ
/d@00_n//T@02on]/43oZk59okB]I_ngZfco]Z]ZokJ/K?ne/6oo/Jm/ojnRH?n[X5OoZZ5D00;oZ:AC
05;o[J9FojZTEonUYeKoVjU;ohF`>?mh]2goNk<]ogna<?mm[bgoMk<_ofRk>_mf/3?oO:h/oh:`<?nD
[CKoWJD/ojfK:_o>V3GogHd`omem:?oMP2_of8HaomF9=ooHT3GoiX4VooE/8OojMB;onf`TooYg9Ooe
YRSoljlXoo>T:?ocR2;ol6/QonMn=?oQScKojYhaonjT;ooJ/4Go^[QFokRjEonl^5Ko^[IDokbdDOnj
]E7o][]AolFYE_oGTESoehmGomBAEOoCTeCodimQon6JJOocNdgomVDiooQR=ooiGCOomF<joo5/:_oa
HQ7olV4@ooEG3_ohB`Somd`;ooI23Oof?`oomT`?ooM?3?odBQKolD`Ooo5=4?o`C@Gokdd4oni?1_o/
DPKojUH2onUL0OoXH@7oiVH1onE[0?oTK@3oi6h0oooTK`0monA_0000IOoTK`000oob]h3ooooooooo
o`04ooooo`05onjUH?oTK`3oi6l0onA_0?o[Td001_ooool00oo^YF3oi6l0onA_0002onA_0003ooSK
_ooooooooooo00?ooooo00?ooOK_ooSK_oomm^l01Oooool01Ooc`8ooi6l0onA_0?oTK`3on=^o00_o
oooo00?oi6l0on^C@?ooool00oooool00oob]h3oi6l0onA_0006onA_0003ooSK_ooooooooooo00;o
oooo0ooTK`000ooVN13oooooooooo`02ooooo`04ooc]gooTK`3oi6l0ooc]g`?ooooo00?ooOK_onIh
4?oTK`001?oTK`000oo`[W3oooooooooo`02ooooo`03ooOB[ooTK`3ojHX`00Cooooo00Goji=0onA_
0?oTK`3oi6l0oo[Tc`05ooooo`04onN18?oTK`3oi6l0onjUH0Cooooo00?oji=0onA_0?oTK`00PooT
K`004ooSK`7oh6h3omQZ2oo@Ia;ob6@Iol5R7?o2HB?oi5e9ooAGCoodEUGom5QEooAGDOoeCDSomUUO
ooAMG_odEU7om5MDooAHDoodEeD00_odEUD06_odEeKom5I=ooAC>ooeDSOom5Hloo=N>_odI3oomfE9
ooQYCOogJdcomfY<ooMZBoogJDWomfQ7ooQVBoofJ4golf]5oo9]@OobJT?olf0koo=F<oocD2oom4hb
ooED@ooeGEOom65L0_odHed03OocHUWomF9aooQRSoohGH[ome=iooA;K_oaC6OolDYVooI=JOogEFoo
n5edooQPMoohHGX00_ohH7P0WoohH7Won61kooQQOOohI7_on6IkooQZNoohK7_on6mmooQ`OOohKWgo
n6mnooQ^OOogKg_on6emooQZNOoiJ7[onFEkooYMKookF6[onUAZooYEIOogE67ol5=GoniCEOo`D5Ko
kdiConm=EOoaC5Gol4aGoni>EoodBV7omdMSooM8JOogAf[omd]_ooM=L_ohCG7on4adooQ:LoohD7Oo
n59iooQCM_ohDWCon51cooQ@K_ohCVWonDiVooU=H?ohCU_on55KooQIH_ogHVSomfI^ooIWK?ogHVGo
n54kooQ=9ooRDfKod51Homi:V_od?[GokBk0onHb`OoR>[Kohd6bonM1]?oX?KCojSZdon`k/_o/=;?o
kbjboo@//Ooh;K_omcVjoo50ZOoe@jGomd>XooQ2Xooi?IgonCVNooU9Y_ogJJ7omV2Roo=IU_ocHhco
lV:Aoo9PSoocHXkolV:>oo5OT?oaG9KolenAoo=PS_odH8oolV>?on9YP?oIJgSodfYfonIdJ?o[M6go
]6>Goj1ZSonZJH[o/6V:ojeWROnUIHSo/6f5ojIaPOnPLX?oW5VIojeWS_n[OGgoWh:7oi^6TOnLY9Go
SkZEogo2Q_mn`YOoO<2Pof_1Jom[^4[oVjMVok6QM?n[Xg?oZj=bojRUL?nYWWWo[iImojjKN?n/WgWo
Zj1jojVLLOn/UVko[YQeojfKNOn/V7?o[9UeojjKO_nZXXCo[IV4okV9ROnmQ97o_H>CokV4TonkQI;o
_hBAok^6R_noPXco`H6=ol:1Roo2P8oo`h2<onAiZ_ojL/7onW2oooU``?oiLL7onG>nooYc`@02ooYb
_`06ooYc_ooiML3okgFookF3W?nQW8koYYb@0_nWV9004onWUXkoYiJ?ojNHSonXVi3oYijCojNLW?nS
[VGoX[I1oj>eA_nT]DSoXKM6oinhAOnR^4KoYKI6oj>fAOnS]T?oXKQ4oj2hA?nQ^4@00_nQ^D<2oinj
A01]oj:hA?nS]dGoWkU7oingC?nV]57oYk=CojJcDonY/E?oZK9BojFdD_nX/Tko[K18ojbaA?nX/T3o
Z[92ojfa@_n]/D?o[;94ojba@on][coo[;16okF/IOnhZfco/jiVojn`I?n[/f3oZkEOojZ`G?nYXeCo
ZJ9BojZSDon^XEOo/:5HojVRDOn@ZT3oNk@`ogVd;Oml/booO[8cogna=?mm/S;oOJl]of^i<On<]S_o
aILaom>1:?o]NB_omg@]oo=`;OoYKR_ohGL/omj2<OoKQBoofHH^omN5;_oGTC3oeITionJ8<ooiNb7o
nWhOooR_9oo`dbgolM<]oo?>;ooeaBconJ<VooV=<OoaXc?om<<]ooOA;?oecc;ob/94oj6fBonV]D_o
YkI:ojNeBOnZ^4WoYK]4ojK0BOo5/USoeIUIom:;E?o?P5;oc7eMonI]E_ohGCCon5dbooMU>_ocK3ko
mg<iooM`9_ocG`koleD9ooM:2?ohBPOomdd8ooM81_ogBPOome4<ooIA3?oeC`ool509onQI0OoXG03o
j5h0onIS0?oUJ03oi6/0onA]003oonA_04;oi6l0001UonA_0003ooSK_ooooooooooo00Cooooo00Go
mLVOonA_0?oTK`3oi6l0oo?0S`06ooooo`05oo?0SooTK`3oi6l0onA_0?o[Td001Oooool01Oo`[W3o
i6l0onA_0?oVN13omLVO00Gooooo00Coih4PonA_0?oTK`3on=^o1?ooool8onA_0003on^C@?oooooo
oooo00;ooooo00?ol[N0onA_0?oTK`001_oTK`000oohfkooooooooooo`02ooooo`?oi6l000?okZEP
ooooooooool00_ooool01?oc`8ooi6l0onA_0?oc`8l?ooooo`03onbLD?oTK`3oi6l000Cooooo00Co
l:i`onA_0?oTK`3oih4P1_ooool01?o^YF3oi6l0onA_0?oc`8l4ooooo`03onIh4?oTK`3oi6l0087o
i6l001GohFh3omY[2Oo?Ia?oaf<Jol9Q7oo0HB7o_f0RokmQ7oo4Hb7ofUi:ooEGEOodEe;om5QCooAJ
EOodDdgomTi?ooIQJ?odFEGom5I@ooAFDoodEe@00_odF5@02oodEeGom5MFooAGCOodDc_omE0dooAC
>oodFCkomEi1ooQTC?ohITkomfM;00;omfU:02_omfY<ooQZC_ohJ53on6QEooE[DoodKeKom75KooA]
F_odIE7om5]3ooAB>OoeD3_omEM<ooENFoodH5_olf1FooEQKOohHY?on6BCooQRTOohGH_on5F0ooE<
LOo`Bf[olDY[ooI<L?ofDW7on5UgooQONOohH7[on5mhooQNN?ohGgWon5ikooQNOOohH7kon6B0ooUY
P?oiJGkonFMoooUWP?ohIWkon6An00;on6Em097on6=jooQROOohHWoon5mkooQKN_ohF7Kon5=cooQ5
F_oi>doon51jooQEO?ohDWSon55hooQCN?ohDGOon51eooU?M?oiCG?onDibooU=KOoiC6gonT]/ooY:
JOojB6?onTUQooU9G?oiBEKonDYBooU<D_oiD5Con5QMooQLHoohHVOomfM[ooI^L_oeLW?omFaYooIV
H_ohEU3om5P]onUU8OoPEV3odU5IomE7K?oS=J_ohCW9om/g^?oN?K;ohd2con@k]_oU>kCoicZdonLj
/_oW>[7ojRneonP//OoX=ZWol3faoo<n]_o_>j[olCnRooE5YOog@jcomd2WooPjWooi@JOon5RiooIA
a?ohC:kom62Aoo9SSOocH8oolefCooANT_ocGI;om5jDoo=OT?ocHHoolf6>ooAPSoocHHgojV>8omMO
ROo[I8;okf5gok=XTonCOHWoYf^<ojI[R?nSJhOoVVf7oiY`QonRK8OoZ6b;oiMHVonSH9Ko[6j>oiUm
UOnPTIWoZI>Doj^HT_nMV9KoSj^XogVkLomV^4SoO;9KojNTKon^XFkoZ:=]oj^QK_nYXVcoYZAXoj^L
M_n^Ugoo[Y]lojbOMonZVWKo[HmmojVGO_nWY7goZ:R0oj^UQOn/XXGoZ:>1ojfAPonmQHko^HV<okV6
S_nmPi3o_hBBokn6T?njRH[o_h6?ol=nT_o3PI3o_X><olEoSoo^M;ConW;1ooY_`OojK/;onG71ooUa
_ooiLL7onW7200;onG:o01oonGFnooUe`?o^M[Go^8JDoj6OSOnTWY7oYiJ@ojJFT?nVUi7oYYN@ojJE
T?nVUY3oYYFGojJXJ_nR]SSoX;Q1oj:fA?nS]TOoX[I6oiniAOnQ]TCoXKI5oj:fAOnP^4CoW[Q3oj6f
A?nQ]d?oX;Q3oj6g@onP^4?oX;U200;oWkU306KoXKQ5oj:gB?nS]DgoY[1?ojV]C?nY[dSoZ;93oj^b
@_nZ/T;oZK=2oj^b@_n]/D;o[K53ojfbA?n]/D?o[[53ojj`@?n^/4;o[k1MojnbI_nY]F3oZ;IOojVe
G_nZ]EooZKURoj^_G_n]XEKo/ImHojnQF?nKYd[oQJheogVc;_mj]33oO[<cogfb<_ml/S;oOK<dogfc
=Omj]37oN;<Zoh6i=_n^[Sgo_ihcolfM:_o?U2OodI8Uom6=9?oMR2?oh80Pon5k7ooROQkoj7lIoo21
5?o_Qa[olY8TooRQ8ooh/2Oomk0XooNf:Ooe]2_olKH_ong4=?o`]c?onXhboo^O?_oh_SGomLP^ooO7
:oodb37ob[e5ojJfBonX^D[o[KY9ojfhB_n^]DcoZ[A:ok2^Doo8ReSoeFiDomA_DooGKeKokei4ooUB
9oofGB_ojX53onRHB_oeVSgomiXiooB37ooeH`OomeH4ooMG1_ogD`ComeL6ooM[3OogKPkomfX=ooIg
3OobL`Coj6D0onAZ0OoTK@3oonA_04Koi6l0001UonA_0003oogfkooooooooooo00Cooooo00GooOK_
onA_0?oTK`3oi6l0ooc]g`06ooooo`05oo[TcooTK`3oi6l0onA_0?ogdZl01?ooool00ooebIooi6l0
onA_0003onA_0003ooSK_ooooooooooo00;ooooo00Coll2?onA_0?oTK`3on=^o1?ooool8onA_0003
on^C@?oooooooooo00;ooooo00?ol[N0onA_0?oTK`001_oTK`000oohfkooooooooooo`02ooooo`?o
i6l000?on=^oooooooooool00_ooool01?oYRS3oi6l0onA_0?oWPB0>ooooo`05oogfkooTK`3oi6l0
onA_0?ohfkl00oooool01?oc`8ooi6l0onA_0?o^YF06ooooo`04ooG9WooTK`3oi6l0ooSK_`?ooooo
00?oo>gOonA_0?oTK`00OooTK`009OoQKP?off/8om9X4?o8I1[o`V8Ool1Q8OnoH27o`F4Pol9Q7oo2
HQko`V8PolUQ<OoOGDcom5MEooAHD_odEe;om5QDoo=IDooeCT[omUEJooENHOodEE7om5MCooAHDood
Ee;om5MCooAHE?odEeGom5QFooAGCoodE3gom54cooAC=oodF3_omU]4ooUOCOohHTd00_ohJe@04ooh
JUGon6aHooQZEooiJEKonFYIooE^F_odKUOom71IooA_F?odK5Kom6A>ooAI@?oeDC[omE54ooIHE_oe
GUgomf1iooUQUooiHI<00_oiHi@0]OohHI?onEb>ooQCQOofCGSold]boo5;L_ocCgOome=hooUGMooh
GWWon5mlooQONOohGW[on5imooQNOoohGWkon5amooQLP?ohFh3onEZ1ooQKO_ohFWcon5UjooQINooh
F7Won5UgooQGMOohDVcon4e^ooQ<LOohDGCon4e]ooXd>Ooi@f_on5V<ooQORoohGhWomef4ooMNPoog
G7con5]fooIIKOofEV7omUALooM>E_ohBU;on4Q?ooQ;D?ohDeKon5EEooQHF?ogGUgomVAQooIXIooe
K6_omG1[ooEaJoodLFWom6]VooINF?ohFDKonD/]oo5F7ooQL1;ogF=>omABIOoEC7KohTJ=onP^X_oQ
><3ofCnmomhi]?oU@k?ojCfbonDc]OoT>;?oiSfaonPg/_o];;Gok3:donY0[?oY?jgoj3jWon90SooO
A8WohdV?onY7VOo^@igolSjPoo9:]?o/D<Gom4c7ooU:]?ohDJSomEjLoo=QSoocGI7olejCoo=QSooc
HHkolF2?oo=RS_ocHHkolf6=oo=SRoodH97okE:QonmJT?oaGg7ofd^@oj1nS_nJN8goWW26oiYaQOnI
LhOoWff=ojYZSonXJH_oX66AojaMWonhJYGo[FfCoij1U?nZVXgoXH^EoiR4XonTXX_oX:U]oh^`I_nD
[F[oZj9]ojfQL?n^XG?o[J5coj^QM?nYXWGoYjEhojVKPon[UHGoZIn0ojVMOOnYUh;oZYQooj^RQ?nY
ZhSoYjV0ojNXO?nYYggo/961okR8QoneSHKo^8Z;ol22T_o2P97o_XF=okb7S?o0Q8ko`XB=ol23S_nk
PH_obWfFooEa_OoiLL7onVo2ooY_`OojL<;onG:oooYa`OoiLL3onG;0ooUb_OojLKoonG:nooIe]Oo]
M:So_hBFoj>JSonSVi3oYYJ@ojFFTOnVV9400_nUUi408onRT9KoZ:IiojBf>OnS]S_oX;Pnoj2h@?nP
^4?oWkU3oi^jA?nO^4?oX[I4oj2gA?nO^D?oX;Q4oj6hA?nR]TCoX;Q5oj2h@onP^D?oXKQ5oj>eAonS
]TKoXkI3ojJd@?nW/T3oYjllojZZ=on[Z3KoZZTgojN/>OnZ[3[o[:`koj^]??n[[Sgo[:hm00;o[:lo
05Ko[:lnojf^?OnY/dooZ;AQojVeGonZ]5ooZ[ANoj^dG_n^/eko/;=Rok6ZGonWX4ooT:HjogZ`:omh
/BWoO;0]ogZa:omk/2[oNK0YogZ`:Omo[2WoOJ`XogZ]9OmmZR;oO:XUofFl<Omj/b[oRj/SohN^6on7
/A?o[k@Moo:g7oogWa?onH@;ooYk1ooeYAKok[PNooBl8ooO`booi/dfooO=<OoiZbKonXlJooZG6_oi
WagomJTToo:V:ooiUcOonj93ooZT@Ooe]CCol<0booK0;Ooe`C;oaKe6ojFeCOn]/5;o/:QEok2SF_nb
WUco[J5HokJKFooBMECofFA8on5L??odC2SokfPaon:CD?oLXekokJ58ooNT>oog[4?omiD[ooMW1_og
HPComfH8ooMO2?ogLa;omhPNooR16?ogN0gom7P8ooAf1_o_K07ohFl4onA`0Oooi6l0A_oTK`0006Co
i6l000?oiWP@ooooooooool01_ooool00oo/W53oi6l0onN18003ooooo`03oogfkooooooooooo00;o
oooo0ooTK`000oomm^ooooooooooo`02ooooo`03onN18?oTK`3oi6l000?oi6l000?ok9a@oooooooo
ool00_ooool01?ohfkooi6l0onA_0?ohfkl4ooooo`Soi6l000?oji=0ooooooooool00_ooool00oob
]h3oi6l0onA_0006onA_0003ooSK_ooooooooooo00;ooooo0_oTK`000oo^YF3oooooooooo`02oooo
o`03oo[TcooTK`3oi6l000;oi6l000?on^C?ooooooooool02oooool01Ooc`8ooi6l0onA_0?oTK`3o
ll2?00?ooooo00Con=^oonA_0?oTK`3omm:_1_ooool01?olkMooi6l0onA_0?omm^l3ooooo`03ooOB
[ooTK`3oi6l007coi6l000SohFh3oma/1ooAIa;obF@Hol=R7_noH27o_f0Rol1Q8@;o`V4O017o`V8O
ol9S7_o2Haoob64bomYR@_oIHD;oje]BooEGDoodF5Com5IAooAGD_odEE7omTi<ooENH?odFeSom5IA
ooAGD`02ooAGE00DooAFE?odEe?om5MDooAHE_odEe;om5E0ooEA=OodDCWom5LlooEQ@?ogJDcon6]C
ooQ]G?oiK5con6YGooQ/EoohJeOonFYFooM]FOodKEH2ooA]F00HooE^F_oeKecomFeIooASC_oeF4;o
mE0mooIDB_ogGGWonF6DooQRT?ohHXoon6>?ooQRS?ohHX_on66AooQNSoohEH7omTaboo5=L_oaDGKo
le5eooMBMOohFGSon5mk0_ohHWX01_ohHGgon5ekooQKNOohFW[on5]jooQLOP;on5am09;on5YjooQH
N?ohEGCon51aooQ?LoohC73on4meooQCNOohE7Son5=jooTmAOoh=cKom4idooMHNOofHGcomeegooEI
JooeFEkoleUHoo1IDOo_FTOolUE3ooIBA_oiDdoonEIGooUNHOohHf;omVIOooEXG_odJUgolfaLoo=]
G_odLFOom6eUooASHOofEE?onD/moo]F=?okBR3ojUHLoma`4ooKHC[of4]XomTmSooR@J;ohD2NonD_
WOoX;JgogCo0omXj^OoQ?[CojCnaonPf/_oU=k?oiCRcon/]]Oo_9kOokCNdona1[Oo]?k?oj3nUomi6
P_oGBWcoeTioomM=OooEBWkoiTFJonY;]_oJDk_oiENiooA?^?oj@kConE2booIMXoobHHoolF2>oo=Q
SoocH8kolf2?oo=RS_ocHHkolf:=oo=SSOodGYGokeJNonmOR?o_Hg7oiTN>ol1NT?nASI;oVg6;oima
QonRK8SoXFZ<oiaZSonGKH_oYF^8ok=VUon^Hi_o]V^Foj]]TOnIPI?oUgnOojNIR_n[ZFoo[JMbojZ]
MonY[h3oZjZ2ojBXOonSYGgoYjB3ojVTPonZXXCoZJJ3ojJYO?nTY7WoYYijojVNO_n[XHOo[:67ojjO
P?nYYGooYjV1ojVXO_nZYGgo/hn0okJ8PonbSHCo]Hf6okb6SOnoPXoo^hJ:okb7R_o0QI3o_hBAokn3
UOnfPI3odWbLooQ`_oojLL;onG6oooYa__oiL;konW72ooUa_`;onG;002ConG71ooYb`_ohLkoolGJa
oo9f/?o`MJkobX2KojBDSonSVY3oYiR@ojJGSonWVHooYiV>oj:CU?nWYXSoXkE1oj:f>?nR]S_oX;Pk
oibj>_nM^SkoWKY1oiZk@OnL^T?oX[M3oj6gA?nR]T?oX[I4oj2hA?nO^4CoX[I4oj>eA?nT]D?oYKE0
ojNc?OnX/c`2oj^a>`05ojZb>onW/C_oYjdiojVW=On/YC<00_n]YC801?n/YS?o[:HdojbV=?n/YcD2
oj^X=@1DojZX=OnXZS_oYK1DojV`F?nY[eGoZZmGojb^F?n^[5OoYJmBoiV`Aon5[S;oO:PPogbW7_mm
YR;oOZHRogfW8?mlYb7oOZHOogbW7_mlYaooOjHNognU7ommYB3oPZ<Nog:^9_mS]S7oNjHRog:`4Omi
^PkoY<@Noko<7_o0bQooa<8Ooljd7OoNcB_o`=0^om?E>Oo4e3KoeM<fooK>;?oiXa[onhDBooZ;5Ooj
SAKonXlEooZA6_olUSCoo9XkoobJ?ookXSooljdgoo2h<_of`Rgol;laol:`A_n^YEGo]Z5GokVQE?nk
VU;oaYM>ol^EA_oCP3coh5`aonaB:ooaL3Coj:9<on>_F_oWYU;omYdlooNN>OogWc_onG@MooQL0Oog
G0?on507ooMJ3?ogKQ?omfdCooI`4_odM0oolV/8oo1U0_oXHP3ohVd2oooTK`17onA_0000I?oTK`00
0oo[Td3oooooooooo`02ooooo`07ooSK_ooooooooooooooooooc`8ooi6l0oo2^L003ooooo`03ooG9
Wooooooooooo00;ooooo00?oji=0onA_0?oVN1001?ooool00oolkMooi6l0onA_0005onA_00Gooooo
0_oTK`000oohfkooooooooooo`02ooooo`Soi6l000?oji=0ooooooooool00_ooool00oolkMoon=^o
ooSK_`04ooSK_`;oi6l000?on=^oooooooooool00_ooool00oohfkoon^C?ooooo`04ooooo`03oo2^
L?oTK`3oi6l000;oi6l000?okZEPooooooooool00_ooool01OogdZool[N0oo:gP?ob]h3ooOK_00Co
oooo00GojHX`onA_0?oTK`3oi6l0onjUH004ooooo`03onA_0?oVN13ooooo00Oooooo0_oWPB04oooo
o`03oo:gP?oTK`3oi6l007Woi6l000KohFh3ome/1ooDJ0oobfDGol9Q7_noH282ol5Q800Gol1Q8?o2
HAoo`V8Ool9R7oo1HB3o`F8Ool9S7_o6HBoofV54omYQ@ooCHSWogea;ooEGEOodEe?om5MBooAFD_od
EeComE9<ooECD_oeGf?om5MDooAFDoodEeD00_odEe<09?odEeCom5IDooAFEOodEEWom5EEooAC@_od
E3Cole/coo5S<oodISgomfQ:ooQ[E?ohKEconFYIooQZEoohK5WonFaIooQ/F?oeKESom6eHooE]FOod
KESomFeHooA_FOodL5Wom6iFooAUBOodFS_omeAOooUIP_ohGhkon6:@ooQSTOohHi3on6:>ooQRS@;o
n6>?00[on5f8ooMBNOodC6col4i/oo1?K_obCfoomEAeooQHMoohGW[on5ik0oohGGd0DoohG7gon5al
ooQJMoohEG;on59aooQ?L?ohCfoon4mbooQAO?ohDG[ome5aooICJOodE6ColEMPoo1H@_ocJA[oh6Y2
on1M@ooZG4;okee4oo9C>_ocDCKomD`eooEDB?ogFE?onEQOooURM?oiJ8;onFV7ooUZQoogJh3omfYi
ooI]M?oeKFoomFYXooEVH_ofFekomdm@ooU;@?okDC;oo5@YooI;7?oSFQ_oegLKommY<ooQC6[ogCR@
onLgZooQ>JgogcZZomhgYOoU;YooiSFfom`o__oN>[GoicZbonLj/OoX>k7oj32fonXT^oo/;;OokC^c
ona2[_o]?[3ojCjUomi3QOoIBgkofDf1omI:OOoMAXgokDFconY;]_oLCk?oi5RgooI>_Ooi@;KonDBh
ooU@_?ogFZ[olf2Coo5PROocH8colen?00;olf6>047olf6?ooAOToocGi3ok5ZFoo9PS?o_HWGoi4j<
omm<SonOMXgoW7F?oja`SOnTLH_oWVj>oi5XT_n@LHSoZ6n9ok][TondJ9Ko[FFIojMPV_n[GjSocW^R
okjOOonW[WGoZJigoj^]OOnZZ8ko[:N@oiR_Qoml/F[oQ:i/ohZ/KOn<Zf_oTJQ[oiJYJ_nFZ67oX:5a
ojVKPon[Xi3oZ:N:ojRPOon/WX3o[:J5ojR[O_n/XH3o^HR9okR7R?n_Sh?o/8n3ok2>PoneRHKo]hR4
okV8R?nlQ8go^h:Aok^3T_njPI;ogWZ]ooYbaoojLl;onG71ooYa`_oiLKoonG>oooUa`@02ooUb_`0Q
ooUc_OojLL7onGBkoo9f[OocMjkomgN`ooIi[ooEOIooZ92<ojFRSOnYX8koZZ6>ojVSS_nXXHooXifA
oj6cBonO^COoX;Ljoj2h>onQ^3[oX;Pjoini??nN^CooVkY1oi^j@_nO]dCoXKI5oj2g@onP^4?oXkE3
oj>f?onV/ccoZ;8l00;oZ[4j00[oZK8kojRb??nZ/C_oZ[8kojZc??nY/ckoZZllojZZ>?n/YSCo[:Dc
0_n/YS<04on/YSCo[:Hcoj^V=?nYYcGoZZLeojbV=?nZZT?oZJiGojV]DonV[e3oXJm<oiJ_@On<[cOo
R:lcohZ`>On9[cKoPJd/ogfW8OmnYAh00_mkYal00omlYQooOJHOogZX8002ogZW8@10og^W8OmkYR7o
Oj@Ooffa:_mY]BOoMZlKogRc8_m`]AkoK[DJog2e6omg/2;oOKHFonO=8_oSeBgoe=DdomCE=Oo@eCCo
g=@boo71:?ojWa[onYHHooZ@5_ojSQGonY8Goo^G8OokV2WoniP^oobE=ookWSGomZdZooG3;?ofbR_o
iLP]ol_8;ooNaRcojL@Wonjh8_oa/Qkolk0NonZg8_oR[2SokZ0aooN`>oof^c_omkDiooJh>_og]3[o
m9TjooAh<oojCAoon3@?ooDo3_oeEQKomFPIooA_6OoaNASokg`Gonim5_o^OASokWTCona`2_oZI`;o
iFT1onA^0?ooi6l0AOoTK`0006Coi6l000?ol[N0ooooooooool00_ooool01oo/W53ooooooooooooo
ooooo>gOonA_0?ohfkl00oooool00oo/W53on^C?ooooo`02ooooo`03oo2^L?oTK`3oji=000Cooooo
00?on=^oonA_0?oTK`001OoTK`05ooooo`;oi6l000?on=^oooooooooool00_ooool8onA_0003on^C
@?oooooooooo00Wooooo0_oTK`000oohfkooooooooooo`08ooooo`03oo[TcooVN13oi6l000?oi6l0
00?oiWP@ooooooooool00_ooool01?oebIooi6l0onA_0?oWPB04ooooo`03oo[TcooTK`3oi6l000;o
i6l000?ojHX`ooooooooool00_ooool00ooWPB3okZEPooooo`02ooooo`03ooOB[oohfkoooooo00;o
oooo00?ol:i`on^C@?ooool00oooool00oo[Td3oi6l0onA_001fonA_0005on=_0OoNK@GoeVT=ol]U
5oo2HAl00_noH2400oo0HB3o`V4Nol9Q7P02ol9Q7`;o`V8O01Go`F4Pol1Q8Oo1Haoo`f4/omMQ@OoJ
HD;oeV50om=Q>ooHGdKoleQFooAFD?odF5Com5QBooAGE?odEU?omDm<ooEIG?odG5com5IBooAGE?od
EUD00_odEUL05?odEEKom5AGooADE_odF5Colei:oo9Q>?obGRkolUh`oo9P<ooeHS_on6Q:ooQ]DOoh
KUWon6YGooQ[E_ohK5OonFaHooI[E?odJe;om6eF0_odKUH0>OodKeOom6iFooA^EOodKeGolfa@ooMU
K_ohG7?on5QgooQLQOohHXgon6>?ooQST?ohHhkon6:;ooQRR_ohHhkon6:AooQIR?ohDWcom4eaonm;
K?o`C7GomD]kooQ;NoohDGSon5QkooQMOOohG7con5MfooQDL_ohDG7on4m_ooMALoogDW;ome9[ooEC
I_oaE63ol5QIon]OD?oUITOoh6Xlomi^>ooSN3;omHXJonb59ooKLckojE/eoo1F@_ogG5con6A/ooUW
N_oiJXGonFb;ooQ/SOohJhgonF^<ooU/Q`02ooQ]Q@1/ooQ[QOohIXKomef1ooUAK?oiBU;onTU3oo]E
=ookG37ondlSone36OoJFB7oeG<SomM`9_oPEFOogcRConTeY_oV>jSogcbZomlkYooN?JGohCROonHa
ZOoO?;kog3fion<h]?oW?;7ojSZaonhZ]_oZ:;Ooj2fhon/f]Oo]@J_ok3n]onPmX_oMA87of4]komM;
OooLAH_ojd6Zoni<^?oZBkCohTffoniD_OoiD<?onDNkooU0]OoiBKWonDngooQF[oodGiWolf2;oo=O
S_odGhoom5jBooAOToocH93olf::oneKUOobGXgok69eomm<SooSD8_oc5R=ojQ_U_n/IY_oVW2<oie_
RonEJXgoTVn8ojI_R_nlJiKo]VfAojAPVOn[D[OoiV>nooEd[OnnVX_oXk1mojVZP_nZZH?oZZB5ojfR
Q_nRZX;oNk1Oog:`E_mc/5KoKk5Gofj_DOme[5CoNjYFogjZG_n8ZVooU:N6oiVXQOnKY7koX9ifoj:R
LonQZWKo[IYjokb5Q?nkS8Co]9F0okBDO_ncTh7o^Xb5okf7QoniR8Oo^HF90_njQHX08?nnQ8gofGfZ
onii_?o[NKOokWNgonme]OoaM[Com7FfooAf^?ofM[Oon7FjooQf]oohMKWom7R`oo5hZ_ofMjoomW^]
ooMm[_ogNJooi7RUok:GSonV[93oYjR@ojRVSonZYHgoYIfCoj>aH?nN^CGoW[Tloini>onP^CcoWkPn
0_nO^3/02?nM^CcoV;`loiRk?_nM^D3oX[HoojFd?OnW/S_oZ;4j0_nZ/CX04?nZ/C_oZk4koj^a>on[
/Cco[K0kojba??n//C_o[;4lojbb??nY/SgoZJlkojZZ=onZYSCoZZHcojVW=?nZYcH2ojZW=`0:ojZW
>?n[YSGoZJPiojV]Don/[eooTZm3oh:/:_n4/C?oR;8hohZb>P;oRk4j01SoRk4iohFa=?mn[RWoO:PO
og^V7OmjYQooO:HNog^W8?miZ2;oNJPQogbV7omlYR3oNjLOogF_7omT_RKoK;HSog6b8Om^]23oL;DP
og:a9Ome/Qoo/<PKomoE;_oDeCD3om3E=P0WolOD=Oo@e3Cohm@aonK5:ood_2Gon;LPooRd8_oh]B3o
n;LNooRk7_oh`B3onKlVooVf9Ooh]R;om<<Yonk9:OoadBGon]0Ooo_I7OoghB?omN4WooSN:Oo`gB_o
jm``ooOD>Ooi]SWonK0booVd=?oi`3Son:0^oo5O;_o`C3ComT`hooM4>?ocFB;olX0Poo698_o_QQgo
kX8I00;okX0H00OokX8Ionj47?o_Q1cokghGonea2_oYJP;oiF/00?ooi6l0A?oTK`0006Coi6l000Oo
mm:_oooooooooooooooooogfkooTK`3ooOK_00?ooooo00?oji=0ooooooooool00_ooool00ooTK`3o
mLVOooooo`02ooooo`03ooG9WooTK`3oji=000Cooooo00?on=^oonA_0?oTK`001OoTK`000oolkMoo
ooooooooo`02ooooo`;oi6l000?on=^oooooooooool00_ooool8onA_0003on^C@?oooooooooo00Wo
oooo0_oTK`000oohfkooooooooooo`08ooooo`03oo[Tcoo[Td3oi6l000Coi6l000GomLVOoooooooo
oooooooooogfk`02onA_0003onjUH?oooooooooo00;ooooo00?ol:i`onA_0?oTK`000ooTK`001_om
m^ooooooooooooooooook9a@ooG9W`?ooooo00?okZEPoo2^L?ooool00_ooool00oogdZool[N0oooo
o`03ooooo`03onN18?oTK`3oi6l007Coi6l000Soh6d3omUZ2_o?IQ?oaV8Kol1P8OnoH2;o`F4Pol9Q
7`?o`V4N0oo2HAl0;Oo2HAko`V4Ool5R8?o2I1go`f8UomMQ@OoMHDOoef12omMPA?oGHD;ofF13onYI
DOoeEeCom5ICooAGDoodEeGom5MDooACC_oeCe3omEaRooAGF?odEEGom5IGooAFEOodEUKom5EEooAG
D_ocGD_olV56oo5TAOoaHd;olV4hoo9M<?obGS3olF4booES?_ohJ4Womfe@ooQ]F?ohJUKon6]EooU/
F?ohJeKom6]AooA]DP02ooA]D@0?ooA]E?odKUOom6mFooA_E_odL5_omg63ooQ`ROohJ7con5igooUJ
OOohGhWon6:AooQTTOohHhoon6:>00;on66;09_on6>?ooQQTOohFX_on4mkooI6L?odAW7om4QhooA;
N_ogC7Gon4mcooQBLOogE77omU=booIDKOocEVGokeMHon]HC?oWHDGoi6U0on1]>ooOKcOoh70honA^
>_oYL4;ok75;onaXB_odI2gonfDLoniUE_o[IFgomea/ooQUPOohK8_on72<ooQ_R?ohKXSon6j;ooU]
S?oiK8Kon6]looMXO?ogGW[omEMdooM@JOohCV;ondU;ooa=>OokGc3one`XooU77OoWAagoeeTWom=[
:_oEJ1oohe1Nom/eV?oQ<:_oiCRVomdiYooI=jgogCVYomhkXooM>jCogSJSomdf^?oI>[kogCRhonLj
/oo];[ColBRgonlb]Oo[=;GojS:gonXk[Oo/?Z_oj3jPoma5OooFBGcofdF9onPoX?o^AkKoje2fonY:
]OoUCkKole:nooU?`_oiCKoonD:cooU7/OohC[?onDjhooQE/oodGIoolV2>ooAMT_odG9Colen@oo=R
S?ocHh_okEfBoo5NSOo[GW[ogD^@on=>SooUCY7o`ebNokmG]?nXHYSoTW63oiE/PonBK8SoXFFDokAU
Von`IIco`U^con5Ia_oiIl3omfRcolV1RonUYgKoZ:YjojZXNonYZ7[oZZR0ojbWQOn:[FSoLjmAogF_
C_mf[U3oMjiDogJ^F?mc[USoLJeCog>]D_mmZf;oQZ]cohBZJ_n6YVSoRJERohVWH_nNUFgoZhUaoj6F
K?nQVfgoZIEdojfCNOnbTWgo]hb4okR6QonkQ8_o_XF;okj5ROnbR8SoYhVAojb6U002ojj8U00Wok68
TonbQI;o^8>Eokf3Uoo0Pi[oaX2OolR1XOo4Q9go_HRCokj6TOo4QIGo`h:DolB5U_o9QYOoeH2Mol>6
T_nXYXooYJbBojNZT_nXZI3oZ:VDoj>dMOnL^cGoW[Xjoinj>OnN^SSoX;Tioj6g>?nS]COoY;DgojFd
=onV/cOoXKDgojBc>OnZ/Cco[;0loj^a>on[/CcoZ[8l00;oZ[4l00ooZK4lojZa>_nX/ScoZ;8kojVa
>onX/S_oYk8kojNb??nV/cgoYK8kojJ]>?n[YcOoZ:HgojFX=onWZ3L00_nYYcL02onYYcKoZZHcojZY
@On/[EcoVJU4ogZT7OmkZROoOZl^oh>a<On8/CGoRk4i00;oS[4j04_oRk4hohFa<_mo[2SoNjPPogZU
7_mkYQooNjLPog^V8OmjYb3oMJlOog:d7?m`]a_oJ[`NofJn9Om`]AkoL;@Mofnc8Omb]1_o//XLooKJ
<?oAeSCocMDfoloD=_o>eCKodM@fomSE=OoCe3Gocm@folgE>OoDeCSoi=HdongB;Oofcb?om]4Roo;C
8_oedaooml8OooV^7oojWaKonXL7ooVG4ooiXB?onZ8[oo^f<?ofcc;om]/booSP<_oegC7ommT_oo_@
<_ok^S;onjd`ooZk=?okY2[ondHKooXY9ooi?BoomU0jooIE??odDROolfdLonn26_o^PAGokh4Gonn5
6oo_QagokhHLonn56oo_Pa_okX<Konn57?o`Q1_okWL?onM/0ooUK@00oooTK`12onA_0000I?oTK`00
1oolkMoooooooooooooooooon=^oonA_0?ogdZl00oooool01oolkMoooooooooooooooooomm:_onA_
0?ob]h000oooool00ooji<ooi6l0onN18004ooooo`03oo[TcooTK`3oi6l000Goi6l01Oooool2onA_
0003ooSK_ooooooooooo00;ooooo2?oTK`000oo[Td3oooooooooo`09ooooo`;oi6l000?on=^ooooo
ooooool00_ooool2ooSK_`03oo[Tcooooooooooo00?ooooo00?ok9a@onA_0?oTK`000_oTK`000oo/
W53oooooooooo`02ooooo`03onbLD?oTK`3omm:_00Cooooo00?oiWP@onA_0?oTK`000ooTK`001_oh
fkooooooooooooooooool[N0oogfk`?ooooo0_oWPB03ooooo`03oogfkoogdZoooooo00;ooooo00?o
oOK_onA_0?oTK`00L_oTK`001OoSKP7og6`7om5W4Oo8HaWo`F4P00;o`60Q00Ko`F4Pol9Q7oo1HB3o
`V4Ool=Q7_o3HQh2ol9Q7P11olAS7?o5Ha[o`f8LokmQ8Oo1Haoo`F<RolaP>OoOH4[oef14omUPAOoL
H4Oog616omUQ@OoSGU3omEMGooEFE?odEECom5EEooEEE_odEE?omDe=ooEDEooeG63om5ECooAFE_od
EESom5EEoo=KCOobHDKolFA3oo5TAOobHdKolV96oo5S@oobHCSolUh_oo9N<?obH3;omF4oooQXBoog
KE3on6aDooQYE?ohJUKonFeHooI/EOodK4kom6eAooA]D?odKE7om6]@ooA]D_odKU7omFiMooQ`Q_oi
LY3on7>;ooQ_QOohIgkon5inooQMQoohH97on6BCooQSSoohHi000_ohHXP0E?ohHhcon6B@ooQPT?oh
EX7omTe_oo98I?obB6[okTi`oni@KOo]DfKok5MFonUIB?oWGT?ohfQ5on9/@ooTJ3koiFQ0onYYB?o]
K5?ol6aOoo=YH_oeIF3omFEQooISH_ofHf3omee7ooML5oohG37ojVMVoo1QKOohFFoomUmiooITN_oh
Jgkon722ooUaROoiJXGomf9hooAILoodDWComTeWooU>FOokCdkoo4/moo]E<_olGB[oo5DPooA66_oS
BakoeUdWomEQ;?oFJAooheQ?onDiV_oM<JWohSRYon0iYOoI=jKoeSJ^omXh[?oJ>:KofCVVomLfY?oH
=ZkoecZnomPj^ooU<[[okRBhon/]]_o[=KGokCJeonde/_oZ>JgojSZ^onLmW_oL@X?of4B3omi3SOo]
A:Wok4ndonY?]OoZC;GojTniooMC`@;onDno06konDBiooU3]OohC[Con4jbooU>]oohD[Kom5RNoo=N
T?odGI?olf2>oo=QS_ocHXcokUjAonmMT?o^GGgoh4f?on==T_oVC9;odEFDokiL[OoKBK_o[6J;oi9/
Pon4GiGoT5VKok9UVOoDHZcojek4ooEQ`?ohH[com6>eolm]UOnfQggoZZ9hojN]NonW[7goZJb0ojjY
P_nF[W;oL[EFog:cEOmh[eOoNJeHogN`FOmc/5CoLK1<og>_C_me[T[oNjmMoh6_J_n1/6_oQjU[ohBU
Hon@V6OoW8a[ohnHIOn9WfGoS9iUohnNJ?nBWFkoUIUdoibCNOnTSWooZXanojZ=PonMR8coUX>?oi^6
S?nORhcoWhf>oij;SOnNQh_oWXJ;oin4S?nQQ8WoXHJ:ojF4SOnQRH[oWiN5oj:GQ_nOTHCoX8n2oj6B
Q?nSW8?oX9j6ojFER?nYUH[oYib;ojJOS_nVXi3oYZ2BojBSOonT/cgoYK<bojFc=?nW/S?oZ;4dojV`
=?nZ[cGo[:hdojb_=_n][SGoZ[0eoj>d=_nR]3OoY[8hojR`>OnY/C_oZ;4kojR`>@;oYk4j00goZJlj
ojR`>_nX/3WoYk4jojR`>OnW/3WoZ:liojV_>OnV/S[oYk8lok2^?onfYcgo[JHg00;oYjHe05[oZJHe
ojZV=On[YSCoZZHdoj^/C_nU[USoPJHZogbQ7?mkYB?oO:HSogf[9omo/2koQK4coh^a>?n=/C[oS[4k
oh^a>On5/3;oNjdXogfV7omlYQkoN:`Nog6d7_m]^QcoKK/Jog2h6omb]AcoJK`SofRj9Omb/AooM;HM
ojg:8?ohfS7og]LcomWE<_oFeSKof=HgomcF=_oLeCGogmHdomkE=?oSeS3olmD^omo;<oo7cSGodm@d
onGC=?o]e2oom<dWooV`7_ojVA[onYLHooNS7?ojS`konXX7ooBQ7oobUR_omi8XooVT9ooj_B[onl`^
oo_D;Ooke2kon/hboo[8<ook^cConj``ooYD6ooj82oonRXdoo/W;?ok<CGon40_oo946OobAAcolThV
onmL6Oo/HPkok6P=one[3oo^Ja3okVh@onic4?o_NQCokg/Gonmo6_o`Q1gol88Konac2_oVL0?oonA_
047oi6l0001SonA_0003onIh4?oooooooooo00;ooooo00?ol[N0onA_0?o`[W001oooool00oo^YF3o
i6l0on^C@004ooooo`;oi6l01Oooool00ooVN13oi6l0onA_0003onA_0003onV:<?oooooooooo00;o
oooo00Coo>gOonA_0?oTK`3on=^o1?ooool8onA_0003on^C@?oooooooooo00;ooooo00?ol[N0onA_
0?oTK`001_oTK`000oohfkooooooooooo`02ooooo`?oi6l000?ojHX`oogfkoooool00_ooool00ooj
i<ooi6l0onA_0003onA_0007oogfkooooooooooooooooooebIooi6l0oogfk`03ooooo`03ooOB[ooT
K`3oi6l000Coi6l000Gol[N0oooooooooooooooooogfk`03ooooo`04oo[TcooTK`3oi6l0oo[Tc`?o
oooo00GooOK_ooooooooooooooooooSK_`1aonA_0009on=^0OoMK0KoeFT=ol]U5oo1HB3o_f0Rol1P
8Oo1HB3o`V4N00;o`f4N02;o`V4Nol1P7oo2HAgoa6<Kol=R7?o1HAoo`f8Ool9Q8_o1HROo`64`ol=Q
=_o6HS_obV93om1RBoo5H3Ko`f4UolAQ:oo5H2koaf0`olEP;Oo:GSOojeYCooAGDOocETooleIBooAF
D_odEe7om5I?ooE?BOoeFecom5ULooACEOocFE7olUm80_oaI4<04oobHdColV95oo9RA_obHTKolV97
oo9RAOobH3Woled_oo9M<?obGcComV10ooQWB_ogKU3omf]BooQYE?oiKE[on6eIooA[D?odKE400_od
KED0K_odKE;om6eAoo=/C_oeK5oon6j6ooU^S?ohKXSon729ooQaROohKXOon6R1ooQQPOohGhWon6:=
ooMTRoogHXOomf>5ooMRQOofH8ComV>8ooMTROogGGoomdeUoo97B_oUD3oogUY1omeQA_oPJ4koiFQ;
onaVBOobHTkomFAIooITG?ogI5komfARooMUHoogIFKomfMZooIXIOofIf?omVEQooEVHOofHEKomETK
ooQO5ooaFcgojfASooEJHoogG73omFAjooMVO?oiIWkomeiiooEGL_o^E7?olU1_ooU>FoolCTSoo4i5
ooa>=OojGBgonUdSoo]97?o]AQoog5@XomIN;OoGGB_oeEhQomiM>?oX@9?ogcBUon4gYooQ>ZCogSVT
omTgYOoG>:[oecV/omLiY_oH>JGoeSNUomPiYOoH@KWoeCk1omlW`OoX:KWoiC>eon@a^?oU<;Koj32e
onPh/OoW>K3ogS6VomPiS_oH@h?ohT>Eoni8/_o[C[GojdbdonY=]Oo_C[[on570ooU@__ohDKkonDZk
ooU0^OoiB[Con4n`ooU;/ooiBkKomU6Z0_ocGhl2oo=PS`1Soo=PS_o`GY;okUj>onmLO_oQBi7ohT^G
onI=U_oNDI;o]V>Mon1=^ooU?kSoXU6NogaGV_nJHYKogV>/ooIS^OoYH<;om6BlooQT__o`J;GoaVnG
okQ`R_nZR7coZiEjok2AO_nZU83oZ9Iooj>NNOn0ZVGoNjMQoh6UIOn0YV?oOJMIogZUDOmmY5;oP:9F
oh2SDon2XEKoS9eYoiFMMOnCXGKoTJ5`oiRIJ_nZRGKoXi1ioiNLMOnJVGGoWI=foij>MonQRgSoZ8R1
ojZ5PonTQ83oX8:6oiioS?nRNhooYG^>ojemT?naO9Co[gfBok5lU?n^OICo[WbCojemTon[OI;o/7ZD
ojMnS?nQR8KoXh^7oj><R_nSSXWoXHZ7oj>=Q_nRThOoYI>7ojF=QOnVT8KoYH^5oj:<Q_nRRX_oWhZ;
ojN]ConU[S?oYZdmojB]??nU[CcoYJdkojJ]>_nV[SWoYJlhojJ^>OnW[cSoYjlfojBa=OnQ]3?oXK<e
ojBa=onW/3SoZJli00;oZJlh0_nY[cT2ojR`>@1UojNa>_nX/3[oYk4jojJb>onV/S[oYk8jojVc??ni
[3ooaj90ol:P?_n]YCKoYZHcojNV<onZYSGoZZDbojZW>OnZ[E;oS:TjogZU7OmlYB?oOJ<PogfR8?mm
XaooOJLTogn/:On3[booR;4eohf`>On@[ccoSJlgoh2a<?me]2CoK[TJofnh6?m]^Q_oJkXLofji7?m`
]agoL;TKofRm9?mX]R3oQ/8FonWH<_oNeRoocM0[ol;?:onhc2go^/hXok;::OnZbRcoY/T_oik2<_n=
`2Wo/K4^omJ59_oUNQ_ojl0Xon;C?_oba2koni/LooZ<7_odWBgojjThonN]>ooZYCGonX`GonjT:_oP
[3oohjPkonnb=_oh]b[onKLWooW1:OojbBkon/Heoo[<=OokdcOonX`XooT`9Ooi?S3onDT]ooQ<9_og
CBKomT<coo@e8_ob=QKol3`Fonm47oo/F1WoiVP7onE/0_oVJ@;oif@4onMV1_oXI`OojF@7onUS1_oY
IPKojW4=on^15OoWM0P0oooTK`11onA_0000HooTK`000oo[Td3oooooooooo`02ooooo`03onjUH?oT
K`3ojHX`00Oooooo00?oiWP@onA_0?oVN1001?ooool00oo[Td3oi6l0oo[Tc`04ooooo`03onjUH?oT
K`3oi6l000?oi6l000?ol[N0ooooooooool00_ooool01?oebIooi6l0onA_0?ohfkl4ooooo`Soi6l0
00?oji=0ooooooooool00_ooool00oob]h3oi6l0onA_0006onA_0003ooSK_ooooooooooo00;ooooo
1?oTK`000oohfkooooooooooo`02ooooo`Goi6l000Koll2?ooooooooooooooooooc]goo/W504oooo
o`03onbLD?oTK`3oi6l000Coi6l000?ok9a@ooooooooool01Oooool01?ob]h3oi6l0onA_0?oc`8l7
ooooo`03oo:gP?oTK`3oi6l006coi6l002Oohfl1on1]0ooHJP_ocVHDol=Q7_nmGbCo_ElSol5P8?o3
HAko`f4Mol=Q7?o4HQ_o`f4KolAR6oo2HAko`F4Rol9Q9oo4HRgoaF8bolQR>Oo<Hckoc693olaSAoo@
IDWod6A;om1TC?o@I4_odFA:olAR<oo3Haco`V8LokiP8?noH23o`60Mol=Q7OoCGCkole]9oo5IAOob
FTL00_obFTH02?obG4[oleE5oo=DB?obH53ol64konmU=_o_IcKokfHg0_o_ICP04_o`IC[ol6Dkoo1T
>_o`IC_ol6@loo1U>oo`I37olF4Xoo1P9_o`HR_omF8jooMZB_ogL4komfa:ooM[CoohKUKomFeAoo=]
C0;olg1@067olg1?oo=_D?ocL4_omG1TooQ`QoogL8?omfmnooQ^P?ohKh?on727ooQbQoogL83omfYn
ooMWQ?ogIHOomV:2ooMPO?ofH7Somf5eooMRLoogHfkomfMeooMYN?ofIg7ol6EPonaRE_o]FU;ojV5O
on]WJOoaJ6Wom6MSooITGOofHe[omV9IooIQEoogH5OomV1IooIRGOogHekomf=MooMSG_ofHekomf1J
ooIG:OofH1GomUdOonaRBOo]IF?omeQYooMNP?ohGXkonE:4oo5AK_o]F7_oleV4oo]<F_olBSWoo4dd
ooUI<_ogHRconELPooI67OoVAbWofED]omIO<OoGFc?oeUTYomYD:_oX@H;ohcFWon4jX_oS?:;ohSZR
om`hY?oI>:GofSZVomTlZOoH>ZOof3VUomLiYOoG>Z7ofSn_omQ3aooG<[oohC6ionDf]OoS<kGohc6c
on@c/_oS>K;ogCBdom4^YOo>>97ogD6KonA2/ooSB[Oohd^f00;oiDVe04kokdVnooU=`_oiCkoon5:m
ooQA^_oiA;OonDFdooU=/OohC;3on4fbooMC/?ocGY3olf28oo=OS_ocGhgolf2>oo5NT_o`GXool5V7
on=;TooSCYWoiDnEon5=S_nmHICo`6FPol/j]onI@JgoRV2AojEXT?oYG[?olf>konmP`?ofJKSon6Jo
ona]Zoo1O8Ko]GR8ok=fQonfLhGo_W24okacOonmL83o`G>3ok1oOOn[PGKo/Gmjok60O?n`OGco[gmi
ojf1L_nbOg?o^gQjokefN_niMWSo_WAnokmfQonoO8co_H6:okilQonnOHgo_H2?okelS_noOHco`7f<
okilRoo0N97o_g>FokQeTonjLIKo^W>Fok9iT_n[N97o[WNCok1iTonaN9?o/7JFojmiTon_NY82ok1i
T`0DojiiUOnQNhSoWGj2oienQOnMOhKoWh25oj21PonQQHCoXHR5oj>9PonSRHGoXh^5ojJ>Q?nSR8?o
XHb5oj6<T?nTY6KoW;8hoj2]@_nVZTH3ojNZA0;oYZY500[oYjU3ojF[@_nU[3ooYJi0oj6a?_nK]3_o
WK@ioj2c>onR/SgoY;4m0_nU/C`06?nU/S_oYK8jojJb>onY[cWoZJlhojR`>OnV/CWoZ;0iojV_>OnX
[cWoYZlhokJY>_oCWD;ofYM7ol:N?on[YCCoYZHcojRV<on[YC7o[ZLnoiR/@OmjYb?oO:DRogfV8P;o
OJDR04GoOJ@QogfS8?mlYB;oOZPUoh2[;?n5/3;oPkHfoh2j=omm^cGoMk//ofnl8Om/^QSoK[HJoffh
7Om]^AgoL;PLog2h7_mW^b;oMKXKohVo7_n7_QooQ[TOogjg:?mb^RSoI[XSofBl7omV_23oK;XSog>f
8om`^2;oK;TPohbe;?o;TBOonH@8ooNg8OojVQWomYDTonbW=ooW[3goiZdoonF]@OoT[d?omiDUooR5
5_o]WbgojKe2omg=?oo[c2koml8XooNm9ooh]bcon;@dooVl=Ooi_33on9d`ooM`<OogMboomH8/ooB2
9oodKBOomDm1oo92>?oYF@Woif@0onYG0_o]B`cokE4EonUP3?oUK@40oooTK`1:onA_0000HooTK`00
0oob]h3oooooooooo`02ooooo`04onV:<?oTK`3oi6l0ooc]g`Gooooo00Gon^C?onA_0?oTK`3oi6l0
oogfk`03ooooo`03oo:gP?oTK`3ol:i`00Cooooo00?ooOK_onV:<?oTK`000_oTK`000ooYRS3ooooo
ooooo`03ooooo`04onjUH?oTK`3oi6l0ooSK_`Cooooo2?oTK`000oo[Td3oooooooooo`02ooooo`03
oo:gP?oTK`3oi6l000Koi6l000?on=^oooooooooool00_ooool3onA_0003onIh4?olkMoooooo00?o
oooo1OoTK`000ooYRS3oooooooooo`02ooooo`05ooSK_oooooooooooooooooolkMl01ooTK`000ooW
PB3oooooooooo`05ooooo`04onV:<?oTK`3oi6l0onV:<0Oooooo00?ok9a@onA_0?oTK`00J_oTK`00
<_oRKP;ofV/9om1W4oo8Ha[o`V4Ool1P8OnnGb7o`60Ool9Q7Oo3HQcoa68Kol=R7Oo3HB3o`f4Tol=Q
;?o7HS?obF4iolaR@?oBI4Kodf=9om9SBooBI4[ocf=9oleSB?o?I4WocVA8oliSB?o>I4OocV=4om1R
B_o?HT_o_Uh/okiO7onmGB?o_ehQol1O7oo3H1_oaU`^oo5NBoobFTKolEY6oo9JAoobFDGolU]8oo5M
A?oaFcOol6Hjonm[>?o^IS3okVHb0_o^Ic82oniW<`?okVLb01SokVLconiW=?o^Ic;okVHYonmS8_o^
Haookf@UooAU=oogKDSomG9:ooE]@OofK4WomVm>oo9^AOoaL4ColG55oo5`A?oaL4?olG50ooAaGoof
L7komW5looM`O?ogL7l2ooQ`PP1WooQaP_ohLh3on7>1ooQ`QOohJHCon6EoooQWN_ogK7WomfmiooM_
MoogL7SomWAoooIhROofNXkomWR?ooI_QOodHfSol5U=on]IC?oYHEcojfIWoo5UH_odI5comFALooET
GOoeI5oomFARooEUI_ofIF?omVAOooMSFoofHU_omVEQooIP?_ocI1Somf4Loo5I:Oo]FE[omU=[ooU>
O_oiEi?on5R>oo=IP_obEW[onTUNooa;=?ojF2oomUhaooMN:OokDakolTdQon1B;?oGF2koef0_omQM
<_oGF2ooeUXXonQ9I_oW>jKoh3bPonDmXOoT?J7ohSbSom`lX_oK>j?og3fRomTlZ?oH?:Sof3^SomTl
XooG?J3ofS^Romm1_ooCAL7ofCZeonDd]?oW=;7oiCBbon<b/ooM<KKog3F_omTmUOoD?HkogT:^on1B
]_oMD;GogT^doma;/ooPBKKoldK0ooU7a?oiB/3onDc1ooQ?`?oiA[konD2hooU:[oohCJgonDbbooME
[oocGY7olen9oo=OSP02oo=PS@1Zoo5LToo]Fi?okER;onE;V_oUCiSohTnCon57T?o2EXSoUGBAogM>
WOmhAj3oReb@oi9ZQOn]Hi?oc5V^onEQ^?ohJ[7on6O0onQ/[?nmOX3o^Gj1okejQ_ncMhWo]WF;okmf
QoneO7_o_gAnolY^QOo8LH;oaW:0olIcP_o3M7oo_WQlol5fP_o7LXOoaW>3okmiNOo1MgkoaG:4olU/
Q_o8Jhgo`g:Col5fT?o2MXoo`G^?okinRonnOXgo_7bAokAmT?ndNY;o^gBFokaeTonmMIGo_gBGokUf
Ton^N93oZgVBojeiTon`NI?o[WVBojijTOn^NI7o/GVBok9iU?nZNhgoWh21oin0P_nNNh;oW7V2oieg
P?nMO8;oWh:2oin4P_nOOh3oWgj1oimoPOnRQX;oXXj2oj>8P_o=LikofH:CokRQBOnW[47oXji2ojF/
@_nW[4;oYZi3ojJ]@onU[TCoY:m2oj>`@OnS[d;oYJe3ojJ/AOnR[T?oW[90oj2a?onP/47oXK13oj2a
A?nR/4KoXk16oj>aAOnT/T;oYK51ojJ`@0;oY[0o017oYjlnojJa>onU/S[oY[4ioj6a=onXZSCoaYdj
on>BAooNUDOo_Z4lojbU=OnVYS?oZjDcoj>V<On4XAooNj<PogbW8`02ogfU8P16ogbV8_mmYB;oOZ<Q
ogjS7omhZ1koLK<Nog2h8Omb^bOoMk`_og^l=Omj_CKoN;//og:i8Om_]acoKkLKofjh7oma^1_oKKXO
ofVg9?mb/AcoL;@Kofnc7Om]]ROoKKX]of^m:om^^bKoL;XSog6h8_m_^R7oL;XQofjj9_me]BKoRkdS
oo6d5?ojVA_ojHX]onN/?OoV/3ooj:/lonR/?OoW[T3okZXeooRQ6ookQPgonZ4Oon38:?nYaR;oVl8U
ojo2:?oFaROomKXaooNW<oogYRoomjT^ooNe<OofXS3omGlZooAj9oodPBWomF`VooI5??o]HTCoiFX4
onA_0?oTKP3oiVP0onUL0Oo[D`KojF4<onEa1_ooi6l0BOoTK`0006?oi6l000?omm:_ooooooooool0
0_ooool3onA_0003ooG9Wooooooooooo00?ooooo00Gol:i`onA_0?oTK`3oi6l0ooSK_`03ooooo`04
ooOB[ooTK`3oiWP@oogfk`Cooooo00CooOK_oo?0Soob]h3omLVO1Oooool01OolkMooi6l0onA_0?oT
K`3on=^o00Cooooo2?oTK`000oo[Td3oooooooooo`02ooooo`03ooSK_oob]h3ol[N000Col[N000?o
ih4PonA_0?ohfkl01?ooool2oo:gP003ooSK_oomm^oooooo00Cooooo1_oTK`000ooji<oooooooooo
o`05ooooo`03oo?0SooTK`3oi6l000Koi6l000?ooOK_ooooooooool00oooool00oolkMooi6l0onA_
0002onA_0003ooc]gooooooooooo00Cooooo00?oih4PonA_0?oTK`00IooTK`001OoSK`7ogF`6omEY
3_o;IAOo`f4M00;o`60O02ko`V4LolAR6oo4HQco`V4Pol=Q9?o2H2[oa60^olMQ=_o<HT3odF=6omAT
BOoDHdSodV9:om9RBooCHdSod6=6olmSAOo<HdKobV=7olaSB?o>HdKocF98olaRB?o<HTKobf1:olaO
COoAH4ooaEhiokmN8?o0GQoo`ElPokmN8Oo0Gago`ehUonALAOocFTSolUU8oo9HB_obFTOol5lnonmV
<oo_I2ookf<conmZ?Oo_J3OokVHb2Oo^Ic<2oniW=01BoniV:oo_I2;okV@Qoo1S9OoeHSSomfi;ooEb
BOoeJd3omVa5ooA/AOoaKd;olG55oo5aA?oaLD?olW15ooI_KOohL8Gon720ooQ_O_ohL7oon760ooQb
P?ohL83on6j1ooQ]RoohIgkonFMbooQ^O?ohKWoon763ooQcQoogLhGomg>4ooM`PoogL87omg:1ooIf
QOofNH[omWJ9ooI]NOodGUgolUA:onaFC?o[HUkokFQUooAVH?oeI5com6ALooEUHOofIV?omVIPooIV
GoofIEcomFEKooIYIOogGToome<GooU<5_og@aCokTDioo5@K?oiCfoon5F2ooQLTOojBgConC/jooY:
:OogH33om5l/ooMI8_okDQcokU<WomUK;ooFGboof5l]omMQ<?oHGS7oeEhXomeC>_o^AIooi3ZVon8l
WP;ohcbQ0<GohSbRomdlX_oL>j;ofS^RomTkYooI?:SofC^SomTlX_oH?Z;ofCZPon8f/_oKB<;odDFh
omlf/_oT<;;ogBfdomdW^?oP<KCoh3fXomM0SooH@97ofdNfomiC]_oPCk?ogTncomaA/OoSCKComTRl
ooU6__oiAL7onDO1ooU9_oohALGon3fmooU6/?ohCZoonDbaooMCZ_odGI;olen:oo=PS_ocGhkolen=
oo5MTOo`FY;ogej6omE?T_oTCIGohT^Comm3SOo7CXOoQFJLofeBXomlCi[oTUZ?oiMVQOnOIh_oYeNM
ojeWUooELiWomfZgon]^[_njOWoo]X5kok]oP?nlOh;o^gR8ojaiQOnAVWWoUi=eol5eO_o6MGoo`7Io
okeiO_nhNgKo_WMlol9fOonnMWgo_WF3ol5cQ?o3LhGoaG69olA_Q_o4KXSoa6j9ol=bQ_noMhOo_GZ=
okYlT?ncOI3o/Gb>okAkT?ncO8oo]GV@okYdTonjMI?o^gJCokmeU?nnLiKo]WFEok1hT?n]NI;o[gRB
ojmhTOn_NI3o/7VCojmiTOnSOXGoWh>0oj22P_nOP8;oWW^2oiehP?nMNh7oWX>3oij0P_nMOX;oWWf0
oiikP?nMOX;oWHB0ol5jT_ofK[7omW>]onenK?oISEKo^Y]<ojJWAOnPZD3oXjQ2ojFXA?nTZT7oY:]2
ojJZ@_nVZdCoY:a3ojF/@_nV[D?oY:i2oj2b?onQ/SkoY:m1oj>_@onR[d?oXji7ojF/BOnW[4[oYj];
ojN/BonWZd_oYj]:ojF/BOnT[TGoXZm3oj:a@onS/D?oXK0noin/=?ngXSOohYE;on^;CooHUdOo^j8k
ojfU=OnWY2koTi`Hoh>H4_mlYB;oNjPTogbV8omnYB;oOj<RogZX8?mc/R7oLK@Pofne7Om_]QcoKKPL
offh7_m`^B?oM[X[ogVk<_mk^c?oMkXZog2j8om]^1goKKPKofjh6omZ_23oK;TRog2e7?m`]akoKKXU
ofbk;?m]^bCoL;XQog2j8003og2j8@0Qofnj8_m_^2?oKkdHohK15_nX]c;oh9=5onRV?OoX/Sgoijdm
onVZ?_ofX2oomj/Oom2g6on`^QWo/<@Xohbo7omb^QWoK[TXog2j:?mi_b;o^L8ionNj?Ooe/SKomZ/^
ooF]:Ooe/2[om9<XooEg9ooePB[omFdVooI0=_o[PT_oiGL>00Coi6l000CoiFX0onMV0OoVKP?oi6l1
oooTK`18onA_0000HooTK`001Ooji<oooooooooooooooooon^C?00?oi6l000?okZEPooooooooool0
0oooool01OoWPB3oi6l0onA_0?oTK`3ol[N000?ooooo00Coo>gOonA_0?oTK`3ok9a@3?ooool00oom
m^oojHX`onA_0002onA_0003ooSK_ooooooooooo00;ooooo2?oTK`000oo[Td3oooooooooo`09oooo
o`03on^C@?oTK`3on=^o00cooooo00?omLVOonA_0?oTK`001?oTK`000oo`[W3oooooooooo`05oooo
o`03onN18?oTK`3oi6l000Koi6l000?omm:_ooooooooool00oooool00ooebIooi6l0onA_0002onA_
0003ooG9Wooooooooooo00?ooooo00?ooOK_onA_0?oTK`00I_oTK`004ooRKP;ofF/:olmV4oo6Ha[o
`F4Mol1P7_o1HAgo`V4Nol9Q8Oo2HBOoaF4/olQR<oo;HS[od6=3omASBOoCHdSodV=9om9RC?oAHTT0
0_oAHdD04_o?HTKod696om9TAOo>HdGobV=6olYSAoo;HdSobf98ol]QBOo:H4WobUm8olaOBoo>H4_o
cF19om1PB_o=H4Co`EhVol5O7@;o_ehQ00oo_elPol=Q6oo=FSWolUY=oo9IA_oaGT3okf@eoniV<?o^
J33okVLcoo1Q<oo_ICSokf/koniW<oo^IS<02Oo^Ic<0fOo^ISGokVHdoniV:oo_I2?okVDQoo1S9ooe
HCSomfi<ooE`B?oeKD7om6Xnoo5Z>?oaL4Kolg9=oo=`B?odKeGon6mnooQ`R?ohL83on75mooQaP?oh
L87on6j4ooQZPoogJH[on6R5ooULG_oiJG3on71kooQ/K_ohK73on6ikooQ_POohL8?on724ooQ`Pooh
L87on720ooMcQOogMhkomg^DooMgT_ogJG_omEQGonmBAOo[FToojfAQoo1XIOodIUoomVEOooIVH?of
If3omFIKooITGOofHF?omV1`ooIHIOohAAgomd@;ooY35oocAA[ojU9QooIFM_oj@eKoncI<ooHl@ooe
CRcomF</oo9K9oofFAkonEHPonYD:OoFGS7odelcomQK;ooIGBkoef4aomMR;OoDHbSoiTaYonll]_oW
>ZooiCbTon8kX?oS>Z;oh3^Qom/jXooJ>JCofCRRomXkYOoI?JSofS^UomPlXooH?Z;ofCZUomhcYOoQ
@;Sod4W0om4l^?oJ<;Ooh2VgonLZ]_oV=;?ofcbVomHoTOoMA9cogTZgomY=^?oOD;;ogU2boma@/ooX
CKCon4ZfooU;^?oiAk_onDFnooU7_OogBL7on472ooTn^?oiB;ConDbbooMFY_ocGI3oleb@oo=OS_oc
GXoolen=oo=NSoo_FYWocFEmokYPMOoBDhSohTZ<on0oS?no?hooPEVLogiIWon2EYCoTUbAoiePR_nO
IH_oZ5>Soj=RTOnSNG_o]6n?ol5cUoniOHCo^7inokUnPoo0O8So^GV4oiR;M_n;WH3oRIn5ojB7O?o3
LWoo`7MnokajO?o1MH;o`g65ol1dOoo1LgkoaFn;olA]Soo3K8oo`ff@ol=]SOo5KX[oafn8ol5eQOnd
O7oo/7Z1ok5gROnbMY7o/WRBok=kTOncOHko/Gf<okEhT?njM9?o^gFCokedU_noLiOo_W6GokMeT_nc
Mi7o[gRAojmiTonaNI;o[GR=oj5jQOnMOh7oX7n2oimnP_nOOH;oWh22oj1oPOnNOH3oX8B0oin0P_nM
O87oW7^2oi]kPOnGOGoo^GJ>onabZ_ogMk3omW:dooAnP_obOV?ojhATom:@FOnfWD_oXjI2oj>U@OnW
Y4800_nYXT@0?OnZXTCoZZ=5ojZSA?nYYDGoZJA5ojRWA?nRZd;oXJdoojJZ@_nWZT?oY:e3oj6^A?nR
[dKoY:i:ojJ]C?nW[4[oYje:ojF]BOnV[4[oZ:Y;ojNZCOnUZdcoY:]<oj6/AonLZ3koZJ4mom2BC_o^
QU[okHYFomJGBOnoWd3oWJ8Soh^E2on7U1;oPj0NogjV9?mlZ27oMZlOog2e7om`]B3oKKPMoffi7Om_
]akoLKDLofnd7?m^]AgoL;DNog2f8Omb^ROoM[/_ogJl<Omb_2[oKkXQofnh7?m]^QcoJk/Qofne7om`
]R7oK;XXofbk:?m`^R001?m`^R42og2j8P0Pofnj8Om^^RCoLkHSogBg8_nhWSGomIDjonZY??ocYcco
mJT[on>g7onP_a[oOKXXog:g9_m`^2;oL;LWofng:?m^^R7oKKTRogFd9?nD[b_o/JhcolBb=OoD/2go
jZHZooF/:ooe[2WomHXYooEk:_oeJBCom5HeonbEBooWQR3oonA_053oi6l0001SonA_00Cooooo00Go
mLVOonA_0?oTK`3oi6l0onN18004ooooo`03oo[TcooTK`3oi6l000;oi6l000?okZEPooooooooool0
0_ooool01OoVN13oi6l0onA_0?o^YF3ooOK_00Wooooo00?ooOK_onV:<?oTK`000ooTK`000oohfkoo
ooooooooo`02ooooo`Soi6l000?oji=0ooooooooool02Oooool00oo[Td3oi6l0ooSK_`0;ooooo`03
oo[TcooVN13oi6l000Goi6l000?oiWP@ooooooooool01?ooool00ooji<ooi6l0onA_0007onA_0003
oo:gP?oooooooooo00?ooooo00?ok9a@onA_0?oTK`000_oTK`000oo/W53oooooooooo`03ooooo`03
ooSK_ooTK`3oi6l006?oi6l001;ohfl1omi/1OoFJ@coc6DDolAR6_o2HQco`F4Ool9Q8_o4HROoaV4a
olYR>_o=Hd3odF=7omATBOoDHdWodf=;om9SBOoBHdD2om5SAP0Wom1RA_o?HTKocf96om1SAOoAHdCo
d6=5olaSA_o7HTSoaF99olIQB_o9Gd_obEm=olYNB_o;H4SocEm:oliOBoo=H4SocV56om5PBOoBHDco
`ehaol5O7?o1Gako`UlOol1O8?o2H1coa5d]onYNA?o`HcWokVHboniW<Oo_IS?okVLconiX<oo_IC;o
l6<eonmX>_o_JCSokVHb00[okVLc01CokVLeoniV=Oo_IRcokfHSoniW8Oo`HRKomV<iooI_BooeKTGo
mFa1oo=W=OobJCWom71<ooA^C?oeKUgon724ooQbQ_ohL83on6j0ooQ[Q0;on6R5023on6R7ooQ[S?oi
GfKonE]EooQ_N_ohKg;on6iYooQ]J?ohJfWon6a`ooQ^N?ohKW_on720ooQaQOohKh?on6j2ooQ_P?oh
LXSon7NEooMiUoogMHoomfIeoo=EC_o^CC[ojeI7oneTGOodIfGomfMUooIUI?ofH6?omUaYooIJK@;o
mUae03ComdDbooQ51ooj@a_onDPIone;<?o_?dOomClTone0:?ob@cOome0[oo9N8_ohFB3omeDNonIH
9?oFGR[oeEl]omEK<OoHFBkoeV4^omEU;ooDIbKofEPionU8UooW@ZkojTBdonI0[ooR?Z7ohCfPomdj
XooJ>:?ofcNSomXgX_oJ>J?ofS^WomTkYooI?:;ofCfRom/gZOoK=:7oh3R]om=0aoo7>l7ofCjcon8i
]?oX;;Goi2jeomPgYooH?iWog4ZQon1?/ooKBkOofDjd0_oLD;40B?oXCKCon4ZdooU;]OoiB[Con4Rf
ooU7_?ogB<?omdG4ooTl^ooi@;WonDZiooEGYOocGI3oleZGooAMTOocGhgom5j?ooAMU?oSH8go`fQc
ok9WKoneIV[o_F1Zol94Qonj<9coTE6Ioh=WVon?G8koSUbBoiURRonLGhooY5>Uok9NVonZKXCoVFF8
oi=YS?nVNH[o^gn2olAnQ?o1NhCoXHQcohjHJ?n@UFcoSYYlohVLQ?nVNh3o`G=mol9fOOnoMWko_g>0
olE^QOo5KHOob6^:olUZRoo8JhgoaFZ@olMYS?o7KH[o_g>7okAgQon/NXCo[7V2ojejPOn`NX;o[gN:
ojmeT?nbMI;o]7VBokEiT_nhMI;o_gBFokebU`;o^GFD04co^gFDokafToneMi7o/7RAojMiS?nPOH?o
WX61oj21P_nNOh?oWh22oj1oP_nOP8;oX7n1oin0POnQQ8;oX7n2oiijP?nLNH3oV7mnojmfR_oYK:Wo
mg6aooEb[oocL;?omGbAoo:1HOobP6GolWiYonb2HooBT5Ko^Im;ojJT@_nUYD?oZJA4oj^RAOnYXTGo
ZJ94ojZRA?nZXDGoZZ56ojZQAOnWYD?oY:I1ojNT@onYXd?oYjE2ojJW@onSZTGoY:Y9ojF[B_nWZT_o
Yj];ojJ[B_nW[4[oYje:ojJ]B_nT[D[oY:m;ojB/B_nOXd;oWJ4ookNIB_oQREcol81Uoo27I?o@Te7o
UYXPohBF3_n5VA?oNJLJog2e7_mb]R?oKkPPofji7_m^^1coKkHM0om`]Ad04om^^1koKkHMog2d7?m`
]AcoLKDPog:h9?me^R[oM[/]og>k:?ma^B7oJk`Pofbi8oma]2?oKKTYofjj9Om`^R7oL;XRofnj8_m`
^R400_m`^R808_ma^BCoL;TRofnj8Om_^B;oL[LOoi6g;oo/Vd;omidlomZf;_nV`1ooO;dOofni9om_
^2WoL[PXog:i8_mf^AooNKHIogbc4on2[0goSZTBojfU9_n`YbooXjHWojBU9?ndZbWobK@[on:d<?oe
[c3omH8WooET8_o_O3Sojia9onR?<OoTL@CoonA_04ooi6l0001RonA_0003on^C@?oooooooooo00;o
oooo00?ol[N0onA_0?oTK`000_oTK`001OolkMooooooooooooooooooll2?00Coi6l000?ojHX`oooo
ooooool00_ooool01oo[Td3oi6l0onA_0?oTK`3oih4Poo?0SoolkMl01Oooool00oolkMool[N0onIh
4005onA_0003ooSK_ooooooooooo00;ooooo2?oTK`000oo[Td3oooooooooo`09ooooo`03on^C@?oT
K`3on=^o00Sooooo00?ooOK_ooSK_oo^YF002OoTK`000oogdZooooooooooo`03ooooo`03onjUH?oT
K`3oi6l000Ooi6l000?oji=0ooooooooool00oooool00ooVN13oi6l0onA_0003onA_0003oogfkooo
oooooooo00;ooooo00?ol[N0onA_0?oTK`00HOoTK`00=OoRKP7ofF/9om5W4?o6HaWo`60Pol5Q9Oo3
HB[oaF4`olYR>Oo>Hd;odV=7omATB?oDHd[oe6A;omASBOoBHdOodV=5om5SAOo>HTKocf=7om5RAooA
HdOodFA6om1SAOo?HTKod6=5oliRB?o3Gd_o_Ue<ol=NCOo7GT_obEm9olaOBoo>GdWocf17om1PB_o@
HDWocf57olmQAOo@HDKod618omAPC_o9Gc_o`f0Nol=P7?noGR;o_ehQolUR5ooIJA3oifPXonmW=?o^
ISCokfHe00;okfHc00OokVPconiW<_o_Hc;okfDgonmZ>_o^IcCokVHb00[okVLc017okVLeoniW=?o^
IB_okVLSoniW8OoaHR_omfA1ooM/C?ogKD_omVU2oo9U<?oaJcColfm2ooI`IoohL8[on6j5ooQYP`03
ooQXQ@2[ooQYQoohJhkon6IfooYHB_oiIF?on75eooQ^JoohKVcon6i[ooQ]JOohK6Won6a]ooQ]L?oh
KG?on6ihooQ^OOohL8?on725ooQ_QOohKH3omfn0ooMeS?ogNYOomgFAooQUKoodDD?ol4Xmoo9CG?of
Fg?omeegooMKL?ogFG3omeYaooILLOoeGG?omU=FooQ55?oiA13on4`?ooAH2ooNEc3oeFY5on9O>Ooj
;AoooSTOooQJ8?oeE2?ohU@WomEN:?oFG2_of5T_omQF;_oGG2_oe6/]omER:_oFIB[ohEE]onM2/?oZ
Bk7ojTZconI8]_oRBZWogDVOomQ5XooF@ZGoecjSomTlX_oJ?:CofCbVomLjZ?oI?:CofSbUom/bZooE
;jCoebnYomhk__o?A<;odd2gomY1]_oL>KKog3JbomHnY?oDAi[ofDbTonA>]OoTBKWohTRion]:^?o`
B;[olTVhooQ:]ooiB;SonDZhooQ9/oohAkOomTK1ooA7a_oh?/3onC^iooU6^OobDjGol5^@oo=JU_ob
GI;olen>ooAMToo_HI7oefF0ol5ULondI6ko/FYPoj=SIOnGE7WoZ4J1oiaCTOn4MikoTf6>oheFT_nI
I8WoU5fBoiE<Z?n]G9[o[6V9ojAXR_nCHYCoT6bBojUhQonjMXGoZ8Mjoi2JJon@UVcoTY=Yoi6DJon<
WGWoRY63ok1]Soo6JXko`W>2olE^Qoo8JH_oa6b8olM]R?o6KHKo`g22olA`POo3KhSo^g29okI`R_nf
LX[o]GJ8ok=fQon`MXGo/GR5ok=iQOnbNhGo/WN9ok=cSOnfLIKo^W2Jok]bVOnkMIOo^WNEokQfU_nj
M9Ko^g>GokabTon_MhKoWh9noif4PonNP8OoWh2300;oWh:300[oWh:4oiioPonNOX;oX8F2oj26P_nP
PH?oWgb2oiR0O_nZNHOoiVVX0_ogK[804_ofKK;om6beooIdY_ocOFSolWmSoo:0J?obOVSolWiWonZ2
I?oDSeWo/im9ojBT@_nUY4?oZ:=4ojZRAOnYXdGoZJ=4ojVTA@;oZZ9403CoYZA4oj>V@onUY4;oZ:93
ojZQ@onYXT;oYjA3ojJUA_nVY4[oZJ=;ojZSBonZY4_oZZE;ojRWC?nXZ4_oZ:Y;ojJ]BonVZDOoY:91
oifT?_n/WTCodXmFonj7J?oaQ6Woe8M8ojVM;on@YB;oLZhCofVh4_m/]Q_oL;HNog2e7_ma]23oL;DP
og2f7Om`]AgoLK@Pog2e7_m^]acoL;DNog2d7oma]1goL;<Log2e7?ma]b7oL;XUog6k9_m`^b?oJk/P
of^h8_m_^2GoLKXS0_m`^R809_ma^R;oLKTQog6j8Omb^R7oLKTRog>i8Omd^R3oLk/SogBj8_mb_27o
Wl4eojg1=on0_b;oL[PRogBh8_mj^B7oO[PKoh2g6?n1]QKoQK8CohR]3on;Y`goSZD<oiVU5on_Yb[o
[j``ojNZ:OnVYBCoXZ<Poj:S8On]YbKo^;8Vol^/;?o[TC_okHi1onRKBOoYUCooiGD:oooTK`1?onA_
0000POoTK`001OoVN13oji=0on^C@?o[Td3oiWP@0;_oi6l000oohFh3omAX3_o9I1Wo`V4Sol5P;Oo5
HCCobV8molmSA?oAHdKodV=7omATB_oCHd[odV=7om5SA_oAHTL00_o@HdH0;oo?HTOod6=6om1RA_o>
HTOocF59olmRBOo>HTSocF=6olaRA_o7H4[o_Ua@okQIE?o0FdoobEi:oleOBOo>H4Socf19om1QA_o@
HDOodF19om1PBOo@HDGocf57om1PAoo?H4Oocf15om=PBOo>H4Co_5dWokaM7oo4H1godFH@on5]0ooT
K`3oj6`GonmW=_o_ISWokVHdoniU<_o_IS?okVLconiX<_o^IS7okf<bonmW>?o_J3OokVHc00[okVLc
02GokVHboniV<oo^ISCol6@aoo1V;?o`IRgomF0eooQVB?ohJdgomfY9ooAV>_oaJ2golFXeooIXJ?oh
JHkon6R8ooQWQOohJ8Kon6R5ooQXQoohJhkon6Z5ooYHC?ojFTKon6m_ooQ`L?ohKF[on6i[ooQ^K?oh
KFgon6i[ooQ^J_ohJfgon6a]ooQ]K?ohK73on6af00;on6io07oon6alooQ]O?ohKGcomg20ooMiT_og
N9komfVDooQFNOoh@5;omSU9ooI=IoogFW[on5]eooQHK_ogFG3omemiooQEIooh@AOomUH3ooEU3?ob
N1SogWXdolm]A_o[DRWooRhFooh`9_ogA2_ohU4iomUH@ooKE3gogE4nom]FA_oLDd3ofU<`omMM=ooJ
FSOog5a?omY;VooL@;OohdNhon14]_oTAkSoiDZboma<Y?oCBj3odTZTomA:X_oEBZ;oeTVTomI7YOoD
A:Ooe4:Wom@j[_oB<:kodS:SomLbXOoV>;?of4G1ol`n_?oH?;Wog4JfomUFX?oOFICoj4bQonm7]Oof
AkgomT>jooI1`?oi@/3onDBjooU:^OoiB[OonDRhooQ<]_ohBKCon4JeooQ6_OoeB<?omd73ooPi^ooi
@kGom5BQoo5HU?oaF9Wol5ZFooAOT?oaHI3ohFR2om9VOOnoIGCo/VURoj]UH_nLF7?oUEEjoiUFL_nB
HXCoS8jNoiQaRonFE97oWF6>oi9OU_n;CjSoYUjKoj]YS_n]KhGoW6V;oi1NUonLHYGoW6b6ohN:Non7
WGSoSYQgohnGMOnCTgGoU9AdohbNLonCS8?o]FJEolEUU?o7K8Woafj6ol9`Poo1Lgoo`GEmol1dOonk
LhGo]G6800;o]W2;00go/WB8ok1iQOn_O87o[gaook1lPOn_OH3o[gmook60PonaOH;o[gZ2okAeR_nb
M8oo]gBE00;o^WFG01ko_W>IokYfTon]N8CoYWYloj9mNOnPPGkoX8>5oin2Q_nOPHGoWh:5oj21QOnN
P8GoWX66oin5Q?nQRHCoX8:2oib4P?nSQhGof6jRooM^/OodL;3omFj`ooE]/_odJ[GomVbdooEiP?oc
NfSolga^oo=mKOocOF`2oo=mKP06onZ0I?o>SUKo/Ie9ojBTA?nUY4?oZ:950onZXDD03onZXDKoZZ57
ojNTAOnTYTCoYZE3ojVRAOnZXDGoZZ54ojVQAOnWXTGoYZ=7ojRRBOnYXD_oZj1<ojZQC002ojZPC01<
ojVSBonYXdWoZia4ojZJ@OnRWd3oYIm2olBCD?oXPf3oj8=Eom6KA?o3Y43oZj`boh>a7?m/]0ooKK<@
ofZd5Om`/a_oL;@Nog2f7om`]QkoKkPOog2g7_m]^AooKKPQog2f7om_^AkoKkPPofnh7_m^^1goK[PN
ofji8?m^^bCoK[/UofBo8omX_R7oKk`Qog2l9?m`_2;oL[`Qog>m8ome_2;oM[`RogFm8omi_2;oN;dQ
ogRl8Omj_27oN[XOogVh7?mk]QWoNkDIogne5on4]1GoQ;@CohBc4_n6[a7oRJ/?ohbW3_n<Y`ooRjL>
ohbW3_nLYQ_o[jP/ojb]<?nVZROoYJHRojJV8_nVYB;oY:8Poj:R8?nTY2?o^jD_onFE?oo^TTOojY]7
onIn6_ooi6l0CooTK`000?ooi6l0?ooTK`002_oSKP7off/:olYT6oo4HBgoaF4iolYR@?o@HdCodF=5
om9SAooDI4T2om9SB00Wom5SB?o@HdOod6=6om1SA_o?HTKocf=7olmRA_o?HTOocV=7oliRA_o?HTKo
cf97oliQB?o>HTSocV57olQPBOo0G4ko_UUAol=JC_o:GD[ocf16om9QA_oAHDSod657om5QB?o@H4[o
d65;om1QB?o@HDCod617om1PB?o@H4Ood655olmQAOo=GdWocUe>olAM;oo@I@oogF`600?oi6l000Oo
iVl<oniW<_o`ICWokVLconiV<oo_IS?okVLc00;okVLb00GokfDaonmU=Oo_JCWokVLdoniV<P06oniW
<`0VoniV<_o^Ic;okVHbonmV=Oo`ISSolFI0oo9T@oobHS_olFH`oo5W;ooeHc[on6Q:ooQ[COofID;o
lV0aoo5R>_ofHFWomf=kooMWOOohJ8Con6R5ooQXR?ohJXoon6b@ooUPHOojFCConFMJooQcMoohKfko
n6i/ooQ_KoohKVkon6i]ooQ^K_ohKVoon6a]ooQ/K_ohK702ooQ[LP2_ooQ[LOohJfkon6]`ooQ^N?oh
KWoon6Z3ooQUQ?ogI8[omfFKooMTYoogI9Kome9[ooPj@Oog?4GomU1SooMKJ_ogF6?onDUFoo/d>?od
@Q[okG@IooMo4ooeNQ7ok7HNonME:_oi@1oooSdGoo`/;Oo_@DSofUM7om]GB_oMDdWogE14omaFCOoN
E4WofU<fomUG?_oOFdSoiDj9ol/mW_o>>/3of3k5omM0_ooI@L3ofT71omM5/?oCB:7oddZRomE<X_oE
Bj7oeDfSomA<YOo@BZOocDJ]ol/k]?o=?:_odd6Tom<nX_oI?J[oh4>momlna_o`=lGolTBhonaDV_o_
CH_omCb?ooPhY?oi>k;on3fbooU0__of@/?omdG0ooU:^_ohC;KonDZgooQ;]ooiB[Oon4NeooQ8^?oh
B[oomTO3ooPk`?oi@;Kole>Poo9HUOobEYcolEBOoo9LU_oUIh7ofVafom=TO_nhIf[oZfQOoieJLonH
EWSoW5Yeoi]FL_nGIGgoUj^MoifXU?nKM8coWFj8oiURTonACjOoYf6Joj]XU?n`LHGoYW>4oj1PU?nT
GiWoX6f=oiiiPonEPH3oSH]oohRJOOn:Ug_oSY=johnJM_n<Wg3oW8EjokeVToo4J9Co`G26okefNOnh
NGCo^7Eook9`Pon_M83o/GN2ok=cQ_naMX;o[7YoojelP?n]OGko[7anojejO_n`Ngoo/GZ1ok=iQ_nb
NhKo/7^1ok=fP?niLhKo^G6=okU`TOnmKISo^6nAojYgP?nQOW[oX7enoj=iO?nTNWWoXh5ioj>7O_nQ
Q8;oWh:3oin4PonNQ8GoX8R6oj:;Q_nSRhCoX8V2oj68Poo<NiSomW:`ooAb[oocL;7olg2_ooE`[ood
Kjkom6jdooEgTOobOF?olWaWoo=lJ@03oo=mJP0:oo=oKOocO6_ojX1Tolb>E_ncVdWoYJ=5ojBSAOnY
XDKoZj17ojZQAP;oZZ1600CoZJ96ojJT@onUY4;oYj=40_nYXTD09OnZXDGoZ:95ojNTAOnUYDOoYZI:
ojRTBonZXdcoZZ9:ojZSBonZXT_oZia6ojjF@_n]Ud;oYY]0oibR??nXX3kochi?onF0EOoPRe7ofI]=
olRPA?nZZ3;oQk8Mog>f4om[]17oJkDAofbg5Om^^AKoLKHEogBc5Omc]QOoKkTKog6h6om`^1coL;TO
ofjk8?m^^b400_m`^2<08om_^BGoL;TVofZl8_mW_R7oK;XQofni8?mb^AooL[POogBg7_mf]Q_oMKDJ
ogJd6?mg/aKoNK8EogZa5?mj/A;oOJhAogf^4?mm[PooO[0?ogn^3on0Za7oQJHBohVP4_n<WA7oSi/A
ohjL4On=WQ7oSId@ohfP4_nMYb7o[JX^ojV_<OnTZROoY:HQ00?oYJHR00SoYZDRoj>U8OnQYB3o`J<a
onbDAOo]UdWoihPXonA_0Oooi6l0C_oTK`000?ooi6l0?OoTK`003ooMK0Woe6PGolUS:Oo:HD?odF9C
om=SCooCI4Wodf=7om5SAooAHTKod6=6om1SAOo@HTKod698om5RA`02olmRAPCod69600oocf98olmR
Aoo?HTKocf96olmRAoo>HDSobF1:olAMC?o3Fdkoae]>oliNBOoBH4Kod617oliPB?o@HDL00_oAHDL2
om5QB@0;om1PAoo?H4Kod657om1PAooAHDKod656olePA_o;G4[ocea=on5WB_oRKb<01OoTK`000ooT
K`;ojf/Uoo1U>P02oniV=009oniV<_o_Ic?okVLboniW<_o^Ic?okf@bonmW=oo_J3SokVHc00?okVLc
00OokVLdoniV<oo^Ic7okVLconmW=oo`IS_olFDn00;olVE10;golFI1oo5U@_obHSOolFH^oo5W;ooe
I3Won6Y<ooMVBOocGSColf95ooISM_ogHWGomVA`ooMWNoohJHOon6V=ooMYS_ohJ7?onV<kooYP?_oh
KV[on79`ooM]I_ogJfOomf]YooM/JOohKFWomfaYooM/J?ogJfComfYRooMXHoogJfWomf]/ooMYI?og
J63omfQNooMWHoogHVWomei/ooIOLOogGGComeefooMSOOofJHKomFV>ooESPoofD5komchnooTl>Ooj
=c?onCDYoo=5:?oYG2koi6h[onah6Oo_La?okfLEoo]=5oom?23omD0`ondn@Ood?4cohdi3omUF@OoM
DdGogE92omeDB_oLE4CofELgomUG=_oWF6[oe4NAolDlTOo?>[Oof3k5omI0`OoE?/?odck1om95[OoC
BJ3oe4ZRomE:Y?oEBZ7oddVTole3ZOo;@Z[oc4>^olhn/Oo>@:_ocD:Wole4Xoo=A:;oi4FhooM3c_of
?l_omSnjoo4nZOob=9OomBZAooPaW?oi=j7on3NOooTkXooi?;;onD2hooU7/?oiB[?on4VdooQ;^Ooi
CK_onDZmooQ8^oohBkcon4_0ooTma_oi>[_olE6Koo5ITOodEYgolE:Son=LT?oIJGOoff]gom9QOOna
HfSoWUm[oiQDN_nJF7OoVeUfoiYDMonSHg7oVjNDoif^W_nJTIOoWiJ<oiY^T_nECjGoYFRFoj1aTonO
NH[oY7^2oim^S_nQIiGoZFjAok1cRon]MHKoYWN2oiYoPOnBPG_oSGajohZ8O?n9U7GoRiM`oj5lNonm
GY3o^5RDokQHS_nnEh[o_EZ:okUMR?niGHWo_Uf=okmKT?nkH8_o^V:8okQPR_nhHhSo]V:7okIQR?nh
HXSo^F>7okYRROnkHXgo_6>?okaQS_o2FXkoaUVCol9HT?ngF8;oYemboj5RM?nVIWWoYfQlojUWP?nZ
IX3oZ6MjojIYNOnRK7/00_nPKWh0LOnPMH3oXGinoin4OonNQgooX8R0olUjUoogMJoomgJ`ooEd/Ood
M;3olW:`ooAa[oodLJkolfjcoo=`YOocOf_olWmRoo9oIOobOfColWiUoo9nI_ocOfOolWmWoo:0J_ob
O6[ojH1Tolf>E?n_WDWoXZE3ojBTAOnYXTKoZZ95ojZSAOnZXTKoZ:=5ojFV@onTYd3oYjI2ojRV@_nY
Y4?oZZA5ojVTA?nXYT?oYZQ2ojBYAOnVZ4SoYjM8ojRUB?nXYdWoZZ57ojfH?on[VSgoXj4koiRY<on<
[bkoUZlgol:KCOoXOUOokGMGon61D_oLSTgodY]7oj^[=On2/acoL[DEofbf4om/]QKoK;HHog:d5Omj
[Q;oNjdCogZ]5?mj[QCoNZlEogZ_5_mj[aOoNZlFogV`6?mi/1[oNJlIogN_5?mg/1;oMk4HogVZ4_mk
ZA7oO:/@ogf[4OmnZQ;oOjTAognX4OmoZA3oOJ/Aogf[4_mk[A7oNjd@og^/4OmnZA7oPj<BohRL4on;
UaCoSYDCohjD5?n=U1GoS9@DohbE5?n=U1CoT98BohRL5_nB/2[o[Z/_ojZ];OnSZRKoXjHQ00CoYJHR
00OoYZHRoj:V8OnSYR;ocj4ionnDBooYSCGoiG@80?ooi6l0C_oTK`000?ooi6l0>ooTK`003?oSKP?o
gVXTolYQ@Oo?HU3oef9IomEREOoBHd[odF=7om1SA_o@HdCocf96olmRA@;od69600God6=5om5SAooA
HdOodF95om1RA@02om1RAP0Aom1RAoo?HTOocf97oliQB?o>HDKoc657ol]OB_o6GDgo`e]=olMLC?o>
GdWod617om5PAOo@H4Oocf18oliPB_o?H4T00_oAHDP03_oAHDOod657om1QAoo@HDSocf17om5QA?o=
H4Kob5e:olmLBooMIDCoiVlfonUf<_oWMAkoi7041OoTK`001?oXKAGokfDhonmV=oo^Ic<2onmV<`08
oniW<oo^Ic;okVLboniV<_o_ICCokfPionmW=_o^IS<2oniW<`0^oniW<Oo^Ic?okfHgoo1U??oaISoo
lFI0oo5U@?oaIT;olFI0oo5V@_obIdKolVI8oo9S?oobIcOolVXjooMYCooiJeOomVI;ooIVIoohJ8[o
n6R3ooMYOoogJX3on6f:ooQ/S_ogIG3on6DoooYY:_ogITkomVaRooI/GOofJ5[omVQLooIXF_ofJ5Wo
mVUKooIXF?ofJ5OomVQIooIWEoofIeGomVQJooIXFoofJ5SomVMJooITG`;omV1Q03?omUmPooIPHoof
GfOomUm[ooINK_ofHWGomVR2ooI[SOogIH3onTIAooXZ7ood<A?ojU4VonIU<OoXHS3ojEdgonIM>?oW
H2Comel:ooiD2_oc@R[oid]:on=?DOo`>d?olT56omYF@OoJDSkogE11omeDBOoMD3cofEDaomaN@OoS
CXgoc3nBolHoSOo?>k3oeCc5om@la?oE?<Coe4:bom98XOoBBJ7oddZQomE;Xoo@AZ?obCnXolPmZoo<
@jKocdB]om0m[_o??ZP00_o=@:D0KOo;@Z;ofTF^oo98bOo`@lgojc^nonlc]Ooe;:;omRbGooP_Y_oi
=JOon3RPooPfWooi<JWonCB/ooPoW_oi@J;onD6TooQ2YooiAk3onDJhooQ7^OohB;conD[1ooU9`_og
@kSolE2Joo9HUOoeEikojENGomAPPooEIg[offAjoliMNOnXG73oV5]doi]HMonMFgGoVEMioj1JLonW
H6[oUI^@oj2/WOnLMi[oVY^Eoi9fVon?Dj7oZFj@oj9bT?nHQ8coWX:9oiYbT?nKKIGoXW>?ojIjRon/
NXWo[gN:ok5bR_n]LXGo[Fn7oj=[Q_nCNgkoSHiiohJ1L_nYGGoo`DfFokU8V_njB9Oo_dnAol5DS_no
EHgo`EF?ol=CTonmEhko_UN>okmGSonnFXgo_E^:okeIR_nmFHco_5Z<okeIRonoF8_o`ERBolAHUOo6
CI3oaTR>okY=PonYE6coXeYUojEHJonUEfooZ5Mcoj]FN?n]F7oo[E^2ojeLQOn[GX?oZen0ojeNPOn/
H83oZV=moj9UNOnOIgWoXVQjol9UT?oLIJ3oiFVYooA]/_ogL[400_ogMk001oofM[;om7:booA^]Ooe
NH?olWmRoo=oIoocOfP00_obP6P05OocP6SolgmVoo=oIoobPFSolX5[oo9nJ_oVPf;obi5CojbRA_nP
Z47oY:I4ojVTAOnZY4GoZZ=5ojVTA_nVYd?oY:M1ojNV@OnXYD;oZJE3ojZTA002ojZT@`0OojRU@onU
YTGoYZM6ojNVBOnZYDcoZj19ojRK?onNY3SoV:`doibV=OnPXcWoVj@hoiBX=On[Xd;ogXaIoo9hGOo_
NE[ohgiAom2AB?niYT7oYJTeoh^_:?m`]Q_oK;PHoffe6oma/Q[oNZdEogf[4_ml[1?oOZXBognY4P02
ogjZ4@0IogjZ4_n1Ya;oOZXCogZZ3omlZ0_oO:hEogb/5?mnY0goOJH=og^X3omlZQ3oO:`@og^]4_ml
[A;oNZhAogZ_4OmnZa;oPJDBohFO4_n;VACoSYDCohnD4on>U1CoSYDDohfE4`03ohbF5009oh^F5?n@
Ta;oPYlGohJj<on/[cCoZZ/Zoj>X8onUYB7oYJHR00?oY:HR00OoYJHSojJV8onPYQooYZHSomJR@?o^
TDCoiWTC0?ooi6l0C_oTK`000?ooi6l0>_oTK`002ooSKP7od6HRomMUF_oEI5oodf=Aom9SBOo@HdCo
d6=3om1RAOo@HTOod69600;od6=500OodF=5om1RAOo@HTOodF97om1RAoo@HTKocf9700;ocf96027o
cf57om1RA_o?HTOoc618olUOB?o7GDcoaUa>olYLBoo>GdSod616olmPB?o@H4OodF56om1PAoo?Gd[o
d658om5QBOo@H4_od657om5QAOo@H4Sod617om9QA_o@HDKobUi8olUJBooHHD[oiFdkonUe;?oXMbWo
jGP_onQf:?oUL@X01OoTK`00<?oUKPOokFL^oo1V>_o^IcCokfHconiV<_o^Ic?okVLaoniW<?o^Ic7o
kVD`oniU<Oo^Ic?okVLaoniV<Oo_ISCol6Hhoo5V@?obITGolVM7oo9WBOobJ4_olVU=oo=ZDOocJE?o
lf]Foo=/F?odK5_om6]OooAZDoocKDkom6eBooM[F?oiJe[on6MhooQZS?ohJhKon6^5ooQ^ROohKHgo
n6UnooQWE?ojJB[on64fooIXF?ofKEgomVUJooIXF@;omVQG0_ofJ5H0ToofJ5OomVMIooIVF?ofJ5Oo
mVQJooIWEoofIU?omVMIooISH?ofH6?omV1RooIQI?ofH6;omV1QooIOGOofGf7omV=XooITKOohGFKo
nU1OooY9G_ojCEoomEIIonYJ@OoSF2Coi5LPonYE=_o/GU7okEaDoo9<:?okE03omU88on]6:?oWC4?o
ie5DonE<E?od>dOoi4i6omQE?ooMDD3ogEA;oma??OoGF2_oiUM[omE4VOo4?9?obD6=oldkZ_oB=lKo
e3[6omM0^?oEB:CodTZOomA:XOoCBJ3ocdJWolU0ZOo7?JOocD>Vom59XooA@[3od3f]om11YOoA@jOo
ddFSolm7X?o@AZCoiD>oone0cOoY=L7ol2fdooL/Xoog;Y[on3FSooThZ?oh>:Oon3NUooT]Z?oi::[o
nCbMooPoWOoi?Ygon3jMooPoX?oi?jSon3jYooTn[Ooh@k?omeJZooIIX?ocCicolUFKonUMTOoIGHGo
dF5oomMUO_oKGg[obEQgojAIM?nLG7;oW5Ufoi]HMonMF7SoXei`ojIMJ?nCU8coV/BTojU]WOnNQI[o
R82QohiIW_nXKXko[FZFoij3T_nMUH_oVgj?oiA^U_nGL9CoVgR>oj5mR?nSQ8KoYhN9ojYnROngM8ko
_VfDok1fR_nVMX3oTG5hohi^MonjGH_ob5FDokQBU_ndD9Oo^U:DokeFT?o3E93o`5J@okQJRonkFXco
_eZ>okiKRonnGH_o_Uf:okaKRonkFhco_5^<okmJSP02okmKS`0@ol=AT?niD8?oZEU_ojAIJOnUFFco
YUY[ojAHJonTFVSoYEUYojEIK?nXFg7oZeajoj]MO_nWGgooZV24ojeRPP;o[6:101CoYfAnoj=TO?nV
HggoZF:3ok1SQonnHhoocfRKon1]YOo_Kk3omg6eooMe]?ohMKWomgfRoo>3JOocPVOolh9[oo>1J?oc
PFWolh9Yoo>1J@;olh9Z037olh9Yoo>2K?ocPFgolh5]onJ6IOo6UeGoZJM9oj2X@onTYdCoZ:E6ojZT
AonXY4KoYJM5oj>Y@onUZ4;oYjM1ojRU@_nXY4?oZJA3ojVT@_nXYD?oYjI3ojNVAonUYdSoWZPooiZX
=onJYcKoWJ@hoinS>OnPXcWoX:@joijS>?nHYcGoYjDnolnBD?o]OE[okgAConIeA_oHSd[oajE:oknS
A?nbYScoT:d[og:c7_mZ^1[oKKHHogR_5OmmZaCoOJ/B00;oO:`D01GoOJ/Dogb/5?mnZQCoNj`EogZ/
4?mlZ0[oO:/?ogba6omm[1GoNjH>ogbV3_mjZPkoNZd=ogZ/3ommZQ;oPZDCohNO5?n;VA?oSYHCohjE
4on?U1<00_n>UA<6ohfE4`0CohfF4onATa7oQ9hGoh2o=onV]CSoZZ/[oj:Z9OnUYR?oYJLSojJV8onU
YR?oY:LRojFV8_nTYR?oY:LSoinU7_nXZBOog:55onUo8P3oonA_04koi6l0003oonA_03[oi6l000So
dVPLolYRCOoBI5Ood6A9om1SAOo@HTKod6=7om5SA@;od6=500?odF=6om1RA_o?HdH00_o@HTH00oo@
HTOocf96olmRAP02om1RAP0SolmQA_o?HTGocV57oliQB?o:Gd[oaee:olQLBoo;GDcocem9om5PA_oA
H4GodF17oliOAoo@H4KodV56om1QB?o?H4Wod659om5PB_o?H4Oocf57om5QAooAHDGod655ol]NB?o8
Fd_oe5m:on=Z?ooYLc7ojGLZonUg:ooYMbcojGL`onUf;ooVLPl01OoTK`002OoTK`7ojVPKonmT=_o_
IS?okVDaoniU;oo^IbookVL`oniW<P02oniW<`0VonmW=oo_JCgol6U2oo9XB?ocJU3olfUCoo=ZE?od
JeKom6]IooA/FOodK5[om6eKooA]GoodKEgom6iLooA]G?odKUcom6eKooAXD_odJ4oolfYBoo=ZC_oh
JUKonVIaooQYQ_ogJhGon6^7ooQ^T?ohJh?on6UOooY]>ookHC;on6ADooI[GOofJecomVQKooIXEoof
J5P2ooIXE`09ooIXF?ofJ5WomVQGooIXEOofJ5WomfQJooIYE?ofIeGomV=L00;omUmN04OomV1OooIO
H_ofH6?omUmPooIPH_ofIV_omfEYooUIF?ojBTOonTI2ooU;@?ogDdComEQ;oo=MDOoaGe[ol5EHona<
BOoXF4OolE4moo/l:_od?b7ojTh>one84ooZASKojd]4onMBDooZAU?ol49<omaB?ooIDd3ogE=:omUA
=OoOG43ofTf6olToToo8?Y;obd6<olhmX?oB=/Goe3bnomY7YooGBj3oe4ZQom98XOo;@JGobcnYole2
Yoo>@j;od4NTom5:Y_oB@jkodT6_om54Z?oBAjKoddVRom98X_o<@iooeCjbonHmb_o]</[olBZaonlY
R_ob:X?ombjHooTcY?oh=Z?on3RRooT/Y_oi9JkonCbRooU2W@02ooTnW`0mooTnX_oi?JGonC^TooTh
XOoh?:GomeBNooINU_oeDYSolEFFom]PPooAHWooden3omIOO?oJHG7oc5QgojMIL_nKFg?oVEIioieJ
M_nTGW;oZV9[oj]MIonJTH?oQ<bOok5cWonfKYgoPgRUohaRX?nRKXko[6bBoie_V?nIThcoXYB5oiIl
TOn?Li_oTWNGoiYhRonQP8SoXHR:oj:4R?nVOhGoY7j5ojYmR?neLh[o]768oj5eOonZJXOo`EbDol5H
TOnjEY;o/eBEok=FU?nnEICo`UV?ok]LRonhFHko^EN=okYJRonkGH[o^ef;okYLR`02ok]KR`0WokiK
S_nhG8coZUiiojeHMon/FgOoZEebojUKLOnXF7?oZ5U_ojIJK_nWFFgoYEY/ojAJJonVFfWoZ5Y]ojYH
L_nVFg?oYeehojQPNonZHggo[VF0oj]YOOnUK7WoZ6]kojQYOOnYJ7coYfMiojMWN_n`Ih3o^VF7olIW
T?oEJi[oiFnXoo9d/?ocOgSolX9Too>2JoocPFWolX5W00;olX1W027olX1Voo:1IoobP6Oolh1Xoo>1
IoocPF[olh9[oo>0JOoTQF3oaYUFojVWBOnN[4CoXjU4ojRVB?nYYT[oYZU8oj>ZA_nTZDCoYjI4ojJX
A?nWYd?oZ:I3ojNWA?nYYTGoZ:M4oinZ>OnHZS7oVZPboifV=onOXcSoWj@ioinT>?nNY3T00_nOY3L0
4_nIYSKoVZLiokfNBOoUPDkokfi9onQeB?oHTDcoaZA;olJTAoo0X4CoZjHioh^_:Oma]AkoL[<Gogb[
4_mmZa?oOJ/Dogb/50?oOJ/D013oNj`DogZ[3ommZ0_oO:T:ogZ_5?mm/QooO:`CogZX3?mkY`koPih?
ohNG4?n:U13oRiDAoh^G4_n=UQ?oSYDD2on=UA<01_nCTQ7oQYhGogc5>onM_CkoZZTYojBW9@;oYJLV
00?oYJLUojBX9_nTZ2D00onTYb@01OnTYb;oWjHOoj^^;OoQT37oi7450?ooi6l0COoTK`000?ooi6l0
>OoTK`003ooJJQ?odfE7om9SE?o@I4God6A3om1SA_oAHdGod6=7om5SAoo@HdKod695olmRAOo@HTOo
d696olmRA@03om1RAP0Com1RAoo@HTKocV56oliQA_o<H4Oobf18olQNBoo9GD_obei:olmOBOoBH4So
dF17om1PAOo@H4Sod617om1PA_o@H4Ood618om5QB@02om1PBP0Aom5QAoo@H4OodF17om5QA_o=H4Ko
bE];om1MC?oPJ4;oj78donUf;OoYMb_ojGL^onUg;OoYMRcojGL^onUf;?oVLQ001?oTK`004_oTK`7o
i6l0onQ^5oo`IS[ol6Lmoo1X?_o`Id7ol6U3oo1ZAOo`K4OolFe:oo5]BoobJe3olfeGooA^G?odKEco
m6iLooA]G0;om6eK00?om6eLooA]FoodKUX00_odKU/08oodKE[om6iJooA]F_odKUcom6UBooAWBood
J57om6QDoo=XCOoeJUkonfM`ooUWNoohK8Oon6f@ooQ[PoogJfGonFY8oo]V;_ojHdWon75aooM`Joof
JU[omVYHooI[FoofJU[omVYGooIYFOofIe_omVQLooIXF?ofJ5comVQOooIZFoofJEkomVAS00;omV9R
09?omV9OooIPGoofGUgomUeLooIPHOofGV3omeQIooY9C?ojA4OonDY4ooMC@OofFCcomUPhooIH@?og
FUSon61eooMSP_ocHGOolE1>ooPa7Oof>COol4I8on]5:?o/C0Sok48UonU6?OoYCCkoie5?oo12D?oU
Bd;ofUI3omaB@_oGFRkoheQ^om93V_o6?ICoc3nAol]1Roo<?Y[od3ViomQ2[_oKBZ7oe4ZRole3YOo9
?ZWobcnVom14Xoo?A:Kocd>Uom59YOoCBjKoddJYomA5[OoDAjSoddRTom56YOo@A:?ocD>Ooli0Z?oV
><ColBo;ondY/?o[:WgokRYfoo<ZQ_of:Y7ombfFooL^Uoog:I?omR6SooPdX?oh@9[onCnNooTnX?oi
?JGonCnXooToZOoi>ZConCZUooU7YOofEIOom5J<ooACT_oZFY7oe624om1KP_oCFWSoeV5]oleKMOnV
FWCoUUIhoiUENOnRGG7oZV=/ojYTJon^GFKoZ8AiogO5TonQO:3obVZPoiEYY_n1HZ?oWg2;ojI`SOnP
J9CoUWRAoj2>R?nQR8_oUGNEoiAfU?nFNY3oW7^;oi]kR_nMQ8_oXh>7oj5nQ?nVMXKo[728ojicR?n`
M8Oo[GB7oji`R?ngI8co_UV>okUHSOndE9;o]U:GokQIT_nhH8_o^5j:okULSOnjFh[o^U^6ok]KR?nl
FX_o^eV8ok]LRoo4Fi7o^5R7ojALKOnSGFOoZEe^ojaNM_n[GWCoZE]aojQJKonWFfh00_nWFfl08OnV
FfooYee/ojINJ_nUG6goYEe/ojAKJonUFVcoYEa/ojINKonTH73oXF=`oj=XL_nYJ7So[FUmojiYO_n_
Igco[FUjojYYN?nWJ7OoYfQfok1VO_nnHIGodG9fomUlCOoTO5OokW]Poo61I_obQF[olX=Xoo:2Ioob
PFGolX1Too9oI003oo9oI@15oo:0I_obPFSolH1VonB7H?o7UU?oZZA4oinY@OnSYT?oZZ=6ojVTAonU
YdGoYJQ4ojRWAOnWYTKoYjM6ojVVAonZXdOoYZDloj6T<OnPXc7oWj@aoifV<onLYcGoW:HgoifU=onN
Y3OoWZDgoinT>OnOYCWoW:HhoiNX<_nWY3CodXe5oo9dCOo^L4Oog8E:olNPBOnmZTKo`j95ol:PA?n]
YC_oRk0Uoh2`5?mkZQ?oOJLDogfY5?mmZQCoOJ/Dogf[5Omk[1?oNZ`=ogbZ3?mlZP_oNZX;ogj^7?n2
[B3oQYdCohZA3on<Sa7oT8h@ohn>4?n=Sa3oS94@oh^D4?n<UQ;oSILCohfF4on=UQCoSIDD00OoSIDC
00OoTY8AohNN5omnaSkoU/I5ojRZ:OnXY2;oY:LV00;oYjHV1OnWYRD01OnVYbGoYJHToib/9OnnXB[o
gGP90?ooi6l0COoTK`000?ooi6l0>?oTK`001OoLK0Wod6Dgom=SC_oAI4Kod6A400;ocf=600KocfA5
olmTA?o@HdOod6=7olmRAoo?HDH2om1RAP03om1RB?o@HTKocf9600;ocV5701cocV58olePAoo;GdSo
bEi9olYMB_o<GTWocem8om5QAOoAHDOodF58om1QAOoAH4Ood617om1PA_oCHDKodf57olmOBooAH4_o
dF1:om1PB?oAH4Soe656oleOAoo8GDWocea=omeUA?oWL3SojGH]0_oYMbT2onUf:@;oj7HX00gojGHY
onUf:ooVLQOoiG08onE`2ooUL1;oiG0GonE`6ooUL1Woig<`oo5]D?obJe7olFmD00;olViF00SolFmD
oo9^DoobKEKolf]HooAZF_odKUkom6eKooA]FP;om6eK05Wom6eIooA]F_odKE[om6iKooA^G?odKE_o
m6eJooA^FoodKE[om6iLooA]FOodI4_om6I>ooAYE?odJ57om6Q?ooIXKOoiJ7konVQgooQ[R?ohKXOo
mfe[ooQVDOokIS[oneldooQYH?ogLgKon79hooM/JOofIEKomV=CooIPDOofGToomVAFooIVEoofIE?o
mfAAooMUD_ogIe7omf9?ooMLCoogET[omeI7ooMDA_ogCckon4lmooQC>oohEC[on5/kooYF<?olD27o
o5`QooYQ9?oiFROon5HaooMD=OogDSgomeYEooMQI?ogHFGomf5WooISKOojDESonS4[oo<a9Oob?3?o
m44joo156oo`BAKokDHoonU9@OoWCCkojDU5on]6AOoNE4GoeeD^on9GA_oOBiSoaSfDolTnTOo=@97o
bd2?olM0Q_oA@Igofd:VomA3Yoo;@JWobSnXola1Y@02om15X@2goli3Yoo=A:OocdVTom=<YOoDB:Go
e4NYom=7Z_oBAJKocd:Uoli3X_o@@Z?ob3bSom/e]_oa<<[okBf[onTZOoo]:G[om2Z5oo@[R?of:i7o
mbV@ooDVP?oc7XoomRRDooLgR_og>8gon3ZAooPiWOoh?:OonD6XooTkYOoj>JOonDFVooEDToocFHSo
m5R@ooAHU_oMFhSoc5YiolmLLooFH73obeecoimFNOnIFWOoWe]dojIQKOn_IVKoZF=[ojiMIOnYKW3o
Kl2;oifAX?o<K9oo[6>TohUSW_nIL8_oXW2?ojAXU_nLKiKoVH>?oin6R?nPPhSoWgZ;oiajS_nKNX_o
W7j8oij;SOnPTHkoXH>5ojQcQOn]K8co[Fj<oja`R?n/LHOoZgB8ojUcR?n`JXWo^F2<okeGS_njDIGo
/EJDok1OSOnfHX_o^62=okQPR_ngH8Oo]en6okQMQOnlGHSo`5Z=okUIQ?n/G7;oYUiYojAOJ?nVGV[o
YEi^ojQNM?nZGW;oZ5e_ojIKKOnTFfgoYUa/ojEKK?nVG6_oYUe[ojILJonTGVWoXUeYojIJK_nXFVko
YeY/oj=KJonQFf_oWEeYoiiPJonSH73oZ65dojUSMon[I7Wo[VMlok1VO_n[JGWoYfQfojQSOon/JGWo
^896ol25@?o7PTWocgm>omenE_oZOUkolGeSoo9oI?obPVOolX=Xoo:2IoobPFGolX1Uoo:0I_obP6Go
lX5Voo:1J?oaP6GogXYLol2IC_nXYdCoWjXooj:X@OnXYTGoYZQ4ojNW@onYXd;oZJ52oj^L@OnXW3_o
Y:8eoj>T=?nRXcKoXZ@goj6T=_nOYCCoW:Lcoi^V=OnMYSWoX:@ioinT>?nNYCSoX:Hhoi^V<OnAZ2Co
VjT[olNI@ooYNTcol6e8on=lB?o<VTOo^ZY1oknV@_o;WDco`JLnojNa9?n@[a_oPJ`D00;oO:TC00ko
O:/Dog^]5?mh[a;oNZ/<oh2T3On3X0koRIL=ohZF4On;XQooSJ0NohjA4on<SPooS90@ohf@40?oSHl@
00KoSI0@oh^D4On;Ua7oS9PBohbG5?n=UQ@6ohfE4`0:oi6C4On6X1SoOlHnohk=B_nQ[bcoZJ<QojBW
9OnUYbKoY:LVojJW9P;oYjHV0onWYRD01?nXYBGoXjTVojNT8_oBOP[oonA_04goi6l0003oonA_03Oo
i6l000CohVh3olaT:OoBHdkod6=70_o?I4D01_o@HdKod6=7olmSA_o?HdKocf97om1SA`;odF9701[o
dF94om1QAOo@HT[ocV58oleQA_o>HDKocF56ol]OB_o:GT_obUi:olaNBOo@GTWodV17om5PA_oAHDKo
dF17om1PAooAHDKodF19olmPA_oAHDKodV58om9PBooAH4_od5m:om1PA`;odF5602;obEe8olYKB_oK
HdCoiVleonQe:OoXMRGojGLYonUf:ooYMRkojGH_onYf<ooZMSSojWHjon]f?_o[MdWojG@konMa:OoW
LB_oig4]onMa;_oWLS;oiW4]onQc>?oaLEColf]Coo5_DooaKU7olVeDoo9^EoocKE[om6eLooA[Fooe
JU_om6iO0oodK5T0ooodJeWom6]HooA/FOodKEWom6eJooA^G?odKE_om6eJooA]FoodKE[om6iLooAX
DOodHDWom6QBooAYDoocJ4oom6UDooMYNOohJ8_onFMnooUTNOohGU[on5i5ooYZ>?olNBOonfLZooUP
?ooiH4GonFU5ooQ[@_ofIS;omVHZooMZ;?oiJRgonF`]ooUa;?oiLRSon70VooMb9?oiKR3onF8NooUS
6oohHaWonF@IooQP6?oiGaConVDIooUZ7OokKAcoo6TFooeY5?olNQWonhXQooZ;8_ojQ23onW`OooY[
8_ojFB_onE<jooUEA?oiEdSon593ooM;?_ogD4komeEHooM6@Oog=Bgomc@]oo8h9?o`?@gokC``onLn
Foo[@EcojTU4one6A?oVCDCofeh]on9EJ_o?@HkoaCf=ol/oToo<@93ob466olQ7J_o@A8?oeC^YolPg
[Oo:?j_ocTBSom15XOoBAj;odTJRom58YOoBBjGod4^Qom1;YOo@AZKodTJVom94[?o@@ZKod4>Rom15
X_o@@:GoaC^Jol/hXOoZ=LOol36[onX/NOo/:GcolRR<oo@ZROoc:hcomRR<ooDVOOod88gom2BEooHb
Q_og<hOomc>6ooL`SOoh<IWon3NLooTgWOoj=jGomdVLooAHRoodFhooleV:oo=CQOoXCXCobUQcoliL
LooHGW7obeecoj5HM_nKFW?oXUi`ojUSJ_n`IfOo[6=ZojUOJonYI6coKL20oiBZWOo<Ij;o^5jZojER
XonEKi3oVVn@ojEXTonPJ9?oVgn>oiQnRonNPH[oXHN9oj=kRonPLXgoXGb8oj66Q_nSVX[oWYR<oj=k
Q_n[KhWoZf^>ojY^RonYLXKoZG28ojYaQonXLhCoZfn5okIRS_nnEiCo]URAojiJTOn`G9;o/5bCok=O
S_nfHhOo]f>6okIRR_nmHHko/en2ojAPJonRHV?oXf5XojANJOnTGfWoY5mZojEOK?nYGWCoZUebojML
KonUFVgoYU]/ojILKOnUG6_oYEeZojILJ_nVGFWoXF1Woj=NJ_nVG6_oYUaZojALJ_nUFfcoXE]Zoi]N
IonNG6[oXUY_ojAKKOnTG6_oYEe_ojUNLonZH7CoZ6=cojUPMon[G8?o]gIJok^5>onhPcoo^891okf2
@_o1P4Gob7a7omEjCooWNU[okWiRoo61IoobPfWolX=Xoo:2IoobP6OolX1Uoo:0IoobP6SolWmXoo21
IOoORUgo`iE=ojVQ@?nRXcgoZ9doojVK?_nZVc_o[IHiojjE>?nUWC;oWZL_oj6U<_nRY3;oXJDboj2T
=?nRXcGoXZDgoinU>0009?nNYSSoWJHjoifW>_nNYS_oWjDloibU<onHYb[oTZTVoi>[9on/XSGogH]8
oo9`B_oZMDSod995okbSA_nmXdKo_:dhokNa;?nd/2WoY;4Sohn`6On1[A?oOjPCoh6T5?n3X1?oR9P?
ohfB3_n>T@ooSi4>ohj?3On;V1GoRjDQoh^P7_n<TQ?oSHh?ohb@4@GoSHl@00KoS90@oh^C4?n<Ua7o
S9PBohbG4on=UQ<4ohfE4`0:oi:B4On6XASoO/HlohOAC?nG]c7oZZ<RojJV8onVYRCoYZHUojFV9@;o
YJLV0onWYRD01?nWYBGoYJLVoj>X9_o7R13oonA_04goi6l0003oonA_03Ooi6l001WodVLKom1SC?oA
I4_ocfA4olmSA?o?I4Gocf=5olmSAoo?HdKod6=6om5SAOo@HdGocf=4oliRB?o?HTSocf58oliRAoo>
HDWocV56olaPA_o8GTSobEe;oliNB_o>GdOod61600;odF1800GodF55om1PAoo@GdWodF15om5QB002
om1PA`0Uom9PB_oBH4_odF1<om5QBOoAH4KocV15ol]NAoo:GDOoef95onE]>ooYM37ojGL`onYh=_o[
McgojgM0on]f@oo[MT[ojgI=onafCoo/MU;ok7MDonafE_o]Me[ojWA:onMa<ooWLC3oig4_onMa;_oW
LC3oiW4XonMb;?o_LTgolV]?oo9]DoobKEOom6]KooA/G002ooA]F`06ooAZFOoeJEcomG1RooA_G?od
KE_om6eJ0_odK5T01?odK5Som6aIooA/F_odKE/2ooA/F@0;ooA/F_odKE_om6aGooASBOodHD_om6QB
ooAXE?ocIdcomFMHooQXP?oiJ8T00_oiHHH0/?ohGfoonE=Aoo]<;?okCBGonEY@ooUMGooiF5;onEa@
ooQOC?ohGdOomedhooMM;?ogHRWom6<Roo=R8?ofI2GomVD^ooAL=OofEC;omE8Voo9G9_odFBWomU<V
ooIH9_ofGB[om5`VooQL7OokGAGomVTIooJ28OoeRbComX`SooN>8_ogRbGomHPZoo>6:_ojPbGoo7HQ
ooeZ7OokGQWonULFooU@5oohDbOon5PgooQ??ooi?T3omS96oo4]A?o/;bkoi2lConLeCood>gGol45=
onm4@_o[?bKohU@domU:Poo7A77oaCn2ol/nT?o8@8KoaTAdolM9G?o7@7GobcjRolPnYOo?@jKodDJR
om97X_oCBJ7odDRSom9:XooCCJ?oddjQom9=Xoo?AJWoc42Woldo[?oA@ZSodTFQom54Xoo>?J?oaSjE
ol4nTOoJ>KKokcFZon/^N?o]:G[olbJ@ooDXSood:Xcokbb0oo0XMood8HcomB6IooL_R_og<hKomc68
ooP^R?og;Xoon36DooPfUOoi<i_om4B8oo5AM_obD7golDegoo1<K_oaBGgoeeEoolYLLOoFG7?obUi_
oj9JM?nJFgGoYV9]oj]UJ?naIVKo[6=[ojUNKOn/Hf[oNKb0og>fTOnfK:3o]eR^ol9M/OncJicoTF^@
oj1ZT?nRIY7oWGR?oib9R_nHMHooVWRAoianSonLMYCoWgF>oj=kQOnSP8CoXHj:oijBRonUPXOoZGB4
ojE_RonVLX[oYG>7ojIcQonVM8GoYGB2ojU`Q_n`JXko[fF>ojeMSon^F9;oZeJDok1ITonhH8_o_6:;
okiRSOnbHh3oXfA]oiiUIonPIFSoXFAXoj=QIonRH6SoXUmYojAOJ?nUGVcoZEiaojYML_nXG73oYEU_
ojILJonVGF[oYUa[0_nVGFX0GOnTGVSoXUiYojEMJ_nUGV[oXEiXojAMJ?nSG6[oWeeWoiiOIonQG6_o
Y5U/oj=JK?nSFf_oY5][ojEJK?nUG6coX5iXoj9GMon^HfGo^ghcokeo;_njOCCo^WheokUn=?nfO3Ko
]gdgok]j>Oo2Lckocg=7omibCOoYLUKokGYMoo5oHooaP6ColGmVoo5oI?oaOF7olG]Ooo5jGoo_NUco
hGiBol>;A?nYUcSoXiXdojFK=_nXVCKo[IHfojRK=?nKYRooVjP`oj6U<_nQY3;oWjDcoj2T<_nRY3?o
XJDcoinV<OnMYc;oVjLfoifW>OnLYSWoVZL^oiZW:_nIYb_oUZPZoi:Y:?nRYc3obY54onecCoobKE3o
ehQ<okV^>_nY/RKo[k4Xok:a:_na[RSo[Z/Toj>Y7OnGYAOoSYdFoh^F4on=Sa3oShl?ohfA3_n=TPko
SI0>ohbA3_n;WA[oS:DRoh^O7?n<T17oS8h?ohf?4@06ohf?400Aohf@4?n=TQ3oS9D@ohbG4_n=Ua?o
SILDohfF5?n=UACoTY4@ohVO6On3aT3oQM9=ohfn=onVYBCoYZHSojFW8onWYRD00onVYRD2ojFW9P06
ojJV9OnWYBGoYZHUoj2[:OnmTQSohg01oooTK`1<onA_0000oooTK`0fonA_0004omIY4?o=HcoodVA?
olmTA0;ocf=500?ocf=4om1SAOo@HdH00_o@HdD00oo@HdKocV=8oleRAP02oleRA`0:oliRB_o=HTOo
c618olYOBoo:GTWobei8olmOB?oAH4Sod616om1QA@;odF1700?odF56om5OBOoBH4L00_o@H4L03ooA
H4SodV19om=QBooBH4[ocem9oleOA_o<GDKoc5]<olmKE?oPJDgojWA6onahAoo/N4_ok7MAonafE002
onafD`05onafE?o/MUOok7IFonafE_o/MUD00_o/MU@00oo/MUKojW=3onMa:`02onMa;`0BonMa;?oW
LBgoiW0UonIa9Oo^MDkolfaFooA/G?odK5kom6]LooA]G?odKE_om6aKooAZF?oeJEcom71QooA^F_od
KE[om6iL0oodKU/0foodKE_om6eLooA]F_odK5Wom6eIooA/FOodKE_om6M?ooAMA?odHDcom6MAooAV
D?ocJ4comVUWooQXQOohHhKonEnBooQTSOohI7oonU1Noo/o@_ojE6Won6jAooQ`T?ohKhWon6f9ooQ[
R?ohJhWon6R2ooIQKOoeG63omEUUooECJ_ohCgGon4]nooQ4OOoh@WOomD=ZooI2Ioog@FSomD9VooE5
I?odA5ComSH_ooP[5_o/A1oogfD/omm_:ooPKB[ohVPaon=V??oVH3gojEdhoo5K:ookDagomUDSonQL
;_oTE2koid`Xoo12:Oof?BgonCP[ooPa9_oj;BWonc8aooPe=_oc;cWol2`[on`nDOo/Bh;ojdU[onY>
Coo/CCCoiDaWolU5Noo6@H;obcn>olToS?o4@G[oaD=YolA6G_o3AFGoaE20olMBR_o>B9ooddZRomA:
XOoBBJ?odDRSom9<XOoBCZ;odTjSom9<X_o@A:OocCnUol`nZ?o>?j_odDBUolm0YOo;?9gob3jEokm1
S?o=?Z;ok3RYon`^N_o^:7SolbN;ooDXT_od:9;ojBemonT^KOob98?omAjIooL[Roog=8Gomc>8ooL_
Q_oh;hkon3BDooPcUOog<YGolTAjoo1=J_oaBFkol4][oo1<L?ocBggojE26oleLMOoBG7?oc5e`oiiG
MonNGG7oZfEXojeUIonbIVGo[6=ZojILKondHfOoS:mooeoEQonBX9coUfVUokEPYooGHJWoYVNLoiUU
TonTJ97oW6jCoij6RonIOHgoVfjAoieiT?nJPiCoVWZCoimjR?nRNhGoXWf5oj69ROnQThgoY8V7ojEi
PonXLhOoYW67ojMdQOnVMhGoXgV2ojUfP_nWMX?oY7V3ojEfPonUK8SoYF6?ojMHUOn^F9Co]eb>ok1S
OOnRIF[oWfEWoj9VJ_nRIF[oXFEYoj9UJ?nQHVOoX69Woj5RIonQH6OoYEi[ojUNL?nYGGCoY5UeojAI
KonVG6[oYea[ojILJonWG6coYEe[oj1NJ_nTGFWoY5iYoj=NJonSGFWoXUaYoj9LJ?nMGfGoW61Uoj9M
JOnRFf_oXE]/oj9KJonRFV_oYE]/oj9NJ?nPFfkoYeQfokMj?OnjPbCo^H4XokZ0:P02okao:P0Lokao
:onjOR_o^Gd/okQl;OngN2co^gD_olAd=ooCM4?ohW=>onIeEOo^MUWol7ENoo5iH_oaOFCol7eRoo1l
Goo/Ne[og7e>okn:@?nYUSSoXI`fojFK>?n/Uc_oZYXhoj6R=OnOY3?oX:Dcoj6U<P;oX:Ha02OoWZHa
oinV<?nPYC3oWjDaoijW=?nKYS;oV:L/oiRW;_nJY37oWJ<boibS<OnFYBkoV:D`okRN?_oORdKol813
omnC>_niYR[oXjXLojVX7_nYYako[:DNok6V8?nbYR;oYjHNoiBT4_n=VPcoSY8>ohf@3on=T@ooSI8>
ohb@3On;UA;oS:4NohfT8?n;WAcoSHlAohb>3on<T1001on=Sa003on=T13oS98@oh^E4?n<Ua7oRiPC
oh^G5?nBTQ3oR:4JohG5@?n4dD[oPlDloj:Y9_nYY2;oY:LTojJV9002ojNV9@;oYZHU00OoYJLVojJW
9_nWYRGoYZHUoj6[:?ncVQgogW@30?ooi6l0C?oTK`000?ooi6l0=OoTK`001_oKJ`[obf<gom9SCoo@
HdOocf=5olmSAP;od6=500Cocf=6olmSAOo>HdKocV=60oo=HTL08_o>HDOocF97ol]QB?o;Gd[obei:
oleNBOo?GdSodF17om5PA_o?H4SodF18om5QA_oAH4Sod618om5PAooCH4OodV56om5QA_oBGdWodV1:
om5PC?o>GT_obee9oliMBOoGH4OogFI9on9WFoo[LEgokGQFonehEOo/MeKok7IGonafE_o/MUD3onaf
E00BonafEOo/MU?ok7IDonafEOo/MUCok7IConafEOoYLd;oiW4ZonMa;OoWLBkoiW4[onIa:_oWLRoo
jG<hoo1eE?oeK5com6aO0_odJe`02?odKEcom6eJooA]F_odJ5SomFYMooA`GoodKEWom6eK1?odKEX0
foodKE_om6iMooA^FoodKU_om6iLooA^G_odJeKom658ooAMAoodI4oom6UCooAXD?odJUGomfYhooQV
Q?oiGhoonUbFooQSP_oiFVWond=6oo]6CooiIHWon7>MooQbVOohLYOon7:FooQbToogLHkomg>@ooQ`
UOoiIYOonV6Soo]RZOokGJWonUVVooYHXoojEikonU>KooY?VOojE:3oneJSoo]<ROol=ekoo2a7ooPe
B?o^A4_ok4I2on]9@_oYCdcojTa<on]8?_oa?bKomS8BooHY4OoZ<2;og3lgom=5A_oA@d[ocd18omLo
EOoP?5Sojc]Moo4iH_oe>F3onSUMooThD_oh>5_oncm`ooQ:S?oM@;[ofDF_omELQOoFEHCoeTJ;ol]1
S?o<?IOobcfEol@lR?o1@77o`T=TolA6G_o7Be?oae9YolMFQOo<AikoddVTom=9X_oAB:;odTZQom==
XOoCCJ?odDbTom58X_oAA:?odD>Tolm2Y?o>@:coc3j/olDjX?o7>iSob3fFol90S_o8A9?oiCbNon`_
Noo/:WKolRV:ooHZT?oc:8koj2YmonL/KOo^9WOolajHooLYRoog=XComcB7ooL`ROoh<8oon3BDooPa
Uoof>HkolDUaoo1<K?o`BfkolDa^oo5;L_obBgOold^4omaHOOo?G7;obe]boiiGMonTHF_o[FIVojiU
J?nbIVKo[6=YojEMKonhH6GoUIAfodoGM_n1^9OoT8nYoiB4W_nlNI_o^FJOoiUPU_nUIIGoXV^Doj5h
SOnMQh[oVgB?oiebS_nKOHooVh>EoiioS_nONHSoXWV5oj9kQ?nOS8_oXYFBoin8SOnPOhSoXgN7ojQc
Q_n[LhGoZWB3ojeaQ_n[MH?oY7anojAnP?nUNH7oY7>5oj=]R_nTIY3oWF:6oiMQM?nJI6[oWVQYoimX
JOnPIf[oWVM[oimVJ_nRIFSoXFAXoj=UIonSI6OoXV9Yoj=SJOnVHVgoYUicoj9HLonTFV_oYE][ojIL
KOnVFfcoYEa[oj5MJonRGF_oXUiZojANJonSGF_oY5][oj9LJ_nOGFKoW61ToimPIOnQGFSoXUaZoj=L
J_nRFf[oXe]Yoj1LJ?nRGVOoY5Ejok9/EOnhPbGo]X<UokN29`03okZ2:016okZ2:OnkPR[o^h4[okV1
:OnfPRSo]X4XokR1:OnjPB_o_Gh[olAj;?o@NSKofh16onJ0Coo^O5;ol7YGoo1kFoo`O5kokGeKomb1
D?o2RdCoZYTkoijO=OnWV3Ko[9HhojRK=OnTWcCoXZ8coj6S=?nQXS?oX:8foj2S=onOXSKoX:8foj2S
=onPY3?oWZH_oiZW;OnHYBWoUjLWoiNW9OnHYbCoUZPPoiJZ6onUYQgodYHbonik?ooWPC[o`9hYojFV
6_nXYQcoZZDMojbV7_n]Yb7o[ZPQok2Y7_n/YAOoV:8=ohnL3?n=U0koSI4?ohf@3_n<T0coRiXGohbQ
7on<XaooRi`Johb@4On=SPooS90Aohb@40KoSHl@00koSHh@ohb?4?n;TQ3oRi@@oh^G4On?UPooQZDK
ohO8@on7cd[oO<TooiRa;?n[XR7oYZHSojFW90GoYjHU00KoYZHUojFW9_nUYbGoXZXXojZS8ooEO@Wo
onA_04coi6l0003oonA_03Coi6l000OohFh3oliU:_o@HTgodF=9om5SA?oAHdGocf=700;ocf9600_o
cF97oleRA_o>HTKocV96oliQA_o>HTKocF56oleQBOo;Gd[oc5m:oleOBP02om1PB@0Gom5PB?oAH4Wo
d616om1PAooBH4SodF17om5PB?oAH4OodF57om9QAoo?GdKocEi7oleMC?oAGDkodV1:omIRAooPITGo
iVlionUc=_o/MT_okGQIonehEOo/Me@00_o/MU@01Oo/MU?okGIDonafE?o/MUCok7IC00?ok7ID01Wo
k7IBonafDoo/MU;ok7IConafE_oZM4CoiW4[onI`9ooVLBcoj78eonYd?oo/MdKokGQ9oo1eE?oeJe_o
m6aLooA[G_odJecom6aKooA]F_odKE_om6IEooEZGoodL63om6eI00;om6eK0_odKEX06_odKU_om6iL
ooA^FoodKE_om6iKooA^G_odKeoom6M=ooANBOodHDkom6UDooAYDoodJDoomFYOooQXPoohHhconU^H
ooYMTOoiG7?onTaCoo]0?OojDfWon6jEooQcVOohL9[on72I0_ohL9<08?ohKiOonVZQoo][ZookJJSo
nV>TooYNYoojG:ConUbRooYLY?ojFjConUZVooYP[?ojGZKoo52;oo`nK?ol?fKonTMdooU=OOojCGko
ndZ4ooa9Q_okAGGooCUIoohY=oon9S;ooRU;on`eGOoM@5goecaHomLjD?oC>T[odC]20_o@@4@0KOoC
@4OofSmDon8nH?o/?6_omcakooY9RoojDHkon52NomLk_ooJ@<CodDfNola5R_o=@Xgoc3jGolHjUoo2
>9Co_camol=5H_o6BE[ob4]HolU<D?o9BekocTREom54X_oAAZCodDRSom5:X_oDCJ7odTbRom19XooA
BZ;odTRRom54Y?o?@JGocd:Tolm2Z_o<>Z[o`c^Gol8iV?o1>iKo`3n>ol=6R_oI@I;ol2f0onhXM_oc
:8SombJBoo4YQooW:WWoiBYbonL[M?o/8IComBF@ooLePoog<h[on32<ooPaS?oh;iCon3BGooA2P_o`
B6kolDUaoo5;L?o`C6gol4]`oo1=LoobBGooj5B1om5OL_o7Fg3oY5a`ojUUJ?n/IFOo/6EXok9WIOn/
HVWoY5eaok9MI?nTMW?oG=Afofo4SOn;RZkoUiVRoj>RT_nTMYGoUVJGojAUUOnWJ9OoXW>?oin2R_nH
NhkoW7:>oi]cS_nHNICoX8^AojB6R_nPNHSoXWZ4oj23Q?nQTHgoXXZCoin5S?nQQXWoWgn;oj5kR?nY
MHKo/Fj8oji`PonXMWl00_nYMX805onWLXOoYgB5oj5eP?nEKWcoSf9koiAPN?nJIFooW6MZoiiXJ?nM
JF[oWFQ[oiiXJ_nOIVWoX6MXoj1WJOnQIFWoXVIWoj9UJOnTHfooY65coj=NKOnSG6WoY5]Z00;oYe][
00goY5a[ojAMK?nTGFcoXee/oj9MK?nQGF[oXUaZoj=JJonPGFSoVemVoimMIonUG6WoXeeX00;oXUeY
00[oXE][oj5MIonRFG3oZei/okQo;OnjPR7o^84VokN29_ngPRSo^H8Y0onkPBX0=?nlPB[o^h8XokZ2
:?njPRSo^8<WokJ38oncPb;o]8@Sok^4:Oo4P2kocWddoman?OoSODGok7i:onmoD?o_P5Cokh5Bom^:
AOnjVCGoX:HZoiZU9_nUWbSoZIhYojNP:onTXRcoYJ8^ojFQ;onTXbkoXZ@]oj:U;_nTY2koWjHPoijV
5_nMYQGoVjLEoibV5_nNYAKoWJHGoijU5onNY1KoVZ@DoinU6Oo2V2_oj7lkonj2@?o8UbgoZZHNojJV
6on[YAgoZZ@LojRW7_nbZB02oknS8P0<ok2U6OnJX`ooSiT=ohbD3_n=T0goRi4@oh^N7?n=XQkoRj<P
oh^J6_n<Sa7oSHh?0_n<T107ohf?400=ohb?4?n=Sa3oS90?oi2B3On3ZA[oR<]2oh[>B?mkbT?oSKXf
ojVT9?nVYR?oXjPTojJV9@06ojNV9@04ojNU9?nSZBKoXJXXolV64?ooi6l0C?oTK`000?ooi6l0=?oT
K`001_o@IQcodV=:om9SB_o@HTGod6=5olmRAP;ocV9700_ocf96oliRAoo>HTOocV97oleRA_o>HDKo
c656olUOBOo;H4WocEm8olmPAP03om1QA`03om1QB?o@H4OodV1700;odV56013od657om1PA_o>GTWo
cUi9ol]MB?o;G4[oe5m>om]VBOoRJd7oig0ionUe=OoYMRcojGL^onaiA_o]MeOok7ID0_o/MU800oo/
MUGok7IConafE@02onafE003onafDoo/MUCok7IC00Gok7IC0?Kok7IEonefFOoYLcooiW0VonMa;_oZ
M3kokGM9oniiCOo]N4Sok7M5onmeDOodJeWom6eKooA/GoodJUcom6YKooA/FoodKU_omFIEooI[HOod
LF3om6eJooA]FoodKEWom6eKooA]F_odKUcom6eKooA]FOodKE[om6iKooA_G_odK5Som699ooANCOod
He3om6QDooAYD_odJU;omV]aooQWS_oiGY7oneZIooYLROojDF3ondI;oo]2A_oiHh?on7>KooQaVooi
LI[on72FooQ`V_oiJjKonfFcoo]S]OokIk3onfV`oo]N[oojEZKonUZTooYIYOojF:?onUbWooYR[Ook
FYkoo4Ihoo`lHOok@FSonTYlooY;QookAhKoo4J3ooe3OOon>fgoocEHoolaGOon<GCoo3VFooM0Yood
?j7olcfOoo0nX?o^?i_ojd2AonToQooS?gWoh3ebom`kHooI?5oog45Von52F?o[@fWon4VIoo]<TOok
B7goi4jgomLkb_oC?:God4F9ole2Soo4>ICo_cJGokhkO_o5B5gobDaDolQ;EOo9C5KobDaEolU<D_o<
@XCoed:XomA4YOoDBZ?oe4fQom9<X_o?BJ7od4RRom18Xoo@B:CodD>Uom50Y?o@@jGoccnWolXjXoo8
?YOoacfIol0lU?no?I3o_d>;olU:OooX=7[om2Ejoo4YQoof:8ookBZ4onH]M?oU;GCoiBigonPRTOod
8i3omcB5ooPbS_oh<8kon32;ooT_UOoh>IColdIjoo17KOoaAWColD]_oo5;K_o`Bfkol4]coo5:Moob
CH;off1eolMPKOn/HVSoZfIUojaTJ?naIVSo/FEVojeRJ_nVGG7o[F5WokIQK?n3YW[oFMN0ogf:Y_nG
SZ7oYZZEoiV3U?nFKIOoVV^Eoj9VU_nTJi7oXGb;oiQoS?nGMi3oX7J;oi]cSOnLO97oZ96<ojB9ROnO
NHKoXG^5oin8QonQRi3oX8N@oin4SOnPQh_oXHf?oj28S_nWNX[oYWJ4ojIhOonZMX3oZg>1ojIbQOnO
MHCoX7ajoiefMonHKWSoU6Ekoi9POOnHHgGoX6IZoj5UJOnQIV[oX6MYoimWJOnOIf[oWfMXoj1WJ?nN
IVWoWVMYoj1WJ?nPIfcoXFAaoj1TKOnOHVKoX61Uoj9MJOnSGFSoXUiZoj9MJ_nQGVWoXUmZoj5OJOnR
Gf[oXEeYoj9LJ?nNGVKoVeiUoj5LJ?nSFV_oXU]/oj9LJonSFfcoXE][oieLJOnSE7co]7=:okf28_nk
PBD2okR19P05okR19OngPBCo]h8UokV19OniPBH00onjPBH0@OnjPROo^X4XokZ1:_njPB[o^H4ZokR2
:_nhPbWo^8<WokR19_o4ORcoeGlgomio?OoXOTCokW]8onj3BooGU47o^Ih`ojBU8onQY23oYJ@RojJT
8onWXb?oYj@SojNS9?nXXRCoZ:<UojRS8onQY1CoWjD>oinU3onNY@ooWjD@oijU4_nLYQCoWJHFoifV
5onLYQOoVJHEoiRV5On_X27ogh`konii?_oCT37oZjHOojJV6_n[YAgoZJPNok6W7?njXQko_J8Rol6Q
9?o2XRCo/JDKoiZU4?n>W0goSI8:oh^F5On=X1koSZ4Ooh^S7on;VQWoSHh@ohf?3on<T17oS90@00Ko
SHl@00_oS8l@ohf?4?n<SQ3oTh`=oh>T6?n2bScoR<e3oh3<@?n3aScoXjXXojfQ8P02ojBW8`KoYjHU
00CoYZHUoj6Z9onL[B_oahPBoooTK`1<onA_0000oooTK`0conA_0009omQZ3oo;HSoodV9=olmRA?o?
HTKocV96olmRA_o?HTGocf9600;ocV5600?ocV96oleQAoo<HDP00_o;GdX05_o>H4Wod617om1QAoo@
HDGocf55oliPAoo?H4OodF57om=QAooCHD[ocV18olaOA_o;GDSobea;om5OB?oIHTOog6M3on9_@_oY
LScojGDbonUh;_oYN2l2onUg:`0<on]g@oo/MUOokGIGonafEOo]MUCok7IConaeE?o/ME;ok7IConae
D_o/MU?ok7ID0_o/MED3onaeE0;ok7EC00_ok7IEonafE_oYLcoojG<gonafAOo]N4WokGM8onegBOo]
Md[ok7M4onmgD002ooA/F@0<ooA]G_odK5gom6UKooA/G?odK5WomFAGooI/IOodLF3om6aIooA]Food
KEWom6eK0_odKE`00oodKE_om6eIooA^G002ooA^GP3HooAVDOodGd_om5m=ooAUD_odJ5?om6YDooEY
G_ohIh7onF2>oo]JU?okFi[oneAeoo]9D?okA4[onTmQooQ]UOohLY_onG6LooQ`VooiJj?onVR`oo]S
]_okI;GonfNaoo]S]OokG;coneRhooYB[_ojDjKonURLooYKW_okFiooo4j6oodhGooi<USom45]ooQ3
O?ol@H;ooC]`oohbE_oo;4_oob]4oohXA?on:eWoncIjooPlS_of?HoonCZ;ooXjT?ok>iOonS^FooLm
U?of?XoomcbBoo@mSoof?i3omd>HooE9Y?ofAikokD1bon/oI?oe@WSomc]ZooTnMOoY?]7ocRKOom8`
aOo??:[oaCBXol8_ZOo1=I?oaD=XolY<E?o9CECob4eBolU=DOo9CU3obU1:olU<EooA@iCoeD6WomQ:
Y?oICJ;oe4VQom57XOo?Aj;ocTNSolm9YOoA@jCodT>Rom52YOo;?Ioob3bLolTmV_o8?IOo`cjBol=0
T?o1@Xko_4a`omE0JOo_:gSom2R5ooHWSOo[:gkoi2maonH`L_oU;gCojb:>oo4RSoog<hCon3>=ooP`
S_oh;8konC:DooLnS_oaAg7ol4QYoo55M?oaBW3olD]]oo1;KOoaBW?olD]goo5:NOoZDggocFIYok1V
H_n[IVOoZf=Xok5UIon`I6Ko[V9[ojYOK_nZHfco^EaVok1mN_mUch3oM:FSoi:?Y?nW]9[oXINCoieb
T_nIL9SoUG2HoiaXU_nRMXcoWH2;oiEnTOnMN8coXWR:oiiaS?nRPX_o[Ib8ojF=R?nNNXSoWH66oin9
RonPQY3oWH>@oiioRonQPXWoWh><oin0SOnRSHkoXXn;ojB0QOnYNX;oY7ejoiikNOnMNG[oWgQioied
M_nJKgGoTfIlohmRPOnEIWWoVfQaoj1XKOnSIf_oY6AXoj=TIonRI6SoX6=Zoj5TJ?nPIVSoXFEXoj9U
J?nSI6goXf=aoj=UK?nMIFSoVV=XoiQSI_nFHfKoVV5Xoj1QIOnQH6OoXUiYoj9MJ_nRGVWoXeiZoj5N
IonLGfCoWEmToj9MJOnTFf_oXe][oj9LJ_nSFfcoWeeXoieGMOnYH6[o^Gl[okZ18OngPBCo^84T0_ng
PR<02_ngPB?o]X8TokF39?ngPRGo^X4WokZ1:?njPRWo^X8XokZ1:?njPRL3okV29P0FokN29OnePRCo
]H8TokR49onjPRSo`7dZolan<_oGPCgoiWa3onamA_oFScko^:4bojFW9_nUYB?oYZDTojFU9?nUY2Co
Yj<TojRS9_nVXb3oWZHBoijV3`?oWZD@01[oWJH@oifV4OnLYQ?oVjHDoifV5OnMYQOoVjHGoiRV5?nW
YAkocI4^on]m?OoOSSWo/Z@Soj>V6onXYaco]:DMokZQ7_njXQko^J4NokZR7onnXb?o_Z<RojfU6OnK
Xa3oRi`9oh^O5P;oSJ4N00KoS:<Poh^J6On=SQ3oSHh?ohf?4?n<T105ohf?40;oS8l@00coRi0Aoi><
3On5XA[oP<XkohC;?_n3acgoM<Xeoh2l9_nUYR?o[:8RojBW8_nVYR@3ojNV9@06ojFW9_nSYbKoXjHV
oj6X:?nNZR[ob8H@oooTK`1<onA_0000oooTK`0bonA_0007oma/1oo;HcCodV9@om1RA_o?HTGocf96
oliRA@02olmRAP0;olmRAOo>HTGocF96olaPAoo:GdSobem9oleOBOo?H4SodF18om5PAooAHDL00_o@
HDL05ooAHDKod656olmPAoo=GdOobEa;ol]KC_oBGd[ofFA5on9Z@OoVL3Ooj7DbonYh=?oZNS;ojGT^
onUh;_oYMc3ojGH^onQe:?o[MSkok7IDonefE_o/MUGok7IC00?ok7ED00?ok7EConaeE?o/ME@00_o/
ME@01?o/ME?ok7EEonafE_o/MEH2onafE00GonafEOo]MUOokGIEonafBoo]MdSokGQ<onehBoo]MdOo
kGM8onegC?o/MdSokWM>ooA]FOodJe[om6eLooA]GoodJUcom6eLooA/FOoeHUOomVaTooA`GoodKET0
1OodKE/0F?odKU_om6eKooA^GOodKUkom6YGooAQBoodGD_om61;ooAWD_odJeKom6IAooIRHoohHHCo
nUV:oo]JVOokEi3ondYOoo]5BookBE?onF>3ooQcVoohL9_onF^SooYV[OokHkOonfFfoo]V/OojJ:oo
nf:foo]I__okE[[oneJkoo]F]?okF:7oneREooa<S?om>FSoo2M0ooD`A?o`?egomD9Woo/mGoom=4Ko
oRXboohV;Oon92gooBDkooPbFOoe>Voolcieoo8oL_od?VcomCe`oo8mLoo_?6kokcYZonliKOo`?7Go
m3mhooM2PoojAiGonT^VooY5Uoob>VOoicM5onLmD?oWAFgoj3RMon0/c_oF:N3ocbKSom0Yf_o8;LGo
a2S5olL/`?o7<jCobSZAolTlR_o6?H?oad1iolM4K_o7AfGobDUPolU=D?o9AfcodT:PomE6YOoGB:42
omM8XP0RomE8XooBB:;odDRSom54YOo@@j;ocCfTolDkV?o6?9SobCZOolHlV?o3?i7ob4>=olI3S?nm
C6kocT=Xon0gMOo^<8;om2Z8on//N?oU;VooibebonPZL_o_9HKolAnDooHZQ?og<hGon2f?ooP`Sooh
>8oomD26oo19J_o`B6SolDI_oo58L`;olD]^043olDY`oo5;N?oaBWOolDYmomMSJon_Jf?oZVAXojaT
JOn`IFKo[F=XojmSJOn[HFcoYV9[ok5TIOniIV?oRJmoog72[on>Sj?oV:JHoj:^U_nMPi?oX6jEoiYd
UonDLISoVg>>oj5nR?nHPHkoVGV@oj9hROnQMXWoVgJ<ojB<R?n_WhSoZ8n8oiioQOnNQXOoXhB;oj23
S_nNP93oWgn:oj9lR?nQP8_oXY>@oj:DU?nSUI;oYZB@ojNPQ?nTSg[oX7mjoimiN_nMLgWoW75eoiY`
M?nCJG_oSF:1oi5XO_nJL7GoWFiaoimZK_nQIf[oXF9Zoj9QJOnRHfSoXfAX0_nRI6P04onRI6WoXf=]
oj=SLOnRI6coX6AXoieSJ?nIHfWoV6=^oiaSJ_nMHVWoWf1[oj9OK?nSGF_oXee]ojALK?nPG6SoVf1T
oimNI_nSFfP00onRFfP02_nSFfSoXEYZoj=DN?nbM4;o^X4QokUo8oniP2Go^H0VokUo9_nhP2H2okN0
9`04okR19OnfPBGo]h4UokN09@;o^H0U01ko^H4UokR29OngPRCo]h4UokV29OniPBGo^88VokJ29?nd
PRCo/H8Sojn38OnaPR;o_7lVolYl<?oGNCWoe84ioknE=?nWYBWoY:HUojFW9OnTYbGoYZDVojNT:?nS
YAcoWZH@oijU3onNYA3oWj@AoijU4OnNY102oijU400>oijT4_nMYA;oW:HDoifV5_nMYAOoUjDEoiRV
5_njWBKoiXHlonB5>_nkVRKoYZPKokFS7_nkX1l4okZQ7P0?okbQ8?o1X2Co`:<Tok>T6_nQY1WoT:HR
ohfS7_n>XAgoSZ8Poh^H6?n<S@ooSHl?ohb@4?n;TA7oS90@00;oSHl@01GoS8l@ohf?4?n<T13oRY0A
oiB;3On6XakoP/`nohC9?_mmaSOoHlPRoe;<5om/`b3oWZ/UojVT8_nUYR?oYjHUojJV9OnSYbKoXZLW
oj:V9_nSYRH00_nQZ2P00oo8QQ3oi6l0onA_003oonA_04[oi6l0003oonA_037oi6l000KohFh3ol]S
:?oAHU3odF99olmRAOo?HdH2oliRAP0TolmRA_o?HTGocV56olaPAoo;Gd[oc5i:oleOB?o?H4Ood655
om1PB?oAHDOodF56olmPA_o>H4KocUm7olUMAoo;GDSocee9omAQB?oKId;ohVdoonMb>_oYMS3oj7LW
onUi;_oZO3KojW/honYh=?oZMc;ojGH`onUe;_oYMB_ojWDionafDoo/MEKok7EE0_o/ME@2onafE@Oo
k7ID0_o/MU<02oo/MUGok7IDonafEoo]MeWojgA=onYc@Oo]MTSokGQ:onegBOo]Md[okGI900?okGM9
00cokWI=oo=`FOodK5[om6eIooA/GoodJeoom6eLooA[FOofHEOomVeTooA^G?odK5T2ooA]FP?om6eK
03Com6eJooA^FoodKUkom6iLooATC_odGTWom5i:ooASC_odJUGom6E?ooAMB_ogHFoonEf6oo]HTook
FISoo4n0oo]7EOok@4?onUIXooQ`U_oiKZKonVN]oo]S]?okI;KonfFdooYW/?okIK;onejjooaE_ook
E[[onUJdoo]L]?olIk7onenKooa8NOom<5Coo2XlooPgA?ofAeWonD]NoodnC_om<3CooRHToohT:Oom
:3KonRe=oo@kJ_o`@gKolT5`oo=0J_o`?VKokSiV0_o[>fT05_o[?G7ol49kooA4Q_ogAHWonDF;ooY7
U?ogB9?okD9]omll?OoDA3CodSiEomLkT_oF<Kcob2g3olPTeoo=9mgobbGLol`Ug?o49/[oab_5olXa
]Oo;=j02ol/fX01bolXeXOo;=J?oc3JQolXgW?o:>ISobCf:olHkQ_o=>j_odd2^omE7XOoHBJ;oedVR
omQ8X_oGB:7oeDNRomA4YooA?jCoacZLol8lU?o5>iSoaC^Lol@kV?o3@Hooad>?olM4R_nnCFgocD5]
om`hN_oO>X?ohcN3on@cM?oX;FookBUbonXYLOo_9X3olQbGoo@UQoog;hOon2^@ooPeT?og>8[om41l
oo19J?oaB6_olDM^oo58LOoaBW7olD]^oo5;KooaBGWolDaioo59N?oTEG3o[faQojEWIon[IVKo[FMU
ojQSIon]I6SoZf5[oj]OJ_niGg3obUQ`okiZROmi[J_oQg>Ooj1cU_nKRICoUgnFoj9^TonWKYGoXG6G
oiIfTonMOXWoWWb;oiEjT_nNMXcoX7V9oiafRonLMh[oYXf7ok2PR?nXShKoWhR6oj63R?nUOh[oXXB?
oin:T?nRQHWoXX28oin5RonPU97oY:nFojNdT?nY[XgoZZ^6ojNRQ_nTT8;oXh5joiibM_nLJg;oVFaa
oiIXMon?HX3oSfB2oiI/NOnJL7GoVfeboieZL?nPJ6coX6EXoj=SIonRI6OoX6EX0_nPIFL08onPI6co
YV=aojIRKonSHfcoXF5[oieQKonLHVooWF9]oiaRK?nNHf_oWV9[oimOJ_nSGf[oY5e/oimNIonNGfCo
XEaXojALJOnRFfSoXU]Yoj=LJ_nSGFSoWeIdojeRH_nkOR[o^glTokQn:?nhObSo^WhXokYo9oniORKo
^GhUokUo9_niObGo]ghT00;o]glT00Oo^GhUokUn9_nkORKo^gdVokYn9onjObKo^WlU00?o^H0U02Go
^GlVokR09OngP2Go]X0UokF19?neORCo_7XVol5l;?nhQB[o[I0TojRM9?nWY2KoYj@YojJT:_nRXago
X:@BoinU4OnPYA7oWZHAoibW4?nMYQ7oWZH@oj2V4OnOYA?oWZDBoifV4OnMYa?oWZDHoinT6OnHYaKo
U:LDojNS7_oDRS;oj8XmolNY;ongY1ko^Z0N00Go^Z4N00co^j4OokbQ8Oo1XB?o`:4PojfX9onPZ2co
Tj@RohjS7On<XQkoRiLFohb=3_n=SPl2ohb@400Dohb@4On=Sa3oS8l@ohf?4?n<T13oRhl@oi>=3On2
Z1ooQ/a1oh?;>omZabOoG<LJoek87OmEcAooN;hVojNU8onWYB7oY:LUoj:W9_nSYRH3ojBV9P03oj6X
:?nRYbOobHD?0?ooi6l0C?oTK`000?ooi6l0<OoTK`00;_o@IQSocf5<om9SC?o>HTKocV57oliRA_o>
HDSocf58olmQAoo<H4Sobem9olaOB_o>GdWod618om5PAoo@H4OodF59om1QB?o=H4SobUe8ol]LBOo<
GDWocei9omURA_oQJT3oi74gonMd<_oYMRkojGPZonQi:?oYNRcojgdoonamBOo[ND3ojWLgonYf<_oY
MS7ojGH_onUe:ooZMSOok7IBonafF?o/MUKok7IEonafE?o/MUD2onafD`05onafE?o/MU?ok7IConaf
E?o/MU<00_o/MU@02_o/MU?ok7EBonaeD_o/MUKokGMIon]eBooWLCGoiW0Yon]d@oo]N4`2onefB@0A
onefB_o]MdWokGM9onegAoo^Mdkolg1KooE[FoodKE_om6eLooA/H?odK5gom6YHooIOEooeKfKom6mK
ooA]FOodKEX00_odKE/0C_odKE[om6iLooA]FoodKUgom6mOooAYEOodH4Som5i;ooAOC?odI53om6EC
ooAHA?oeG57on61mooUGROokFYWoo5>>ooa9L_ok@dKondQ?ooYTTOoiJJkonVJaoo]T]OokHkGonf6f
oo]R^OolGKooo5K4ooa@`oolDkconUVbooYO/_okJjconfNJooa@M?ol>dcoo3M4ooa2E?okCF;oo4MJ
oodf?_om:R_ooRDWoohW<_om:dOon3QQoo13LOo_A6oolCmWonlmH_o]>Uook3aVonhoMooa@H?om4F;
ooQ7S?ojB8gonDB7ooI4Ooo_AG[oidMWomY4Aoo>AT3ocD5SoldjUooA;KSobb72olHWb?o6:L;obB_7
olPUg?o98]gobB7LolDUc?o8<;Coc3FSol`gXP;obcJQ09CobSFSol`fXoo<=J?oc3FTol`eYOo;<jGo
b2f]olLeXOo@@:7oeTJUomY:XOoIBJ7ofTRQom]8XOoJBioog4FVom/hYOo=>iGoaCfEolDmU?o1>iSo
a3fFolE3Roo6A8go`dB:ok]=KOo=@f[ogSYhomdlQ?oF?Gooe3iaomhhK_oZ;W3okRQboo8SOOoc7Y;o
l2B;ooLZS?oh<XWomcF9ooHeQ_ob@W;ol4UXoo58JooaAVgolDQ_oo5;LOoaBVkolD]^oo59MooaBg_o
lDYjonQAKOnfH5goZF=_okUNL?nnFW;o`EAjoli>QOo?B8_oddF<on98TOoXAi;oiD2Eoi9/WOn0SJ3o
XfNDoia[TOnFLY;oUgFDoimbUOnUL9CoX72GoiUmTOnPPX_oUWZ?oi]fSOnTMX[oXWZ8oimfR_nON8Ko
XXb4ojNOQ_nWWXSoXY69oj65ROnPQH_oWXN?oij1S?nRNhOoXXb8oj:YRonU[H[oYZb8ojB`RonT]8ko
Y[F=ojF`SonWYh[oYYN1oj5oN_nMKW7oW6a`oiQYM?n@HWooSf:0oiEYNonHL7OoW7=coiecLOnKKVoo
WVY/oj1UJ_nQI6SoXFAWoj5SJ?nRHV[oYF9`ojMSL_nSHg7oXV9/oiiQJ_nLHfcoWF5^oieQKOnMHV_o
WF=[oiaRJ_nKHV[oWV5ZoiePJ_nMHFKoWV1VojALJ?nUFf_oYU][ojEKJonTFf_oXUY_ojIGMongMT7o
^h4SokV09OnhPBGo]h0UokR09OnfP2Co]h0T0_nhP2D03OngP2Co^80UokN09?neP2?o]glTokUo9Oni
ORGo^WhVok]n9_nlOBSo_7dWok]n9onjObH00_nkObH2okUo9P0CokUo9OnhObGo^7lUokUn9_nlO2Oo
_7`XokUm:OndR2SoZY/Toj:Y8?nSYacoY:LIoj>X6OnTYaOoXjLGojBV5onSYQOoY:HGojFV5`02ojBV
5`;oYJHH00[oXjLIojFV6OnUYacoXZLKoifW6_nSYagoaJHbol^Z<_nmYB3o_J0P0_niXAh00onjXAko
^j4NokZQ7P03okZQ7P0OokjP7onjXb3o]:P`ok6W=?nQZ2coTZLSohfS7_n;UQGoSXd=ohj>3on=Sa3o
S90@oh^@4On<T13oSHl@ohb@4?n<SQ3oTXh>oh2[7_n7cD;oML/boek77?mPaagoI/LSof;98_mPbB7o
Sk<VojFU8onOZ2GoXZHWoj>V9P02ojBV9P04ojBU9_nQZ2SoX:TYolR64?ooi6l0C?oTK`000?ooi6l0
<?oTK`000ooIJPgobV8mom5QD`02oliQA@;ocf5601?ocV57olaPB?o<GdSocEi9oliOA_o@GdKodF16
om1PAoo?H4Ooc5m7ol]NBOo:G4WocEa9omIRAooMId7ohf`monIc=OoYMC3ojGLZ00;oj7PX00SojGP[
onUi;?oZNC;ojg]0onakC?o[N3oojGHaonUf;P;ojGH]00OojGDYonUf<Oo/MTcok7IHonafDoo/MUCo
k7IC00_ok7IB0_o/MU<09?o]MeOok7IGonUcAOoWLBooiW0ZonI`:OoYLSWokGM<onegB_o]MdWokGM:
onegBOo]Md[okGM7onegB_obLE_omF]LooA]F_odKE_om6aNooA]G_odJ5SomUmGooEbJ?odKU_om6eJ
ooA^F_odKUcom6eKooA^FoodKUkom6iLooA_G_odKE_om69;ooANB@;om5m<04Som69?ooAKB_odF4Co
mf1VooUJQ?okF97oo5JCooa9OoolAV?ondMEoo]JT?okIKOonf6jooaP^?olG[ooo5_3ooeJaOomF/Co
o5K3ooaD__okE;SoneVhoo]R/_okJZWoo66@ooa=IoomAUCoo4aDooa=FOolCF7oo49?ood]<?on9ROo
oRT`ood]@ooi=EWolceYonm0J_o]?VCokSUNoo0jHoo`?V_olT1doo=6Q?ogB93onTJ9ooQ4OoocAGWo
jdAbon13GooHCUSof4mKom=9Foo@@gWocCBNold[^_o@8L3ocb72oldO`oo88l_oaRO7olT/__o69/go
bR?NolTNhoo89/_obSFQol`fW?o<=J?oc3JQol`gW_o;=Yl2ol`hW@0[ol/gW_o<=J3obC2YolT`ZOo5
@f_ob4IaomI3Y?oJB:;ofdZQom]:X_oLBZ7ofdbQomY3X_oM=j3of3NKom4iVoo;?9Ko`SbBolHoU_o5
@Xcoa4:>ol14QonlCfWod4MVomhmMOoN?Wooeciiom<nLOoH?VoogCiaon<dLOo^:WComAn9oo<KT_oi
:8oon329ooHbPOob>W?ol4EYoo19J_oaAf_olDI/oo57K002oo5:L00^oo5;K_oaBGColDUjoo5;N_o/
CfoocdaZole5QOoU@ISoicjGonHnU_oZ@ISoiCfIon0kV_oZA9Koj4JEon=2T_njBIkoPIfHoiUlU?nM
JhooV6j@oiAcU?nGM9CoVWJBoj1^U_nOL9SoWXZ>oiV3S_nIOhkoWgN<oiaiR?nLO8GoWg^2ojifR_no
Q9WoZinCoj2@S_nPQHcoX8><oiinSOnPQ8koXYb@oj>_S_nU[8GoYj>1ojNTQ@;oYjJ601CoYZ^8ojF`
S?nU/Y3oY[:=ojJ[R_nUUhCoXhEhoj9kLOnLL77oU6Egoi1QOOnBIWgoV6egoiY^LonLLG;oWGAboia`
L?nMJVooXVI[oj=SJP;oXf9Y00KoXfA[oj9TL?nSHfkoXF5Zoj1SJ_nNHfX2oiaQKP0DoieRK_nMHVco
W6=[oiaSK?nLHVcoVF=/oiMTJOnLHFWoXUe/ojALJonUG6_oYE][ojIKJ_nQE7Ko[VINokZ19onjPB;o
^H0UokR09OniP2D2okR09@0=okN19OnhP2Go^80TokR09?ngP2Go]h4TokN09?nePBCo]84SokF19?nf
PBCo]H4TokJ09002okQo9@0EokUo9_njOROo^ghXok]n:?nlOROo_gdXokmm:OnlOBSo^g`Yokak:Oni
PR?o/HlGojRO2onSYP_oYJHBojBW6OnVYakoZ:HMojRV7?nXYQ_oZZHL00OoZ:HK00koYjHJojNV6onW
YQcoYjLNojBV6onTYQgoW:PFoinT3_ngXako_:4PokNR7OngXQko^J4NokVR7P;o^Z4N023o]j8MokVQ
7OnkX1co/ZDRokNV<onjYSGo/jTdojRW;_nHYRKoSiTEohf?3_n=Sa3oSI0@ohb@4?n;T13oSHl@ohb@
4?n>SA3oU8h>oh2_8?mmc3[oJ/XXof787omTab7oILLRof?88omHc2;oJ<@VoijY9_nTYB?oXJLXoj>V
9`?oY:HV00?oXZLXoinY:Oo9QQ00oooTK`1<onA_00000_oTK`000ooUL03oi6l0onA_000<onA_0003
onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_000<onA_0003
on=^0?oTKP3oi6l000;oi6l000?oi6h0onA_0?oTK`007OoTK`000ooSKP3oi6l0onA_0009onA_0003
onA^0?oTK`3oi6h000Soi6l000?oi6h0onA_0?oTK`004OoTK`000ooTKP3oi6l0onA_0003onA_0005
onA^0?oTK`3oi6l0onA_0?oSKP005?oTK`001?oTKP3oi6l0onA_0?oTKP04onA_0004onA^0?oTK`3o
i6l0onA^00Coi6l000?oi6h0onA_0?oTK`001ooTK`000ooUL03oi6l0onA_0007onA_0003onA^0?oT
K`3oi6l000;oi6l000Coi6h0onA_0?oTK`3oi6h01?oTK`000ooTKP3oi6l0onA^0002onA_0004onA^
0?oTK`3oi6l0onA^01Koi6l000?oiG00onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_0002onA_0004
onA^0?oTK`3oi6l0onA^00Coi6l000?oi6h0onA_0?oTKP000_oTK`001?oTKP3oi6l0onA_0?oTKP0C
onA_0005onA^0?oTK`3oi6l0onA_0?oSKP000ooTK`008_oOK@GobF8]om5RDOo?HDSocf55olmRA?o?
HDKocF17ol]OB?o<GTWocUm8om1OAoo?GdGocUi6ol]NB?o;GDOoc5e7om9OAooIHdKogfXnonI_=ooX
Lc7oj7LZonUh:_oYN2WojGP[onUi:ooYN2gojGL^onUh;ooZNCGojgTnon]h?_oZMSD2onUe:`;ojGD/
00Ooj7DXonUe:_o[MTKokGEGonafE?o]MeCok7ID00Kok7IC0_o/MU802_o/ME;ok7IConafD_o/MU;o
k7IConefF?o[MU?oj78monI`;?oVL2X2onIa;@0EonM`;?o[Ld?okWM=onefBoo]Md[okGM9onefBOo/
MTOokGI7oo5bEooeK5com6iKooA]FOodKEcom6aPooAXFOogGeWomG9Xoo=^F?odKE_om6iL00;om6eK
05_om6iNooA]G?odKEcom6mNooAWD_odGT[om5m=ooAPBoodGd[om5e8ooAJ@ooeGdoon61hooYHS_ok
F9Coo4b0ooe4MoomAWGooEJJooaO`oolFlKooEW4ooeGb?omF<Ooo5g2ooaO__okG;WoneReoo]F]ook
F[Wonf>`ooaXX?olGH;ooDiRooe>F?olFVOoo5YXooa:E_om=CkooB@RoohT9Oon;CoonC=Boo4jFoo/
?VCokCeYonljJ?o`?73omD62ooU3Q?ohA7oomDInooM4Noog@7Cok49[on18I?oFBE[odDa?omECHOoH
Bh;oeT6KomH^[_o>9[gocR2lollR^oo@9;oobao5olHNa?o78/_obB[9olXZ`_o;:kgoc2OBolLNi?o;
8l_ocCNLoldgVoo==j3ocCRNoldhW?o=>9gobcJOol`eXoo;=J;ob3:SolT`[_o7>h_oada@olQ>COo=
@XgofdJX00?ofdZQ01cofDFRomM0V_oF>iWofSJPomXgWOoD>9[ocCZEol/mUoo3@93o`d6@ol=7Pono
D6KoddA/on8hOOoO?GgofcibomXlK_oJ?7Cofc]domdiKooR=Foom22AooTJYOog;Y3omS:3oo<iM_o`
@VGol4IW0_oaB6`0I?o`B6[olDMZoo59L?oaBg3olDY`oo5;LOoaBGOolTMnoo57N?oU@G_og3b2onPm
UooV?9coiCnFonQ4UOoO@9GofCjEonM5UOoWAICogD:Dom4oW?nNL9KoSWnAoimWU?nMJiCoV6jDoia`
U?nPMY?oUW>Eoii[V?nQMYGoWHJDoiR7T?nMNhgoZ6fFokU]VooEJJOojV>^ooEM^?o2OIkoWXn@oin4
T?nRQ8koYHV?ojFGU?nU]9CoYk:>ojRWQonWZ8GoZ:N5ojNVQonXY8GoZ:F4ojVSPonWY8SoYjR7ojJ/
QonV[HcoYjJ9ojRMPOnVT7[oWWefoiIZMon@H7coT61noiEXMonIKW;oVg5doiecLOnMLg?oWW5aoii]
L?nNJ6coWf=Zoj5TJ?nSHV[oY69`oj=RK_nSHF_oX6=ZoiaSJonLHVgoW69^oiiQKonOHVkoWf9]oieR
KOnLHFkoUfE]oiQUJ_nJHV[oWf5Zoj1PJ_nOGf[oXeiXoj9KKOnTEgCo]WTiok^18OnhP2D3okV09@;o
^80U00ko]h0TokJ19?ngP2Go]h0UokF19?ngPBGo^glWok]n:?nkObOo^glVokim:?noO2Wo_W`Yokin
:0;o_gdX01So_WhXokb0:?nlObOo^7lXok:19?nbQB3o/8dKojVI3onUXPOoXZD3oj>V0_nUX`CoXj@4
oj2U2?nOY`koXJLEojFW6onRYaWoWZLDoj6W5onSYQOoYZHIojRV6_nXYQ/2ojRV6P0`ojRU6_nXYQ_o
YZLJojFV6OnTYQWoYZHKoi6T4On;WPSoU:D=ok6T6oo1WR?o^YlNokbO7onlX23o_:4OokbQ8?o4WbCo
aJ0TolJO8oo1X1oo]ZLZok^U<onjYC?o]jHcojfW<_nFZBWoR9/Eohf=3_n<Sa7oSI0Aoh^@4On<TA7o
Ri0@ohf=3onDSPkoN[8Qofk><_mYbROoILLRofC78_mQab?oG/TUoec99OmGbb;oPkLWojRR8_nRYRGo
XjHW0_nTYRH01?nTYBKoXZLXoj:W:?o?P@`6onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_000AonA_0003onA^0?oTK`3oi6l000?oi6l000Goi6h0onA_
0?oTK`3oi6l0on=^000DonA_0004onA^0?oTK`3oi6l0onA^00Coi6l000?oi6h0onA_0?oTK`002?oT
K`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000ooi6l000?oi6h0onA_0?oTK`001ooT
K`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooT
K`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l0017oi6l000?oi6h0onA_0?oTK`000ooT
K`001OoTKP3oi6l0onA_0?oTK`3ohfh001Coi6l000Coi6h0onA_0?oTK`3oi6h01?oTK`001?oTKP3o
i6l0onA_0?oTKP04onA_0000<OoTK`000ooSKP3oi6l0onA_000:onA_0003onA^0?oTK`3oi6l000Ko
i6l000?oi6h0onA_0?oTK`002_oTK`000ooUL03oi6l0onA_0004onA_0004onA^0?oTK`3oi6l0onA^
00Coi6l000?oi6h0onA_0?oTK`000_oTK`000ooTKP3oi6l0onA_000>onA_0003onE`0?oTK`3oi6l0
00_oi6l000Goi6h0onA_0?oTK`3oi6l0onA^000AonA_0003onA^0?oTK`3oi6l000?oi6l000?oi6h0
onA_0?oTK`001?oTK`000ooTKP3oi6l0onA_000BonA_0006onA^0?oTK`3oi6l0onA^0?oTK`3oi6h0
1?oTK`000ooUL03oi6l0onA_0005onA_0003onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oTK`00
0_oTK`000ooTKP3oi6l0onA_0003onA_0004onA^0?oTK`3oi6l0onA^00;oi6l000?oi6h0onA_0?oT
K`002_oTK`001_oTKP3oi6l0onA_0?oTKP3oi6l0onA^00Coi6l000?oiG00onA_0?oTK`001OoTK`00
0ooTKP3oi6l0onA_0003onA_0003onA^0?oTK`3oi6l000;oi6l000?oi6h0onA_0?oTK`000ooTK`00
1?oTKP3oi6l0onA_0?oTKP02onA_0003onA^0?oTK`3oi6l000;oi6l000Goi6h0onA_0?oTK`3oi6l0
onA^0005onA_000Kon=_0Oo>IAkocf59om9RB_o?HDCocV56olePAoo=H4Soc5m8olaNAoo=GTOocEi6
ol]KAoo;G4WodEm7omMTAOoNJD3ohfhmonMb=ooYMC3ojGL[onUh:OoYN2[ojGP[onUh;OoYMbgojGP]
00;ojGP_00CojGPaonYh=ooZN3_ojWLd0_oYMRl01ooYMBcojGH]onUf;OoYMB_ojGDYon]f?Oo/MU@0
0_o/MU<00oo/MUCok7IBonaeDP02onafD`03onaeE?o/MUCok7EC00?ok7IC0_o/MU805?o/MUGokGMG
on]eCOoWLSOoiW0YonIa:_oWLBgoig0^onMa;_oVLB_oj74donafB?o]Md_okGI;onegBoo]Md[okGI9
onafA_oaLeComF]I0_odKU`01oodKEcom6aOooETF?ogHUkomG5Woo=^FOodKEX00_odKE/0;oodKUko
m6iMooA/G?odKegom6eIooASC?odH4[olf59oo=SB?ocH4Wom5U5ooEI@oogH6GonE^<ooaFV_omCHoo
oT=looi4R_onDJ[ooE_4ooeJaoomF<Soo5W3ooaM__okHkKonfBgoo]M^?okFKConeFmoo]K_OokI:So
o6:;ooeFKoomC5cooE=OooaNKOolGFoooDaGoodb;_on81cooR8ZooT]B?o`>F;ojSiUon`oJ_o`?gKo
mD6100;onDJ60;7omTN8oo97MOod@f_omd9eoo94M_oRBVcoddiJolmAD_oDDEoofdJ8omHo[ooE:[oo
cB>kollP_?o<7kcocb70oldR`Oo87l?oa1_3ol<Ja?o=9lOod2k8olh/`?o>;kcobBW4ol/Tc?o?8Lko
bc6YoldhVoo>>:3ocCRMol/fWOo<=J3obcBSolXcYOo8<Z7oac6WolPdXOo7Af?ob4aAolQ<Coo7AfGo
edBSomi<Z_oJC:?of4RSomToWooE?YKodSfGomDhW?oH=i[oe3RJom<jV?oD?ICocSZJolXnU_o5Ah3o
_E=RolEHF_oJAW7ohCemomdjL_oL>W3of3ecomHlMOoF@FoocdYSomPnN?oN>ggoj4=`oo11L?oa?W3o
lD5Zoo55J?oaB6_olDQ/oo17Joo`B6WolDU_oo5<L?oaBfoolDUcoo56NOo_@X;olDEmonA3N_oF@G_o
g4>0om]3SooOAY;oiDNAomi2TooI?iKogd>Gon=2U?oM?i_ofS^Oolm@U_n9M97oWVfCoj5[U?nKKY7o
V6jBoj9bTonQLICoW6^FojMXV?nSL9_oTWfJoin5SOoGGK;onEO6ooUM`oohGKoon5jnonQW/_n/ViSo
XJZDojJKU?nVUY7oZ9nCojR`TonX[hgoZJV;ojVYR?nYZXKoYjf9ojN]R?nV[HWoZ:Z6ojRVQonWXhOo
Yj>1ojRVP_nXYhOoZ:B8ojRRQOnWWX;oYiImoij4NonEL7goTFAmoiETN?nHJGCoVVecoi]_L_nNLg3o
WG9aoie`LOnMKW3oVf]`oj1WK?nSHfcoYF5`oj=QK_nRHVkoWf9]oiiRK?nMHf_oWV9/oieRKonNHVgo
Wf9[oimRK?nLI6coUVE[oiQUJ_nNHfWoWV9ZoieTJ_nNI6WoX6=Woi]LLOn[K5Go^h8Sok^08onkObH0
0_nlORL0:OnnORSo_GhWol1m:Oo2O2Wo`GdZokan9oo1O2So`g/Zol1m:_niP2Ko]H8SokJ38onbQ27o
/8HPoj^97onWRQgoYhLNoj>:6onMSAOoV90Eoi:D5On=UACoSIh9oj2T1onUYPOoXJH2oj:V0onRYPCo
XZL5oj:V1?nSYP?oXZH3oj>T1?nOY@GoWZL;okbX:onkYR_oZJLNojFW7?nSYQSoX:HE00;oWjHE02So
XJHFojBV6?nUYQSoY:HGojFV5onWYQ[oXjPJohjW5?n;XaGoRj@Aoi2V4on^Yaoo`J8Uol2P8onhXAko
]J8MokNR7_n^XaSoYj@Doj:T5OnQXQCoVilGoiVW:OnIYR[oUZDXoiFV:_n?ZBcoR:8Poh^@3on=R`_o
S8h>ohf@4?n=Sa3oRY0AohZC4_nBTQ7oO:XIofO=:_mXbRSoHLPR0_mOb2D01omOb2CoHLLSoe[:8_mQ
ab?oUj`TojJT8_nRYbL00onTYRH00onRYbSoY:DVolj13@1monA_0003onE`0?oTK`3oi6l000_oi6l0
00Goi6h0onA_0?oTK`3oi6l0onA^000AonA_0003onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oT
K`001?oTK`000ooTKP3oi6l0onA_001PonA_0003onE`0?oTK`3oi6l000_oi6l000Goi6h0onA_0?oT
K`3oi6l0onA^000AonA_0003onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oTK`001?oTK`000ooT
KP3oi6l0onA_0006onA_00000ooTK`02onA^01Soi6l000?oi6h0onA_0?oTKP000ooTK`001OoTKP3o
i6l0onA_0?oTK`3oi6h000_oi6l000?oi6h0onA_0?oTK`00EOoTK`000ooTKP3oi6l0onA_0004onA_
0003onA^0?oTK`3oi6l000Coi6l000Coi6h0onA_0?oTK`3oi6h00ooTK`001OoTKP3oi6l0onA^0?oT
K`3oi6h000?oi6l000?oi6h0onA_0?oTK`000ooTK`000ooTKP3oi6l0onA_0004onA_0004onA^0?oT
K`3oi6l0onA^01koi6l000?oi6h0onA_0?oTK`000ooTK`000ooTKP3oi6l0onA_000;onA_0004onA^
0?oTK`3oi6l0onA^01koi6l000?oi6h0onA_0?oTK`000ooTK`000ooTKP3oi6l0onA_000AonA_0003
onA^0?oTK`3oi6l000?oi6l001Coe6PBolaP@_oCHDgocf96oliQA_o;GdOobUi7olULB?o9FdOocEe8
om9NB?oEHDGofVI3on=[?_oWLCOoj7D]onUg:_oYMbgojGTZonUh:@?ojGP]00cojGL/onUg:ooYN2ko
jGP_onUg;_oYMc3ojWLionYh>?oYMS3ojGD/onUf<?oYMRl2onUe;007onUe:_oXMBOojWDjonafD_o/
MUGok7IBonafD`03onafDP03onafDoo/MU;ok7IC00Cok7IC00Wok7IBonafDoo]MeSok7IFonYdA_oW
LC7oiW0ZonIa;?oWLBh00ooWLBd00ooVLBcoiW0ZonUc?@02onegB`3UonegB_o]Md_okGI<onefBOo`
LeGomFYJooA]FOodKE_om6iLooA/FooeHEWomf=PooEaIOocKE[om6eLooA^G?odKUgom6mMoo=`F_oc
LE[om75KooAXD?odGdOom5i<ooANCooeGEKomU=JooM:C_ohD5WonUN8ooaCY_onBi_ooT64oom0ROon
CJCooE_4ooaKaOolGKkoo62koo]U]?okJ;7onfJeoo]M]ookEkKoneNnoo]M^_olHikooEahooe@Goom
CU[oo5MVooaML?olEFCooD56ooh`:?on927onbDfooDdGoo_@7[okdB1ooA4Q?oj@XWonDJ:ooA9O_o_
BG?ok4M/one9LooeB7oon4N0on]:MooLDFCoeDmGomIAK?oLB9Koe3j_om4d`_o=9/7ocB>kollR_?o?
8kkocR:nolTMa?o36LKoaA[5olPL`oo;7/;odBS2om4_a_o?;/;obb_4olXZ]_o?;jKodBC8ol`[]oo<
=igocCNPolXdX?o;=:7oc3BTolXdX_o6<Ykoac6TolXbZ?o4?g[ob4e?olQ;EOo7BUOoadaColY4O?oM
AJWofdJWomU1WooG?iOoe3fGom8mUooD?IWofSRMom@gW?oE>i[ofCnEom`kX?oJ?:;odDj6okY/D_n`
NSgo`6UGomU4MOoAAf_obDiTolQAFoo3EDko_EM5okmHAOo?DU;odT]KomA@D_oLDEOoj4AYoo4mLOoa
?fgolDI/oo58K?oaAf[ol4QZoo18KOoaBfoolDa_oo55Moo`@7kokD9noo18N?oPAg?odD5iomY4M_oJ
@X3ohTBDonU6U?oN@iGoeCfHoma1U?oO@i?ofD2Jom4mW?oXBXooZ6NFohmcT_nNJY7oXVZDoj1WUonN
KI;oXg6Doim_U?nOKICoX6fGoi1eXonFVYOo_HnNonIS/OoaGk?okF>bonmU[_oaHjWo`X6Foj6hUOnV
]YGoYZj@ojJbTonV]iOoY[>AojN]SOnZZ8_oZZF9ojZVR?nYZHSoYj^;ojJ]RonWZh[oZJJ:ojVTQonY
Y8?oZJJ3ojVPQ?nWVh;oYiV1ojNLP_nWWh?oY9F1oiYoP_nAJh?oTV=loiESM_nFIgCoVFYboi]^LOnL
LG;oW7=boiY`M?nLL7?oW6]aoj1VLOnSHfooXf5^oj5QK_nNHF_oWem/oieQK?nLHFcoW69^oiaQKP02
oimQK00>oiURK?nGHf[oVem[oj=MJ_nSGFWoXEeZoj9NJ_nQFfkoXe]_okEl=_niQ23o^X4Vok^09onj
P2D2okV19P0Gok>28on]QQooYH/Koj>;6_nOT1SoWI4HoiR@5onHT1GoUHhEoiB>5?n@TQ3oSY@?ohfD
3on;U0ooRY8?oh^A3on;T13oRY0BohVG3OnAX0CoWJL1ojJV1OnTYP@00_nTYPD00onSYPGoXjH4oj>V
1002oj>V100moj>V1OnTY0CoX:H2okbU7ooXWDKoh9dmomVS=oo?XSCo`J<]okNU9_n_YR3oZ:HLoj>W
6OnOYQCoW:HBoinW5_nSYaSoUJH@ohbV3on<YQ?oS:HEohbV5?n?YaSoWZTRoi^W8?nCYaSoSZ8FohnG
5?n:UA3oRY8?oh^B4?n;TQ7oRhlAohNK7On8Z2SoRJ@Uoh^R8on<XRGoRj0QohbG5On<S0_oS8L8ohf9
2on;SPkoRY@AohZI4on@UQ?oRYdDofS38omOcbcoG/PUoeo89?mPb2CoHLLSof388omOb2?oEl/QogFm
9OnRYR?oYJ@Toj>V9`02ojBV9P03oj6X:?nUYBKocH8=08ooi6l000?oi6h0onA_0?oTK`001?oTK`00
0ooTKP3oi6l0onA_0004onA_0004onA^0?oTK`3oi6l0onA^00?oi6l000Goi6h0onA_0?oTKP3oi6l0
onA^0003onA_0003onA^0?oTK`3oi6l007Coi6l000?oi6h0onA_0?oTK`001?oTK`000ooTKP3oi6l0
onA_0004onA_0004onA^0?oTK`3oi6l0onA^00?oi6l000Goi6h0onA_0?oTKP3oi6l0onA^0003onA_
0003onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oTK`000_oTK`0000?oi6l00_oTKP04onA_0003
onA^0?oTK`3oi6l000Soi6l000Coi6h0onA_0?oTK`3ohfh01_oTK`000ooTKP3ohfh0onA^0009onA_
0003onE`0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`002ooTK`001?oTKP3oi6l0onA^0?oSKP0>
onA_0003onA^0?oTK`3oi6l000Ooi6l000Goi6h0onA_0?oTK`3oi6l0onA^0003onA_0003onA^0?oT
K`3oi6l000?oi6l000?oi6h0onA_0?oTK`001?oTK`000ooTKP3oi6l0onA_000<onA_0003onE`0?oT
K`3oi6l000Coi6l000Goi6h0onA_0?oTK`3oi6l0onA^0002onA_0005onA^0?oTK`3oi6l0onA_0?oT
KP003_oTK`000ooTKP3oi6l0onA_0009onA_0003onE`0?oTK`3oi6l000Coi6l000?oi6h0onA_0?oT
K`001?oTK`000ooTKP3oi6l0onA^0005onA_0003onA^0?oTK`3oi6h000coi6l00_oTKP0>onA_0003
onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oTKP001_oTK`000ooTKP3oi6l0onA^0005onA_0003
onA^0?oTK`3oi6h000coi6l00_oTKP0>onA_0003onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oT
K`000_oTK`001OoTKP3oi6l0onA_0?oTK`3oi6h000;oi6l000kogf`7olQP=oo=GeCoaei8olAJBoo5
FD_ob5Y:oleMB?oDH4Kog6E4on5/?_oVL3Soj7@bonUg;@;oj7PY00CojGTYonUi;?oYN2kojGL/0_oY
N2d03OoYN2cojGL/onUh;OoYN2kojGP`onUg;_oYMc3ojWPgonYg=OoZMbgojGDZonUe;_oYMS000_oY
MRd02ooYMBcoj7DXonUe;Oo/MTkok7EGonafDOo/MU;ok7IDonaeD_o/MU;ok7EB00Gok7IB00_ok7EB
onafD_o/ME;okGMGonafDooYLcgoig4[onI`:OoWLBgoig4_onMa;@04onMa;P0ConI`:ooWL2ook7I6
onehBoo]MdWokGM:onegBoo]MTWokgEDooA]FoodJe_om6eIooA^FoodKE_omV1HooMTH_odLF;olfmJ
ooA`G002ooA`G@0>ooA_G?odKUgomFaQooEUH?ofF5Oome9JooMAHOohDV[onDY_ooToG_oiA5OonTml
ooaCZOonCJP2ooi1R00nooi:WOomG;Coo6:ooo]R^?okIK?onfNcoo]Y]?olI;Oone^eooYH]OojFKco
nejaooeMQ_omEFSooDeIooe@FoolF6Soo5MZooe7EOon<c;ooRHLood]<_ol>5conCajooE:SoogBi;o
nDR8ooA5OOo^AWGojDY]onM8JOoYBW3olDj5ooY<U?o`C7kogE5NomMDIOoFBWKog4>OomHk^Oo:>L7o
ac33ol/ZaOoD:L7odbW0om0U`Oo?9/3obB;3olHLaOo66lOobao4ol/Q`?o=8Kkod2K0om0]aoo<;<Go
bbRkold^X_o?<iOocRZcom4Y_oo==Z42ol/eXP2Jol`eX_o8=:3oaSBLolLcWOo;<JgoaSR@olM:Eoo8
C57oadYGolQ9Eoo8C5CoaDYJol`mP?oI=i3og3FEomPlVooG?Ioof3jPomTnWooI>J3odcBOomHkVOoF
@9;oeT6Dom=1V_o0B6ko/5/hok1O;onkFDkobeILol9IBOnoFSgoa5dgolAN=oo0G3So`EQ0om5=EOoB
AF;od4iHomAGCOoDD5Goh4UQona1K_oa@W3olDM]oo57J_oaB6SolDQ[oo59LOoaAg?ol4Efoo12O?o_
@Wkol4Ihon=6MOoD?ggofd=jomU0NOoN@XKoi4VCom]6TooI@IKohTBFonE4V_oS@IooecjSooA8UOoD
DIWoU6bGoie^TonPKY?oWV^FoiU^U_nINYCoWXJDoib8UOnJOY3oUgbIoi6>YOnK^i7o[ib<omAWVOoO
I9_og6RKon9VV_oJIiGo[YbBoj:lVOnW/YCoY[:GojJbVOnV/IWoYZjFojNXT_nWY8koYj6;ojRNR_nX
XHcoZ:B<ojJSSOnWY8ooYj:>ojRNRonYXHOoZZ68ojNMROnUUhGoY9>3ojBGQOnTVXOoXYZ9oifAROnD
OX_oTFj5oi9XO_nDHWSoTfAfoiMZMOnHKGKoV6]goiI[NOnGK7WoUVUhoi]WMOnMI7GoWf9doiaSLOnJ
Gg?oW5e`oi]NKOnJGFooVee`oieJL?nQFG3oWE]aoiENLOnHGg3oVUacoiUKL_nGGg3oV6Aaoim[MOnJ
J83oVWmGoiVF5_nITaKoU9DFohjI4_n?V17oSiDBohjC4_n=Ta7oRi8@ohf?40;oS98?00ooSI4?ohfB
3on;TA3oRhl?ohf?3on<Sa3oSHh@ohf>3on<SQ3oRh`AohZ?4On;V@_oVZ<3ojBW0_nVYPD00_nSYPD2
ojBV1@03ojBU1OnSYPCoXjH400?oXjH403;oXjH5oj:V0onTYPCobilXonnBB_o^TT?okY=1onZG@_oV
WT3ohZ4momfQ>?oBXC?oaJ8^okbT:_ngYROoXJHIohjV3_n>YQ3oS:H?ohfV3on=YQ3oSJHAohZX5On8
Z1_oSj0LohjQ6on<Wa[oRiXHoh^D5on8TQKoQi0DohR<4On8S1?oRY/PohfQ9?n<XR;oSJ8Roh^O7_n=
W1SoSI/EohfB3?n;SPSoRi4;oh^C3On<U0koRiDBoi2B5?mc/1koF]0Zof399@;oHLLS00goH<PSof37
8omPab?oGLTRoek88on=/RGoZ:8Roj:W9onSYROoY:DVoj2Y:OnTYBKoch0<00Woi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000coi6l000?oiG00onA_
0?oTK`001?oTK`001OoTKP3oi6l0onA_0?oTK`3oi6h000;oi6l000Goi6h0onA_0?oTK`3oi6l0onA^
000>onA_0003onA^0?oTK`3oi6l000Woi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Goi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`003?oTK`000ooUL03oi6l0onA_
0004onA_0005onA^0?oTK`3oi6l0onA_0?oTKP000_oTK`001OoTKP3oi6l0onA_0?oTK`3oi6h000ko
i6l000?oi6h0onA_0?oTK`002OoTK`000ooUL03oi6l0onA_0001onA_000000?oi6l0onA^0?oTK`00
0_oTK`001OoTKP3oi6l0onA_0?oTK`3oi6h000?oi6l000Coi6h0onA_0?oTK`3oi6h01OoTK`000ooT
KP3oi6l0onA_000:onA_0003onA^0?oTK`3oi6l000Woi6l000?oi6h0onA_0?oTK`003?oTK`000ooT
KP3oi6l0onA_000;onA_0003onA^0?oTK`3oi6h001?oi6l000?oi6h0onA_0?oTK`003OoTK`000ooT
KP3oi6l0onA_000DonA_0003onA^0?oTK`3oi6l000Coi6l000?oiG00onA_0?oTK`001OoTK`000ooT
KP3oi6l0onA_0008onA_0003onA^0?oTK`3oi6l000Koi6l000Goi6h0onA_0?oTK`3oi6l0onA^000:
onA_0003onE`0?oTK`3oi6l000;oi6l000Coi6h0onA_0?oTK`3oi6h01_oTK`000ooTKP3oi6l0onA_
0009onA_0003onA^0?oTK`3oi6l000coi6l000Coi6h0onA_0?oTK`3oiG002?oTK`000ooUL03oi6l0
onA_0002onA_0004onA^0?oTK`3oi6l0onA^00Koi6l000?oi6h0onA_0?oTK`002OoTK`000ooTKP3o
i6l0onA_000<onA_0004onA^0?oTK`3oi6l0onE`00Koi6l000?oi6h0onA_0?oTK`000ooTK`003?oR
KP;oaf8WolEJF?o6FU7obEY;oliMBooFHTOogfM3onA_>_oWLc;ojGD]onUh:P;oj7PW00?ojGPZonUh
:ooYN2d00_oYN2h01_oYN2gojGH[onUg:ooYMb_ojGL/onUg;P;ojGL_00CojGL]onUg<OoZMcSojWLd
0_oYMR`00ooYMBkojGH_onUf;P02onUf;@07onQe9ooYMR_ojgI5onafF?o/MUCok7IConegE002onaf
D`03onafD_o/MUCok7EC00;ok7IC00_ok7EBonafDoo/MU;ok7IEonegEoo[MDgoj78fonI`:_oVLBWo
ig4]onMa;P05onMa;@;oig4^0?KoiW0ZonUa>?o]Md_okGM:onegB?o]MTSok7I5onmeD?odKEWom6aL
ooA^G?odL5_olfmIooIPE?ogIFCom7=SooA_G_oeKF?omFUUooIWJOogHVkon5maooQJL?oiCVSonDMW
ooU:KOoiCg?onD]dooQ0J_oi@5SonTajooaDYOonD:oooTJAooi2R_onBYGooEfYoo]V^?ojIK?onfJ_
oo]W/ookJ;Conf>doo]M/OojFKSonUZhooaLXOomEWKooTaJooe8DoomC5[oo5=Wooe=H?on>T3ooR`V
ood]:_ol=dCondM_oo]?S_ohC8goldb3oni;MOoVBf_oh4]Von=;JOo/BWKom4^9ooY=T_ogCHSoi4eT
omY>HooHAhSoddB[om0i^oo;>;oob3NnolD``Oo::/3odBZmom8Z_ooA9/GocBO1olXT`_o98/GocR?5
ollSaOo?9/7od2Nnom0V_oo@9lSodS78ol`^^Oo;;Z;ocS6MollaW_o?<:7od2bcolheY_o<=Z;obcJP
olHcWoo6<igoacBMolXcYOo8=:?oaD9]olQ=Coo7BUOob4YGolQ:F?o7BEWo`dYDolA8Eoo:@FOoccUk
ol`jR_o:?HWobC^7olHkP_o1>gco_SYgokloKoo1@V_oaT=aol54KongDS7oaf0Bol5K7Oo6Ed[obV1:
olIN?Oo4G3koaEdmolEN?_o3GScob5U3omM=F?oA@fKodDUOomMED?oBEDood5=?omA@EOoPB6Cok4M^
oo17JooaAF_olD5_oo8oNOoa@gWolD9joo8mOooa>X?olD=honA2NOoG?Wkofd1lomQ0NOoLA7SohdJ5
omi1S_oG@93ofdJAomU7Soo@A97oaTF>omQ@N_o?DG7oV6:;oiF3UOnLOHgoW86=oiMfT_nJO93oWXVA
oij>UOnIQIGoVWnDohm_XonBUZ3oVLN=ojZMRoo=J9Cogf:KomeYV_oVIYSobGB?oin`TonU_9OoZ;2C
ojJbUonV]9_oY[BJojJbU_nV[XkoYZb?ojRXRonXY8[oZjB:ojRSS?nVYHgoYZN<ojNSRonYXHSoZj68
ojVQROnXX8SoYi^6ojJFQOnTTXGoXY:8ojBGR?nRUHOoVHf=oiB2SOnENhCoUW=koiI[MOnDIWKoUFEf
oiAVN?nEJGOoUVefoiMZN?nHJgWoVfahoiYZN?nEJgSoVFMeoiQTM?nJI7CoVV=coi5bM_n@OWKoTGeh
oi2:N_n;UW_oRI=koh^AOOn5V7koPYj0ohNTO_n8XXCoO:AeogbS7_n?U0`2oh^E4006oh^D4On<Ta3o
S98Aoh^A4On=Sa3oSHh@0_n<SA07ohf=400:ohb<4On;S1;oRI<?oi2N1_nOYP;oYjH2oj6W0onOY`?o
X:L3oj:V10;oXjH51onSYP@01onTYPGoX:H2ojFU1_oBWc3okiI:onjH@_o_Vd<00_o_Vd80:?o^Ud;o
kY=2onfC@oo[UT;oh:A1okRW;On[YRCoYZLToj2W8?nJYa_oUJHFoi6V4on>YQ7oQjTEohVW7?n>XAco
S:<Loh^S7?n;Y1coR:@MohJP6on7VaSoRi8BohRG5_n;Y2?oSjDUoiJV9onGYB?oVJDOoj>W9OnTYR;o
UJ0DohbG3?n;TPWoRi0;oh^@4On@S1KoRIHGoeg58_mIcBH5of778`0:of388omKbR?oKL4ToinW8onW
XbCoXjHWojBV9_nPZBSoXJLXolj13@Soi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l001Coi6l000?oi6h0onA_0?oTK`001?oTK`000ooUL03oi6l0onA_
0005onA_0003onA^0?oTK`3oi6l000Soi6l000?oi6h0onA_0?oTK`001_oTK`000ooTKP3oi6l0onA^
0009onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001OoTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0onA_
000DonA_0003onA^0?oTK`3oi6l000Coi6l000?oiG00onA_0?oTK`001OoTK`000ooTKP3oi6l0onA_
0008onA_0003onA^0?oTK`3oi6l000Koi6l000Goi6h0onA_0?oTK`3oi6l0onA^0002onA_00002?oT
K`000ooTKP3oi6l0onA_0005onA_0003onE`0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oTK`000_oT
K`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000Goi6h0onA_0?oTK`3oi6l0
onA^0008onA_0003onA^0?oTK`3oi6l000_oi6l000?oi6h0onA_0?oTK`001ooTK`000ooTKP3oi6l0
onA_0004onA_0005onA^0?oTK`3oi6l0onA_0?oTKP000_oTK`000ooTKP3oi6l0onA_000;onA_0003
onA^0?oTK`3oi6l000[oi6l00_oTKP000ooTK`3oiG00onA_0002onA_0003onA^0?oTK`3oi6l000go
i6l000?oiG00onA^0?oTK`001ooTK`000ooTKP3oi6l0onA_0002onA_0003onE`0?oTK`3oi6l000[o
i6l000?oi6h0onA_0?oTK`005?oTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Go
i6l000?oi6h0onA_0?oTK`008OoTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Go
i6l000?oi6h0onA_0?oTK`006OoTK`00;ooBIQWoaea8omUTDOoMJD7oi6dmonQc=OoXMBgojGL[onQh
:?oXNBWojGTZonUh:_oYN2_ojGP/onUh;OoYMbgojGL/onUh;_oYN2gojGL[onYh:ooYN2gojGP`onUg
<?oYMbgojGH/onUg;_oZN3CojWPgonYg<_oYMR_ojGH/onUf;_oYMBkojGH_onUe;?oYMRkojGH/onQe
9_oZMSgok7IGonafE_o/MU;ok7IDonafEOo/MU?ok7IB00?ok7ID00[ok7IConafD_o/MU?ok7IConaf
Eoo/MUKojW=6onMa<OoVL2[oig4/0_oWLBh2onMa;`03onMa;_oWLBgoig0]00?oig4^0_oVLB`0MOo[
M4?okWQ<onefB?o]MdOok7M2onigB_ocKeKom6eIooA]F_odKEcomF]PooQKH?ojHWComfYiooQPLooh
G7GonEUhooUFN?oiEG[onEMlooUBLoojAfWonDMZooU=L?ohCG?on4AYooPoHOolB7coo5>SooeBZ_on
BY_ooTJ<ooi:T_omFIgonfNaooYV/ookIZkonfRboo]Y/ookHK7oneVcooYF^?okEkCoo5FAooi=I_on
AE?ooDMHooe=GoolCF3ooD=@oohe=oom;B_oo3DlooY5GOojBW3onDj2oo5?Q?oUCg;ogTiXomm<I_oR
C6ook4amooM<SOokDI;onU26ona;N?oKCGOoeSnAom<h/_o=<[oo`C:folLe^oo8=L7obC32ol/Y_oo?
9k_ocbVlolXW_oo:9L3oabG2olPS`Oo=9[kocBK0ol`X_Oo=:;gocBVool`/_OoB;[SoecNaolddZ_o<
=Ikod3NRom0cY_o><iooac:EolHcW_o7=:;oaS:NolDbW?o6<igobC>SolXbZ?o4?8;oadYEolM;E?o8
BUOob4YHolE9F?o3B5Oo`dQFol=:D_o3BU7o`TQFol57FOnoB5Ko_dQDol1:D002oke9DP21oki9Doo2
B5So`dQFokY:AonmF1ooaElCokeI8?njDSco^U@iok]F=OnmECco`UXool=K?oo1G3gocUY8on1CF_oE
B6KodDAYomQBF_oHEeCoeUEDom5ED_o@DeCoeTmMomm?GooVBVKojd9`onY2LOoXBFooiTU]on=6KooR
A77oiTaZom=@Hoo2B6WoaD]XolA:J?o:CVOobDmUol5>I_niC6Wo_U5UokiEG_ncD6Go]E1VolAJE_o8
Fd_o/E]Woi>8T_nLPXgoVgj;oiAcTonDKYCoUWVDoib5U?nKR9KoVhJBoiIfV?n:J:KoU:JKoiK:QOnT
W8KocfJEonMUVooWJYWohfFFokVBS_nQaIKoY[ZDojJgT?nV]iKoY[NJojJhV?nU]Y;oY[F>ojJdSonU
/HkoZJb9ojVXR?nZYHOoZ:N:ojJXRonWYH[oZJB9ojZSROnYXhWoZ9n9ojJLROnUUhOoY926oj>AQonS
T8GoWhn9oiV<S_nJSHkoVhj:oif8POnJOWgoUgAjoiM_N?nHK7GoV6YboiUZMOnKK7;oW6iaoi]^MOnM
LWGoW7Idoi]aMOnMLG?oWG5doiF=NOn2/g_oP;9hohF_O?mn]7[oO[9coh:bN?n5/WcoQK1mohJ^OOn5
[WgoQ:j7ogfU@on@T`_oT90@ohfB4On=TA7oS98A00;oRi8B0_n<TA42oh^@4@0Doh^?4?n<SA3oSHd@
ohf=4?n=S@ooSHd@ohb<4_n:Sa;oRiP:oiJS1?nSYP7oYZD2oj6V0_nPY`?oXJH4oj:V1?nQYPCoWjP4
oj6V0onRYP@6oj>V100Joj>U1?nSYPCoWjH0ojRW2OoJXCSokiU9onfO@?o/WcookIi0onfL@Oo^VD;o
kYA2onjH@_oBYS[o_jHaol6W=?o0YcOo_JLdokVW<oneYboo/JL/oj^W9onVZBGoT[4XohRV7on;XQ`2
ohVU700Hoh^T7?n;YAcoRj<KohbQ6_nCYbCoXjP^oj^V<On_YS?o[JL_ojjW:?ndYRWo]:H[ojnU9_nP
YQgoTZ4Aoh^F3On<SQ;oSXXEoi>:5?mdYQ_oDm0Uoec:9OmPab?oH/LS0omQab<02OmMbB?oFlXSoh:g
8onWXR7oYJDVojBU9onQZ2SoXZLWom5o2`06onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_
0?oTK`001ooTK`000ooTKP3oi6l0onA_000:onA_00;oi6h000?oi6l0onE`0?oTK`000_oTK`000ooT
KP3oi6l0onA_000=onA_0003onE`0?oTKP3oi6l000Ooi6l000?oi6h0onA_0?oTK`000_oTK`000ooU
L03oi6l0onA_000@onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`003ooTK`000ooT
KP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`001ooTK`000ooT
KP3oi6l0onA_0007onA_0003onA^0?oTK`3oi6l000Ooi6l000?oi6h0onA_0?oTK`002_oTK`02onA^
0003onA_0?oUL03oi6l000;oi6l000?oi6h0onA_0?oTK`003OoTK`000ooUL03oi6h0onA_0007onA_
0003onA^0?oTK`3oi6l000;oi6l000?oiG00onA_0?oTK`002_oTK`01onA^007oi6l00OoTK`000003
onA_0?oTKP3oi6l000Coi6l000?oiG00onA_0?oTK`003?oTK`000ooTKP3oi6l0onA_0009onA_0003
onA^0?oTK`3oi6l000[oi6l00_oTKP0<onA_0003onE_0?oTK`3oi6l0013oi6l000?oi6h0onA_0?oT
K`00@?oTK`000ooTKP3oi6l0onA_0006onA_0003onA^0?oTK`3oi6l000;oi6l000?oi6h0onA_0?oT
K`001_oTK`000ooTKP3oi6l0onA^0009onA_0003onA^0?oTK`3oi6l000Koi6l000?oi6h0onA_0?oT
K`001ooTK`000ooTKP3oi6l0onA_0003onA_0003onA^0?oTK`3oi6l000;oi6l000?oi6h0onA_0?oT
K`002ooTK`000ooTKP3oi6l0onA_0003onA_0003onA^0?oTK`3oi6l0017oi6l000?oi6h0onA_0?oT
KP001_oTK`000ooTKP3oi6l0onA^0002onA_0003onA^0?oTK`3oi6l000?oi6l000?oi6h0onA_0?oT
K`004?oTK`000ooTKP3oi6l0onA_0004onA_000:onE^2ooSK3goj6m@onUe<?oXMRCoj7LUonQh:OoY
N2[ojGPYonUh:`CojGL/00?ojGP/onUh;OoYMb`00ooYMb`05_oYN2gojGP_onUh<?oYMbgojGL/onUf
;?oYMRkojWLdonYh=_oYMRoojGHZonUf:ooYMRgojGD/onUe;_oYMRgojGD[onUf;OoYM2WojGHconaf
DOo/MUH2onafDP03onafE?o/MU?ok7ID00;ok7IC0oo/MU802Oo/MU?ok7IDonafE_o/MU7ojG<monI`
:_oVL2Woig4^onQb;P02onMa;@;oig4^0>coig4]onM`;OoWLBkoig4^onMa;OoWLBooig4^onI`:_oW
LC;okGM8oneiAOo/MdGokGE8onmdE?oeJEoomf5VooMPJoohGWConEUgoo]BLoolFX?onE^3ooUGO?oi
Eg_onEMmooUGNooiFG_onEQhooU?KOoiAfCon4UWooQ<LOoiA7;onS][oo]2MoolDICoo5FMooe@WOon
B8oooTR:ooeFU?okI[3onVBdoo]R[_olI;;onfB`oo]L[OokDk;ondnjoo]>ZoomBWcooTMOooi7F_om
C5ooo59Uooe=Foom?dGooS<food_<ook<CconSiLooU<M_o`C6gohTm[omaALOoOCVkoiT]boo19Q?oi
C9;one6Aoo]BROofBh;ohdB?omXm[Oo<=;WobC32olP^_oo3<[[oa36iolDb_oo6;<7obRJnol`W^?o:
:KSoabRjol<T^oo19;[oaBNmolHZ]oo4;;CoaBbgolD[]_o5;;Koa3RZol@iV?o<;Y_od2jQolX`[?o9
<Z7ocC>QoldaY_o<<Z3oa36Dol<^XOo7<j?ob3BNolLcW_o7<j3ob32WolDgU?o6AV3oaT]ColM:F?o8
BUOoaTUGol99EOo3BECo`dQGol=9E_o1BU;o`4Y@ol1:D_o0BEGo`TQGol57FOnlAU[o^TQ@ok];A?nj
CcKo^E@WokiI7?o1FaSo`E`Gol9L6?o1G1Oo_e/DokeJ5_njF1[o^eTLokYH8OnhF27o`eH]omAC?oo<
CDWoa4MBole<D_oCDE;oeU5EomAAEooADE?ocdmEomADDooJEE7ogE9ComYCDooIEU?of5IAomMBDooG
DUGoeeQDolMQBOnbE5;o^EIAokeHCOo1FDko`5U>okaFD_ngEEGo^UMDokQFE_n_CV?o]U5QolAJE_o6
FU?o`EIJoiYXR?n@QI_oUGJBoiAeTonDL9CoUgFBoib3T_nQS9;oWhN?oif0SonAKYcoTWNOoiVdTonC
bWkoY9Z2omAXU?oYIiWojFRIomM`T_nS[Y3oWlFIojJeTonU/iGoYk6IojNbVonW/iKoY[:CojJaT_nU
/I?oYJjCojN]S_nXZ8[oZZB9ojZVR_nXYHcoZ:R:ojR[ROnZYHSoZZ>8ojRSQonYYHCoZYn4ojRIPOnX
Uh3oYiJ0oj>AQ?nNRh[oVHJ>oiZ8S?nPU8SoXY:5oj2;POnMPgkoWWegoiigL_nIKW?oUfUcoiUXL_nL
JWCoVfmfoiYaMP;oWG1c013oWg=coi>BN?n3/G[oPk1lohF/N_mn[7?oPJefohR[Non8ZgSoR:UiohRY
Non9Z8CoPZU_ohJK6onDT0coSI4A0_n<TQ805?n<TQ7oSI8AohfB4On<TQ;oRi<Boh^B4_n=TA7oSI0A
ohb?4On<Sa3oS8dAohZ<4on:TA3oT9d6oj2T0_nWYP;oXjH1oinV0OnPY`?oXJL40_nQYP@01onRYPCo
XZL4oj2W0onPYP?oXJL3oj:V0onSYP<01OnSYP@0?_nRYPGoWZH0ojbV3OoOWccokYU6onfM?Oo]WD3o
kIa1onjK@Oo^VT;ofJ@lokVV;OnkYRgo^jH`okbV<onmYS?o_ZHdokjV=OnoYSCo`jLgoknW=OnG[2[o
OZhQohZU7?n<XQ_oRj<LohfR6on<Xa_oSjLRoj6X;OnaYcCo]JHeokFV=?nbYSGo[jL`ojnW:?n`YbSo
[ZLWok2V9onaYb[o[:LToi^U7_n>W1[oRi8Doi2:4on?SACoIkLOoeC@9_mNb2?oH<LSof778omRab?o
H<PSof389?mKbR?oI<DPoiN[8_nYXR?oXjHWoj6X:?nVY2Godgh:UooTK`000ooTKP3oi6l0onA_0006
onA_0003onA^0?oTK`3oi6l000;oi6l000?oi6h0onA_0?oTK`001_oTK`000ooTKP3oi6l0onA^001j
onA_0003onA^0?oTK`3oi6l000Koi6l000?oi6h0onA_0?oTK`000_oTK`000ooTKP3oi6l0onA_0006
onA_0003onA^0?oTK`3oi6h000Koi6l000000ooUK`7oiG02onE`0P05onE`0P04onE_0OoUL0;oiG02
onE`0P;oiFl100?oiG02onE_0OoUK`400_oUK`42onE`0P04onE_0OoUL0;oiG02onE`0P?oiFl100?o
iG02onE_0OoUK`400ooUL084onE_0@?oiG020_oUK`401?oUL0;oiFl1onE_0OoUL082onE_0@?oiG02
00GoiFl1onE`0_oUK`7oiFl1onE`0P02onE_0@03onE`0_oUK`7oiFl100GoiG020_oUK`401OoUL0;o
iFl1onE`0_oUK`7oiG0200?oiFl11?oUL0800ooUK`7oiG02onE_0@02onE_0@05onE`0_oUK`7oiFl1
onE`0_oUK`401OoUL083onE_0@04onE`0_oUK`7oiFl1onE_0@CoiG0200?oiFl1onE`0_oUK`400_oU
L0801?oUK`7oiG02onE_0OoUL082onE_0@GoiG020_oUK`400ooUL0;oiFl1onE_0@04onE`0P03onE_
0OoUL0;oiG0200OoiG0200?oiFl1onE`0_oUK`400ooUL0801?oUK`7oiG02onE_0OoUL083onE_0@04
onE`0_oUK`7oiG02onE_0@;oiG0200?oiFl1onE`0_oUL0801_oUL082onE_0@;oiG0200?oiFl1onE`
0_oUL0802OoUL083onE_0@CoiG020ooUK`45onE`0P03onE_0OoUL0;oiG0200;oiG0200?oiFl1onE`
0_oUK`400_oUL0801OoUK`7oiG02onE_0OoUL0;oiFl100;oiG020ooUK`401?oUL0;oiFl1onE`0_oU
L082onE_0@KoiG0200?oiFl1onE`0_oUL0800ooUK`400ooUL0;oiFl1onE`0P02onE`0P;oiFl100Oo
iG02onE_0OoUK`7oiG02onE_0OoUL0;oiFl100;oiG021?oUK`43onE`0P05onE_0OoUL0;oiG02onE`
0_oUK`400ooUL082onE_0@04onE`0_oUK`7oiG02onE`0P;oiFl100CoiG02onE_0OoUL0;oiG020_oU
K`45onE`0P04onE_0OoUL0;oiG02onE_0@CoiG0200ooiG07onY`:Oo^MTgokWI:onag??oZN33ojGTZ
onUi;?oZMbgojWP_onYh;_oZN2gojWL/onYh;_oZN2d00_oZMb`02_oZN2oojWTaonYi<?oZN33ojWL_
onYg;_oZMRgojWL^onYf;_oZMc02on]g=P03onYg;ooYMRcojWL^00?ojWH^00SojWH`onYg<?oZMRgo
jGH[onYf<Oo/MT_ok7EGonafE0;ok7IC00Cok7MDonafDoo/MU?okGME0oo/MU<01Oo/Me?okGMGoneg
F?o[MD_oj78g00;oig4[00Woig8^onMb;ooWLRooj74_onMa;_oWLRooig4^onMb;ooWLS000_oWLRl0
4_oXLBooj78`onQb<OoWLRooig0YonUd=Oo^MdcolF]Zoo=GOooeDHOon5IlooYHNOojEX7onUN1ooYD
M_okD6coneYkooUJO@;onEUf063onEYgooUKNOoiG7WonEE^ooU:H_oiBVSonDimoo]8R?oj>gCoo41`
oo]AQ?ojFX[oneVIooi;UOonAHCooE:8oo]QZookHKWoo5f]ooaNZ_okH:goneR]oo]@]_okD;_oo4bN
ooe7K_onAeWooDeMooaCI_olE6GooDQ?oohi??om<cSoo350ooXa@Oog=DOol4APonE=J?oIC5KofTaM
onY;NooeBhOonTb>oo]?UOokDIConDVIonTnW?oF=[CobBk3olD_`Oo7;/3oac6oolTb_oo9<[koaC70
olH[`Oo99[gob2JjolTZ^?o6;;Wo`RFkol8T_?o6:[Ooabfcol<]/_o0:KGo`b^holLe[_o6@9_o`3b>
ol0aRoo9;IKobBRXold//Oo<<:?ocBnSoll`Xoo><:Gob2N^olDV^Oo8<Z?obcFMolXdX_o9<JOoac>Q
olE1Loo8C5;ob4YGolU;FOo7BE[oa4UFolA:Doo4Be?oa4UFolE:F?o3B5T2ol96G`25ol56G?o0BEGo
^d]8okQ?>OnjEBOo`5/Jol=M5?o5GQ;oaElFokmK7OnjEbCo^eXRokeK6onmG1Oo_edFokeK5_o0GQGo
`EhDol1N5?o9GQ[odehQoleK8oo5EbWobUTXoliL9_o@G2CodUhToleH;?o8DScobE15olaABoo<DE;o
c5IFoleCH?o:DFOoae1WolQ@J_o7FFKo/61ToiE:MonSCW3o/59TokUEGonkEUgo_EEHokmFDoo1Ee7o
_eMCokA?H?nmEEkoaeYHol1FGoo1E5co/5=^ohmiV?nEQISoUgZBoiQhT_nKN93oW7f>oj6;S_nSSXko
XH><oiUhTonBKYgoTGjSoi6fT_n?c8?oXIVAom1UW?oVHikoi6>Nok]jV?nP]ISoYKFIojJ^V?nV[iOo
YjjLojR_VOnY/YSoZ:jEojNaTonU/iKoYKBEojJbT?nXZh_oZZ>7ojRNQonWVX?oZJ21ojfLOon]VWoo
[9aooj^NPOn/Xh?o[9f1ojVHP?nZVWooZYYnojJGPonTTXKoWhZ9oif<SOnQUHcoYIJ7oj>CROnTU8Ko
Yi9noij6POnHNh7oW7MhoiU[MOnHJ7OoUVYgoiM[M_nGK7OoVFYdoiY/M_n@SGgoQZj1ohJ/POn5ZGoo
PZj2ohJ[QOn9Z8;oR:R0ohNYP?n9YX;oRYj;ogjR@?nAU@koTI4@oh^C4`03ohjB4P0LohfB4_n<Ta?o
S98BohfC4on=TQ;oSY8AohbC4_n<TAGoRI8EohZI3onDX@GoXZL2ojNV0onTYP?oXZD2oj6V0_nSZ0Go
XjL6oj>W1OnSY`KoXZL5oj>W1OnSYPCoXZL5oj:V1?nPY`CoXJL4oj:W10;oXjL5043oXjH4ojFV1OnT
YPGoXZH4oiZU0On`YQ;oiYm3onnFA_o]Vd3okY]2onnH@_oUXd7o_ZLbokNW;OnmYRoo^jH`ok^W<onk
YS;o^ZLbokVX<onlYS;o_jLdoj:V:On?XAkoQ:PPohB]8On?XQgoSZ<NohjV8?nJZ2Wo[:Lbok>X=_nc
YSKo/ZHdok6V<onaYSCo[jP`ojnX:On`YbSo[ZLWojjV9On`YbSo/ZLYojjW;onVYRgoVZ<SohjJ6OnB
RaCoR9<Gof708_mIcROoGlLToeo89?mQabCoHlLSoeo88omObBCoFL/SogNm8onVY2?oYj@Woj2Z:_nW
XbGodX0=0_oUK`44onE`0P04onE_0OoUL0;oiFl1onE`0P;oiFl11?oUL0801?oUK`7oiG02onE_0OoU
L082onE_0@CoiG0200CoiFl1onE`0_oUK`7oiG020_oUK`44onE`0P04onE_0OoUL0;oiFl1onE`0P;o
iFl11?oUL0801?oUK`7oiG02onE_0OoUL082onE_0@CoiG0200CoiFl1onE`0_oUK`7oiG020_oUK`44
onE`0P04onE_0OoUL0;oiFl1onE`0P;oiFl11?oUL0801?oUK`7oiG02onE_0OoUL082onE_0@CoiG02
00CoiFl1onE`0_oUK`7oiG020_oUK`44onE`0P04onE_0OoUL0;oiFl1onE`0P;oiFl11?oUL0801?oU
K`7oiG02onE_0OoUL082onE_0@CoiG0200CoiFl1onE`0_oUK`7oiG020_oUK`45onE`0P;oiFl100?o
iG02onE_0OoUK`401?oUL0800ooUK`7oiG02onE`0P07onE`0P03onE_0OoUL0;oiFl100?oiG0200Co
iFl1onE`0_oUK`7oiG020ooUK`401?oUL0;oiFl1onE`0_oUK`42onE`0P03onE_0OoUL0;oiG0200Ko
iG020_oUK`42onE`0P04onE_0OoUL0;oiFl1onE_0@CoiG0200CoiFl1onE`0_oUK`7oiG020_oUK`44
onE`0P04onE_0OoUL0;oiFl1onE`0P;oiFl11?oUL0801?oUK`7oiG02onE_0OoUK`44onE`0P04onE_
0OoUL0;oiFl1onE`0P;oiFl11?oUL0801?oUK`7oiG02onE_0OoUL082onE_0@CoiG0200CoiFl1onE`
0_oUK`7oiG020_oUK`44onE`0P04onE_0OoUL0;oiFl1onE`0P;oiFl11?oUL0801?oUK`7oiG02onE_
0OoUL082onE_0@CoiG0200CoiFl1onE`0_oUK`7oiG020_oUK`45onE`0P;oiFl100?oiG02onE_0OoU
K`401?oUL0800ooUK`7oiG02onE`0P07onE`0P03onE_0OoUL0;oiFl100?oiG0200CoiFl1onE`0_oU
K`7oiG020ooUK`401?oUL0;oiFl1onE`0_oUK`42onE`0P03onE_0OoUL0;oiG0200KoiG020_oUK`42
onE`0P03onE_0OoUL0;oiG0200;oiG0200001_oTL0CoiG45onEa1OoUL@GoiG85onIb10;oiG4500So
iG85onIb1?oULPGoiG85onIb1?oULPGoiW44onIb10GoiG8500Soi745onEa1OoVLPCoiW44onIb1?oU
LPGoiG45onEb1@;oiW8400_oiG85onIa1?oVL@CoiW44onEa1OoULPGoiW84onAa1OoULPGoi704onIb
1003onEb1@04onIa1?oULPGoiG85onEb1@;oiW8400OoiG85onIb1?oULPGoiG45onIb1?oUL@GoiW44
00;oiG4500Goi745onEb1OoVLPCoiG45onEb1@04onEa1@;oiG8500?oiW84onEa1OoUL@D00ooULPD0
0ooVL@Coi705onEa1@02onEa1@03onIb1?oULPGoi74500?oiG4500CoiW84onEa1OoULPGoiW440_oU
LPD01OoVLPCoiG85onIb1?oUL@GoiG8500;oiW8400?oi745onEa1OoVLP@00_oUL@D9onEb1@;oiG45
00KoiG85onAa1OoUL@GoiG45onIb1?oUL@D2onEb1@?oiG4500CoiG85onEa1OoULPGoiG850ooUL@D0
1OoVL@CoiG85onIa1?oVLPCoiG4500;oiW841?oUL@D00ooULPGoiG45onIa1002onEb1@04onEa1OoU
LPGoiG85onA`1@;oiG8500goiW84onEa1OoUL@GoiG85onA`1?oTL@GoiG45onAa1OoULPGoi704onEb
1OoUL@GoiG8500;oiG4500KoiG85onIb1?oULPGoiG85onEa1OoVL@@3onEa1@05onEb1OoTL0CoiW44
onEb1OoUL@D00ooULPD01ooTL@GoiG45onEb1OoUL@GoiW84onEa1OoTL@D00_oULPD2onEa1@;oi704
00KoiG45onIb1?oUL@GoiG45onA`1OoUL@D3onEb1@03onEa1OoULPGoiG4500;oiG850_oUL@D02?oU
LPGoiG45onEb1OoULPGoiG45onAa1OoVLPCoiG850_oUL@D2onEb1@03onEa1OoULPGoiG8500CoiG85
00GoiW44onEa1OoUL@GoiG45onIa1002onEb1@;oiG4500?oiW44onIb1?oUL@D00_oUL@D00ooULPGo
iG45onEb1@02onEb1@03onA`1OoUL@GoiG8500;oiG8500CoiG45onEb1OoTL@GoiG450_oULPD01_oV
LPCoiG85onEb1OoULPGoiG45onIb10;oiG4500_oiW44onEb1OoULPGoiW44onEb1OoUL@GoiG85onEa
1OoVLPCoiW44onIb1002onEa1@;oiG8500?oiG45onEb1OoUL@D00ooULPD03ooUL@Goj70OonedB_o_
MTgokWE:onicC?o]MDOojgTlonUi<OoYNRgojWT^onYj<?oZNRoojWX`onUh;`02onYj<00MonYi<?oZ
NS;ojWXconYj<_oZNC;ojWP`onYi;_oZNC3ojWTbonYi=_o[NCWojWPeonYg<?oZMboojgP`onYg<?oY
MS3ojGHaon]g<Oo[Mc;ojWL`onUg;?oYN2kok7Q6onehF_o/N5KokGMFonegF?o/MeH00_o/MeD02oo/
N5GokGMEonegEoo/N5KokGQEonihF_o/MeSojgA5onQc=?oWLbgoig<`00?oig8a0ooXLc82onQb<P3o
onQc<ooWLc;oig8bonMc<ooXLc;oig8conMc<ooXLc;oig<XonQb>OoaHWgomeBOooI=X?ofCYOomeV3
ooYLN?oiFGconE]jooUEK_okDF_onUajooUKN?oiFWOonEUfooUIMoohFgGon5Q_ooU;I_ojAfoondn=
ooa>W?ok@G[ondIVooYENoohG7konEn=ooeBVOon@h7ooDZ0ooaKXOokGKKoo5Z]oo]OY_okH:Woneb]
oo]G]ookD[Koo4b>ooe8H?omCE_ooE9SooaDIOomD5cooD55oodc<ool<3Wonc96ooPbAoo/=SoogT56
om]<FOoMBEWoidAKoo=3LOokBh_one2Boo]BU_ohC9[ojSnWom4a_?o09lKo_2_6olH``Oo9<l7obcC1
olXc`Oo9=;ooaS70olLZ`_o89Koob2FkolPY^_o6;KSo`bNmolDU__o7:k[oaBfdol4X^?o29[WoaS:c
olY1X_o:Ai7o`S^9okh/T_o=;IWoeSFIol`ZZOoC<:gocc6Zolh`Xoo?<JWobbnVol@V/oo38l;oac>T
olTfVoo9<j?ob36YolHjROo7Be_oadaGolQ;Foo5Be_o`dYJol9:F?o2BeOoaDYLolM7Hoo4AfCo`TQO
okm9EonlCTOo_E@eokiI9onnFR7o`5dMol5N6OnoGAco^e`RokMI:OnaFC7o[EdlojeR@onZI4CoZ6@o
ojUT>On[HCKo[60cojiO;onaGB[o^5hTolEM;?oBG37obU`]ol5F<Oo4Ec7o`eT/okmE<?niDSOo[D]5
ojE4E_nT@ekoXDIPoj9;HOnTCf7oWdaYoii;KonNBW3oX4Uboi]BKOn6FW[oLd^EogU8Ton5BHkoS4R;
oha6Son@AH_oWDV2ojE>N_n/Cg3o[Da`okYBJ?o9G5KobEeColQMDOo9Fe3oZVEjoiF<V?nIP9CoVGbC
oiaoTOnMO8ooW82@oj6?T?nLQ9CoSfRKoh]PXOn9GJ?oSG^Woi33Uon9cXSoWYZ;omI_VOo_IIkohfRK
ok:KSonQ`iKoYkVHojJgUOnU]IOoZ:nJojVbVOnW]9OoZ;>CojRcT_nV]YKoYKNDojFfT_nYXXKo[XE`
ok62MOngPW3o^8=ZokJ3JOndPf[o]H5]okB6LOnbRWGo/8Ufojn<N_n`TGcoZi9lojNAO?nSSh?oWXf8
oib@SOnPUI3oXiF=oj:ESOnVUhWoYIN8oin@S?nXV87oYY5moj63NonLMgWoVWIjoiaaMonNLGGoX79e
oiifM?n?UgSoNk=logndO_ml/ggoOZilohNYPOn9Z8CoQj^3ohZZP_n;Wh_oQYidohNL6onAU17oRi@E
00?oSY<D00?oSI@EohfD5?n>Ta@00_n>Ta@03On=U1CoRi8GohZF5_n?X0goVJP7oj:X1onRZ0SoWZT7
oinW1_nPY`KoXJT5oj:X1onTY`P00_nUY`P00onSZ0OoXJP7oj6X1`02oj6W1P03oj6X1_nQY`OoXJP7
00;oX:P6013oXJP7oj:Y1onQZ0GoXZL6oj6W1onLZ0?o^JLLonZMB?o_VDWoki]2onbMA?o8ZCSo]:T^
okfX<OnlZC;o^JXe0_njZ3D03OnjZ3Co^jTfol2X=onYZ2ooS:DQohnO8?n=XR?oPZhWohNY8onEYRKo
YJP`ok>X=oneZ3P00_n`ZCH2ok6W=P04ok6X=on^Z3;o[jPZojnW:@;o[ZPX01[o[jPXojfX:_n[Z3;o
[jLeojnX=OnVZ2ooUj8ToiBD6?mnWQWoG<PSoe_=9_mObBCoGlPToek89OmObBKoG/TVoek:9?mLbR;o
S;<UojfR9_nQZbgoYjDXomAo3_oUL@GoiG85onAa1@;oiG451?oULPD2onEa1@04onEb1OoTL@GoiG45
onEa1@CoiG850_oUL@D01?oULPGoi745onEa1OoUL@D4onEb1@;oiG4500CoiG85onAa1OoUL@GoiG45
1?oULPD2onEa1@04onEb1OoTL@GoiG45onEa1@CoiG850_oUL@D01?oULPGoi745onEa1OoUL@D4onEb
1@;oiG4500CoiG85onAa1OoUL@GoiG451?oULPD2onEa1@04onEb1OoTL@GoiG45onEa1@CoiG850_oU
L@D01?oULPGoi745onEa1OoUL@D4onEb1@;oiG4500CoiG85onAa1OoUL@GoiG451?oULPD2onEa1@04
onEb1OoTL@GoiG45onEa1@CoiG850_oUL@D01?oULPGoi745onEa1OoUL@D4onEb1@;oiG4500KoiG85
onAa1OoUL@GoiG45onIb1?oUL@D2onEb1@?oiG4500CoiG85onEa1OoULPGoiG850ooUL@D01OoVL@Co
iG85onIa1?oVLPCoiG4500;oiW841?oUL@D00ooULPGoiG45onIa1002onEb1@04onEa1OoULPGoiG85
onA`1@;oiG8500goiW84onEa1OoUL@GoiG85onA`1?oTL@GoiG45onAa1OoULPGoi704onEb1OoUL@Go
iG8500;oiG450ooULPD2onEa1@04onEb1OoTL@GoiG45onEa1@CoiG850_oUL@D01?oULPGoi745onEa
1OoUL@D4onEb1@;oiG4500CoiG85onAa1OoUL@GoiG450_oULPD2onEa1@04onEb1OoTL@GoiG45onEa
1@CoiG850_oUL@D01?oULPGoi745onEa1OoUL@D4onEb1@;oiG4500CoiG85onAa1OoUL@GoiG451?oU
LPD2onEa1@04onEb1OoTL@GoiG45onEa1@CoiG850_oUL@D01?oULPGoi745onEa1OoUL@D4onEb1@;o
iG4500CoiG85onAa1OoUL@GoiG451?oULPD2onEa1@06onEb1OoTL@GoiG45onEa1OoVLPCoiG450_oU
LPD3onEa1@04onEb1OoUL@GoiG85onEb1@?oiG4500GoiW44onEb1OoVL@CoiW84onEa1@02onIb10Co
iG4500?oiG85onEa1OoVL@@00_oULPD01?oUL@GoiG85onEb1OoTL0D2onEb1@0=onIb1?oUL@GoiG45
onEb1OoTL0Coi745onEa1OoTL@GoiG85onA`1?oULPGoiG45onEb1@02onEa1@06onEb1OoVLPCoiG85
onEb1OoUL@GoiW440OoUL@D000?oiW@80ooVM@T2onId20;oiWD900?oiW@8onIe2OoVM0P00_oVM@T0
0ooVM0SoiWD9onId2002onIe2@04onId2?oVM@WoiWH9onIe2@CoiW@800?oiWD9onId2?oVM@T00_oV
M@T01?oVM0SoigH8onMf2?oVM@T2onId20;oiWD91?oVM0P2onIe2@06onId2?oVM@SoiWD9onIe2OoV
M@SoiWD91_oVM0P00ooVM@WoiW@8onId2005onId2004onIe2OoVM0SoiWD9onIe2@;oiW@800CoigH8
onId2?oVM0SoiWD80ooVM0P01?oWMPSoiWD9onId2?oVM@P3onId2006onMg2?oVM0SoiWD9onId2?oV
M@WoigH91OoVM0P2onIe2@07onMf2?oVM0SoigH8onId2?oWMPSoiWD9onMf2006onId2003onIe2OoV
M0SoiW@800?oiWD900?oigH9onId2?oVM0P01?oVM0P00ooVM@SoiW@8onId2002onId2003onIe2OoV
M0SoiWD900WoiW@800?oigH8onId2?oVM@P00_oVM0P00ooVM@WoigH9onId2003onId2006onIe2OoW
MPWoigH8onMf2?oVM@WoigH91_oVM0P01?oVM@WoiW@8onIe2OoWMPT2onId2007onIe2OoVM0SoiW@8
onIe2OoVM0SoigH8onIe2@02onId2005onIe2OoVM0SoiW@8onId2?oWMPP00_oVM@T00ooWMPSoiWD9
onIe2@02onIe2@0:onId2?oVM@WoiWD9onIe2OoVM0SoiWD8onId2?oVM@WoiW@8onIe2@;oiWD800Co
iW@8onMf2?oWMPWoiW@80_oVM@T3onId2008onIe2?oWMPSoiW@8onIe2OoVM0SoiWD9onId2?oVM@T3
onId2005onIe2OoWMPWoiW@8onIe2OoVM0P00_oVM@T00ooWMPWoiW@8onId2002onId2003onMf2OoV
M@WoiW@800?oiW@800KoiWD9onId2?oVM0SoiW@8onIe2OoVM0P2onIe2@05onId2?oVM@SoiW@8onId
2?oVM@T00_oVM0P01OoWMPSoiW@8onId2?oVM@WoiWH900;oiWD900OoiW@8onIe2OoVM@WoiW@8onIe
2OoWMPSoiWD900GoiW@800SoiWH9onIe2OoVM0SoiWD8onIe2OoVM0SoigH9onMf20;oiW@800?oiWD9
onId2?oVM0P00_oVM0P04_oVM@WoiW@8onIe2OoVM0Soig@Eonee@oo_NEGokWM:onigCOo_MTookgA>
onieC?o]NDCojg`gonYk;OoZNboojg`conYk<P;ojg`d00Gojgddon]k=Oo[NcKojg`eon]l<`02onYj
<P0Hon]k=?o[NcGojg/hon]k??o[NSKojWX`onYk<oo[NcCojgXcon]j=?oZNS?ojgXdon]j=Oo[NcKo
jWT`onYi;?o[NSookW]IoneiF_o]NEOokGYIonejF_o]NEWokGUG0_o]NUP01_o]NEOokGYHoneiFOo^
NUgokGUGonYf@P;oj7Db0_oXMSD2onQe=@03onUg=_oYMcGoj7Dd00;oj7De017oj7HdonQe=OoXMSKo
j7HdonQe=OoYMcKoj7HdonQe=OoXMS;oj7DfoneSKOoeBYgomUbLooETUOoeH9;on6>8ooYONP02ooUK
NP1WooYDKookDfkonUekooUKMooiFWSonE]hooUJMOoiFGGonTmeoo]7O?okDIConeJNooY:N_ojB5[o
nUAcooUDNoojEWooo5BEooi3QOonBG_oo5bMoo]Q]_okH:_onfFVoo]TZookH;7onURkooaC[_omAgWo
oDIDooe@G_omEFSooEAUooe7D_om>CcooC4hoo/_?ooi<d;ol3M2omlk>_oD>c;og45<onU8J?odAW?o
nTAdooY8L?okD8Wom4fVonI1/?oB=[?o`BjlokLYa?o0<<Koc3G0ol`f_Oo;<l;obcC2olLc`Oo7<L3o
ab_2olPV__o7:K[ob32iolDa^?o2:;go`R71olHW_?o39[go_B6nol0X_?o9?ZGobdfColI6R_o0=Xco
aB^Gom<[Y?oP<ZGofRjWom</Z?oG=:[odC:/old`Y_o;;jcoaRfTol8U]Oo58LgobC2/olTfWoo9<Jco
aSFRolI6Joo9CeOoadeNolE=G?o2Beco`daMolI;H_o6B6Woa4UVol5;F?nlDDOo^eDhokiK:@02ol5O
901NokiN9OniG2_o/eTaojmI=On_GSSo[V4mojeS?on]Id7o[V]3ok5]@_n_KD;o/7@nokAm?OneOSoo
/g`nok=h??nbM3WoZVi0okATE?nkGf?oZUURoiM7K_nE@g?oTdU`oh]4M_n6B7OoRE1cohU?Mon:D7Ko
Qe1_ohQAKon;DF_oS4]Yoi5;K?n>AW3oSTAeoi1@LomoDH?oM4NBog=3U?mcA9SoLD:Iof`kVOm]>Ico
LSVJofhhW_m_=ZCoMc>UohHhVonI@hkoZ4Z3okA?Loo5Ef7oa5]Poj9hQ?nIRICoUgNFoiUiU?nJNY?o
UW>FoiUnU_nGPicoR6:UohiWWonELIWoTFNPoiB4X?nB`hSoS<j0ojbSR?oOLiSom6>Oom5kTonQ]i;o
XlJJojRjU_nV^YGoZ;BHojRcVOnX]iOoZ;JFojNeTonW]9CoZ;VLoj[9ZOn__Ioo^i9aokZ7J_nhQ6oo
]h9[okN6K?nfQFco]X9[okQmJ0;o]g]V02Go^GaZokUmK?ngNfWo/7YYojn0LOn/PgSoYH9koif5P_nL
RH_oX8n;ojFJRonWW8WoW96Eoj:ISon]YHCoZY^4ojVEPOnTT83oXh:0ojacO_njKX;o`fN2okm[PonR
SH?oQ:Mjogj]M_ml/W;oO;Afoh6dOOn4/gkoQ;AnohFaPOn8YhKoOjHnoi6G4_n?UAKoSiHG00;oSYDF
00koSiDFohnE5on?UAKoSYDFohfE6?n<UAWoRi/EoiJV3_nSZ@WoYJT:oj2Y2_nOZP_oX:T:oinY2P;o
Wj/;00coXZX<oj>[2onTZ@[oXjT:ojBX2OnUZ@WoXjT8oj:Y2?nRZPWoXJX9oj:Z2OnRZ`T2oj>Y200Q
oj6Z1onNZ`OoX:X7ojBY2OnVZ@coXjT9oinY1_o4ZbOol9e<oo2IBOoJYd3o^:Xbok^Y<_nlZcCo^J`d
okR/=onkZcSo_:/gokfY=oo2ZC[o]:Teoi6X:On>Y2CoSZ@UohnU9On:[2WoU;8dojn/>?nfZ3So]:Th
ok:Y>?n`ZcWo/:Xh00;o/ZTh01go/ZTiojn[=On`Zbco/:TZojjY:on_ZB[o/:T[ojfY;_nZZCCoZjTc
ojb[=On_ZSOoZj/eoj:W;?nHWb3oL[HPoeW@9omMc2KoH<XVoeg:9_mKbbOoG//Vof?:9_mJcB?oJLDT
oj6Z9onVZRgoYZL[omF24@03onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf
2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe
2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oV
M0P3onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8onId2?oV
M@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8
onId2?oVM@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf2OoV
M0SoiW@8onId2?oVM@T00_oVM0P3onIe2@05onMf2OoVM0SoiW@8onId2?oVM@T00_oVM0P3onIe2@03
onMf2OoVM0SoiW@800CoiW@800?oiWD8onId2?oVM0P00_oVM0P00ooVM@WoiW@8onIe2@09onId2003
onMf2?oVM0SoiWD800;oiW@800?oiWD9onMf2OoVM0P00ooVM0P01_oVM@WoigH9onMf2?oWMPSoiWD9
onMf2@KoiW@800CoiWD9onId2?oVM@WoigH90_oVM0P2onIe2@;oiW@80ooVM@T01OoWMPWoiW@8onId
2?oVM0SoiWD900;oiW@80ooVM@T01OoWMPWoiW@8onId2?oVM0SoiWD900;oiW@80ooVM@T00ooWMPWo
iW@8onIe2@02onId20?oiWD900GoigH9onId2?oVM0SoiW@8onIe2@02onId20?oiWD900GoigH9onId
2?oVM0SoiW@8onIe2@02onId20?oiWD900GoigH9onId2?oVM0SoiW@8onIe2@02onId20?oiWD900Go
igH9onId2?oVM0SoiW@8onIe2@02onId20?oiWD900GoigH9onId2?oVM0SoiW@8onIe2@02onId20?o
iWD900GoigH9onId2?oVM0SoiW@8onIe2@02onId20?oiWD900?oigH9onId2?oVM0P01?oVM0P00ooV
M@SoiW@8onId2002onId2003onIe2OoVM0SoiWD900WoiW@800?oigH8onId2?oVM@P00_oVM0P00ooV
M@WoigH9onId2003onId2006onIe2OoWMPWoigH8onMf2?oVM@WoigH91_oVM0P01?oVM@WoiW@8onIe
2OoWMPT2onId2006onIe2OoVM0SoiW@8onIe2OoVM0SoigH80OoVM@T00003onQh2ooWMP_oj7L<00;o
j7L;00Coj7P<onMe2ooWMPcoj7L;0_oWM@/2onQg2`03onMe2ooWM`coigH;00?oigH;00GoigD;onQg
3?oWMP_oigD;onMf3002onQh2`;oigH<00_oj7P;onMe2ooXM`_oigH<onQg2ooWMP_oj7L;onMg3?oX
N0coj7L;onMe2`02onQh2`07onMe2ooWMPcoigL<onMg3?oXM`coigH<onMe2`02onMf300<onQg2ooX
M`coigD;onMe2ooXN0_oj7P<onQg2ooWMP_oj7L;onMg3?oWMP_oigH<0_oXN0/03_oWM@_oigL<onQh
3?oWMPcoj7P;onQh3?oXM`coj7P<onQg2ooWM@_oigH<onMf2ooWMPcoigH;0_oXN0/01ooXM`_oigH<
onQg2ooWM@_oj7L<onQg2ooWM@/00_oWMP`05_oXN0_oigH<onMf2ooWM@_oj7P;onMe2ooXN0coigD;
onMg3?oXM`coj7L;onMg3?oWM@_oj7P<onMg3?oXN0_oigH<onQg2ooWMPcoj7L<onQh2ooXM`/2onMf
2`07onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2`02onQg2`06onMe2ooXN0_oigD;onQg3?oWM@_o
igL<0_oXN0`06OoWMP_oigH<onQg2ooWM`coj7L<onMf2ooXN0_oigD;onMf3?oXM`_oigH<onQg3?oW
M@_oigL<onMe2ooXM`_oj7L<onMe2ooXM`_oigD;onQg3?oWMP_oigH<onQg3?oWM``00ooXM`/03_oW
M@_oigH<onMg3?oWMPcoigD;onQg3?oXN0coj7P;onMe2ooXN0coigD;onMf2ooWM@_oj7P<0_oWM@/0
3_oWMP_oigD;onMe2ooWMPcoj7P<onMf2ooXM`coigL<onQg2ooWM`coigD;onMf3?oXN0coj7P;0_oW
M``01OoWM@_oj7L;onQg3?oXM`_oigH;00;oj7P;00?oj7L<onMf2ooXN0/00_oWMP/04?oXM`_oigD;
onQg3?oWM@_oigH<onMe2ooXN0_oigH<onQg2ooWM@_oigH;onQh2ooWMP_oj7L<onMg3?oXM`/2onQh
2`05onQg2ooWMPcoigD;onQg2ooXN0/00_oWMP/01_oXM`_oigD;onMf3?oWMPcoigL<onQg30;oj7P;
00Goj7P<onMg3?oWM@_oigD;onQg2`02onMf30;oj7L;00Ooj7P;onMe2ooXM`_oj7L<onMg3?oWMP_o
j7L;00;oigH;0_oWM``01?oXM`_oj7L<onMf2ooWM@/2onQg2`06onQh2ooXN0coigH;onQg2ooWMP_o
igL<0_oWMP`01OoWM@_oj7P<onQh3?oXN0_oigL<00;oigD;00Coj7L;onMf2ooWM`coigD;0_oXN0`0
0ooXM`_oigL<onMf2`02onMf3003onMe2ooXN0_oj7L<00;oj7P;01;oj7L<onMg3?oWMP_oig@?onae
=oo`NEOokgUBonmgCOo_N4gokgM>onmgCoo_MTcokgE<onihBOo]OD3ojgdeonao<_o/OSD2onam=`0@
onan=_o/OSWok7dgon]k=?o/OCCok7hfon]k=Oo[OCOokGhloneo?oo[OCOok7dbonam=_o[O3Ook7df
on]k=P;ojg/e00WojgXfonal>?o/NcOojg/_onak>Oo^O5CokWYMonekF_o^O5T00_o^NUX02oo^Neco
kWaJonilFOo^NU[okWaJonmlG_o^Negok7UAonYg?ooZN3?ojWLf00;ojGLg00?ojWLfonUf=_oZN3H0
0_oZMcL2onUg>03oonUf=_oYMcSojWPionUf=ooYMcOojGHfonYg>?oYMSSojGHfonYh>?o^KFGom4nG
ooA@TOodFXgomV6CooIRToohJ8konVN3ooYRP_oiGgkonUEboo]FL_oiGW_onEahooYJN_oiFG[onUUo
oo]GROokD8WoneB?ooYKU?ojCGOonTEFooY=JOojCg[onE9joo]HSoonB8KooTEhooeLVOolIk7onfF]
oo]WZ?okI:_oneneoo]J^oolCIkooD9Xooi8D_omE6?ooEM[ooe@H?om@DSooC<ioo`^?Ooj<D?okSHl
on4j=OoH?COofSXoonHfCoof@FconTQeooY:LOojBW?old>6onA0[Oo==[Wo_RjdokT/__nn;/Oob3;7
oldf`Oo<=[kobcG1ol`f`_o9=Kooac70olTX`oo:9[kob2fjolLc^Oo5<;[o`bRmolDT_oo38/7o`2?2
ol4W__o6=jgobTbColYFQ_o4@XWoa2nFolh[X?oK;ZKohcFWomh`Z?oG:Z_ofS6WomPdZoo?<:gocS:W
ol``Z_o7;:Go`RFjolHPe?o;;[?obCFTolTc[Oo6?hKobdmIolY@G_o8C6?oadaUolI;IOo5C5oo`TeH
ol1CB?o0FCKo`ehZol5O9onmGb_o^E`]okMN<onbFcgo[Ua4ojiSAOn^IT?o/6Y1ok9Z?onbJcgo/fPk
ok9W?On`I3oo/FDook5X?onaKS_o[W8ooj]fAOnWMTSoWW=?oi=`E?nBIUWoY61YojUKKonREVgoUdYe
oiU=MonOH6goWF=ZoiiNIonOGVGoXUmSojIOI?nSG6CoXUmQojIRG_nZHecoZV9QojQPJonZG73o]75X
ojMeK_nBGX3oU5f1oiALP_nEGh?oTen2oi=GPOnFF7coTUQkoh9;Romj@i[oOdFFoga4Uomg?IooOSZM
ohTmVonM?hcoS4fFogik[?n2K:coSf^NoiQjUOnIN9CoW7NAoj:8SonBM9koSVJPoiUgV?nIM9OoTVBQ
oi:7X?nAah?oT<YmojjTQooNLiSokfBLokfDTonNaiKoYl2KojRjU_nX^YOoZ;FIojRiVOnW^YWoZ;ND
ojReT_n[`:?o/M:eok3B]?nd^IGo_9M/okV>JoneSW3o]X]_okR4KOnfQFco]8I^okF4KOngOf_o]H1Z
okF1KOniOFgo^WYZokYiIonjMfGo]GEXojehK_nZNgCo[7elojN3O_nXSW[oX8Z5oiR5TOnXVHKo[:26
ojfPQOn[XXSoYYf<ojN@RongRX[o`gZ<om1XT_oRHY_o`fZ@ojilQOnZRX7oXIJ2oiBNP?n>XGkoR:B0
ohJ[OOn7[8KoOZi[000?ohJP6onEU1?oSiHHohnE6?n>U1SoT9@HohnF6?n@UQWoS9DLoh^J6_nAX17o
WJL=ojV/3_nWZ`goXjX=00;oXZX<02ooXZ/<oj2[2onQ[0goXZ/@ojBY4?nT[13oXj`?oj:[3_nRZ`co
Xj/<ojB/2onTZP[oYJ/:ojBZ2onSZ@_oY:/;ojB[2_nPZ`WoXJ/8oj:[2_nT[0coXZ/;oj6]2onTZPco
XJT8oj>/2Oo@Yc7ojZA>olFZ>ongZc7o_J`fok^/=?nk[CCo^j/iokbZ>_nk[3_o`:/nokZ[??nHZRko
SZLXohjW9on<Z2SoTZ`]oj:/=_n][Cko/;0ookBZ>@02ok>Z>@0>ok:[>ona[3[o/ZXiok>[>OncZS_o
[j/gok2/;?naZb_o[j//ok6Z;?n_Zbko[:`dojbZ=_n/Zc@2ojZ[=@0Fojb/=On_[3So[ZLcoj:Z;_ml
a3CoFm4Zoec:9?mQbbKoGL/Woe[;9_mObbGoH</Xoe_<9_n2^bSoYjX]ojVY;_oGPa?oj7P;onMf3?oW
M@_oj7P;onQg2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<
onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_o
j7P;onQg2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<onQh
3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;
onQg2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<onQh3?oW
MP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg
2`;oigH;00SoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;onQg2`;oigH;00SoigH<onQh3?oWMP_o
j7P;onMf3?oWM@_oj7P;onQg2`;oigH;00OoigH<onQh3?oWMP_oj7P;onMf3?oWM@_oj7P;00;oj7L;
00KoigD;onQh2ooWM@_oj7L<onMe2ooWM``2onQh300IonMf2ooWMPcoj7L;onMg3?oXM`coigH;onQh
2ooWM@_oigH<onQg2ooWMPcoj7L<onMe2ooWM`coigD;onQg2ooXM`coigD;onQg2ooWM@_oj7L<onMf
2ooWMPcoj7L<onMg3003onQg2`0GonMe2ooWMPcoigL<onMf3?oWM@_oj7L<onQh3?oXN0_oigD;onQh
3?oWM@_oigH;onMe2ooXN0coigD;onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2ooXM`/00_oWMP/0
2?oWMPcoj7P<onMf2ooXN0_oigH<onMe2ooXN0_oj7L;0_oWMP/04?oWMPcoj7P<onMf2ooXN0_oigH<
onMe2ooXN0_oj7L;onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2ooXM`/2onMf2`08onMf3?oXN0co
igH;onQh2ooWMPcoigD;onQh2ooXM`/2onMf2`08onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2ooX
M`/2onMf2`08onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2ooXM`/2onMf2`08onMf3?oXN0coigH;
onQh2ooWMPcoigD;onQh2ooXM`/2onMf2`08onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2ooXM`/2
onMf2`07onMf3?oXN0coigH;onQh2ooWMPcoigD;onQh2`02onQg2`06onMe2ooXN0_oigD;onQg3?oW
M@_oigL<0_oXN0`06OoWMP_oigH<onQg2ooWM`coj7L<onMf2ooXN0_oigD;onMf3?oXM`_oigH<onQg
3?oWM@_oigL<onMe2ooXM`_oj7L<onMe2ooXM`_oigD;onQg3?oWMP_oigH<onQg3?oWM``00ooXM`/0
3_oWM@_oigH<onMg3?oWMPcoigD;onQg3?oXN0coj7P;onMe2ooXN0coigD;onMf2ooWM@_oj7P<0_oW
M@/01?oWMP_oigD;onMe2ooWMP`1onQh30000_oYN@l2onUi4007onUj4?oYNA3ojGT@onUi3ooYNA3o
jGT?onUj4002onUi4009onQh4?oYNQ3ojGT@onUj4?oYNA3ojGX@onUi3ooXN13ojGT?00;ojGX@00Ko
jGT@onQg3ooYNQ3ojGX@onUi3ooYNA02onUj4004onUi3ooYNQ3ojGT@onUj40?ojGT@0ooYNQ001?oY
N@oojGX@onQi4?oYN@l2onUi4006onUi3ooYNQ3ojGT?onQi4?oYNQ3ojGT?0_oYNA02onUi3`08onUj
4?oYNA3ojGT@onQh3ooYNQ3ojGT?onUi4?oYNQ03onUi3`?ojGX@00KojGT@onUi3ooYN@ooj7T@onQh
4?oYNQ02onUi40CojGX@00KojGT?onUj4?oYNQ3ojGT?onUi4?oYN@l2onUj4004onUi3ooYNQ3ojGT?
onUj40?ojGT@00CojGX@onUi4?oYNA3ojGT?0ooYNQ001_oYN@oojGX@onUi3ooYNQ3ojGT@onUi3`?o
jGT@00?ojGX@onUi4?oYN@l00_oYNQ001?oYNA3ojGX@onUi4?oYNA03onUj40?ojGT@00OojGX@onUi
3ooYNQ3ojGT?onUi4?oXN13ojGT?00;ojGX@0_oYNA000ooYNQ3ojGT@onUi3`03onUj40;ojGT@00?o
jGX@onUi3ooYNQ000_oYNQ02onUi4004onQh4?oYN@oojGT@onUi40;ojGX@00CojGT?onUi4?oYNA3o
jGT@0_oYNQ000ooYNA3ojGX@onUj4002onUj40?ojGT?0ooYNQ002_oYN@oojGX@onUi3ooYNQ3oj7T@
onQh3ooXNA3oj7P@onUi3ooYNQ02onUi40;ojGT?00Goj7T@onUj4?oYNA3ojGT?onUi4003onUj4004
onUi3ooYNQ3ojGT@onUj40?ojGT@0ooYNQ02onUi3`06onUi4?oYNQ3ojGT@onUj4?oYN@oojGT@0_oY
NQ001OoYNA3ojGT?onUj4?oYN@oojGT@00;ojGX@0_oYN@l00ooYNA3ojGT?onQh4002onUi3`07onUi
4?oYNQ3ojGX@onUi4?oYN@oojGX@onUi3`02onUj4003onUi4?oYNQ3ojGT?00;ojGX@00?ojGT@onUi
3ooYNQ000_oYN@l02OoXNA3ojGT@onQi4?oXM`oojGT@onUj4?oYN@ooj7P?onUj4004onUi3`;ojGX@
00GojGT?onUj4?oYNA3ojGT@onUi3`02onUi40;ojGX@00goj7P?onQh4?oYN@oojGX@onUi4?oYNQ3o
jGT@onUj4?oYN@oojGT@onQi4?oYNQ3ojGT?00;ojGX@01KojGT?onUj4Oo[MRSolGYDoo5kEoo`Ndoo
l7Y@onmiD?o`NU3ol7YBoo1jD?o`NTkolGUAoo1jD_o^ODWokH0loneo>?o/OCSokGlionf0>oo]OcSo
kGlg0_o]OcX03Oo]OcWokGlkonio@_o^P43okGhionen=_o]OSWokGljoneo>Oo]OSSokGhionen>_o]
OST00_o]OS/01Oo]OSOokGhionmmDoo^O6;okgeO00;okgeN00cokgeOonmmGOo_OEookgeOonmmGOo_
OEkol7iPonmmGOo]Nd_ojWPhonYj=_o[NST3on]i>P;ojgTk00CojgXkonYi??o[NCcojgTk1_o[NCX0
3ooZN3cojgXoon]j??o[NcGokGEBooAHSOoeCiSoleN<ooAGRoofGI7omVBDooQVTOojIh?onVN7ooYU
Q@02oo]LNP3iooYOO_ojFWOonU]ioo]MQ_okGI7oneB9oo]AO_ojEhSonTmfooY5D_ojC5konU5gooUI
O_ojGhkooE:;ooi4MOomFY;oo6Naoo]T[OolIJSonf:^oo]M^?okEk?ooDN7ooi1FOomC5SooEQXooeF
J_onBUWooS]5ooda>_ok<coolSM2on@k>_oI?C?ogS]1on`fDOog<E?oncIEooY7I_ohC7_okT:<om`j
W_o@=ZSoa3:]okX]^?nl;L;oa3;8olXea_o:=L;obcK0ol/f`Oo;=<?obCO1olLa`_o99l?obRRoolTc
^Oo7<kcoaBboolDT`?o38<?o`Ao4ol8U`_o4=K3oc4^Gol]IPoo6Dh?oaC^Bol`^WooI;jCoh32Won4d
Z?oN=JSof2f[omd`ZOoO<jOoeC2Zom0a[?o?=JWobc:Vol@^Y?o29[goaB7Aol`]^Oo:>:KoaSZJolY<
K?o>DF7oada[olE>H?o4De;o`eU2ol=N=oo4HRooaV@Yol=S;?nkGcKo]Ulnok9RA_naHd[o/FI:ok5Z
BOn_JT[o[fU9ok1Z@oncK3oo/f]0ok5[@On`K4;o[F]5ojYZBonWJTooYVa<ojM`A_nVL4KoYG16ojA]
B?nRJTSoXVm5oj]ZB_o4HEKocVAEoleUCoo0GUOo_V1Lol5]DOo4L4Goa6]5okmVC?o0ITgoaVY:olIZ
BOo4JTOo`fi>olE`D_o6Ke;oaV]EolAVF?o?ODgobXQ>okEaH_niLUoo^6mQokMbHoneMFSo/g1/ok=`
J_nbLVWoZfQ/ojAOLon`J6So/VUTojQUKonMHGgoTER9ohm?S_n<BI7oPVVRogb8^?n5Nk3oUXVOoiN9
WOnGPY[oWHNDoiB2W_n:J:GoTf^MoiUeVOnILISoT62ToiJDV?n<bWKoQlabojR`Q_oMN9[oh6jIojZ^
T_nRb9_oZ[^KojNkVOnY]YSoZ;NHojRlV_nX_IWoZ;bFoj_6X_n`cjco[m2`ojk=Z_nc]Xoo^YUdok^@
K_ngTg?o^I1cokV7K_nhPfco]XE_okF5L?nePfco]h5ZokR0KonhP77o^7m_okUnK_niOFgo^GY/okIk
J_ndNfgo/gIcok9hKon`NF_oZgQhojeoNon/S7OoZYEnojbOQ?nZXhWoYIn=oj>PS?nVWHSo[9F5ol67
S_o<LYCo_Vf;okI_Qoo3J8[ob6N<okeZR_ndLXWoZWf3ojJ7Q?nPRh[oT:55oiNS6_nCX1coT9dKoi2K
6?n?VA[oSiPJohjI6On>WQGoT:H>oin/2_nV[@koY:`?oj:/3_nS[0ooY:`@00;oYJ`@01;oYJd@ojF/
4OnU[1;oYJdBojF]4onR[A;oXj`Aoj>/4_nS[17oXj`@oj>]4?nT[0koYZ`=ojF]3_nU[@goXjd<oj:]
2onS[Ph2ojJ/3`0KojF]3_nR[PkoY:d=ojF]3_nS[0coY:T@ok>/:_o0[Sko_Jhiokb]=_nn[SSo_Jdk
okf]?onl[T3o`:i2okn^@onO[CGoSJX[oh^Z;?n?[BkoVjleoj^^?Onc[3ko/Z`loj^`?on`[cko]J/k
00;o]:`m0_nb[Cd01?nd[3go]:`lok6^>?n`[C02ok6/;`0Jok:/;on_[3;o[J`hojf]>?n/[3So[:`g
ojf]>?n/[COo[:`hok6[>OnfZ3SoZk4loh3=?omRdRooH//Wof3<9omMcBSoG<`Voec;9_mJcBKoH/XV
oiFd;_nbYBkofHHHonUi4?oYN@l2onUj4003onUi4?oYN@oojGT@00;ojGT@00?ojGX@onUi4?oYN@l0
0_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj4?oYNA3ojGT?00;ojGX@00?ojGT@onUi3ooYNA00
0_oYNA000ooYNQ3ojGT@onUi3`02onUj4003onUi4?oYN@oojGT@00;ojGT@00?ojGX@onUi4?oYN@l0
0_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj4?oYNA3ojGT?00;ojGX@00?ojGT@onUi3ooYNA00
0_oYNA000ooYNQ3ojGT@onUi3`02onUj4003onUi4?oYN@oojGT@00;ojGT@00?ojGX@onUi4?oYN@l0
0_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj4?oYNA3ojGT?00;ojGX@00?ojGT@onUi3ooYNA00
0_oYNA000ooYNQ3ojGT@onUi3`02onUj4003onUi4?oYN@oojGT@00;ojGT@00?ojGX@onUi4?oYN@l0
0_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj4?oYNA3ojGT?00;ojGX@00?ojGT@onUi3ooYNA00
0_oYNA000ooYNQ3ojGT@onUi3`02onUj4004onUi4?oYNQ3ojGT@onUi40?ojGX@0ooYNA001ooYNQ3o
jGT?onUj4?oYN@oojGT@onQh4?oYN@l00_oYNQ02onUi4003onUj4?oYNA3ojGT?00?ojGX@0_oYNA00
0ooYNQ3ojGT?onUj4002onUj40;ojGT@00Coj7P@onUi3ooYNA3ojGT@0_oYNQ001?oYN@oojGT@onUi
4?oYNA02onUj4003onUi4?oYNQ3ojGX@00;ojGX@0_oYNA000ooYNQ3ojGT@onUi3`02onUj4003onUi
4?oYN@oojGT@00;ojGT@00?ojGX@onUi4?oYN@l00_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj
4?oYNA3ojGT?00;ojGX@0ooYNA000ooYNQ3ojGT@onUi3`02onUj4003onUi4?oYN@oojGT@00;ojGT@
00?ojGX@onUi4?oYN@l00_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj4?oYNA3ojGT?00;ojGX@
00?ojGT@onUi3ooYNA000_oYNA000ooYNQ3ojGT@onUi3`02onUj4003onUi4?oYN@oojGT@00;ojGT@
00?ojGX@onUi4?oYN@l00_oYNQ000ooYNA3ojGT?onUi4002onUi4003onUj4?oYNA3ojGT?00;ojGX@
00?ojGT@onUi3ooYNA000_oYNA000ooYNQ3ojGT@onUi3`02onUj4004onUi4?oYNQ3ojGT@onUi40?o
jGX@0ooYNA001ooYNQ3ojGT?onUj4?oYN@oojGT@onQh4?oYN@l00_oYNQ02onUi4003onUj4?oYNA3o
jGT?00?ojGX@0_oYNA000ooYNQ3ojGT?onUj4002onUj40;ojGT@00Coj7P@onUi3ooYNA3ojGT@0_oY
NQ001?oYN@oojGT@onUi4?oYNA02onUj4003onUi4?oYNQ3ojGX@00;ojGX@0ooYN@l3onUj400000Co
jgdFonYl5Oo[OQGojWhF0_oZO1D01_oZOQKojW`EonYl5_oZOQKojW/Eon]n5@;ojWhF00?ojglFonYk
5OoZOQH00_o[OQD04_o[OAKojW/EonYn5_oZOQKojglFon]m5Oo[OQGojglFon]m5_oZNaGojW`Fon]o
5_oZOQKojglFon]m5_o[OAGojglFonYn5P;ojghE00GojgdEonYl5Oo[OQGojW`Eon]m5@03onYl5@0:
on]n5Oo[OaKojgdEonYn5_oZO1GojglFonYn5_o[OaKojghEonYl5@;ojghE00?ojglFon]m5_o[OaH0
0_o[OaH01?oZO1KojghEon]o5_oZO1H2on]o5P0?on]n5OoZO1KojgdFon]m5OoZO1KojW`Eon]o5_oZ
OQKojghEon]m5_o[OaKojWhFon]m5OoZOQKojW`E00;ojWhF0_o[OaH2onYl5P03on]n5OoZOQKojghE
00;ojgdF00SojW`EonYl5_o[OAKojghEonYn5_oZO1GojghEonYl5@;ojW/E00KojgdEonYn5_oZO1Go
jWhFon]n5OoZNaD2onYl5P0>onYl5Oo[OQGojWhFonYn5_o[OAKojW`Eon]o5_oZO1GojW/Eon]m5_oZ
OQKojghEon]m5Oo[OAH2on]n5@03onYn5_oZO1GojW`E00;ojWhF00CojglFon]n5OoZO1KojW`E0_o[
OaH06ooZOQKojghEonYk5Oo[OQGojglFonYn5_oZO1GojgdFonYl5OoZOQKojghEonYl5_oZNaGojghE
onYl5_oZNaGojglFonYn5_o[OQGojW/Eon]o5_oZNaGojgdFon]n5OoZO1KojgdFon]o5P02on]m5@04
onYn5_oZO1GojW/EonYn5P;ojglF00KojW`EonYn5_o[OaKojghEon]m5OoZO1D2onYl5P07onYl5OoZ
O1KojgdFon]m5_o[OaKojgdEonYl5@02onYn5P09onYl5_o[OaKojglFonYl5_o[OaKojghEonYn5_o[
OaKojghE00?ojgdF00_ojglFonYl5OoZO1KojgdEonYl5_o[OAKojghEonYl5OoZNaGojglFon]m5@02
onYl5P04on]o5_oZO1GojW`Eon]o5P;ojW/E00SojWhFon]n5OoZOQKojW`Eon]n5Oo[OAGojW/EonYl
5@;ojW`F00?ojW/EonYl5Oo[OaH00_oZOQH01Oo[OAGojW`FonYk5OoZO1GojglF00;ojW`F00cojWhF
onYl5_oZOQKojW/Eon]m5_oZO1GojgdFonYl5Oo[OAKojW/EonYn5_o[OAH2onYk5@09on]o5_oZOQKo
jW`EonYl5OoZO1KojgdEon]m5_oZO1KojgdF00;ojW`E00[ojghEonYl5_o[OaKojglFon]m5_o[OAGo
jWhFon]o5_o[OQGojglF0_oZO1H07Oo[OaKojWhFonYk5Oo[OAGojW`EonYk5OoZOQKojW`Eon]n5OoZ
OQKojghEonam8?o`NDSolWeJoo5lE?oaOE?olGiCoo5lE?obOUGolGaEoo5kEOobO5?olWaDoo9kEoob
O5Sol7eAonn0AOo^PcgokX<k00;okX4l01_okh@oonn3@?o_Pckokh8oonn3A_o^PDCokX8monf0>_o_
PcookX8nonn2?Oo_PCkokh8nonn1?Oo_PCookX8oonn3?oo^PSkokH0joo22C_o`OVGol7mUoo61H_o`
P67ol85Soo60HOo`P6400_o`Of402OoaPF?olH5Uoo21GOo]OTWok7hkon]k>_o[Ncook7i0on]m?`02
on]k?`;ok7a000?ok7doon]m?oo[OCl00_o[OCl0AOo/OSkojge0onen@_o/O4;ok7e3onamAOo/O4?o
jgdeonakA?ocIWgomDnJooEFTooeFXkomEZ?ooEJTOogHISon6JDoo]WQ_ojJHSonVR8oo]OOOokHhGo
nVB6ooUUM?ojIWSonfB7oo]MP_ojDW;onUEmooYGO?ojBUWondmOoo]DN?ojFHGonV6=ooaFQoonA7Go
oEF<ooaW[OolI:_oo6:WooaR/_olGK_oo5>Zooe1Joon?dWooE=RooeKKOomDfKooT9@oode?ool<Sko
mCI0onPm?ooN?S_ohC]1ondfC?of<T_omc4loo<i>_oc@6;okDBComPmXOo9=:WoaC:XolHfXoo3<[3o
_bg8olLdb@02ol/fa@1Nol/f`oo:=/CobcO3olXf`_o8<LCobB[3olTZ`?o9=K[ob3JlolDZ`Oo38l;o
`b35ol8Raoo6;k[obDRMolULQ?o8G7goaTR<ol/eW_oH<:Koh3:Von8dZ?oO=:_ogcFZom/`ZooI;Zco
gcBZomlbZ_oG<JWoe3F`olhe[oo9<JKoa2f[ol4W`oo78]?ocRW:oldhZoo=BGoocUIOolMGD_o1FTKo
a68iolMU<_o3IC;o_f@eokaU?OniIT?o]VI8ok=WC_ndJDko]FY:okAZB_ncJTWo/fY8ojmTCOn`IDSo
/fe3ok9^A?naLTOo/GM9ok5hBOnaMD[o/6m<ok1^COn_L4Co/G=0okAf?oneLcco]g0jokIb>onfM3So
`6m0omAWC_oGJ4oodV]?olMZE_o0Ie[oa6e@olQ`A_o7K4[oa6Y>ol5WD?o5JE3obfe<ol]_C_o7LEGo
agALolY_E_o9JUWoaFMLoln0Coo;QeCo]79WokMcI`;o^G9S037o]VmVokI_JondKVco]7E]oji`L_nZ
IgGo^G1XokabIOnjKfGo]feYokA/K?niLFSo^VeSokA[JonIPiOoSYfcoi^QZ?nMXZKoUifWoiNHYOnC
U:WoQ82dohIf/On@O:[oV8RRoi9dYOn>IZ_oUZ:Gohc<L_n8cW?oXkJ5omafV_oCOIgoY<:IojG5WOnZ
_9coZ;ZIojViVOnY_I_oZKbKojZnVon]bJGo[lfYojo?[on^e[Wo[MBcok30WOnhXGko_9Aa00;o^IIe
03Go^Xe^okZ8KOngQVoo]HE_okN5KOnhPfoo]h=`okN2KOnhPFko^81[okUnJ_niOFko]X1^okF2LOnf
OWOo]WYlokEgM?ndLfko/gASok5kJOn_QfooZhYcojZ?O?nVTXOoYYf>ojRXRonS[8[oXZB:ojJJR?nJ
XHSoVj:9okF8SOnlL8go`fN<olMXSOo5Jh[oaFBIol=mP_naZcWoZZ`ZojB`;?nL[BSoTj/Voi:Y9_nV
ZBKo/ZhLok6_6_nW/1KoWZl@oi^^3_nK/0koW:d>oij^3`02oin^400Eoj:_4OnS/1CoYZlFojR^5onV
[aKoY[0FojJ]5OnT[QKoXjhFoj>^5OnT[aGoY:lFojB`5OnT[a?oXZlAojBa4OnV[Q;oYZhCojF^4_nW
[Q;oY[0B00;oY;0B00SoZJlDojN_4onCYPgoSIh>oj^^;_o9/4Ko_k0mokfa?`;o_[56033o`K17ol>_
A_nZ/CcoSZ`^oh^^;onD/3KoYK4mok:a@_nd[d;o/K10ok:]?on`[Soo[[A2ok>_@Onf[Coo]Ji0okB^
?onc/43o]:m1okF`@_na/3co/Jhcok>`<onb[S;o/Jhcojf^>On^[Sco[jlkojf`>on^[c_o[Zhkojf^
>on^/3_o[Jhkojn]>ondZS[oYKY4ohCCA_mbdC_oJ<d`of7=:omNcBWoGlhYoek<:?mFcbKoKLP/oj^[
<_oNR1`2onYn5P04on]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1Go
jglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n
5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglF
onYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZ
OQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk
5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKo
jWhFon]m5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;o
jW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00kojW`Eon]n5OoZOQKojWhF
on]m5_oZO1GojglFonYl5OoZNaGojgdFonYn5_o[OQGojgdEon]m5P;ojghE00?ojWhFonYl5OoZO1D0
0_oZOQH01?o[OaKojghEonYl5_oZO1D2on]o5P0KonYn5_o[OQGojW/Eon]n5Oo[OaKojWhFonYl5Oo[
OAKojW`EonYn5_o[OQGojW`FonYk5Oo[OQGojW`FonYk5Oo[OaKojWhFon]n5OoZNaGojglFonYk5Oo[
OAKojghEonYl5_o[OAKojglF00;ojgdE00KojWhFonYl5OoZNaGojW`FonYl5Oo[OQD2onYn5P04on]m
5_oZO1GojglFonYk5@;ojW`F00SojW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYk5@;ojW`F00[o
jW`Eon]n5OoZOQKojWhFon]m5_oZO1GojglFonYl5_oZO1GojghE0_oZOQH01?o[OAKojW`Eon]o5_oZ
NaD2onYl5P08onYl5Oo[OQGojWhFonYn5_o[OAKojW`Eon]o5_oZNaD2onYl5P08onYl5Oo[OQGojWhF
onYn5_o[OAKojW`Eon]o5_oZNaD2onYl5P08onYl5Oo[OQGojWhFonYn5_o[OAKojW`Eon]o5_oZNaD2
onYl5P08onYl5Oo[OQGojWhFonYn5_o[OAKojW`Eon]o5_oZNaD2onYl5P08onYl5Oo[OQGojWhFonYn
5_o[OAKojW`Eon]o5_oZNaD2onYl5P0>onYl5Oo[OQGojWhFonYn5_o[OAKojW`Eon]o5_oZO1GojW/E
on]m5_oZOQKojghEon]m5Oo[OAH2on]n5@03onYn5_oZO1GojW`E00;ojWhF00CojglFon]n5OoZO1Ko
jW`E0_o[OaH06ooZOQKojghEonYk5Oo[OQGojglFonYn5_oZO1GojgdFonYl5OoZOQKojghEonYl5_oZ
NaGojghEonYl5_oZNaGojglFonYn5_o[OQGojW/Eon]o5_oZNaGojgdFon]n5OoZO1KojgdFon]o5P02
on]m5@04onYn5_oZO1GojW/EonYn5P;ojglF0OoZO1D1onYn5P7ojglF00001Oo/PA[ok84Konb06_o/
P1_ok84K00;okH8K0_o/P1/2onf26`0Konb16oo/P1[ok80Jonb16oo/PA[ok84Konb06_o]PQ[ok84K
onb16_o/P1[okH8Konb16oo/P1_ok84Jonb06_o]PQ_ok80Konb16_o/P1_ok80Jonb06oo/PA_ok80J
onb16oo/PA[ok80J00;ok84K00Kok80Jonf26oo]PQ[ok84Konb06oo/P1X2onb06`07onf16_o/PA[o
kH8Jonb06_o/P1_ok84Jonb16`02onb06P0:onf26oo/P1[okH8Konf26oo/PA_ok80Jonb16oo]PQ_o
k80Konb06PCok84J00ook80Konb06_o/PA[ok80Jonf16_o/PA[okH8Jonb16oo]PQ_ok80Jonb16oo]
PA[okH8Konb16_o/PA/00_o/P1/01oo/P1[ok80Konb16_o]PQ_ok80Konb16_o]PQ/00_o/PAX01_o/
P1[ok80Konb16_o]PQ_ok80Konb06P;ok84J00?ok84Konb16_o/PA/00_o/PA/01oo]PQ_ok84Konb1
6_o/PA[ok80Jonb06oo/PA/00_o/PAX01_o]PQ_ok80Jonb16_o/PA[okH8Konb06P?ok80K0_o/PA/0
0oo]PQ_ok80Konb16P02onb06`09onf26oo/PA_ok80Konb06oo/PA_ok80Jonb06oo]PQ_ok84J00?o
k84K00?okH8Jonb16_o/PAX00oo/P1/01oo/P1[ok84Konb16_o/P1_ok84Konb06_o]PQX00_o/PAX0
2?o/P1[ok84Jonb06_o/P1[okH8Jonb16_o/P1_ok84J0_o/P1X06Oo/PA_ok84Jonb06_o]PQ_okH8J
onb16oo/PA[ok80Jonb06oo]PA[ok84Konb06oo/PA[ok80Jonf26_o]PQ_ok80Konb06_o/PA_ok80J
onb06oo/P1[okH8Konb06_o]PAX00_o/PA/2onb16P07onf26oo/PA[ok80Konb16oo/P1_ok84Konb0
6`02onb06P05onf26oo/P1_ok80Konb16oo]PQ/00oo/PAX01oo/P1[ok84Jonb06oo/P1[ok84Jonf2
6oo/PAX00_o/P1X2onb06`0:onb16_o/P1_ok80Jonf16_o/P1_ok84Konb16_o/P1_ok84Jonf16P;o
k84K00Cok80Jonb16oo]PA[ok84J0_o/PA/01_o/PA[ok84Konb16oo/P1[ok84Jonb06`;ok84K013o
k84Jonb06oo/PA_ok84Konb06oo/PA_ok84Jonb06oo]PQ_ok84Konb16_o/PA_ok80Konf26_o/PA[o
k84K0_o/P1/01Oo/PA_ok84Jonb16_o/PA[okH8K00Cok80K02[ok80Jonf26_o]PQ_ok80Jonf26oo/
P1[ok84Konf16_o/PA[ok80Jonb16oo/P1kol7`loo=mF?obOUKolgmDoo9nEoobOeOolh1Hoo9oF?ob
OeOolWiIoo=nFOobOUOolgmHoo9mF?ocO5[olgmFoo62COo_QD7okh@noo25@oo`QDCokhE2oo25AOo`
QD_ol8E7onn4?oo`Q3ookhE2oo25@oo_Q482onn4@`03onn3@Oo_Q4?okhA200;okhA200Cokh=0oo24
B_oaPV;olH5X0_oaPVD04OobPfColH9Uoo62I?oaPVColH9Uoo63J?obPfKol89Jonj0B?o]OcookGm1
onf0@oo]OdGokGm3onf0A?o]P4?okGm300;okH120?ookGm3onj0@_o]P4?okH12onf0AOo]OdKokWm8
oneoBOo]OdSokGm5onioA_o]P3gokX8koo5`L?ogEISomUNFooIJToofFi;omUVDooEHT_ogG9Con6JH
oo][ROokJXOonVN4ooaMO_olHHkonfV<ooY^P_ojK8Gonf:2oo]FLOojEGKonUf8ooYBIookC5Wone5d
oo]GR?ojH8koo5R1ooi7MOonDX[oo6FXooaTZoolHJSoo6:eooaL^oomC9OooSeJooi6BOomFFSooE]a
ooi=HOon>DWooC4mooPf@Oo_>D;oic]4onDj@ooZ=T3okcHmonle;Oo_>c7ol3YCon<mOooC>j;obCRY
ol@eY_o6=JWobcZXolPfZoo3;/3oaC3<ol/ha_o;><Goc3K6ol/faOo;=lCobCK5olL`aoo::lGoc2no
olXd_?o5<Kgo`bO1ol8Qa_o18LWoaRbnola3Y_o:FH[oa6=kolMGPoo<?IWodS2VomhaZOoT=JWohSB[
omld[OoP=j_ohCN/omX`/?oJ<:kogcB/omlcZ_oK<jgoecNgoldc[oo;<JWoaRfbol0Uaoo:8][oe2OH
ol<oTOo:GU3obFDnol=U>oo0IC[o_FHnokUWAonhJTco^6i=okU`C_niKdoo^Fi=okQ/BonhJd[o]fY:
okEZC?ndK4co/F]>ojmZDOncLDco]7M8okAlBOneNdWo^7U8ok]dA?nlLD?o_6m4okeaAOnhMD7o]WHo
okMe?oniLSgo^74mokE^?_ndKcco`Va8omAXFOoBKeOocg=EolE^F?nmIE[o`VYEolEaCoo6L53oa6eB
ol=/DOo2JEGobFaKol]`F_o8M5SoagILolQ^Foo9JV3obF]Pom:5E?o9Re_o]7A/okIcK?nhLf[o]GA]
ok9`K_nfKfgo]W1/okQfKOnbLgSo[feookUbMonkM7Go^W9bok]bKOnmLV_o_gA[ol1fJoo2LfGo^79a
oib;WOnNYJSoYjBOojBVXOnTYj?oX::VohbF]?n8UKWoT9:doiRK[OnIXZgoS8:gohj6^on@`IWoQ=5e
ogoDN_nS/hWoeWRHoknIVonUb9goZl2Ooj^jWOnZ^I_oZKfLojVmWOnZ_j3o[/f[ojoC/_n^cjoo[L^[
ojgA]?n]e[So[lV/okR]TOnkUGOo_9Ecok^IM?nkV7?o^Xm`okV8KongQVoo]hU]okN7KOngPfco^H9Z
okR0JOnhP6[o^Gm]okUnKonePG3o]XAbokN5O?nfOhGo/gF4okAfJ_nfMV3o/gIVok5iI?nbNfCo/X5]
ojn3MonZS83oZYV7ojVRR_n[XhcoZJZ?ohg6SOmgbX8001koPkJ3oi^TR?nZQ8[o]g69olAWTooAH9oo
aIALokR_=?na/CWoZk<jokNb??o>Yc_oj9/monjL?OoSWSWoeJ8bolfW;Oo9[2[o`ZhVokZa9?na/Aoo
Y[4Hoj6`5?nO/ACoX;8Foj6a5_nQ/AGoX;8Doj:`5OnT/AL2ojFa5`0VojJa6?nW/1WoY[4IojBb6?nT
/QOoY[8IojJa6OnW/ASoYk4GojNa5_nX/AGoZ;0FojNa5OnY/1Go[[0Hoin`5?n=X1;oSiTBoiFS5_nh
/cSob;A>okjbB_nn/TSo`K57olFaB?n`/T7oS[4cohjb=?nN]3go/;93okFaAOnc/DCo/[53ok:a@_nb
/D?o];52ok6a@on`]4D2okJa@`0AokFa@ond/DCo][53okFbAOna/Sko/k8eok>`=Onc/CKo/K4gojja
?_n_/3oo[k0nojja?_n_/Cko[[4nojjc?_n_/3h00_n_/Cl03_n`[cgo/Zhmoic4B?n3eT[oOM52og??
>?mTcbooGLhZof3>:omHd2SoD/dVoiV[9ooUQ1gok84K0_o/PAX00oo]PQ_ok80Jonb16`02onb16P03
onb06_o/P1_ok84K00;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb16P03
onf26oo/P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX00oo]PQ_ok80Jonb16`02onb16P03
onb06_o/P1_ok84K00;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb16P03
onf26oo/P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX00oo]PQ_ok80Jonb16`02onb16P03
onb06_o/P1_ok84K00;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb16P03
onf26oo/P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX00oo]PQ_ok80Jonb16`02onb16P03
onb06_o/P1_ok84K00;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb16P03
onf26oo/P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX01_o]PQ_ok80Jonb16_o/PA[okH8K
onb06P?ok80K0_o/PA/00oo]PQ_ok80Konb16P02onb06`09onf26oo/PA_ok80Konb06oo/PA_ok80J
onb06oo]PQ_ok84J00?ok84K00?okH8Jonb16_o/PAX00oo/P1/01oo/P1[ok84Konb16_o/P1_ok84K
onb06_o]PQX00_o/PAX02?o/P1[ok84Jonb06_o/P1[okH8Jonb16_o/P1_ok84J0_o/P1X01Oo/PA_o
k84Jonb06_o/P1_ok84K00;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb1
6P03onf26oo/P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX01_o]PQ_ok80Jonb16_o/P1[o
k80Konb16`;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb16P03onf26oo/
P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX00oo]PQ_ok80Jonb16`02onb16P03onb06_o/
P1_ok84K00;ok84J00?okH8Konb06_o/PA/00_o/PAX00oo/P1[ok80Konb16`02onb16P03onf26oo/
P1[ok84K00;ok84J00?ok80Jonb06oo/PA/00_o/PAX00oo]PQ_ok80Jonb16`02onb16P03onb06_o/
P1_ok84K00;ok84J00KokH8Konb06_o/PA[ok84Jonf26oo/P1X3onb06`;ok84K00?okH8Konb06oo/
PAX00_o/P1/02Oo]PQ_ok84Konb06oo/P1_ok84Konb06_o/P1_okH8Konb16P03onb16`03onf26_o/
PA[ok84J00?ok80K00Ook80Jonb16oo/PA[ok80Konb16oo/P1[okH8J00;ok84J00Sok80Jonb16_o/
P1[ok80Jonf26_o/PA[ok80Konb16P;ok80J00Kok84Konb16_o/P1[okH8Konf26_o/PA/1onb16P00
00CokXDPonj48?o^PaookXDP0oo^Q2000oo]Pb3okX@Ponj48003onj48003onj58?o]PR3okX@P00;o
kX@P00WokH8Oonj48?o^Q23okH8Ponj48?o^QB3okX<Oonj48?o^QB001Oo^Q2000oo]PR3okX@Ponj4
8002onj58005onj37oo^QB3okX@Ponf28?o^QB000_o^Q2001_o^PaookX@Ponj48?o^Q23okX<Oonj4
80;okXDP00?okH8Ponj58?o^QB000_o^Q2001?o^Q1ookXDPonj48?o^QB02onj37`;okX@P00_okX<O
onj58?o^Q23okH8Ponj48?o]PR3okXDPonj48?o^QB3okX@Ponj37`02onj580?okX@P00?okXDPonj4
8?o^Q2001?o^Q2001_o^QB3okH8Oonj58?o^QB3okX@Ponf280;okX@P00?okX<Oonj48?o^Q2001?o^
Q2000oo^QB3okX@Ponj48004onj4800:onj37oo^Q23okX@Ponj48?o^QB3okH8Ponj58?o^PaookX@P
onj580;okX@P00GokX<Oonj48?o^QB3okXDPonj48002onj58003onj37oo]PR3okXDP00?okX@P00Co
kH8Ponj48?o^QB3okH8P0_o^Q202onj580;okX@P00?okX<Oonj48?o^QB000_o^QB02onj480CokXDP
0oo^Q202onj58007onj37oo^Q23okXDPonj48?o^QB3okX@Ponj58003onj48008onj37oo]PaookX@P
onj48?o^PaookX@Ponj47oo^Q202onj58003onj48?o^QB3okX@P00?okX@P00GokH8Oonj48?o^QB3o
kX<Oonj58003onj48004onj47oo^Q23okXDPonj37`;okX@P00KokXDPonj48?o^QB3okXDPonj37oo^
QB03onj48003onj58?o^Q23okX@P00?okXDP00CokX@Ponj58?o^QB3okX@O0_o^Q2000oo^QB3okX@P
onj48002onj58004onj48?o^PaookX@Ponj37`;okX@P00?okX<Oonf38?o^Q2000_o^QB03onj48005
onj37oo^Q23okXDPonj48?o^QB001?o^Q202onj580?okX@P00OokXDPonj48?o^QB3okX@Ponj37oo^
Q23okXDP00;okX<O00[okXDPonj48?o^Q23okX@Ponj58?o^Q1ookX@Ponj58?o^Q23okXDP0oo^Q202
onj580;okX@P00WokXDPonj48?o^Q23okXDPonj48?o^QB3okX<Oonj48?o^QB000oo^Q2001?o`PC?o
lgmHooB1G?ocP5P2ooB1FP0FooB1FoodPE[om85LooB2G?odPUgom85NooB0GOodPE_olh1KooB0Food
Oe[om81Loo>4F?oaR4WolHM2oo68AooaR4_olHI=oo66AooaQd?olHQ5oo68AP;olHI600golHM5oo67
AooaR4SolHM6oo66A_oaQdKol8E7oo68A?oaQdSolhEPoo:5J_obQ6SolhAY00;olhAX00golhEYoo>4
IoocQ6WolhA]oo>5J?o`PUOokh=7onn1A?o_PTOokh=8onn2B?o_PdSokh9800;okh5700[okh=7onn2
B?o_PdWokh98onn2BOo_PT[okh9;onj1C?o_PTcokh=;0oo_PTP0ooo_PdKokh@ooo5jH_ogFYSomeRJ
ooIKU_oeFYKome^EooMKU_ofFiCom5Z>ooISU_okL8[onfZ8ooaQR_omFHGoo6:@oo]XSOokJXgonf^=
oo]QPOokF7Wonef8oo]FL_okCE_one1boo]EQ_okGh_oneejooi:K_onChKooFFXooaSZOolHJcoo62o
ooaD]oom@X7ooSa=ooi>DoomGg3ooUM^ooi6E_om=TGonS<noo8jAOoY?DOoiS]4onLh>OoY=b_ojCPV
onLo<_oY?EcoiS^:on@iXooD=:[oaCFZol@gZ_o:>Z[ocCZ]olPd]?o6;kgoc3;2oldhaoo:><Woc3S7
oldiaOo;=lGobCK6olH`bOo8;<Koc370olXc_Oo6;kooa2?7ol0Nboo4:l?obcbaolm@VOo;GhCoaf1o
ol]=T_oE>:Kog3:[on0dZooS=jcohCF]omdd[_oO=jgohSZ^omhd/OoG;k3og3>[on0eZOoO=jSogSR_
omLg]_o=<K;obc:/ol@]]_no9L_ob2;KolhUd?nmDfGo`VU2okUUAonjJDco^Va@ok]aD?nkM53o^g=@
oka_C_nmKTco_Fi=okY[C_nfJe7o]FiAokIaDOneLU;o]WM@okEdD_ngMDoo^7Q;okUgBOnkMDOo_G95
okibA?noLdCo_G=6ok]dC?niMT_o]GE5okMa@?niLD3o^WA0okYc@?ngLT3o^7A0olIaC_oELegodWUG
oligE?o7LECo`6QJol=[F_o7M5;ob7=AolE^E?o7L57oag5FolQ/IOo=L67obgEMolQiGoo8Lecob6YU
ola[J?oHRECob8iPokEgL?niMFko]g=_okAcL?ngMG3o_7=_okifKonoN6ko]75kok=_POnoMWKo`7Qf
okefMonoN7Co`GQ`ol5eL?o0MG3o`7Maol=eKOnbM8;oW96VojBUYOnYWigoYj2PojNQXOnITjcoT96b
oiBC/?nLVZgoX::WoiZK[?nCS;OoTJ6eohO?R?n2dWSoP]EooibfP_nkU9;o[;^Ooj?<X_nZ`Z?o[;^O
ojbgW?n[_9co[<2PojoA]?n_d[?o]l6ColBhM_o1_hOo]<NQojc?[On^c[Co/kZRokVOPonnUWGo_IUg
okbLM_nkV7Go^XabokZ8K?niQfco^hA]ok^3KOniPfco^89[okR3JonhOfgo]gi]okJ2KonhPFoo^XEg
okEnSOnbMXWo]GY]ok=jIOnbOV[o]7i^okAkI_neN6?o]7QXok=kKOn^Ofco[Hejok6BQOnXXhkoR<F<
ogW<QomkcH_oP<B:ohjgS_nPX8_oZGZEokMoO?nbZD3o/jhjolZW@`007_oUV47olXlooo:C?oo`UD7o
lYI2oo>C@OocUT;olYY3oo6K@_o^WD7oiIhoombT>OoDZS?ocJ/aolR`;_o1/R_o]K<Vojbd7onX/ago
Y[<KojFc6_nR/aWoXK<Hoj6b5onQ]1OoX[<HojNd7?nY]1koZK<MojRc7P;oZ[<N01SoZK<LojNb6onY
]1[o[K8JojNb6OnAZ1CoTI`Goi:L5onCW1CoUjXQok^dAoo8/U;o`KA:olFcC?ne]DKoTKHhoiJd>_n[
]4Co][=8okFcAonc/dKo/[96ok>dA_nc/dH2ok>dA`06ok>cA_n`]DSo/[M9okNcAong/dKo]K960_nf
/dL03Onc]47o/k<hokFc>?nd/cWo/K<nojnc@on`/d?o/;91ojnd@On`/T7o/;=1ojnd@On`/d400_n`
/d804On_/d;o/k50ojjd@onBcTcoPmI;ohO@B?mndD;oJ]8eoeoB;omIdR_oKK@Qoj6I7OoSQR7okXDP
onj37oo^Q23okXDP00CokX@P00KokXDPonf28?o^QB3okX<Oonj48?o^QB04onj48006onj58?o]PR3o
kXDPonj37oo^Q23okXDP1?o^Q2001_o^QB3okH8Ponj58?o^PaookX@Ponj580CokX@P00KokXDPonf2
8?o^QB3okX<Oonj48?o^QB04onj48006onj58?o]PR3okXDPonj37oo^Q23okXDP1?o^Q2001_o^QB3o
kH8Ponj58?o^PaookX@Ponj580CokX@P00KokXDPonf28?o^QB3okX<Oonj48?o^QB04onj48006onj5
8?o]PR3okXDPonj37oo^Q23okXDP1?o^Q2001_o^QB3okH8Ponj58?o^PaookX@Ponj580CokX@P00Ko
kXDPonf28?o^QB3okX<Oonj48?o^QB04onj48006onj58?o]PR3okXDPonj37oo^Q23okXDP1?o^Q200
1_o^QB3okH8Ponj58?o^PaookX@Ponj580;okX@P00GokX<Oonj48?o^QB3okXDPonj48002onj58003
onj37oo]PR3okXDP00?okX@P00CokH8Ponj48?o^QB3okH8P0_o^Q202onj580;okX@P00?okX<Oonj4
8?o^QB000_o^QB02onj480CokXDP0oo^Q202onj58007onj37oo^Q23okXDPonj48?o^QB3okX@Ponj5
8003onj48009onj37oo]PaookX@Ponj58?o]PR3okXDPonj37oo^Q23okXDP00CokX@P00KokXDPonf2
8?o^QB3okX<Oonj48?o^QB04onj48006onj58?o]PR3okXDPonj37oo^Q23okXDP0_o^Q2001_o^QB3o
kH8Ponj58?o^PaookX@Ponj580CokX@P00KokXDPonf28?o^QB3okX<Oonj48?o^QB04onj48006onj5
8?o]PR3okXDPonj37oo^Q23okXDP1?o^Q2001_o^QB3okH8Ponj58?o^PaookX@Ponj580CokX@P00Ko
kXDPonf28?o^QB3okX<Oonj48?o^QB04onj48006onj58?o]PR3okXDPonj37oo^Q23okXDP1?o^Q200
1_o^QB3okH8Ponj58?o^PaookX@Ponj580;okX@P00GokX<Oonj48?o^QB3okXDPonj48002onj58003
onj37oo]PR3okXDP00?okX@P00CokH8Ponj48?o^QB3okH8P0_o^Q202onj580;okX@P00?okX<Oonj4
8?o^QB000_o^QB02onj480CokXDP0oo^Q202onj58007onj37oo^Q23okXDPonj48?o^QB3okX@Ponj5
8003onj48007onj37oo]PaookX@Ponj48?o^PaookX@Ponj47`01onj480000oo_R2D2onj69@?okhPU
00?okXHUonn89Oo_R2D02Oo_R2D00oo^QRGokhPUonn89@08onn89@03onj79Oo_R2GokhPU00?okhPU
00?okXHUonn89Oo_R2D00_o_R2D00oo^QRGokhPUonn89@03onn89@;okXHU1Oo_R2D00oo^QRGokhPU
onn89@02onj69@?okhPU0oo^QRD3onn89@03onj69Oo_R2GokhPU00OokhPU00GokXHUonn89Oo_R2Go
khPUonj69@09onn89@03onj69Oo_R2GokhPU00KokhPU0oo^QRD7onn89@;okXHU1Oo_R2D2onj69@03
onn89Oo^QRGokhPU00KokhPU00?okXHUonn89Oo_R2D01oo_R2D00oo^QbGokhPUonn89@06onn89@03
onj69Oo_R2GokXHU00;okhPU0_o^QRD2onn89@03onj69Oo_R2GokhPU00[okhPU00?okXHUonn89Oo_
R2D00oo_R2D2onj69@kokhPU00?okXHUonn89Oo_R2D01?o_R2D00oo^QRGokhPUonj69@03onn89@;o
kXHU2oo_R2D01?o^QRGokhPUonn89Oo_R2D3onj69@?okhPU0_o^QRD6onn89@04onj79Oo^QRGokXHU
onj69@;okhPU00?okXLUonn89Oo^QRD01?o_R2D00oo^QRGokhPUonn89@05onn89@03onj69Oo_R2Go
khPU00_okhPU00CokXHUonn89Oo_R2GokhPU0_o^QRD2onn89@;okXHU1Oo_R2D00oo^QRGokhPUonn8
9@02onj69@08onn3;OocPEComHATooB3GOodPUgom8=NooB1GOodPed3ooB3G`03ooB4GoodPV7om85P
00?om8=N013om8=OooF2H_oePV7om8EKoo:8D?oaRDoolX]Aoo::BoobRTOolXY9oo69B_obRT_olHU<
oo68B_obRT_olHQ<0_obRTX05?oaR4[olXY<oo::B_obRTOolhUKoo>7KOocQfcolhM[oo>7K?obQFgo
lhM/oo>6KOodQfkom8M_oo:6I_o`QU;okXA6onj4BOo`QD_ol8E<0oo`QD/01Oo_Q4_okhA=onn4Boo_
Q4col8E<00;ol8E>00Gol8I?oo25D?o`QDkokhA<onn5B`02oo26B`1Foo26COo_Q4cokhM5oo22F?of
Hi;on5FRooIKV?ogFiSomebGooMOUOogGYComenEooAMS_ocGY7onVJDooeQUoomFYCooEZ3ooaWSook
Ji3onfb<oo]WQookG7oonf6?oo]PQ?okDF3ondi_ooaFR?okGHWonemfooe@K?onC7oooF>UooaW[?ol
HJgoo630ooe=[_on>V_ooSe4ooeGGoomGWCooDmUoodjC_ol<TComCM2on/lA?oT?D7ohcXeon<j9OoU
?B3oiSlkonE3J_oQ>YCog3N/om/c[_oE=:OocSBZolXh[_o;?:_oc3^^olLc^_o8<L;odcBoom@i__o=
>/OobSO:oldia_o;>LOobCK8olL_b_o;<<Koc372olP^`oo3:LCo`B?:ol@Ya_o8?K3oce2Nom5JS_o<
GhSoc5NAomM1Y?oO=J_ohCFZon8g[_oR>:l2omle[`3Nomlg[ooS>ZoohCRaomH`/_oH<Jgoh3N[omlg
ZooR?:kohc^comPd]Oo=<[;ob3NVol8^]?o09<koaB;FollVa?o0GFco_7=>okQ^E_njKUCo_G5Aokeb
D?nmLe7o^g9BokaaDOnjLe?o^G9DokAbF?ncLeSo]WMEokQgE?niMU?o^gM@ok]eConkLdco_G98okib
A_nnM4So_W=9okefB_nkMd_o^GI<okIbD?nfLDco^WA3okae@_njMDCo^WI4ok]fA?njNT?o_7e4olYh
D_oDMUcod7QHom5gEOo;LeKo`6YLolA/GOo8MEKob7EDolIaEoo8M5Woc7QIolYaHoo;KVKoc7=SolUl
I?o8N5kob6iTolUVK_oHRECobhmOok=eMOneMGGo]7AfokQgLoo0NW7oaG]`ol=jLOnmN7;o/6f0okI`
Ooo4NgCoa7eeokihN_noNGWo`7Uhol9hMOo3N77o`gM_ol9gLOo5MVoo/GZ;oijNZ_nVYjKoZ:2RojRQ
XOnQUJOoUHZaoiFA/_nHTk7oXijXoj6KZ?nMTj[oVHNaoiN^Y?n<dWkoS=20oh[DQ?nHa8KoXl:Goi_B
W_nOdJ;oY<bTojO3X_nY`:3o[<6Rojg9[Onk`8god[U_ombmJ?oK_6SockY]olBlNOnnai?o/LZXok73
ZOngZhoo^YIjokbHN?nlXG_o_ImkokZFMOnkSfoo^XU^okZ7K_njQVko_85[ok^1J_niP6go^Gm/okN0
K?ngPW7o^89_okR3M_ngP93o]W^<ok=kL?nbOfKo/h9aok>0M?ncOf_o]7aWokEgIOneLEgo/gUQok5m
JOncOWCo[9b3ohfkQomobHcoPLj@oh7=T?mmchcoP<JAohffV_nE]5;o_:hfonVH@OoeQ3oolHE0onb;
@?o/TT3okIQ2onnJA?oaVTColIQ4oo6FAOocUDGom9A5ooBFA_oeVDOomIU9ooBJBOobWTOok:98onBU
A?oKYcgoe:/holb^<_o1/Bgo][HXojjg9On[]R?oZ;HPojBe7OnP]1_oW[DJoj6e6_nQ]A_oY;DNojNf
7onY]B3oZkDQojRg8?nH/1[oTj0Koi>N6onBX1_oTIhNoi:M7OnL[2co_[M=olZgEOnm]dgoWkQ2oiff
@?nd]D[o^;E;ok>eB_nb]DWo/kI90_nd]DT2ok>fBP;o/kE:00Co];I:ok2hCOnd]d_o^;I:0_nf]TX0
3ong]DWo];I4okBd??ne]3_o/kHmok6d@_n`]4Ko/KE5ok2fAOna]DCo/[E5ojnfAOn^]DGo/KA5ok6e
A@02ok2dA@0=ok:eAOnf/T?oZKa8ohODBon0ed[oQM9:oh7BB?mldTGoKm8oog^f9onFW1oo`I4Sonj8
9@02onn89@;okXHU00?okhPUonj69Oo^QRD01Oo_R2D2onj69@03onn89Oo^QRGokXHU00GokhPU0_o^
QRD00oo_R2GokXHUonj69@05onn89@;okXHU00?okhPUonj69Oo^QRD01Oo_R2D2onj69@03onn89Oo^
QRGokXHU00GokhPU0_o^QRD00oo_R2GokXHUonj69@05onn89@;okXHU00?okhPUonj69Oo^QRD01Oo_
R2D2onj69@03onn89Oo^QRGokXHU00GokhPU0_o^QRD00oo_R2GokXHUonj69@05onn89@;okXHU00?o
khPUonj69Oo^QRD01Oo_R2D2onj69@03onn89Oo^QRGokXHU00GokhPU0_o^QRD00oo_R2GokXHUonj6
9@05onn89@;okXHU00?okhPUonj69Oo_R2D01_o_R2D00oo^QRGokhPUonn89@07onn89@03onj79Oo_
R2GokhPU00KokhPU00?okXHUonn89Oo^QRD00_o_R2D2onj69@;okhPU00?okXHUonn89Oo_R2D02_o_
R2D00oo^QRGokhPUonj69@05onn89@;okXHU00?okhPUonj69Oo^QRD01Oo_R2D2onj69@03onn89Oo^
QRGokXHU00GokhPU0oo^QRD5onn89@;okXHU00?okhPUonj69Oo^QRD01Oo_R2D2onj69@03onn89Oo^
QRGokXHU00GokhPU0_o^QRD00oo_R2GokXHUonj69@05onn89@;okXHU00?okhPUonj69Oo^QRD01Oo_
R2D2onj69@03onn89Oo^QRGokXHU00GokhPU0_o^QRD00oo_R2GokXHUonj69@05onn89@;okXHU00?o
khPUonj69Oo_R2D01_o_R2D00oo^QRGokhPUonn89@07onn89@03onj79Oo_R2GokhPU00KokhPU00?o
kXHUonn89Oo^QRD00_o_R2D2onj69@;okhPU00?okXHUonn89Oo_R2D02_o_R2D00oo^QRGokhPUonn8
9@03onn89@;okXHU00001OoaRR[ol8XZoo6;:_oaRR[ol8PZ00;ol8XZ00?olHXZoo2::_oaRbX00_oa
RbX00oo`R2[olH/Zoo6::P02oo6;:P;olHXZ00?olH/Zoo2::_oaRRX00_oaRbX2oo6::P03oo2::_oa
RR[olH/Z00?olH/Z00GolHXZoo6;:_oaRb[olHXZoo6;:P02oo6::P03oo6;:_o`R2[olH/Z00;ol8XZ
00golHXZoo2::_o`RR[olH/Zoo2::_oaRR[olH/Zoo28:_oaRb[ol8XZoo6::_oaRb[ol8XZ00;olHXZ
0ooaRbX01oo`RR[olH/Zoo6;:_oaRb[ol8XZoo6;:_oaRRX00_oaRbX00oo`R2[olH/Zoo6;:P02oo6;
:P04oo6::_oaRb[ol8XZoo6::P;olH/Z00?ol8XZoo6::_oaRbX01?o`RRX4oo6;:P;olHXZ0ooaRbX0
1Oo`RR[olH/Zoo6;:_oaRb[olHXZ00;olH/Z00Ool8XZoo28:_o`RR[ol8XZoo28:_oaRb[olHXZ00?o
lH/Z0_oaRRX01?o`RR[olH/Zoo6;:_oaRRX3oo6;:P06oo6::_oaRb[olH/Zoo2::_oaRb[ol8XZ0ooa
RbX00oo`R2WolH/Zoo6::P05oo6;:P05oo28:_o`RR[olHXZoo6;:_oaRRX00_o`RRX3oo6;:P03oo2:
:_o`RBWolH/Z00?olH/Z00ColHXZoo6;:_oaRb[olHXZ0ooaRbX00ooaRR[olH/Zoo6;:P02oo6;:P04
oo2::_oaRb[olH/Zoo2::P;olH/Z00?ol8XZoo6;:_o`RRX00_oaRbX01?o`RR[olH/Zoo6::_o`RRX3
oo6;:P04oo6;:Oo`R2[ol8XZoo28:P?olH/Z00_olHXZoo2::_oaRR[olH/Zoo6::_o`RR[olHXZoo6;
:_oaRR[ol8PZoo2::P04oo6;:P05oo6::_o`RR[ol8PZoo6;:_o`RRX01OoaRbX00ooaRR[olH/Zoo6;
:P02oo6;:P03oo2::_oaRb[olH/Z00;olH/Z00OolHXZoo6;:_o`R2[ol8XZoo6;:_o`RR[olH/Z00?o
l8XZ00ColHXZoo6;:_oaRb[olH/Z0_o`RRX4oo6;:P06oo6::_o`RR[olH/Zoo6;:_o`RR[olH/Z0_o`
RRX00oo`R2[olHXZoo6;:P04oo6;:P04oo6::_oaRb[olHXZoo2::PColH/Z00Gol8XZoo6;:_oaRb[o
l8XZoo6::P03oo6;:P04oo2::_oaRR[olH/Zoo28:PColH/Z01Col8PZoo29:Oo`RR[olHT/oo>2B?of
QFcomXETooF5G_ofQ63omXERooF4H_ofQF;omXEQooJ5HoofQ6;omXERooF5H_oeQ6?omH=QooF5HP;o
mXES0_ofQ6809?oePfKomXIXooB:F_ocS4golXY;oo>=C_ocS4kom8a?ooB=CoocSDkom8e?ooB<D?oc
RToolha>ooB<CoocS4kolhY>oo>=B_odS5KomHU^ooB8L?oeR6oomHU_ooF9L?odR77omHQaooF9M?od
RFoolXMPoo67DOo`Qd_olHQ>oo68D?o`Qe3olHQ@oo27D0;olHQ@00golHE@oo67D?oaQe3olHMAoo67
DooaR5?olHMBoo:8DOobR53olXM@oo:8D?oaQe3olHMA00;olXQA00WolHY9oo68DOodKXGonEBWooQM
W?ohGYSomefJooMPV?ohGiP00_ohGiH0ooogEigon4V_ooe?[_omHI[oo627ooeOPoolJi3oo6jAooa]
S_olH87oo5j9oo]SR_olF6goo5AhooaHS_olGhconf9fooaFK?onBWSooV6NooeZ/?omH[;oo5jkooe8
VOon=eWooTM=ooeOK?omFg?ooDIKoodfB?oh=TSok3a9on8o@?oQ?COohSXOonDm7OoY?CooiSmcon8j
WooH=ZkoeC>`omLd[_oG=:SoeC>Woldh[Oo;?ZcobSb_olPe_?o9<LCoeCK0omPj^ooC>l3ocS[6ol`h
bOo<>LSob3G:ol/bb_o<</Cobbk4olLXb?o09LWo`BW5olTi]_o>DIgocef;olaKS?o>FI7oedjPon4k
[_oS=ZgohcN/on<h/?oQ>K3ogcN`on0f/?oP=[7ohcZcon<j/_oJ=;7oe36`omde[_oQ=ZoogSR`on@o
/_oS>ZkofSB]olhf[?o4?Igo_bjiolHRf?o69<ooc2^iol=JOOo0MU;o_gEBok]aE_nhKeSo^GAGok]i
F?nkO5Oo_7]HokUhFongN5[o]gAKok]dEonkM5Go^W=EokabDonlLE;o^fmAokebC_nnMDco_WQ=okej
C_njN53o^WI?okaeCOnlMDco^GA@okUfC?nmNTGo_WU5okeiAonlN4Oo_G]8ok^0AonnP4WocWMGomAf
G?oAMeWodWQHolifFOo1Keko`f]QolQeF_o9MeOob7EMolagGoo=NEkoc7IPola_J_o<LV[obg]Zol]l
HOo;M6;oafIcom^?E?o>TEoo/G1hokIcN_njNg[o`7edolEmL_o6O7Co`7QhokaiNOnbL8?o^gAmolQl
L_o7OWGo`G]kol1jOOo1Nggoa7ejolAlNOo5O7Goa7]dolQjLOo9Mg;o[X2Eoj6TZ_nXZJGoZ:JTojJP
YOnJRJgoVHn^oiJ>/onPVZkoXin]oj6N[OnLT:ooVh^coiRmXOn>eH7oU<n8oi;AS?nCcXGoUm6Boi_B
W_nLdj7oWM>Toik?YOnRcZCoYLZQol>jM_oO_VSoel9domO0KooM`6WogL1ZomRjJ_o<^WGo_lFAok>o
UOndZhWo^ieook^HOOnlWGgo_:1kokjPN_nlV7Ko^XicokZ<L_nlR6oo_HA/okf2K_nkPFgo^gm[okN4
K?nfQ7;o^H1^okV4N_njQ8co]h6:ok5nN_ndOF_o]85_ok>3M?ncPG3o/gm[okAjJ?ndNFWo]7]VokIi
I?nfNVOoZX]/oiJQMOn8]gooQ<J9ogk?SomkcY3oPLfNohflI_nW^2[o`K4bomJ^?OoOXd3ojiQ3oo>=
AOoaQD?okXM2onj?@oo^UDCokYU5onnLAP002?oaWTKolYi6oo:LB?ocV4[oliI:oo>EB?oeUTWomYQ:
0_ofUD/07OofVT_omJ5;oo6VBooXYDSohJI4omN[?Oo=[SKoa;<aokjg;ong]bgo[KPWojFh8OnQ^1ko
XKLNoj>h7onK]1goUJLNoiNR8OnFY1ooU:@RoiFT9_nEXBGoTj8Qoj2a<oo1^E;o^;QAojjhBonh]e3o
^KM@00;o/kQ=0_ne]d`01One]dgo]KM<okBgCOne^4go];Q=00;o]KM=00_o];Q>ok>jC_nh^4go^KM=
okNhCOnf^4go]KQ8okFh@?nf]cko];M2ok:gB002ok>gB006ok2gAona]dOo/[M8ojnhBOn`^4So/kI8
0_nb]dP03onc]dSo/KQ8ok:fAond]4KoVlI<ohGHD?n6eU3oR==?ohgAD_n9e5?oQL]1oi6a9onMWb;o
fXhXoo2::P02oo6;:P;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03
oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03
oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03
oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03
oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03
oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P04
oo2::_oaRb[olH/Zoo6::P?olH/Z00KolHXZoo6;:_oaRb[ol8XZoo6;:_o`RRX3oo6;:P03oo28:Ooa
Rb[olHXZ00GolH/Z00Gol8PZoo2::_oaRR[olH/Zoo6::P02oo2::P?olH/Z00?ol8XZoo29:OoaRbX0
0ooaRbX01?oaRR[olH/Zoo6;:_oaRRX3oo6;:P03oo6::_oaRb[olH/Z00;olH/Z00Col8XZoo6;:_oa
Rb[ol8XZ0_oaRbX2oo6::P03oo2::_oaRb[olH/Z00;olHXZ0ooaRbX2oo6::P03oo2::_oaRb[olH/Z
00;olHXZ0ooaRbX2oo6::P04oo2::_oaRb[olH/Zoo6::P;olH/Z0_oaRRX00oo`RR[olH/Zoo6;:P02
oo6::P?olH/Z0_oaRRX00oo`RR[olH/Zoo6;:P02oo6::P?olH/Z0_oaRRX00oo`RR[olH/Zoo6;:P02
oo6::P?olH/Z0_oaRRX00oo`RR[olH/Zoo6;:P02oo6::P?olH/Z0_oaRRX00oo`RR[olH/Zoo6;:P02
oo6::P?olH/Z0_oaRRX00oo`RR[olH/Zoo6;:P02oo6::P?olH/Z0_oaRRX01?o`RR[olH/Zoo6;:_oa
RRX3oo6;:P06oo6::_oaRb[olH/Zoo2::_oaRb[ol8XZ0ooaRbX00oo`R2WolH/Zoo6::P05oo6;:P05
oo28:_o`RR[olHXZoo6;:_oaRRX00_o`RRX3oo6;:P03oo2::_o`RBWolH/Z00?olH/Z00ColHXZoo6;
:_oaRb[olHXZ0ooaRbX00ooaRR[olH/Zoo6;:P02oo6;:P04oo2::_oaRb[olH/Zoo2::P;olH/Z00?o
l8XZoo6;:_o`RRX00OoaRbX00007oo:><OobSc7oli0`oo>@<?ocSS3olXd_oo:?<@02oo>>;`09oo:=
;oocSS3olXlaoo:><OocSS3olXhaoo>><?obSBoolhh`00;olhh_00?olXhaoo>@<?ocSbl00_ocSS00
1oobSc7olXd_oo>><?obSBoolhh`oo:=;oocSRl00oocSS005?obSBoolhh`oo:=;oocT33olXlaoo:>
<OocSboolXhaoo:=;oocSRoolhh`oo:=;oobSc7oli0`oo:=;oobSS7olXd_oo:><OocSS3oli0`0oob
SBl01OocSboolhh_oo>>;oocSRoolXha00;olhh`00?olXd_oo>><?obSc400_ocT3000oocSS3olhh_
oo>?;`02oo>?;`03oo>>;oobSBoolhh`00;olXha01golhh`oo:><OobSc7oli0`oo>?;oocT33olhh`
oo:><OocSS3olXd_oo:?<OocT33olhh_oo:><OocSS3olhh_oo>@<?ocSRoolhh`oo>@<?ocSS3olhh_
oo>><?obSS7olXlaoo>>;oobSc7olhh`oo>@<003oo:><@08oo>><?obSS7olhh_oo>><?obSS7olXla
oo>><?obSBl2oo:><@07oo>><?obSS7olhh_oo:><OocT33olhh_oo:><@06oo>><004oo>>;oocT33o
lhl_oo>@<0;olXla00?olXhaoo>@<?ocSRl00_obSBl02_obSS7olXd_oo>><?obSc7olXd_oo:><Ooc
SS3olXd_oo>?;oocSS03oo:><@0<oo>><?ocT33oli0`oo>>;oocSS3olXlaoo:=;oocSS3olhh_oo>@
<?ocSRoolXha0_ocSS002OobSS7olhh`oo:><OocT33olhh`oo:><OobSc7olXhaoo:=;`02oo>><006
oo:?<OocSbooli0`oo>?;oocT33olXla0_obSS401_ocSS3olXd_oo>>;oobSBoolhl_oo>@<0;olhh`
00OolXlaoo>><?ocSS3olhh`oo:><OobSc7olhh_00;olhh`00ColXhaoo>>;oobSc7olhh`0_obSc40
0oocSS3olXd_oo>>;`02oo>><007oo>@<?obSBoolXd_oo>?;oocT33olXhaoo:=;`03oo:><@0;oo>>
;oocT33oli0`oo>@<?ocSRooli0`oo:=;oocSS3olhh_oo>?;oobSBl00_obSS403?obSc7olhh_oo>>
;oocSS3olXhaoo>><?ocT33olXd_oo>@<?obSBoolhh`oo:=;`?olXha00_olhh_oo>@<?ocSRoolXha
oo>@<?ocSS3olXhaoo>><?obSS7olhh`oo:><@02oo>><0;oli0`00Golhh_oo:?<OobSS7olXhaoo:?
<@02oo>><006oo:=;oocSS3olXhaoo:><OocSRoolhh`0_obSc403?obSS7olXlaoo>@<?odRD3omXIT
ooN8J_ogQfComhIUooN7I_ofQVComXIUooJ6IP;omhMU017omhUVooN7IOofQfGomhMWooN6J_ogRFOo
mXMWooJ7I_ogQfComhMYooN7K?ogQV[omXIVooJ<G?oeSe7omI5AooF?E002ooF?D`0CooB?E?oeSeCo
mHmCooB@E?odSU;om91EooF@E?odSe;om8mEooJ<KOofRgOomHYcooF;M?ofRg?omH]dooF;N?ofS7So
mH]`oo>:G@02oo>:DP0Boo::EOocRUGolhYEoo:9EOocRUGolXYFoo:9EOocRUKolhaFoo::EoobReWo
lXUEoo>:EoocS5KolX]Eoo>;EOobRU?olh]E0_ocS5H0EOocReGolhaFoo>=D?ocS4gom7egooUMXOoj
G:3onF:JooQOW_oiGikonF:JooQQV_ohFikonU:/oo/na?ol=/coo5NXooa[ROomGh?ooFF:ooa_TOol
Ki3oo6R9ooaRQ_olHX_oo5McooeBN?olG9;oo6NBooa/POomGW?ooTacooiISoomJ[7ooFBmooeG]?on
?WkooSI7ooiBG?omI7_ooE=[oodkCOoj=dSolSe>onQ0A_oP@SGohSdVon@o9ooY@Tooj3mlomhmX_oF
=K7odc>comLe[_oK=JgofCFZomHeZ?oF=ZcocSj^olTm/oo7<l3obc;6omHj_ooH?KgodcW1om@k`?oB
>lKobSW<olPfcOo<<LgocRo7olL[b?o08Loo`RS9olDi^?o=Cj3odEj@oliOSOo>FI?ofE6Oon97[_oU
>[Coi3Z^on<k[ooS>K800_oR>[40g?oO>;?ohCJeon@k]OoS>kCogSNbomDd/_oI<k;ohCV`on4i[OoS
?joohcn^omhnX_oK?JGoccb]okm2Y?o2<<7oaR7Kokl]__o5<;7o`d^Dok]eGonmOUSo^gaLokUiG_nk
N5oo_WMOol5iF_o4NE_o_WAKok]bFonlLU_o_g=IokacFOnnLeOo_g=FokeaEonkL5Oo^gEDokajDOnl
Ne;o^gQBok]eDOnnMU3o_gU>ol1kD?nnO57o_7Y>okilB_nnNd_o_Ge;okf1COnnQDko_8M=okj6Coo?
OEgoe7YPom=kGOoCO5gocgYNol=cHOo1KVKob7QOolYjGOo:MfCocGUSolmlHOo>NF;ocG=/olifKOo<
Mg3ocWYXoliiI?o;KW3og95Jom2EIOndMGgo_7Ulol5nN_o2OWSo`gejolAmN_o1NWgo_WYlok=cQonm
MX7obGifolQoMoo5OWco`G^1ol5kP?o7OgcoaWmnolF0O_o4OWgoaGakolimL_o9NGKoZhZNojJ`[OnX
Z:SoZZNUoij@[OnHS[7oUi6aoi^D/?nUX:goXin^oj>Q/?nNTKCoWiNeoiS8X?n?eh?oVLn?oiO@T?nA
dHOoVM>HoioCYOnOeJSoW]FXoikAXOnNdZ?o]<V<omO5KooDaGCod<9homC1M?oH`G3oel9eom_0L?oE
]f_od;abolRoP?o5/h;o`IihokVDNonjV7go_IelokfPOOnlW7[o^iMfokVBMOnjSG?o_8U`okj5L?nm
Pfko_85/okN5K_nhPVko^WmaokV0MOnhQ7co/X><ok=lQOndOW3o]8=_okB4MoncPWKo]7m]okAmK?nc
OFgo]7i[ok:0JOnbOFCo]7MRoif;H?n<X6WoR:mjoi2gP?nQ/X_oYZf9oj2k@onZ]RcoZKP^ojbi<Oo1
]cSodZ`oomjK@_o`U4SomHi8onn9A_o^S4OokI58onfEB?o]VTWol9]:oo6MC?obX4colZ1=oo>OC?ob
WD_olYa<oo:MC?ocWDcoliY=ooBJC?oeUdgomIE?ooJFCoogVDoomYm>oo>TCoo[YDkoi:M8omRZ@?o?
[c[obkHiokRi<onH]B;oU:hNoiB/7_nCZbGoUZL[oiNU:?nDY2SoTj<SoiN/8_na]cgo][U=ok>iC_nf
^582okFiD`0`okNiD_nf^E;o]kU?okJiD?ne^U7o]KYBokJiD?ne^Doo][U@okFiDOnf^E7o];YBokNk
D?nj^E7o]kY@okNkD_ne^dgo]K]4okFk@onc^TWo/kU<okBiC?nd^D[o/[U;ok:iC?nc^Tco/;Y<ok6i
Bond^Dco/kU<ok:iBon`^T_o/[U:ok6kC?ne^4ko]kU?oi_>Eon8fEOoRMECohWDD_n9eEGoT]=FojW0
@OnS]3;o[j</on^B<?ocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_
0_obSS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;ooc
SS3olXhaoo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_ob
SS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3o
lXhaoo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_obSS40
2?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3olXha
oo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_obSS402?oc
SS3olXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_0_obSS402?ocSS3olXhaoo>>;oocSS3olXhaoo:?
<OocSS3olXd_0_obSS401oocSS3olXhaoo>>;oobSS7oli0`oo>>;oobSS401_ocSS001?ocSRooli0`
oo>?;oocT302oo:?<@03oo:><OocT33olhh_00;olXd_00[olXhaoo:=;oocSS3olXlaoo:=;oobSS7o
lhh`oo:=;oocSboolhh`0oobSS403?ocSS3oli0`oo>@<?ocSRoolhh`oo:?<OobSBoolhh`oo>>;ooc
T33olhh_oo:><@;olhh`00OolXhaoo>>;oocSS3olXhaoo:?<OocSS3olXd_00;olXha00Solhh`oo:>
<OocSRoolhh`oo:><OobSc7olhh`oo:=;`;olXha00Solhh`oo:><OocSRoolhh`oo:><OobSc7olhh`
oo:=;`;olXha00Kolhh_oo>><?obSS7olXlaoo>><?obSBl2oo:><@08oo>><?obSS7olhh_oo>><?ob
SS7olXlaoo>><?obSBl2oo:><@08oo>><?obSS7olhh_oo>><?obSS7olXlaoo>><?obSBl2oo:><@08
oo>><?obSS7olhh_oo>><?obSS7olXlaoo>><?obSBl2oo:><@08oo>><?obSS7olhh_oo>><?obSS7o
lXlaoo>><?obSBl2oo:><@08oo>><?obSS7olhh_oo>><?obSS7olXlaoo>><?obSBl2oo:><@08oo>>
<?obSS7olhh_oo>><?obSS7olXlaoo>><?obSBl2oo:><@07oo>><?obSS7olhh_oo:><OocT33olhh_
oo:><@06oo>><004oo>>;oocT33olhl_oo>@<0;olXla00?olXhaoo>@<?ocSRl00_obSBl02_obSS7o
lXd_oo>><?obSc7olXd_oo:><OocSS3olXd_oo>?;oocSS03oo:><@0<oo>><?ocT33oli0`oo>>;ooc
SS3olXlaoo:=;oocSS3olhh_oo>@<?ocSRoolXha0_ocSS001OobSS7olhh`oo:><OocT33olhh`007o
lXha00000ooeTcKomI@gooFD=`03ooFC=P06ooBC=ooeTcKomI@gooBC=ooeTcKom98f0_oeU3L01_od
TSKomI<fooFC=_odTSKomI@gooFC=P;om9<g00ComI@gooBC=oodTcOomI@g0_odTcL00oodTSKom9<g
ooFC=`02ooFD=`;omI<f01KomI@gooFC=_odTcOomI<fooFD=oodTcOom94gooBB=_oeTcKom9<gooFC
=_oeU3Oom98fooFD=ooeTcKom9<gooFD=oodTSKom9<gooBB=_oeTcKom9<g0_oeU3L02OoeTcKom98f
ooBC=ooeTcKom98fooFC=_oeU3OomI<fooBC=`02ooFC=P?omI@g0oodTSH01_oeU3Oom9<gooBC=ooe
TcOomI@gooBC=`;omI@g00?om98fooFC=_oeU3L00ooeU3L01OoeTcKomI@gooBB=_oeTcKomI@g00;o
m9<g00KomI<fooBC=oodTcOom98fooFD=ooeTcH2ooBC=`07ooBB=_odTcOom9<gooBC=ooeU3Oom98f
ooFD=`02ooBC=`0=ooFD=ooeTcKomI@gooBC=oodTSKomI@gooFC=_oeU3Oom98fooBC=oodTSKomI<f
ooFD=`02ooBC=`;omI<f00?om98fooBC=oodTcL00_oeU3L01?oeTcKomI@gooBC=oodTcL2ooFD=`03
ooBC=oodTSKom9<g00;omI@g0_odTSH00oodTcOomI<fooFD=`02ooFD=`08ooFC=oodTcOom98fooBB
=_oeTcKomI@gooBC=ooeTcH2ooBB=P0;ooFB=_oeTcKom9<gooFC=_odTcOom98fooBC=ooeTcKomI@g
ooFC=_odTcL01?oeU3L2ooBC=`04ooBB=_oeU3OomI<fooBB=P;omI<f00?om9<gooFD=oodTSH00ooe
U3L01_odTSKomI@gooBC=oodTSKomI<fooFD=`;om9<g00WomI<fooFD=ooeTcKomI<fooFD=oodTcOo
m98fooFD=oodTSH00ooeTcH01oodTSKomI@gooBB=_oeU3Oom98fooFD=ooeTcH01?odTSH02?oeU3Oo
mI<fooBC=ooeU3Oom9<gooFD=ooeTcKomI@g0_odTcL00ooeTcKom98fooFC=P02ooBC=`05ooBB=_od
TcOom9<gooFD=oodTcL00_odTSH03_oeTcKomI@gooBC=oodTcOomI<gooFC=_oeU3OomI<fooFD=ood
TSKom9<gooFD=oodTcOom94g0oodTSH00oodTcOomI@gooFD=`02ooBC=`08ooFC=_odTSKomI@gooBC
=ooeU3Oom98fooFD=ooeTcH2ooFD=`03ooBC=ooeU3OomI<f00;omI@g00?omI<fooBB=_odTcL00_oe
U3L2ooBB=P03ooBA>oofRESonHY]00;on8YZ01?on8UYooR9J?ohRFWon8YZooR9J_ohRFSon8YXooR9
J?ohRf[on8Y[ooR;K_ohRFkon8Q[ooR:J_ohRV_onHU`ooV:L?ohRV_omh]Y00;on8U/00_on91SooNC
FOogTeOomY=IooNDFOogTeSomi=IooNDFOofTeWomY=JooNCFP02ooJCF006ooNAJOogSW[omhihooN>
MoogSgOomhig0_ogSg/05_ofSVcom8iNooB?F?ocSUWom8eKooB?FoodSecom8mKooF?FooeSU[om8iL
ooB=GOodSUgomHiLooB>FooeSe[omHmIooB?FoodSe[om8iIooB?FoodSUX2ooF?F`1oooF@F_oeSeco
mHmIooFBCooeRVWonFRJooYMXoojI9gonFBOooQOXooiHikonF2OooYF[OokB;kooCS<oo`ib_ojCk;o
nfRIooaZROomGXKooFZ=ooeaT_omKY3ooF>4ooaSS_omFWcooE9eooeMTOomJ93oo6j4ooaXO?onDWKo
oU^:ooeY[OomI<3ooDfXoohfI_on?TKooUe]ooiQOOomB5koncI1oo<lAOoZA4WohT<hon909ooU?SCo
iTAMonLmSooO?JcoeSVaom8g[OoH<k?ofcF`omXf[?oI=JooecN/omThZOoD>ZgobSbeolLe`oo>=LWo
ecg2omU0__oC>/?odCW5omLl`_oC>/WobSKBol/bcOo:;L[oa2C@ol0Tcoo4=[oocE2UoliOTOo?HXko
cU^Com9GVooRD:Wok46eonLi]_oS>[?oi3^don<k/ooS?K;ohSfbon8k]?oR>;Soi3Zhon<n]OoR?K?o
g3NdomLd]_oR>;?ohcVbon<m/OoVAK;ogdJYoma8Y?oLA:[odCnbol=3[_o4;lgoaRGFol0k/_o9>KOo
cSbeokebKonoOF3oa7aPolEjG_o6MeooaGEOolIeG_o5MUko`GILol5iG?o0N5ko_gMNol5gFoo2Me[o
`7IKol5iG?noNUWo_g]Eol9oD`02ol1jE00?ol5lDoo1OU?o`GiCol5nE?nnO5Co_7a@okenD?nnPe7o
_XMAokf7D_noQe;o_HUAol67EooCOf?oeWaT00;oeWeR01KoeGiQolYgI?o3L6WobWYWolimI_o=Nf[o
cgiWolmoIOo>O6KocWI^om9lKoo?Ng;ocWUbolijK?o=MG3ogiMLom>JJonmO7oo`7elol9oNonoOH3o
`Gb20_o6P7h0XOnnOH;o]GJ9okmkQOo:PW_obh=jolV1O?o2OH;oaH23olZ3Ooo8PX;oaX:2olJ3Poo6
PH?ob81oom:1Loo5Nh3oZYNWojR`/_n^[jWoY9j^oiR=/onJT[;oV8jeoj2M/OnUXZkoYZ>]ojBQ[_nP
TkCoY:FeoiKAW_n@f8KoWm:HoicAU?nBdh_oV]FLoj?EZonSe[7oY=F^oj7CZOn^dI_ocLEfom;8M?o>
aGWobl=jom73M?oEa7?oe<=homFoN?oI_77of[m]omS0LooE]Vkob:A`okbJNonjUWco_9UmokfMO?nn
WW[o_Yahok^GMonkTGGo_8ecokb9M?nmR7?o_HQaokZ9L?nkQ6oo^h5fokR0KongQ77o]h2=okIkS?ne
OgKo]XA`okJ6N?ndPGGo/h5^okB1L?neP77o/gi[oj^1I_ndM6;o/WIPojJ9HOnXREoo[h9NojbAI_n[
VHGoXKAQojbl<ona]S;oZKXaojJl<OnY_C;o/[dgolBi@?oB/4?ohZM9oo6JC?ocS4[olXU9oo6>B_o_
TTgokYE<onnIC_o`VdoolYi?oo>QD?odXdoom:A@oo:QDOobWe7olYiAoo:MD?obWU3olY]@oo6KD?oc
W57oliU@ooBHDOoeUU;omYUCooRIE?oiWUGoh[IAokbm?Onc_3Ko[[`goink=_nD/cKoTj`aoi6];?nK
/b[o[[@^ok^a=Ong/SKo];DhokFg@Onc^DKo/ka;ok>lD?ne_EOo]keHokVlF?ni_EOo^;aEokNkE?ng
_ECo][eCokJnEOng_EGo]kaDokJnEOnh_eKo^;iDokRmE?nf_E3o]ki7okFnB?nc_e3o/keB00;o];e@
01_o];e?okJlD?nc_E3o/[a?ok>mC_nc_Dgo/Ki?ok6mCond_E7o]keCokRmDong_UGo^kYBok;0EOnB
eeWoQ]]Foh[FEOn9eEGoRMMGojS8C_nk_4GoYl0mom>S=oodTSKomI@gooFC=_oeU3L00_odTcL02?oe
U3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD
=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3Oo
mI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooe
TcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<f
ooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKo
mI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD
=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g
0_odTcL03OoeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@gooBB=_odTcOom98fooFC=_oeU3L0
0_odTcL2ooFC=P03ooBB=_odTcOom9<g00;omI@g00ComI<fooFD=oodTcOom9<g0_oeU3L00oodTcOo
m98fooBC=`02ooFD=`;om98f00?om9<gooFC=_oeU3L00_oeU3L02?oeTcOom9<gooBB=_odTSKomI<f
ooFD=oodTcOomI<f0_odTSH04_oeTSKomI<fooBC=ooeTcKom9<gooBB=_odTcOomI<fooFD=oodTcOo
mI@gooFC=_oeU3Oom9<gooBB=_oeU3OomI<fooFD=`;om9<g00SomI@gooFC=_oeU3Oom9<gooBB=_oe
U3OomI<fooFD=`;om9<g013omI@gooFC=_oeU3Oom9<gooBB=_oeU3OomI<fooBC=ooeU3OomI<fooFD
=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g
0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=ood
TcOom98fooFD=ooeTcKomI@g0_odTcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_od
TcL02?oeU3OomI<fooFD=oodTcOom98fooFD=ooeTcKomI@g0_odTcL03OoeU3OomI<fooFD=oodTcOo
m98fooFD=ooeTcKomI@gooBB=_odTcOom98fooFC=_oeU3L00_odTcL2ooFC=P03ooBB=_odTcOom9<g
00;omI@g00ComI<fooFD=oodTcOom9<g0_oeU3L00oodTcOom98fooBC=`02ooFD=`;om98f00?om9<g
ooFC=_oeU3L00_oeU3L02?oeTcOom9<gooBB=_odTSKomI<fooFD=oodTcOomI<f0_odTSH02ooeTSKo
mI<fooBC=ooeTcKom9<gooBB=_odTcOomI<fooFD=ooeTcKom9<g00ComI@g00001?ogUccomiTmooJG
?OogUc`2ooNI?@0>ooNG??ofUScomiPlooNH??ogUcgomYHmooNG??ofUcgomYHlooNG?OofUSgomiPl
ooJF??ogVCd2ooNH?009ooJG?OogUcgomYDlooNG?OofUScomiPlooNG??ofUCcomiPl00?omYDl00So
miPlooNG??ofUcgomiPlooJG?OofUCcomiPlooJG?@;omiPl00komYLmooNH??ofUcgomiLlooJF??og
UcgomiPlooJF?OogV3comYDlooNI?OofUSgomYHlooJF?@?omiLl00ComiTmooJE??ogV3comiLm0_og
VCd03?ofUSgomiTmooNH??ogUcgomYHmooNH??ogVCgomYHlooNI?OofUcgomiTmooJE?0;omYLm00Ko
miLlooNI?OofUScomYLmooJE??ofUSd2ooNG?004ooJF?OogVCgomiLmooJF?0;omYLm00KomiTmooJG
?OofUScomYHmooJG?OogVCd2ooJE?004ooJF??ogV3comYDlooJE?0?omiLm00komYDlooNI?OogUcgo
miLmooJF??ofUcgomYDlooJF??ogVCgomiLlooNI?OofUCcomYHlooNH?0;omiLm00OomiLlooJF?Oof
UScomYLmooNG??ofUcgomiLl00;omYHm00komiPlooJF??ogV3comYHmooJF??ofUCcomiLlooNG?Oof
UCcomYLmooJF?OofUScomiLlooJE?0;omYHm02oomYHlooJG?OogV3comYLmooJF??ogV3comYDlooJF
?OofUCcomYHmooNH??ofUCcomYLmooNH??ofUcgomYHlooNH??ofUScomYLmooJF??ofUSgomYLmooNG
??ofUcgomYDlooNI?OofUScomYLmooNG?OofUScomYDlooNG??ofUScomiLmooJF??ogUccomYLmooJF
?OogV3comiLmooJG?OogVCgomiPlooNG??ofUCcomYHlooNI?@02ooJE?00RooNG??ogV3comYDlooJG
?OofUScomiPlooJG?OofUCcomiTmooNG??ofUCcomiTmooJF??ofUCcomiTmooJG?OogUccomiPlooNI
?OofUScomiPlooNI?OogUccomYLmooJE??ogV3comiLmooJF?OofUcgomYHlooNH??ofUCcomiPlooNI
?@;omYHl00SomiPlooNG?OogV3comiLlooNI?OofUScomiPlooNI?@;omYHl00GomYLmooJF??ogUcco
mYHlooNG?002ooJF?@07ooNI?OogUccomYDlooJE??ogV3comiTmooJF?002ooNH?0;omiTm00WomYHm
ooJG?OofUcgomYDlooNI?OofUScomYHmooNG??ofUS`00_ogV3`00oofUcgomiPlooJF?002ooNG?008
ooNG?OofUCcomiPlooJF?OofUScomiLmooNH??ogUc`2ooJG?@0GooR@D?ojRg7onXeaooZ>K_ojS6go
nXe/ooV;K?oiRfgonXa]ooV;K?oiS6conXe[ooV<K?oiS6oonXa`ooV<L?oiRg7onX]aooV=LOoiS7Co
nHaeooV;KOojSf`00_oiS6h01OojSFoonH]`ooV?J_ohUEoon9MK00?on9EN00Son9EMooREG_ohUEko
n9EMooNEFoohUF?onI9jooRAOP;on95k00_on95mooRAP?ogT7_omY1ZooFAG_ofTecomI9PooF@Goof
TV3omYAOooFBH002ooJBH03oooFAHOofTV7omI9RooFAHOofU63omYAOooJBGoofT5komY9OooJCGoof
Tf7omY1PooJBG_ofT5komY9NooJCGooeT67omYAIooJBHOoiM9?onf2Woo]VX_okJ9oonVJPooUQXooi
G:[ondnhoodnaoom><kooD74oo]D[OojH9gonfJLooeWS_omIHWooFj@ooeaUOomJ8gooF2;ooeKPoom
EgSooFB=ooe/SOomK8Goo6b1ooiIN?onFX;ooFjXooeV__onA9CooSAFooi:E?onIGcooUUiooi1Doog
>C[ojd<oon=3?_oR@c?oj452onM5J_oU@YWofCj]omXj]?oD=k3oeCJ^om`c]_oM=[;ofCR/omHg[ooF
=k3ofCR[omXlZOo>>;OoaSK6om0gb_oJ?/?ofT71om@l`oo?=lOoeCg5omU4`?oA@<Cob37?ol<Vconm
9<go`CC1ole?ZOoBGiOocf>?om1OTooDEYoogUFTonUBZ_o[@kOoiC^fon<k]_oU?;KoiCfeonDl]?oS
?;KohcZion@h_?oT>[_ohSjgon4l]_oQ>[Kof3Biomhd^_oV>[OoicZhonQ6]ooRCK3ogDVZomi;ZOoR
B:gof4F`olE1^?o6:=Cob2o5olTo[oo<?k;ofCBoolU[Moo7O63oagIRolUiHOo;O63obWaQolEhI?no
MV;o`7QPol9jH?o0NF7o`7MPol9jG_noNUko`7]Ool=lG?o3OEWoaH1Fol9mEoo0OUWo`WmGolB2E_o4
PEKoa81Gol>0F?o1P5Go_h9Col67D_nnREKo_hQEol:9EOo2ReGo_h]GolF3G?oIOVKof7aWomMoI_oH
OVOof7mUolehIOo7LfcocWU`om5lK_o?OFgoch1[oln0JOo?OfWocWQ`om9mL_oBPG?ocgaeolafMOo<
M7CohiaQomBGLOo1PH7o`Gj0okmnPoo1OX;ob821olV3P?o7Q8;o_gn6ok]jR_o2OXKobXB0ol^3Ooo9
PgooaH63olR1Q?o;QXCobhN4olV3QOo8Q8GobHB5olR3R?o;Ph?odH5hol1oS?nXW:oo[k>aojf[[onO
TkKoViBfoiZ@]?nJTKKoX9fbojJR[onXYJooY:2aojFK]OnU/;CoTmBFoi;IROnSdikoW=BFoi;DR_nJ
eI[oXmV`ojKH]_nVeJooZljMol_2M?oCaGKod/Mgol[6Noo8aGcodLEfom;5MOo@`g[od<5jom>oMOoG
`GCofL9bombmJ?oA/W3o`j9jok^JO_nkVh7o_IUnokjIO?nlVg_o_IYiokbEM?nkT7Go_Hadokj:Lonm
SG;o_8mcokf9MonlPWGo^XA]000`okZ2LoniOH?o]WV8okJ0NonfQW?o]H=dokB6N?neQgCo]7]ZokI]
Gon]NV;o[GMQokMZG?nbM5co/GMIok5fF?n_OEOo[WMMojn6I?n`^Coo/L8dojo1>?n^_COo[[/fojfj
=OnY_CGoZ<0fok:o>_o2^T3odZe5onVUC?odW57olY9@oo:@D?oaT4ookY=?onnID?o`Ve3olIeBoo:L
DoobVe?olYaDoo6LDooaW5ColIaCoo6MDoobWUColYaB0oobWE<0<_obW5ComYACoo6XEOoF^Tgoc;e9
olZnCOo4_D[o]L57oiO3AonL_D_o[;m>okNnCOnl_Dko^;U6okZg@Onm]d3o^KDiokNg>?nf^CSo]kU0
okZiB_ng^Tko]KiAokFnEOng_UWo^/1KokZoG?nk`5_o^/1JokRoFOni_eSo]kiGokG1F?nh_eKo^[iG
okW1Donh_dWo]/5>okG0E?ne_eGo]kmDokJoDond`5Co][iCok70Don``E;o/[m@ok?1Donf`EKo^KmH
0_nj_UL03oni_eSo]kiGokRnE_nn_EKoZlQIohcMFon7feSoRmMFohKIF?nFd57o^;i8ok?1BOo4]TGo
lY`nooNG?002ooNI?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00KomYHl
ooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI
?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00KomYHlooJG?OofUCcomYHl
ooNI?OogUc`2ooNI?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00KomYHl
ooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI
?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00KomYHlooJG?OofUCcomYHl
ooNI?OogUc`2ooNI?@;omiLm00KomYHlooJG?OofUCcomYHlooNI?OogUc`2ooNI?@;omiLm00[omYHl
ooJG?OofUCcomYHlooNI?OogUccomiTmooJE??ofUScomiPl0_ogUcd01oogUccomYHmooJF??ofUcgo
miLlooJG?OogUc`00_ofUSd03_ogV3comYHlooNH??ofUSgomYHlooJE??ogUccomiLmooJE??ofUcgo
mYHmooJF??ogUccomYDl0_ofUSd07OofUScomYLmooNH??ofUcgomYHlooNH??ofUCcomYHmooJE??of
USgomiPlooJE??ofUcgomiPlooJG?OofUScomiPlooJF??ofUcgomYHlooJF?OofUcgomiLmooJF??of
UcgomYDlooJF??ogVCgomiLl00;omiTm0_ogUcd01_ofUScomYLmooJE??ofUScomiTmooNG?0;omiTm
0_ogUcd03_ofUScomYLmooJE??ofUScomiTmooNG??ogVCgomiLmooJF??ofUcgomYDlooJF??ogVCgo
miLl0_ogVCd2ooNG?@06ooJF??ofUcgomYDlooJF??ogVCgomiLl0_ogVCd2ooNG?@06ooJF??ofUcgo
mYDlooJF??ogVCgomiLl0_ogVCd2ooNG?@06ooJF??ofUcgomYDlooJF??ogVCgomiLl0_ogVCd2ooNG
?@06ooJF??ofUcgomYDlooJF??ogVCgomiLl0_ogVCd2ooNG?@06ooJF??ofUcgomYDlooJF??ogVCgo
miLl0_ogVCd2ooNG?@0:ooJF??ofUcgomYDlooJF??ogVCgomiLlooNI?OofUCcomYHlooNH?0;omiLm
00OomiLlooJF?OofUScomYLmooNG??ofUcgomiLl00;omYHm00komiPlooJF??ogV3comYHmooJF??of
UCcomiLlooNG?OofUCcomYLmooJF?OofUScomiLlooJE?0;omYHm01_omYHlooJG?OogV3comYLmooJF
??ogV3comYDlooJF?OofUCcomYHmooNH??ofUCcomYLmooNH??ofUcgomYHlooNH??ofUScomYLmooJF
??ofUSgomYLmooNG??ofUcgomYDlooNI?OofUS`00OofUcd00004ooRL@_ogVT7omiY1ooVL@@;omiY1
0_ogVT83ooNJ@@04ooNJ@_oiW47omiY1ooVL@@;omiY100Con9a2ooVL@OogVT7omiY20_oiW4400oog
VT;omiY1ooVM@@02ooNJ@@;onIa100KomiY1ooNK@OohW4;omiY1ooNJ@_oiW442ooNJ@@?onIa100Ko
mi]1ooVL@OogVT7on9a2ooNJ@OoiW443ooNJ@@05ooVL@OohWD;omiY1ooNJ@OogVT800_ogVT401Ooi
W47omiY1ooNJ@OohW4;omiY200;onIa10_ogVT404_ohW4;omia2ooVL@OogVT7on9a2ooNJ@OoiWD7o
miY2ooNJ@OogVd7omiY1ooNJ@_ohW4;omiY1ooRL@_ogVT7onIa1ooNJ@P;omiY100WomiY2ooVL@Ooh
W4;omiY2ooVL@OohW4;onIe1ooVL@OogW4800oogVT400oohW4;omiY1ooVM@@02ooRL@P;omiY1013o
nIa1ooNJ@OohW4;onIa1ooRL@_ogVT7omiY2ooNJ@OogVT;onIa1ooNK@OogVT7omi]1ooNL@_oiW47o
miY10_oiW4400oohW4;omiY1ooNJ@P03ooNJ@@05ooVM@OogVT7onIe1ooNK@OogVT400_ogVT801oog
VT7on9a2ooVM@OogVT;omiY1ooVM@OohW4800_ogVd405?ohW4;omiY2ooNJ@OoiW47on9a2ooNJ@Ooi
W47on9a2ooVL@OogVT7omiY2ooNJ@OoiW47omiY1ooVL@OogVT;omiY1ooVL@OogVT;omiY10_oiW440
0oogVT;omiY1ooRL@P02ooNJ@@04ooVL@OoiWD7omiY1ooNJ@@;omiY20ooiW4401OogVd7on9e2ooRL
@_ogVT;omiY100;onIa100?omiY2ooVL@OogVd400oogVT404OoiW47omiY1ooNJ@OoiW47omiY1ooVL
@OohWD;omiY2ooNJ@OohW4;onIe1ooNL@_oiW47omiY1ooVL@OogVT;omiY100;onIa100?omi]1ooNL
@_oiW4400oogVT403?oiW47omiY1ooVL@OogVT7omiY2ooNJ@OoiW47omi]1ooNJ@_ogVT7omia2ooVL
@@;omiY100ConIa1ooNJ@OoiW47omiY10oogVT82ooVL@@0?ooNJ@OoiW47omia2ooNK@OoiW47omiY1
ooVL@OogVT7on9a2ooVL@OoiWD7omiY2ooRM@_ogVd7onIa100?omiY100Gon9a2ooNJ@OoiWD7onIa1
ooVM@@02ooNJ@@07ooVM@OohW4;omiY1ooNJ@OoiWD7onIa1ooNK@@02ooNJ@@05ooNJ@_ogVT7onIa1
ooRL@_ogVd400_oiW442ooNJ@@0UooNK@OoiW47onIe1ooVL@OoiW4;onI5QooZ=NookTGConi1booZ>
M?okSg3onY1`ooZ>K_okSfkonhm_ooZ@KoojSg7onhmaooZ>L_ojSW7onXmaooZ?LoojSWOonXiiooZ?
MOojSg3oni1_oo^@LOojSg;onY1boo^AL_ojSg;onXmcooVBK_oiV6Gon9YPooRIH@02ooZJH@0JooZJ
H_ojVV?on9UPooRIHOoiUgGonI>0ooVCOoojUGkonI>1ooZEPOojU7SomYAXooRFG_ofUV;omiISooJD
HoofU6ComYETooJDIOogUVKomYAVooRFI?ofU6ComYASooNFHoogUV@3ooJEH`3oooJDI?ofU6?on9IT
ooRFHoofUF?omYARooNFHoofUF?omYASooJFGOohV5con7n8ooaL[?okIJGonfZNoo]XX?okHJSooEFf
ooe4a_om>lgooC[>ooe9`OolG:gonf>Too]QYOokI:7ooFV?ooi/R?omKY7ooVb?ooeSQoomH8CooEn0
ooeZSoomMY3ooGF5ooeaQOomHGcooUR2ooe`XOomHjgooSiooohkE_onG73ooVJ6ooi@Jooj>d7ol3dc
onE7<?oSAccoidIFonM1NooS@jKofd:_om8o[_oL=k[ofcZaomHg[ooL=KSogCVbom/k[ooG>;3oecNb
omPk[ooG?JOodSJdolXbb?oA>L_ofSo6om]2`_oF?/GocCK8om0ia_oJA<GodTVgolDn]onn9Lgo`2_8
olM7[?o?HY?ocfN?oliPU_oCFYgogUFWoneB/?o_CKCoj4:fon4n]?oS?kKoiT2gonDn]ooT?KOoi3fi
on8i_?oS>KgohSNoomlg__oO>;gohcNnomhc_ooO<koojCJoon`i_Oo[@[cojdfgon5;[ooQB:_ohTV/
onU;[OoM@jooaSG0olPaa_o;@jgocDNYol]6Z_oE;<SobUN@olb1H_o8NfGoagYWol]nIOo:Of?oaWeP
ol=iHoo0MfCo_gQTol5lH_o4Of7o`h1Qol=nGoo3OEkoaGiNolF2F_o0Pe[o_WmLol62Foo5Q5WoaH=I
olB3F_o4PU[o`X=Kol25F?o2RUGo`haEol69E_o0REOoa8mHol:?Foo1SE_obHAPomUoJ_oHOf_of85Z
omV2J_oHOf_ocgaZolQfLoo?N7WodGmbom20L?oBPfkodH9^om22KOo?OW;odX1fom:2MooCQG?ocgeh
ol]`P_oUVf_ofYaeokanQonoP8Oo`H:4olR6Poo:Q8;ob8>3olR3QOnoP8[o^gf<olF3R?o;Qh?obXF3
olZ7POo6Q8GobX>6olb6Q?o<R8KobXJ7olV5R?o<R8SobHJ9ol^7R_o>RHOod8B0ok^5Uon[Y[7o/:jb
ojFG]onLSk_oWYVfoi^B]_nGSK[oX9bfojRU/_nXYK?oYZBcojRO]OnS/K7oTMBAoiGISOnTe:7oW=BG
oi3GRonEficoXM^bojCH]_nUcjGob<AnomC5N_oAagcod/Mgolo6O?o>aWgodlMgolo5N?o;a7goc<9m
om73N?oC`gWofLAaomg4JooE_g;oc;1fol2ROOnkWH;o^iV2okbIOonkVgko_9alokbLN_niUGSo_8ie
okf9LonlSgGo_99fokj9N_nkRgSo_HQaokb3KOnkNGOo^7N6okInO_neQ7Co]HUi000VokF6MondM6Co
]fYLok5eH_n[O6Go/g5Kok1`E_n]MUOo[GQJojejF_n]N5Oo[FUKokb1D?o<Zd;o_kE1ojfl>?n]`S[o
[l0kok6m>_n__S[oZl0gojS0=on[`C_o]l90olJmB?oJ]4gok:QBoo2GDOoeTE7omY9Boo>CD_o_U5;o
kiMDoo2KE?oaW5GolimFoo:OE_obWEH2oo:NEP0Too>NE_obWEKolZ1Goo:PE_odVUKomJAHomNmCoo6
`4Oo_l18ok?2AOne`TGoc;YAoknlEonc`U_o`/1Pol32H?nl`Eko^l5Mok[1Foni`ESo]l5@okRoCOnl
^dco_KU7okZiA?nd_3co[[ljok6m@Onc_dWo]<5?okO2E?nh`E_o^L5Nok[1GOni`Ego^/9L0_ng`UX0
3Onj`E[o^L9FokK3C_ne`ECo]l1IokK1Eonf`5Ko]<9Eok;3E_nd`UOo/LAHok75FOni`eX00_nj`5/0
Ronj`5[o^L1Jok_2F_ni`E[o^<5JokW1F_nl`5Wo_[mIojC?Gon8gecoQm]IohOJF_n=f5Oo/<A:okW0
B?ne`d_ogjY5ooVL@OogVT7omiY2ooNJ@OogVT;onIa1ooNK@OogVT7omi]1ooNL@_oiW47omiY1ooNJ
@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1ooNJ@OogVT;omiY1ooNJ@_oiW47omi]1ooNJ
@OogVd7omia2ooVL@OogVT7omiY2ooNJ@OogVT;onIa1ooNK@OogVT7omi]1ooNL@_oiW47omiY1ooNJ
@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1ooNJ@OogVT;omiY1ooNJ@_oiW47omi]1ooNJ
@OogVd7omia2ooVL@OogVT7omiY2ooNJ@OogVT;onIa1ooNK@OogVT7omi]1ooNL@_oiW47omiY1ooNJ
@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1ooNJ@OogVT;omiY1ooNJ@_oiW47omi]1ooNJ
@OogVd7omia2ooVL@OogVT7omiY2ooNJ@OogVT;onIa1ooNK@OogVT7omi]1ooNL@_oiW47omiY1ooNJ
@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1ooNJ@OogVT;omiY1ooNJ@_oiW47omi]1ooNJ
@OogVd7omia2ooVL@OogVT400_oiW4400oohW4;omiY1ooNJ@P03ooNJ@@05ooVM@OogVT7onIe1ooNK
@OogVT400_ogVT801oogVT7on9a2ooVM@OogVT;omiY1ooVM@OohW4800_ogVd405?ohW4;omiY2ooNJ
@OoiW47on9a2ooNJ@OoiW47on9a2ooVL@OogVT7omiY2ooNJ@OoiW47omiY1ooVL@OogVT;omiY1ooVL
@OogVT;omiY10_oiW4400oogVT;omiY1ooRL@P02ooNJ@@1QooVL@OogVT;onIa1ooNK@OogVT7omi]1
ooNL@_oiW47omiY1ooNJ@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1ooNJ@OogVT;omiY1
ooNJ@_oiW47omi]1ooNJ@OogVd7omia2ooVL@OogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1
ooNJ@OogVT;omiY1ooNJ@_oiW47omi]1ooNJ@OogVd7omia2ooVL@OogVT7omiY2ooNJ@OogVT;onIa1
ooNK@OogVT7omi]1ooNL@_oiW47omiY1ooNJ@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1
ooNJ@OogVT;omiY1ooNJ@_oiW47omi]1ooNJ@OogVd7omia2ooVL@OogVT7omiY2ooNJ@OogVT;onIa1
ooNK@OogVT7omi]1ooNL@_oiW47omiY1ooNJ@_ogVT7omiY2ooVL@OogVd7omiY1ooNK@OogW4;onIa1
ooNJ@@02ooVL@@03ooRL@_ogVT7omiY200?omiY100GonIe1ooNJ@OoiWD7omi]1ooNJ@@02ooNJ@P07
ooNJ@OohW4;onIe1ooNJ@_ogVT7onIe1ooRL@P02ooNK@@0DooRL@_ogVT;omiY1ooVL@OohW4;omiY1
ooVL@OohW4;onIa1ooNJ@OogVT;omiY1ooVL@OogVT7onIa1ooNJ@_ogVT7onIa1ooNJ@_ogVT42ooVL
@@03ooNJ@_ogVT7on9a200;omiY100ConIa1ooVM@OogVT7omiY10_ogVT81ooVL@@0000?onIm7ooVM
AooiWdL00_oiWDL01?ojX4OonIm7ooVOAooiWdL2ooVMA`03ooVOAoojX4OonZ1700;onIm700ConZ17
ooVMAooiWdOonIm70_ojWTL3ooVOA`04ooVOB?oiWdOonIe7ooZPA`;onIm70_ojX4L01ooiWDOonIm7
ooZPAoojX4SonIm7ooZNAooiWdL00_ojX4L01?oiWDOonZ17ooVOAooiWdL2ooZPA`03ooVOAooiWDOo
nZ1700?onIm700KonIe7ooVOAoojWTOonYi7ooVOAoojX4L2ooVOA`03ooZNAooiWdOonIe700KonIm7
00ConIe7ooVOAoojX4OonIe70_oiWdL01?ojWTOonIm7ooVMAoojX4L4ooVOA`03ooVMAooiWdOonZ17
00ConIm70_ojX4L3ooVOA`03ooZPAooiWDOonZ1700;onIm700SonYi7ooVOAooiWdOonIm7ooZPAooi
WDOonZ17ooZNA`;onIe70ooiWdL01?ojX4OonIm7ooVOAoojX4L5ooVOA`05ooVMAooiWdOonIm7ooVO
AoojWTL01?oiWdL01OoiWDOonIm7ooVOAooiWDOonIm700;onZ1700KonIe7ooZPAooiWdSonIm7ooZN
AooiWDL2ooVOA`04ooVMAooiWdOonIe7ooVMA`;onIm700_onZ17ooVOAooiWdOonZ17ooVOAoojX4Oo
nIe7ooZNAoojX4OonYi7ooZPB003ooVOA`04ooZPAooiWdOonIm7ooVMA`?onIm700?onYi7ooZPAooj
WTL00_oiWDL2ooVOA`03ooZNAoojX4OonYi700;onIm700ConIm8ooVOAoojX4OonIe70_oiWdL01ooi
WDOonIm7ooVOAooiWdOonZ17ooVOAoojX4L00ooiWdL00oojX4OonIe7ooZPA`02ooVOA`03ooVMAooj
X4OonIm700;onIm70_ojWTL01?oiWdOonZ17ooVOAoojX4L2ooZNA`;onIm7013onZ17ooVOAooiWdOo
nYi7ooVOAoojX4OonIm7ooZPAooiWDOonZ17ooVOAooiWDOonIm8ooZPAooiWdOonIe70_oiWdL01_oj
X4OonIm7ooVOAooiWDOonYi7ooZPA`;onIm700?onYi7ooVOAooiWdL00_oiWdL00ooiWDOonIm7ooZN
A`02ooVOA`03ooVMAooiWdOonIm700;onIe700GonIm7ooVMAoojX4OonIm7ooZNA`02ooVOA`03ooZP
AooiWdOonZ1700;onIm700?onIe7ooZPAooiWdL00ooiWdL07OoiWDOonIm7ooVOAooiWdOonYi7ooVO
AoojX4OonIe7ooVJCooiSeoonXiXoo^@KOolT7Coni5eoo^BMookTGOoni9foo^BMOokTGKoni9eoo^A
M?okTGGoni5doo^AM_okTW[oni5loo^@NOolTWConi9d00?oni5e0_olTgH07OolU7Goo99eoo^AM_ol
U7KonYaYoo^NH_okWVGonY]Voo^LIookW6KonYeSooZJL_ojUh?onYN4ooZFQ?ojUHOonIF2ooVGM?oi
VFWon9UUooVIIooiV6Oon9QYooRFJ_oiVF[on9QZooVIJOohUfWonIUX00;on9UX00ConIQWooRGIooh
UfOonIQW0_oiVFL0R?ohUfKon9UUooRGIOohVFGon9MTooRIIOohUfKonIUWooVIIOohVeoonHemooaU
Z_olIJcoo6nTooa[ZOolGKOooDo3ooi9b?onAlcooT[;ooeF__olJJconW2UooY`Y?ojJjSoo6bVooi^
SOonJ8OooVbAooiYR_onHGOooV9fooe/RoomMXoooGJ9ooegR?omLH;ooUj3ooiZW_onFiCooSY[ooi5
HoonIXOooV61ooe7Eooc?SGojTLconM8>OoVBEkokD2Eon16[OoK@;Coe42_omHm[_oN>[KogSNhom`j
]_oJ=[SofSNdomXj/_oG>k;oecVaomHi/?oD>jkoeSFaom8``_oC>l[ofT;6omY2aOoF?/Koe3O9om<f
b_oF=lgod3?=olD_a?o78lOodB_6om5DYOo@JXgocVJ>om=LW_oKEjOoiUNXoo1B/oo_B;WoiT6ion0o
^?oR@;SoiCjlonDl_OoS>[kohc^mon<m_OoV?L3oiCfoon8j_ooT><;oj3O2onPf`OoR<L?oj3?5onlg
`ooa>l;okdNmonU9]OoTA[3oidV^onY6/?oXAK3ogTRYolY4/oo4@k?oadF]olY0]_o9>k[ocRS?ol]9
Z?o;Of[oc89Vol]nJOo7NfSoagiTolN2Hoo4OfKo`WmXol1lIoo1OFKoah9SolN2H_o4Of?oa85SolB3
HOo3QUgo_X9Nol:3Goo7QU`2olF5G@2^olB7GOo4QEko`hMOol6;GOo3SU[oa8aIolB=FOo4T5Wo`i5M
olBAG_o0ReoobX=WomV0LOoGOg3oeh5_omR2KooIPVkoe7m`olYhNOo?N7kodX1gom>2LooCPW;oe8Ea
om>4LOo?OWGodh=hom>4O?oBR7SodhEnole^SooXWW3ogJ5fokYnSOo0Q8WoaXR5olV9Q_o<QhKobhN6
olV5ROnnPY3o^WnBolN6R_o=RXOobhR6olb:QOo9QhWobXF9olf8Q_o>RHKobhZ;olZ9S?o=Rhcoc8Z?
olj:S?o?S8godH^;om26R?nhSZ;o[Jbfoj^N]onORkcoWY>moj6N^?nIRk_oUXbmojBT]_nXY[GoZJJd
ojNT]?nWWkSoY;^`oi;IRonIei3oYmBSoikDU_nBfI3oU=fQoigL/_nMfjko^=2:om?7N?o;aX?odLMl
omC8NOo=aGood<QmomC8N?o?aggocLEoolo5O?oBaGWodLEiomS7M?oHag?of/IaomJkKoo7[7Wo_Z60
okVFP_njVH7o_IeookfOP?nlWh3o^iemok^EN?njSWOo_95hokj;NonjSWgo^i5jokf>N?nmRW;o^ged
okUdN_ngN7Go]H9aokB2LOndLfOo]VmSok=bHOnZPF;o[7MLojeeF_n^MEWo[gMHojejF_n]NU_o[7EL
oja_GOo6U4SodZ0oom2K@_o=ZDKo^ki2ok36@?n^acko[l8mok;1?_n_`3goZl@mojS4?On]a3oo^<A3
olFjBOoP/e;okjIFooBJE_ohUUOomI=Foo:EE_oaV5KolYaHoo>QF_ocXU[om:5JooBQFOocXEWolj9J
ooBRF_ocWeWomj5KonFhFOo7a4co_L=9ok;4Aonja4codkIFooBQIoo/[6[o`LEQok_4GOnla5ko_LEO
0_noa6008_o1a6;o_lASokk4Honm`f;o^lAPokW4G?nga5Ko^/=BokS0COnc`TGo[/A0ojc4@?n]a4Oo
/<=?okG4E_nga5co^<EOok[4GOnia5oo^/EPok[5FOnga5Co]lAIokO3F_ndaESo/<IHok;5FOnfaUco
^/AMokS5G_njaEoo_<APok_5H?nj`eh4ok_4G@0@okW4GOnka5go^lENokk1GOnla5koVmMRohKPG?n7
g5_oQ]aLojK=D_nn`Dco/<Q=olNlC?oeXDOonIm7ooVMA`?onIm700ConZ17ooVOAooiWdOonZ170_oi
WdL01OoiWDOonIm7ooVOAooiWdOonZ1700;onIm700ConZ17ooVOAooiWdOonIe70ooiWdL01?ojX4Oo
nIm7ooVOAoojX4L2ooVOA`05ooVMAooiWdOonIm7ooVOAoojX4L00_oiWdL01?ojX4OonIm7ooVOAooi
WDL3ooVOA`04ooZPAooiWdOonIm7ooZPA`;onIm700GonIe7ooVOAooiWdOonIm7ooZPA`02ooVOA`04
ooZPAooiWdOonIm7ooVMA`?onIm700ConZ17ooVOAooiWdOonZ170_oiWdL01OoiWDOonIm7ooVOAooi
WdOonZ1700;onIm700ConZ17ooVOAooiWdOonIe70ooiWdL01?ojX4OonIm7ooVOAoojX4L2ooVOA`05
ooVMAooiWdOonIm7ooVOAoojX4L00_oiWdL01?ojX4OonIm7ooVOAooiWDL3ooVOA`04ooZPAooiWdOo
nIm7ooZPA`;onIm700GonIe7ooVOAooiWdOonIm7ooZPA`02ooVOA`03ooZPAooiWdOonIm700?onIm7
00GonIe7ooVOAooiWdOonIm7ooZNA`04ooVOA`05ooVMAooiWdOonIm7ooVMAooiWdL00_ojX4L01_oi
WDOonZ17ooVOB?oiWdOonYi7ooVMA`;onIm700ConIe7ooVOAooiWDOonIe70_oiWdL02oojX4OonIm7
ooVOAoojX4OonIm7ooZPAooiWDOonYi7ooZPAoojWTOonZ1800?onIm700ConZ17ooVOAooiWdOonIe7
0ooiWdL01?ojX4OonIm7ooVOAoojX4L2ooVOA`05ooVMAooiWdOonIm7ooVOAoojX4L00_oiWdL01?oj
X4OonIm7ooVOAooiWDL3ooVOA`04ooZPAooiWdOonIm7ooZPA`ConIm700ConZ17ooVOAooiWdOonZ17
0_oiWdL01OoiWDOonIm7ooVOAooiWdOonZ1700;onIm700ConZ17ooVOAooiWdOonIe70ooiWdL01?oj
X4OonIm7ooVOAoojX4L2ooVOA`05ooVMAooiWdOonIm7ooVOAoojX4L00_oiWdL01?ojX4OonIm7ooVO
AooiWDL3ooVOA`04ooZPAooiWdOonIm7ooZPA`;onIm700GonIe7ooVOAooiWdOonIm7ooZPA`02ooVO
A`04ooZPAooiWdOonIm7ooVMA`?onIm700ConZ17ooVOAooiWdOonZ171OoiWdL01OoiWDOonIm7ooVO
AooiWdOonYi700ConIm700GonIe7ooVOAooiWdOonIe7ooVOA`02ooZPA`06ooVMAoojX4OonIm8ooVO
AoojWTOonIe70_oiWdL01?oiWDOonIm7ooVMAooiWDL2ooVOA`0;ooZPAooiWdOonIm7ooZPAooiWdOo
nZ17ooVMAoojWTOonZ17ooZNAoojX4P00ooiWdL01?ojX4OonIm7ooVOAooiWDL3ooVOA`03ooZNAooj
X4OonYi7007onIe700001?okXTgonj5<oo^RCOokXTd2oo^QC0;onj9=00Conj5<oo^RCOokXdgonj9<
0_okXdd01_okXDconj9=oo^SCOokXDconj==oo^RC0;onj==01;onj9=oo^SCOokXdgonj9=oo^QC?ok
Xdgonj5<oo^RC?okXdgonj5<oo^RC?okXTgonj9<oo^QC?okXTconj5<oo^RC?okXTd2oo^QC0;onj9=
00Gonj9<oo^SCOokXTconj5<oo^SC@02oo^RC@04oo^SCOokXTgonj==oo^SC@;onj5<00Gonj9=oo^R
C?okXdgonj==oo^RC@02oo^RC006oo^SCOokXDconj5<oo^RCOokXDconj==0ookXTd2oo^SC@0>oo^R
COokXTconj9=oo^RCOokXdgonj5<oo^RCOokXDconj9=oo^RC?okXTgonj9<oo^SCOokXT`2oo^SC@03
oo^RCOokXTconj==00;onj==0_okXTd2oo^SC@03oo^RCOokXdgonj9=00;onj==0_okXD`00ookXTco
nj==oo^QC002oo^SC@04oo^RCOokXTconj9<oo^SC@;onj9<0_okXTd00ookXTconj5<oo^SC@02oo^Q
C005oo^SCOokXDconj9=oo^RCOokXD`00ookXdd03?okXTconj9=oo^SCOokXTgonj==oo^RCOokXDco
nj9=oo^QC?okXdgonj5<oo^SC@Gonj9=00Oonj9<oo^RCOokXDconj9<oo^SCOokXDconj9<00?onj==
00[onj9=oo^QC?okXdgonj9<oo^RCOokXTconj9=oo^SCOokXTgonj9<0_okXTd00ookXdgonj9<oo^S
C@02oo^RC@08oo^QC?okXTconj9=oo^QC?okXTgonj9<oo^SCOokXD`2oo^RC@;onj5<00Oonj==oo^R
COokXTgonj==oo^RCOokXdgonj9<00?onj9=0_okXD`2oo^RC@03oo^SCOokXTconj9=00;onj9=00Oo
nj5<oo^RCOokXdgonj==oo^RCOokXTconj9=00;onj5<00Konj==oo^RCOokXDconj==oo^QC?okXT`2
oo^RC@08oo^SCOokXTconj9=oo^RC?okXDconj9=oo^QC?okXTd3oo^QC005oo^SCOokXDconj9=oo^R
C?okXD`00_okXTd00ookXdgonj9<oo^SC@02oo^QC003oo^SCOokXDconj9<00;onj9=00conj==oo^Q
C?okXTgonj9=oo^SCOokXDconj9=oo^SCOokXDconj==oo^QC?okXdd2oo^QC0Conj9<00Conj==oo^Q
C?okXdgonj9=0_okXdd01OokXTgonj==oo^RC?okXDconj==00;onj9=00Gonj9<oo^QC?okXTconj9=
oo^SC@02oo^QC00@ooZJD_oiTe[onIALooZCGoojTVConi9[oobBKoolTWCoo9AjoobCN_olU7coo9=l
oobCN_olU7_oo9=noobCP0;oo9=i00Goo9=joobENOolTgSoo9AjoobDN002oobDN@;oo9Ei01?oo9Ej
oobDNoolV7Soo9i]oobPJ?olX6_oo9m[oobOJ?olWVcoo9V4oo^HR?okV8WoniR:oo^IPOojVW?onYa[
ooZKK?ojVfkonYY^00;onIY^00conI]^ooVKKOoiVfconIY/ooZJK?ojVV_onI][ooZKJOojVV_onY][
ooZKJ_ojW6/2ooZKK02>ooVLK?ojVVgonY]^oo^KL?okVW7oniYcooVLMOohWGGon9i_ooVIO_omNZGo
oFj`ooee[?onK;GooUc1ooiAboonDL[ooUC7ooiGaoonH;coo6n[oo]dYoojMZKonW:VooU[[_okL;3o
oVb@ooiXR?onKi;ooVZ0ooiQMoonJH;ooWB6ooiePOonMHCooW>4ooiZR?onI9GooUF3oohmIOonDGKo
oVN9ooeBIOog@SookTPfonY=EOoSCG[ohdJMon0m^_oM?;ooed6comM0[_oM?K?ogSbfom/l]OoL>K[o
gcNmom/i]ooF>[?oeSZdomHk/_oB>ZoodcVbomXf]ooQ>;_ogCo5om]2b?oK?/[of3K=omD_d?oE:];o
dRKGol/Qf?o98<kodb3>on4TdOoMA[GocVNColiSV?oKEjOoiUJ/onYLZOo_EK?ojdJlon91^_oP?[co
hcjnon<l_ooV>l3oiCfoonLo_OoW@Kcoid32onXm`ooZ>/;ok3[3oo0k`oo`>l;ok3G4onPda_o/><?o
lSfnooE7`?oaBk_oj4VconY6/ooZAkCohTFeomU7/_oEIXoodf:EomE2/ooB>[_ocSNnol`i^oo:@;So
bU:WolYjL_o=Pf[obh1/olJ1JOo3QFWoa8I[olB4J_o7Q6WoaH1Xol=oJOo4OfSoaH9Vol>3I_o4QFKo
aXMRol>6H?o1PV;oaXIRolN8H?o6R67oahYQolJ8HOo4RF;o`haSol:>H0?oaI5N0:GoaYAOolJBHOo5
TV3o`8]RolaoL_oJP7OofH9comZ5L_oIQG3og8IbomZ6MOo>O7[ocGR1om9oNooCQGKoe8IeomF7MOoD
QGKodH5gomJ6OOoERH?oeXb3omR4Q_oALi7oj:5domjRN_o0Q8go`XN<olN;R_o:Rh_ocHZ;olf9R_o:
RHgo_H2DokYnUoo:RHcocXb:olb;R_o=S8SobhV<ol^7SOo=RX_od8f:om2<SOo>Ri3odHj=om2=SooA
Rhooe8j;om6>SooBRhkocXV>okNJZ_n[Z;WoYYBjoij5__nPU;koX9RloiN7__nOUk_oYjViojVW]on[
Z[GoZjFeoj^V^_nSb:_oT=j<oigHV_nYeJGoX=NIoiWHUOnQeJKoX]Rcoj3FR_o5cGGobLR2olG8P_o<
bWkoc/MnolW5P?o?bW_od/Yiolc9Ooo;ah7oc/Mmolc7OOoAb7_oe<Ehom;4NOoJaGCofL=com6fMOo6
YGSo_Ib1ok^MPonlWH;o_Yf0okfNPOnlX7oo^ianok^ENonkSW_o^hb0okb@OOnnSgco_I9nokf<M_nk
PW;o^GafokMiL_ngNVko]79PokE^GoncL67o[8AQojalG_n]MUco[GQLojihFon]P5ko[X1NojimGOnZ
MF7o^8UEom6`A_oD/TOodJ]7om>VA_o=Z4Wo_;I2ok?4@On/b43o/LI2okO2A_ne`dCo[lE1oj_7@On]
aT;o]<E6okc4B_o>_E7ohkIGonfTF?ohV5SoniEIooJDFOocVE[oliiLooBRG?odXegom:ANooFVGOod
Xegon:1Noo6dGoo;aE3o]/M9okC6Boo8`EGojK9WooZMK?omV6gooJ9`olboIOnfaV000_nnaV82oko5
H@;o_lER023o`<ERol36Hoo1aFCo`LETol75IOnoaVKo_lIUokk6HonmaUoo^/IJokK6EOneaU?o]<IB
ok?6DoncaUGo]<MIokO6G?ngaf3o]/QMokG7F_ndaU_o/lMLokC7GOnfaeoo^LIQokc7HonlaV;o^/IP
ok_5HOnmaF7o^lIQok_7H`;o^lIR0_nlaV404OnjaV3o_<EPokg5HOnlaV7o`L9PokK:Hon@gF7oQ=mM
ohGNGonIeUWo_<A@okO6D?ndb57oi:i>oo^RC?okXdgonj9=00;onj9<00?onj==oo^RC?okXT`00_ok
XTd00ookXTconj==oo^RC@02oo^RC003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_ok
XT`00ookXdgonj9<oo^RC002oo^RC@03oo^RC?okXdgonj9=00;onj9<00?onj==oo^RC?okXT`00_ok
XTd00ookXTconj==oo^RC@02oo^RC003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_ok
XT`00ookXdgonj9<oo^RC002oo^RC@03oo^RC?okXdgonj9=00;onj9<00?onj==oo^RC?okXT`00_ok
XTd00ookXTconj==oo^RC@02oo^RC003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_ok
XT`00ookXdgonj9<oo^RC002oo^RC@03oo^RC?okXdgonj9=00;onj9<00?onj==oo^RC?okXT`00_ok
XTd00ookXTconj==oo^RC@02oo^RC003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_ok
XT`00ookXdgonj9<oo^RC002oo^RC@03oo^RC?okXDconj==00;onj5<00Gonj==oo^QC?okXTgonj9=
oo^QC003oo^SC@0<oo^RC?okXTgonj==oo^RCOokXdgonj9=oo^QC?okXTgonj5<oo^SCOokXDconj==
1OokXTd01ookXTconj9=oo^QC?okXTconj==oo^QC?okXT`00ookXdd02_okXTgonj5<oo^SCOokXTco
nj9=oo^RC?okXTgonj==oo^RCOokXT`2oo^RC@04oo^SCOokXTconj9<oo^SC@;onj9<0_okXTd00ook
XTconj==oo^RC@02oo^RC003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_okXT`00ook
Xdgonj9<oo^RC002oo^RC@?onj9<00?onj==oo^RC?okXT`00_okXTd00ookXTconj==oo^RC@02oo^R
C003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_okXT`00ookXdgonj9<oo^RC002oo^R
C@03oo^RC?okXdgonj9=00;onj9<00?onj==oo^RC?okXT`00_okXTd00ookXTconj==oo^RC@02oo^R
C003oo^SCOokXTconj9<00;onj9=00?onj9<oo^SCOokXTd00_okXT`00ookXdgonj9<oo^RC002oo^R
C@03oo^RC?okXdgonj9=00;onj9<00?onj==oo^RC?okXT`00_okXTd00ookXTconj5<oo^SC@02oo^Q
C005oo^SCOokXDconj9=oo^RCOokXD`00ookXdd03?okXTconj9=oo^SCOokXTgonj==oo^RCOokXDco
nj9=oo^QC?okXdgonj5<oo^SC@Gonj9=00Oonj9<oo^RCOokXDconj9<oo^SCOokXDconj9<00?onj==
00[onj9=oo^QC?okXdgonj9<oo^RCOokXTconj9=oo^SCOokXTgonj9<0_okXTd00ookXdgonj9<oo^S
C@02oo^RC@7onj5<0OokXT`000?oo:EC00?oo:MDoobUDoolYU<00oolYE<01OolYECoo:ECoobUDool
YE?oo:IC00Coo:EC00Coo:ICoobUDoolYU?oo:ED1OolYE<00oolYU?oo:ECoobUD`02oobUD`03oobV
DoolYE?oo:EC00?oo:EC00Koo:EDoobUDoolYE?oo:ICoobUDoolYU<2oobUD`03oobUE?olYE?oo:EC
00;oo:EC00?oo:MDoobUDoolYE<02?olYE<2oobUE0Coo:EC0_olYU<4oobUD`04oobWE?omYU?oo:EC
oobVD`Goo:EC00CooJICoobUDoolYE?oo:ED0oolYE<00oomYU?oo:ECoobUD`02oobVD`03oofWE?ol
YE?oo:EC00Koo:EC00?oo:EDoobVDoolYE@00_omYU<5oobUD`03oobVDoolYE?oo:EC00;oo:EC00?o
oJICoobUE?omYU<00oolYE<01?olYeCoo:ECoobUDoomYU<6oobUD`03oobUE?olYE?oo:ED00;oo:EC
00KooJMCoobUDoolYE?oo:ICoobUDoomYU<5oobUD`06oobVDoolYE?oo:ECoobUE?olYE?oo:IC1?ol
YE<01?olYU?oo:ECoobUDoolYE@2oobUD`03oobVDoolYECoo:EC00?oo:EC00?oo:EDoobUDoolYE<0
1?olYE<01OolYU?oo:ECoobUDoolYU?oo:MD00Koo:EC00?oo:EDoobUDoolYE<01OolYE<00oomYU?o
o:ECoobUD`04oobUD`;oo:MD00Koo:ICoobUE?olYE?oo:EDoobUDoomYU<3oobUD`05oobVDoolYECo
o:ECoobUDoomYU<00_olYE<01?olYU?oo:ECoobUDoolYE<2oobVD`06oobUDoolYU?oo:ECoobUDool
YU?oo:ED0_olYE<00oolYU?oo:ECoobVD`04oobUD`04oobVDoolYE?oo:ECoobUE0;oo:EC00Coo:IC
oobUE?olYE?oo:ED0oolYE<00oolYU?oo:ECoobUE002oobUD`05oobVDoolYE?oo:EDoobUDoolYE@0
0_olYE<00oolYECoo:ECoobUD`02oobVD`03oobUDoolYU?oo:ED00?oo:EC0oolYU<02_olYE?oo:IC
oobUDoolYECoo:ECoobVDoolYE?oo:ADooZMG?oiUeh2ooZHG@0?ooZGG_ojUV3onYISoo^EIookUF_o
o9EaoofDMOomU7WooIAmoofEP_omUH7ooYMooofGPOomUH;ooIF000;ooIIn00?ooIMnoofFO_omUgh0
0_omUgd2oofGOP03oofFOoomVWgooJ1c00?ooJ9_00OooImnoobISoolVhgoo9^:oo^LOookWW7onim_
00ConYec0_ojWG401?ojWFoonYi`ooZNLOokWG42oo^NL@3^oo^MLookWGGonYieooZNMookWWWoniil
oobNO?okX7con:5jooRRNoogXW_on:9kooNRN_ogXg[omZAiooBWLoodYWCon8jGooid/oonLk?ooVJn
ooiCb_onD<cooUG9ooiDb_onElSooVFjooeb[OokM:[onWBYoo]cZoonJJoonfbgooUc]_onKI;ooW2:
ooi`R?onHg_ooVZ4ooidQOonMX?ooWB1ooigP_onKH7ooeR3ooi=LOonCf_oof>6oomONOoiATWokd<n
onU:G?oSB8[oi4NgomHo__o??/7od3W4om8m]?oI?ZoogCffom`m]ooJ?[Gofcbiomhh`?oN>[_og3bh
omPj]OoD>[?odc^aomPj]?oQ>;ooj3K4onHgaooN><kofS;Com`]eOoG:=KodB?GolXOfoo<7mSodBO=
omX^a_oP<<OogcK4om9HY?oCI9coheN^onaF/Oo]FjgokU>fonY5`?oS?koohSk1on<n`_oT?l7oiD:o
onM2_ooWA;kojDC0on/oa_o]>/Sokc[6oo0iaOob?LColck3oo4l`oo[=lCojc[1onlo__o^AK_ok4bl
onE9^_oKAkGoeTBhol]5]_noAk?ob4>hom]LWoo[Dj7omSfioo0j_?oV?KSofdZ_omMCZ_oCEZKobgai
olV5Koo5RFooahiZolN:J_o5PfkoaH5^olV3KOo9QF_oaXA[ol>2K?o2PFco`XA[olJ6JOo7R6Ko`hMT
olB7I?o6RVGoahYVolN;I_o7RVKoaXaVolB>Ioo4TVOoaI9TolBCHoo5UF?oa9=SolFBIOo7TFGoa95T
ol><I_oEQWKog8AkomZ5MooKR7CofhUeon2:N_oMRW_och5lol]hQ?oAP87oeHQiomJ:NOoERGWoe8Mi
om:4NooHQh7ofhR7om^=RooJQX[odGFBonZVM_oOYh3o`hVAolB9Soo6Ri3obX^@olf<S_o>SHkobhZ@
okf0V?njOYcobXZColj>S_o=SHkoc8f>olb<T?o<RY?ocXbCom:>S_oCShgod8b@om:@T?oBSi7ochfD
omB?TOoDSi3od8jDomJ>Soo>SICo/IZcojJQ`?nRR[ooWXO0ojBI__nOTKooVhk0ojBR^onYZ[[o[:^h
ojj/]OnZXkSoZjfloioCZOnAghgoXMVOojSFY_nQf9_oYMJRok2j/One[ISoaLYfol;@O?o2bH3oa<R3
ol_:OOo9b7goa/V0olk:Noo@bW[ob/N0ol[6O`;oblQn04ood/]iolg8OOo<agkoclMlomC6N?oG`G;o
ck=col:SO?njVh;o^Yf2okfOP_nnXh;o_ZN2okfUPOnlX7co]iQnokb>O?nmSW[o_91lokbBOonjTGko
^HenokZ3O_nkPX;o]gU]okI`G?nfJeWo[7aMojajG?n_Ke[o[GQNojigGOn]OEko[X9NojilGOn/N5oo
[7ENolJOCOoC]4Ood[=9om6_BOo@ZD[oe:99om>QB_o2[4Co^L58ok7:B?n`bTOo]/M:okO5B_neaTWo
/<M7ojc8AOn[b4Ko[/Q8ok_4COoD`5SoiKMKonbXGOoiWekonIQMooJGGOoeVekomZ=PooBVH_ohWf7o
nZaSomK5F?nabD[o^lQBomRjHOofZ6oooIidoojLKoomWFgooIQ^omRhJ?ngbFGo_LUV00Co`<MV023o
`<QVol37I_noafGo_lMUoko7I_o0b6Ko`<MVol37Ioo1afSo`LMYol;8JOo1b6[o`LMWol37IOnnb6Co
_<QPokW8G_ngb5ko^<QOojo;H?n_c5oo]lUSokS9I?nkb6Co_LMVokg8I_nlafGo^lQVokW8I_nkb6Go
_LQUokc7I@;o_<QU00Co_<QVokc9IOnkb6Ko^lQU0_nmb6D03?nlbFGo_LMUol?3I?nZdFKoR^5QohKP
HOn=g5ko/l]Fokc6E?n`c5CocKmDooRWE0?oo:EC00?oo:ICoobUDoolYE<00_olYE<00oomYU?oo:ED
oobUD`02oobUD`03oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:EC
oobUD`02oobUD`03oofVDoolYECoo:EC00;oo:EC00?oo:ICoobUDoolYE<00_olYE<00oomYU?oo:ED
oobUD`02oobUD`03oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:EC
oobUD`02oobUD`03oofVDoolYECoo:EC00;oo:EC00?oo:ICoobUDoolYE<00_olYE<00oomYU?oo:ED
oobUD`02oobUD`03oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:EC
oobUD`02oobUD`03oofVDoolYECoo:EC00;oo:EC00?oo:ICoobUDoolYE<00_olYE<00oomYU?oo:ED
oobUD`02oobUD`03oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:EC
oobUD`02oobUD`03oofVDoolYECooJIC00?oo:EC00Coo:MDoobUDoolYE?ooJIC1_olYE<00oolYECo
o:ECoobUE002oobUD`06oofWDoolYE?oo:ECoobVDoolYE?ooJIC1OolYE<01_olYU?oo:ECoobUDool
YECoo:ECoobVD`Coo:EC00Coo:ICoobUDoolYE?oo:ED0_olYE<00oolYU?oo:EDoobUD`04oobUD`03
oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:ECoobUD`02oobUD`03
oofVDoolYECoo:EC00;oo:EC00?oo:ICoobUDoolYE<00_olYE<01?omYU?oo:EDoobUDoolYU<4oobU
D`03oofVDoolYECoo:EC00;oo:EC00?oo:ICoobUDoolYE<00_olYE<00oomYU?oo:EDoobUD`02oobU
D`03oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:ECoobUD`02oobU
D`03oofVDoolYECoo:EC00;oo:EC00?oo:ICoobUDoolYE<00_olYE<00oomYU?oo:EDoobUD`02oobU
D`03oobVDoolYE?oo:EC00;oo:EC00?ooJICoobUE?olYE<00_olYE<00oolYU?oo:ECoobUD`02oobU
D`03oofVDoolYECooJIC00?oo:EC00Coo:MDoobUDoolYE?ooJIC1_olYE<00oolYECoo:ECoobUE002
oobUD`06oofWDoolYE?oo:ECoobVDoolYE?ooJIC1OolYE<01_olYU?oo:ECoobUDoolYECoo:ECoobV
D`Coo:EC00Coo:ICoobUDoolYE?oo:ED0_olYE<00oolYU?oo:EDoobUD`03oobUD`03oobUE?olYE?o
o:EC00?oo:EC0007oojYF003oofWF?onZESooZUH00?ooZUH00?ooJMHoojYF?onZEP03_onZEP01?om
YeSooZUHoojYF?onZEP2oofWF0OooZUH0_omYeP3oojYF004oojXF?onZESooJMHoofWF0?ooZUH00?o
oJMHoojYF?onZEP00_onZEP00oomYeSooZUHoojYF003oojYF004oofWF?onZESooZUHoofWF0;ooZUH
00?ooJMHoojYF?onZEP01oonZEP2oofWF0gooZUH0_omYeP=oojYF003oofWF?onZESooZUH00KooZUH
00?ooJMHoojYF?onZEP02oonZEP00oomYeSooZUHoojYF002oojYF004oofWF?onZESooZUHoofWF0Ko
oZUH00?ooJMHoojYF?onZEP00oonZEP00oonZ5SooZUHoojYF00:oojYF004oofWF?onZESooJMHoofW
F0CooZUH00?ooJMHoojYF?onZEP00oonZEP00oomYeSooZUHoojYF005oojYF004oofWF?onZESooZUH
oofWF0SooZUH0_omYeP4oojYF003oofWF?onZESooZUH00GooZUH00?ooJMHoojYF?omYeP01?onZEP0
0oomYeSooZUHoojYF003oofWF0CooZUH00?ooJMHoojYF?onZEP01?onZEP2oofWF0OooZUH00?ooJMH
oojYF?onZEP00_onZEP00oomYeSooZUHoojYF002oofWF003oojYF?omYUSooZUH00;ooZUH00?ooJMH
oojYF?onZEP02oonZEP2oofWF0;ooZUH00CooJMHoojYF?onZESooJMH1?onZEP01_omYeSooJIKoobL
H_okVV?oni]RooZIHP;oni]Q00koni]Poo^KHOokV6?oo9YToo^GI_olV6[ooIQ_oofFM?onUgWooYQl
oojHP?onUh?ooYN2oojGQ0;ooYV300CooYZ3oojJP_onVX?ooYV20_onVX402OonV8;ooY^2oofQNOon
YW3ooJ=hoojNS_omW97ooIj5oobPN@02oobQLP;oo:1f01Coo:1eoobPM_okWgSoo:1ioofPN_omX7_o
o:5moobROOojXWgonj=loo^QP?okXh;onj>0ooRUO_ofYgcomjMlooJWO?oeYW[om:IiooJWN`;omZQl
08?omZQkooFXN_oeYW_omJMiooNZMOoiVXkooWFcooiW__ooF/Ooodo>oomBc?ooE/WooeC:oomJa_oo
JKSooGB]ooaeZoojMj_ongFZooeZ/?olJKOon7ZgooMn/_omN9Goog:;oomXOoooJX;oogN7oomhP_oo
MXGoogR3oomdP_ooDgOood1WoomEH_ooHW7oo5ILooE7B?oYDfkoiDjOoma6/ooM@L;odd6nom=1_ooD
?L7od42kom10^?oD?KWoecbhomXn]OoN?[[oh3c0omlm_?oN?;_ofSZjom@h]Oo@>;?oeSRhonDbb?o/
;]3ok2g>onD/dooM;MGofB[IomDWeoo;9=Oo`aoGollVe?oN=<Ooh3S2on0ga?oP=<OogDNiomiPY?oZ
G:goke^aonmI/oo^B[cojT71onA0`OoT@<;oiT72onE3`?oUA<;oj4;5onY0aoo]@<OolCg8oo<lb?ob
?<ColSk1oo=1`Ooa@L3okT70onHm`OoO?L3ogco0omi3`?oFC;kocTflolA:]onnB;Ko]TZdokI:/_o7
@;[oiSG9ooHl__oeA[?omT>eoo9:ZooZEYkohebJon=HX?oHJIKob8UfolF?KOo7SFgobX]]olZ7Koo9
Q73obXE`olJ4L?o5QVkob8M]olN8KOo2Q6ko`X=_olJ6KOo6RVWoa8]XolN<I`02olN=J@1NolN<JOo7
SfWoaHm[olB@Joo3TV[oaI=WolBFIoo2VFSoaiIXolVDJ?o9UFSoaYAWolR?J_oJRG[ogHQmom^9N_oK
R7[ogh]lon>=OooORgkodXEnol]jQooAOhGoeX]lomN<O?oGRggoeXYmomJ8P?oJRh;ofXV:omb?SooK
RXcodWFEonfZM_oS[H;o`hVEolJ=Too9SY;oc8jColf>Too?Si7oc8fBokj1VonmP9gobHVFolj?U?o>
TI?oci6Boln@Too>S9KodXjCom>@T_oCSi7odXnBom>?TooETY;odY2FomBAU_oFTYCoe96Eom:?UooI
TI3obXjLojZH__nTVL?oXX[1ojJG__nWUkooWhk2oj:J`?nWZ;goZZ^lok6a]on^[[[oZjBmojbb__nO
e:?oU=n=ojCIYOnXf:OoX=fLoj_:Zoo<VJ[oi8Yfolc0N?o4d7oob<Z1ol_8P_o=bGkoc<Yool_8P_oB
bg_odlUkolk7O`;od<Mm04oodLQlom?9N?o<b7goc/Qmolg7O_oAb7gof/Ycom[2Koo;[7Go_YiookZK
P_njVWoo_IemokfPOonnYgoo/Z^0okFPPoniWH3o^Ib0okZMP_niWHCo]YB0okF;NongSHGo]XF0okIi
JoneNEoo/H=Nok21GOnbKeWo/FiJok1dG?n^NUgo[WaLojmiGOn_NegoZW9QokN7E_o?ZdSodJm8om2_
B_oA/D_od[5;om:_BOoFZ4[oeZM<olV`BOno_D_o//Y:ok7<B_nfbDgo^LM<okW7COnfb4co//U9ojo:
BOn_b4[o]<Y<ol79D_oFaU[ohkIMoo>WGoonWf7onYQPooZEH?onWV?oh<5MokK:D?o7a5_ok[E^oofQ
LoonWWGooYiaoojOKoonWg3ooYecoo:aL_o0bFWo_<YY00Oo`LYY00Co`<QYol7:JOo1bVWo`LYY0_o0
bVT2ol7:J@0Kol7:J_o1bVWo`<UZol3:J_o0bVWo`<YXol3:I_o1bVKo^<eWok7=H?nnbVGo`/YZokk9
IonmbfKo_/YVoko:IonmbVOo^l]Wokg:J?nmbVWo_/YXokg:JOnlbFWo_LYXokk9J?nmbVWo_<]Y00;o
_L]Y00ko_<]Xokg:J?nobFSo_lMWoj7IIon7hf;oQ>5RojSBF?nmb5Ko]/aGokS;F?oX/eOooZUHoofW
F0WooZUH00?ooJMHoojYF?onZEP01oonZEP00oomYeSooZUHoojYF007oojYF003oofWF?onZESooZUH
00OooZUH00?ooJMHoojYF?onZEP01oonZEP00oomYeSooZUHoojYF007oojYF003oofWF?onZESooZUH
00OooZUH00?ooJMHoojYF?onZEP01oonZEP00oomYeSooZUHoojYF007oojYF003oofWF?onZESooZUH
00OooZUH00?ooJMHoojYF?onZEP01oonZEP00oomYeSooZUHoojYF006oojYF003oofWF?onZESooZUH
00_ooZUH00?ooJMHoojYF?onZEP00_onZEP01?omYeSooZUHoojYF?omYeP6oojYF003oofWF?onZESo
oZUH00?ooZUH00?ooZQHoojYF?onZEP02_onZEP01?omYeSooZUHoofWF?omYeP9oojYF003oofWF?on
ZESooZUH00OooZUH00?ooJMHoojYF?onZEP03oonZEP00oomYeSooZUHoojYF007oojYF003oofWF?on
ZESooZUH00OooZUH00?ooJMHoojYF?onZEP01oonZEP00oomYeSooZUHoojYF007oojYF003oofWF?on
ZESooZUH00OooZUH00?ooJMHoojYF?onZEP01_onZEP00oomYeSooZUHoojYF00;oojYF003oofWF?on
ZESooZUH00;ooZUH00CooJMHoojYF?onZESooJMH1_onZEP00oomYeSooZUHoojYF003oojYF003oojX
F?onZESooZUH00[ooZUH00CooJMHoojYF?omYeSooJMH1?onZEP1oofWF07ooZUH00001?ooZUcooZ]M
oon]G_ooZeh2oon/G@06oon]G_oo[5goojaMoon]G_ooZUcooZ]M0_oo[5d00ooo[EkoojYLoon/G@02
oon/G@;ooZ]M0_oo[5d00oonZUgooZ]Moon/G@02oonZG006oon]G_ooZUcoojYLoonZG?onZegoojeN
0_oo[5d00oooZegoojYLoon]GP02ooj[G@06oon/GOooZUcooZ]MoonZG?oo[5goojeN0_oo[5d01Ooo
ZUcoojeNoon]G_oo[5gooZ]M00;oojaM00OoojeNoonZG?ooZUcoojaMoonZG?oo[5gooZ]M00;oojeN
0_onZed2oonZG006ooj[GOooZUcooZ]Moon/GOonZegoojYL0_oo[5d01_ooZekooZ]Moon]G_onZego
ojYLoon]GPGoojaM00Gooj]Moon]G_oo[5goojeNoon/G@02oon]GP03oon/GOooZUcoojaM00;oojYL
0ooo[5d2oon]GP0=oon[G_ooZUcoojYLooj[GOooZUcooj]Nooj[GOooZUcooZ]Moon/GOonZegoojYL
oon/G@02oonZG003ooj[GOoo[EkoojeN00;oojaM00CoojeNoonZG?oo[5gooZ]M0ooo[Eh01_ooZUco
oZ]Moon]G_oo[EkooZ]Moon]GP;oojaM0_oo[Eh00oooZUcooZYMoonZG003oonZG005oon/GOoo[Eko
ojYLoon]G_oo[5d00_ooZU`02?onZegoojYLoon]G_ooZUcoojeNooj[GOooZUcooZ]M0_oo[Eh01Oon
ZegoojYLoon]G_onZegoojeN00;oojaM00KoojeNooj[GOooZegooZ]MoonZG?onZed2oon]GP;ooZ]M
00GoojeNoon/GOoo[5goojYLoon/G@02oonZG004ooj[GOoo[5gooZYMooj[G@;oojYL0_oo[5d2ooj[
G@0Boon/GOoo[EkoojYLoon[GOooZUcooZYMooj[GOooZegooZ]MoonZG?oo[Ekooj]Noon/GOonZego
ojYLooj[GOoo[5gooZ]M0_ooZU`2oon/G@04oon[G_ooZUcoojeNoon]GP;oojYL00?ooZ]Moon[G_oo
[5d00_onZed2oonZG003ooj[GOooZUcoojaM00;oojaM00?ooZ]Moon/GOoo[5d00_oo[Eh2oon/G@Co
ojYL00CoojaMoon]G_ooZUcoojeN1?ooZU`01ooo[5gooZ]MoonZG?onZUgoojaMooj[GOoo[5d00_oo
ZU`2ooj[G@07oon]G_ooZUcoojaMooj[GOoo[5gooZ]Moon]GP02oon/G@06oon]G_ooZUcooZ]Mooj[
GOooZUcoojaM1?onZed07_oo[EkoojYLooj[GOoo[EkoojaMoojVH_okVfOoniaWoo^LI_olW6OoniaW
oobKI_okW6Ooo9aVoobMI_olWFConieToobLI?olWVOoo9]ZoofLK?omVVgoo9YcoojHN?onV7Wooi]l
oonLP?ooVh;ooib5oonKQ`;ooib60:[ooi^6oojJQoooV8Sooib6oonTO?ooX8OooIZDoofOR?omXG_o
oJ9koobRNoolXX3oo:>2oofTPoomXH;oo:>3ooZWPooiYX3onJR1ooVVPOoiYh7omjYoooJ[O_ofZGco
mjUnooFZO_oeZGcomZQmooRZP?ogZ7komZUoooNXO_ohYgoon:N0ooRYPOohZH3omjR0ooRYPOogZGko
n:igooRTQoomM;SooeS9oomEc?ooDLgooeG;oomFb_ooEL_ooec5oom]]oonMZooo7F^oo]h[?olMjco
o6j`ooa[]_ogO[ComHZbooJ9/?omNIGoofV0oom/POooNHSoogV9oomeR?ooM8Ooog:4oomFM_oo@V[o
oeAOooiRB_ofFTSoie]ZonQKXOoNF;kofDc0omU4`_oG@<;oeD6mom@o_ooC@;oodT:komE2_OoC@<3o
dd2jomHk_?oO=lCogc[1om`g`?oF<l3oe3:nom8f^_oF<kooi2g=on/[e?o[;M7oj2_?omdYe_oE:=Oo
cBGHolHRf?o=8M_oebSEon<ga_oS>/GogcG7on4abooZ>lWojEV`oneQZoo`F[ColE2koni4aOoV@<Co
iD?5onQ3a_oW@lKoj4C8onQ2bOoZ?/_olCo9ooE0a_oe@<GolT33oo11`Oo]?l7ojD33onA2`_oN@L?o
e3g5olXm`oo:?l;obD;1olE<_Oo2DKco`D^kok]:]onhCKCo^TVdom=4^_oY>/Oon3W7oo98/Oo]Cjco
j5JTon1RV_oHJY;oeVJBom9_SOo9Q7cob8eaolV<LOo=RG3oc8YbolZ8Loo8Qg?obHYcolJ8L_o5Qg;o
aHMaolR:Koo4R73oaHMaol65LOo3R6coaXm[olV?J_o8SF_oahi]olJAKP;oa95_03Woa99_olBDKOo8
UfWoaiUZolNIK?o:VFcobIM]olNFKOo6UF[obi9^omf;O_oNS83ofh]momj;P_oQS8?ohXf2on6?POoE
RX3ocGf7om9oR_oER8;oehenomN<O_oGRX;oehV5om^=QOoKRhcog9>Bomb=T?oBMIWokZUjonF`O_o0
QiWoahnGol^?U?o?TIKocI2Foln@U?o;SYKo`hBMokn2Woo:RYOocHnFoljAVOo@TiKodI6Dom2=UooA
SYKodi6EomBAU?oCTIKoe96EomFBU?oDT9Oodi:JomFCUooETYL00_oCTIT0=?oJU97o`HbYojFJaOnV
V<?oZ9G0ojRG_onTS/3oXi;2ojJM`_nXYl3o[k6kok6d^On/ZkgoZjFoojf`_onUdJ;oU^2EojKIZonU
fZCoWmfTok;9[OoWMggokW9colffO_o2dg_oaM20ol[9POo?bGgocLUool[;PooDcWcodLYoolg8P_oB
b7kod/MoomO8NooBag[odLMlom78O_o>ah;oclMoomG8N_oHa7?odK=colFVOonnX8Ko_YJ1okbDNonl
W7ko^:B3okBXROnhW8D2okVLP@0EokVHPOnfUH7o]HajokB;N_ncSH7o/GabojmjJ?n`QfGo/Y=Rok9m
GOndKe_o/VmKok5jGOn^PEko/7IKok1iG?n]N63o[WUOolRPC_oB/D[ocje;00;od:i:01godK5;om:c
C?oB[d_oeJM<omBOC?o;XDWoa[9=okO5C?nacT_o]lY?okS8ConibE3o]lY@okK:C_nabdco[/a;ojc;
BoncbdkoaLaGomO3GOoU]5oonZMSonJcHOo9a5cogKMZooVXN?onX7WooimdoonQL`02oonPLP08oojP
LoonXGGooZ5folg8Konkc6_o`L]/ol7:K?o1c6`2ol7:K0;o`L]/00Wo`LY/ol7;K?o1c6co`L]/ol7:
K?o1c6co`<]/ol7;K?noc6`00_o0bf/03oo2bf[o`laZol7<J_o3bV[oa<][oko<K?ndcFGo]<aKol3;
J?o3bfgo_/aZol3=JOo0c6Wo_/aWokc>J002ol3;J00Lol3;JOnobf[o_l]Zokg;JonncFco_<a/okc;
Jonmc6_o_L][okk;Jonmc6co^la/ol79J_nicF_oU>1Voh;VIOnJfEko_/]Iokc:FOndce_oal=CooV]
FoooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/
G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/
GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed0
1_ooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/
G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/
GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed0
1_ooZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/
G@;oojYL00?ooZ]Moon]G_oo[Eh00_oo[5d01?oo[EkoojYLoon/GOonZed3oon]GP06oonZG?onZego
ojeNoon]G_onZegoojeN0_oo[5d2oon]GP03oonZG?onZUgoojYL00?oojYL00GoojaMoon]G_ooZUco
ojeNoon/G@02oonZG008ooj[GOooZUcoojeNoonZG?oo[EkooZ]MoonZG?onZed2oon]GP05ooj[GOoo
ZUcoojeNooj[GOoo[Eh00_oo[5d01_oo[EkooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_oo
ZUcooZ]Moon/GOonZegoojYLoon/G@;oojYL0_onZed01_ooZUcooZ]Moon/GOonZegoojYLoon/G@;o
ojYL0_onZed01?oo[5gooZ]MoonZG?oo[5d2oonZG0;ooZ]M00KoojYLooj[GOoo[5gooZ]MoonZG?oo
[5d2oonZG0;ooZ]M00KoojYLooj[GOoo[5gooZ]MoonZG?oo[5d2oonZG0;ooZ]M00KoojYLooj[GOoo
[5gooZ]MoonZG?oo[5d2oonZG0;ooZ]M00KoojYLooj[GOoo[5gooZ]MoonZG?oo[5d2oonZG0;ooZ]M
00KoojYLooj[GOoo[5gooZ]MoonZG?oo[5d2oonZG0;ooZ]M00KoojYLooj[GOoo[5gooZ]MoonZG?oo
[5d2oonZG003ooj[GOoo[EkoojeN00;oojaM00CoojeNoonZG?oo[5gooZ]M0ooo[Eh01_ooZUcooZ]M
oon]G_oo[EkooZ]Moon]GP;oojaM0_oo[Eh00oooZUcooZYMoonZG003oonZG005oon/GOoo[EkoojYL
oon]G_oo[5d00_ooZU`02?onZegoojYLoon]G_ooZUcoojeNooj[GOooZUcooZ]M0_oo[Eh01OonZego
ojYLoon]G_onZegoojeN00;oojaM00KoojeNooj[GOooZegooZ]MoonZG?onZed1oon]GP000_oo[f<0
0ooo[fCoojmSoon_H`03oon_H`03oon_I?oo[f?oojmS00GoojmS00CoojmToon_Hooo[f?oojmT0_oo
[f<00ooo[F?oojmSoon]H`08oon_H`03oon`I?oo[f?oojeS00;oojmS0_oo[f@01?oo[F?ook1Toon_
Hooo[f@2oon_H`03oon_I?oo[f?oojmS00;oojmS00?oojmToon_Hooo/6@01Ooo[f<00ooo[fCoojmS
oon_H`04oon_H`03oon^I?oo[F?oojmS00CoojmS00?oojiToon_I?oo[f<00ooo[f<01Ooo[fCoojmS
oon_Hooo[f?oojmT00;oojmS00Oook5Uoon_I?oo[f?oojeSoon_I?oo[f?oojmT00;oojmS00GoojmT
oon_Hooo[f?oojmToon`I002oon_H`04oon`I?oo[f?oojmSoon_I0GoojmS0_oo[f@6oon_H`03oon^
I?oo[f?oojmS00?oojmS00OoojeSoon_Hooo[fCoojmToon`I?oo[f?ook1T00[oojmS00?ook5Uoon_
Hooo[f<01?oo[f<01?oo[fCoojmSoon_Hooo[f@2oon_H`04oonaIOoo/6CoojmSoon_I0?oojmS00?o
ojmToon_Hooo[f<00ooo[f<00ooo[fCoojmSoon_I002oon_H`06oon`I?oo[f?oojmSoon_I?oo[f?o
ojiT0_oo[f<01_oo/6CoojmSoon_Hooo[fCook1Toon_I0WoojmS00CoojmToon_Hooo[f?oojeS1Ooo
[f<01?oo[F?oojmSoon_I?oo[f@4oon_H`04oon_I?oo[f?oojmToon_I0?oojmS00?ook1Toon_I?oo
[F<00_oo[f<00ooo[fCoojmSoon_I002oon_H`05oon]Hooo[f?oojmSoon_Hooo[f@00ooo[f<2oon_
I0CoojmS00?ook1Toon_Hooo[f<01?oo[f<00ooo[fCoojmSoon_I006oon_H`04oon_I?oo[f?ook5U
oon_H`;ook1T00?oojmToon_Hooo[f@01?oo[f<00ooo[fCoojiToon_H`02oon_I0CoojmS00koojeS
oon_Hooo[f?ook1Toon_I?oo[F?oojmSoon`I?oo[f?ook5Uoon_Hooo[VCooJEZoobNK@;oo:1[00?o
o9m/oobNJoolWf`00_olWf`0:_olWVcoo9m[oobOJoolX6_oo:5/oobOJoolX6coo9m/oobOK_olX6ko
o:1_oofQL?omX7?ooImfoojNN?onWg[ooYimoonMP?ooWHCooif5oonLQ?ooW8[oo::AoobTT?okY8[o
njF9oo^WR?ohZXKon:Z8ooJ[QooeZhComZb3ooN/Poog[XComZf2ooJ]POof[H;omZb3ooJ/Q?ogZXGo
mj^6ooRZQ@;on:^40_ohZh<2ooR[Q00;ooRZQOohZXKon:Z5ooR[PoohZXGon:Z3ooR]POoh[Goon:B<
ooae]oooCm400_ooDlh2oomFc@0?oomGc?ooI<7oog2gooie]?olMk3oo7R`ooag/OokL[3onW6cooF4
]OodSk3omHbcooN7]OonMicoofIh00;oog2007[oofamoom]N_ooKgWooeecoom5FoonH4comg15oniW
LOoLHJCogVC8omYNcOoHFLCofEO3om]@a?oIAL?oe46oom=1`?oE@Kooe470omDo`_oC?/7odcc5om8c
booB;l[oe3;3omPaa?oE<l;oecS1omXfa?oR;Lcok2_ConX]dooU:m7og2KAom0Uf?o?9]WocbCLomDT
g_oP;MKohcS8omlhaooR=l[ojC;Aoo8fdoo_DKcojf:/oo5F^oobAlSokD3;onI1b?oW@lWojD?<onU2
c?oZ@/cok4C9oni2aoo`@lGol4C3onY2aOoR@L?og472omQ0aOoD@<Gocd75ola2a?o9A<Co`d35ol91
`oo6@/?ob4W1olA?`?o5C/7o_dZkokY>]Oo1BkOogd30onQ4__oa>=7oldBjonQDZOoMHI_oe6bBom1_
SOoEIY;ofVNJom23Q?o?TGKocHeeol^:MOo<SGGobX]golV;M_o8RgKoahYeolR<MOo6S7Ooa8UfolB:
MOo5RgCob8edolB;Loo1RG7oaHi_olRAKoo6Sg7oaI9bolBBL_o5U7;oaYIbolJEL_o7VFoob9a^olJG
LOo8Ug3obIa`olNGL?o4UG7oaYU^oljCM?oMRhCog8^3omb=Q0;oh8b:08Soh8Z:on2<QooGSH?ocXB:
om=oT?oGR8_oeXn3omN@PooGS8Woeh^:omZ?R?oJSXkofi:Eom^?UOoEO9_okZf1onJdP?o0RYkoaI2L
olbBVOo?TYSocY>JoljCVOo;T9_oaHRQol>7XOo;Si_od9:Iom6CVOoAU9WodYBHom:AVooATI_odi>J
omBDVOoEU9Woe9BJomFDV?oDTiWoeI>LomFEWOoDU9goeIFLom>CWOoGUY[of9BHokN<]OnUWLOoYiW5
ojVK`_nXVL7oYiK2ojFDa?nTUlKoZJO3ok:g_?na];coZjg0ojZU`OncZkooYm2NoiOQV_nYfjooY=bV
oigOY_nl_XOonVi_oo9[O_oHYgko_l]kol7@P_o9c8;odL]lolc:P?o:bX;od<amol[9Q?o=c8?odL^0
om7:P?oFbW[od/Mmom;8O_o?ah;oclQoolg6P_o?b83oelYfomO7Moo5_Hco^;6DokbUROnoUW[o_Y9j
okZQQOnjV8So^IJ5okVLPonkVX3o^iB0okbAPonjR7co^Hb2okMmL_ndKf;o[gIWojf@JOnbQ67o/GUO
ok9dG_n`Meoo[HYRok9jGOnaM5_o[gYMojacH?nkReCodJm:om:aC?o@/4cod;5=om2^C_oA/4kodK1@
om6bD?o@/4kodZI>omBOC_o@X4_ob[1?okS3COn`cTgo/m1AokK<Donhc5Co]/eC0_nfcU<03?ndcU;o
/<e@ok3=D?nhcEGo`<mHokK?FOoK`Vgooj9ioonNNoooXGcooj5joonRN@;ooj=g00Oooj=foonSMooo
Xggoi[ifokc>K_o0cW3o`/e`00;o`Le`00Co`Leaol7=L?o1cG7o`Lea1?o1cG006?o1cFoo_li_ol3>
L?o2cVoo`li`olC>L?o4cFgo`le]ol;=KOo3cFko`le]ok_@K_njcg;o/liPok?>Foo1cFko`/iaol7>
Koo1cFko_li]okg?KOo0cVgo`le/ol;>K0;o`/i]00?o`/i/ol7>KOo0cVd00_nocVd03onmcVko_Le^
okg>K_nncFoo_<i_ol7<Kon^eFkoR>IXoh_SIOnhd5oo`/aOok_>H_n_d4gohkYHoon_I006oon_H`04
oon^I?oo[f?oojmToon_I0KoojmS00CoojiToon_Hooo[fCoojmT1_oo[f<01?oo[VCoojmSoon_I?oo
[f@6oon_H`04oon^I?oo[f?oojmToon_I0KoojmS00CoojiToon_Hooo[fCoojmT1_oo[f<01?oo[VCo
ojmSoon_I?oo[f@6oon_H`04oon^I?oo[f?oojmToon_I0KoojmS00CoojiToon_Hooo[fCoojmT1_oo
[f<01?oo[VCoojmSoon_I?oo[f@6oon_H`04oon^I?oo[f?oojmToon_I0KoojmS00CoojiToon_Hooo
[fCoojmT1_oo[f<00ooo[VCoojmSoon_H`03oon_H`07oon]Hooo[f?oojmToon_I?oo/6CoojmSoon`
I00:oon_H`03oonaIOoo[f?oojmS00CoojmS00CoojmToon_Hooo[f?oojmT0_oo[f<01?oo/FGook1T
oon_Hooo[f@3oon_H`03oon_I?oo[f?oojmS00?oojmS00?oojmToon_Hooo[f@02?oo[f<01?oo[VCo
ojmSoon_I?oo[f@6oon_H`04oon^I?oo[f?oojmToon_I0KoojmS00?oojiToon_Hooo[f<01Ooo[f<0
1?oo[VCoojmSoon_I?oo[f@6oon_H`04oon^I?oo[f?oojmToon_I0KoojmS00CoojiToon_Hooo[fCo
ojmT1_oo[f<01?oo[VCoojmSoon_I?oo[f@6oon_H`04oon^I?oo[f?oojmToon_I0KoojmS00CoojiT
oon_Hooo[fCoojmT1_oo[f<00ooo[VCoojmSoon_H`03oon_H`07oon]Hooo[f?oojmToon_I?oo/6Co
ojmSoon`I00:oon_H`03oonaIOoo[f?oojmS00CoojmS00CoojmToon_Hooo[f?oojmT0_oo[f<01?oo
/FGook1Toon_Hooo[f@3oon_H`03oon_I?oo[f?oojmS00?oojmS00?oojmToon_Hooo[f@00_oo[f<0
1Ooo/6CoojmSoon_Hooo[fCoojmS007oojiT0002oonbJ@06ooncJ_oo/FWook=ZoonaJOoo/FSook5Y
0_oo/fX03Ooo/FSook5YoonaJOoo/VWook=ZoonaJ?oo/FWook9YooncJ_oo/FWook=ZoonaJOoo]6X0
0_oo/FT3oonaJ003oonaJOoo/f[ook5Y00;ook5Y00Cook5XooncJ_oo/VWook5Y0_oo/VT01_oo/f[o
ok5YoonaJOoo/FSook=ZoonbJ@?ook=Z00[ook9XoonaJOoo/FWookAZoonaJOoo/VWook5XoonaJOoo
/FSook=Z0_oo/FT00ooo/FSook5YoonaJ003ooncJP03oonaJOoo/f[ook=Z00;ook5Y0_oo/fX2oonb
J@07oonaJOoo]6[ook9XoonaJOoo/FSook9YooncJP02oonbJ@07ooncJ_oo/FSook9YoondJ_oo/FWo
ok=ZoonbJ@02ooncJP04oonaJOoo/VWook5XoonaJ0?ook5Y00Cook9YoonaJOoo/f[ook=Z0_oo]6X0
1_oo/VWook5XoonaJOoo/FSook=ZoonaJ0;ook5Y00Gook=ZoonaJ?oo]6[ook=ZoonaJ@02ooncJP;o
ok9Y01Sook5XoondJ_oo/f[ookAZooncJ_oo]6[ook5YoonbJOoo/FWook9XoonaJOoo/FSook9Xoona
JOoo/FSook9YoonaJOoo/f[ook9YoonaJ?oo/f[ook9YooncJOoo/VT2oonaJ@06ooncJ_oo/FSook9Y
oonbJOoo/f[ook5Y0_oo/fX01ooo/VWook5YooncJ_oo/FSook5YoonaJ?oo]6X00_oo/fX00ooo/FWo
ok=ZooncJP02ooncJP04oonbJOoo/f[ook5XoonaJ0;ook=Z00?ook9YoonaJOoo/FT00_oo/fX02?oo
/VWookAZoonbJOoo/f[ook5YooncJ_oo/fWook5Y0ooo/fX04_oo]6[ook5YooncJ_oo/FWook=Zoonc
JOoo/FSook=ZoonaJ?oo/f[ookAZooncJOoo/FSook9YooncJ_oo/VWook=ZoonaJ@;ook9Y00Sook=Z
ooncJOoo/VWook5XooncJ_oo/FSook5YoonbJ@;ook5Y00?ook5XoonaJOoo/fX01?oo/fX2oonaJ@07
ooncJ_oo/FWook9YooncJOoo/FSook=ZoonaJ@02oonbJ@;ook5X01Cook=ZoonaJ?oo/VWook9Yoonc
J_oo/VWook5YooncJ_oo/VWook=YoonbJOoo/f[ook5YoonbJOoo/FWook=ZoonaJ?oo/VWook=Zoonb
J@;ook5Y00kook5XooncJ_oo/FWook9YoonaJOoo/VWook=ZoondJ_oo/VWook5XooncJOoo/FSookAZ
ooncJP;ook9Y0ooo/fX2oonbJ@06oonaJ?oo/f[ook9YooncJ_oo/VWook5Y0_oo/fX02?on/F_oo:9`
oobQL_olXg7oo:5`oobRL?olXFooo:5`0_olXg408OolXW;oo:1aoobPL?olX77oo:5aoobPL?olXW?o
o:5doo^PLoolYG;oo:AaoobVL_olY77ooJIaoofTLOomYG?oo:=coofSM?omXWGoo:5dooBXMOof^GWo
mkejooRnO?oe^7kom;21ooN]Roog[8komjj<ooN]S?og[8Womjb7ooN]RP02ooR/R`05ooR/R_oh[X[o
n:j:ooR/ROoh[XX00_og[HP01?oh[HSon:b6ooN^R?oh[8L2ooR]R@24ooR]R?oh[XSon:b8ooR_Q_oh
/8;on:^:ooREWOomIL3ood[FoomCcoooElgooeK=oomFcoooFLkoofO1oome]_onMkCoo7Jdooag/ool
Mk;onWVbooMl[oogP[ComHbhooJ7^_ogP<3omWg1ooYm]oomNISooW:1oom[KoooJFKoof]ZoomTIooo
CDcon6I8onf>I?o/QYCogEk<om9JdOoII<[ofFO5oma/`_oMH/Kof5G6omQ<b?oJ@<coeCg5om@ka_oD
><OodcW6om<fb?oC<Lkocbo>ol`cb?o?=LKodSG5omLh`OoM=/Soj33BonX[e?oT:m?ofRWAomDUd?oC
9=Koe2SNomP[gooM:MoohC3Eon0hb?oQ>LWoiSS?oo8de_oj<Mgom4O9onaL]?odDKoomD?=on]2booX
A/WojTK<onU4c_oV@lcoiDK7onI7aOoTALCoh4?6omU4aooB@lOoc4?7olQ5`_o6A/?oaDG4olM5a_o;
A/OobDG5olY5aOo5@/Goa4;6olM3b?o7C<GobDk4olA?__njDk?oadbjonI2`oo/A<3ojD7:onlnb_oQ
GIooeF^FolibR_oCKI7ohUjRonEOYOoCP8[oci9jolb?N?o<SWWobhiiol^>N?o8S7_oahajolR=N_o6
S7Sob91iolR@N?o6SGOo`XYiol>;NOo7SgWoaHie0_o3SgD0]_o1SgCo`iAfolBGMoo5UWKoaYMfolFF
M_o4UgOoa9edolJKM?o4UGOoaIQeolRKLoo7VW?oaYMdolNLLOo@U7Woh8b7omj>QooOT8_oh8j>on2>
SOoQSHgoh8f>omV=R?o?QX_oeH:Dom^9TOoESX[of9:8omR=S_oHS8kog9>;omZ?SooKTYOog96HomEo
Woo_[h?oikF5ol>>Woo5T:3obi>NolnEWOo?U9coc9>OolV@X?o5RJGoa8^TolnDWoo@U9codINLom6F
WOoBUIgodiJNom2BX?oDUIcoe9JLomBEWOoEUYooeIFLomFFWOoFUYkoeiJOomFGX?oGVIooeIJNom>E
XOoJVI_odI2Rok:?_OnXXL[oZ9k7ojRLaOnVUlGoYYK5ojJBaOnWUlKo[jg4okBi`?n_/KooZk73oj^U
`onfX;goY]6LoiSRX?n/g;;oX]f[oj7QV?oF`VoomgMhooeSROoUSHCoc;YnolG=Poo8cX?odLakolc:
P?o<bh3od<anolc;QOo@c8;ocl^3omC;O_oBbWkod<Z0om79P?oAah3od/Moolk5PooDbGgof/ifolo=
P?nkahoo]LFSokRhW_o0XhSo`:5ook^LQ?nmUHKo^iZ5ok^PQ_niWHCo^Yj4okVCP?nkRh?o^H1hokAd
HoneKV7oZh=/ojn2J_ncNf7o/gYPok=cH?n^Q6?o/GmPok9eGOn_N5go[WIOojmhG?o8WdcodJi:olfX
B_o>ZD_ocZQ>olf[Coo>[53odK1@om:dD_oA]U?od;=Aom:^D_oDY53odii<om:WD_no^e3o]La@okO?
E_njcEWo^lmKokS?F?nhdESo]m5HokK?E_nadEGo[=5HokK?H?o7cVOod<=Yon72LOoc^g[onJUjoonT
O_ooXh3ooj=noonTO?ooY7WoojAmooF/O?o1dG?o_/mbol7AM?o1d7Co`Lmd0_o1d7@3ol7?L`0Iol7@
Loo1cg;o`M5col;@Loo4cg;oaM1dolK@M?o5cg;o`lmbol;?LOo2d7;o`/m`ol?@L_o5cg;o]m=aok_B
MOnld7Co[m1HokC?GOnocg;o`]1dol7?LOnodG;o_]5col3?LP02ol7@LP0Lol7@LOo1d73o`=1`ol;@
L?o2cfko`M9`ol?@L?o3cg3o`M5`ol7@L?o0cfoo_]1`ol7>LOo2cg?oXMa]ohCYJOnYfFCo`laSokcA
I?n/de7o`<M=oo^cIooo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=Z
oonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z
00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=Zoona
J?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00So
ok5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo
]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5X
oonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[o
ok=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z0_oo/VT06?oo
/FSookAZooncJ_oo]6[ook=ZoondJ_oo/FWook9YoonaJOoo/VSook5YoonaJ?oo/VSook5YoonaJ?oo
/VWook5YooncJ_oo/VWook5XooncJ_oo/VWook=YoonbJ@;ook5Y00Kook=ZoonaJ?oo/VWook9Yoonc
J_oo/FT2ooncJP07oonbJOoo/FWook=ZoonaJ?oo/FWook5XoondJP02ooncJP03oonaJOoo/f[ook=Z
00;ook=Z00Sook9YooncJ_oo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWo
ok=ZoonaJ?oo]6[ook=ZoonaJ@;ook=Z00Sook5XoonaJOoo/FWook=ZoonaJ?oo]6[ook=ZoonaJ@;o
ok=Z00Kook5YooncJ_oo/FSookAZooncJ_oo/FT2ooncJP08oonaJ?oo/FWook5YooncJ_oo/FSookAZ
ooncJ_oo/FT2ooncJP08oonaJ?oo/FWook5YooncJ_oo/FSookAZooncJ_oo/FT2ooncJP08oonaJ?oo
/FWook5YooncJ_oo/FSookAZooncJ_oo/FT2ooncJP08oonaJ?oo/FWook5YooncJ_oo/FSookAZoonc
J_oo/FT2ooncJP08oonaJ?oo/FWook5YooncJ_oo/FSookAZooncJ_oo/FT2ooncJP08oonaJ?oo/FWo
ok5YooncJ_oo/FSookAZooncJ_oo/FT2ooncJP;ook9Y01Sook5XoondJ_oo/f[ookAZooncJ_oo]6[o
ok5YoonbJOoo/FWook9XoonaJOoo/FSook9XoonaJOoo/FSook9YoonaJOoo/f[ook9YoonaJ?oo/f[o
ok9YooncJOoo/VT2oonaJ@06ooncJ_oo/FSook9YoonbJOoo/f[ook5Y0_oo/fX01ooo/VWook5Yoonc
J_oo/FSook5YoonaJ?oo]6X00_oo/fX00ooo/FWook=ZooncJP02ooncJP04oonbJOoo/f[ook5Xoona
J0;ook=Z0Ooo/VT1oonaJ@0000CookE_ooneK_oo]FoookA^0_oo]Fl01?oo]FkookE_oondK_oo/fd3
oondKP06ooneKooo]6kookE^ooneKooo]6gookE^0_oo]Fl00ooo]FkookE_ooneK`02ooneKP06oone
Kooo/fkookE^oondK_oo]FkookA^0_oo]Fl00ooo]FkookE_ooneK`02oondKP03ooneKooo]FkookA^
00cookE_00GookE^ooneKooo]FkookE^oondKP02ooneK`04ooncK_oo]FkookE_oondKP?ookE_00?o
okE^ooneKooo]Fl01_oo]Fl3ooneKP;ookE_00CookA^ooneKooo]FoookA^0ooo]Fl01Ooo]FkookE_
oondKOoo]FoookE^00OookE_00Cook=^ooneKooo]6kookE^1ooo]Fl00ooo]FkookE_ooneK`02oone
KP04ooncK_oo]6kookE^ooneK`;ookA^00?ookE^oondK_oo]Fl01Ooo]Fl00ooo/fkookE_oondKP03
ooneK`03ooncK_oo]FoookE_00;ookE_00_ook=]ooneKooo]FoookA^ooneKooo/fgookE_ooncKOoo
]FoookA^ooncKP02ooneK`04oondK_oo]FoookE_oondKP?ookE_00?ook=]ooneKooo]Fl00ooo]Fl0
1?oo]6kookE^ooneK_oo]Fl2oondKP;ookE_00CookA^ooneKooo]FoookA^1Ooo]Fl00ooo]6kookE_
ooneKP03ooneK`03oondK_oo]FoookA^00;ookE^0ooo]Fl01?oo]FkookA]ooneKooo]6h4ooneK`03
oondK_oo]Fkook=^00?ookE_00?ookE^ooneKooo]Fl00_oo]6h3ooneK`03ooncK_oo]6kookE_00;o
okE_00?ookE^oondK_oo]6h00_oo]Fl01?oo]6kookE_ooneK_oo]Fh2ooneK`;ookA^0_oo]Fl2oond
KP;ookE^1ooo]Fl01Ooo]FkookE_oondK_oo]6kookE_00;ookE^0_oo]Fl01Ooo]FkookE_ooneKooo
]FoookE^00SookE_00?ook=]ooncK_oo]Fl00_oo]Fl01_oo]6kookE_ooneKooo]6kookE_ooneKP;o
okE_00_ook=^ooneK_oo]FoookE_ooneK_oo]FoookA^ooneK_on[77onj9eoobSM@03oobTM@;oo:=d
00coo:AeoobTM?olYGGoo:AeoobTM_olXgGoo:=foobSMOolXgSonj9ioobTNOolYgP2oobUM`0aoobV
MoolYGSoo:IhoobVN?omYgSoo:IhooB]MOoa]gKom;YfooS2Moog`GOoml9iooO0Noog_Wcon<60ooW0
P?og^h;omKF3ooJ`Qoog[h_on:n?ooR_T?oh[Hkon:f=ooR]T?oi[I3on:j?ooR^SOog[Xgomjn<ooN^
Rooh[Xcon:j=ooN_S?oh[X_omjn;ooN_R_oh/XSomjn9ooRNVOokPZgooV;4oom?e?ooE=;ooeS>oomG
d?ooEM?ooeg<ooi]_`02ooig]`1:ooag]?olNKCongZdooN3/?oeQjgon7biooJ0`_oeQ<7omX30ooF1
`OogQ[komhVmooJ<_OoeSK;onXFQooimSoolMWKonfMOonmkJ?oVVXWojiNWonalbOoGH=3ofFC7omYR
b?oLFlgogECAom]@d?oKB=GofT7Gom/leooH=];oe3C=om4fbOoC=l[oe3?@oll`c_o><l_odCO9om4i
aoo>=lKoeSC:on@^dooV:mKogB_Bom@VdOoF9];oh2GGomlXg_oI;N3ogRoOon0ceOoN>LWoiSW>oo4d
fOoh=M_ooC?NooXndoobDkoom535oo=5cOoXAlWoi4[9onE9c?oPAlcofDK7omI9a?oBB/7ocDC8ola5
b_o:AlWoaTK8olA6aOo7Al@2olQ8a01Mol]7aOo<A/SocDO8ole5bOo7@L[o`So9ol<ob_o6B/Ooae?2
olIC`OnlE;Socdbloni1a_o[Al;ogTO2onM2c?oJH:7od7B=omE_UOoQI:3ojeN]onQN[?oCP8ooc95k
olZAO?o;TGcocIAkolbCNoo:TGcob8imolN=O_o6SGgoaY1jolRANoo8TGcoai1lolB>O?o3SGgoa8el
olFAN?o8UGKoaIIfol6FMonoTgWoa9IjolBGN_o3UW[oa9Ikol>INOo5WGSoaieiolJIN?o7VgSobIig
olRMMoo8VgOob9igomBFO_oRShcohI6?on6CT?oQTHoohI2@on2@TOoQSi;ofHZBolf3SooFPiOogXbE
omN?T_oITY7of8n?omV@TOoLThgofI:Bom^BVOoLTY_odWjSonncQOoU]H_o`i2RolFAY?o<UJ;od9NP
oljFXOo<UZ7obI:UolF;Z?o7SjKod9JQom2GX?oAV:3odIJO00;odiNQ08[od9BTom>FXOoDVIooe9RQ
omJIXOoDUj7oe9RPomFFX?oGUZ7oeINRomNJXooFVJCoe9NSomBIY?oHV:3ocHjYok6J`_nWX<_oZ9k8
ojJGaonWV<OoZI[6ojJFaon[XLSo/[75ok>e`on^/L?oZK;4oj^QaonoX[coY=NMoiSSYOn/gkWoXMfZ
ok_IOooTa77okGQloomPS_ocMhOog:60olW8Poo9dX?ocliool[:Poo>bgooclb0olc;QOoBbh;odlb3
omC=O_o@bh7od<b2olo9PooBbX3odLZ1om?9P?oDbg_od<YmomK<N_o6cHco/]6Zok;@/_nf_Ygo]jb<
okfLQonmUh;o_9b5ok^NQonkX8Oo^Z26okRDP?ndQ7Co/GaYok=gI?naOVCo[X9[okAgJOndN6?o]7UP
ok1oH_n_OF?o]GEOokAhG_nbNeko[gEQok^;EooA[4_odja<olnYCOo>YDgoc:A<olfVCOo>ZDgocjY=
oln/Coo?[e7od;ACom6cDoo@[e;ocjE@om2HC_oCY57o_km@okGAE_nfdUSo^LmJokO@F_ngd5Wo]m5I
ok_BGoo1dFWo`]5YokgAIOnjdFKo_M5Wol?AJOo<bF_oi<Agoo:dNoojZWkoojZ6oonVPoooXX3ooJb6
omG>OOnldGGo`M5gol7@Moo1dGOo`=5fol7AMoo0dGKo`M5fol;AM_o4dGKo`m9eolGAM_o6d7H2olKA
MP03olGAM_o2dWKo`]5d00;o`]5e00oo`]5dol?AM?o4cgCo]]EdokODM?o2dG_o]m9_ojgAE?nfdF;o
`M5fol;AM_nndWGo_]5eol3AMOo1dGD00_o0dWH00oo0dWGo_]9fokoBM@02ol3BL`0@ol7ALoo1dG;o
`]9bol?BLoo3dWCo`]9col?BM?o7d7Go`]5coiWRK?nGhVOo_]5VokoAI_n^deGoYm97on>oHP;ookE_
0_oo]Fh00ooo/fkookA^ooneKP02ooneK`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh0
0_oo]Fl00ooo]FkookE_ooneK`02ooneKP03ooncK_oo]6kookE^00;ookE_00?ookE^ooneKooo]Fl0
0_oo]Fh00ooo/fkookA^ooneKP02ooneK`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh0
0_oo]Fl00ooo]FkookE_ooneK`02ooneKP03ooncK_oo]6kookE^00;ookE_00?ookE^ooneKooo]Fl0
0_oo]Fh00ooo/fkookA^ooneKP02ooneK`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh0
0_oo]Fl00ooo]FkookE_ooneK`02ooneKP03ooncK_oo]6kookE^00;ookE_00?ookE^ooneKooo]Fl0
0_oo]Fh00ooo/fkookA^ooneKP02ooneK`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh0
0_oo]Fl00ooo]FkookE_ooneK`02ooneKP04ooncK_oo]6kookE^ooneK`;ookA^00?ookE^oondK_oo
]Fl01Ooo]Fl00ooo/fkookE_oondKP03ooneK`03ooncK_oo]FoookE_00;ookE_00_ook=]ooneKooo
]FoookA^ooneKooo/fgookE_ooncKOoo]FoookA^ooncKP02ooneK`04oondK_oo]FoookE_oondKP?o
okE_00?ook=]ooneKooo]Fl00ooo]Fl01Ooo]6kookE^ooneK_oo]FoookA^00;ookE_0_oo]Fh00ooo
/fkookA^ooneKP02ooneK`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh00_oo]Fl00ooo
]FkookE_ooneK`02ooneKP03ooncK_oo]6kookE^00?ookE_0_oo]Fh00ooo/fkookA^ooneKP02oone
K`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh00_oo]Fl00ooo]FkookE_ooneK`02oone
KP03ooncK_oo]6kookE^00;ookE_00?ookE^ooneKooo]Fl00_oo]Fh00ooo/fkookA^ooneKP02oone
K`03ooneK_oo]FoookE_00;ookE^00?ook=^oondK_oo]Fh00_oo]Fl00ooo]FkookE_ooneK`02oone
KP03ooncK_oo]6kookE^00;ookE_00?ookE^ooneKooo]Fl00_oo]Fh01?oo/fkookA^ooneK_oo]Fl2
oondKP03ooneK_oo]6kookE_00GookE_00?ook=^ooneKooo]6h00ooo]Fl00ooo/fkookE_ooneK`02
ooneK`0;ooncKOoo]FoookE_oondK_oo]Foook=]ooneKooo/fgookE_oondK_oo/fh00_oo]Fl01?oo
]6kookE_ooneKooo]6h3ooneK`03ooncKOoo]FoookE_00?ookE_00CookA^ooneK_oo]FkookE_0_oo
]6h2ooneK`7ookA^0Ooo]Fl1ooneK`000_oo]g<02ooo^7CookMdoongLooo]g?ookMdoongLooo^GGo
okIcoongM?oo]g?ookMd00KookMc00?ookQdoongLooo]g<00_oo]g<01?oo]gCookMcoongM?oo^GD6
oongL`03oongM?oo]g?ookMc00?ookMc00?ookQdoongLooo]g<00ooo]g<00ooo]gCookMcoongL`03
oongL`06oongM?oo]g?ookMdoongM?oo^7CookMc0_oo]g@4oongL`03oongM?oo^7CookMc00;ookMc
00CookMdoonhM?oo]g?ookMd0ooo]g<01Ooo]W?ookMcoonhM?oo]gCookMc00;ookMd0_oo]g<01Ooo
]gCookMcoonfLooo^7CookMc00;ookMd00?ookQdoongLooo]g<00_oo]g<01_oo^7CookMcoongM?oo
]gCookMcoonhM0;ookMd0_oo]g<02?oo^7CookMcoongLooo]gCookMcoongM?oo]g?ookIc0_oo]g@0
0ooo]g?ookMdoongL`03oongL`03oonhM?oo]g?ookMc00KookMc00?ookMdoongLooo]g<01Ooo]g<0
1Ooo]gCookMcoongM?oo]g?ookMd00;ookMc00?ookMdoongLooo]g<01?oo]g<00ooo]W?ookMdoong
L`02oongL`05oonhM?oo]g?ookMcoongLooo]g@01_oo]g<00ooo]gCookMcoongM004oongL`04oong
M?oo]g?ookMcoonhM0CookMc0_oo]g@9oongL`04oonhM?oo]g?ookMcoonhM0?ookMc00?ookMdoong
Looo]g<00ooo]g@01Ooo^7CookMcoongLooo]g?ookQd00;ookMd0_oo]g<01?oo]gCookMcoongLooo
]g@8oongL`03oongM?oo^7CookMd00?ookMc0_oo]g@:oongL`04oongM?oo]g?ookMcoongM0KookMc
00GookQdoongM?oo^7CookMcoongM005oongL`04oongM?oo]g?ookMcooniM@;ookMc00_ookMdoong
Looo^7CookMdoongLooo]gCookMcoongM?oo]W?ookMcoongM002oongL`03oonfLooo]g?ookMd00Go
okMc00GookIdoof[MookXgSoo:IhoobVM`02oobVN005oobVNOolYgWoo:IhoobVN?olYWT00_olYWP0
1OolYW[oo:EioobTNOokXWconj9o00;oo:Ql00goo:MmoobVOOolYggoo:MmoofXOOolZ7comZUioo:i
Nooc]G_olkIkooO4O?og`Wcon<=m00?on<=l0_oga7`02Oof`Wkoml5oooO2P?oh`X7onL64ooRoQOoe
^HGomKB8ooNbS002ooNbSP0NooRaT?oi[i?onJjEooV_U?oh[i?on:nBooR`T?oh/hgomk6>ooNUVOoj
RJgooGFfooi/_?ooG<gooeOCoomHd?ooF=7ooeGBoomPc?ooLKoooWRiooaf^_olMKWongVfooV1/ood
SJkom8n[ooIm]_ogOL7omH^m0_ogSKT2ooN=^P1KooR<_OohS<7omHc2oo6?_Oo]VJ_ojYjBon^GT?oY
VZ7ojiJZooB9^OoUHm3ofEC@omiAdooPB]SohDCKomhng?oM?M_ogScNomdlh?oL?=_ofS_IomPidooD
=M7odc;@olhbc?o<=L[od3O:om4ibOoA>lKoecG<om/^e_oG:MOodbOEomLXd_oQ:]CojRcEonTWg?oN
:n;ogS;Oon<deooV=m3okCCGooLdg_oj<moooC;Qoo`ifOogCLcokTk8onA7c?oJB<[oeTW:om=;b?o>
C<Gobdc4olU;aOo9BLOoadS9olU7b_o=B<[obdK:olQ7aoo8AlKob4S6olQ8aoo9AlKoc4S8ola6b_o9
A<goad3?ol8ocOo3@<cob4S9olYEaOo5E/Go`5>momM6`oob?/_oi4boomMC^_oOCL;ogUN_omeWWooR
IZKoiej/onUF[ooUHJSodX6@olbEP?o;U7koc9EnolfEOP02olbDOP0oolZBOoo9TH3ob960olJ?Ooo5
T83oaY1oolJBO_o4T7oo`hmoolB@Ooo3Sgooa9AkolJHN_o7VgWoaI]jokjBOOnoTWoo`iUmolFKOOo7
W7koaI]molZON_o:XG[ob9ijolRMN_o9WWWoaiiiolVQNOo8WWWoeIF5onBBT_oSTY?ohI>Con2CTooP
TYCogi2Eon6BU?oNT9GocX:Hom=oVooOS9Sofi6HomZBU_oFT9?of92DombFTOoIU9?ofY>KombDWOoC
PJKokk>:onRhSOo2T:GoaY>VolbFY?o=V:GobIBVolbGXoo9TZOo`H^^olVBZ?oBUj?od9RT00;odIVS
01SodiRTomFJXoo@UJKodINUomBIY?oDVJ?oeYVSomFIYOoDVJGoeIRTomNIY?oEUjGoeiZTomNLYOoE
VJOoe9RVomFIY_oGUZCoai:`ojVPb_nTXLooZ9c:ojRLbOnXW<P2ojVLb01HojjWaond]<Oo/k76ojj^
aonY]/So]Io9olRW_OnNh9goVn>/oj[O^_n[eYCof=Qdomc0NOoYO7kooV>@ooYZR_oXSX7ocl25olW@
Q?o?d8;oc<^5om3=P?o8c8Cob/b6om3<PooEc8;of<eoom;<P_o?c8Cod<b3om3:P_o;bXCoeLYlom39
POoBbH;oe/Ukol[9QOncdJ7oY]jioj[G]onc_JCo^jB=oknJP_noVh?o_Yf7okfMQonjVhKo]Hmeok67
JOnaPfWo/X5Xojn:J?ndN6So]7=/ok9hI_naQFCo[h=TokAcHOneMf;o]GYPok9eHOncNEkoc:9AomNa
CooC[E7odZ]?om2/Coo@ZToocjQ>om2YC_o?Z4kocZU?olj[D?o>[E;ocZmDolnbE?o>/5CocJE@om6J
DOo<YU;o_Km@okGBE_nedU_o]]5LokSBGonmdfKo_M=Xok_CIP;o_]=X01?o_M9XokWCJ?nhdfOo_=9X
ol;?J_oAc77oi<Qkoo2fNool/8?oojV:onZiP_nmdg[o`=9jol3CNOo0dg[o`==hol?BN?o3dgSo`m=i
00;oaM9i00Soa]9jolGBN_o5dWWoa]9jolGCNOo2dgSo`]=iol;BN0;o`]9g0_o2dWP03?o3dWOo]MMg
okCFN?o1dW[o_==mokGAJondd5Oo^=9Wol;BN_nodg[o_m=fol7BN@;o`==h01So`M9gol3CN?nodgSo
`=9hol3CNOnodgSo`==gol3CN?o0dgOo`]=gol?CMoo2dgOoa==golKBMoo:d7Wo^MIeoi;VJ_nWgV_o
`]5Zok7CEonOedKo_leFoo^hLOoo]W<2oongM003oongLooo]gCookMc00;ookMc00?ookMdoongLooo
]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo]g?ookIc00;ookMd00?ookMcoongM?oo
]g<00_oo]g<00ooo]gCookMcoonfL`02oongM003oongLooo]gCookMc00;ookMc00?ookMdoongLooo
]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo]g?ookIc00;ookMd00?ookMcoongM?oo
]g<00_oo]g<00ooo]gCookMcoonfL`02oongM003oongLooo]gCookMc00;ookMc00?ookMdoongLooo
]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo]g?ookIc00;ookMd00?ookMcoongM?oo
]g<00_oo]g<00ooo]gCookMcoonfL`02oongM003oongLooo]gCookMc00;ookMc00?ookMdoongLooo
]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo]g?ookIc00;ookMd00?ookMcoongM?oo
]g<00ooo]g<00ooo^7CookMcoongL`06oongL`03oongM?oo]g?ookMc00GookMc00GookMdoongLooo
]gCookMcoongM002oongL`03oongM?oo]g?ookMc00CookMc00?ookIcoongM?oo]g<00_oo]g<01Ooo
^7CookMcoongLooo]g?ookMd00KookMc00GookMdoongLooo]gCookMcoonfL`02oongM003oongLooo
]gCookMc00;ookMc00?ookMdoongLooo]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo
]g?ookIc00;ookMd00?ookMcoongM?oo]g<00_oo]g<01Ooo]W?ookMdoongM?oo]g?ookMd00?ookMc
00?ookMdoongLooo]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo]g?ookIc00;ookMd
00?ookMcoongM?oo]g<00_oo]g<00ooo]gCookMcoonfL`02oongM003oongLooo]gCookMc00;ookMc
00?ookMdoongLooo]W<00_oo]g@00ooo]g?ookMdoongL`02oongL`03oongM?oo]g?ookIc00;ookMd
00?ookMcoongM?oo]g<00_oo]g<00ooo]gCookMcoonfL`02oongM003oongLooo]gCookMc00?ookMc
00?ookQdoongLooo]g<01_oo]g<00ooo]gCookMcoongL`05oongL`05oongM?oo]g?ookMdoongLooo
]g@00_oo]g<00ooo]gCookMcoongL`04oongL`03oonfLooo]gCookMc00;ookMc00GookQdoongLooo
]g?ookMcoongM006oongL`03oongM?oo]g?ookMd00CookMc0Ooo]g@1oongL`0000?ookQgooniMooo
^WP01Ooo^GL00ooo^7OookUgoonhM`04ooniM`06oonhMooo^GOookUgooniMooo^GSookQg0_oo^GL0
1?oo^WSookQgooniMooo^GL2oonhM`CookUg00OookUhoonhMooo^GOookUgoonjN?oo^GOookQg00?o
okUg00?ookYhooniMooo^GL00ooo^GL00ooo^7OookUgooniM`08ooniM`08oonhMooo^GOookUgooni
Mooo^7OookUgoonjN?oo^7L3ooniM`04oonhMooo^GSookQgoonhM`CookUg00CookQgooniMooo^GOo
okQg1Ooo^GL00ooo^WSookQgoonhM`03ooniM`;ookQg0_oo^GL00ooo^7OookUgooniM`03ooniM`03
oonhMooo^GOookUg00?ookUg00CookYhooniMooo^7OookQg1?oo^GL00ooo^GSookUgooniM`02ooni
M`06oonhMooo^GOookUgoonhMooo^GSookYh2?oo^GL00ooo^7OookUgooniM`03ooniM`03oonhMooo
^GOookUg00;ookUg00CookQgooniMooo^GOookUg0_oo^7L2ooniM`06oonhMooo^WSookUgooniMooo
^7OookYh0_oo^7L00ooo^GOookQgooniN002ooniM`04oonhMooo^GOookUgoonhM`OookUg00[ookUh
ooniMooo^7OookQgooniMooo^7OookUgoonhMooo^GOookQg1Ooo^GL00ooo^WSookQgooniM`04ooni
M`03ooniN?oo^7OookUh00;ookUg00CookQgooniN?oo^GOookQg0_oo^GL01Ooo^7OookYhoonhMooo
^GOookQg00?ookUg00?ookYhoonhMooo^7L01_oo^GL00ooo^7OookUgoonhM`02oonhM`CookUg0ooo
^7L2ooniM`;ookQg00?ookUgoonhMooo^GL00_oo^7L00ooo^GOookQgooniM`02oonhM`03ooniMooo
^GSookQg00GookUg00GookQgooniMooo^7OookQgoonjN003ooniM`05oonhMooo^GOookUgoonhMooo
^GP00_oo^GL01?oo^WSookUgooniMooo^7L2ooniM`;ookQg00?ookUgoonhMooo^GL00ooo^GL01ooo
^WSookUgoonhMoon]WWoo:Yjoo^VNoolYg/00_olZ7/2oobWN`0MoobXNoolYg_oo:IkoobWNoolZ7_o
o:MkoobWO?olYWconjAlooZNP?okXX;oo:V0oobYPOolZ7ooo:Z0oofYOoomZWoon:Ymoo>gNood^Wko
lkImoo:cO?of`7gonLJ1ooS5P_ogaX7on<N2ooS5POogaH000_ohaH00W_oha7oomlEoooO5OoohaWoo
n<EnooO4Ooof`Woom/>0ooO4P_oh`h;onL>3oo[2Q_oj`8[omk^:ooJiR_og^h_omkF=ooNZU_oiTJWo
oW>mooia_?onM[_oofG9oomHdoooFM;ooeODoomGeOooI<WoogJmooih^oonMKcooWBlooYm]oofRK7o
m9>]oo>B[OohP;ConG[1ooJ?_?ofTkSomhjkooN<_ooiRl?onH_2ooZ;a?ofTK[ol9N/onbKXOoYVJ3o
jY6]onn7^OoeOKkonGS0ooATdOoUB]cohDOLon12gOoO?mgog43Loma3fooMA=_ogD;Momm2gOoN@mco
gD?Lom/mf_oG==Wod37Dol/db_o?=l_od3S;ollhbOoA=<goeR_Fom8XeooA9mOofB_GonL_fOo[;=[o
j2SHonD[gooS<^3ojC7Koo0de_of<]gon3;PooDeg_oc<^3olCKNonU6eOoMC/kodDS=ola;boo<C/So
be34olUA`?o9CLCobTW:ole9boo<BL_ocTS;ole8boo;BLWobDO9olU9bOo9B/SobT[8olY9b?o9A/_o
b4?>olI1coo8A<koad?>olE2cOo7ALcobU?8olMGa_o6DLCofTK1oo=1a?oOEKSodF6bomiD__oWD;ko
iUj^onMP[OoVGZkoiUb[on5WX_oBQY3ocYJ1olZGP?o9V87obiF1olfFP_o=UX7obiF1olVCP_o8TX;o
aY:2olNCPOo5TH?oa923olJCPOo6Th3oaY>1olNDPOo1Th3o`YEmolFIOOo4VGgoa9Unol:HOoo1Uh7o
`YR1olFJP?o6W8;oaib10_o9WWd0>Oo8WWkoaiemolVMNoo9WgcobZ9kolRNO?oJUX_oiiFGon:CU_oQ
TYKoh9:Fon6DU_oQU9GohIBFon2CUoo@Q9godWjPon2<W?oMT9cog9BIomN?VOoGTYKofiNDomZFU_oJ
UY_og9>PomR;Y?o]/Y3oj[b<okj<ZOo8UjSocINVol^DZ?o8U:Woc9ZWolNAZonoR[7obiBYom:JYOo?
VJKodIZUom2JY_oBVJOoeY^Uom6GZ?o@UjWoe9ZVomBIY_oFVjGoeY^VomFKY_oDVJOoeiZWomJJYooG
VZKof9bVomJKZ002omBJZ@1TomBIZOoGUZKo`iJfojJQconSW]3oYi_;ojRNbonYWL[oYi_:oj^SbOn`
[LOo];C7ok:]b?n^[L[oZkC8okZBb_o5Zk[oUn>Ioj7R]OnYfjoo`]5homkKO_oH_g_oj7mjooiWS?on
J8golGV4omVUOooAcX?ocln2omC=QOoCc83oal^5olW<Q_o?cHGoe/j0omG<P_oDbh;odL^6olg;Q?o=
bXGoe<]nom;<Ooo=b8Kod<^5omO<O_oBaggo^/nCojWQ^?nYj=3o[]JnokRkX_nnZhco`:B7oknPR?nn
X8_o_9aookB<JOnaRFWo/HQ[ok6BK?ncQVGo/gYWokAfK?naOfco/8eXok=kHoncLV7o]GIRokAiHonb
LfCo_haIomB]CooD[U3odZeAom>`D_oC/5CodZeBom6]DOoA[E;od:]Bom2ZD?o?[57ocjiBoln^Doo>
[ECocjmDolj_Doo@Z5;oeJ5Dolf]DOnnaeGo]MAIokgCIoo2dF_o_M=YokgDJ?nldfSo_M=XokcDJ0;o
_=AY00[o^mAXok[DJOnhe6So^MAXol3AJooAcgCoi[ekon70Nonoe7[o`=Am0_o2e7`00oo4e7_oaMAk
olKDN`02olKCO0?oaMAl00GoaMAkol?DNoo2e7co`mAlol;DN`02ol;CNP;o`]Aj0_o3dgX02onbfGWo
/]QkokoCNonme7go^m=mokOAIOnddEWo^M=/okkDO?o0e7co`MAk00?o`MAj0_o1dgX2ol3DNP06okoD
N_o2e7_o`]Amol;DO?o1e7_o`]Ak0_o1e7X02_o3e7Woa=AjolWBN_n]g7;oTNQ[ojoLK_nede_oYmE<
ojGFC?oS`FX4ooniM`04ooniN?oo^GOookUgooniM`;ookQg1?oo^GL01?oo^GSookUgooniMooo^GL2
oonhM`CookUg00CookUhooniMooo^GOookUg0_oo^7L4ooniM`04ooniN?oo^GOookUgooniM`;ookQg
1?oo^GL01?oo^GSookUgooniMooo^GL2oonhM`CookUg00CookUhooniMooo^GOookUg0_oo^7L4ooni
M`04ooniN?oo^GOookUgooniM`;ookQg1?oo^GL01?oo^GSookUgooniMooo^GL2oonhM`CookUg00Co
okUhooniMooo^GOookUg0_oo^7L4ooniM`04ooniN?oo^GOookUgooniM`;ookQg1?oo^GL01?oo^GSo
okUgooniMooo^GL2oonhM`CookUg00?ookUhooniMooo^GL00_oo^GL01_oo^7OookUgooniMooo^7Oo
okUhoonjN0SookUg00?ookQgooniMooo^GL00ooo^GL00ooo^7OookUgooniM`02ooniM`04oonhMooo
^GOookUgooniM`;ookQg0_oo^GL01_oo^7OookYhooniMooo^GOookQgoonjN0;ookQg00?ookUgoonh
Mooo^GP00_oo^GL00ooo^7OookUgooniM`02oonhM`CookUg00CookUhooniMooo^GOookUg0_oo^7L4
ooniM`04ooniN?oo^GOookUgooniM`;ookQg1?oo^GL01?oo^GSookUgooniMooo^7L4ooniM`04ooni
N?oo^GOookUgooniM`;ookQg1?oo^GL01?oo^GSookUgooniMooo^GL2oonhM`CookUg00CookUhooni
Mooo^GOookUg0_oo^7L4ooniM`04ooniN?oo^GOookUgooniM`;ookQg1?oo^GL01?oo^GSookUgooni
Mooo^GL2oonhM`CookUg00CookUhooniMooo^GOookUg0_oo^7L4ooniM`03ooniN?oo^GOookUg00;o
okUg00KookQgooniMooo^GOookQgooniN?oo^WP8ooniM`03oonhMooo^GOookUg00?ookUg00?ookQg
ooniMooo^GL00_oo^GL01?oo^7OookUgooniMooo^GL2oonhM`;ookUg00KookQgoonjN?oo^GOookUg
oonhMooo^WP2oonhM`03ooniMooo^7OookUh00;ookUg00CookQgooniMooo^GOookQg1_oo^GL000;o
ok]j0_oo^WX3oonkNP;ookYj1?oo^gX01Ooo^W[ook]joonkN_oo^g[ookYj00?ook]j0_oo^WX3oonk
NP04oonjN_oo^g[ookYjoonkNP;ookYj1Ooo^gX00ooo^W[ook]joonkNP02oonjNP;ook]j0_oo^WX0
0ooo^g[ookYjoonkNP03oonkNP03oonjN_oo^g[ook]j00;ookYj00?ook]joonjN_oo^gX00_oo^gX0
0ooo^W[ook]joonjNP02oonjNPCook]j0_oo^WX00ooo^g[ookYjoonkNP03oonkNP;ookYj00?ook]j
oonjN_oo^WX00_oo^gX4oonjNP;ook]j00?ookYjoonkN_oo^gX00_oo^gX2oonjNP04oonkN_oo^W[o
okYjoonjNP_ook]j0_oo^WX4oonkNP03oonjN_oo^g[ook]j00GookYj0ooo^gX01_oo^W[ook]joonj
N_oo^W[ookYkoonkNP;ookYj00?ook]joonjN_oo^gX02?oo^gX01?oo^W[ook]joonkN_oo^WX2oonk
NP03oonjN_oo^g[ook]j00?ook]j00CookYjoonkN_oo^W[ookYj0_oo^gX01?oo^W[ook]joonjN_oo
^WX2oonkNP;ookYj0ooo^gX3oonjNPKook]j0_oo^WX01Ooo^g[ookYjoonjN_oo^W[ook]j00;ookYj
1?oo^gX01_oo^W[ook]joonjN_oo^g[ookYjoonkNP?ookYj00?ook]joonjN_oo^gX01Ooo^gX01ooo
^W[ook]joonjN_oo^W[ook]joonjN_oo^gX01?oo^WX01Ooo^g[ookYjoonjN_oo^g[ookYj00Cook]j
00KookYjoonkN_oo^g[ookYjoonkN_oo^WX6oonkNP03oonjN_oo^g[ook]j00?ook]j00CookYjoonk
N_oo^g[ookYj0_oo^gX2oonjNP?ook]j00CookYjoonkN_oo^g[ook]j0_oo^WX5oonkNPGookYj00?o
ok]joonjN_oo^WX00_oo^WX3oonkNP07oonjN_oo^g[ook]joonkN_oo^W[ook]joojdN`03oobYO@;o
o:Qm0_olZGd4oobXO@0>oo^XOOokYggonjQmoo^WOOoiXgkonJ20oobXPOomZh7oo:Z1oob[P?omZh7o
njZ1oo:eOOoc_802oo>gO`04oo:dOood^7kon<N2ooS6P`;on<N300Oon<J3ooS8Poohah?on<N3ooO8
PoogaX?omlN300;omlJ202con<N3ooO6Poohah;on<F1ooO5POogaX7on<N1ooS7P_ohaH7on<B0ooK6
P?ob[XOolH2NooEdZ?oeNjOomH2VooY/^?ooE/gooe;AoomDd_ooFM3ooVc3ooem^?omN;_oo7Bmooaj
_?okQ;SomY2aoo>E[_odTjkomh>eooYf`?oiR<ConI31ooV<`_oiRlGonX_5oo^;aOoiRLCom8^honn=
[ooaQK?olGVkooE]aP;onf_=00WooF_<ooeTdoo[D]goiTkMonM>gOoUBMkohDSMomi7gOoOA]d00_oN
@]h0DOoNA=gogTKMome3h?oM?n;of3OMomDge_oF=]God3K>oldfb_o<</kodb[Gom8WfOoF:MWogRoG
on4aeooN;=_ogbOOonhbgOobAmGol4GDondbg_o[<]gojSGNonPfg_oW=^3oicWOomY3eoo>Bm7obT[<
olU>b?o;D/?obe?1ola?aOo<BL_oc4O=ole:c?o>BLcocD[<ola9c?o9Al_ob4W:ol]<b?o:B/Wobd[9
olU7b_o5A<goaT??olM4coo;A/kobTK=olI5cOo5BLWoadc;olEIa_o9E<GohDO1oo18_?oKGK;od6J^
omeJ^_oZCLSoj5JhonMP[OoUH:cohf6XommVY?oCQi7ocIZ3olRIP?o:VH7obiN3olbFPoo<Uh?obiR2
olREPoo7ThCoaY>4olNCQ?o8UX?obIF3olNCP`02olFDP`0>olBDPoo3UX?o`YF0ol:FOoo4VgooaIao
ol>IP?o4WH3oaYj1olBKP_o1V8Go`iV6olNMPOo9WWh2olVOO`0:olNNO_o8WggobImmolVRO?o:Wgoo
giJConNEV_oQTY[oh9BHon6EU`;ohIJG02?ohIFHomnBV_oCRIcodX>Qon2;X_oNT9oogYFLomZ?WOoH
TiWofYRFomVGV?oJV9cofi>RomV?Y?o^]i7ojkj>okj>Zoo5UJ_oc9NZol^FZOo;V:SobiVZolJ@[onn
R[?ociRYom:JYoo@VZSod9^Xom6KYooCVjSoeYfWom>IZ?o@V:_odi^XomBKZ002omJLY`1FomJLZ?oD
VjSoei^XomNLYooGVZSof9bWomRMZ?oEW:_oe9Z[om>H[?oDUjcoeiZXokfH__nUY=;oYik=ojRLbonX
W/goZIk;ojNJbon[Wl[o[jW;ok>`c?n`Y/coZjG=ojNRc_o8Qlko`[:ioi3VYOnThL;o]LjJom3AM?oG
fXKoeL1monMkO?ooI8_oofJ?ooU]ROoQThCoe[j0om;>PooCbhGoel^1olk;Q_o>c8Koc/n5olk>POoA
cXCoc/^6om?:QOoCbXCodlZ2omG;Ooo>bXKocLZ7om3<QOoEcH7of/Yiol?:Q?n]f;7oZNcCoj_Xd_n_
e;Ko]l6Pokf_T_o2YhWo`ZF1ok^FKondR6Ko/XQ[ok>CKonaTVgo/HEVok>0I_n`N6_o[8U_ok23J?nb
NF?o]7MRokAjHoncM6Go]WYQoljUDooF/e7odZa@om:[DOoB[E82om:_D`0Gom>_DooC[U?odZeAom:/
DOo@[5;odJaCom2^Doo?[e?odK1Com6eEOo?/UGod:MCom2PDoo>[eOoa<YSok_EI_nndf_o_m=/okgD
JonmeF[o_=EYokgDJ_nneFX00_nneF/02OnmeF[o^mAYokSEJOneeFOo]]EXokoDK?nneG3o`=EholGE
O@02olKEOP04olGDOOo5eGgoaMEmolGEO@;oaMAm00?oa=Emol?EOOo3eGd00_o3eGd00oo3eGco`]El
ol;EO002ol;DO00@ol?EO?o4e7co/]Yjok?INonoe7ko_=EmokkEPOnie7Ko]m5Ook?BG?nceVko`=En
ol;EOOo1eGco`MAlol7EO0?o`=El00?o`=Enol3EOOo3eGd00_o2eGd04?o1eGgo`]Emol7EOOo0eGgo
`=Elol7EO?o5e7goa=AkoigRLOnEj6ooY=YIok3CDOnRfDgo`<mKoobkNOoo^WX4oonkNP04oonjN_oo
^g[ook]joonkNP;ookYj1?oo^gX01?oo^W[ook]joonkN_oo^gX2oonjNPCook]j00CookYjoonkN_oo
^g[ook]j0_oo^WX4oonkNP04oonjN_oo^g[ook]joonkNP;ookYj1?oo^gX01?oo^W[ook]joonkN_oo
^gX2oonjNPCook]j00CookYjoonkN_oo^g[ook]j0_oo^WX4oonkNP04oonjN_oo^g[ook]joonkNP;o
okYj1?oo^gX01?oo^W[ook]joonkN_oo^gX2oonjNPCook]j00CookYjoonkN_oo^g[ook]j0_oo^WX4
oonkNP04oonjN_oo^g[ook]joonkNP;ookYj1?oo^gX01?oo^W[ook]joonkN_oo^gX2oonjNPCook]j
00?ookYjoonkN_oo^gX01Ooo^WX3oonkNP06oonjN_oo^g[ookYjoonjN_oo^W_ook]j0_oo^WX00ooo
^g[ookYjoonkNP08oonkNP04oonjN_oo^g[ook]joonjNP;ook]j00?ookYjoonkN_oo^gX00ooo^gX0
1?oo^W[ook]joonjN_oo^WX2oonkNP04oonjN_oo^g[ookYjoonjNP;ook]j0_oo^WX4oonkNP04oonj
N_oo^g[ook]joonkNP;ookYj1?oo^gX01?oo^W[ook]joonkN_oo^gX2oonjNPCook]j00CookYjoonk
N_oo^W[ookYj1?oo^gX01?oo^W[ook]joonkN_oo^gX2oonjNPCook]j00CookYjoonkN_oo^g[ook]j
0_oo^WX4oonkNP04oonjN_oo^g[ook]joonkNP;ookYj1?oo^gX01?oo^W[ook]joonkN_oo^gX2oonj
NPCook]j00CookYjoonkN_oo^g[ook]j0_oo^WX4oonkNP04oonjN_oo^g[ook]joonkNP;ookYj1?oo
^gX00ooo^W[ook]joonkNP05oonjNP?ook]j00KookYjoonkN_oo^W[ookYjoonjNooo^gX2oonjNP03
oonkN_oo^W[ook]j00Sook]j00CookYjoonkN_oo^g[ookYj0_oo^gX00ooo^W[ook]joonkNP03oonk
NP04oonjN_oo^g[ookYjoonjNP;ook]j00CookYjoonkN_oo^W[ookYj0_oo^gX2oonjNP?ook]j0000
1?oo^g[ookYjoonjN_oo^gX2oonjNP?ook]j00?ookYjoonkN_oo^WX00_oo^gX00ooo^W[ook]joonj
NP03oonjNP05oonkN_oo^W[ookYjoonkN_oo^WX00ooo^gX2oonjNP;ook]j0ooo^WX2oonkNP03oonj
N_oo^g[ookYj00?ook]j0ooo^WX01?oo^g[ookYjoonjN_oo^WX2oonkNP03oonjN_oo^g[ook]j00Oo
ok]j0_oo^WX01?oo^g[ookYjoonkN_oo^gX3oonjNP03oonkN_oo^W[ook]j00;ookYj0ooo^gX2oonj
NP04oonkN_oo^W[ookYjoonkNP;ookYj1Ooo^gX01?oo^W[ook]joonjN_oo^WX2oonkNP03oonjN_oo
^g[ookYj00?ook]j2_oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNP;ookYj00?ook]joonjN_oo^gX0
1?oo^gX2oonjNP03oonkN_oo^W[ookYj00;ookYj0ooo^gX2oonjNP?ook]j00?ookYjoonkN_oo^gX0
0ooo^gX2oonjNPCook]j0ooo^WX3oonkNP03oonjN_oo^g[ookYj00Gook]j0_oo^WX01?oo^g[ookYj
oonjN_oo^WX5oonkNP03oonjN_oo^g[ookYj00;ookYj1_oo^gX00ooo^W[ook]joonkNP04oonkNP;o
okYj00Gook]joonjN_oo^g[ook]joonjNP03oonkNP03oonjN_oo^g[ookYj00Cook]j00CookYjoonk
N_oo^g[ook]j0_oo^WX2oonkNP04oonjN_oo^g[ook]joonkNP;ookYj00Kook]joonjN_oo^g[ookYj
oonkN_oo^WX3oonkNPCookYj00Gook]joonjN_oo^g[ookYjoonkNP02oonjNP;ook]j00?ookYjoonk
N_oo^WX01?oo^gX2oonjNP05oonkN_oo^W[ookYjoonkN_oo^WX01?oo^gX00ooo^W[ook]joonjNP03
oonkNP03oonjN_oo^g[ook]j00;ookYj00Gook]joonjN_oo^W[ook]joonjNP02oonkNP04oonjN_oo
^g[ookYjoonjNP;ook]j1?oo^WX00oom/7conjMnoo^XO@04oo^YO@0Joo^XOOokZGgonjUmoo^XOOok
ZGgonjYmoo^XOOojZWconZUlooVVOOojYGoonjUooobYP?olZX7oo:Z0ooF]OOob^gool[Mooo:fOoob
]gool[Iooo2aOoof`h;on<J2ooS6Poohah<2ooS6P`03ooS7PoohaX?on<J300?on<N30oogah<3ooO8
P`1oooO8Q?ogaXCon<F1ooK5P?o`_83ok9>8oo9jWOoaNYgol8:Honn6T_oaNi_on5bgoo]A_ookCl;o
nUbkooEjYoodQYoomGjUoo=lYOo_RIgoki6KonjFV_o]UiWokYJLoo2=XOocOZcolX^eoo6H/_obU[Co
li>fooB?^?ogQL3onW_5ooMaa_odK/ComV[9ooUVcoojIM3onfK?ooeZc?omKL_ooFk>ooIQfOoVCMoo
iTgNonI<gOoVBmkoiDgMonM>gOoVB]kohTONon56g_oPAMkogD7PomXkh_oI=n;ofcORomThg?oE=mOo
cSKDol``dOo@:]KofBWHoml]f_oS<=WohR_Lon<[gOoZ;=ool3[LooM>doogD<ooiT?DomXfgOoL>=co
gcONon<ehOoQ=n3oeD7Gol]9c_o9ClOobU72olYB`Oo:ClGobdW<olY5d?o:A<oobdK=ol]6c_o9ALko
bTO<olQ6c?o7Al_obDW:ol]7c?o9ALkoaD;?ol=2cOo6A/cobDS<olU9boo:C<[oaD_8ol5:aOnmD<7o
_5[2oleDa_o[@l?okTZjom]O/_oEIjoog62donIB`ooYD[oojEbaonIP[?oSI:Goh6ZSom:4Too;VX?o
b9^0olZJPOo;Uh?oc9J3olZFQ?o9Uh?ob9J3olRDQ@02olVDQ00GolREPoo8UX?obIJ3olJEQ?o2TXCo
_Xj5okn@QOnoU8?o`iYoolJMOoo2VH3oaIV0olNMP?o2Vh7oaIj2olROP_o5VhKo`YF6olBKPOo9X7ko
bJ1oolROOoo6WGl00_o9Wgh02?o8XWcocIj1on6FU_oVU9[ohY>Ion2EV?oQUiOohIJH0_oQUIL08_oP
TI[oehfKom>7X?oMQZCoghnOomfEVooKT9oofI2MomZHU_oIUiOofIRJomZCX_oIS:Kol;Z?onZmS_o0
T:_oaY>/olfHZ?o<V:SobINYol^HZ_o4SK7o_XZcom2IZ?oBVZSod9ZWom2KZ?o@VZSodi^XomFMYooD
VZSod9NZom:JZOoDVZP2omJLY`0fomJLZ?oDVZWoeI^XomRLYooGVjSoei^WomRLYooGWJSoe9b[om>I
[?oBUjgoeYNZomBJZoncV/KoXIkDojNGc_nXUlkoZIO@ojZLcOn/YlSo/Zo4okBd`on`/<?o/Jk4ok>n
`_ng]/CogIG8olC0ZOn>hhoo[=>EomKHM?o>fG_ofM^3om?1OOoXOX3oofJ=oom/T_omJY;ok7b9omV^
POo<bXCod<b6omO9PooBbHSoe<^7omK?PooBd87obLb5olc;Q_o@bXCod/Z3omW;O_oCbXCodLV70_oA
bhD0:OoDc8?oe/elolK8OoncdJSoZ>K>oj_[eon]i/Go[mJgokJnWonm[HGo`ZAhok^?IOngRVKo]I5[
ok>EK_naR6co/8AXok63I_n]RFoo[89`ok9lJ?ndNV?o]7ESokEeI?ncLF?o`hmIomNeDOoD/E;odjiA
om:[D?oAZE3odJ]Com>_DooC/5Codk5Dom>`DooB[e?odJeCom6]D_oA[U?ocjeC00;od:iC00cod:mC
olnYEOo>VUSociYGol^bG_nncF3o_MEYokkCK?nmdfco_ME[okcDJ_nleFT2okgEJ`0=okkEJonne6[o
_]A[okkDJonle6[o^]EYokkDJOnneF_o_mEbol?EN_o6eGooa]AoolGDOP02olGDO@04olGEOOo4eGgo
`MEmol;EO@?o`mEm0oo2e7`04_o2eGco`]Alol?EO?o5dgco[]ajok;INoo0dggo_=EmokgEOOnoe83o
]]E]okO@G?n_de_o]]E_ol;EOoo2eGgo`MAlol3EO0;o`MEm00Co`]Emol;DOOo0eGgo`]Am0_o2eGd2
ol;DO@0@ol7EOOo0eGgo`MEmol7EOOo2eGgoa]=mok[GNonBifooRNIKojOFD?n_de7oYmE@onS2Kooo
^W[ook]joonjNP;ook]j1?oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNPCookYj00Cook]joonjN_oo
^g[ookYj0_oo^gX4oonjNP04oonkN_oo^W[ook]joonjNP;ook]j1?oo^WX01?oo^g[ookYjoonkN_oo
^WX2oonkNPCookYj00Cook]joonjN_oo^g[ookYj0_oo^gX4oonjNP04oonkN_oo^W[ook]joonjNP;o
ok]j1?oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNPCookYj00Cook]joonjN_oo^g[ookYj0_oo^gX4
oonjNP04oonkN_oo^W[ook]joonjNP;ook]j1?oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNPCookYj
00Cook]joonjN_oo^g[ookYj0_oo^gX2oonjNP03oonkN_oo^W[ook]j00Cook]j0_oo^WX00ooo^g[o
okYjoonjNP02oonjNP?ook]j0_oo^WX3oonkNP03oonjN_oo^g[ook]j00?ook]j0_oo^WX4oonkNP?o
okYj0ooo^gX00ooo^W[ook]joonjNP05oonkNP;ookYj00Kook]joonjN_oo^g[ookYjoonkN_oo^WX2
oonkNPCookYj00Cook]joonjN_oo^g[ookYj0_oo^gX4oonjNP04oonkN_oo^W[ook]joonjNP;ook]j
0_oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNPCookYj00Cook]joonjN_oo^g[ookYj0_oo^gX4oonj
NP04oonkN_oo^W[ook]joonjNP;ook]j1?oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNPCookYj00Co
ok]joonjN_oo^g[ookYj0_oo^gX4oonjNP04oonkN_oo^W[ook]joonjNP;ook]j1?oo^WX01?oo^g[o
okYjoonkN_oo^WX2oonkNP;ookYj00?ook]joonjN_oo^gX01?oo^gX2oonjNP03oonkN_oo^W[ookYj
00;ookYj0ooo^gX2oonjNP?ook]j00?ookYjoonkN_oo^gX00ooo^gX2oonjNPCook]j0ooo^WX3oonk
NP03oonjN_oo^g[ookYj00Gook]j0_oo^WX01?oo^g[ookYjoonjN_oo^WX3oonkNP0000CookYjoonk
N_oo^g[ookYj0ooo^gX00ooo^W[ook]joonjNP02oonjNP03oonkN_oo^W[ookYj00Gook]j00?ookYj
oonkN_oo^gX00ooo^WX2oonkNP03oonjN_oo^g[ookYj00Cook]j0_oo^WX01?oo^g[ookYjoonkN_oo
^gX2oonjNP03oonjNooo^g[ook]j00;ook]j00?ookYjoonkN_oo^gX01Ooo^gX2oonjNPGook]j00Ko
okYjoonkN_oo^W[ookYjoonkN_oo^WX3oonkNP03oonjN_oo^g[ook]j00?ook]j00CookYjoonkN_oo
^W[ookYj1Ooo^gX2oonjNPCook]j00?ookYjoonkN_oo^gX01Ooo^WX00ooo^g[ookYjoonjNP03oonj
NP03oonkN_oo^W[ook]j00;ookYj0_oo^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ook]j
00;ook]j00KookYjoonkN_oo^g[ookYjoonkN_oo^WX2oonkNP?ookYj0ooo^gX2oonjNP04oonkN_oo
^W[ook]joonjNP;ook]j00?ookYjoonkN_oo^gX00_oo^WX01?oo^g[ookYjoonjN_oo^WX2oonkNP05
oonjN_oo^g[ook]joonjN_oo^gX00_oo^WX9oonkNP03oonjN_oo^g[ookYj00;ook]j00SookYjoonk
N_oo^W[ookYjoonkN_oo^W[ook]joonjNP?ook]j0ooo^WX5oonkNP05oonjN_oo^g[ook]joonkN_oo
^WX01?oo^gX2oonjNPGook]j0_oo^WX2oonkNP05oonjN_oo^g[ook]joonjN_oo^gX01?oo^WX4oonk
NP;ookYj0_oo^gX3oonjNP?ook]j00Gook]koonkN_oo^g[ook]joonjNP05oonkNP03oonjN_oo^g[o
okYj00;ook]j00?ookYjoonkN_oo^WX00_oo^WX2oonkNP;ookYj00?ook]joonjN_oo^WX00ooo^WX0
0ooo^g[ookYjoonkNP0;oonkNP04oonjN_oo^g[ookYjoonkNP?ookYj1?oo^gX3oonjNP04oojgNook
ZGgonjImoo^ZO@;onjQm00?onjUmoo^ZOOokZWd00ookZWd00ookZ7gonjYmooZYO@02ooZWO@07ooZW
OoojYWoonjUooobZP?ogZgkol[Ymoo>iO`04oo>gO`06oo:eO_of_Woon<J2ooW6Poohah?on<J30_oh
ah<00oohaX?on<N3ooS7P`03ooS7P`0JooS8Poohah?omlR3ooO7Poohah?on<J2ooO8P_ob`H;ok:68
oo1gVOobMj3ol8:Ionn4V?o_QiOol8:IooMS/OomCLCondo0ooQR/oodOJ3olXNHonn0W?o^Pi[ok96=
onVJQooYVXP2onZGRP1WonZESOo[R9?ojHnLonNUV_oWY9[ojYZQonn;[_odNKconFo8oo]Xc?oiILgo
nFK?ooaYcoolJ/gonVc:ooU[b_ojJlWonfc:ooYZdOo/EMgohdONonE;gOoTBmkoiTcMonE=gOoVBmko
iDcMon==gOoVC=gohdKPomlnhooJ=n?ofCKRom/lhooH?>;odcGJomP`gOoU;^7ok37Lond_g?ob;N3o
lbcQooD/h_oj;^;onS?OooHjg?oj@mOonSgEoo<dg_oS=MoogSKNon8dhOoO=moodT?AolU>aOo:E;oo
bU?0olY?a?o;B<_oc4G>ol]5coo:A/gobdK=ol]7cOo:ALkobDG=olM6boo6B<WoaD[8olA<a_o2B<[o
`DW9ol5@`oo0EKoo`URool9H__o2G;[o_e^iokYI^OneG[Oo]UZoomA;c?oe?/cokDjiomUS[_oEIZko
fF>aonAH__oYBlSoi5ZconARZ?oSI:SohF^UomF5UOo;VX?ob9Z0olZGP_o;UHCobYF4olVFQ?o9UX?o
biR3olZFP`02olVEP`0=olRDQ?o6U8?oaI>4ol>BQOo3ThGo`Y>3oknBQ?o0UH?o_iJ2olBKOoo8WGoo
aYb0ol:IP002olBLP009ol>MPoo7WXCob9^5olBHQOo3V83oaienolZPOoo7WWooaYeo00;obJ1m00Oo
bJ5nom2LQOoSUIOoiY>Kon>DV?oPU9Soh9JG00;ohIFG01[ohIFHomn@V_oISIcoe8NPom^5Y?oOSZ3o
g9>Mom^AW_oKT9oofYFHomRGUooJVIWofY>PomN6ZOoa^hoojKf?ol>CZOo;UZ[ocYVXolbHZ?o:UjWo
biJZol::/_o2S[3odI^Xom>KY`;od9ZX087odI^Wom>KZ?oEW:Ooe9^Xom2FZ_oBVZSodiZYomJLZ?oF
WJOoeifWomBKZOoDVZWoei^XomRMYooGVjSof9bWomVNYooGW:WodiZ/olnD[oo=TK3odiJ/ol^E]?n/
YL[o[KZnojngZ?ncaYco_=FDok[CQ_nidH7o^M60okCCNongdggo^mEkokCFN?o8bH7omkBColW;N_nU
g6Sof^=^onGWJ?oIiG7oj>QeomoBLooeRW7oof1booi^OOooKHComG23on2EN?o>ah3ocMJ5om3>QOo@
bHSoelf5omW;Q?o?ahOobLN8ol[9Q_o8bHGodl]oom?;Q?o?b8Sod/V6om?:Q_oBbXGodL^4olo>POo=
aWko]lZJojWM_onZj/coZn_=ojWT`OnZdJ[o/l2FokNTNoniTFOo^Y9YokZKJoneSF[o/HQ/ok65JOnb
T6Wo[hm`ok=hKOndNV[o/gYVokIfHoneMVGo]W]PoljVDOoF/e7oe;1ComB_D_oC[E;odZ]Aom6XD?oC
Ze7odjmCom>`E?oB/ECod[1Dom:_DooB[U;odJiBom:bEOoA/UGodK5FolnXF?o>YE_ocZEJolbHE?oA
WEKobkUOol7@Hoo0eV_o`M=^ol7DK_nmeF_o^mEZokcEJ_nmeF_o_=E[okgDJonmeF_o_]E[okgDJonm
eFX00_nneFT02?nmeFco_mEdolCEO?o6e7koa]EnolCEOOo3eGgo`]Em0oo3eGd00oo4e7go`]Elol;D
O002ol;EO00Bol;DO?o2eGco`mElolCDO?n/g7[o/=UlokoDOOnleGgo_MEmokkEOonkeGco/mATok;B
F?nadego^MEaol?DOoo1eGgo`=Em0_o2eGd00oo2e7go`]Emol3EO@05ol;EO@03ol3FOOo0eGgo`MEm
00?o`]Em00Ooa]=nojkKN?mljV3oR^1@ok;CD_nWeToo`laM00Cook]j00?ookYjoonkN_oo^WX00_oo
^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo
^gX00ooo^W[ook]joonjNP02oonkNP03oonjN_oo^g[ook]j00;ook]j00?ookYjoonkN_oo^WX00_oo
^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo
^gX00ooo^W[ook]joonjNP02oonkNP03oonjN_oo^g[ook]j00;ook]j00?ookYjoonkN_oo^WX00_oo
^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo
^gX00ooo^W[ook]joonjNP02oonkNP03oonjN_oo^g[ook]j00;ook]j00?ookYjoonkN_oo^WX00_oo
^gX00ooo^W[ook]joonkNP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo
^gX00ooo^W[ook]joonkNP02oonkNP06oonjN_oo^g[ook]joonjN_oo^g[ookYj0_oo^gX3oonjNP?o
ok]j0_oo^WX01?oo^g[ookYjoonkN_oo^WX2oonkNP03oonjN_oo^g[ook]j00;ookYj00Cook]joonj
N_oo^W[ookYj0_oo^gX01Ooo^W[ook]joonkN_oo^W[ook]j00;ookYj2_oo^gX00ooo^W[ook]joonk
NP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo^gX00ooo^W[ook]joonj
NP02oonkNP03oonjN_oo^g[ook]j00;ook]j00CookYjoonkN_oo^g[ookYj1?oo^gX00ooo^W[ook]j
oonjNP02oonkNP03oonjN_oo^g[ook]j00;ook]j00?ookYjoonkN_oo^WX00_oo^gX00ooo^W[ook]j
oonkNP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo^gX00ooo^W[ook]j
oonjNP02oonkNP03oonjN_oo^g[ook]j00;ook]j00?ookYjoonkN_oo^WX00_oo^gX00ooo^W[ook]j
oonkNP02oonkNP03oonjN_oo^g[ookYj00;ook]j00?ookYjoonkN_oo^gX00_oo^gX00ooo^W[ook]j
oonkNP02oonkNP06oonjN_oo^g[ook]joonjN_oo^g[ookYj0_oo^gX3oonjNP?ook]j0_oo^WX01?oo
^g[ookYjoonkN_oo^WX2oonkNP03oonjN_oo^g[ook]j00;ookYj00Cook]joonjN_oo^W[ookYj0_oo
^gX01Ooo^W[ook]joonkN_oo^W[ook]j00;ookYj2Ooo^gX00ooo^W[ook]joonjNP02oonkNP7ookYj
003ooooFMRcoomIf00?ooLahoo^nN_ok_WX01_ok`7X03_ok_g[onkmioo^oNOoj_gWon[ijooZmN_oj
_WWon[ijooZnNook_g_on;ijoo;7N_occGcollYl0_ocbG`2oo?9N`04oo?8O?ocbgcon=aoooWMO`go
n=f00_ohg7h02_odeggokkR4oo6>U?o`OicolHbJonnBUOo_TiCokiFDonjFT_obNjH2oo]E`P0CooM`
/OocSIkolY6Ioo2<Voo]UYKok:>>onZVQooYYHSojZ>:on^TS?o[Y8_ojiV?on^GVOoYZYkojjRRoo2@
/_ofO<;oo6g<ooa^c`02ooadc00;ooUcbookM/[ongG9ooYebOojM<SonWG:ooYgaoomMl_om6SFonE@
gOoSC]`00_oTDm/0L_oTD]coi5?LonAAgOoUDMgoi4oNonA9hOoSA>Coi4CSonI7hOoXCN3ojDkQonM;
h_oX@n7omcoOooi5g_ojAMgonC_PooHdhOog=^3omcONonhffOoX==_ojcSNoo<igOoh?=[onCgJoo0m
f_oL@MSocd_BolaK`_o;IKWoc6BkoleJa?o=Dl_ocE7=oliCc?o<EL[obE?9olYFb?o;ELWob5O7olIM
`Oo1H;co`6:iokmT^OnlJ;Ko^fReokQR^OniI[Ko^ffaok]Z]OnnJKKo_fRfokeY]oniIkOo]VRfokES
_?oJCLkooTC=on]P]OoGLj_oeW2]omU^[_oPIKOojE;5onIG__oSKJOohfjUonAcY_oFTiCoc:^1olVZ
O_o:YX7objN1olVXPOo:ZH7objZ0ol^YP?o:Z87ob:F1olNTP_o4XH?o`j:2ol>SP_o6YX;oaJN2olFX
P?o4ZGoo`jUoolBYP?o2Z7ooa:YmolJ/OOo7/7goa[5mol6[O_o2[7koaJj2olBZPoo5ZX?oajj0olJ_
OOo4[7coaJimolN_OOo6[gcob;1lolRaO?o8/7godJ^5onBUUooUY9WohZFFon6UUP;oh:JE0_oPYIH0
1OoPX9Wog9jMomBJWOoGU:;oh9fO00;ofj>K01;og:>Lom^VVOoHYiKofZbEomVVW?oFUjKol<^?oncB
S?o2XZOoc:VWolbZY_o;ZZKobZZVolVUZOo1VZooaj:/om:]YOoC[J@3om2/Y@07om>]YOoE[JGoeZjT
om6YYooAZZKodj^VomF^YP02omJ_Y@1EomF^Y_oCZZOoeZbVomR^YOoG[ZGoejfUomV_Y?oG[:Kod:F/
om6Y[OoN^Z?oi/2Ioo36RooRchSo^NM_okCWJ?nhiFKo]nEVok_UIoniiFKo^NEWokSUJOniiFSo_^EY
okoTJ?nliFSogMUmooc<T_o7hW;o/^eKooK[HooOl6[oio5Yoo7bJ_o]hVKonHiJoomXFOooM5ooogEU
oom^I_obSF7ohLi_omc[M_oFhWkofMeoomcKO_oJe7ooe=:3om?AQ?o?chCoclj0olk?POo5c8Soa/j7
olg?QooBchKod/b4olc?Q_oDdH?oe<YookW;R?n/gJkoZn_3ojW^`OnSj[GoXnRdojOHY_n/]83o]jIb
okZWJOnhV6Ko]i1WokBAJ_ncVFWo]9]Wok>7JoncP6oo/X9/ok>3IoncOVGo/7aWol>KEOoE^Dgoe;I@
omBhDP02omBiDP0Mom:fDOoB/e7odkA?om:eCooC]U7odkQBom>iDooC^E;od[M@om:gDOoC]e?od;AG
oln`F?o@/USod[AJom6dF_o?[UOocjAEom:ZEoo9`U[o`]iQokoVJOo0iF_o_^IYokgVJ?nmiVWo_^IY
okkVJ_nmiVX00_nmiVT02_nliVSo_NIYokkVJOnmiVKo^nIVokcVK?o1iWCo`nIiol;VNoo2iWX3ol?V
N`03olCVNoo3iW_o`nIj00Go`^Ii013o`nEiolCUNOn]jWOo[^UiokkUNonliW_o_NIjokgVNoo0iGoo
]NIaojoUF_nghU_o/nAMok_VLOo3iWko`nIl0oo2iW/3ol7VN`?o`^Ik0oo1iW/4ol;VN`08olCUOOo1
iGWoSNaQog?bE?nMjE3o[^E>ojOVC_o/fVgooooFMT;oomIf003ooooFMRcoomIf00?oomEfooc6NOok
_7X01?ok`7X2oo^oNP04oo^nN_ok_gWon[mioo[0N@;on[ii00Konl1iooZoNOok`7_on[ijoo;2Mooc
cg/2oo?9N`;oll]k0_ocbW`01Oobb7col/QkooWLOOohgGoon=j100[on=f002?on=aoooWLOOoefWko
klB1oo2ATOocN9oolXNMoo2BUoo_U9Kol9>FonnCU_o_UYCol8NMooQN_?oiF/3olWfXonnAV_o^TYSo
k9:JonbNT_oYYh[oj:F6onRSQooZXXWojZB9onZWR?o[WhgokXjKoo2A[?ocS[_ongO9ooe^coolK/oo
o7?<ooYfbP02ooYebP1LooYgbOokM/SongK9oo]gb?olMl[ongO9ooaib?oiL]3ojESLon5>gOoRDmco
iECKonMDg?oWDMgoj53MonQ>g_o[Bn3okDOSona6iOo^B>Col53Poo5Ch?obDn7ol5;Oone>foo^CMWo
kd[HonU3fOoY@Mcoj43KonHlf_oO>m?oeCg5om8mbOoI?]?ogcgFon<od_oY@=GojdGCoo1?c?oZF/?o
ef:kolMR^oo4GKkobEc3olQIa_o8F/Goaeg2olEP_oo2HKko`6Bkol5U^oo0I;co_FJgokY[/_ngJk7o
^F^aokU[/_niJ[?o^VNeokQT]onkJ;Co_VReokeV^OnmI[So^fRfokYX]_ncHk[o^UW2omi7cOojCL?o
j6^bomIgZ_oGL:gofFb`omY//OoUF/7oj574onMS/_oVKJOohfjVomF?UOo;ZH?obJYool^WPOo;ZH7o
bjZ0olZZPOo;ZX3obZV0olRWP_o6Xh82olFRPP06olBSP_o5Yh;oajR1olRYPOo6ZH3oaJYo0_o3Z800
1Oo5ZX3oa:YoolF]OOo6/7koa;1m00;oak5m01;o`J^1ol>YPoo8[8?o`jV3olF[P?o:/g_oaZmmol>[
OOo4[Ggoa[1lolVbO?o:/Gkob;1nomF[R?oVYYKoiZJGon>UU_oRZ9D2on6WU@0Lon2VUOoQYiGohZBI
omnPWOoFWI_oeIBPon6KX?oNXYcofZ:KombSVooNYiWofjFIom^[UOoJYi[ofIjRong5Too/dHko`J2W
olbYYoo<ZZKoc:^UolbZYOo9Y:Wo`9V`olRSZ_oC[JGodZfUom6]Y@;od:bU00SodjfUomB^YOoE[ZGo
dZ^Vom6YYooCZjKoeJfUomF^YP;oeZnU00_odjZWomJ/Y_oH[ZGof:nUomF[YooCZ:[oeJbXonC0W?of
eXOoo=ElookEN002oooFMP1EomgMK?naifSo/nMYokKVJ?ngiV_o]^I/okCVJ_ngiV_o]^I[okOVJonk
iVgo^NI/okcVKoo_eY3om]6Fok_WK?o@lE_om>Y[omG^JooXkVWokO9/on_PJOoiSEcoofYNoomfGOoo
NF?oogAToo]kF_o^/F?oj^E[on7`L_oVjW?oj^Q_onGVM?oPi7SohN5gomoON?oMg7Ood=R0ol[GPoo8
eX?oam>4olg>QOo9cHOoc=27om?<QooCbX3oa/R4okCDX_nWiKOoX^Ndoj?Y]OnSk;_oX=NToio0S?nM
_7ooZ[AhokVTLOniVV_o^J1]okVUK?ndTFKo/8MXok:4KonbPVoo/X5Xok20IonfSF;od[ABomNjCooC
]53oe;Q@om>hD_oD^E?odkMBomBfDOoD]U3od[A?om:dD?oB]E3od[MAom>iDooC^U;odkMEom6`E`03
om6aE`0>om6bF?oA/eWodK=Jolj[Eoo@XUCodZ]Eol?AG?o0iV[o`nA/okoUJ_nniVWo_NIYokoVJOnn
iVX3okoVJP08okkVJ_nmiV[o_^IZokkVJOnmiVOo_>IXokcVM?o0iW`2olCVN`04ol?VNoo4iW_o`nIk
ol;VNPKo`^Ii00Koa>Eiol?UN_n[jWOoZnYhokkUN_nmiWX2okkVNP09okoVO?nkiWko/^EYokKSG?nh
heco/nENok_VL_o4iWko`nIk00;o`^Ik00?o`NIkol3VNoo2iW/01?o2iW/00oo1iW_o`>Ijol;VN`03
ol;VN`08ol7VO?o0iGWoY^IRogW_Don1l5SoZ^I?ojGWB_o5hE_ooooFMT;oomIf003ooooFMRgoomIf
00Coo]5gooc1NOok_G[onl1j0_ok_gX01?ok_W[onkmjoo^oNOok_gT2oo[0N@0DooZoNOoj_WWonl1i
ooZoN_ok`7[om[mjoo7;N_occ7_ollYkoo;9Noobb7collYkooC;NoocbWcollUloo;5Noofe7gon=eo
ooSMP?ohgX07ooSMP008ooWMOooifggom]]loo;?POo`XH[ol7fKooB1X?obTIP3oo2CUP0Koo2CUoo`
UYColHfJooQQ^_olE<?omGbXoo6EU_o]UY?ojI^ConNTRooUZ8Coi:F2onNTQOoZYHSojZN6on^XR_o]
VYGomGf[ooYc`OokMl[oo7;>oo]bcOokML_onWK9oo]fb_oiM/[onGO900;onWS903KonGO9ooYeb_ok
ML[onGS8ooYfaoomL/comF?GonQAgOo[DMgokeSLoo1EgOoaD]koldoPoo=>h?obBn7olT[Too5<i?oc
DN7olUCOoo9Egoo^D]ookU7KonY>e_oWB=KoiTOFonM6f?oT@]WogckIomm0eOoK@M;odT79ol]8_?o<
DK[oed_9on52e?o/A];olDk>onmFaoo^H[_ol6Jfon]U]?oEH;_o_f2nokaX^Oo0JKSo`6RhokmY]onn
JKKo_V^eokiY^?nmI[Wo^VJfokUZ/onjJ[@2okYX]01Qok]Y]?nkJ;Ko^F6kokYT^?nkIkGo^VNgok]W
]onkIkSo^fRgokAN__nmCL_ogdS7oo9J]OoVL[3oeWJ^omE_[OoHKJoofFf`on5P^OoWD<KoieNlon=^
Y?oPLZ7odXfDolbWQ?o:ZX3objV0ol^[P?o;ZX7obZV1olNVP_o8YH;oajF2olNUPOo6YH;oaZJ2olNW
P_o8ZH7oajV1olNXPOo6Z83oaJV0olBYP?o3Yh3o`jR1ol:XP?o5[7kob;9lolNbO_o5[Wgoa:inolRb
Ooo6[X7o`JF4olBXPoo7[H?o`j^0olN`O?o;/g_oajmlol>/OOo3[GcobK1mol^aOOo:/Gkof:^:onJW
U_oTYiKohjJFon:XU_oQZ9GohJNEon6XUOoPYiKohjFJon6QW?oIX9WodiJNomfGX_oOXIgofJ:KombT
V_oNZ9WogJJKom^YV?oIYYWofZ6Pono:T?o[dXgo`j6Wol^XYoo=ZjGoc:^Uol^YY_o9Y:Wo_iV`ol^V
Z002om:/YP09om2/YOo@[JGod:^VomB]YOoE[ZGoeZjUom>[Y_o@ZJOodj^V00;oeZfU00[oeZjVomJ_
Y_oCZjWoeJ^YomJ]YooCZJWodZRZomniXOobd8[ooMIi1OooeWH0FookegGoc^1_ojkXJ_ncif[o]nI[
okWVKOngiV_o]NIZokSVJonfiV_o]nI/okcVK_nhiV_oan=dooW;T_obdI3ofNe/ooOdGooVkVgofni/
onK]Joo[lVgoj^1[ooZ<HOooJ6?oogMSoomiI_ooM6OooV]NooN?FooWeF_ohO5conK/Koo/jFgojnY_
onSXK_oZjFcojnU[onGYL_oQiWGogNIdom[WMOoDiG[obn5kolKQNOo=g7kodmF2omKCOooFcGco_MB=
ojOOZ?nRik?oY^VkojGP/onNaIGoUlB@oiO6SonP_hcoZkV8ok>dOondZg;o]9QVokN<H_nfTFGo/hM/
ok=mKoncNf[o/7eUolJUEooH`e;oe;UAomBfCooC^57oe;MAom>gDOoC]e;oe;UBomBhD_oC]U7od[A@
om:fD?oB]E7odK=Bom>bE_oB/5Sod[5Hom6aF?oA[eSod:iGom6`Eoo@/5L00_o@/EP01_o@ZUSod:MF
ol;>H?nliF[o`>EYokoUJ@;o_^IY00Co_NIYokkVJOnniVWo_nIZ1?nniVX01OnoiVWo_^IYok[VLonm
iW_o`NIk00;o`nIk00?oa>Ikol?VNoo2iWT01_o2iWT01_o4iG[o`nIjojS[Mon[jGWo_nEjokkUNP;o
_NIk00Wo_^IlokgVOoniiWWo]^AQokSRG?ngheco]>ANok_VL_o3iWd00_o2iW/00oo1iW_o`>Ikol;V
N`04ol;VN`03ol7VNoo0iW_o`NIk00;o`^Ik00[o`>IjokkVNonkiW_o[NESoiKXEOmhlE[oTNaCojcU
COnXiTgojmY/ooooeWI1oooFMP00ooooeWH^oooFMP05oog<N?ok_G[onkijoo^oN_ok_gT00ook`7T0
0ooj`7Won[mioo[0N@02ooZnN@0;oo_0NOok_gWon;iioo;7NOobbgcolLQjoo?;N_ocbg_ollYkoo?9
NoocbG`00_ocbW/01?obag_omLiloo[NOoohgGl6ooSMP009ooWMP?oig7kon=amooCEOoo_[HOol7jJ
ooB0X_obSiWol9BF00;olI:G01col9:Foo2AUoo`UYColI:FooM]/?omF<;omG^Yoo2HU?o]W97ojYnA
onZTSoo[YHcojJF:onVVROo/YhcokJB>oo2LUoofRj[oo6S2oomOcoolL<congC:oo]eb_ojM<[onG?:
ooUdb_ojM<[ongG:0_okMLT0FOokMlOooGS6ooaia_onNlGoogg3ooml`_ooL/_onE_KooACg_ofDmko
m4oPoo=@h?ocC^3om53Poo9=h?obC^;ol4oSoo1Bh?o_Dmool5;Oonm>gOo[C=Ooj4SEonM4eOoYA=Oo
iT;Fon11dooK?=?of47=omA0b_oA?<[ocTG3om5I^OoFG;cogU7<onQBc_oaF/Col66loneR^_oYJ;?o
if^_onMZ[_o[J;?ogFJjol9U^_nkIkWo`6ZhokiW^?noI[Wo`FNjokiU^_njI[Ko^FRdok]Y]?nkJ[Co
^fVdokYX]?njJKCo^6>hokQQ^OniI[Go^VVeokaX]onmIkSo_66mokMEaonnB<oohe31onaU[OoSM;3o
fgJcomM_[_oFL:coeW:/omiT]ooWDLCoie33ommXZOoKN9_od92Boln/Poo;Zh7obJV1olVXP_o8Yh;o
aZF2olNUP_o7Y8;oajJ200;obZV10oo7Z8808_o8ZH3oajR1olJXPOo5ZH7oa:V1olBXP?o2Yh7o`:J2
ol2XP?o7/Ggob;=molVbOOo8/ggoa[1oolB[POo6[87oaZ^2ol:VQOo3Z8?oajmmolF^Noo8/7cob[=l
olR`O?o2ZWkoaJ]oolZaO_o;/7kofZZ=onRWUooUYiGohjFFon:VU_oPZ9D2on6XU@0Son:XU_oRY9[o
hJ6LombRVOoCV9gofYFSomnOW_oHWigog:BJomjWVOoLYi_ofjNKomNTVOoIX9kol/j=on[BSOo5XjOo
bZRWolf/YOo;ZZKobZVVolRSZ_o0VZoocZVWom>]YOoA[:Kocj^Vom2]YOo@ZjKoe:fUomF^YOoF[jCo
djfUom2XYooCZjH00_oE[JH02?oF[JOoeZnVomB]Yoo@YJ_odZNZomZbY?o]bi3onmEn2?ooeWH0C?of
f7Gob^9^ojoWK?nciV_o^>I[okOVJonfiV[o]nI[okSVK?nfiV_o^>I/ok_VKOnfiV[odm]iook6U_ol
`H_okMYDonGdIOoRk73ogNe/onW]Joo/lVgokn1Yoo^<GoooJVCoogIRoomjI_ooMVGoofiPooQmGoo]
^6GogNUconK`K_oYifooj>EaonWUKOo^ifSok>Q/onSWL?oZjFkojNU^onOZKooSkFooe^e_omC_KooE
kG;od^YdomSXL_oOi6[ocMicok3UR?nTjiSoZ>NToj;@SonJa83oUlR:oig5U_nPaISoW/BCoifoS?nX
]XSo]JF1okJLM?niWFoo]i5]okAnK?nbL6So^XAMom>hD?oI`E;oe;U@omFjD?oC]doodkA?omBdDOoC
]U42omBjDP09omBiD_oC^57odkEAom:^Doo@ZeGodJmFom6`F?oA/ESod[AH00;od[9H00_od[AHom:b
FOoA/UWod;AHom2^Eoo@YE?oalUSokGVI_nhifGo_>EWokkUJP02okcVJ00=okgVJ?nliVSo_>IYokgV
JOnniVWo_NIYokgVJ?nmiV[o_>IfokkVO?nliW[o_^Ikol;VNP02ol?VN`03ol?VNOo2iWWo`^Ii00;o
`^Ii00Oo`nIiol;VNOo3iGWoa>EiojG[M_nYjWSo_nEl00Co_^Il00co^nIlokgVOoniiG;o]^ANokSR
GOnghUgo]>ANokcVLoo3iWgo`^Ikol7VNoo0iW/5ol;VN`03ol7VNoo0iW_o`NIk00;o`^Ik00_o_NIj
ok_VO?njiW[oYnIQojGUF?n9jeKoNO9HoicYCOnTiTWoa^1LoogFM@3ooooFMT3oomIf003ooooFMRko
omIf00CoomAfooc5NOoj_G[onkmi0ook`7T4oo[0N@0CooZoNOok_gWonl1iooZoNOod`GOollmjoo?:
Noobag[ol/Ujoo?<N_occ7_ollYkoo;8NoobbGcollYkoo?8NooecG_on]enooSLO`03ooSMP00=ooSN
POoigH3onMaoooSLOOoff7oolKV4oo6;U_oeN:ColhbMoo2EUOoaTiKolI>Goo6CUP02oo2BUP0Noo2D
UOoaU9GomGNXooUS^?odQ:?okifAonfRSoo/XIGokJ6DonjTTOo_YhkokJR?onjSU?ocUZ3on8R`ooej
_oooI/Ooof?8ooagaoohN<Won7O8ooUgbOojM<WongG9ooehbOomN/KooWc2ooim`OooO[ooognn0_oo
P;`06?ooP;_oog^noomdaOomHm?old[Poo58h?obA^7oldWQooEAgoodD]kolToOoo9=h?o_Bn;okdcQ
oo5=goo_BMgojdCHonQ3eOoV@m;oid7FonLoe_oQ?];oeCg:olllaP;odSg603Koccc4om8maooKDLWo
gUk4on5FbOoQF/Goj6>koniW]?o[IKKojV>honMX/_oVJZooifRdon]X]_o^J;Coh6BholIT^onjIkWo
_6Riol1W^_nmIK[o^VJfokYZ]?nlJKGo^fRdokYX]?njJKKo^VVdokQX]OnhHkWo^VJfokYX]?nlIkSo
_F2nok]Ga_ngD<coa5C6omaQ[ooRKj;ogWF/omag]?oILZooe6n]omEeZOoMJ[CojU?6onY=b?oRG[?o
fgVJom6>U?o=ZHGobJZ1olNUP_o6YH82olNUPP03olVWP_o:Z87obZV000;obZ^104Oob:V2olJWP_o6
Yh;oajR2olNZP?o6ZH3oa:V1olJYPOo4ZH3o`JV1oknXP_o0ZH7oa:eoolNcOOo7]7goak=molRcOoo7
[h7oaZ^0olBZPOo5ZX;oaZ^3ol6VPoo4Zgkob[=kolJ_OOo8/7cob[5lolJ/P?o4ZH3oaJemol^^P?oN
ZHooj:NIonFXUOoSYIKohZJFon2WUOoQZ9GohJVFon>XU_oQXi[ohZ:LomfSV_oEWI_of9BRomnNW_oH
WIkofjJJomfXVOoLZ9[og:VLomNSW?oEVikolLj=onWASoo3XZWobZVVolf/YOo<ZjGoc:VVolFO[?o0
Vjood:ZVom>]YOoA[:KodJbUom2/Y_o@ZjKodjfUomB]Y@02omF^Y@04om2YZ?oBZZWoeJfWomF]YP;o
eZjU00God:NZomB[Z?oX`iOon=:3oooFM`0:oooFMP0WooSHMOo;hFoo[^QZok?VJ_nhiVco]nI[okGV
JonfiVco]^I[okGVJonjiVco^NI/ok[VK?oUfHOook^FooVRJOoRfU3ohO=[onC]K_oPkVcojne[onkb
Jooah6GonXYOoom/I?ooM67oogUUoomgIOooKUoooVaLoo6KI?oYeF[oiNm_on?ZL_oViFook>IZongW
JOoViVooj>I_00;oj>E^02kojnM_onOYKooSjFoognY`om[[L_o@kVkoe>mUonCaG_oMkeko^>m[ojO]
NonUjWGoXmmToioLI?nSfFooXm9foiOBMon@eGOoU<n2oj?0S_nZ]hgo[kJ;ok>dROn_Z8Co[9F6ojb6
QOo5YVCog<IEomVnE?oG^U7oek]?omFhC_oC]4oodK9>om>gDOoD^U7oe;]ComBnE?oD_EGoe;IGom>a
E_oB/eOodK9Fom6aE_oA]EOod[EH0_oB]EX03?oB]5WodJiFom6/E?oC/EGodk9Jolk2I_o0efoo^=mX
okOTIOnliVSo`NEZokkVJ@;o_NIX0_nmiVT01_noiV[o_^IYokoVJOnmiV_o_NIhokkVO0;o_^Ij00?o
_NIjokoVN_o0iWT00oo1iWT4ol;VN@04ol?UNOo4iGWoYNagojC[N0;o`>El0onniW`03?nkiW_o_NIm
okkVO_nfiFOo]^=KokOSG_nghUco]>AOokgVMOo4iWko`NIkol3VN`Go`^Ik013o`>Ikol3VN_o2iW_o
`^IkokoVN_njiW_o_>IlokWVN?nUiV3oXNEFoj?VFommkeKoPO1Eoj7WBon[iDkojmY]ooooeWI0oooF
MP00ooooeWH_oooFMP03ookAMook`GWon[ii00;onl1i00?onkmiooZoN_oj`7T00_oj`7T02ooj_WWo
nl1ioo_0NOof_WSol/YiooC>N_ocbg[ollQkoo;7N_obbg[ollaj00;oll]k00GollYkoo?9Noocb7co
llMkooOIOP03ooWMP00TooSNPOoigH3on]]mooSKOOoaaX;ol9:CooIgX_obPYoolY>Ioo2DUOo`TIOo
lI6Hoo:@V?obSiSolI2Hoo6@UooaT9KolXNNooAnZOo`Ti[okZF>onfVTOo]XYCokZBConjXS_o^ZHoo
lJ6IooFBZ?oiPKOooW?3oomaaOooJLOoofK2ooj6]?omR[WooWG70_onN<801?onML7oogVnoomj_Ooo
NKh2oomh_@04oomg_OooM[googBmoom``@;oof_400GoofG>ooU?gOoaA>3olTSPooA=gP02ooMAg@0V
ooA>gOo`C=ookd[Roo1:h?oaBMgokDGIonQ1eOoU@M;ojD;Cone1eOoX?mGofCc=olhma?o>?l;odcc7
om@lb?o??l;odTG4ommAc?oVI<[oi676omiQ^ooOI[KojV6hon]U/ooWIk;ojVBfonUV/ooWJ;;ojFRe
onQZ]ooYJKGokFZcon=V]_o:H[_o^fFkokQV^?njJ;D2ok]Z/`0SokYY]OnjIkKo^FNfokQY/onjJk?o
^FRfokIU]_nhI;Oo^efnokaHa_niElKo_5o1ol]U]_oKKJ;og7JLomAiY_oHN;7og7BcomQ]/?oFLZ[o
ffj`onQG`ooWD<GohUViomm^Y_oDSYCoc:F7olRYP_o5Y8;oajN2olVXPOo:Z83objV1olZYPOo:ZX40
0_o:Zh409?o9ZX;ob:R2olJWPoo7Yh;oaZR1olFZPOo6Zh7oa:V1olBZP?o5[Woo`Z^0okjVPOo2ZX7o
ak5oolNdOOo7/Wkoak1oolR_P?o9[h3ob:j1olFZPOo3Z8;oaZ^3olF/P_o1ZGkoaJemolVcO?o7[gco
ajeoolR]POo6Zgoo`jamolVZPOoOYI;oj:JIonBVUP;ohZBF02;ogjFFomjUUooQYiSohZNHon:RVooQ
XIcoh:BIomJNV_oDUJ3ogY^OomZMW_oJY9_ogjVHomfWVooMZYcofjJMomBJWoo`c8kojm6Aol>RZ_o<
ZJGocJbTolbZYOo;Z:Koa9j/ol:M[Oo@ZjKodjfUom:/YOo@[:GodJbVom6[Y_oC[:GodjfV0_oC[JL2
om6ZZ007omJ]YOoE[JKoeZfUoljTZ_oE[ZKom=::ookEN@0=oooFMP1UooOHMOo<hFoo[>Q[okCWKOnj
iFco]nI[okKVJ_nfiV_o]nI/okKVK?niiVgo]^IZol;ULoobe8kooj24ooNBC_oZiE[ojO=Won?]KOoT
kFcojNi[on_bK?oaffSonXUNoom[H_ooMF;oogQVoomfH?ooL5koof]QooV0H_o[]VCoina^on;]LooZ
j6golNQXonSWKooVig3oinM_onSVKooYifooiNM`on?WL?oWiW7ojNMcon?YKooIjVSof>]Uomk[H?oG
kEoo/o1YojO^M_n_jF[o[^AMoj_VG_n[iF3oX^MMoi_YF_nFjE[oWN9VoikLK_nMfWCoY=IfojW@M?nV
b7WoY;R9ojZmNonlfEkoaMQLol[>G_oAbEgod/UMom?4F?oE^e?od[==om:fC_oB^U7odkUBom>fE?oC
/UCodJmFom>bEooB/5Cod:YCom2]Doo?[ECocjeEom2/EOo=ZUCod;1Gom;0Hoo:c6WoaME/ol?HL?o2
eFooa]Aaol?EKonjh6So^nIWol3UJ_o0iFT01?nniVT01OnniV[o_^IYokkVKOnmiW[o_^Ik00;o_^Ij
01oo_^IkokgVN_nmiWSo`>Iiol;VNOo1iWWo`>Ijol7VNOo2iWWo`>IjolCUN_o4iG_oYNagojC[NOo1
iGco`>ElokkVO?noiWco_NImok[VNonmiW_o_nIook_VN?nfi63o^>9LokKSG_nghU_o]>EPokkVMoo4
iWko`NIk00Go`^Ik017o`NIkol3VN_o2iW_o`>Ijok_VN_nkiW_o_NImok[VN?nViV7oW^IFojOUGOnH
j5SoN_5Iohc]C_nUiT[ocMmNookFMP3ooooFMSooomIf003ooooFMS3oomIf00GooL]hooZnNOok_gWo
nl1iooZoN@03oo[0N@0DooZoNOoj_WWoo<1iooZmN?oca7Oollijoo?;N_ocbW[ollUjoo?9NoobbG_o
ll]joo?<NoocbW_om<]joo?:Noobb7colL=kooKDO_ojgGl2ooWMP00UooWLOooifggollmmooBXROoe
NIkomWbRoo:=UoobTIGolHnFoo:=V?oaSiSolhfIoo>;VOobSIWolI2Joo6?WOoaT9_ol9ZHonnQU_o_
X9KokiVIonnGV_o`WIGolYjFooBEW_ojPjoooGBooom[a_ooIlOoof[2oomWa?ooG<GoofZnoon2]?oo
NkSoog2moomd_@03oomb_@03oomb__ooLKooog2o00;oofo003Goofg1oom[`oooJlCoog30oomb`Oon
I=;omTcOoo=9goofCmgomU?LooA@gOoaC=gol4[Poo18hooaBMkokTKIonY1eooW@=CojD7Don]1e_o[
@]Coh43?olllaoo;?l7ocT72om91a?oD@lCod4blom5>_OoOE<Soi6O6onA]`OoRIKcogV6ion=N^oo[
HKOojf:fon]O^Oo/H[Soj6RdonUX]_o/J;SojfVgonUX]_oZJ[GokFVdonUU^?o?H[[o]FNfokE[/oni
JKGo]fVdokQY]@02okUY]@0JokY//_njJ;Go]f6jokEK__nfD/Oo^5;8okQQ__noK[Codg>/omi`XOoL
Kj?oe7FZomMg[ooNM;GoffbdomQ][ooJLJgohV2ion=D__oRE;goiEnfomV9V_o@Z8KobJZ2olVXPOo:
ZX03ol^ZP003ol^ZPOo9ZX7obZ^100;obJZ200Cob:V2olRWP_o6Yh;oajR10oo5ZX402oo4ZX7oa:j0
olF]P?o0YX7o`ZR1ol>/POo7/GkobK9molN`Ooo7[h3obJj000?ob:j003;oaJZ2ol>VQ?o4Zh7oaZml
ol>ZOOo7[gcobk=nolN^POo6[87ob:eoolN`OOo8ZX;ogZ:DonNVUooTZICohjJFon:TU_oQYiGohJRF
on:XV?oSYiSohZ>Jon:SVooQY9[of9nIom>FWooNVJ3ofibOomVRW?oMZ9WogJNKomfYVooLYigoeYbP
onc7T?o]dXooaZBWolbZYOo=[:GobjZUolZVYoo4WZcoaJ2/om6[Y_oC[JGodJ^Vom2/YOoA[JGod:ZX
om:[Y`?oe:fV00OodJZWom:ZYooE[:KoeZjUolbRZooD[JOomM28013oomIf00Son=QeolWRK_nYjF[o
/nM[ok[UJonfiV_o]NI[okSVK0;o]^I/05_o^NI/okKVJOo=hWOoml>;oon0J_oiXDgomNiKon_cIOoS
kFcoiNa/onS^JooXlVcokmeXooR:H?onJF3oogAQoomgIOooMF;oofiJoom]H?okM6;omIUMonCHK?oR
kg3okNeYon[VK_oXiVooinM_onOVKooWifooi^M`on7WL?oTig7oi^MbonSYK?oTjF?ohnUTon7[IOoL
k6;od^mQok3`L?nUjg3o[>1PojoNGOncgV;o[n1OojSRG?nSiU[o[>ANojgTGonXiekoYnIPojSSG_nZ
h63o[meTojkJI_n]gf7o/>1Pok;MH_nhffCo_MQVokkIHoo0f5ko`]9Molk9F_oG]57oe:9;omBRD?oD
Xe7odIi@omBSDOoDYE;odj=AomFVDOoCXU3odZ1@omB]E_oEbFWoa]MaokgLK_nlgFko_=U]okkIKOo0
f6ko`MM^ol7EKoo3eFoo^]mXok[VIoo0iF[o_nEZ00Go_^IY00?o_^I^okgVNonniW/00_nniWX02?nn
iW_o_^IjokgVN?nmiWSo`>Iiol7VN_o1iWWo`^Ii0_o0iWX01?o4iG[o`nEjoj;/MonTjgT2ol3UO00?
okkVO?noiWco_>Ilok[VNonniW_o_nIlokkVOonhiFoo]n=LokOSGOngheko]n9KokGUH_nmiWOo`nIn
00Go`^Ik017o`NIkol;VNoo2iW_o_>Ijok_VNonliW_o_^ImokWVN?nUiV3oWnIHojCUG?nWiEcoSNYH
ogWaE_nGjD_o]^ABonoIK`3ooooFMSooomIf0000\
\>"], "Graphics",
  Evaluatable->False,
  ImageSize->{1046, 161},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Proportional Hazards Modeling of Survival Data with \
Distribution-Free Methods\
\>", "Title"],

Cell["Harold Bishop", "Author"],

Cell["\<\
Process Modeling Solutions, Inc.
Falls Church, VA\
\>", "Affiliation"],

Cell[CellGroupData[{

Cell["Introduction", "Section"],

Cell["\<\
Purpose: Look at how much effect particular explanatory variables \
have on an item's survivability\
\>", "BulletedList"],

Cell["\<\
One way to look at this is through proportional hazards \
models\
\>", "BulletedList"],

Cell["\<\
This can be done in a  robust way without specifying a parametric \
failure model\
\>", "BulletedList"],

Cell[TextData[{
  "Survival data consists of {time, indicator, covariates}\n\nwhere indicator \
=",
  Cell[BoxData[
      FormBox[
        RowBox[{"\[Piecewise]", GridBox[{
              {"True", \(Event\ occurred\)},
              {
                "False", \(Event\ didn' 
                  t\ occur\ during\ the\ observation\ period\)}
              }]}], TraditionalForm]]]
}], "BulletedList"],

Cell[TextData[{
  "Time independent covariates, ",
  StyleBox["x",
    FontWeight->"Bold"],
  "=(",
  Cell[BoxData[
      \(TraditionalForm\`x\_1, \ x\_2, \  ... , \ x\_k\)]],
  ") are treated here"
}], "BulletedList"],

Cell[TextData[{
  StyleBox["In the Proportional Hazards model the basic assumption is ",
    FontFamily->"Times New Roman"],
  Cell[BoxData[
      \(TraditionalForm\`h(t; 
          x) = \(\(h\_0\)(t)\)\ \[ExponentialE]\^\(\(x\^T\) \[Beta]\)\)]],
  StyleBox["  where ",
    FontFamily->"Times New Roman"],
  Cell[BoxData[
      \(TraditionalForm\`\(h\_0\)(t)\)]],
  StyleBox[" is the baseline hazard function under ",
    FontFamily->"Times New Roman"],
  Cell[BoxData[
      \(TraditionalForm\`x = 0\)]],
  StyleBox[".  Here x is a vector of covariates contributing to the \
survivability of individual items.  Data types are defined to organize the \
items by covariates as well as risk sets for failure at specific times.  This \
data type facilitates the calculations involved in applying the statistical \
method and makes procedures clear with regard to what mathematics is being \
performed.  Model setup of variables includes automatic variable definitions, \
naming of coeficients (\[Beta]) and provides a data pattern for transforming \
and recoding the data to fit continuous and nominal scale layouts.  Three \
different data sets are used to demonstrate the versatility of this \
Mathematica approach.",
    FontFamily->"Times New Roman"]
}], "Text"],

Cell[TextData[StyleBox["By solving the partial likelihood function introduced \
by D.R. Cox (1972), discussed in Lawless (1982) and Andersen, Borgan, Gill \
and Keiding (1993), the \[Beta] coefficients can be solved with the usual \
maximization methods and the \[Beta] are treated as normally distributed \
under standard large sample assumptions.  This is done independently of a \
parametric model which can then be applied to the hazard function once the \
\[Beta] have been found.  Without the parametric assumption, the survivor \
function can still be estimated for both the baseline and consequently for \
any covariate vector x within the range of the model.  For the present \
application NMaximize was used after testing other approaches with \
FindMaximum and a direct Newton method.  NMaximize was fast and able to \
consistently reach a solution using Simulated Annealing for the data sets \
demonstrated.",
  FontFamily->"Times New Roman"]], "Text"],

Cell[TextData[StyleBox["Data analysis is conducted showing the power of \
Mathematica to get accurate results with few lines of code and produce \
textbook quality output with tables and graphs.  Testing the proportional \
hazards assumption, comparing independent variable effects through \
stratification and computing exact survival contributions with ties in the \
data are easily performed and visible.",
  FontFamily->"Times New Roman"]], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Model Setup Functions", "Section",
  InitializationCell->True],

Cell["Data drives the model", "BulletedList"],

Cell[TextData[{
  "Basic datatype: \tdata ",
  Cell[BoxData[
      \(TraditionalForm\`\( \[Rule] \&Transformations\)\)]],
  " {phDataPt}\n- keeps data organized:  Risk set are those items with \
opportunity to fail at a particular event time.\n- organizes the calculations\
\n- facilitates modifying the covariate structure"
}], "BulletedList"],

Cell[CellGroupData[{

Cell["Packages", "Subsubsection"],

Cell[BoxData[
    \(\(Off[General::spell, General::spell1];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(<< Personal`SurvPkg`;\)\), "\[IndentingNewLine]", 
    \(\(<< PMSI`FileInputDataDT`;\)\), "\[IndentingNewLine]", 
    \(\(<< Statistics`NormalDistribution`;\)\)}], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["PH Utility Functions", "Subsubsection",
  InitializationCell->True],

Cell[BoxData[{
    \(\(booleanQ[x_] := 
        MemberQ[{True, False, 0, 1}, x];\)\), "\[IndentingNewLine]", 
    \(\(booleanQ[_] := False;\)\), "\[IndentingNewLine]", 
    \(\(toBoole[boole_] := MemberQ[{True, 1}, boole];\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(UnsortedComplement[x_List, y__List] := 
        Replace[x, 
          Dispatch[\(\((# \[RuleDelayed] Sequence[])\) &\) /@ Union[y]], 
          1];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(numberForm[entry_?NumberQ] := 
        Which[Abs[entry] <  .001, "\<<.001\>", \[IndentingNewLine]True, 
          ToString[NumberForm[entry, {6, 3}]]];\)\), "\[IndentingNewLine]", 
    \(\(numberForm[entry : {_?NumberQ .. }] := 
        ToString[Map[numberForm, entry]];\)\), "\[IndentingNewLine]", 
    \(\(numberForm[s_] := s;\)\), "\[IndentingNewLine]", 
    \(\(SetAttributes[numberForm, Listable];\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(lastTimePt = {0, 0};\)\), "\[IndentingNewLine]", 
    \(\(addLastPt[spts : {{_?NumberQ, _?NumberQ} .. }, 
          lastPt : \({_?NumberQ, _?NumberQ} : lastTimePt\)] := 
        With[{diff = lastPt - Last[spts]}, 
          If[First[diff] > 0, 
            Append[spts, 
              lastPt - {0, diff\[LeftDoubleBracket]2\[RightDoubleBracket]}], 
            spts]];\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(reset[y_, at_List] := 
        With[{x = Union[at]}, Clear[y]; 
          Table[y[x\[LeftDoubleBracket]i\[RightDoubleBracket]] = 0`30, {i, 
              Length[x]}]; {}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(\(errmsg[n1_, n2_] := 
        Print["\<Lists of unequal lengths \>", n1, "\< and \>", n2];\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(discreteF[head_, x_List, 
          y_List] := \[IndentingNewLine]Module[{nx = Length[x], 
            ny = Length[y]}, \[IndentingNewLine]Catch[\[IndentingNewLine]If[
              nx \[NotEqual] ny, 
              Throw[errmsg[nx, ny]], \[IndentingNewLine]Table[
                head[x\[LeftDoubleBracket]i\[RightDoubleBracket]] = 
                  y\[LeftDoubleBracket]i\[RightDoubleBracket], {i, 
                  nx}]]]; {}];\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(partAt[wordList_List, searchWord_String] := 
      Position[Map[nameContains[#, searchWord] &, wordList], True]\)], "Input",\

  InitializationCell->True],

Cell[BoxData[{
    \(\(gradient[f_, vars_List] := 
        Map[D[f, #] &, vars];\)\), "\[IndentingNewLine]", 
    \(\(hessian[f_, vars_List] := 
        Outer[D, gradient[f, vars], vars];\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(Options[showTable] = {RowAlignments \[Rule] {Center}, 
          ColumnAlignments \[Rule] {Center}, RowSpacings \[Rule] {3}, 
          ColumnSpacings \[Rule] {2}, RowLines \[Rule] True};\)\), "\n", 
    \(\(showTable[title_String, sked_List, notes_List: {}, opts___?OptionQ] := 
        Module[{rowAlignments, columnAlignments, rowSpacings, columnSpacings, 
            rowLines}, \[IndentingNewLine]{rowAlignments, columnAlignments, 
              rowSpacings, columnSpacings, 
              rowLines} = \({RowAlignments, ColumnAlignments, RowSpacings, 
                  ColumnSpacings, RowLines} /. {opts}\) /. 
              Options[showTable]; 
          DisplayForm[
            GridBox[{\[IndentingNewLine]{StyleBox[title, FontSize \[Rule] 12, 
                    FontWeight \[Rule] "\<Bold\>"]}, {"\<\>"}, \
\[IndentingNewLine]{StyleBox[
                    GridBox[sked, RowAlignments \[Rule] rowAlignments, 
                      ColumnAlignments \[Rule] columnAlignments, 
                      RowSpacings \[Rule] rowSpacings, 
                      ColumnSpacings \[Rule] columnSpacings, 
                      RowLines \[Rule] rowLines], FontSize \[Rule] 12, 
                    FontFamily \[Rule] "\<Bell MT\>"]}, \
\[IndentingNewLine]{StyleBox[
                    StringJoin[
                      Insert[notes, "\<\n\>", 
                        Table[{i}, {i, Length[notes]}]]], 
                    FontSize \[Rule] 12, 
                    FontFamily \[Rule] "\<Bell MT\>"]}\[IndentingNewLine]}, 
              ColumnAlignments \[Rule] Left]]];\)\)}], "Input",
  ShowCellBracket->True,
  ShowSelection->True,
  ShowClosedCellArea->False,
  InitializationCell->True],

Cell[BoxData[
    \(\(setshowTableOpts[c_Integer] := 
        Module[{fillData}, \[IndentingNewLine]fillData[x_] := 
            Table[x, {c}]; \[IndentingNewLine]SetOptions[showTable, 
            RowAlignments \[Rule] fillData[Center], 
            ColumnAlignments \[Rule] fillData[Center], 
            RowSpacings \[Rule] fillData[3], 
            ColumnSpacings \[Rule] 
              fillData[
                2]]; \[IndentingNewLine]fillData["\< \>"]];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Define Proportional Hazards data type: phDataPt ( time,  indicator, \
 riskSet,  covariates). \
\>", "Subsection",
  InitializationCell->True],

Cell[TextData[StyleBox["The data type phDataPt keeps track of which risk sets \
a particular data point belongs in.  The indicator part of phDataPt informs \
whether the data point was an observed event or was censored.  The operation \
\[Beta].z_phDataPt results in \[Beta].x for the covariates contained in the \
data point z.",
  FontWeight->"Bold"]], "Text"],

Cell[TextData[{
  StyleBox["Distinct failure times ",
    FontWeight->"Bold"],
  Cell[BoxData[
      \(TraditionalForm\`t\_\((i)\)\)],
    FontWeight->"Bold"],
  StyleBox[" are ordered such that ",
    FontWeight->"Bold"],
  Cell[BoxData[
      \(TraditionalForm\`\[Tau][t\_\((i)\)] = i\)],
    FontWeight->"Bold"],
  StyleBox[" for ",
    FontWeight->"Bold"],
  Cell[BoxData[
      \(TraditionalForm\`i = 1, 2,  ... , k\)],
    FontWeight->"Bold"],
  StyleBox[" .",
    FontWeight->"Bold"]
}], "Text"],

Cell[CellGroupData[{

Cell["Constructor and Selectors", "Subsubsection",
  InitializationCell->True],

Cell[TextData[{
  "data for an individual:  {time, \[Delta] indicator, covariates = {",
  Cell[BoxData[
      \(TraditionalForm\`x\_1,  ... \ , x\_k\)]],
  "}}"
}], "Text",
  InitializationCell->True],

Cell[BoxData[
    \(\(make\[Ellipsis]phDataPt[{time_?NumberQ, indicator_?booleanQ, 
            riskSet_List, covariates_List}] := 
        phDataPt[time, toBoole[indicator], riskSet, 
          Flatten[covariates]];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(phDataPt /: 
        timef[phDataPt[time_, indicator_, riskSet_, covariates_]] := 
        time;\)\), "\[IndentingNewLine]", 
    \(\(phDataPt /: 
        indicatorf[phDataPt[time_, indicator_, riskSet_, covariates_]] := 
        indicator;\)\), "\[IndentingNewLine]", 
    \(\(phDataPt /: 
        riskSetf[phDataPt[time_, indicator_, riskSet_, covariates_]] := 
        riskSet;\)\), "\[IndentingNewLine]", 
    \(\(phDataPt /: 
        covariatesf[phDataPt[time_, indicator_, riskSet_, covariates_]] := 
        covariates;\)\)}], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Operations", "Subsubsection",
  InitializationCell->True],

Cell[BoxData[{
    \(\(phDataPt /: \((\[Beta]vector_)\) . \((dataPt_phDataPt)\) := \
\[Beta]vector . covariatesf[dataPt];\)\n\), "\[IndentingNewLine]", 
    \(\(phDataPt /: exp[\[Beta]vector_, dataPt_phDataPt] := 
        Exp[\[Beta]vector . 
            covariatesf[
              dataPt]];\)\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(\(phDataPt /: addRiskSet[x_phDataPt, times_List] := 
        With[{eventT = timef[x]}, 
          make\[Ellipsis]phDataPt[{eventT, indicatorf[x], 
              Union[riskSetf[x], Cases[times, t_ /; t \[LessEqual] eventT]], 
              covariatesf[x]}]];\)\n\), "\[IndentingNewLine]", 
    \(\(phDataPt /: deleteCovariates[x_phDataPt, positions_List] := 
        make\[Ellipsis]phDataPt[{timef[x], indicatorf[x], riskSetf[x], 
            Delete[covariatesf[x], 
              positions]}];\)\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(\(phDataPt /: exchangeCovariates[x_phDataPt, newXi_List] := 
        make\[Ellipsis]phDataPt[{timef[x], indicatorf[x], riskSetf[x], 
            newXi}];\)\)}], "Input",
  InitializationCell->True],

Cell["\<\
Note that positions must be 2 levels deep to work with the Delete \
function in deleteCovariates.  Use the partAt function to provide such a list \
of positions.\
\>", "Text",
  InitializationCell->True],

Cell[BoxData[
    \(\(time\[Delta]f = 
        x_phDataPt \[RuleDelayed] {timef[x], 
            Boole[indicatorf[x]]};\)\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Format data input as Proportional Hazards Layout", "Subsubsection",
  InitializationCell->True],

Cell[BoxData[
    \(\(interactionSeparator = 
        Characters["\<,-\[EmptyVerySmallSquare]+*\>"];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(makeVariable[name_String] := 
        With[{s = name}, Clear[s]; Symbol[s]];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(setupPHlayout::usage = \
"\<setupPHlayout[colNames_List,timeName_String,\[Delta]Name_String,xNames_\
List] takes the titleLine from a file read in with FileInputDataDT to \
describe the set of all column Names,and separately identiying the column \
names for the time variable and the censor (\[Delta]) variable and a list of \
the covariate column names.  The covariate names define the model in that \
main effects and interaction effects can be described by the xNames list.  \
For example {\[Alpha]_String,\[Beta]_String,\[Alpha]*\[Beta]_String} where \
\[Alpha],\[Beta] and \[Alpha]*\[Beta] are the column names from the titleLine \
identifying the variables.\nNote: Interaction name separator can be any of \
the following {comma,dash,plus,asterisk,or \[EmptyVerySmallSquare]}. Option \
is CenteredDataList which is a list of variable names that are to have an \
offset applied and TransformedDataList which provides a function \
transformation to the data element.\>";\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Options[setupPHlayout] = {CenteredDataList \[Rule] {}, 
          TransformedDataList \[Rule] {}};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(setupPHlayout[colNames_List, timeName_String, \[Delta]Name_String, 
          xNames_List, 
          opts___?OptionQ] := \[IndentingNewLine]Module[{time\[Delta]Layout, 
            interactions, mainVariableLayout, interactionList, 
            interactionLayout, covariateLayout, neweLayout, \[Beta]Layout, 
            centeredDataList, transformedDataList, s\[CapitalDelta]rules, 
            fxrules}, \[IndentingNewLine]Clear[e, 
            fx, \[Beta]]; \[IndentingNewLine]{centeredDataList, 
              transformedDataList} = \({CenteredDataList, 
                  TransformedDataList} /. {opts}\) /. 
              Options[setupPHlayout]; \
\[IndentingNewLine]s\[CapitalDelta]rules = 
            Map[# \[Rule] "\<\[CapitalDelta]\>" <> # &, 
              centeredDataList]; \[IndentingNewLine]fxrules = 
            Map[# \[Rule] "\<fx\>" <> # &, 
              transformedDataList]; \
\[IndentingNewLine]\[IndentingNewLine]labelPositions[title_List, names_List] := 
            With[\[IndentingNewLine]{positions = 
                  DeleteCases[\[IndentingNewLine]Map[
                      Flatten[{\[IndentingNewLine]Position[
                              title, #], \[IndentingNewLine]Which[
                              MemberQ[
                                centeredDataList, #], "\<centered\>", \
\[IndentingNewLine]MemberQ[
                                transformedDataList, #], "\<transformed\>", \
\[IndentingNewLine]True, "\<none\>"]\[IndentingNewLine]}] &, 
                      names], \[IndentingNewLine]y_ /; 
                      Length[y] < 
                        2]}, \[IndentingNewLine]Map[\[IndentingNewLine]Switch[\
#\[LeftDoubleBracket]2\[RightDoubleBracket], \
\[IndentingNewLine]"\<centered\>", \[IndentingNewLine]makeVariable["\<e\>" <> 
                          ToString[#\[LeftDoubleBracket]1\[RightDoubleBracket]\
]] - makeVariable["\<offset\>" <> 
                          ToString[#\[LeftDoubleBracket]1\[RightDoubleBracket]\
]], \[IndentingNewLine]"\<transformed\>", \[IndentingNewLine]\(makeVariable["\
\<fx\>" <> ToString[#\[LeftDoubleBracket]1\[RightDoubleBracket]]]\)[
                      makeVariable["\<e\>" <> 
                          ToString[#\[LeftDoubleBracket]1\[RightDoubleBracket]\
]]], \[IndentingNewLine]"\<none\>", \[IndentingNewLine]makeVariable["\<e\>" <> 
                        ToString[#\[LeftDoubleBracket]1\[RightDoubleBracket]]]\
] &, positions]]; \[IndentingNewLine]\[IndentingNewLine]time\[Delta]Layout = 
            labelPositions[
              colNames, {timeName, \[Delta]Name}]; \[IndentingNewLine]\
\[IndentingNewLine]interactionLayout = 
            Catch[\[IndentingNewLine]interactions = 
                Flatten[
                  StringCases[
                    xNames, __ ~~ \(interactionSeparator ~~ __\)]]; \
\[IndentingNewLine]If[isEmpty[interactions], 
                Throw[{}], \[IndentingNewLine]\((interactionList = 
                    Map[StringSplit[#, interactionSeparator] &, 
                      interactions]; \[IndentingNewLine]Map[
                    Apply[Times, labelPositions[colNames, #]] &, 
                    interactionList])\)]]; \[IndentingNewLine]\
\[IndentingNewLine]mainVariableLayout = 
            labelPositions[colNames, 
              UnsortedComplement[xNames, 
                interactions]]; \
\[IndentingNewLine]\[IndentingNewLine]covariateLayout = 
            Join[mainVariableLayout, 
              interactionLayout]; \[IndentingNewLine]neweLayout = 
            Join[time\[Delta]Layout, {{}}, {covariateLayout}]; \
\[IndentingNewLine]\[Beta]Layout = {Map[
                makeVariable["\<\[Beta]\>" <> ToString[#]] &, 
                Range[Length[xNames]]], 
              StringReplace[xNames, 
                Join[s\[CapitalDelta]rules, 
                  fxrules]]}; \[IndentingNewLine]{neweLayout, \
\[Beta]Layout}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(replace\[Beta]nameList[oldNames_List, new\[Beta]Names_List] := 
        Flatten[Replace[\[Beta]nameList, 
            MapThread[#1 \[RuleDelayed] #2 &, {oldNames, new\[Beta]Names}], 
            1]];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Solution of PH Baseline Survival and Cumulative Hazard \
Functions\
\>", "Subsection"],

Cell["\<\
Partial Likelihood Function solved with NMaximize using Simulated \
Annealing Option\
\>", "BulletedList"],

Cell[TextData[{
  "The problem to solve is finding \[Beta] such that the partial likelihood \
is maximized.  The partial likelihood for the proportional hazard model is \
defined as \n\t",
  Cell[BoxData[
      \(TraditionalForm\`L(\[Beta]) = \[Product]\+\(i = 1\)\%r \
\[ExponentialE]\^\(\(x\_i\^T\) \[Beta]\)\/\(\[Sum]\+\(l \[Element] R\_i\)\
\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\)\)\)]],
  "  where ",
  Cell[BoxData[
      \(TraditionalForm\`R\_i\)]],
  " is the risk set at time ",
  Cell[BoxData[
      \(TraditionalForm\`t\_\((i)\)\)]],
  ".  The coefficients of \[Beta] are solved for by maximizing ",
  Cell[BoxData[
      \(TraditionalForm\`L(\[Beta])\)]],
  " or equivalently ",
  Cell[BoxData[
      \(TraditionalForm\`log\ \(L(\[Beta])\)\)]],
  " yielding ",
  Cell[BoxData[
      \(TraditionalForm\`\[Beta]\&^\)]],
  ". \n\t",
  Cell[BoxData[
      \(TraditionalForm\`log\ \(L(\[Beta])\) = \[Sum]\+\(i = \
1\)\%r\((\(x\_\((i)\)\^T\) \[Beta] - 
              log(\[Sum]\+\(l \[Element] R\_i\)\[Lambda]\_l))\)\)]],
  "    where ",
  Cell[BoxData[
      \(TraditionalForm\`\[Lambda]\_l = \[ExponentialE]\^\(\(x\_l\^T\) \
\[Beta]\)\)]],
  ".\n\tUnder standard large sample assumptions ",
  Cell[BoxData[
      \(TraditionalForm\`\[Beta]\&^~\ 
          N\ \((\[Beta], \ \[CapitalLambda])\)\)]],
  ", a multivariate normal with mean vector \[Beta], and variance covariance \
matrix \[CapitalLambda] which is approximated by the inverse of the Fisher \
Information matrix.\n\tIf the eigenvalues of the hessian matrix given by  ",
  Cell[BoxData[
      \(TraditionalForm\`\((\(\[PartialD]\_\(\(\[Beta]\_i\) \
\[Beta]\_j\)\((log\ \(L(\[Beta])\))\)\)\(|\))\)\_\(\[Beta] = \
\[Beta]\&^\)\)]],
  " are all negative then the solution occurs at a maximum of ",
  Cell[BoxData[
      \(TraditionalForm\`L\)]],
  ".  The values of the coefficents of ",
  Cell[BoxData[
      \(TraditionalForm\`\[Beta]\&^\)]],
  " can then be used to empirically derive a baseline survivor function and a \
baseline cumulative hazard function ",
  Cell[BoxData[
      \(TraditionalForm\`H\_0\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`\(H\_0\)(t) = \(-\(log(\(S\_0\)(t))\)\)\)]],
  ".  "
}], "Text"],

Cell[TextData[{
  " NMaximize is used to find the maximum of ",
  Cell[BoxData[
      \(TraditionalForm\`log\ \(L(\[Beta])\)\)]],
  " and the \"Simulated Annealing\" method provides the most consistent \
ability to find a solution under various data sets.  This is also true when \
specifying AccuracyGoals ranging from 4 to 10. \nA version of the \
Broyden-Fletcher-Goldfarb-Shanno (BFGS) algorithm as discussed in Rose, C. \
and Smith, M.D., (2002) and implemented in mathStatica 1.5 was used to \
maximize the likelihood under the several datasets. A FixedPointList function \
was implemented using Armijo's method as described therein.  The maximum was \
not always found.\nNMaximize with a Newton-Raphson method option was also \
tried with poor convergence results, i.e. inability to find a solution.\nAs a \
test of the quality of the solution SetAccuracy was set at 20 for all \
calculations starting with ",
  Cell[BoxData[
      \(TraditionalForm\`\(x\^T\) \[Beta]\)]],
  " and the ",
  Cell[BoxData[
      \(TraditionalForm\`\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\)\)]],
  " calculation and an AccuracyGoal of 10 set in NMaximize. Results were not \
very different from using the 16 digit working precision and AccuracyGoal\
\[Rule]4, but slower. Values of the gradient of L at the solution point were \
on the order of ",
  Cell[BoxData[
      \(TraditionalForm\`10\^\(-10\)\)]],
  " to ",
  Cell[BoxData[
      \(TraditionalForm\`10\^\(-11\)\)]],
  "."
}], "Text"],

Cell["\<\
Ties in data solved with FindRoot using Non-derivative option\
\>", \
"BulletedList"],

Cell[TextData[{
  "The baseline survivor function is found in the following way as shown in \
",
  StyleBox["Lawless, J.F. (1982).  ",
    FontFamily->"Times New Roman"],
  StyleBox["Statistical Models and Methods for Lifetime Data, page 361",
    FontFamily->"Times New Roman",
    FontSlant->"Italic"],
  StyleBox[".  ",
    FontFamily->"Times New Roman"],
  "\n\t",
  Cell[BoxData[
      \(TraditionalForm\`L\_1 = \[Product]\+\(i = 1\)\%k\((\[Product]\+\(l \
\[Element] D\_i\)\((1 - \[Alpha]\_i\^\(\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\
\)\))\) \(\[Product]\+\(l \[Element] R\_i - D\_i\)\[Alpha]\_i\^\(\
\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\)\)\))\)\)]],
  "   where ",
  Cell[BoxData[
      \(TraditionalForm\`\[Alpha]\_i = \(\(S\_0\)(t\_\((i)\) + 0)\)\/\(\(S\_0\
\)(t\_\((i - 1)\) + 0)\)\)]],
  " \nwhere ",
  Cell[BoxData[
      \(TraditionalForm\`\(\[Alpha]\&^\)\_i\)]],
  " is found that maximizes ",
  Cell[BoxData[
      \(TraditionalForm\`L\_1\)]],
  " when ",
  Cell[BoxData[
      \(TraditionalForm\`\[Beta] = \(\[Beta]\&^\)\)]],
  ", which is a solution of\n\t",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+\(l \[Element] \
D\_i\)\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\)\/\(1 - \[Alpha]\_i\^\(\
\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\)\)\) = \[Sum]\+\(l \[Element] R\_i\)\
\[ExponentialE]\^\(\(x\_l\^T\) \[Beta]\)\)]],
  "  \t\twhich is easily solved for ",
  Cell[BoxData[
      \(TraditionalForm\`\[Alpha]\_i\)]],
  " when there are no ties in the data of failures, but must be numerically \
solved when ties are present.  FindRoot is used for this solution when ties \
are present with 0.1 and 0.999999 as the first two starting values of a \
non-derivative finding method.  FindRoot often fails to converge when using \
Newton's method."
}], "Text"],

Cell[BoxData[
    RowBox[{"\t\t", 
      RowBox[{
        FormBox[\(\(S\&^\_0\)(
              t) = \[Product]\+\(i : t\_\((i)\) < t\)\[Alpha]\&^\_i\),
          "TraditionalForm"], "."}]}]], "Text"],

Cell[CellGroupData[{

Cell["\<\
boxedPH procedure given a set of phDataPts and a list of \[Beta] \
coefficient variables\
\>", "Subsubsection"],

Cell[BoxData[
    \(\(boxedPH[dataset : {_phDataPt .. }, \[Beta]_List] := 
        Module[{eventT, failedT, lenFailedTimes, \[Tau], \[Lambda], 
            observations, riskData, indtoAtRisk, obslog\[Beta], 
            obslog\[Beta]0, \[Beta]trial, zero\[Beta]trial, 
            maxLogL\[Beta], \[Beta]hat, grad\[Beta], score, hessian\[Beta], 
            infoMatrix, eigenvaluesHessian, variances, stdErr, find\[Alpha], 
            findTied\[Alpha], \[Alpha]lpha, lastTimePt, addLastPt, 
            sBaselinePts, 
            logHBaselinePts}, \[IndentingNewLine]\[IndentingNewLine]eventT = 
            Union[Append[
                dataset /. {\((x_phDataPt /; indicatorf[x])\) \[RuleDelayed] 
                      timef[x], \((_phDataPt \[RuleDelayed] 0)\)}, 
                0]]; \[IndentingNewLine]failedT = 
            Rest[eventT]; \[IndentingNewLine]lenFailedTimes = 
            Length[failedT]; \[IndentingNewLine]Table[\[Tau][
                failedT\[LeftDoubleBracket]i\[RightDoubleBracket]] = i, {i, 
              lenFailedTimes}]; \[IndentingNewLine]\[Lambda] = 
            Table[0, {i, lenFailedTimes}]; \[IndentingNewLine]observations = 
            Table[{}, {i, lenFailedTimes}]; \[IndentingNewLine]riskData = 
            Map[addRiskSet[#, failedT] &, 
              dataset]; \[IndentingNewLine]countEX\[Beta][\[Beta]in_, 
              z_phDataPt] := 
            With[{ind\[Lambda] = exp[\[Beta]in, z]}, 
              Map[\[Lambda]\[LeftDoubleBracket]\[Tau][#]\[RightDoubleBracket] \
+= ind\[Lambda] &, riskSetf[z]]; \[IndentingNewLine]If[indicatorf[z], 
                AppendTo[
                  observations\[LeftDoubleBracket]\[Tau][
                      timef[z]]\[RightDoubleBracket], \[Beta]in . 
                    z], {}]]; \[IndentingNewLine]\[IndentingNewLine]Map[
            countEX\[Beta][\[Beta], #] &, 
            riskData]; \[IndentingNewLine]\[IndentingNewLine]indtoAtRisk = 
            MapThread[#1 - 
                  Log[#2] &, {observations, \[Lambda]}]; \
\[IndentingNewLine]obslogL\[Beta] = 
            Total[Flatten[
                indtoAtRisk]]; \
\[IndentingNewLine]\[IndentingNewLine]\[Beta]trial = 
            DeleteCases[\[Beta], 
              y_ /; y \[Equal] 0]; \[IndentingNewLine]zero\[Beta]trial = 
            Map[# \[Rule] 
                  0 &, \[Beta]trial]; \[IndentingNewLine]obslogL\[Beta]0 = 
            N[obslogL\[Beta] /. 
                zero\[Beta]trial]; \[IndentingNewLine]{maxLogL\[Beta], \
\[Beta]hat} = 
            NMaximize[obslogL\[Beta], \[Beta]trial, 
              Method \[Rule] "\<SimulatedAnnealing\>", 
              AccuracyGoal \[Rule] 4]; \[IndentingNewLine]solutionSet = 
            Map[{#, # /. \[Beta]hat} &, \[Beta]]; \[IndentingNewLine]\
\[IndentingNewLine]grad\[Beta] = 
            gradient[
              obslogL\[Beta], \[Beta]trial]; \[IndentingNewLine]score = 
            grad\[Beta] /. \[Beta]hat; \[IndentingNewLine]hessian\[Beta] = 
            hessian[obslogL\[Beta], \[Beta]trial]; \
\[IndentingNewLine]infoMatrix = 
            hessian\[Beta] /. \[Beta]hat; \
\[IndentingNewLine]eigenvaluesHessian = 
            Eigenvalues[infoMatrix]; \[IndentingNewLine]Which[
            Apply[And, 
              eigenvaluesHessian /. 
                x_?Negative \[Rule] 
                  True], \[IndentingNewLine]Print["\<All Eigenvalues of the \
infoMatrix are negative => solution is a MAXIMUM\>"], \
\[IndentingNewLine]Apply[And, 
              eigenvaluesHessian /. 
                x_?Positive \[Rule] 
                  True], \[IndentingNewLine]Print["\<All Eigenvalues of the \
infoMatrix are positive => solution is a MINIMUM\>"], \[IndentingNewLine]_, 
            Print["\<solution is neither a Maximum nor a Minimum\>"]]; \
\[IndentingNewLine]variances = \(-Inverse[
                infoMatrix]\); \[IndentingNewLine]stdErr = \@Tr[variances, \
List]; \[IndentingNewLine]\[IndentingNewLine]find\[Alpha][ei_, 
              ri_] := \((1 - ei/ri)\)\^\(1/ei\); \[IndentingNewLine]findTied\
\[Alpha][eobs_List, ri_] := 
            Block[{\[Alpha]}, \[Alpha] /. 
                FindRoot[
                  Total[Map[#/\((1 - \[Alpha]\^#)\) &, eobs]] - 
                    ri, {\[Alpha],  .1,  .999999}]]; \[IndentingNewLine]\
\[Alpha]lpha = 
            Flatten[MapThread[
                If[Length[#1] > 1, findTied\[Alpha][\[ExponentialE]\^#1, #2], 
                    find\[Alpha][\[ExponentialE]\^#1, #2]] &, {observations /. \
\[Beta]hat, \[Lambda] /. \[Beta]hat}]]; \[IndentingNewLine]\[Alpha]lpha = 
            Map[Max[Abs[#], 
                  0.000001] &, \[Alpha]lpha]; \[IndentingNewLine]\
\[IndentingNewLine]Print[\*"\"\<Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) \
\>\"", maxLogL\[Beta], "\<    ObsLog\[Beta] at \[Beta]=0 \>", 
            obslogL\[Beta]0]; \
\[IndentingNewLine]Print[\*"\"\<\!\(\[Beta]\&^\) \>\"", \[Beta] /. \
\[Beta]hat]; \[IndentingNewLine]Print["\<Gradient vector \>", 
            score]; \[IndentingNewLine]Print[\*"\"\<\!\(\[Beta]\&^\) Variance \
Covariance matrix \>\"", 
            variances]; \[IndentingNewLine]Print[\*"\"\<\!\(\[Beta]\&^\) \
Standard Error vector \>\"", 
            stdErr]; \[IndentingNewLine]Print["\<\[Alpha] \>", \[Alpha]lpha]; \
\[IndentingNewLine]\[IndentingNewLine]lastTimePt = {Max[Map[timef, dataset]], 
              0}; \[IndentingNewLine]addLastPt[
              spts : {{_?NumberQ, _?NumberQ} .. }, 
              lastPt : \({_?NumberQ, _?NumberQ} : lastTimePt\)] := 
            With[{diff = lastPt - Last[spts]}, 
              If[First[diff] > 0, 
                Append[spts, 
                  lastPt - {0, 
                      diff\[LeftDoubleBracket]2\[RightDoubleBracket]}], 
                spts]]; \[IndentingNewLine]sBaselinePts = 
            addLastPt[
              Transpose[{eventT, 
                  FoldList[Times, 
                    1, \[Alpha]lpha]}]]; \[IndentingNewLine]logHBaselinePts = 
            Rest[sBaselinePts] /. {t_, s0_} \[RuleDelayed] {t, 
                  Re[Log[\(-Log[
                          s0]\)]]}; \[IndentingNewLine]logHBaselinePts = 
            DeleteCases[logHBaselinePts, 
              y_ /; Not[
                  NumericQ[
                    y\[LeftDoubleBracket]2\[RightDoubleBracket]]]]; \
\[IndentingNewLine]{{obslogL\[Beta]0, 
              maxLogL\[Beta], \[Beta]hat}, {variances, 
              stdErr}, {sBaselinePts, logHBaselinePts}}];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["HIV-AIDS Data set", "Section"],

Cell[TextData[{
  StyleBox["The first problem demonstrated is an HIV-AIDS data set discussed \
in Hosmer, D.W. jr, Lemeshow, S. (1999). ",
    FontFamily->"Times New Roman"],
  StyleBox["Applied Survival Analysis: Regression Modeling of Time to Event \
Data",
    FontFamily->"Times New Roman",
    FontSlant->"Italic"],
  StyleBox[", John Wiley & Sons, Inc. New York. and available at ",
    FontFamily->"Times New Roman"],
  StyleBox["ftp://ftp.wiley.com/public/sci_tech_med/survival",
    FontFamily->"Times New Roman",
    FontColor->RGBColor[0, 0, 0.996109],
    FontVariations->{"Underline"->True}],
  StyleBox[". ",
    FontFamily->"Times New Roman"]
}], "Text"],

Cell["Demonstrates", "Text"],

Cell["Shows basic model variables and constructing a phDataPt set", \
"BulletedList"],

Cell["Setting up an interaction in the regressor variable set", "BulletedList"],

Cell["\<\
Constructing baseline survivor function and comparison of survivor \
functions with different covariates\
\>", "BulletedList"],

Cell[CellGroupData[{

Cell["Read in Data, and Select Model", "Subsection"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[BoxData[
    \(\(filePath = "\</File Organizer/OR Tools/Proportional Hazards \
testing/hmohiv Hosmer&Lemeshow.txt\>";\)\)], "Input",
  CellOpen->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({titleLine, pattVars, dataFile, fnAbbr, rowForm, vars} = 
        readDataFile[filePath, abbr \[Rule] "\<hiv\>"];\)\)], "Input",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    \({"EnterDate", "EndDate", "Time", "Age", "Drug", "Censor"}\)], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("hiv\[EmptyVerySmallSquare]rowForm \
="\[InvisibleSpace]{"date", "date", "number", "number", "number", "number"}\),
      
      SequenceForm[ 
      "hiv\[EmptyVerySmallSquare]rowForm =", {"date", "date", "number", 
        "number", "number", "number"}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("hiv\[EmptyVerySmallSquare]patt \
="\[InvisibleSpace]{e1_?Date\[EmptyVerySmallSquare]TimeQ, 
          e2_?Date\[EmptyVerySmallSquare]TimeQ, e3_?NumberQ, e4_?NumberQ, 
          e5_?NumberQ, e6_?NumberQ}\),
      SequenceForm[ "hiv\[EmptyVerySmallSquare]patt =", {
        PatternTest[ 
          Pattern[ e1, 
            Blank[ ]], Date\[EmptyVerySmallSquare]TimeQ], 
        PatternTest[ 
          Pattern[ e2, 
            Blank[ ]], Date\[EmptyVerySmallSquare]TimeQ], 
        PatternTest[ 
          Pattern[ e3, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e4, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e5, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e6, 
            Blank[ ]], NumberQ]}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("hiv\[EmptyVerySmallSquare]vars \
="\[InvisibleSpace]{"hiv\[EmptyVerySmallSquare]EnterDate", 
          "hiv\[EmptyVerySmallSquare]EndDate", 
          "hiv\[EmptyVerySmallSquare]Time", "hiv\[EmptyVerySmallSquare]Age", 
          "hiv\[EmptyVerySmallSquare]Drug", 
          "hiv\[EmptyVerySmallSquare]Censor"}\),
      SequenceForm[ 
      "hiv\[EmptyVerySmallSquare]vars =", {
        "hiv\[EmptyVerySmallSquare]EnterDate", 
        "hiv\[EmptyVerySmallSquare]EndDate", "hiv\[EmptyVerySmallSquare]Time",
         "hiv\[EmptyVerySmallSquare]Age", "hiv\[EmptyVerySmallSquare]Drug", 
        "hiv\[EmptyVerySmallSquare]Censor"}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(displayDates[Take[dataFile, {1, 10}], 
      hiv\[EmptyVerySmallSquare]rowForm]\)], "Input",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            InterpretationBox["\<\"\\!\\(15\\)\[CenterDot]May\[CenterDot]90\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "90", "May", 15],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(14\\)\[CenterDot]Oct\[CenterDot]90\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "90", "Oct", 14],
              Editable->False], "5", "46", "0", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(19\\)\[CenterDot]Sep\[CenterDot]89\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "89", "Sep", 19],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(20\\)\[CenterDot]Mar\[CenterDot]90\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "90", "Mar", 20],
              Editable->False], "6", "35", "1", "0"},
          {
            
            InterpretationBox["\<\"\\!\\(21\\)\[CenterDot]Apr\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Apr", 21],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(20\\)\[CenterDot]Dec\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Dec", 20],
              Editable->False], "8", "30", "1", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(3\\)\[CenterDot]Jan\[CenterDot]91\"\>\
",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Jan", 3],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(4\\)\[CenterDot]Apr\[CenterDot]91\"\>\
",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Apr", 4],
              Editable->False], "3", "30", "1", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(18\\)\[CenterDot]Sep\[CenterDot]89\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "89", "Sep", 18],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(19\\)\[CenterDot]Jul\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Jul", 19],
              Editable->False], "22", "36", "0", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(18\\)\[CenterDot]Mar\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Mar", 18],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(17\\)\[CenterDot]Apr\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Apr", 17],
              Editable->False], "1", "32", "1", "0"},
          {
            
            InterpretationBox["\<\"\\!\\(11\\)\[CenterDot]Nov\[CenterDot]89\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "89", "Nov", 11],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(11\\)\[CenterDot]Jun\[CenterDot]90\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "90", "Jun", 11],
              Editable->False], "7", "36", "1", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(25\\)\[CenterDot]Nov\[CenterDot]89\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "89", "Nov", 25],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(25\\)\[CenterDot]Aug\[CenterDot]90\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "90", "Aug", 25],
              Editable->False], "9", "31", "1", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(11\\)\[CenterDot]Feb\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "Feb", 11],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(13\\)\[CenterDot]May\[CenterDot]91\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "91", "May", 13],
              Editable->False], "3", "48", "0", "1"},
          {
            
            InterpretationBox["\<\"\\!\\(11\\)\[CenterDot]Aug\[CenterDot]89\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "89", "Aug", 11],
              Editable->False], 
            
            InterpretationBox["\<\"\\!\\(11\\)\[CenterDot]Aug\[CenterDot]90\"\
\>",
              StringForm[ 
              "`3`\[CenterDot]`2`\[CenterDot]`1`", "90", "Aug", 11],
              Editable->False], "12", "47", "0", "1"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$]]]], "Output",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[BoxData[
    \(\(setVarsToRules[fnAbbr, vars];\)\)], "Input"],

Cell[BoxData[{
    \(\(timeColumnName = "\<Time\>";\)\), "\n", 
    \(\(censorColumnName = "\<Censor\>";\)\)}], "Input"],

Cell["\<\
Center the variables to ensure the mean is used in the data to find \
the coefficient, especially when large values are found in the data.\
\>", \
"Text"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell["\<\
The covariate names define the model in that main effects and \
interaction effects can be described by the xNames list.  For example {\
\[Alpha]_String,\[Beta]_String,\[Alpha]*\[Beta]_String} where \
\[Alpha],\[Beta] and \[Alpha]*\[Beta] are the column names from the titleLine \
identifying the variables.
Note: Interaction name separator can be any of the following \
{comma,dash,plus,asterisk,or \[EmptyVerySmallSquare]}\
\>", "Text",
  CellOpen->False,
  FontFamily->"Century Schoolbook",
  FontSize->14,
  FontTracking->"Extended"],

Cell[CellGroupData[{

Cell[BoxData[
    \(titleLine\)], "Input"],

Cell[BoxData[
    \({"EnterDate", "EndDate", "Time", "Age", "Drug", "Censor"}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(covariateNames = {"\<Age\>", "\<Drug\>", \
"\<Age\[EmptyVerySmallSquare]Drug\>"};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({phLayout, {\[Beta], \[Beta]nameList}} = 
        setupPHlayout[titleLine, timeColumnName, censorColumnName, 
          covariateNames, CenteredDataList \[Rule] {"\<Age\>"}];\)\), "\n", 
    \(phLayout\), "\n", 
    \(\[Beta]\), "\n", 
    \(\[Beta]nameList\)}], "Input"],

Cell[BoxData[
    \({e3, e6, {}, {e4 - offset4, e5, e5\ \((e4 - offset4)\)}}\)], "Output"],

Cell[BoxData[
    \({\[Beta]1, \[Beta]2, \[Beta]3}\)], "Output"],

Cell[BoxData[
    \({"\[CapitalDelta]Age", "Drug", 
      "\[CapitalDelta]Age\[EmptyVerySmallSquare]Drug"}\)], "Output"]
}, Open  ]],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["For any centered variables the corresponding offset \
must be assigned. \nFor any transformed variables the corresponding \
transforming function must be defined.  \nNote that the grouping function can \
also be used to apply transformations on the group name's data.",
  FontSize->14,
  FontColor->RGBColor[1, 0, 0],
  Background->RGBColor[1, 0.879942, 0.832074]]], "Subsection",
  CellOpen->False],

Cell[CellGroupData[{

Cell[BoxData[{
    \(meanAge = 
      Mean[dataFile /. hiv\[EmptyVerySmallSquare]Age] // 
        N\), "\[IndentingNewLine]", 
    \(medianAge = 
      Median[dataFile /. 
          hiv\[EmptyVerySmallSquare]Age]\), "\[IndentingNewLine]", 
    \(\(offset4 = medianAge;\)\)}], "Input"],

Cell[BoxData[
    \(36.07`\)], "Output"],

Cell[BoxData[
    \(35\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(formatInputData = pattVars \[Rule] phLayout\)], "Input"],

Cell[BoxData[
    \({e1_?Date\[EmptyVerySmallSquare]TimeQ, 
        e2_?Date\[EmptyVerySmallSquare]TimeQ, e3_?NumberQ, e4_?NumberQ, 
        e5_?NumberQ, e6_?NumberQ} \[Rule] {e3, 
        e6, {}, {\(-35\) + e4, e5, \((\(-35\) + e4)\)\ e5}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(inputData = 
        Map[make\[Ellipsis]phDataPt, 
          dataFile /. formatInputData];\)\), "\[IndentingNewLine]", 
    \(First[inputData]\), "\[IndentingNewLine]", 
    \(Last[inputData]\), "\[IndentingNewLine]", 
    \(\(With[{nrXis = Length[covariatesf[First[inputData]]], 
          len\[Beta] = Length[\[Beta]]}, 
        Print[covariatesf[First[inputData]], "\<  has length of \>", 
          nrXis]; \[IndentingNewLine]Print[\[Beta], "\<  has length of \>", 
          len\[Beta]]; \[IndentingNewLine]If[
          nrXis \[NotEqual] 
            len\[Beta], \((StylePrint[
              StyleForm["\<\[Beta]'s must be adjusted\>", 
                FontFamily \[Rule] "\<CopperPlate\>", FontSize \[Rule] 24, 
                FontWeight \[Rule] "\<Bold\>"]]; \[IndentingNewLine]\[Beta] = 
              Map[makeVariable["\<\[Beta]x\>" <> ToString[#]] &, 
                Range[nrXis]])\), \[IndentingNewLine]Print["\<\[Beta]'s are \
OK\>"]]; \[IndentingNewLine]If[
          Length[\[Beta]nameList] \[NotEqual] 
            nrXis, \((StylePrint[
              StyleForm["\<\[Beta]nameList must be adjusted\>", 
                FontFamily \[Rule] "\<CopperPlate\>", FontSize \[Rule] 24, 
                FontWeight \[Rule] "\<Bold\>"]]; \
\[IndentingNewLine]\[Beta]nameList = 
              Map["\<x\>" <> ToString[#] &, 
                Range[nrXis]])\), \[IndentingNewLine]Print["\<\[Beta]nameList \
is OK\>"]]];\)\), "\[IndentingNewLine]", 
    \(\(Print["\<\[Beta] = \>", \[Beta]];\)\), "\[IndentingNewLine]", 
    \(\(Print["\<\[Beta]nameList = \>", \[Beta]nameList];\)\), "\
\[IndentingNewLine]", 
    \(TableForm[Take[inputData, {1, 10}]]\), "\[IndentingNewLine]", 
    \(lastTimePt = {Max[Map[timef, inputData]], 0}\), "\[IndentingNewLine]", 
    \(\(maxKMdata = lastTimePt;\)\)}], "Input"],

Cell[BoxData[
    \(phDataPt[5, True, {}, {11, 0, 0}]\)], "Output"],

Cell[BoxData[
    \(phDataPt[1, True, {}, {\(-1\), 1, \(-1\)}]\)], "Output"],

Cell[BoxData[
    InterpretationBox[\({11, 0, 
          0}\[InvisibleSpace]"  has length of "\[InvisibleSpace]3\),
      SequenceForm[ {11, 0, 0}, "  has length of ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\({\[Beta]1, \[Beta]2, \[Beta]3}\[InvisibleSpace]"  has \
length of "\[InvisibleSpace]3\),
      SequenceForm[ {\[Beta]1, \[Beta]2, \[Beta]3}, "  has length of ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    \("\[Beta]'s are OK"\)], "Print"],

Cell[BoxData[
    \("\[Beta]nameList is OK"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Beta] = "\[InvisibleSpace]{\[Beta]1, \[Beta]2, \
\[Beta]3}\),
      SequenceForm[ "\[Beta] = ", {\[Beta]1, \[Beta]2, \[Beta]3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Beta]nameList = \
"\[InvisibleSpace]{"\[CapitalDelta]Age", "Drug", 
          "\[CapitalDelta]Age\[EmptyVerySmallSquare]Drug"}\),
      SequenceForm[ 
      "\[Beta]nameList = ", {"\[CapitalDelta]Age", "Drug", 
        "\[CapitalDelta]Age\[EmptyVerySmallSquare]Drug"}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(phDataPt[5, True, {}, {11, 0, 0}]\)},
          {\(phDataPt[6, False, {}, {0, 1, 0}]\)},
          {\(phDataPt[8, True, {}, {\(-5\), 1, \(-5\)}]\)},
          {\(phDataPt[3, True, {}, {\(-5\), 1, \(-5\)}]\)},
          {\(phDataPt[22, True, {}, {1, 0, 0}]\)},
          {\(phDataPt[1, False, {}, {\(-3\), 1, \(-3\)}]\)},
          {\(phDataPt[7, True, {}, {1, 1, 1}]\)},
          {\(phDataPt[9, True, {}, {\(-4\), 1, \(-4\)}]\)},
          {\(phDataPt[3, True, {}, {13, 0, 0}]\)},
          {\(phDataPt[12, True, {}, {12, 0, 0}]\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {
        phDataPt[ 5, True, {}, {11, 0, 0}], 
        phDataPt[ 6, False, {}, {0, 1, 0}], 
        phDataPt[ 8, True, {}, {-5, 1, -5}], 
        phDataPt[ 3, True, {}, {-5, 1, -5}], 
        phDataPt[ 22, True, {}, {1, 0, 0}], 
        phDataPt[ 1, False, {}, {-3, 1, -3}], 
        phDataPt[ 7, True, {}, {1, 1, 1}], 
        phDataPt[ 9, True, {}, {-4, 1, -4}], 
        phDataPt[ 3, True, {}, {13, 0, 0}], 
        phDataPt[ 12, True, {}, {12, 0, 0}]}]]], "Output"],

Cell[BoxData[
    \({60, 0}\)], "Output"]
}, Open  ]],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[BoxData[{
    \(\(Clear[addLastPt];\)\), "\[IndentingNewLine]", 
    \(\(addLastPt[spts : {{_?NumberQ, _?NumberQ} .. }, 
          lastPt : \({_?NumberQ, _?NumberQ} : lastTimePt\)] := 
        With[{diff = lastPt - Last[spts]}, 
          If[First[diff] > 0, 
            Append[spts, 
              lastPt - {0, diff\[LeftDoubleBracket]2\[RightDoubleBracket]}], 
            spts]];\)\)}], "Input",
  CellOpen->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Semi-Parametric Proportional Hazards Analysis of HIV-AIDS Dataset\
\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["Empirival Survival Plot (Kaplan-Meier Plot)", "Subsubsection",
  FontFamily->"Century Schoolbook"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(ES = 
        surv\[EmptyVerySmallSquare]data[
          inputData /. time\[Delta]f];\)\), "\n", 
    \(\(empsurv = ES\[LeftDoubleBracket]1\[RightDoubleBracket];\)\), "\n", 
    \(\(p = 
        empsurv\[LeftDoubleBracket]All, 5\[RightDoubleBracket];\)\), "\n", 
    \(\(q = 1 - p;\)\), "\n", 
    \(\(event\[EmptyVerySmallSquare]t = 
        N[empsurv\[LeftDoubleBracket]All, 
            1\[RightDoubleBracket]];\)\), "\n", 
    \(\(kmData = 
        MapThread[{#1, #2} &, {empsurv\[LeftDoubleBracket]All, 
              1\[RightDoubleBracket], 
            empsurv\[LeftDoubleBracket]All, 
              4\[RightDoubleBracket]}];\)\), "\[IndentingNewLine]", 
    \(\(empSplot = 
        ListPlot[
          addLastPt[
            Transpose[{event\[EmptyVerySmallSquare]t, q}]]];\)\)}], "Input",
  CellOpen->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.015873 0.0147151 0.588604 [
[.18254 .00222 -6 -9 ]
[.18254 .00222 6 0 ]
[.34127 .00222 -6 -9 ]
[.34127 .00222 6 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.65873 .00222 -6 -9 ]
[.65873 .00222 6 0 ]
[.81746 .00222 -6 -9 ]
[.81746 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(10)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(20)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(30)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(40)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(50)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(60)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.03968 .55917 Mdot
.05556 .49996 Mdot
.07143 .45269 Mdot
.0873 .40718 Mdot
.10317 .37018 Mdot
.11905 .33971 Mdot
.13492 .31218 Mdot
.15079 .27724 Mdot
.16667 .25241 Mdot
.18254 .23112 Mdot
.19841 .20945 Mdot
.21429 .19108 Mdot
.23016 .17971 Mdot
.24603 .17166 Mdot
.2619 .15959 Mdot
.37302 .14726 Mdot
.5 .13841 Mdot
.51587 .12925 Mdot
.53175 .12008 Mdot
.56349 .11092 Mdot
.57937 .10176 Mdot
.59524 .0926 Mdot
.70635 .08343 Mdot
.86508 .07427 Mdot
.88095 .06511 Mdot
.92857 .0548 Mdot
.94444 .04335 Mdot
.97619 .04335 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00>oooool3o`0000Cooooo0_l0000Qooooo`Go00000oooool2o`0002;ooooo0ol00004oooo
o`;o00009?ooool3o`0000?ooooo0_l0000Rooooo`?o00001?ooool2o`0002;ooooo0ol00004oooo
o`;o00001?ooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Qoooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00009?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool07_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00008?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000oooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Rooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00009?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo01oooooo1Ol00002ooooo`04o`000?ooooooooooo`0002Cooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Nooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00003ooooo`00??ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooo
oooo023ooooo0_l00003ooooo`04o`000?ooooooooooo`00027ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool07_ooool4o`0000?ooooo00Co0000oooooooooooo00000oooool003cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool0000Pooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool08?ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00023ooooo1?l00003oooo
o`04o`000?ooooooooooo`00023ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0003ooooo`00>oooool2o`0000Cooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00008oooool2o`0000?ooooo00Co0000oooooooooooo00008?oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00027ooooo00?o0000ooooooooool0
0oooool01?l0003oooooooooool00003ooooo`00??ooool00ol0003oooooooooo`03ooooo`;o0000
8_ooool3o`0000Cooooo0_l0000Rooooo`?o00001?ooool2o`0002Gooooo00?o0000ooooooooool0
0_ooool2o`00027ooooo1Ol00003ooooo`;o00008oooool2o`0000Cooooo0_l00004ooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool0
01Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000?oooooooo00004Ol00001ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`005Oooool0
0ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`05ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03
o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?Oooooo0_l00006
ooooo`;o00001oooool001Gooooo0_l0003hooooo`;o00001_ooool2o`0000Oooooo000Eooooo`03
o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0l_ooool2o`0001Cooooo
000Eooooo`03o`000?oooooooooo0?;ooooo0_l0000Dooooo`005Oooool00ol0003oooooooooo`3o
ooooo`Wooooo000Eooooo`03o`000?oooooooooo0>Gooooo0_l0000Qooooo`005Oooool00ol0003o
ooooooooo`3Uooooo`;o00008Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Ooo
ool2o`000>;ooooo0_l0000Uooooo`005Oooool00ol0003oooooooooo`3Qooooo`;o00009Oooool0
01Gooooo00?o0000ooooooooool0]_ooool2o`00053ooooo000Eooooo`03o`000?oooooooooo0;Ko
oooo0_l0001@ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo09Sooooo0_l0001^ooooo`005Oooool00ol0003oooooooooo`2Hooooo`;o0000K_ooool0
01Gooooo00?o0000ooooooooool0Toooool2o`0007?ooooo000Eooooo`;o0000U?ooool2o`0007?o
oooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0Sooo
ool2o`0007Oooooo000Eooooo`03o`000?oooooooooo08oooooo0_l0001gooooo`005Oooool00ol0
003oooooooooo`27ooooo`;o0000Ooooool000;ooooo0_l00004ooooo`04o`000?oooooooooooooo
o`Go00001?ooool00ol0003oooooooooo`27ooooo`;o0000Ooooool00005ooooool0003ooooooooo
ool000002?ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0?oooooo2Oooool0
0005ooooool0003oooooooooool000002Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo08;ooooo0_l00024ooooo`0000Goooooo`000?ooooooooooo`00000:ooooo`03o`000?oooooo
oooo00?ooooo0ol00022ooooo`;o0000Q?ooool00005ooooool0003oooooooooool000001oooool0
1Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0O_ooool2o`0008Sooooo0000
1Ooooooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`00
0?oooooooooo07kooooo0_l00028ooooo`000_ooool2o`0000Wooooo0ol00005ooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0Foooool2o`000:_ooooo000Eoooo
o`03o`000?oooooooooo05_ooooo0_l0002[ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000Eooooo`03o`000?oooooooooo03gooooo0_l00039ooooo`005Oooool2o`0003kooooo0_l0
0039ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
03Wooooo0_l0003=ooooo`005Oooool00ol0003oooooooooo`0iooooo`;o0000cOooool001Gooooo
00?o0000ooooooooool0=Oooool2o`000=7ooooo000Eooooo`03o`000?oooooooooo03Gooooo0_l0
003Aooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
033ooooo0_l0003Fooooo`005Oooool2o`00037ooooo0_l0003Fooooo`005Oooool00ol0003ooooo
ooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`0/ooooo`;o0000f_ooool001Go
oooo00?o0000ooooooooool0;?ooool2o`000=[ooooo000Eooooo`03o`000?oooooooooo0?oooooo
2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_ooool0
01Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`0Xooooo`;o
0000g_ooool001Gooooo00?o0000ooooooooool0:?ooool2o`000=kooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool000;ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo0ol00004
ooooo`03o`000?oooooooooo0?oooooo2Oooool00005ooooool0003oooooooooool000002_ooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo2Oooool00005ooooool0003ooooo
ooooool000001oooool5o`0000Cooooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`00
0?ooooooooooo`000007ooooo`04o`000?ooooooooooo`0000Gooooo0ol0000Sooooo`;o0000hooo
ool00005ooooool0003oooooooooool000002?ooool00ol0003oooooo`000005ooooo`03o`000?oo
oooooooo02?ooooo0_l0003Sooooo`0000Goooooo`000?ooooooooooo`000009ooooo`;o00001Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo0002ooooo`;o00002oooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo
2Oooool001Gooooo00?o0000ooooooooool07oooool2o`000>Oooooo000Eooooo`;o00008?ooool2
o`000>Oooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
0_l0000Looooo`;o0000joooool001Gooooo00?o0000ooooooooool06oooool2o`000>_ooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo
2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3o
ooooo`Wooooo000Eooooo`;o00005oooool2o`000?3ooooo000Eooooo`03o`000?oooooooooo01Ko
oooo0_l0003`ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`000_ooool2o`00
00Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0ooooool9oooo
o`0000Goooooo`000?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool0
0ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0?oooooo2Oooool00005ooooool0003o
ooooooooool000001oooool4o`0000Gooooo0ol0000Booooo`;o0000m?ooool00005ooooool0003o
ooooooooool000001oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01;ooooo0_l0
003dooooo`0000Goooooo`000?ooooooooooo`000008ooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0ooooool9ooooo`000_ooool2o`0000[ooooo0_l00005ooooo`03o`000?oooooo
oooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o
0000ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_ooool001Gooooo00?o0000oooo
ooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`0>ooooo`;o0000n?ooool001Gooooo
00?o0000ooooooooool03_ooool2o`000?Sooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oo
oooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo00Wooooo0_l0003mooooo`005Oooool2o`00
00[ooooo0_l0003mooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo0002ooooo`;o00001?ooool00ol0003oooooooooo`02oooo
o`?o00001Oooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo0000
00Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0?oooooo2Oooool0
0005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o
0000ooooooooool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`000008ooooo`?o00001Ooo
ool3o`000?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`000?oooooooooo
o`000007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3oooooo`Wo
oooo0002ooooo`;o00002Oooool3o`0000Gooooo00?o0000ooooooooool01Oooool2o`000?oooooo
0_ooool001Gooooo00?o0000ooooooooool01Oooool2o`000?oooooo0_ooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03
o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03
o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`04o`000?ooooooooooooooo`;o0000oooo
ool6ooooo`005Oooool01?l0003oooooooooooooool2o`000?oooooo1_ooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o
0000ooooool:ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000=ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000>ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0ooooool9ooooo`003_oo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo2Oooool000kooooo00?o0000
ooooooooool00oooool4o`000?oooooo2Oooool000kooooo00?o0000ooooooooool00oooool2o`00
0?oooooo2oooool000gooooo0_l00006ooooo`03o`000?oooooooooo0?oooooo2Oooool000kooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-4.97912, -0.07747, \
0.231708, 0.00624851}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["PH Solution Results", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({{valuelogL\[Beta]0, maxLogL\[Beta], \[Beta]hat}, {varCov\[Beta], 
            stdErr\[Beta]}, {s0, logH0}} = 
        boxedPH[inputData, \[Beta]];\)\)], "Input"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-281.68438066183677`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-299.19501764652614`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -281.68438066183677, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -299.19501764652614],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{0.09423088365243491`, 
          0.9513071025607879`, \(-0.0067029002247708655`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {0.094230883652434913, 
        0.95130710256078788, -0.0067029002247708655}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{4.353032068138418`*^-7, \(-3.4241361746012444`*^-8\), 
          3.953867917516618`*^-7}\),
      SequenceForm[ 
      "Gradient vector ", {4.3530320681384183*^-07, -3.4241361746012444*^-08, 
        3.953867917516618*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.0005256073704139787`, 
            0.0016222479309906178`, \(-0.00045919807009123356`\)}, \
{0.0016222479309906173`, 
            0.06767921554919266`, \(-0.001665299224385016`\)}, \
{\(-0.00045919807009123345`\), \(-0.001665299224385017`\), 
            0.0011384334679685505`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00052560737041397866, 
        0.0016222479309906178, -0.00045919807009123356}, {
        0.0016222479309906173, 
        0.067679215549192664, -0.0016652992243850161}, \
{-0.00045919807009123345, -0.0016652992243850169, 0.0011384334679685505}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.022926128552679333`, 0.26015229299237913`, 
          0.0337406797200138`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.022926128552679333, 
        0.26015229299237913, 0.033740679720013801}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9300076119358703`, 
          0.9706172026264538`, 0.9266352637777112`, 0.9610627829798455`, 
          0.9168832384643087`, 0.9710866553767532`, 0.8999813988660957`, 
          0.9111491162349751`, 0.9244392108254739`, 0.9177287177372979`, 
          0.9050671880494832`, 0.9247581189004331`, 0.9462128493946678`, 
          0.9426627328908245`, 0.8766538029075234`, 0.9217713676774498`, 
          0.9115305134544178`, 0.9050591414102378`, 0.8960816858531934`, 
          0.8839206754400227`, 0.8694016986262159`, 0.836724786177572`, 
          0.7973762201365006`, 0.7659819988975664`, 0.7300915593829748`, 
          0.5635549422040728`, 0.40229263210242655`}\),
      SequenceForm[ 
      "\[Alpha] ", {0.93000761193587034, 0.97061720262645379, 
        0.92663526377771122, 0.96106278297984549, 0.91688323846430875, 
        0.97108665537675321, 0.89998139886609574, 0.91114911623497508, 
        0.92443921082547387, 0.91772871773729792, 0.90506718804948316, 
        0.92475811890043313, 0.94621284939466777, 0.94266273289082447, 
        0.87665380290752337, 0.92177136767744983, 0.91153051345441782, 
        0.9050591414102378, 0.89608168585319337, 0.88392067544002273, 
        0.86940169862621586, 0.83672478617757196, 0.79737622013650056, 
        0.76598199889756635, 0.73009155938297476, 0.56355494220407276, 
        0.40229263210242655}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[s0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.015873 0.0147151 0.588604 [
[.18254 .00222 -6 -9 ]
[.18254 .00222 6 0 ]
[.34127 .00222 -6 -9 ]
[.34127 .00222 6 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.65873 .00222 -6 -9 ]
[.65873 .00222 6 0 ]
[.81746 .00222 -6 -9 ]
[.81746 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(10)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(20)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(30)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(40)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(50)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(60)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.03968 .56212 Mdot
.05556 .54604 Mdot
.07143 .50706 Mdot
.0873 .48789 Mdot
.10317 .44856 Mdot
.11905 .43601 Mdot
.13492 .39388 Mdot
.15079 .36019 Mdot
.16667 .33408 Mdot
.18254 .30781 Mdot
.19841 .27998 Mdot
.21429 .26002 Mdot
.23016 .24683 Mdot
.24603 .23352 Mdot
.2619 .20653 Mdot
.37302 .19153 Mdot
.5 .17588 Mdot
.51587 .16058 Mdot
.53175 .14542 Mdot
.56349 .13025 Mdot
.57937 .11516 Mdot
.59524 .09876 Mdot
.70635 .08173 Mdot
.86508 .06605 Mdot
.88095 .05219 Mdot
.92857 .03584 Mdot
.94444 .02321 Mdot
.97619 .02321 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00>oooool3o`0000Cooooo0_l0000Qooooo`Go00000oooool2o`0002;ooooo0ol00004oooo
o`;o00009?ooool3o`0000?ooooo0_l0000Rooooo`?o00001?ooool2o`0002;ooooo0ol00004oooo
o`;o00001?ooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Qoooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00009?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool07_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00008?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000oooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Rooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00009?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo01oooooo1Ol00002ooooo`04o`000?ooooooooooo`0002Cooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Nooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00003ooooo`00??ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooo
oooo023ooooo0_l00003ooooo`04o`000?ooooooooooo`00027ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool07_ooool4o`0000?ooooo00Co0000oooooooooooo00000oooool003cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool0000Pooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool08?ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00023ooooo1?l00003oooo
o`04o`000?ooooooooooo`00023ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0003ooooo`00>oooool2o`0000Cooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00008oooool2o`0000?ooooo00Co0000oooooooooooo00008?oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00027ooooo00?o0000ooooooooool0
0oooool01?l0003oooooooooool00003ooooo`00??ooool00ol0003oooooooooo`03ooooo`;o0000
8_ooool3o`0000Cooooo0_l0000Rooooo`?o00001?ooool2o`0002Gooooo00?o0000ooooooooool0
0_ooool2o`00027ooooo1Ol00003ooooo`;o00008oooool2o`0000Cooooo0_l00004ooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool0
01Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000?oooooooo00004Ol00001ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`005Oooool0
0ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07oooool2
o`0000Kooooo0_l00007ooooo`005Oooool00ol0003oooooooooo`3gooooo`;o00001_ooool2o`00
00Oooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0
l_ooool2o`0001Cooooo000Eooooo`03o`000?oooooooooo0?;ooooo0_l0000Dooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0>Gooooo0_l0000Qooooo`005Ooo
ool00ol0003oooooooooo`3Uooooo`;o00008Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`005Oooool00ol0003oooooooooo`3Qooooo`;o00009Oooool001Gooooo00?o0000oooooooo
ool0hOooool2o`0002Gooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0
003oooooo`[ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool0]_ooool2o`00053ooooo000Eooooo`03o`000?oooooooooo0;Kooooo0_l0001@ooooo`00
5Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool0V?ooool2o`0006kooooo000Eooooo`03o`000?oooooooooo
09Sooooo0_l0001^ooooo`005Oooool2o`000?oooooo2_ooool001Gooooo00?o0000ooooooooool0
ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooo
oooo09?ooooo0_l0001cooooo`005Oooool00ol0003oooooooooo`2Cooooo`;o0000Loooool000;o
oooo0_l00004ooooo`04o`000?ooooooooooooooo`Go00001?ooool00ol0003oooooooooo`3ooooo
o`Wooooo00001Ooooooo0000oooooooooooo000000Sooooo00Co0000oooooooooooo00001?ooool0
0ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Wooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`2?ooooo`;o0000Moooool00005ooooool0003ooooo
ooooool000002_ooool00ol0003oooooooooo`03ooooo`?o0000Soooool2o`0007Oooooo00001Ooo
oooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oo
oooooooo0?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool0ooooool9ooooo`000_ooool2o`0000Wooooo0ol0
0005ooooo`03o`000?oooooooooo08Oooooo0_l0001oooooo`005Oooool00ol0003oooooooooo`27
ooooo`;o0000Ooooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo08;ooooo0_l00024ooooo`005Ooo
ool2o`0008?ooooo0_l00024ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eoooo
o`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0O_ooool2o`0008So
oooo000Eooooo`03o`000?oooooooooo07kooooo0_l00028ooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool0ooooool9ooooo`005Oooool2o`0005cooooo0_l0002[ooooo`005Oooool00ol0003ooooo
ooooo`1Kooooo`;o0000Zoooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo03gooooo0_l00039oooo
o`005Oooool00ol0003oooooooooo`0mooooo`;o0000bOooool001Gooooo00?o0000ooooooooool0
ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oo
oooo2Oooool001Gooooo00?o0000ooooooooool0>Oooool2o`000<gooooo000Eooooo`03o`000?oo
oooooooo03Wooooo0_l0003=ooooo`000_ooool2o`0000Cooooo00?o0000ooooooooool00oooool3
o`0000Cooooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`00000:
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`00
0?ooooooooooo`000007ooooo`Go00001?ooool00ol0003oooooooooo`0eooooo`;o0000dOooool0
0005ooooool0003oooooooooool000001oooool01?l0003oooooooooool00005ooooo`?o0000=Ooo
ool2o`000=7ooooo00001Ooooooo0000oooooooooooo000000Sooooo00?o0000ooooool000001Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Wooooo0_l0
0005ooooo`03o`000?oooooooooo033ooooo0_l0003Fooooo`000_ooool2o`0000_ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0`ooooo`;o0000e_ooool001Gooooo00?o0000oooo
ooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2
o`0002gooooo0_l0003Jooooo`005Oooool00ol0003oooooooooo`0/ooooo`;o0000f_ooool001Go
oooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo02So
oooo0_l0003Nooooo`005Oooool2o`0002Wooooo0_l0003Nooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool08oooool2o`000>?ooooo000E
ooooo`03o`000?oooooooooo02?ooooo0_l0003Sooooo`005Oooool2o`000?oooooo2_ooool001Go
oooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`000_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000oooo
ooooool07oooool2o`000>Oooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo01oooooo0_l0003Wooooo`0000Goooooo`00
0?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooooooo
o`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Oooooo1?l00005ooooo`?o0000oooo
ool9ooooo`0000Goooooo`000?ooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`000008ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool0ooooool9ooooo`000_ooool2o`0000[ooooo0_l00005
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo
2Oooool001Gooooo00?o0000ooooooooool06oooool2o`000>_ooooo000Eooooo`;o00007?ooool2
o`000>_ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000
ooooooooool05_ooool2o`000?3ooooo000Eooooo`03o`000?oooooooooo01Kooooo0_l0003`oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo01;ooooo
0_l0003dooooo`005Oooool00ol0003oooooooooo`0Booooo`;o0000m?ooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_ooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`000_ooool2o`00
00Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0ooooool9oooo
o`0000Goooooo`000?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool0
0ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0?oooooo2Oooool00005ooooool0003o
ooooooooool000002?ooool3o`0000Gooooo0ol0000>ooooo`;o0000n?ooool00005ooooool0003o
ooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
3_ooool2o`000?Sooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo0?oooooo2Oooool000;ooooo0_l00009ooooo`?o0000
1Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool02Oooool2o`000?gooooo000Eooooo`03o`000?oooooooooo
00Wooooo0_l0003mooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000
ooooool:ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooo
oooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o
0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eoooo
o`;o00001_ooool2o`000?oooooo0_ooool001Gooooo00?o0000ooooooooool01Oooool2o`000?oo
oooo0_ooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`04o`000?ooooooooooooooo`;o0000ooooool6ooooo`005Oooool0
1?l0003oooooooooooooool2o`000?oooooo1_ooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`00
5Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000=ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`Wooooo000>ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0ooooool9ooooo`003_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo0?oooooo2Oooool000kooooo00?o0000ooooooooool00oooool4
o`000?oooooo2Oooool000kooooo00?o0000ooooooooool00oooool2o`000?oooooo2oooool000go
oooo0_l00006ooooo`03o`000?oooooooooo0?oooooo2Oooool000kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-4.97912, -0.07747, \
0.231708, 0.00624851}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[logH0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.015873 0.39434 0.144712 [
[.18254 .38184 -6 -9 ]
[.18254 .38184 6 0 ]
[.34127 .38184 -6 -9 ]
[.34127 .38184 6 0 ]
[.5 .38184 -6 -9 ]
[.5 .38184 6 0 ]
[.65873 .38184 -6 -9 ]
[.65873 .38184 6 0 ]
[.81746 .38184 -6 -9 ]
[.81746 .38184 6 0 ]
[.97619 .38184 -6 -9 ]
[.97619 .38184 6 0 ]
[.01131 .10492 -12 -4.5 ]
[.01131 .10492 0 4.5 ]
[.01131 .24963 -12 -4.5 ]
[.01131 .24963 0 4.5 ]
[.01131 .53905 -6 -4.5 ]
[.01131 .53905 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .39434 m
.18254 .40059 L
s
[(10)] .18254 .38184 0 1 Mshowa
.34127 .39434 m
.34127 .40059 L
s
[(20)] .34127 .38184 0 1 Mshowa
.5 .39434 m
.5 .40059 L
s
[(30)] .5 .38184 0 1 Mshowa
.65873 .39434 m
.65873 .40059 L
s
[(40)] .65873 .38184 0 1 Mshowa
.81746 .39434 m
.81746 .40059 L
s
[(50)] .81746 .38184 0 1 Mshowa
.97619 .39434 m
.97619 .40059 L
s
[(60)] .97619 .38184 0 1 Mshowa
.125 Mabswid
.05556 .39434 m
.05556 .39809 L
s
.0873 .39434 m
.0873 .39809 L
s
.11905 .39434 m
.11905 .39809 L
s
.15079 .39434 m
.15079 .39809 L
s
.21429 .39434 m
.21429 .39809 L
s
.24603 .39434 m
.24603 .39809 L
s
.27778 .39434 m
.27778 .39809 L
s
.30952 .39434 m
.30952 .39809 L
s
.37302 .39434 m
.37302 .39809 L
s
.40476 .39434 m
.40476 .39809 L
s
.43651 .39434 m
.43651 .39809 L
s
.46825 .39434 m
.46825 .39809 L
s
.53175 .39434 m
.53175 .39809 L
s
.56349 .39434 m
.56349 .39809 L
s
.59524 .39434 m
.59524 .39809 L
s
.62698 .39434 m
.62698 .39809 L
s
.69048 .39434 m
.69048 .39809 L
s
.72222 .39434 m
.72222 .39809 L
s
.75397 .39434 m
.75397 .39809 L
s
.78571 .39434 m
.78571 .39809 L
s
.84921 .39434 m
.84921 .39809 L
s
.88095 .39434 m
.88095 .39809 L
s
.9127 .39434 m
.9127 .39809 L
s
.94444 .39434 m
.94444 .39809 L
s
.25 Mabswid
0 .39434 m
1 .39434 L
s
.02381 .10492 m
.03006 .10492 L
s
[(-2)] .01131 .10492 1 0 Mshowa
.02381 .24963 m
.03006 .24963 L
s
[(-1)] .01131 .24963 1 0 Mshowa
.02381 .53905 m
.03006 .53905 L
s
[(1)] .01131 .53905 1 0 Mshowa
.125 Mabswid
.02381 .13386 m
.02756 .13386 L
s
.02381 .1628 m
.02756 .1628 L
s
.02381 .19174 m
.02756 .19174 L
s
.02381 .22068 m
.02756 .22068 L
s
.02381 .27857 m
.02756 .27857 L
s
.02381 .30751 m
.02756 .30751 L
s
.02381 .33645 m
.02756 .33645 L
s
.02381 .3654 m
.02756 .3654 L
s
.02381 .42328 m
.02756 .42328 L
s
.02381 .45222 m
.02756 .45222 L
s
.02381 .48117 m
.02756 .48117 L
s
.02381 .51011 m
.02756 .51011 L
s
.02381 .07597 m
.02756 .07597 L
s
.02381 .04703 m
.02756 .04703 L
s
.02381 .01809 m
.02756 .01809 L
s
.02381 .56799 m
.02756 .56799 L
s
.02381 .59694 m
.02756 .59694 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.03968 .01472 Mdot
.05556 .06454 Mdot
.07143 .14504 Mdot
.0873 .1741 Mdot
.10317 .22254 Mdot
.11905 .23582 Mdot
.13492 .27547 Mdot
.15079 .30324 Mdot
.16667 .32314 Mdot
.18254 .34216 Mdot
.19841 .36151 Mdot
.21429 .37505 Mdot
.23016 .38392 Mdot
.24603 .39282 Mdot
.2619 .4109 Mdot
.37302 .42104 Mdot
.5 .43178 Mdot
.51587 .44252 Mdot
.53175 .45348 Mdot
.56349 .46488 Mdot
.57937 .47681 Mdot
.59524 .49071 Mdot
.70635 .50664 Mdot
.86508 .52339 Mdot
.88095 .54094 Mdot
.92857 .56831 Mdot
.94444 .60332 Mdot
.97619 .60332 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`00
0?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool0
0ol0003oooooooooo`3oooooo`oooooo000?ooooo`04o`000?ooooooooooooooo`;o0000ooooool<
ooooo`003oooool2o`0000;ooooo0_l0003oooooo`cooooo000?ooooo`03o`000?oooooooooo0?oo
oooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003ooooooooo
o`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`00
0?oooooooooo0?oooooo3oooool000oooooo0_l0003ooooooa3ooooo000?ooooo`03o`000?oooooo
oooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003o
ooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o
0000ooooooooool01Oooool2o`000?oooooo2?ooool000oooooo00?o0000ooooooooool01Oooool2
o`000?oooooo2?ooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool2o`000?oo
oooo4?ooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003ooooooooo
o`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo0006ooooo`Go0000
1?ooool00ol0003oooooooooo`3oooooo`oooooo0007ooooo`04o`000?ooooooooooo`0000Cooooo
00?o0000ooooooooool0ooooool?ooooo`001Ol00003ooooo`03o`000?oooooooooo00Cooooo0ol0
003oooooo`oooooo0009ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0ooooool?
ooooo`001_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0ooooool?
ooooo`001_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0ooooool?
ooooo`001oooool3o`0000Gooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003o
ooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o
0000ooooooooool0ooooool?ooooo`003oooool2o`000?oooooo4?ooool000oooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`00
0?oooooooooo00[ooooo0_l0003oooooo`?ooooo000?ooooo`03o`000?oooooooooo00[ooooo0_l0
003oooooo`?ooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`;o0000
ooooool@ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooo
oooo0?oooooo3oooool000oooooo00?o0000ooooooooool03_ooool2o`000?kooooo000?ooooo`03
o`000?oooooooooo00kooooo0_l0003nooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo
000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?
ooooo`003oooool2o`000?oooooo4?ooool000oooooo00?o0000ooooooooool0ooooool?ooooo`00
3oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3ooo
ool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3ooooo
o`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0
ooooool?ooooo`003oooool2o`000?oooooo4?ooool000oooooo00?o0000ooooooooool04_ooool2
o`000?[ooooo000?ooooo`03o`000?oooooooooo01;ooooo0_l0003jooooo`003oooool00ol0003o
ooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo01Oooooo0_l0003eooooo`003ooo
ool00ol0003oooooooooo`0Gooooo`;o0000mOooool000Oooooo0ol00005ooooo`03o`000?oooooo
oooo0?oooooo3oooool000Sooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3ooooo
o`oooooo0005o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooo`oo
oooo0008ooooo`03o`000?oooooooooo00Cooooo0ol0003oooooo`oooooo0008ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0ooooool?ooooo`001oooool2o`0000Kooooo00?o0000
ooooooooool0ooooool?ooooo`002?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003ooooo
ooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo01_ooooo0_l0003aooooo`003oooool0
0ol0003oooooooooo`0Kooooo`;o0000lOooool000oooooo0_l0003ooooooa3ooooo000?ooooo`03
o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003ooo
ool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool0
00oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`0Pooooo`;o
0000k?ooool000oooooo00?o0000ooooooooool08?ooool2o`000>cooooo000?ooooo`;o0000oooo
ool@ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo
0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003ooooo
ooooo`0Tooooo`;o0000j?ooool000oooooo00?o0000ooooooooool09?ooool2o`000>Sooooo000?
ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?oooo
o`003oooool2o`000?oooooo4?ooool000oooooo00?o0000ooooooooool0:Oooool2o`000>?ooooo
000?ooooo`03o`000?oooooooooo02Wooooo0_l0003Sooooo`003oooool00ol0003oooooooooo`3o
ooooo`oooooo000?ooooo`03o`000?oooooooooo02Cooooo0ol00004ooooo`;o00008_ooool5o`00
00?ooooo0_l0000Sooooo`?o00001?ooool2o`0002Gooooo0ol00003ooooo`;o00008oooool3o`00
00Cooooo0_l0000Sooooo`?o00001?ooool2o`0000Cooooo000?ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Rooooo`04o`000?oooooooooo
o`0000;ooooo00Co0000oooooooooooo00008Oooool01Ol0003ooooooooooooooooo000000;ooooo
00Co0000oooooooooooo00009Oooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ooooool07oooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00008Ooo
ool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo00000oooool000oooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o0000
8_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002Gooooo00Co0000oooooooo
oooo00000_ooool00ol0003oooooooooo`0Pooooo`Go00000_ooool01?l0003oooooooooool0000U
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool07oooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00000oooool000oooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o00008oooool01Ol0003ooooo
oooooooooooo000000;ooooo00?o0000ooooooooool08Oooool2o`0000?ooooo00Co0000oooooooo
oooo00008_ooool01?l0003oooooooooool00003ooooo`04o`000?ooooooooooo`0002Gooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Oooooo`Co00000oooool01?l0003ooooo
ooooool00003ooooo`003oooool2o`0002Kooooo00?o0000ooooooooool00_ooool01?l0003ooooo
ooooool0000Qooooo`05o`000?ooooooooooooooool000000_ooool01?l0003oooooooooool0000U
ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool08Oooool00ol0003oooooo`00
0003ooooo`04o`000?ooooooooooo`00027ooooo1?l00003ooooo`04o`000?ooooooooooo`00027o
oooo00?o0000ooooooooool01?ooool01?l0003oooooooooool00003ooooo`003oooool00ol0003o
ooooooooo`0Tooooo`;o00001?ooool01?l0003oooooooooool0000Qooooo`05o`000?oooooooooo
ooooool000000_ooool01?l0003oooooooooool0000Qooooo`05o`000?ooooooooooooooool00000
0_ooool01?l0003oooooooooool0000Tooooo`;o00000oooool01?l0003oooooooooool0000Qoooo
o`03o`000?oooooooooo00Cooooo00Co0000oooooooooooo00008_ooool00ol0003oooooooooo`03
ooooo`04o`000?ooooooooooo`0000?ooooo000?ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool00oooool2o`0000Cooooo0_l0000Mooooo`?o00001?ooool2o`0002?ooooo0ol00004
ooooo`;o00009_ooool00ol0003oooooooooo`02ooooo`;o00008_ooool5o`0000?ooooo0_l0000T
ooooo`;o00001?ooool2o`0000Cooooo000?ooooo`03o`000?oooooooooo037ooooo0_l0003Koooo
o`003oooool00ol0003oooooooooo`0fooooo`;o0000e_ooool000oooooo00?o0000ooooooooool0
=_ooool2o`000=Kooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000
ooooooooool0>_ooool2o`000=;ooooo0008oooooooo00006Ol0000000oooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01Oooool000oooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool01Oooool000oooooo00?o0000ooooooooool0oooo
ool?ooooo`003oooool00ol0003oooooooooo`0oooooo`;o0000cOooool000oooooo00?o0000oooo
ooooool0?oooool2o`000<gooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo
00?o0000ooooooooool0G_ooool2o`000:kooooo000?ooooo`;o0000Goooool2o`000:kooooo000?
ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0POooool2o`00
08_ooooo000?ooooo`03o`000?oooooooooo087ooooo0_l0002;ooooo`003oooool00ol0003ooooo
ooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo08Gooooo0_l00027ooooo`003oooool0
0ol0003oooooooooo`25ooooo`;o0000Qoooool000oooooo00?o0000ooooooooool0ooooool?oooo
o`003oooool2o`0008_ooooo0_l00022ooooo`003oooool00ol0003oooooooooo`2:ooooo`;o0000
P_ooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`2C
ooooo`;o0000NOooool000oooooo00?o0000ooooooooool0Toooool2o`0007Wooooo000?ooooo`03
o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0Uoooool2o`0007Gooooo
000?ooooo`03o`000?oooooooooo09Oooooo0_l0001eooooo`003oooool2o`000?oooooo4?ooool0
00oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`2Kooooo`;o
0000LOooool000oooooo00?o0000ooooooooool0Voooool2o`00077ooooo000?ooooo`03o`000?oo
oooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0
003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0;[ooooo0_l0001Booooo`00
3oooool2o`000;_ooooo0_l0001Booooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?
ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0i_ooool2o`00
02Kooooo000?ooooo`03o`000?oooooooooo0>Kooooo0_l0000Vooooo`003oooool00ol0003ooooo
ooooo`3oooooo`oooooo0007ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`oooooo0008
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0ooooool?ooooo`002?ooool00ol0
003oooooooooo`04ooooo`?o0000joooool2o`00027ooooo0008ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0joooool2o`00027ooooo0008ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool0ooooool?ooooo`001oooool2o`0000Kooooo00?o0000ooooooooool0oooo
ool?ooooo`002?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo3oooool0
00oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oo
oooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo0_l0003iooooo`;o00005?oo
ool000oooooo00?o0000ooooooooool0n?ooool2o`0001Cooooo000?ooooo`03o`000?oooooooooo
0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003ooooo
ooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000
ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`;o
0000ooooool@ooooo`003oooool00ol0003oooooooooo`3looooo`;o00001oooool2o`0000Oooooo
000?ooooo`03o`000?oooooooooo0?cooooo0_l00007ooooo`;o00001oooool000oooooo00?o0000
ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03
o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`00oooo
oolQooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-3.50581, -2.78757, \
0.226502, 0.0248443}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\[Beta]\&^ = \[Beta] /. \[Beta]hat\), "\[IndentingNewLine]", 
    \(stdErr\[Beta]\)}], "Input"],

Cell[BoxData[
    \({0.09423088365243491`, 
      0.9513071025607879`, \(-0.0067029002247708655`\)}\)], "Output"],

Cell[BoxData[
    \({0.022926128552679333`, 0.26015229299237913`, 
      0.0337406797200138`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(zScores = \(stdVar = \[Beta]\&^/stdErr\[Beta]\)\)], "Input"],

Cell[BoxData[
    \({4.110196077628743`, 
      3.656731569106928`, \(-0.19865931215354082`\)}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(\[Alpha]lpha = 0.05;\)\), "\n", 
    \(\(q = 
        Quantile[NormalDistribution[0, 1], 1 - \[Alpha]lpha/2];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(pValues = 
      Map[2\ \((1 - \ CDF[NormalDistribution[0, 1], Abs[#]])\) &, 
        zScores]\)], "Input"],

Cell[BoxData[
    \({0.00003953232868036949`, 0.00025545164099893825`, 
      0.8425292537701634`}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " 95% Confidence Interval for ",
  Cell[BoxData[
      \(\[Beta]\&^\)]],
  " "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ci95 = 
      Transpose[{\[Beta]\&^ - q\ stdErr\[Beta], \[Beta]\&^ + 
            q\ stdErr\[Beta]}]\)], "Input"],

Cell[BoxData[
    \({{0.04929649738424803`, 0.13916526992062178`}, {0.44141797780021297`, 
        1.4611962273213628`}, {\(-0.07283341728989891`\), 
        0.059427616840357175`}}\)], "Output"]
}, Open  ]],

Cell["Significance Test", "BulletedList"],

Cell["\<\
Log partial likelihood ratio test can be used to test the full \
model against reduced models.  The basic test is full model vs no covariates.\
\
\>", "Text"],

Cell[BoxData[{
    \(\(\[Lambda] = 
        2\ \((maxLogL\[Beta] - 
              valuelogL\[Beta]0)\);\)\), "\[IndentingNewLine]", 
    \(\(note1 = \*"\"\<Probability \[Beta] > \!\(\[Beta]\&^\) given Ho: \
coefficients are simultaneously zero: \>\"" <> 
          numberForm[
            pTest = \((1 - 
                  CDF[ChiSquareDistribution[
                      Length[\[Beta]]], \[Lambda]])\)];\)\), "\
\[IndentingNewLine]", 
    \(\(note2 = 
        If[pTest \[LessEqual] 
            0.05, "\<Reject Ho: \[Beta] = 0\>", "\<Accept Ho: \[Beta] = \
0\>"];\)\)}], "Input",
  ShowSelection->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Table of Estimated Coefficients and Confidence Intervals", \
"Subsubsection",
  ShowSelection->True,
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(tableTitle = "\<\nProportional Hazards Model Solution of Estimated \
Coefficients\>";\)\), "\n", 
    \(\(\(tableColumnLabels = {"\<Variable \>", "\<Coefficent\>", "\< Std \
Error \>", "\< z \>", "\< P >|z| \>", "\< 95% CI\>"};\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(blankRow = setshowTableOpts[Length[tableColumnLabels]];\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(showData = 
        numberForm[
          Transpose[{\[Beta]nameList, \[Beta] /. \[Beta]hat, stdErr\[Beta], 
              zScores, pValues, ci95}]];\)\), "\[IndentingNewLine]", 
    \(\(tableData = Join[{tableColumnLabels}, showData];\)\), "\n", 
    \(\(notes = {note1, note2};\)\), "\[IndentingNewLine]", 
    \(showTable[tableTitle, tableData, notes, 
      ColumnSpacings \[Rule] {4, 3, 3, 3, 3, 5}]\)}], "Input",
  ShowCellBracket->True,
  ShowSelection->True,
  ShowClosedCellArea->False],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            StyleBox[\(\(\n\)\(Proportional\ Hazards\ Model\ Solution\ of\ \
Estimated\ Coefficients\)\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Variable\)\(\ \)\), 
                    "Coefficent", \(\(\ \)\(\(Std\)\(\ \)\(Error\)\(\ \)\)\), \
\(\(\ \)\(z\)\(\ \)\), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\ \
\)\)\), \(\(\ \)\(95  %\ CI\)\)},
                  {"\[CapitalDelta]Age", "0.094", "0.023", 
                    "4.11", \(\(<\)\(.001\)\), \({"0.049", "0.139"}\)},
                  {"Drug", "0.951", "0.26", 
                    "3.657", \(\(<\)\(.001\)\), \({"0.441", "1.461"}\)},
                  {
                    "\[CapitalDelta]Age\[EmptyVerySmallSquare]Drug", \(-0.007\
\), "0.034", \(-0.199\), "0.843", \({"-0.073", "0.059"}\)}
                  },
                RowSpacings->3,
                ColumnSpacings->{4, 3, 3, 3, 3, 5},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            
            StyleBox[\(\(\n\)\(Probability\ \[Beta]\  > \ \[Beta]\&^\ given\ \
\(Ho : \ coefficients\ are\ simultaneously\ \(zero : \ \(\(<\)\(.001\)\)\)\)\n
              
              Reject\ \(Ho : \ \[Beta]\)\  = \ 0\)\),
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Output", "Subsubsection"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            StyleBox[\(\(\n\)\(Proportional\ Hazards\ Model\ Solution\ of\ \
Estimated\ Coefficients\)\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Variable\)\(\ \)\), 
                    "Coefficent", \(\(\ \)\(\(Std\)\(\ \)\(Error\)\(\ \)\)\), \
\(\(\ \)\(z\)\(\ \)\), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\ \
\)\)\), \(\(\ \)\(95  %\ CI\)\)},
                  {"\[CapitalDelta]Age", "0.094", "0.023", 
                    "4.11", \(\(<\)\(.001\)\), \({"0.049", "0.139"}\)},
                  {"Drug", "0.951", "0.26", 
                    "3.657", \(\(<\)\(.001\)\), \({"0.441", "1.461"}\)},
                  {
                    "\[CapitalDelta]Age\[EmptyVerySmallSquare]Drug", \(-0.007\
\), "0.034", \(-0.199\), "0.843", \({"-0.073", "0.059"}\)}
                  },
                RowSpacings->3,
                ColumnSpacings->{4, 3, 3, 3, 3, 5},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            
            StyleBox[\(\(\n\)\(Probability\ \[Beta]\  > \ \[Beta]\&^\ given\ \
\(Ho : \ coefficients\ are\ simultaneously\ \(zero : \ \(\(<\)\(.001\)\)\)\)\n
              
              Reject\ \(Ho : \ \[Beta]\)\  = \ 0\)\),
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Survival Functions", "Subsection"],

Cell[BoxData[
    \(\(survivor[covariates : {_?NumberQ .. }] := 
        s0 /. {x_, s0value_} \[Rule] {x, 
              s0value\^\(\[ExponentialE]\^\(covariates . \
\[Beta]\&^\)\)};\)\)], "Input"],

Cell[BoxData[
    \(drugSelectData[x_?booleanQ] := 
      Cases[inputData, 
        y_ /; MatchQ[covariatesf[y], {_, Boole[x], _}]]\)], "Input"],

Cell[BoxData[{
    \(\(nondrugTimes = 
        Map[timef, drugSelectData[False]];\)\), "\[IndentingNewLine]", 
    \(\(maxNonDrugPt = {Max[nondrugTimes], 0};\)\), "\[IndentingNewLine]", 
    \(\(drugTimes = 
        Map[timef, drugSelectData[True]];\)\), "\[IndentingNewLine]", 
    \(\(maxDrugPt = {Max[drugTimes], 0};\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(restrictedS0 = 
      Select[s0, 
        MemberQ[nondrugTimes, 
            IntegerPart[#\[LeftDoubleBracket]1\[RightDoubleBracket]]] &]\), "\
\[IndentingNewLine]", 
    \(restrictedS1 = 
      Select[survivor[{0, 1, 0}], 
        MemberQ[drugTimes, 
            IntegerPart[#\[LeftDoubleBracket]1\[RightDoubleBracket]]] &]\)}], \
"Input"],

Cell[BoxData[
    \({{1, 0.9300076119358703`}, {2, 0.9026813867185031`}, {3, 
        0.8364564048891302`}, {4, 0.803887120324064`}, {5, 
        0.7370706262424752`}, {6, 0.7157594492142542`}, {7, 
        0.6441701903554706`}, {8, 0.5869350996473027`}, {9, 
        0.5425858203237234`}, {10, 0.49794658914813056`}, {11, 
        0.4506751192391298`}, {12, 0.41676547550280607`}, {13, 
        0.3943488481048337`}, {14, 0.3717379628668512`}, {15, 
        0.3258854988323208`}, {22, 0.3003919219649163`}, {30, 
        0.2738164028662396`}, {31, 0.24782003848215858`}, {32, 
        0.2220669978712959`}, {34, 0.19628961075133397`}, {35, 
        0.17065452100988848`}, {36, 0.1427908676022349`}, {43, 
        0.11385804227868156`}, {53, 0.08721321081518812`}, {54, 
        0.06367362908285681`}, {57, 0.03588358835771294`}, {58, 
        0.014435703209704326`}, {60, 0.014435703209704326`}}\)], "Output"],

Cell[BoxData[
    \({{1, 0.8287216186506895`}, {2, 0.7671401485928263`}, {3, 
        0.6297941518147141`}, {4, 0.5682524909757706`}, {5, 
        0.45390913871137323`}, {6, 0.4207059795838183`}, {7, 
        0.32024702789284637`}, {8, 0.25168568287782067`}, {9, 
        0.20535933683043958`}, {10, 0.16442899986245135`}, {11, 
        0.1270050789576835`}, {12, 0.10372056238360504`}, {15, 
        0.05486315093843538`}}\)], "Output"]
}, Open  ]],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Block[{$DisplayFunction = Identity}, 
        survPlot0 = 
          ListPlot[addLastPt[restrictedS0, maxNonDrugPt], 
            PlotJoined \[Rule] True, 
            PlotStyle \[Rule] {AbsolutePointSize[3], 
                Blue}]; \[IndentingNewLine]survPlot1 = 
          ListPlot[addLastPt[restrictedS1, maxDrugPt], 
            PlotJoined \[Rule] True, 
            PlotStyle \[Rule] {AbsolutePointSize[3], 
                Red}]; \[IndentingNewLine]kmPlot = 
          ListPlot[addLastPt[kmData, maxKMdata]];];\)\), "\n", 
    \(\(Show[kmPlot, survPlot0, survPlot1];\)\)}], "Input",
  CellOpen->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.015873 0.0147151 0.588604 [
[.18254 .00222 -6 -9 ]
[.18254 .00222 6 0 ]
[.34127 .00222 -6 -9 ]
[.34127 .00222 6 0 ]
[.5 .00222 -6 -9 ]
[.5 .00222 6 0 ]
[.65873 .00222 -6 -9 ]
[.65873 .00222 6 0 ]
[.81746 .00222 -6 -9 ]
[.81746 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .01472 m
.18254 .02097 L
s
[(10)] .18254 .00222 0 1 Mshowa
.34127 .01472 m
.34127 .02097 L
s
[(20)] .34127 .00222 0 1 Mshowa
.5 .01472 m
.5 .02097 L
s
[(30)] .5 .00222 0 1 Mshowa
.65873 .01472 m
.65873 .02097 L
s
[(40)] .65873 .00222 0 1 Mshowa
.81746 .01472 m
.81746 .02097 L
s
[(50)] .81746 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(60)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.05556 .01472 m
.05556 .01847 L
s
.0873 .01472 m
.0873 .01847 L
s
.11905 .01472 m
.11905 .01847 L
s
.15079 .01472 m
.15079 .01847 L
s
.21429 .01472 m
.21429 .01847 L
s
.24603 .01472 m
.24603 .01847 L
s
.27778 .01472 m
.27778 .01847 L
s
.30952 .01472 m
.30952 .01847 L
s
.37302 .01472 m
.37302 .01847 L
s
.40476 .01472 m
.40476 .01847 L
s
.43651 .01472 m
.43651 .01847 L
s
.46825 .01472 m
.46825 .01847 L
s
.53175 .01472 m
.53175 .01847 L
s
.56349 .01472 m
.56349 .01847 L
s
.59524 .01472 m
.59524 .01847 L
s
.62698 .01472 m
.62698 .01847 L
s
.69048 .01472 m
.69048 .01847 L
s
.72222 .01472 m
.72222 .01847 L
s
.75397 .01472 m
.75397 .01847 L
s
.78571 .01472 m
.78571 .01847 L
s
.84921 .01472 m
.84921 .01847 L
s
.88095 .01472 m
.88095 .01847 L
s
.9127 .01472 m
.9127 .01847 L
s
.94444 .01472 m
.94444 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.03968 .51503 Mdot
.05556 .48489 Mdot
.07143 .42048 Mdot
.0873 .39387 Mdot
.10317 .34648 Mdot
.11905 .33294 Mdot
.13492 .29143 Mdot
.15079 .26305 Mdot
.16667 .24176 Mdot
.18254 .22048 Mdot
.19841 .19843 Mdot
.21429 .18373 Mdot
.23016 .17569 Mdot
.24603 .16764 Mdot
.2619 .15154 Mdot
.37302 .14299 Mdot
.5 .13383 Mdot
.51587 .12466 Mdot
.53175 .1155 Mdot
.56349 .10634 Mdot
.57937 .09718 Mdot
.59524 .08801 Mdot
.70635 .07885 Mdot
.86508 .06969 Mdot
.88095 .06053 Mdot
.92857 .04907 Mdot
.94444 .03762 Mdot
.97619 .03762 Mdot
0 0 1 r
.5 Mabswid
.03968 .56212 m
.05556 .54604 L
.07143 .50706 L
.0873 .48789 L
.10317 .44856 L
.11905 .43601 L
.13492 .39388 L
.15079 .36019 L
.16667 .33408 L
.18254 .30781 L
.19841 .27998 L
.21429 .26002 L
.23016 .24683 L
.24603 .23352 L
.2619 .20653 L
.37302 .19153 L
.5 .17588 L
.51587 .16058 L
.53175 .14542 L
.56349 .13025 L
.57937 .11516 L
.59524 .09876 L
.70635 .08173 L
.86508 .06605 L
.88095 .05219 L
.92857 .03584 L
.94444 .02321 L
.97619 .02321 L
s
1 0 0 r
.03968 .5025 m
.05556 .46626 L
.07143 .38541 L
.0873 .34919 L
.10317 .28189 L
.11905 .26234 L
.13492 .20321 L
.15079 .16286 L
.16667 .13559 L
.18254 .1115 L
.19841 .08947 L
.21429 .07577 L
.2619 .04701 L
.9127 .04701 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00>oooool3o`0000Cooooo0_l0000Qooooo`Go00000oooool2o`0002;ooooo0ol00004oooo
o`;o00009?ooool3o`0000?ooooo0_l0000Rooooo`?o00001?ooool2o`0002;ooooo0ol00004oooo
o`;o00001?ooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Qoooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00009?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool07_ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000
oooooooooooo00008?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000oooool003cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Rooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo00009?ooool01?l0003oooooooooool00002
ooooo`03o`000?oooooooooo01oooooo1Ol00002ooooo`04o`000?ooooooooooo`0002Cooooo00Co
0000oooooooooooo00000_ooool00ol0003oooooooooo`0Nooooo`05o`000?ooooooooooooooool0
00000_ooool01?l0003oooooooooool00003ooooo`00??ooool00ol0003oooooooooo`02ooooo`04
o`000?ooooooooooo`0002?ooooo00Go0000ooooooooooooooooo`000002ooooo`03o`000?oooooo
oooo023ooooo0_l00003ooooo`04o`000?ooooooooooo`00027ooooo00Co0000oooooooooooo0000
0oooool01?l0003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool07_ooool4o`0000?ooooo00Co0000oooooooooooo00000oooool003cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool0000Pooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool0000Tooooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooooooo
ool08?ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`00023ooooo1?l00003oooo
o`04o`000?ooooooooooo`00023ooooo00?o0000ooooooooool01?ooool01?l0003oooooooooool0
0003ooooo`00>oooool2o`0000Cooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooo
oooooooo000000;ooooo00Co0000oooooooooooo00008?ooool01Ol0003ooooooooooooooooo0000
00;ooooo00Co0000oooooooooooo00008oooool2o`0000?ooooo00Co0000oooooooooooo00008?oo
ool00ol0003oooooooooo`04ooooo`04o`000?ooooooooooo`00027ooooo00?o0000ooooooooool0
0oooool01?l0003oooooooooool00003ooooo`00??ooool00ol0003oooooooooo`03ooooo`;o0000
8_ooool3o`0000Cooooo0_l0000Rooooo`?o00001?ooool2o`0002Gooooo00?o0000ooooooooool0
0_ooool2o`00027ooooo1Ol00003ooooo`;o00008oooool2o`0000Cooooo0_l00004ooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool0
01Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000?oooooooo00004Ol00001ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`05ooooo`005Oooool0
0ol0003oooooooooo`0Xooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo02Sooooo00?o0000ooooooooool07oooool:
o`00o`Oooooo000Eooooo`03o`000?oooooooooo0?Kooooo00?o003oooooooooool03oooool001Go
oooo00?o0000ooooooooool0mOooool00ol00?ooooooooooo`0@ooooo`005Oooool00ol0003ooooo
ooooo`3dooooo`03o`00oooooooooooo017ooooo000Eooooo`03o`000?oooooooooo0?7ooooo0ol0
0?l3ooooo`;o00001_ooool2o`0000Oooooo000Eooooo`03o`000?oooooooooo0>kooooo0ol00?l6
ooooo`;o00001_ooool2o`0000Oooooo000Eooooo`;o0000k?ooool3o`00oa[ooooo000Eooooo`03
o`000?oooooooooo03gooooo/ooo0002ooooo`;o00005?ooool001Gooooo00?o0000ooooooooool0
??ooool00ooo003oooooooooo`2Wooooo`;o003o2_ooool2o`0001Cooooo000Eooooo`03o`000?oo
oooooooo03[ooooo0_oo002Yooooo`03o`00oooooooooooo023ooooo000Eooooo`03o`000?oooooo
oooo03Sooooo0_oo002Zooooo`03o`00ool0003o0000027ooooo000Eooooo`03o`000?oooooooooo
03Oooooo00?oo`00ooooooooool0ZOooool01?l00?ooooooo`000?l0000Qooooo`005Oooool00ol0
003oooooooooo`0eooooo`;oo`00Y_ooool6o`00obGooooo000Eooooo`03o`000?oooooooooo03?o
oooo0_oo002Mooooo`_o003o1?ooool2o`0002Gooooo000Eooooo`;o0000<oooool00ooo003ooooo
ooooo`2Booooo`_o003o=_ooool001Gooooo00?o0000ooooooooool0<?ooool2ool008Cooooo0_l0
0004ooooo`_o003o@Oooool001Gooooo00?o0000ooooooooool0;_ooool2ool008Cooooo2?l00?m<
ooooo`005Oooool00ol0003oooooooooo`0]ooooo`03ool00?oooooooooo06Sooooo0_l0000Doooo
o`Ko003oE?ooool001Gooooo00?o0000ooooooooool0;?ooool00ooo003oooooooooo`1Yooooo`;o
00003Oooool7o`00oe[ooooo000Eooooo`03o`000?oooooooooo02cooooo00?oo`00ooooooooool0
L_ooool6o`00of7ooooo000Eooooo`03o`000?oooooooooo02_ooooo00?oo`00ooooooooool0IOoo
ool2o`0000Kooooo1_l00?mWooooo`005Oooool00ol0003oooooooooo`0Zooooo`03ool00?oooooo
oooo06Kooooo0_l00003ooooo`?o003oKOooool001Gooooo0_l0000[ooooo`03ool00?oooooooooo
06;ooooo0_l00006ooooo`03o`00oooooooooooo06kooooo000Eooooo`03o`000?oooooooooo02Wo
oooo00?oo`00ooooooooool0Hoooool2o`0000Gooooo00?o003oooooooooool0Koooool001Gooooo
00?o0000ooooooooool0:?ooool00ooo003oooooooooo`1Zooooo`03o`00oooooooooooo073ooooo
000Eooooo`03o`000?oooooooooo02Sooooo00?oo`00ooooooooool0G?ooool2o`0000_ooooo00?o
003oooooooooool0LOooool001Gooooo00?o0000ooooooooool09oooool00ooo003oooooooooo`1M
ooooo`;o00002_ooool00ol00?ooooooooooo`1booooo`000_ooool2o`0000Cooooo00Co0000oooo
oooooooooooo1Ol00004ooooo`03o`000?oooooooooo02Oooooo00?oo`00ooooooooool0F?ooool2
o`0000kooooo00?o003oooooooooool0Loooool00005ooooool0003oooooooooool000002?ooool0
1?l0003oooooooooool00004ooooo`03o`000?oooooooooo02Kooooo00?oo`00ooooooooool0FOoo
ool2o`0000gooooo00?o003oooooooooool0M?ooool00005ooooool0003oooooooooool000002Ooo
ool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02Gooooo00?oo`00ooooooooool0Iooo
ool2o`00ogOooooo00001Ooooooo0000oooooooooooo000000[ooooo00?o0000ooooooooool00ooo
ool3o`0002Gooooo00?oo`00ooooooooool0E_ooool2o`0000gooooo0_l00?miooooo`0000Gooooo
o`000?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`0Tooooo`03ool00?oooooooooo05Oooooo0_l0000:ooooo`?o003oNoooool00005ooooool0
003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooooooo
ool09?ooool00ooo003oooooooooo`0dooooo`;o0000:oooool2o`00ogkooooo0002ooooo`;o0000
2Oooool3o`0000Gooooo00?o0000ooooooooool08oooool00ooo003oooooooooo`0eooooo`;o0000
:_ooool00ol00?ooooooooooo`1nooooo`005Oooool00ol0003oooooooooo`0Sooooo`03ool00?oo
oooooooo067ooooo00?o003oooooooooool0O_ooool001Gooooo00?o0000ooooooooool08_ooool0
0ooo003oooooooooo`0Hooooo`;o0000Aoooool00ol00?ooooooooooo`1oooooo`005Oooool00ol0
003oooooooooo`0Qooooo`03ool00?oooooooooo01Wooooo0_l00016ooooo`03o`00oooooooooooo
083ooooo000Eooooo`03o`000?oooooooooo027ooooo00?oo`00ooooooooool0H?ooool00ol00?oo
ooooooooo`21ooooo`005Oooool2o`00027ooooo00?oo`00ooooooooool0Goooool2o`00ohCooooo
000Eooooo`03o`000?oooooooooo023ooooo00?oo`00ooooooooool05_ooool2o`0004Kooooo00?o
003oooooooooool0Q?ooool001Gooooo00?o0000ooooooooool07oooool00ooo003oooooooooo`0G
ooooo`;o0000AOooool00ol00?ooooooooooo`25ooooo`005Oooool00ol0003oooooooooo`0Ooooo
o`03ool00?oooooooooo01?ooooo0_l00018ooooo`03o`00oooooooooooo08Kooooo000Eooooo`03
o`000?oooooooooo01kooooo00?oo`00ooooooooool05?ooool2o`0004?ooooo1Ol00?n9ooooo`00
5Oooool00ol0003oooooooooo`0Nooooo`03ool00?oooooooooo00oooooo0_l0000oooooo`Wo003o
S_ooool001Gooooo00?o0000ooooooooool07Oooool00ooo003oooooooooo`0@ooooo`;o0000=ooo
ool8o`00oiOooooo000Eooooo`03o`000?oooooooooo01gooooo00?oo`00ooooooooool0@?ooool9
o`00oioooooo000Eooooo`;o00007_ooool00ooo003oooooooooo`0hooooo`So003oZ?ooool001Go
oooo00?o0000ooooooooool07?ooool00ooo003oooooooooo`0=ooooo`;o00008oooool7o`00ok3o
oooo000Eooooo`03o`000?oooooooooo01cooooo00?oo`00ooooooooool03Oooool2o`0001_ooooo
2?l00?ngooooo`005Oooool00ol0003oooooooooo`0Kooooo`03ool00?oooooooooo02Cooooo1ol0
0?noooooo`005Oooool00ol0003oooooooooo`0Kooooo`03ool00?oooooooooo023ooooo1?l00?o6
ooooo`005Oooool00ol0003oooooooooo`0Kooooo`03ool00?oooooooooo023ooooo00?o003ooooo
ooooool0aoooool001Gooooo00?o0000ooooooooool06_ooool00ooo003oooooooooo`0Pooooo`03
o`00oooooooooooo0<Sooooo000Eooooo`03o`000?oooooooooo01[ooooo00?oo`00ooooooooool0
2oooool2o`0001;ooooo00?o003oooooooooool0bOooool001Gooooo0_l0000Kooooo`03ool00?oo
oooooooo00_ooooo0_l0000Aooooo`03o`00oooooooooooo0<[ooooo000Eooooo`03o`000?oooooo
oooo01[ooooo00?oo`00ooooooooool07_ooool00ol00?ooooooooooo`3:ooooo`005Oooool00ol0
003oooooooooo`0Iooooo`03ool00?oooooooooo01kooooo00?o003oooooooooool0boooool001Go
oooo00?o0000ooooooooool06Oooool00ooo003oooooooooo`0Mooooo`03o`00oooooooooooo0<co
oooo000Eooooo`03o`000?oooooooooo01Wooooo00?oo`00ooooooooool07?ooool00ol00?oooooo
ooooo`3=ooooo`000_ooool2o`0000Cooooo00?o0000ooooooooool00oooool3o`0000Cooooo00?o
0000ooooooooool06Oooool00ooo003oooooooooo`07ooooo`;o00004_ooool00ol00?oooooooooo
o`3>ooooo`0000Goooooo`000?ooooooooooo`00000:ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool06?ooool00ooo003oooooooooo`08ooooo`;o00004Oooool00ol00?oooooooooo
o`3?ooooo`0000Goooooo`000?ooooooooooo`000007ooooo`Go00001?ooool00ol0003ooooooooo
o`0Hooooo`03ool00?oooooooooo01[ooooo00?o003oooooooooool0d?ooool00005ooooool0003o
ooooooooool000001oooool01?l0003oooooooooool00005ooooo`?o00006?ooool00ooo003ooooo
ooooo`0Iooooo`03o`00oooooooooooo0=7ooooo00001Ooooooo0000oooooooooooo000000Sooooo
00?o0000ooooool000001Oooool00ol0003oooooooooo`0Hooooo`03ool00?oooooooooo01Sooooo
00?o003oooooooooool0d_ooool00005ooooool0003oooooooooool000002Oooool2o`0000Gooooo
00?o0000ooooooooool05oooool00ooo003oooooooooo`0Hooooo`03o`00oooooooooooo0=?ooooo
0002ooooo`;o00002oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Oooooo00?o
o`00ooooooooool01Oooool2o`00013ooooo00?o003oooooooooool0e?ooool001Gooooo00?o0000
ooooooooool05oooool00ooo003oooooooooo`05ooooo`;o00003oooool00ol00?ooooooooooo`3E
ooooo`005Oooool00ol0003oooooooooo`0Fooooo`03ool00?oooooooooo01Kooooo00?o003ooooo
ooooool0e_ooool001Gooooo00?o0000ooooooooool05Oooool00ooo003oooooooooo`0Fooooo`03
o`00oooooooooooo0=Oooooo000Eooooo`03o`000?oooooooooo01Gooooo00?oo`00ooooooooool0
5Oooool00ol00?ooooooooooo`3Hooooo`005Oooool2o`0001Gooooo00?oo`00ooooooooool05Ooo
ool00ol00?ooooooooooo`3Iooooo`005Oooool00ol0003oooooooooo`0Cooooo`03ool00?oooooo
oooo01Kooooo00?o003oooooooooool0fOooool001Gooooo00?o0000ooooooooool04oooool00ooo
003oooooooooo`0Eooooo`03o`00oooooooooooo0=[ooooo000Eooooo`03o`000?oooooooooo01?o
oooo00?oo`00ooooooooool01Oooool2o`0000kooooo00?o003oooooooooool0f_ooool001Gooooo
00?o0000ooooooooool04_ooool00ooo003oooooooooo`06ooooo`;o00003Oooool00ol00?oooooo
ooooo`3Kooooo`005Oooool00ol0003oooooooooo`0Booooo`03ool00?oooooooooo01Gooooo00?o
003oooooooooool0foooool001Gooooo00?o0000ooooooooool04_ooool00ooo003oooooooooo`0D
ooooo`03o`00oooooooooooo0=cooooo000Eooooo`03o`000?oooooooooo017ooooo00?oo`00oooo
ooooool05Oooool00ol00?ooooooooooo`3Looooo`005Oooool2o`0001;ooooo00?oo`00oooooooo
ool05?ooool00ol00?ooooooooooo`3Mooooo`005Oooool00ol0003oooooooooo`0Aooooo`03ool0
0?oooooooooo01Cooooo00?o003oooooooooool0gOooool001Gooooo00?o0000ooooooooool04Ooo
ool00ooo003oooooooooo`0Cooooo`03o`00oooooooooooo0=kooooo000Eooooo`03o`000?oooooo
oooo013ooooo00?oo`00ooooooooool05?ooool00ol00?ooooooooooo`3Nooooo`005Oooool00ol0
003oooooooooo`0@ooooo`03ool00?oooooooooo01?ooooo00?o003oooooooooool0goooool001Go
oooo00?o0000ooooooooool04?ooool00ooo003oooooooooo`0Booooo`03o`00oooooooooooo0>3o
oooo000Eooooo`03o`000?oooooooooo013ooooo00?oo`00ooooooooool00oooool2o`0000gooooo
00?o003oooooooooool0h?ooool001Gooooo00?o0000ooooooooool03oooool00ooo003ooooooooo
o`04ooooo`;o00003?ooool00ol00?ooooooooooo`3Qooooo`005Oooool2o`00013ooooo00?oo`00
ooooooooool04_ooool00ol00?ooooooooooo`3Qooooo`005Oooool00ol0003oooooooooo`0?oooo
o`03ool00?oooooooooo017ooooo00?o003oooooooooool0h_ooool001Gooooo00?o0000oooooooo
ool03_ooool01?oo003oooooooooooooool2o`0000oooooo00?o003oooooooooool0h_ooool001Go
oooo00?o0000ooooooooool03_ooool01?oo003oooooooooooooool2o`0000kooooo00?o003ooooo
ooooool0hoooool001Gooooo00?o0000ooooooooool03_ooool00ooo003oooooooooo`0@ooooo`03
o`00oooooooooooo0>Cooooo0002ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o0000
1Oooool00ol0003oooooooooo`0=ooooo`03ool00?oooooooooo017ooooo00?o003oooooooooool0
i?ooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool03Oooool00ooo003oooooooooo`0@ooooo`03o`00oooooooooooo0>Go
oooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo00gooooo00?oo`00ooooooooool04?ooool00ol00?ooooooooooo`3Uoooo
o`0000Goooooo`000?ooooooooooo`000007ooooo`Co00001Oooool3o`0000cooooo00?oo`00oooo
ooooool04?ooool00ol00?ooooooooooo`3Vooooo`0000Goooooo`000?ooooooooooo`000007oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03?ooool00ooo003oooooooooo`0@oooo
o`03o`00oooooooooooo0>Kooooo00001Ooooooo0000oooooooooooo000000Sooooo00?o0000oooo
ooooool01Oooool00ol0003oooooooooo`0;ooooo`03ool00?oooooooooo013ooooo00?o003ooooo
ooooool0ioooool000;ooooo0_l0000:ooooo`;o00001Oooool00ol0003oooooooooo`0;ooooo`03
ool00?oooooooooo00oooooo00?o003oooooooooool0j?ooool001Gooooo00?o0000ooooooooool0
2oooool00ooo003oooooooooo`0?ooooo`03o`00oooooooooooo0>Sooooo000Eooooo`03o`000?oo
oooooooo00[ooooo00?oo`00ooooooooool03oooool00ol00?ooooooooooo`3Yooooo`005Oooool0
0ol0003oooooooooo`0:ooooo`03ool00?oooooooooo00oooooo00?o003oooooooooool0jOooool0
01Gooooo00?o0000ooooooooool02_ooool01?oo003oooooooooooooool2o`0000_ooooo00?o003o
ooooooooool0j_ooool001Gooooo0_l0000;ooooo`04ool00?ooooooooooooooo`;o00002oooool0
0ol00?ooooooooooo`3Zooooo`005Oooool00ol0003oooooooooo`09ooooo`03ool00?oooooooooo
00kooooo00?o003oooooooooool0joooool001Gooooo00?o0000ooooooooool02Oooool00ooo003o
ooooooooo`0>ooooo`03o`00oooooooooooo0>_ooooo000Eooooo`03o`000?oooooooooo00Wooooo
00?oo`00ooooooooool03_ooool00ol00?ooooooooooo`3[ooooo`005Oooool00ol0003ooooooooo
o`09ooooo`03ool00?oooooooooo00gooooo00?o003oooooooooool0k?ooool001Gooooo00?o0000
ooooooooool02Oooool00ooo003oooooooooo`0=ooooo`03o`00oooooooooooo0>cooooo000Eoooo
o`03o`000?oooooooooo00Sooooo00?oo`00o`000?l000003_ooool00ol00?ooooooooooo`3/oooo
o`005Oooool00ol0003oooooooooo`08ooooo`03ool00?l0003o000000gooooo00?o003ooooooooo
ool0kOooool001Gooooo0_l00009ooooo`03ool00?oooooooooo00gooooo00?o003oooooooooool0
kOooool001Gooooo00?o0000ooooooooool02?ooool00ooo003oooooooooo`0=ooooo`03o`00oooo
oooooooo0>gooooo000Eooooo`03o`000?oooooooooo00Sooooo00?oo`00ooooooooool03?ooool0
0ol00?ooooooooooo`3^ooooo`005Oooool00ol0003oooooooooo`08ooooo`03ool00?oooooooooo
00_ooooo0_l00?o`ooooo`005Oooool00ol0003oooooooooo`07ooooo`03ool00?oooooooooo00_o
oooo00?o003oooooooooool0l?ooool001Gooooo00?o0000ooooooooool01oooool00ooo003ooooo
ooooo`0:ooooo`03o`00oooooooooooo0?7ooooo000Eooooo`03o`000?oooooooooo00Oooooo00?o
o`00ooooooooool02Oooool00ol00?ooooooooooo`3booooo`005Oooool00ol0003oooooooooo`07
ooooo`03ool00?oooooooooo00Wooooo00?o003oooooooooool0l_ooool001Gooooo0_l00008oooo
o`03ool00?oooooooooo00Sooooo00?o003oooooooooool0loooool001Gooooo00?o0000oooooooo
ool01_ooool00ooo003oooooooooo`09ooooo`03o`00oooooooooooo0??ooooo000Eooooo`03o`00
0?oooooooooo00Kooooo00?oo`00ooooooooool02?ooool00ol00?ooooooooooo`3dooooo`005Ooo
ool00ol0003oooooooooo`06ooooo`03ool00?oooooooooo00Sooooo00?o003oooooooooool0m?oo
ool001Gooooo00?o0000ooooooooool01_ooool00ooo003oooooooooo`07ooooo`03o`00oooooooo
oooo0?Gooooo0002ooooo`;o00001?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0
003oooooooooo`05ooooo`03ool00?oooooooooo00Sooooo00?o003oooooooooool0mOooool00005
ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool01Oooool00ooo003oooooooooo`08ooooo`03o`00oooooooooooo0?Gooooo00001Ooo
oooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oo
oooooooo00Cooooo00?oo`00o`000?l000002?ooool00ol00?ooooooooooo`3fooooo`0000Gooooo
o`000?ooooooooooo`000008ooooo`?o00001Oooool3o`0000Cooooo00?oo`00o`000?l000002?oo
ool00ol00?ooooooooooo`3fooooo`0000Goooooo`000?ooooooooooo`000007ooooo`05o`000?oo
ooooooooooooool000001?ooool00ol0003oooooooooo`03ooooo`03ool00?oooooooooo00Sooooo
00?o003oooooooooool0moooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooooooool00oooool00ooo003oooooooooo`08ooooo`03
o`00oooooooooooo0?Oooooo0002ooooo`;o00002Oooool3o`0000Gooooo00?o0000ooooooooool0
0_ooool00ooo003oooooooooo`08ooooo`03o`00oooooooooooo0?Sooooo000Eooooo`03o`000?oo
oooooooo00;ooooo00?oo`00ooooooooool01oooool00ol00?ooooooooooo`3iooooo`005Oooool0
1Ol0003oooooooooooooooooo`0000Wooooo00?o003oooooooooool0n_ooool001Gooooo00?o0000
ooooooooool02_ooool00ol00?ooooooooooo`3kooooo`005Oooool00ol0003oooooooooo`0:oooo
o`03o`00oooooooooooo0?_ooooo000Eooooo`;o00000_ooool2o`0000Kooooo00?o003ooooooooo
ool0o?ooool001Gooooo00Co0000oooooooooooooooo0_l00006ooooo`03o`00oooooooooooo0?co
oooo000Eooooo`03o`000?oooooooooo00Wooooo00?o003oooooooooool0o?ooool001Gooooo00?o
0000ooooooooool02?ooool00ol00?ooooooooooo`3mooooo`005Oooool00ol0003oooooooooo`08
ooooo`03o`00oooooooooooo0?gooooo000Eooooo`03o`000?oooooooooo00Oooooo00?o003ooooo
ooooool0o_ooool001Gooooo00?o0000ooooooooool01oooool00ol00?ooooooooooo`3nooooo`00
5Oooool00ol0003oooooooooo`07ooooo`03o`00oooooooooooo0?kooooo000Eooooo`;o00001ooo
ool00ol00?ooooooooooo`3oooooo`005Oooool00ol0003oooooooooo`05ooooo`03o`00oooooooo
oooo0?oooooo0Oooool001Gooooo00?o0000ooooooooool01?ooool00ol00?ooooooooooo`3ooooo
o`;ooooo000Eooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool0ooooool3ooooo`00
5Oooool00ol0003oooooooooo`02ooooo`03o`00oooooooooooo0?oooooo1?ooool001Gooooo00Go
0000ooooooooooooooooo`00o`3oooooo`Oooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_ooool001Go
oooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`003Oooool3o`0000Gooooo00?o0000ooooooooool0ooooool9ooooo`003_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo0?oooooo2Oooool000kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`3oooooo`Wooooo000>ooooo`03o`000?oooooooooo00?ooooo1?l0
003oooooo`Wooooo000>ooooo`03o`000?oooooooooo00?ooooo0_l0003oooooo`_ooooo000=oooo
o`;o00001_ooool00ol0003oooooooooo`3oooooo`Wooooo000>ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo
0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-4.97912, -0.07747, \
0.231708, 0.00624851}}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Kevlar 49 Data set", "Section"],

Cell[TextData[{
  StyleBox["The second problem demonstrated is the Kevlar 49 failure data \
given in Table 4.4 of Crowder, M.J., Kimber, A.C., Smith, R.L., and Sweeting, \
T.J., (1991).  ",
    FontFamily->"Times New Roman"],
  StyleBox["Statistical Analysis of Reliability Data",
    FontFamily->"Times New Roman",
    FontSlant->"Italic"],
  StyleBox[", Chapman & Hall, London, pgs 112-115.",
    FontFamily->"Times New Roman"]
}], "Text"],

Cell["Demonstrates", "Text"],

Cell["Indicator model variables and constructing a phDataPt set", \
"BulletedList"],

Cell["\<\
Establishing a new basis set and solving for the coefficients\
\>", \
"BulletedList"],

Cell["\<\
Testing the Proportional Hazards assumption by constructing a \
stratified model based on a category variable\
\>", "BulletedList"],

Cell[CellGroupData[{

Cell["Read in Data, and Select Model", "Subsection"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[BoxData[
    \(\(filePath = "\</File Organizer/OR Tools/Proportional Hazards \
testing/Table_4.4.txt\>";\)\)], "Input",
  CellOpen->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({titleLine, pattVars, dataFile, fnAbbr, rowForm, vars} = 
        readDataFile[filePath, abbr \[Rule] "\<spool\>"];\)\)], "Input",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    \({"Time", "Failure", "Stress", "Spool"}\)], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("spool\[EmptyVerySmallSquare]rowForm ="\
\[InvisibleSpace]{"number", "number", "number", "number"}\),
      SequenceForm[ 
      "spool\[EmptyVerySmallSquare]rowForm =", {"number", "number", "number", 
        "number"}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("spool\[EmptyVerySmallSquare]patt \
="\[InvisibleSpace]{e1_?NumberQ, e2_?NumberQ, e3_?NumberQ, e4_?NumberQ}\),
      SequenceForm[ "spool\[EmptyVerySmallSquare]patt =", {
        PatternTest[ 
          Pattern[ e1, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e2, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e3, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e4, 
            Blank[ ]], NumberQ]}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("spool\[EmptyVerySmallSquare]vars \
="\[InvisibleSpace]{"spool\[EmptyVerySmallSquare]Time", 
          "spool\[EmptyVerySmallSquare]Failure", 
          "spool\[EmptyVerySmallSquare]Stress", 
          "spool\[EmptyVerySmallSquare]Spool"}\),
      SequenceForm[ 
      "spool\[EmptyVerySmallSquare]vars =", {
        "spool\[EmptyVerySmallSquare]Time", 
        "spool\[EmptyVerySmallSquare]Failure", 
        "spool\[EmptyVerySmallSquare]Stress", 
        "spool\[EmptyVerySmallSquare]Spool"}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[Take[dataFile, {1, 10}]]\)], "Input",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    TagBox[GridBox[{
          {"2.2`", "1", "29.7`", "2"},
          {"4", "1", "29.7`", "7"},
          {"4", "1", "29.7`", "7"},
          {"4.6`", "1", "29.7`", "7"},
          {"6.1`", "1", "29.7`", "7"},
          {"6.7`", "1", "29.7`", "6"},
          {"7.9`", "1", "29.7`", "7"},
          {"8.3`", "1", "29.7`", "5"},
          {"8.5`", "1", "29.7`", "2"},
          {"9.1`", "1", "29.7`", "2"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$]]]], "Output",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[BoxData[
    \(\(setVarsToRules[fnAbbr, vars];\)\)], "Input"],

Cell[BoxData[{
    \(\(timeColumnName = "\<Time\>";\)\), "\n", 
    \(\(censorColumnName = "\<Failure\>";\)\)}], "Input"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell["\<\
Center the variables to ensure the mean is used in the data to find \
the coefficient, especially when large values are found in the data.\
\>", \
"Text",
  CellOpen->False],

Cell["\<\
The covariate names define the model in that main effects and \
interaction effects can be described by the xNames list.  For example {\
\[Alpha]_String,\[Beta]_String,\[Alpha]*\[Beta]_String} where \
\[Alpha],\[Beta] and \[Alpha]*\[Beta] are the column names from the titleLine \
identifying the variables.
Note: Interaction name separator can be any of the following \
{comma,dash,plus,asterisk,or \[EmptyVerySmallSquare]}\
\>", "Text",
  CellOpen->False,
  FontFamily->"Century Schoolbook",
  FontSize->14,
  FontTracking->"Extended"],

Cell[BoxData[
    \(\(covariateNames = {"\<Stress\>", "\<Spool\>"};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({phLayout, {\[Beta], \[Beta]nameList}} = 
        setupPHlayout[titleLine, timeColumnName, censorColumnName, 
          covariateNames, 
          TransformedDataList \[Rule] {"\<Time\>", "\<Stress\>", \
"\<Spool\>"}];\)\), "\n", 
    \(phLayout\), "\n", 
    \(\[Beta]\), "\n", 
    \(\[Beta]nameList\)}], "Input"],

Cell[BoxData[
    \({fx1[e1], e2, {}, {fx3[e3], fx4[e4]}}\)], "Output"],

Cell[BoxData[
    \({\[Beta]1, \[Beta]2}\)], "Output"],

Cell[BoxData[
    \({"fxStress", "fxSpool"}\)], "Output"]
}, Open  ]],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["For any centered variables the corresponding offset \
must be assigned. \nFor any transformed variables the corresponding \
transforming function must be defined.  \nNote that the grouping function can \
also be used to apply transformations on the group name's data.",
  FontSize->14,
  FontColor->RGBColor[1, 0, 0],
  Background->RGBColor[1, 0.879942, 0.832074]]], "Subsection",
  CellOpen->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(meanStress = 
      Mean[dataFile /. spool\[EmptyVerySmallSquare]Stress] // N\)], "Input"],

Cell[BoxData[
    \(27.075000000000006`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(spoolList = 
      Union[dataFile /. 
          spool\[EmptyVerySmallSquare]Spool]\), "\[IndentingNewLine]", 
    \(\(spoolBasis = Most[spoolList];\)\)}], "Input"],

Cell[BoxData[
    \({1, 2, 3, 4, 5, 6, 7, 8}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(fx1[y_] := Log[y\ 1. ];\)\), "\[IndentingNewLine]", 
    \(\(fx3[y_] := Log[y/meanStress];\)\), "\[IndentingNewLine]", 
    \(\(fx4[y_] := Map[If[# \[Equal] y, 1, 0] &, spoolBasis];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(formatInputData = pattVars \[Rule] phLayout\)], "Input"],

Cell[BoxData[
    \({e1_?NumberQ, e2_?NumberQ, e3_?NumberQ, 
        e4_?NumberQ} \[Rule] {Log[1.`\ e1], 
        e2, {}, {Log[0.036934441366574325`\ e3], {If[1 \[Equal] e4, 1, 0], 
            If[2 \[Equal] e4, 1, 0], If[3 \[Equal] e4, 1, 0], 
            If[4 \[Equal] e4, 1, 0], If[5 \[Equal] e4, 1, 0], 
            If[6 \[Equal] e4, 1, 0], If[7 \[Equal] e4, 1, 0]}}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(inputData = 
        Map[make\[Ellipsis]phDataPt, 
          dataFile /. formatInputData];\)\)], "Input"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(First[inputData]\), "\[IndentingNewLine]", 
    \(Last[inputData]\), "\[IndentingNewLine]", 
    \(\(With[{nrXis = Length[covariatesf[First[inputData]]], 
          len\[Beta] = Length[\[Beta]]}, 
        Print[covariatesf[First[inputData]], "\<  has length of \>", 
          nrXis]; \[IndentingNewLine]Print[\[Beta], "\<  has length of \>", 
          len\[Beta]]; \[IndentingNewLine]If[
          nrXis \[NotEqual] 
            len\[Beta], \((StylePrint[
              StyleForm["\<\[Beta]'s must be adjusted\>", 
                FontFamily \[Rule] "\<CopperPlate\>", FontSize \[Rule] 24, 
                FontWeight \[Rule] "\<Bold\>"]]; \[IndentingNewLine]\[Beta] = 
              Map[makeVariable["\<\[Beta]x\>" <> ToString[#]] &, 
                Range[nrXis]])\), \[IndentingNewLine]Print["\<\[Beta]'s are \
OK\>"]]; \[IndentingNewLine]If[
          Length[\[Beta]nameList] \[NotEqual] 
            nrXis, \((StylePrint[
              StyleForm["\<\[Beta]nameList must be adjusted\>", 
                FontFamily \[Rule] "\<CopperPlate\>", FontSize \[Rule] 24, 
                FontWeight \[Rule] "\<Bold\>"]]; \
\[IndentingNewLine]\[Beta]nameList = 
              Map["\<x\>" <> ToString[#] &, 
                Range[nrXis]])\), \[IndentingNewLine]Print["\<\[Beta]nameList \
is OK\>"]]];\)\), "\[IndentingNewLine]", 
    \(\(Print["\<\[Beta] = \>", \[Beta]];\)\), "\[IndentingNewLine]", 
    \(\(Print["\<\[Beta]nameList = \>", \[Beta]nameList];\)\), "\
\[IndentingNewLine]", 
    \(TableForm[Take[inputData, {1, 10}]]\), "\[IndentingNewLine]", 
    \(lastTimePt = {Max[Map[timef, inputData]], 0}\), "\[IndentingNewLine]", 
    \(\(maxKMdata = lastTimePt;\)\)}], "Input",
  CellOpen->False],

Cell[BoxData[
    \(phDataPt[0.7884573603642703`, 
      True, {}, {0.0925362529215994`, 0, 1, 0, 0, 0, 0, 0}]\)], "Output"],

Cell[BoxData[
    \(phDataPt[10.621327345686446`, 
      False, {}, {\(-0.14587477052339873`\), 0, 0, 0, 0, 0, 0, 
        0}]\)], "Output"],

Cell[BoxData[
    InterpretationBox[\({0.0925362529215994`, 0, 1, 0, 0, 0, 0, 
          0}\[InvisibleSpace]"  has length of "\[InvisibleSpace]8\),
      SequenceForm[ {0.092536252921599393, 0, 1, 0, 0, 0, 0, 0}, 
        "  has length of ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\({\[Beta]1, \[Beta]2}\[InvisibleSpace]"  has length of \
"\[InvisibleSpace]2\),
      SequenceForm[ {\[Beta]1, \[Beta]2}, "  has length of ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      StyleBox["\<\"\[Beta]'s must be adjusted\"\>",
        FontFamily->"CopperPlate",
        FontSize->24,
        FontWeight->"Bold"],
      (StyleForm[ #, FontFamily -> "CopperPlate", FontSize -> 24, FontWeight -> 
        "Bold"]&)]], "Output"],

Cell[BoxData[
    TagBox[
      StyleBox["\<\"\[Beta]nameList must be adjusted\"\>",
        FontFamily->"CopperPlate",
        FontSize->24,
        FontWeight->"Bold"],
      (StyleForm[ #, FontFamily -> "CopperPlate", FontSize -> 24, FontWeight -> 
        "Bold"]&)]], "Output"],

Cell[BoxData[
    InterpretationBox[\("\[Beta] = "\[InvisibleSpace]{\[Beta]x1, \[Beta]x2, \
\[Beta]x3, \[Beta]x4, \[Beta]x5, \[Beta]x6, \[Beta]x7, \[Beta]x8}\),
      SequenceForm[ 
      "\[Beta] = ", {\[Beta]x1, \[Beta]x2, \[Beta]x3, \[Beta]x4, \[Beta]x5, \
\[Beta]x6, \[Beta]x7, \[Beta]x8}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Beta]nameList = "\[InvisibleSpace]{"x1", "x2", 
          "x3", "x4", "x5", "x6", "x7", "x8"}\),
      SequenceForm[ 
      "\[Beta]nameList = ", {"x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8"}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(phDataPt[0.7884573603642703`, 
              True, {}, {0.0925362529215994`, 0, 1, 0, 0, 0, 0, 0}]\)},
          {\(phDataPt[1.3862943611198906`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 0, 0, 1}]\)},
          {\(phDataPt[1.3862943611198906`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 0, 0, 1}]\)},
          {\(phDataPt[1.5260563034950492`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 0, 0, 1}]\)},
          {\(phDataPt[1.8082887711792655`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 0, 0, 1}]\)},
          {\(phDataPt[1.9021075263969205`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 0, 1, 0}]\)},
          {\(phDataPt[2.066862759472976`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 0, 0, 1}]\)},
          {\(phDataPt[2.1162555148025524`, 
              True, {}, {0.0925362529215994`, 0, 0, 0, 0, 1, 0, 0}]\)},
          {\(phDataPt[2.1400661634962708`, 
              True, {}, {0.0925362529215994`, 0, 1, 0, 0, 0, 0, 0}]\)},
          {\(phDataPt[2.2082744135228043`, 
              True, {}, {0.0925362529215994`, 0, 1, 0, 0, 0, 0, 0}]\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {
        phDataPt[ 
        0.78845736036427028, True, {}, {0.092536252921599393, 0, 1, 0, 0, 0, 
          0, 0}], 
        phDataPt[ 
        1.3862943611198906, True, {}, {0.092536252921599393, 0, 0, 0, 0, 0, 0,
           1}], 
        phDataPt[ 
        1.3862943611198906, True, {}, {0.092536252921599393, 0, 0, 0, 0, 0, 0,
           1}], 
        phDataPt[ 
        1.5260563034950492, True, {}, {0.092536252921599393, 0, 0, 0, 0, 0, 0,
           1}], 
        phDataPt[ 
        1.8082887711792655, True, {}, {0.092536252921599393, 0, 0, 0, 0, 0, 0,
           1}], 
        phDataPt[ 
        1.9021075263969205, True, {}, {0.092536252921599393, 0, 0, 0, 0, 0, 1,
           0}], 
        phDataPt[ 
        2.066862759472976, True, {}, {0.092536252921599393, 0, 0, 0, 0, 0, 0, 
          1}], 
        phDataPt[ 
        2.1162555148025524, True, {}, {0.092536252921599393, 0, 0, 0, 0, 1, 0,
           0}], 
        phDataPt[ 
        2.1400661634962708, True, {}, {0.092536252921599393, 0, 1, 0, 0, 0, 0,
           0}], 
        phDataPt[ 
        2.2082744135228043, True, {}, {0.092536252921599393, 0, 1, 0, 0, 0, 0,
           0}]}]]], "Output"],

Cell[BoxData[
    \({10.621327345686446`, 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Beta]nameList = 
      replace\[Beta]nameList[\[Beta]nameList, 
        Join[{"\<logStress\>"}, 
          Map["\<Spool\>" <> ToString[#] &, spoolBasis]]]\)], "Input"],

Cell[BoxData[
    \({"logStress", "Spool1", "Spool2", "Spool3", "Spool4", "Spool5", 
      "Spool6", "Spool7"}\)], "Output"]
}, Open  ]],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[BoxData[{
    \(\(Clear[addLastPt];\)\), "\[IndentingNewLine]", 
    \(\(addLastPt[spts : {{_?NumberQ, _?NumberQ} .. }, 
          lastPt : \({_?NumberQ, _?NumberQ} : lastTimePt\)] := 
        With[{diff = lastPt - Last[spts]}, 
          If[First[diff] > 0, 
            Append[spts, 
              lastPt - {0, diff\[LeftDoubleBracket]2\[RightDoubleBracket]}], 
            spts]];\)\)}], "Input",
  CellOpen->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Semi-Parametric Proportional Hazards Analysis of the Kevlar 49 \
dataset\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["Empirival Survival Plot (Kaplan-Meier Plot)", "Subsubsection",
  FontFamily->"Century Schoolbook"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(ES = 
        surv\[EmptyVerySmallSquare]data[
          inputData /. time\[Delta]f];\)\), "\n", 
    \(\(empsurv = ES\[LeftDoubleBracket]1\[RightDoubleBracket];\)\), "\n", 
    \(\(p = 
        empsurv\[LeftDoubleBracket]All, 5\[RightDoubleBracket];\)\), "\n", 
    \(\(q = 1 - p;\)\), "\n", 
    \(\(event\[EmptyVerySmallSquare]t = 
        N[empsurv\[LeftDoubleBracket]All, 
            1\[RightDoubleBracket]];\)\), "\n", 
    \(\(kmData = 
        MapThread[{#1, #2} &, {empsurv\[LeftDoubleBracket]All, 
              1\[RightDoubleBracket], 
            empsurv\[LeftDoubleBracket]All, 
              4\[RightDoubleBracket]}];\)\), "\[IndentingNewLine]", 
    \(\(empSplot = 
        ListPlot[
          addLastPt[
            Transpose[{event\[EmptyVerySmallSquare]t, q}]]];\)\)}], "Input",
  CellOpen->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0896668 0.0147151 0.588604 [
[.20314 .00222 -3 -9 ]
[.20314 .00222 3 0 ]
[.38248 .00222 -3 -9 ]
[.38248 .00222 3 0 ]
[.56181 .00222 -3 -9 ]
[.56181 .00222 3 0 ]
[.74114 .00222 -3 -9 ]
[.74114 .00222 3 0 ]
[.92048 .00222 -6 -9 ]
[.92048 .00222 6 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20314 .01472 m
.20314 .02097 L
s
[(2)] .20314 .00222 0 1 Mshowa
.38248 .01472 m
.38248 .02097 L
s
[(4)] .38248 .00222 0 1 Mshowa
.56181 .01472 m
.56181 .02097 L
s
[(6)] .56181 .00222 0 1 Mshowa
.74114 .01472 m
.74114 .02097 L
s
[(8)] .74114 .00222 0 1 Mshowa
.92048 .01472 m
.92048 .02097 L
s
[(10)] .92048 .00222 0 1 Mshowa
.125 Mabswid
.06864 .01472 m
.06864 .01847 L
s
.11348 .01472 m
.11348 .01847 L
s
.15831 .01472 m
.15831 .01847 L
s
.24798 .01472 m
.24798 .01847 L
s
.29281 .01472 m
.29281 .01847 L
s
.33764 .01472 m
.33764 .01847 L
s
.42731 .01472 m
.42731 .01847 L
s
.47214 .01472 m
.47214 .01847 L
s
.51698 .01472 m
.51698 .01847 L
s
.60664 .01472 m
.60664 .01847 L
s
.65148 .01472 m
.65148 .01847 L
s
.69631 .01472 m
.69631 .01847 L
s
.78598 .01472 m
.78598 .01847 L
s
.83081 .01472 m
.83081 .01847 L
s
.87564 .01472 m
.87564 .01847 L
s
.96531 .01472 m
.96531 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.09451 .60059 Mdot
.14811 .59242 Mdot
.16065 .58424 Mdot
.18595 .57879 Mdot
.19437 .57334 Mdot
.20914 .56789 Mdot
.21357 .56244 Mdot
.2157 .55699 Mdot
.22182 .55154 Mdot
.23205 .54609 Mdot
.25028 .54064 Mdot
.25585 .53519 Mdot
.26045 .52974 Mdot
.26421 .52429 Mdot
.26663 .51884 Mdot
.2864 .51339 Mdot
.2883 .50794 Mdot
.30138 .50249 Mdot
.30989 .49704 Mdot
.36692 .49159 Mdot
.38378 .48614 Mdot
.39271 .48069 Mdot
.4045 .47524 Mdot
.40628 .46979 Mdot
.42477 .46434 Mdot
.43511 .45889 Mdot
.43763 .45344 Mdot
.44642 .44799 Mdot
.46431 .44254 Mdot
.46944 .43709 Mdot
.47815 .43164 Mdot
.49849 .42619 Mdot
.50953 .42074 Mdot
.51669 .41529 Mdot
.52036 .40984 Mdot
.56187 .40439 Mdot
.56799 .39894 Mdot
.57048 .39349 Mdot
.57228 .38804 Mdot
.5817 .38259 Mdot
.58355 .37714 Mdot
.58356 .37169 Mdot
.58822 .36624 Mdot
.58876 .36079 Mdot
.59028 .35534 Mdot
.59596 .34989 Mdot
.60294 .34444 Mdot
.60656 .33899 Mdot
.61047 .33354 Mdot
.61803 .32809 Mdot
.63141 .32264 Mdot
.63674 .31719 Mdot
.63881 .31174 Mdot
.65074 .30629 Mdot
.65242 .30084 Mdot
.65451 .29539 Mdot
.65562 .28994 Mdot
.66357 .28449 Mdot
.66503 .27904 Mdot
.68174 .27359 Mdot
.68361 .26814 Mdot
.69342 .26269 Mdot
.69367 .25724 Mdot
.69602 .25179 Mdot
.69711 .24634 Mdot
.7017 .24089 Mdot
.70741 .23544 Mdot
.72107 .22999 Mdot
.72328 .22454 Mdot
.74095 .21909 Mdot
.76074 .21364 Mdot
.76751 .20819 Mdot
.78587 .20274 Mdot
.79402 .19729 Mdot
.79697 .19184 Mdot
.80648 .18639 Mdot
.80783 .18094 Mdot
.8217 .17549 Mdot
.82184 .17004 Mdot
.82875 .16459 Mdot
.82962 .15914 Mdot
.83631 .15369 Mdot
.84141 .14824 Mdot
.84259 .14279 Mdot
.84943 .13734 Mdot
.8621 .13189 Mdot
.86396 .12644 Mdot
.87659 .12099 Mdot
.88005 .11554 Mdot
.88237 .11009 Mdot
.8924 .10464 Mdot
.91285 .09919 Mdot
.91286 .09374 Mdot
.94761 .08829 Mdot
.95114 .08284 Mdot
.96423 .07739 Mdot
.97619 .07739 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00@oooool5o`0002kooooo0ol0000/ooooo`?o0000;_ooool3o`0002_ooooo0ol00004oooo
o`;o00004oooool004Cooooo00Co0000oooooooooooo0000;oooool00ol0003oooooooooo`0Zoooo
o`05o`000?ooooooooooooooool00000;?ooool01Ol0003ooooooooooooooooo000002_ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool0000Booooo`00AOooool00ol0003ooooooooo
o`0/ooooo`Go0000:oooool01Ol0003ooooooooooooooooo000002cooooo00Go0000oooooooooooo
ooooo`00000[ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00004_ooool004Ko
oooo00?o0000ooooooooool0:oooool01?l0003oooooooooool0000/ooooo`Co0000;_ooool3o`00
02cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Booooo`00@oooool01Ol0
003ooooooooooooooooo000002gooooo00?o0000ooooool00000;?ooool00ol0003oooooooooo`0^
ooooo`05o`000?ooooooooooooooool00000:oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0001;ooooo0013ooooo`05o`000?ooooooooooooooool00000;_ooool2o`0002gooooo
00?o0000ooooooooool0;Oooool01Ol0003ooooooooooooooooo000002[ooooo0_l00004ooooo`04
o`000?ooooooooooo`0001;ooooo0014ooooo`?o0000<?ooool00ol0003oooooooooo`0/ooooo`;o
0000;_ooool3o`0002cooooo00?o0000ooooooooool00oooool2o`0001?ooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool000oo
ooooool0000Ao`00007ooooo000Eooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo000Eooooo`03o`000?oo
oooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0Dooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Go
oooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo000Eoooo
o`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`00
5Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo
000Eooooo`03o`000?oooooooooo0?cooooo0_l000000ooooooo0000o`000007ooooo`005Oooool0
0ol0003oooooooooo`3iooooo`;o000000Coooooo`000?l0003ooooo0_l00007ooooo`005Oooool0
0ol0003oooooooooo`3iooooo`;o00003Oooool001Gooooo00?o0000ooooooooool0n?ooool2o`00
00kooooo000Eooooo`03o`000?oooooooooo0>kooooo0_l00008ooooo`;o00003_ooool001Gooooo
00?o0000ooooooooool0k_ooool2o`0001Sooooo000Eooooo`03o`000?oooooooooo0>kooooo0_l0
000Hooooo`005Oooool2o`000>[ooooo0_l0000Mooooo`005Oooool00ol0003oooooooooo`3Voooo
o`;o000000?oooooo`000?l000007Oooool001Gooooo00?o0000ooooooooool0i_ooool2o`00023o
oooo000Eooooo`03o`000?oooooooooo0>Gooooo0_l0000Qooooo`005Oooool00ol0003ooooooooo
o`3Tooooo`?o00008Oooool000;ooooo0_l00004ooooo`04o`000?ooooooooooooooo`Go00001?oo
ool00ol0003oooooooooo`3Tooooo`;o00008_ooool00005ooooool0003oooooooooool000002?oo
ool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo0>7ooooo0_l0000Uooooo`0000Go
ooooo`000?ooooooooooo`000009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
h?ooool3o`0002Gooooo00001Ooooooo0000oooooooooooo000000[ooooo00?o0000ooooooooool0
0oooool3o`000>3ooooo0_l0000Vooooo`0000Goooooo`000?ooooooooooo`000007ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`3Mooooo`;o0000:Oooool00005oooo
ool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooo
ooooool0foooool4o`0002Wooooo0002ooooo`;o00002Oooool3o`0000Gooooo00?o0000oooooooo
ool0foooool2o`0002_ooooo000Eooooo`03o`000?oooooooooo0=_ooooo0_l0000[ooooo`005Ooo
ool00ol0003oooooooooo`3Iooooo`Co0000:oooool001Gooooo00?o0000ooooooooool0fOooool2
o`0002gooooo000Eooooo`03o`000?oooooooooo0=Sooooo0_l0000^ooooo`005Oooool2o`000=So
oooo0ol0000^ooooo`005Oooool00ol0003oooooooooo`3Gooooo`;o0000;oooool001Gooooo00?o
0000ooooooooool0eOooool2o`00037ooooo000Eooooo`03o`000?oooooooooo0=Gooooo0_l0000a
ooooo`005Oooool00ol0003oooooooooo`3Eooooo`;o0000<Oooool001Gooooo00?o0000oooooooo
ool0d_ooool2o`0003Cooooo000Eooooo`03o`000?oooooooooo0=7ooooo0ol0000dooooo`005Ooo
ool00ol0003oooooooooo`3Aooooo`;o0000=Oooool001Gooooo0_l0003@ooooo`;o0000=oooool0
01Gooooo00?o0000ooooooooool0c_ooool3o`0003Oooooo000Eooooo`03o`000?oooooooooo0<ko
oooo0_l0000hooooo`005Oooool00ol0003oooooooooo`3<ooooo`;o0000>_ooool001Gooooo00?o
0000ooooooooool0aoooool2o`0000?ooooo0_l0000jooooo`005Oooool00ol0003oooooooooo`37
ooooo`;o0000?oooool001Gooooo00?o0000ooooooooool0aOooool2o`00047ooooo000Eooooo`03
o`000?oooooooooo0;oooooo0_l00004ooooo`;o0000@Oooool001Gooooo0_l00030ooooo`;o0000
Aoooool001Gooooo00?o0000ooooooooool0^oooool2o`0004_ooooo000Eooooo`03o`000?oooooo
oooo0;[ooooo0ol0001;ooooo`005Oooool00ol0003oooooooooo`2jooooo`;o0000C?ooool001Go
oooo00?o0000ooooooooool0]_ooool2o`00053ooooo0002ooooo`;o00001?ooool00ol0003ooooo
ooooo`03ooooo`?o00001?ooool00ol0003oooooooooo`2eooooo`?o0000D?ooool00005ooooool0
003oooooooooool000002_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0;?ooooo
1?l0001Aooooo`0000Goooooo`000?ooooooooooo`000007ooooo`Go00001?ooool00ol0003ooooo
ooooo`2cooooo`;o0000Doooool00005ooooool0003oooooooooool000001oooool01?l0003ooooo
ooooool00005ooooo`?o0000/oooool2o`0005?ooooo00001Ooooooo0000oooooooooooo000000So
oooo00?o0000ooooool000001Oooool00ol0003oooooooooo`2cooooo`;o0000Doooool00005oooo
ool0003oooooooooool000002Oooool2o`0000Gooooo00?o0000ooooooooool0/oooool2o`0005?o
oooo0002ooooo`;o00002oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0;;ooooo
0_l0001Dooooo`005Oooool00ol0003oooooooooo`2`ooooo`Co0000E?ooool001Gooooo00?o0000
ooooooooool0/?ooool2o`0005Kooooo000Eooooo`03o`000?oooooooooo0:oooooo0_l0001Goooo
o`005Oooool00ol0003oooooooooo`2[ooooo`;o00000_ooool2o`0005Oooooo000Eooooo`;o0000
[?ooool2o`0005_ooooo000Eooooo`03o`000?oooooooooo0:[ooooo0_l0001Looooo`005Oooool0
0ol0003oooooooooo`2Xooooo`Co0000G?ooool001Gooooo00?o0000ooooooooool0Z?ooool2o`00
05kooooo000Eooooo`03o`000?oooooooooo0:Sooooo0_l0001Nooooo`005Oooool00ol0003ooooo
ooooo`2Wooooo`?o0000G_ooool001Gooooo00?o0000ooooooooool0Yoooool2o`0005oooooo000E
ooooo`03o`000?oooooooooo0:Oooooo0_l0001Oooooo`005Oooool2o`000:Gooooo0_l000000ooo
oooo0000o`00001Oooooo`005Oooool00ol0003oooooooooo`2Tooooo`;o0000H_ooool001Gooooo
00?o0000ooooooooool0Xoooool2o`0006?ooooo000Eooooo`03o`000?oooooooooo0:;ooooo0ol0
001Sooooo`005Oooool00ol0003oooooooooo`2Rooooo`;o0000I?ooool001Gooooo00?o0000oooo
ooooool0W_ooool2o`0006Sooooo000Eooooo`03o`000?oooooooooo09cooooo1?l0001Xooooo`00
5Oooool00ol0003oooooooooo`2Looooo`;o0000J_ooool001Gooooo0_l0002Looooo`;o0000Jooo
ool001Gooooo00?o0000ooooooooool0V_ooool3o`0006_ooooo000Eooooo`03o`000?oooooooooo
09[ooooo0_l0001/ooooo`005Oooool00ol0003oooooooooo`2Hooooo`;o0000K_ooool001Gooooo
00?o0000ooooooooool0U_ooool4o`0006kooooo0002ooooo`;o00001?ooool00ol0003ooooooooo
o`02ooooo`?o00001Oooool00ol0003oooooooooo`2Fooooo`;o0000L?ooool00005ooooool0003o
ooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
U_ooool2o`00073ooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo09Kooooo0_l0001`ooooo`0000Goooooo`000?oooooo
ooooo`000007ooooo`Co00001Oooool3o`0009Kooooo0_l0001`ooooo`0000Goooooo`000?oooooo
ooooo`000007ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0UOooool2o`00077o
oooo00001Ooooooo0000oooooooooooo000000Sooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`2Eooooo`;o0000LOooool000;ooooo0_l0000:ooooo`;o00001Oooool00ol0003ooooo
ooooo`2Eooooo`;o0000LOooool001Gooooo00?o0000ooooooooool0U?ooool2o`0007;ooooo000E
ooooo`03o`000?oooooooooo09;ooooo1?l0001booooo`005Oooool00ol0003oooooooooo`2Boooo
o`;o0000M?ooool001Gooooo00?o0000ooooooooool0TOooool2o`0007Gooooo000Eooooo`;o0000
TOooool3o`0007Gooooo000Eooooo`03o`000?oooooooooo08oooooo0ol0001fooooo`005Oooool0
0ol0003oooooooooo`2?ooooo`;o0000Moooool001Gooooo00?o0000ooooooooool0Poooool2o`00
08?ooooo000Eooooo`03o`000?oooooooooo08;ooooo0ol00023ooooo`005Oooool00ol0003ooooo
ooooo`22ooooo`;o0000Q?ooool001Gooooo00?o0000ooooooooool0P?ooool2o`0008Kooooo000E
ooooo`03o`000?oooooooooo07gooooo0_l000000ooooooo0000o`000026ooooo`005Oooool2o`00
07kooooo0_l00029ooooo`005Oooool00ol0003oooooooooo`1hooooo`;o0000S_ooool001Gooooo
00?o0000ooooooooool0M_ooool4o`0008kooooo000Eooooo`03o`000?oooooooooo07Kooooo0_l0
002@ooooo`005Oooool00ol0003oooooooooo`1dooooo`;o0000T_ooool001Gooooo00?o0000oooo
ooooool0Koooool2o`0000?ooooo0_l0002Booooo`005Oooool00ol0003oooooooooo`1_ooooo`;o
0000Uoooool001Gooooo00?o0000ooooooooool0KOooool2o`0009Wooooo000Eooooo`;o0000KOoo
ool3o`0009Wooooo000Eooooo`03o`000?oooooooooo06cooooo0_l0002Jooooo`005Oooool00ol0
003oooooooooo`1Yooooo`;o0000WOooool001Gooooo00?o0000ooooooooool0I?ooool2o`0000?o
oooo0_l0002Mooooo`005Oooool00ol0003oooooooooo`1Tooooo`;o0000X_ooool000;ooooo0_l0
0004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`000?oooooooooo06Cooooo0_l0
002Rooooo`0000Goooooo`000?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool00000
1?ooool00ol0003oooooooooo`1Qooooo`;o000000?oooooo`000?l00000X_ooool00005ooooool0
003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooooooo
ool0HOooool2o`000:Gooooo00001Ooooooo0000oooooooooooo000000Sooooo0ol00005ooooo`?o
0000G_ooool2o`000:Sooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000oooooooo
ooooooooo`000004ooooo`03o`000?oooooooooo05[ooooo0_l00002ooooo`;o0000Z?ooool00005
ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool0F_ooool2o`000:cooooo0002ooooo`;o00002Oooool3o`0000Gooooo00?o0000oooo
ooooool0B_ooool2o`000;cooooo000Eooooo`03o`000?oooooooooo04Sooooo1?l0002looooo`00
5Oooool00ol0003oooooooooo`18ooooo`;o0000__ooool001Gooooo00?o0000ooooooooool0A?oo
ool2o`000<;ooooo000Eooooo`03o`000?oooooooooo04Cooooo0_l00032ooooo`005Oooool2o`00
04Gooooo0_l00032ooooo`005Oooool00ol0003oooooooooo`0nooooo`;o0000b?ooool001Gooooo
00?o0000ooooooooool0?_ooool2o`000<Sooooo000Eooooo`03o`000?oooooooooo03kooooo0_l0
0038ooooo`005Oooool00ol0003oooooooooo`0mooooo`;o0000bOooool001Gooooo00?o0000oooo
ooooool0??ooool3o`000<Wooooo000Eooooo`03o`000?oooooooooo03cooooo0_l0003:ooooo`00
5Oooool00ol0003oooooooooo`0jooooo`;o0000c?ooool001Gooooo0_l0000fooooo`;o00000ooo
ool2o`000<cooooo000Eooooo`03o`000?oooooooooo03;ooooo0_l000000ooooooo0000o`00003A
ooooo`005Oooool00ol0003oooooooooo`0booooo`;o0000e?ooool001Gooooo00?o0000oooooooo
ool0<Oooool2o`000=Gooooo000Eooooo`03o`000?oooooooooo033ooooo0ol0003Eooooo`005Ooo
ool00ol0003oooooooooo`0`ooooo`;o0000e_ooool001Gooooo00?o0000ooooooooool0;oooool2
o`000=Oooooo000Eooooo`03o`000?oooooooooo02_ooooo0_l00002ooooo`;o0000eoooool001Go
oooo0_l0000/ooooo`;o0000foooool001Gooooo00?o0000ooooooooool0:Oooool2o`000=gooooo
000Eooooo`03o`000?oooooooooo02;ooooo0_l00005ooooo`;o0000gOooool001Gooooo00?o0000
ooooooooool08_ooool2o`000>Cooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool000go
oooo0ol00005ooooo`03o`000?oooooooooo01kooooo0_l0003Xooooo`003_ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo01kooooo0_l0003Xooooo`003_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo013ooooo0_l0003fooooo`003_ooool00ol0003oooooooooo`03
ooooo`Co00004?ooool2o`000?Kooooo000>ooooo`03o`000?oooooooooo00?ooooo0_l0003ooooo
o`_ooooo000=ooooo`;o00001_ooool00ol0003oooooooooo`3oooooo`Wooooo000>ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.881414, -0.07747, \
0.0410174, 0.00624851}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solution of partial likelihood equation", "Subsubsection"],

Cell[TextData[{
  "\"Max ObsLog\[Beta] (at ",
  Cell[BoxData[
      \(TraditionalForm\`\({\[Beta]\_1, 0, 0, 0, 0, 0, 0, 0}\&^\)\)]],
  ")  \[InvisibleSpace]-320.1411371153724    ObsLog\[Beta] at \[Beta]=0   \
\[InvisibleSpace]-383.43803017339184\nshowing that any submodel of \[Beta] \
can be tested."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({{valuelogL\[Beta]0, maxLogL\[Beta], \[Beta]hat}, {varCov\[Beta], 
            stdErr\[Beta]}, {s0, logH0}} = 
        boxedPH[inputData, \[Beta]];\)\)], "Input"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-261.8513458104071`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-383.43803017339184`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -261.85134581040711, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -383.43803017339184],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{32.58194764833275`, \(-0.8429027257850936`\), 
          2.1746758228063`, 2.87763826612114`, \(-1.4995648512384798`\), 
          0.9623430705691278`, 1.4852615974361796`, 3.451923108675684`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {32.581947648332751, -0.84290272578509362, 
        2.1746758228063001, 2.8776382661211399, -1.4995648512384798, 
        0.96234307056912782, 1.4852615974361796, 3.4519231086756839}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{5.9778383770803245`*^-9, \(-3.1440481884636995`*^-9\), 
          7.1720344385628465`*^-9, \(-2.853515479461777`*^-10\), \
\(-9.778704439071528`*^-10\), \(-1.1967048949013126`*^-9\), 
          3.061401805670716`*^-9, \(-3.0123643579571535`*^-9\)}\),
      SequenceForm[ 
      "Gradient vector ", {5.9778383770803245*^-09, -3.1440481884636995*^-09, 
        7.1720344385628465*^-09, -2.8535154794617767*^-10, \
-9.7787044390715283*^-10, -1.1967048949013126*^-09, 
        3.061401805670716*^-09, -3.0123643579571535*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{9.595434733410814`, \(-0.2579472640407563`\), 
            0.4727528526911799`, 
            0.561950235803907`, \(-0.4634457250256894`\), 
            0.12456219925465878`, 0.3132644872801682`, 
            0.5103627530112075`}, {\(-0.2579472640407563`\), 
            0.20358441027341806`, 0.07890584461012035`, 0.07533182002366368`, 
            0.11169031421608211`, 0.09300025621066509`, 0.08534567360033764`, 
            0.076581658824495`}, {0.4727528526911799`, 0.07890584461012033`, 
            0.17632038442947548`, 0.14088736108152705`, 0.07411604362371213`, 
            0.09854499683020464`, 0.11291100929218825`, 
            0.1445396288931119`}, {0.5619502358039069`, 0.0753318200236637`, 
            0.14088736108152708`, 0.2571018729873036`, 0.07011432924415299`, 
            0.10271068784953227`, 0.11844504379088154`, 
            0.17504715863281436`}, {\(-0.46344572502568937`\), 
            0.11169031421608211`, 0.07411604362371219`, 0.07011432924415303`, 
            0.22632444382608524`, 0.08476563228788368`, 0.08234752768813061`, 
            0.0710342661143118`}, {0.12456219925465871`, 
            0.09300025621066509`, 0.09854499683020465`, 0.10271068784953227`, 
            0.08476563228788368`, 0.2397772548637798`, 0.09933833468002326`, 
            0.10456906080224716`}, {0.31326448728016815`, 
            0.08534567360033761`, 0.11291100929218825`, 0.11844504379088153`, 
            0.0823475276881306`, 0.09933833468002327`, 0.1953350063129617`, 
            0.11824074955938221`}, {0.5103627530112074`, 
            0.07658165882449507`, 0.1445396288931119`, 0.1750471586328144`, 
            0.0710342661143118`, 0.10456906080224716`, 0.11824074955938221`, 
            0.29812727358856456`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        9.5954347334108139, -0.2579472640407563, 0.47275285269117989, 
        0.56195023580390702, -0.46344572502568943, 0.12456219925465878, 
        0.3132644872801682, 0.51036275301120748}, {-0.2579472640407563, 
        0.20358441027341806, 0.078905844610120346, 0.075331820023663676, 
        0.11169031421608211, 0.093000256210665086, 0.085345673600337638, 
        0.076581658824494997}, {0.47275285269117989, 0.078905844610120332, 
        0.17632038442947548, 0.14088736108152705, 0.07411604362371213, 
        0.098544996830204637, 0.11291100929218825, 0.14453962889311189}, {
        0.56195023580390691, 0.075331820023663704, 0.14088736108152708, 
        0.25710187298730358, 0.070114329244152993, 0.10271068784953227, 
        0.11844504379088154, 0.17504715863281436}, {-0.46344572502568937, 
        0.11169031421608211, 0.074116043623712186, 0.070114329244153034, 
        0.22632444382608524, 0.084765632287883683, 0.082347527688130612, 
        0.071034266114311795}, {0.12456219925465871, 0.093000256210665086, 
        0.098544996830204651, 0.10271068784953227, 0.084765632287883683, 
        0.23977725486377979, 0.09933833468002326, 0.10456906080224716}, {
        0.31326448728016815, 0.08534567360033761, 0.11291100929218825, 
        0.11844504379088153, 0.082347527688130598, 0.099338334680023274, 
        0.19533500631296169, 0.11824074955938221}, {0.51036275301120737, 
        0.076581658824495066, 0.14453962889311189, 0.17504715863281439, 
        0.071034266114311795, 0.10456906080224716, 0.11824074955938221, 
        0.29812727358856456}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{3.0976498726309942`, 0.4512032915143883`, 
          0.4199052088620424`, 0.5070521403044302`, 0.47573568693769996`, 
          0.489670557481027`, 0.44196720049451826`, 0.5460103237014522`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {3.0976498726309942, 
        0.45120329151438832, 0.41990520886204241, 0.50705214030443024, 
        0.47573568693769996, 0.489670557481027, 0.44196720049451826, 
        0.54601032370145219}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9998869903672363`, 
          0.9997530667451718`, 0.9998600576808632`, 0.9998461967947287`, 
          0.9998371398436459`, 0.9998266173563065`, 0.9998156711542593`, 
          0.9998116133312016`, 0.9998050226606346`, 0.9997979540730993`, 
          0.9997861732669862`, 0.9997763414173616`, 0.9997569468701413`, 
          0.9997235087019117`, 0.9997053080217886`, 0.9996839355448792`, 
          0.9996632478623912`, 0.9996506326853861`, 0.999637273876227`, 
          0.9995840659868667`, 0.9995014380923802`, 0.9993645843220942`, 
          0.9992045850150654`, 0.9991885888943035`, 0.9991648064925178`, 
          0.9991383866032656`, 0.9989560105158468`, 0.9985601514760427`, 
          0.9983105334273568`, 0.998110163958866`, 0.9974280726105669`, 
          0.9966407907016356`, 0.9965424947271894`, 0.9961732048103517`, 
          0.9957128277354097`, 0.9955088166735687`, 0.995150315072307`, 
          0.9948363456812996`, 0.9947062910297915`, 0.9946309674134372`, 
          0.9943074693533066`, 0.9938803769014926`, 0.9935546432892433`, 
          0.9929910481366733`, 0.9925189245784652`, 0.991820643075124`, 
          0.9901780224019684`, 0.9890778007701336`, 0.9879015019721065`, 
          0.9857597084961409`, 0.9847834980102574`, 0.9846405393024136`, 
          0.9833912251296795`, 0.981704330410122`, 0.979544196907363`, 
          0.9772742988943262`, 0.9756475482523063`, 0.9710445867059795`, 
          0.9670679502201182`, 0.9666090541971718`, 0.9635042447954327`, 
          0.9562105140910909`, 0.950576794580544`, 0.9427163929374219`, 
          0.9317430249082241`, 0.9253824497893042`, 0.9154537859639196`, 
          0.9027461969341267`, 0.8801698616792173`, 0.8588103433860717`, 
          0.8429424876641488`, 0.8223713216474884`, 0.815640739291672`, 
          0.8083149182006253`, 0.7741746199622811`, 0.7244636489759129`, 
          0.6779161171612806`, 0.6415313310988815`, 0.6296934486129715`, 
          0.6095579591263957`, 0.5386897029593811`, 0.44793748323276295`, 
          0.4218975360287203`, 0.39446150719423934`, 0.342337590580581`, 
          0.3009688818053051`, 0.18773084069868104`, 0.08993697236386003`, 
          0.06612143316899143`, 0.035238479674133474`, 0.01632292817053015`, 
          0.009134375043817724`, 0.004128697423666429`, 
          0.001129762881383194`, 0.00003866933287699728`, 1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.99988699036723627, 0.99975306674517184, 
        0.99986005768086317, 0.99984619679472875, 0.99983713984364586, 
        0.99982661735630651, 0.99981567115425929, 0.99981161333120161, 
        0.99980502266063465, 0.99979795407309935, 0.99978617326698616, 
        0.9997763414173616, 0.99975694687014127, 0.99972350870191173, 
        0.99970530802178859, 0.99968393554487922, 0.99966324786239125, 
        0.99965063268538612, 0.99963727387622703, 0.99958406598686667, 
        0.99950143809238023, 0.99936458432209418, 0.99920458501506537, 
        0.99918858889430351, 0.99916480649251782, 0.99913838660326559, 
        0.99895601051584682, 0.99856015147604271, 0.99831053342735676, 
        0.99811016395886598, 0.99742807261056687, 0.99664079070163558, 
        0.99654249472718937, 0.99617320481035165, 0.9957128277354097, 
        0.99550881667356872, 0.995150315072307, 0.99483634568129964, 
        0.99470629102979147, 0.99463096741343715, 0.99430746935330661, 
        0.99388037690149256, 0.99355464328924326, 0.99299104813667327, 
        0.99251892457846524, 0.99182064307512396, 0.99017802240196839, 
        0.98907780077013363, 0.98790150197210647, 0.98575970849614092, 
        0.98478349801025744, 0.98464053930241358, 0.98339122512967947, 
        0.98170433041012195, 0.97954419690736305, 0.97727429889432615, 
        0.97564754825230626, 0.97104458670597948, 0.96706795022011816, 
        0.9666090541971718, 0.96350424479543273, 0.95621051409109092, 
        0.950576794580544, 0.94271639293742193, 0.93174302490822414, 
        0.92538244978930417, 0.91545378596391958, 0.90274619693412672, 
        0.88016986167921729, 0.85881034338607165, 0.84294248766414881, 
        0.82237132164748838, 0.81564073929167202, 0.80831491820062529, 
        0.7741746199622811, 0.72446364897591287, 0.67791611716128064, 
        0.6415313310988815, 0.6296934486129715, 0.60955795912639565, 
        0.53868970295938112, 0.44793748323276295, 0.42189753602872032, 
        0.39446150719423934, 0.342337590580581, 0.30096888180530512, 
        0.18773084069868104, 0.089936972363860029, 0.066121433168991425, 
        0.035238479674133474, 0.016322928170530149, 0.0091343750438177239, 
        0.0041286974236664289, 0.0011297628813831939, 3.866933287699728*^-05, 
        9.9999999999999995*^-07}],
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[s0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0896668 0.0147151 0.588604 [
[.20314 .00222 -3 -9 ]
[.20314 .00222 3 0 ]
[.38248 .00222 -3 -9 ]
[.38248 .00222 3 0 ]
[.56181 .00222 -3 -9 ]
[.56181 .00222 3 0 ]
[.74114 .00222 -3 -9 ]
[.74114 .00222 3 0 ]
[.92048 .00222 -6 -9 ]
[.92048 .00222 6 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20314 .01472 m
.20314 .02097 L
s
[(2)] .20314 .00222 0 1 Mshowa
.38248 .01472 m
.38248 .02097 L
s
[(4)] .38248 .00222 0 1 Mshowa
.56181 .01472 m
.56181 .02097 L
s
[(6)] .56181 .00222 0 1 Mshowa
.74114 .01472 m
.74114 .02097 L
s
[(8)] .74114 .00222 0 1 Mshowa
.92048 .01472 m
.92048 .02097 L
s
[(10)] .92048 .00222 0 1 Mshowa
.125 Mabswid
.06864 .01472 m
.06864 .01847 L
s
.11348 .01472 m
.11348 .01847 L
s
.15831 .01472 m
.15831 .01847 L
s
.24798 .01472 m
.24798 .01847 L
s
.29281 .01472 m
.29281 .01847 L
s
.33764 .01472 m
.33764 .01847 L
s
.42731 .01472 m
.42731 .01847 L
s
.47214 .01472 m
.47214 .01847 L
s
.51698 .01472 m
.51698 .01847 L
s
.60664 .01472 m
.60664 .01847 L
s
.65148 .01472 m
.65148 .01847 L
s
.69631 .01472 m
.69631 .01847 L
s
.78598 .01472 m
.78598 .01847 L
s
.83081 .01472 m
.83081 .01847 L
s
.87564 .01472 m
.87564 .01847 L
s
.96531 .01472 m
.96531 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.09451 .60325 Mdot
.14811 .60311 Mdot
.16065 .60302 Mdot
.18595 .60293 Mdot
.19437 .60284 Mdot
.20914 .60274 Mdot
.21357 .60263 Mdot
.2157 .60252 Mdot
.22182 .6024 Mdot
.23205 .60228 Mdot
.25028 .60216 Mdot
.25585 .60203 Mdot
.26045 .60188 Mdot
.26421 .60172 Mdot
.26663 .60155 Mdot
.2864 .60136 Mdot
.2883 .60117 Mdot
.30138 .60096 Mdot
.30989 .60075 Mdot
.36692 .6005 Mdot
.38378 .60021 Mdot
.39271 .59984 Mdot
.4045 .59938 Mdot
.40628 .5989 Mdot
.42477 .59841 Mdot
.43511 .59791 Mdot
.43763 .5973 Mdot
.44642 .59646 Mdot
.46431 .59548 Mdot
.46944 .59438 Mdot
.47815 .59289 Mdot
.49849 .59095 Mdot
.50953 .58896 Mdot
.51669 .58676 Mdot
.52036 .58431 Mdot
.56187 .58175 Mdot
.56799 .579 Mdot
.57048 .57608 Mdot
.57228 .57311 Mdot
.5817 .57011 Mdot
.58355 .56695 Mdot
.58356 .56357 Mdot
.58822 .56004 Mdot
.58876 .55621 Mdot
.59028 .55216 Mdot
.59596 .54777 Mdot
.60294 .54253 Mdot
.60656 .53677 Mdot
.61047 .53045 Mdot
.61803 .52311 Mdot
.63141 .51537 Mdot
.63674 .50768 Mdot
.63881 .49949 Mdot
.65074 .49062 Mdot
.65242 .48089 Mdot
.65451 .47029 Mdot
.65562 .4592 Mdot
.66357 .44633 Mdot
.66503 .43212 Mdot
.68174 .41818 Mdot
.68361 .40345 Mdot
.69342 .38643 Mdot
.69367 .36806 Mdot
.69602 .34782 Mdot
.69711 .32508 Mdot
.7017 .30192 Mdot
.70741 .27764 Mdot
.72107 .25207 Mdot
.72328 .22363 Mdot
.74095 .19413 Mdot
.76074 .16595 Mdot
.76751 .13909 Mdot
.78587 .11616 Mdot
.79402 .09671 Mdot
.79697 .0782 Mdot
.80648 .06071 Mdot
.80783 .04589 Mdot
.8217 .03472 Mdot
.82184 .02731 Mdot
.82875 .02239 Mdot
.82962 .01885 Mdot
.83631 .01657 Mdot
.84141 .0155 Mdot
.84259 .01502 Mdot
.84943 .01482 Mdot
.8621 .01475 Mdot
.86396 .01472 Mdot
.87659 .01472 Mdot
.88005 .01472 Mdot
.88237 .01472 Mdot
.8924 .01472 Mdot
.91285 .01472 Mdot
.91286 .01472 Mdot
.94761 .01472 Mdot
.95114 .01472 Mdot
.96423 .01472 Mdot
.97619 .01472 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00@oooool5o`0002kooooo0ol0000/ooooo`?o0000;_ooool3o`0002_ooooo0ol00004oooo
o`;o00004oooool004Cooooo00Co0000oooooooooooo0000;oooool00ol0003oooooooooo`0Zoooo
o`05o`000?ooooooooooooooool00000;?ooool01Ol0003ooooooooooooooooo000002_ooooo00?o
0000ooooooooool00_ooool01?l0003oooooooooool0000Booooo`00AOooool00ol0003ooooooooo
o`0/ooooo`Go0000:oooool01Ol0003ooooooooooooooooo000002cooooo00Go0000oooooooooooo
ooooo`00000[ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00004_ooool004Ko
oooo00?o0000ooooooooool0:oooool01?l0003oooooooooool0000/ooooo`Co0000;_ooool3o`00
02cooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Booooo`00@oooool01Ol0
003ooooooooooooooooo000002gooooo00?o0000ooooool00000;?ooool00ol0003oooooooooo`0^
ooooo`05o`000?ooooooooooooooool00000:oooool00ol0003oooooooooo`02ooooo`04o`000?oo
ooooooooo`0001;ooooo0013ooooo`05o`000?ooooooooooooooool00000;_ooool2o`0002gooooo
00?o0000ooooooooool0;Oooool01Ol0003ooooooooooooooooo000002[ooooo0_l00004ooooo`04
o`000?ooooooooooo`0001;ooooo0014ooooo`?o0000<?ooool00ol0003oooooooooo`0/ooooo`;o
0000;_ooool3o`0002cooooo00?o0000ooooooooool00oooool2o`0001?ooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool000oo
ooooool0000Ao`00007ooooo000Eooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`09ooooo`Oo000000Goooooo`000?l0003o0000ooooo`04o`000003
ooooool0003o000000?ooooo0_l000000ooooooo0000ooooo`05ooooo`?o000000Coooooo`000?l0
003ooooo0_l00007ooooo`005Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo02ko
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0^ooooo`03o`000?oooooooooo01Co
oooo0ol0000Gooooo`03o`000?oooooooooo01Cooooo000Eooooo`03o`000?oooooooooo0=Gooooo
1?l0000_ooooo`005Oooool00ol0003oooooooooo`3Eooooo`;o0000<Oooool001Gooooo00?o0000
ooooooooool0eOooool2o`00037ooooo000Eooooo`03o`000?oooooooooo0=Gooooo0_l0000aoooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000doooool2o`0003Cooooo
000Eooooo`03o`000?oooooooooo0=;ooooo0_l0000dooooo`005Oooool00ol0003oooooooooo`3o
ooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooooooo
ool0dOooool2o`0003Gooooo000Eooooo`03o`000?oooooooooo0=7ooooo0_l0000eooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool0
01Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooooooo0<oooooo0_l0000gooooo`00
5Oooool00ol0003oooooooooo`3?ooooo`;o0000=oooool001Gooooo00?o0000ooooooooool0oooo
ool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
0?oooooo2Oooool001Gooooo00?o0000ooooooooool0c_ooool2o`0003Sooooo000Eooooo`03o`00
0?oooooooooo0<kooooo0_l0000hooooo`005Oooool2o`000?oooooo2_ooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03
o`000?oooooooooo0<cooooo0_l0000jooooo`005Oooool00ol0003oooooooooo`3<ooooo`;o0000
>_ooool000;ooooo0_l00004ooooo`04o`000?ooooooooooooooo`Go00001?ooool00ol0003ooooo
ooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Sooooo00Co0000oooooooooooo
00001?ooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Wo
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000
oooooooooooo000000[ooooo00?o0000ooooooooool00oooool3o`000?oooooo2Oooool00005oooo
ool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000oooo
ooooool0aoooool2o`0003oooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000oooo
ooooooooooooo`000004ooooo`03o`000?oooooooooo0<Oooooo0_l0000oooooo`000_ooool2o`00
00Wooooo0ol00005ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2o`00
0?oooooo2_ooool001Gooooo00?o0000ooooooooool0aOooool2o`00047ooooo000Eooooo`03o`00
0?oooooooooo0<Gooooo0_l00011ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo
2Oooool001Gooooo0_l00030ooooo`;o0000Aoooool001Gooooo00?o0000ooooooooool0_oooool2
o`0004Oooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000_?ooool2o`0004_ooooo000Eooooo`03o`00
0?oooooooooo0;_ooooo0_l0001;ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`000_ooool2o`0000Cooooo00?o0000ooooooooool00oooool3o`0000Cooooo00?o0000oooooooo
ool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`00000:ooooo`03o`000?oooooooooo00?o
oooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`000007ooooo`Go
00001?ooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Oo
oooo00Co0000oooooooooooo00001Oooool3o`000;[ooooo0_l0001<ooooo`0000Goooooo`000?oo
ooooooooo`000008ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool0^_ooool2o`00
04cooooo00001Ooooooo0000oooooooooooo000000Wooooo0_l00005ooooo`03o`000?oooooooooo
0?oooooo2Oooool000;ooooo0_l0000;ooooo`03o`000?oooooooooo00?ooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`2fooooo`;o0000D?ooool001Gooooo0_l0002gooooo`;o0000D?ooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0;Gooooo
0_l0001Aooooo`005Oooool00ol0003oooooooooo`2eooooo`;o0000DOooool001Gooooo0_l0003o
ooooo`[ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0;?ooooo0_l0001Cooooo`005Oooool00ol0003oooooooooo`2cooooo`;o0000Doooool0
01Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo0;?ooooo0_l0001Cooooo`005Oooool00ol0003oooooooooo`2coooo
o`;o0000Doooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`000_ooool2o`0000Cooooo
00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0ooooool9ooooo`0000Go
ooooo`000?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003o
ooooooooo`3oooooo`Wooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000oooooooo
ooooooooo`000004ooooo`03o`000?oooooooooo0?oooooo2Oooool00005ooooool0003ooooooooo
ool000001oooool4o`0000Gooooo0ol0002cooooo`;o0000Doooool00005ooooool0003ooooooooo
ool000001oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo0;?ooooo0_l0001Coooo
o`0000Goooooo`000?ooooooooooo`000008ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool0ooooool9ooooo`000_ooool2o`0000[ooooo0_l00005ooooo`03o`000?oooooooooo0?oo
oooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003ooooooooo
o`2booooo`;o0000E?ooool001Gooooo00?o0000ooooooooool0/_ooool2o`0005Cooooo000Eoooo
o`03o`000?oooooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`00
0?oooooooooo0;3ooooo0_l0001Fooooo`005Oooool00ol0003oooooooooo`2`ooooo`;o0000E_oo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo0:oooooo0_l0001Gooooo`005Oooool00ol0003ooooo
ooooo`2_ooooo`;o0000Eoooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2
o`000?oooooo2_ooool001Gooooo00?o0000ooooooooool0Zoooool2o`0005_ooooo000Eooooo`03
o`000?oooooooooo0:_ooooo0_l0001Kooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0Z_ooool2
o`0005cooooo000Eooooo`03o`000?oooooooooo0:[ooooo0_l0001Looooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`;o0000ZOooool2o`0005kooooo000Eooooo`03o`000?oo
oooooooo0:Sooooo0_l0001Nooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eoooo
o`03o`000?oooooooooo0:Sooooo0_l0001Nooooo`005Oooool00ol0003oooooooooo`2Xooooo`;o
0000G_ooool000;ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03o`00
0?oooooooooo0?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooo
oooooooooooo000000Cooooo00?o0000ooooooooool0Yoooool2o`0005oooooo00001Ooooooo0000
oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
0:Oooooo0_l0001Oooooo`0000Goooooo`000?ooooooooooo`000008ooooo`?o00001Oooool3o`00
0?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo
000000Cooooo00?o0000ooooooooool0Yoooool2o`0005oooooo00001Ooooooo0000oooooooooooo
000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0:Oooooo0_l0
001Oooooo`000_ooool2o`0000Wooooo0ol00005ooooo`03o`000?oooooooooo0:Cooooo0_l0001R
ooooo`005Oooool00ol0003oooooooooo`2Tooooo`;o0000H_ooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`2Sooooo`;o0000Hoooool001Gooooo00?o
0000ooooooooool0Xoooool2o`0006?ooooo000Eooooo`;o0000Xoooool2o`0006Cooooo000Eoooo
o`03o`000?oooooooooo0:;ooooo0_l0001Tooooo`005Oooool00ol0003oooooooooo`2Nooooo`;o
0000J?ooool001Gooooo00?o0000ooooooooool0W_ooool2o`0006Sooooo000Eooooo`03o`000?oo
oooooooo09cooooo0_l0001Zooooo`005Oooool00ol0003oooooooooo`2Kooooo`?o0000J_ooool0
01Gooooo00?o0000ooooooooool0Voooool2o`0006_ooooo000Eooooo`03o`000?oooooooooo09[o
oooo0_l0001/ooooo`005Oooool2o`0009Wooooo1?l0001/ooooo`005Oooool00ol0003ooooooooo
o`2Hooooo`;o0000K_ooool001Gooooo00?o0000ooooooooool0U_ooool2o`00073ooooo000Eoooo
o`03o`000?oooooooooo09Kooooo0_l0001`ooooo`005Oooool00ol0003oooooooooo`2Fooooo`;o
0000L?ooool001Gooooo00?o0000ooooooooool0UOooool3o`00073ooooo000Eooooo`03o`000?oo
oooooooo09Gooooo0_l0001aooooo`005Oooool00ol0003oooooooooo`2Booooo`Go0000LOooool0
01Gooooo0_l0002Booooo`Go0000L_ooool001Gooooo00?o0000ooooooooool0T?ooool3o`0007Go
oooo000Eooooo`03o`000?oooooooooo08?ooooo0_l0000:ooooo`?o0000M_ooool001Gooooo00?o
0000ooooooooool0P_ooool3o`0000[ooooo0_l0001gooooo`005Oooool00ol0003oooooooooo`1m
ooooo`;o000000?oooooo`000?l000000_l00024ooooo`003Oooool3o`0000Gooooo00?o0000oooo
ooooool0M?ooool6o`0000?ooooo0_l000000ooooooo0000o`000026ooooo`003_ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo06Cooooo0_l00003ooooo`;o000000?oooooo`000?l0
00000ol00003ooooo`Ko0000S_ooool000kooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0Rooooo`;o00001Oooool4o`0000;ooooo1Ol000000ooooooo0000o`000003ooooo`Ko0000
1?ooool2o`0000;ooooo1?l0000>ooooo`;o00000_ooool2o`000004ooooool0003o0000ooooo`;o
00000oooool2o`000003ooooool0003o000000?o0000Uoooool000kooooo00?o0000ooooooooool0
0oooool4o`00013ooooo0_l0000<ooooo`;o00000_ooool2o`0000Gooooo1?l00002ooooo`Go0000
00?oooooo`000?l000000oooool6o`0000Cooooo0_l00002ooooo`Co00003_ooool2o`0000;ooooo
0_l000000ooooooo0000o`00002Uooooo`003_ooool00ol0003oooooooooo`03ooooo`;o00004_oo
ool2o`0000cooooo0_l0003Xooooo`003Oooool2o`0000Kooooo00?o0000ooooooooool0ooooool9
ooooo`003_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo2Oooool001Go
oooo00?o0000ooooooooool0ooooool9ooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.881414, -0.07747, \
0.0410174, 0.00624851}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[logH0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0896668 0.418038 0.0443798 [
[.20314 .40554 -3 -9 ]
[.20314 .40554 3 0 ]
[.38248 .40554 -3 -9 ]
[.38248 .40554 3 0 ]
[.56181 .40554 -3 -9 ]
[.56181 .40554 3 0 ]
[.74114 .40554 -3 -9 ]
[.74114 .40554 3 0 ]
[.92048 .40554 -6 -9 ]
[.92048 .40554 6 0 ]
[.01131 .063 -12 -4.5 ]
[.01131 .063 0 4.5 ]
[.01131 .15176 -12 -4.5 ]
[.01131 .15176 0 4.5 ]
[.01131 .24052 -12 -4.5 ]
[.01131 .24052 0 4.5 ]
[.01131 .32928 -12 -4.5 ]
[.01131 .32928 0 4.5 ]
[.01131 .5068 -6 -4.5 ]
[.01131 .5068 0 4.5 ]
[.01131 .59556 -6 -4.5 ]
[.01131 .59556 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.20314 .41804 m
.20314 .42429 L
s
[(2)] .20314 .40554 0 1 Mshowa
.38248 .41804 m
.38248 .42429 L
s
[(4)] .38248 .40554 0 1 Mshowa
.56181 .41804 m
.56181 .42429 L
s
[(6)] .56181 .40554 0 1 Mshowa
.74114 .41804 m
.74114 .42429 L
s
[(8)] .74114 .40554 0 1 Mshowa
.92048 .41804 m
.92048 .42429 L
s
[(10)] .92048 .40554 0 1 Mshowa
.125 Mabswid
.06864 .41804 m
.06864 .42179 L
s
.11348 .41804 m
.11348 .42179 L
s
.15831 .41804 m
.15831 .42179 L
s
.24798 .41804 m
.24798 .42179 L
s
.29281 .41804 m
.29281 .42179 L
s
.33764 .41804 m
.33764 .42179 L
s
.42731 .41804 m
.42731 .42179 L
s
.47214 .41804 m
.47214 .42179 L
s
.51698 .41804 m
.51698 .42179 L
s
.60664 .41804 m
.60664 .42179 L
s
.65148 .41804 m
.65148 .42179 L
s
.69631 .41804 m
.69631 .42179 L
s
.78598 .41804 m
.78598 .42179 L
s
.83081 .41804 m
.83081 .42179 L
s
.87564 .41804 m
.87564 .42179 L
s
.96531 .41804 m
.96531 .42179 L
s
.25 Mabswid
0 .41804 m
1 .41804 L
s
.02381 .063 m
.03006 .063 L
s
[(-8)] .01131 .063 1 0 Mshowa
.02381 .15176 m
.03006 .15176 L
s
[(-6)] .01131 .15176 1 0 Mshowa
.02381 .24052 m
.03006 .24052 L
s
[(-4)] .01131 .24052 1 0 Mshowa
.02381 .32928 m
.03006 .32928 L
s
[(-2)] .01131 .32928 1 0 Mshowa
.02381 .5068 m
.03006 .5068 L
s
[(2)] .01131 .5068 1 0 Mshowa
.02381 .59556 m
.03006 .59556 L
s
[(4)] .01131 .59556 1 0 Mshowa
.125 Mabswid
.02381 .08519 m
.02756 .08519 L
s
.02381 .10738 m
.02756 .10738 L
s
.02381 .12957 m
.02756 .12957 L
s
.02381 .17395 m
.02756 .17395 L
s
.02381 .19614 m
.02756 .19614 L
s
.02381 .21833 m
.02756 .21833 L
s
.02381 .26271 m
.02756 .26271 L
s
.02381 .2849 m
.02756 .2849 L
s
.02381 .30709 m
.02756 .30709 L
s
.02381 .35147 m
.02756 .35147 L
s
.02381 .37366 m
.02756 .37366 L
s
.02381 .39585 m
.02756 .39585 L
s
.02381 .44023 m
.02756 .44023 L
s
.02381 .46242 m
.02756 .46242 L
s
.02381 .48461 m
.02756 .48461 L
s
.02381 .52899 m
.02756 .52899 L
s
.02381 .55118 m
.02756 .55118 L
s
.02381 .57337 m
.02756 .57337 L
s
.02381 .04081 m
.02756 .04081 L
s
.02381 .01862 m
.02756 .01862 L
s
.02381 .61775 m
.02756 .61775 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.09451 .01472 Mdot
.14811 .06613 Mdot
.16065 .08071 Mdot
.18595 .09261 Mdot
.19437 .10248 Mdot
.20914 .11103 Mdot
.21357 .11861 Mdot
.2157 .12521 Mdot
.22182 .13114 Mdot
.23205 .13656 Mdot
.25028 .14165 Mdot
.25585 .14641 Mdot
.26045 .15107 Mdot
.26421 .15583 Mdot
.26663 .1604 Mdot
.2864 .16483 Mdot
.2883 .16911 Mdot
.30138 .17315 Mdot
.30989 .17699 Mdot
.36692 .18102 Mdot
.38378 .18541 Mdot
.39271 .19045 Mdot
.4045 .19604 Mdot
.40628 .2011 Mdot
.42477 .20577 Mdot
.43511 .21012 Mdot
.43763 .21487 Mdot
.44642 .2207 Mdot
.46431 .22668 Mdot
.46944 .23254 Mdot
.47815 .23944 Mdot
.49849 .24709 Mdot
.50953 .2538 Mdot
.51669 .2602 Mdot
.52036 .26642 Mdot
.56187 .27213 Mdot
.56799 .27756 Mdot
.57048 .28269 Mdot
.57228 .28741 Mdot
.5817 .29172 Mdot
.58355 .29589 Mdot
.58356 .29997 Mdot
.58822 .30389 Mdot
.58876 .3078 Mdot
.59028 .31163 Mdot
.59596 .31546 Mdot
.60294 .31968 Mdot
.60656 .32394 Mdot
.61047 .32822 Mdot
.61803 .3328 Mdot
.63141 .33721 Mdot
.63674 .34127 Mdot
.63881 .34527 Mdot
.65074 .34931 Mdot
.65242 .35343 Mdot
.65451 .3576 Mdot
.65562 .36168 Mdot
.66357 .36609 Mdot
.66503 .37064 Mdot
.68174 .37482 Mdot
.68361 .37899 Mdot
.69342 .38354 Mdot
.69367 .38818 Mdot
.69602 .39304 Mdot
.69711 .39823 Mdot
.7017 .40331 Mdot
.70741 .40846 Mdot
.72107 .41376 Mdot
.72328 .4196 Mdot
.74095 .42568 Mdot
.76074 .43165 Mdot
.76751 .43762 Mdot
.78587 .44308 Mdot
.79402 .44815 Mdot
.79697 .45357 Mdot
.80648 .45957 Mdot
.80783 .46587 Mdot
.8217 .47211 Mdot
.82184 .4778 Mdot
.82875 .48318 Mdot
.82962 .48909 Mdot
.83631 .49575 Mdot
.84141 .50195 Mdot
.84259 .50778 Mdot
.84943 .51367 Mdot
.8621 .51945 Mdot
.86396 .52643 Mdot
.87659 .53487 Mdot
.88005 .54278 Mdot
.88237 .55092 Mdot
.8924 .55924 Mdot
.91285 .56714 Mdot
.91286 .57489 Mdot
.94761 .58291 Mdot
.95114 .59272 Mdot
.96423 .60332 Mdot
.97619 .60332 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`00
0?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool0
0ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo013ooooo0_l0003loooo
o`003oooool2o`00017ooooo0_l0003looooo`003oooool00ol0003oooooooooo`3oooooo`oooooo
000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?
ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oo
oooo3oooool000oooooo0_l0003ooooooa3ooooo000?ooooo`03o`000?oooooooooo0?oooooo3ooo
ool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3ooooo
o`oooooo0007ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`oooooo0006ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`3oooooo`oooooo0005o`000003oooo
ool0003ooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`3oooooo`oooooo
0007ooooo`?o00001Oooool3o`0001oooooo0_l0003]ooooo`001_ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool07oooool2o`000>gooooo0006ooooo`05o`000?oooooo
ooooooooool000001?ooool00ol0003oooooooooo`3oooooo`oooooo0007ooooo`?o00001Oooool0
0ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo02;ooooo0_l0003Zoooo
o`003oooool00ol0003oooooooooo`0Rooooo`;o0000j_ooool000oooooo0_l0003ooooooa3ooooo
000?ooooo`03o`000?oooooooooo02[ooooo0_l0003Rooooo`003oooool00ol0003oooooooooo`0Z
ooooo`;o0000h_ooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003o
ooooooooo`0/ooooo`;o0000h?ooool000oooooo00?o0000ooooooooool0;?ooool2o`000>3ooooo
000?ooooo`;o0000ooooool@ooooo`003oooool00ol0003oooooooooo`0`ooooo`;o0000g?ooool0
00oooooo00?o0000ooooooooool0<?ooool2o`000=cooooo000?ooooo`03o`000?oooooooooo037o
oooo0_l0003Kooooo`003oooool00ol0003oooooooooo`0aooooo`?o0000f_ooool000oooooo00?o
0000ooooooooool0<_ooool2o`000=[ooooo000?ooooo`;o0000=?ooool2o`000=Wooooo000?oooo
o`03o`000?oooooooooo03?ooooo0_l0003Iooooo`003oooool00ol0003oooooooooo`0fooooo`;o
0000e_ooool000oooooo00?o0000ooooooooool0=_ooool2o`0000?ooooo0_l0003Aooooo`001ooo
ool3o`0000Gooooo00?o0000ooooooooool0>oooool4o`000<oooooo0006ooooo`05o`000?oooooo
ooooooooool000001?ooool00ol0003oooooooooo`0mooooo`;o0000coooool000Go000000?ooooo
o`000?ooool00_ooool00ol0003oooooooooo`02ooooo`?o0000?_ooool2o`000<kooooo0006oooo
o`Co00001Oooool00ol0003oooooooooo`0nooooo`?o0000cOooool000Kooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`0oooooo`?o0000c?ooool000Oooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`10ooooo`;o00000oooool2o`000<Oooooo0008ooooo`;o00001Ooo
ool00ol0003oooooooooo`15ooooo`;o0000aoooool000oooooo00?o0000ooooooooool0A_ooool2
o`000<Kooooo000?ooooo`;o0000Aoooool2o`0000;ooooo0_l00032ooooo`003oooool00ol0003o
ooooooooo`1:ooooo`Co0000`?ooool000oooooo00?o0000ooooooooool0C?ooool2o`0000kooooo
0_l0002`ooooo`003oooool00ol0003oooooooooo`1Looooo`;o00000oooool2o`000:_ooooo000?
ooooo`03o`000?oooooooooo067ooooo0_l0002[ooooo`003oooool00ol0003oooooooooo`1Soooo
o`;o0000ZOooool000oooooo00?o0000ooooooooool0Hoooool2o`000003ooooool0003o00000:Ko
oooo000?ooooo`;o0000Ioooool2o`000:Kooooo000?ooooo`03o`000?oooooooooo06Oooooo0_l0
002Uooooo`003oooool00ol0003oooooooooo`1Wooooo`;o00000oooool2o`000:3ooooo000?oooo
o`03o`000?oooooooooo06cooooo0_l000000ooooooo0000o`00002Mooooo`003oooool00ol0003o
ooooooooo`1_ooooo`?o0000W?ooool000oooooo00?o0000ooooooooool0L?ooool2o`0009cooooo
000?ooooo`;o0000Loooool2o`0009[ooooo000?ooooo`03o`000?oooooooooo07;ooooo0_l0002J
ooooo`003oooool00ol0003oooooooooo`1gooooo`;o0000UOooool000Sooooo0ol00004ooooo`03
o`000?oooooooooo07Oooooo0ol0002Dooooo`002Oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo07Sooooo0_l0002Dooooo`001Ol000000ooooooo0000o`000003o`0000Cooooo00?o
0000ooooooooool0Noooool2o`00097ooooo0006ooooo`04o`000?ooooooooooo`0000Gooooo0ol0
001kooooo`;o0000TOooool000Oooooo00?o0000ooooool000001Oooool00ol0003oooooooooo`20
ooooo`;o0000S?ooool000Sooooo0_l00005ooooo`03o`000?oooooooooo083ooooo0_l0002<oooo
o`002Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo08Cooooo0_l00028ooooo`00
3oooool00ol0003oooooooooo`24ooooo`;o0000R?ooool000oooooo00?o0000ooooooooool0Q_oo
ool2o`0008Kooooo000?ooooo`;o0000Qoooool2o`0008Kooooo000?ooooo`03o`000?oooooooooo
08Oooooo0_l00025ooooo`003oooool00ol0003oooooooooo`27ooooo`;o00002Oooool2o`0007[o
oooo000?ooooo`03o`000?oooooooooo09;ooooo0_l0001jooooo`003oooool00ol0003ooooooooo
o`2Dooooo`;o0000N?ooool000oooooo00?o0000ooooooooool0U?ooool2o`0007Sooooo000?oooo
o`;o0000UOooool2o`0007Sooooo000?ooooo`03o`000?oooooooooo09Gooooo0_l0001gooooo`00
3oooool00ol0003oooooooooo`2Eooooo`;o000000?oooooo`000?l00000M?ooool000oooooo00?o
0000ooooooooool0V?ooool2o`0007Cooooo000?ooooo`03o`000?oooooooooo09Sooooo0_l0001d
ooooo`003oooool00ol0003oooooooooo`2Hooooo`?o0000Loooool000oooooo0_l0002Jooooo`?o
0000L_ooool000oooooo00?o0000ooooooooool0V_ooool2o`0007;ooooo000?ooooo`03o`000?oo
oooooooo09[ooooo1?l0001`ooooo`003oooool00ol0003oooooooooo`2Looooo`;o0000L?ooool0
00Kooooo1Ol00004ooooo`03o`000?oooooooooo09gooooo0_l0001_ooooo`001oooool01?l0003o
ooooooooool00004ooooo`03o`000?oooooooooo09gooooo1?l0001]ooooo`001Ol00003ooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool0Woooool3o`0006cooooo0009ooooo`03o`00
0?oooooooooo00?ooooo0ol0002Pooooo`Co0000J_ooool000Kooooo00Go0000oooooooooooooooo
o`000004ooooo`03o`000?oooooooooo0:;ooooo0_l000000ooooooo0000o`00001Wooooo`001_oo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0YOooool2o`0006Oooooo
0007ooooo`?o00001Oooool00ol0003oooooooooo`2Wooooo`;o0000IOooool000oooooo00?o0000
ooooooooool0Yoooool2o`0006Gooooo000?ooooo`03o`000?oooooooooo0:Oooooo0_l00002oooo
o`;o0000HOooool000oooooo0_l0002/ooooo`;o0000HOooool000oooooo00?o0000ooooooooool0
Zoooool3o`00063ooooo000?ooooo`03o`000?oooooooooo0:cooooo0_l0001Pooooo`003oooool0
0ol0003oooooooooo`2/ooooo`Co0000G_ooool000oooooo00?o0000ooooooooool0[_ooool2o`00
05kooooo000?ooooo`03o`000?oooooooooo0:oooooo0_l0001Mooooo`003oooool2o`000;3ooooo
0_l00002ooooo`;o0000FOooool000oooooo00?o0000ooooooooool0;?ooool5o`0002oooooo0ol0
000^ooooo`?o00007oooool3o`0000gooooo0ol0000[ooooo`?o00001?ooool2o`0001Cooooo000?
ooooo`03o`000?oooooooooo02gooooo00Co0000oooooooooooo0000<?ooool00ol0003ooooooooo
o`0/ooooo`05o`000?ooooooooooooooool000007oooool2o`000003ooooool0003o000000Wooooo
00Go0000ooooooooooooooooo`00000[ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00004oooool000oooooo00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0]ooooo`Go
0000;Oooool01Ol0003ooooooooooooooooo000002;ooooo0_l00009ooooo`05o`000?oooooooooo
ooooool00000:oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0001?ooooo000?
ooooo`03o`000?oooooooooo02oooooo00?o0000ooooooooool0;?ooool01?l0003oooooooooool0
000^ooooo`Co00008oooool2o`0000[ooooo0ol0000/ooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00004oooool000oooooo00?o0000ooooooooool0;?ooool01Ol0003ooooooooo
oooooooo000002kooooo00?o0000ooooool00000;_ooool00ol0003oooooooooo`0Tooooo`;o0000
2Oooool01Ol0003ooooooooooooooooo000002_ooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool0000Cooooo`003oooool2o`0002gooooo00Go0000ooooooooooooooooo`00000_oooo
o`;o0000;oooool00ol0003oooooooooo`0Sooooo`?o00002?ooool01Ol0003ooooooooooooooooo
000002[ooooo0_l00004ooooo`04o`000?ooooooooooo`0001?ooooo000?ooooo`03o`000?oooooo
oooo02gooooo0ol0000aooooo`03o`000?oooooooooo02kooooo0_l0000Tooooo`;o00002Oooool3
o`0002cooooo00?o0000ooooooooool00oooool2o`0001Cooooo000?ooooo`03o`000?oooooooooo
0;Wooooo0_l0001Cooooo`003oooool00ol0003oooooooooo`2iooooo`Co0000DOooool000oooooo
00?o0000ooooooooool0^oooool2o`00057ooooo000?ooooo`03o`000?oooooooooo0;kooooo0_l0
001>ooooo`002?ooooooo`0001Wo0000000?ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo0_l00004oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08oooo
o`003oooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo02oooooo00?o0000oooooooo
ool0;oooool00ol0003oooooooooo`0^ooooo`;o0000<?ooool00ol0003oooooooooo`0Eooooo`00
3oooool00ol0003oooooooooo`34ooooo`;o0000B?ooool000oooooo00?o0000ooooooooool0bOoo
ool2o`0004?ooooo000?ooooo`03o`000?oooooooooo0<Wooooo1?l00011ooooo`003oooool00ol0
003oooooooooo`3;ooooo`;o0000@Oooool000oooooo0_l0003Aooooo`;o0000??ooool000oooooo
00?o0000ooooooooool0d?ooool2o`000003ooooool0003o000003Wooooo000?ooooo`03o`000?oo
oooooooo0=?ooooo0_l0000iooooo`003oooool00ol0003oooooooooo`3Cooooo`;o0000>Oooool0
00oooooo00?o0000ooooooooool0doooool2o`000003ooooool0003o000003Kooooo000?ooooo`03
o`000?oooooooooo0=Kooooo0_l0000fooooo`003oooool2o`000=Oooooo0_l0000fooooo`003ooo
ool00ol0003oooooooooo`3Fooooo`;o0000=_ooool000oooooo00?o0000ooooooooool0f_ooool2
o`0003;ooooo000?ooooo`03o`000?oooooooooo0=[ooooo0_l0000booooo`003oooool00ol0003o
ooooooooo`3Jooooo`;o0000<_ooool000oooooo00?o0000ooooooooool0f_ooool4o`00033ooooo
000?ooooo`;o0000gOooool2o`00033ooooo000?ooooo`03o`000?oooooooooo0=gooooo0_l0000_
ooooo`003oooool00ol0003oooooooooo`3Mooooo`;o0000;oooool000oooooo00?o0000oooooooo
ool0g_ooool2o`0002kooooo0006ooooo`Go00001?ooool00ol0003oooooooooo`3Nooooo`Co0000
;?ooool000Oooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`3Pooooo`;o0000
;?ooool000Sooooo00?o0000ooooooooool01?ooool3o`000>3ooooo0_l0000/ooooo`002Oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo0>3ooooo0_l0000/ooooo`001_ooool01Ol0
003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0h_ooool2o`0002[ooooo0006oooo
o`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3Rooooo`;o00000_ooool2
o`0002Kooooo0007ooooo`?o00001Oooool00ol0003oooooooooo`3Vooooo`;o00009_ooool000oo
oooo00?o0000ooooooooool0i_ooool2o`0002Kooooo000?ooooo`;o0000ioooool2o`0002Kooooo
000?ooooo`03o`000?oooooooooo0>[ooooo0_l0000Rooooo`003oooool00ol0003oooooooooo`3Z
ooooo`;o00008_ooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003o
ooooooooo`3[ooooo`;o00008Oooool000oooooo00?o0000ooooooooool0joooool2o`00027ooooo
000?ooooo`;o0000k?ooool2o`00027ooooo000?ooooo`03o`000?oooooooooo0>_ooooo0_l0000Q
ooooo`003oooool00ol0003oooooooooo`3^ooooo`;o00007_ooool000oooooo00?o0000oooooooo
ool0k_ooool2o`0001kooooo000?ooooo`03o`000?oooooooooo0?Cooooo0_l0000Hooooo`003ooo
ool00ol0003oooooooooo`3dooooo`;o00006?ooool000oooooo00?o0000ooooooooool0ooooool?
ooooo`003oooool2o`000?Gooooo0_l0000Hooooo`003oooool00ol0003oooooooooo`3dooooo`;o
00006?ooool000oooooo00?o0000ooooooooool0oOooool2o`0000oooooo0008ooooo`?o00001?oo
ool00ol0003oooooooooo`3mooooo`;o00003oooool000Wooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`3oooooo`oooooo0006ooooo`Go00001?ooool00ol0003oooooooooo`3noooo
o`;o00003_ooool000Kooooo00Co0000oooooooooooo00001Oooool3o`000?kooooo0_l0000>oooo
o`001oooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0?oooooo0oooool2o`000003
ooooool0003o000000Oooooo0008ooooo`;o00001Oooool00ol0003oooooooooo`3oooooo`?ooooo
0_l000000ooooooo0000o`000007ooooo`002Oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0
003oooooooooo`3oooooo`oooooo000?ooooo`;o0000ooooool@ooooo`00oooooolQooooo`00oooo
oolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.620606, -9.62357, \
0.0400959, 0.0810115}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\[Beta]\&^ = \[Beta] /. \[Beta]hat\), "\[IndentingNewLine]", 
    \(stdErr\[Beta]\)}], "Input"],

Cell[BoxData[
    \({32.58194764833275`, \(-0.8429027257850936`\), 2.1746758228063`, 
      2.87763826612114`, \(-1.4995648512384798`\), 0.9623430705691278`, 
      1.4852615974361796`, 3.451923108675684`}\)], "Output"],

Cell[BoxData[
    \({3.0976498726309942`, 0.4512032915143883`, 0.4199052088620424`, 
      0.5070521403044302`, 0.47573568693769996`, 0.489670557481027`, 
      0.44196720049451826`, 0.5460103237014522`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(zScores = \(stdVar = \[Beta]\&^/stdErr\[Beta]\)\)], "Input"],

Cell[BoxData[
    \({10.518279659753546`, \(-1.8681218458226039`\), 5.178968435994748`, 
      5.675231474998661`, \(-3.1520966209012937`\), 1.9652867746830278`, 
      3.3605697340760052`, 6.322083958550073`}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(\[Alpha]lpha = 0.05;\)\), "\n", 
    \(\(q = 
        Quantile[NormalDistribution[0, 1], 1 - \[Alpha]lpha/2];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(pValues = 
      Map[2\ \((1 - \ CDF[NormalDistribution[0, 1], Abs[#]])\) &, 
        zScores]\)], "Input"],

Cell[BoxData[
    \({0.`, 0.061745089176955315`, 2.2311621261650316`*^-7, 
      1.3850124380709872`*^-8, 0.0016210262395919273`, 0.04938105542351501`, 
      0.0007778189263900614`, 2.5805912962084676`*^-10}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " 95% Confidence Interval for ",
  Cell[BoxData[
      \(\[Beta]\&^\)]],
  " "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ci95 = 
      Transpose[{\[Beta]\&^ - q\ stdErr\[Beta], \[Beta]\&^ + 
            q\ stdErr\[Beta]}]\)], "Input"],

Cell[BoxData[
    \({{26.510665461260917`, 38.65322983540459`}, {\(-1.7272449268592216`\), 
        0.041439475289034355`}, {1.351676736515928`, 
        2.9976749090966726`}, {1.8838343328405065`, 
        3.8714421994017734`}, {\(-2.431989663796794`\), \
\(-0.5671400386801657`\)}, {0.0026064136166646934`, 
        1.922079727521591`}, {0.6190218021189308`, 
        2.3515013927534283`}, {2.3817625390337813`, 
        4.522083678317586`}}\)], "Output"]
}, Open  ]],

Cell["Significance Test", "BulletedList"],

Cell["\<\
Log partial likelihood ratio test can be used to test the full \
model against reduced models.  The basic test is full model vs no covariates.\
\
\>", "Text"],

Cell[BoxData[{
    \(\(\[Lambda] = 
        2\ \((maxLogL\[Beta] - 
              valuelogL\[Beta]0)\);\)\), "\[IndentingNewLine]", 
    \(\(note1 = \*"\"\<Probability \[Beta] > \!\(\[Beta]\&^\) given Ho: \
coefficients are simultaneously zero: \>\"" <> 
          numberForm[
            pTest = \((1 - 
                  CDF[ChiSquareDistribution[
                      Length[\[Beta]]], \[Lambda]])\)];\)\), "\
\[IndentingNewLine]", 
    \(\(note2 = 
        If[pTest \[LessEqual] 
            0.05, "\<Reject Ho: \[Beta] = 0\>", "\<Accept Ho: \[Beta] = \
0\>"];\)\)}], "Input",
  ShowSelection->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Table of Estimated Coefficients and Confidence Intervals", \
"Subsubsection",
  ShowSelection->True,
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(tableTitle = "\<\nProportional Hazards Model Solution of Estimated \
Coefficients\>";\)\), "\n", 
    \(\(\(tableColumnLabels = {"\<Variable \>", "\<Coefficent\>", "\< Std \
Error \>", "\< z \>", "\< P >|z| \>", "\< 95% CI\>"};\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(blankRow = setshowTableOpts[Length[tableColumnLabels]];\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(showData = 
        numberForm[
          Transpose[{\[Beta]nameList, \[Beta] /. \[Beta]hat, stdErr\[Beta], 
              zScores, pValues, ci95}]];\)\), "\[IndentingNewLine]", 
    \(\(tableData = Join[{tableColumnLabels}, showData];\)\), "\n", 
    \(\(notes = {note1, note2};\)\), "\[IndentingNewLine]", 
    \(showTable[tableTitle, tableData, notes, 
      ColumnSpacings \[Rule] {4, 3, 3, 3, 3, 5}]\)}], "Input",
  ShowCellBracket->True,
  ShowSelection->True,
  ShowClosedCellArea->False],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            StyleBox[\(\(\n\)\(Proportional\ Hazards\ Model\ Solution\ of\ \
Estimated\ Coefficients\)\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Variable\)\(\ \)\), 
                    "Coefficent", \(\(\ \)\(\(Std\)\(\ \)\(Error\)\(\ \)\)\), \
\(\(\ \)\(z\)\(\ \)\), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\ \
\)\)\), \(\(\ \)\(95  %\ CI\)\)},
                  {"logStress", "32.582", "3.098", 
                    "10.518", \(\(<\)\(.001\)\), \({"26.511", "38.653"}\)},
                  {"Spool1", \(-0.843\), "0.451", \(-1.868\), 
                    "0.062", \({"-1.727", "0.041"}\)},
                  {"Spool2", "2.175", "0.42", 
                    "5.179", \(\(<\)\(.001\)\), \({"1.352", "2.998"}\)},
                  {"Spool3", "2.878", "0.507", 
                    "5.675", \(\(<\)\(.001\)\), \({"1.884", "3.871"}\)},
                  {"Spool4", \(-1.5\), "0.476", \(-3.152\), 
                    "0.002", \({"-2.432", "-0.567"}\)},
                  {"Spool5", "0.962", "0.49", "1.965", 
                    "0.049", \({"0.003", "1.922"}\)},
                  {"Spool6", "1.485", "0.442", 
                    "3.361", \(\(<\)\(.001\)\), \({"0.619", "2.352"}\)},
                  {"Spool7", "3.452", "0.546", 
                    "6.322", \(\(<\)\(.001\)\), \({"2.382", "4.522"}\)}
                  },
                RowSpacings->3,
                ColumnSpacings->{4, 3, 3, 3, 3, 5},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            
            StyleBox[\(\(\n\)\(Probability\ \[Beta]\  > \ \[Beta]\&^\ given\ \
\(Ho : \ coefficients\ are\ simultaneously\ \(zero : \ \(\(<\)\(.001\)\)\)\)\n
              
              Reject\ \(Ho : \ \[Beta]\)\  = \ 0\)\),
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Output", "Subsubsection"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            StyleBox[\(\(\n\)\(Proportional\ Hazards\ Model\ Solution\ of\ \
Estimated\ Coefficients\)\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Variable\)\(\ \)\), 
                    "Coefficent", \(\(\ \)\(\(Std\)\(\ \)\(Error\)\(\ \)\)\), \
\(\(\ \)\(z\)\(\ \)\), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\ \
\)\)\), \(\(\ \)\(95  %\ CI\)\)},
                  {"logStress", "32.582", "3.098", 
                    "10.518", \(\(<\)\(.001\)\), \({"26.511", "38.653"}\)},
                  {"Spool1", \(-0.843\), "0.451", \(-1.868\), 
                    "0.062", \({"-1.727", "0.041"}\)},
                  {"Spool2", "2.175", "0.42", 
                    "5.179", \(\(<\)\(.001\)\), \({"1.352", "2.998"}\)},
                  {"Spool3", "2.878", "0.507", 
                    "5.675", \(\(<\)\(.001\)\), \({"1.884", "3.871"}\)},
                  {"Spool4", \(-1.5\), "0.476", \(-3.152\), 
                    "0.002", \({"-2.432", "-0.567"}\)},
                  {"Spool5", "0.962", "0.49", "1.965", 
                    "0.049", \({"0.003", "1.922"}\)},
                  {"Spool6", "1.485", "0.442", 
                    "3.361", \(\(<\)\(.001\)\), \({"0.619", "2.352"}\)},
                  {"Spool7", "3.452", "0.546", 
                    "6.322", \(\(<\)\(.001\)\), \({"2.382", "4.522"}\)}
                  },
                RowSpacings->3,
                ColumnSpacings->{4, 3, 3, 3, 3, 5},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            
            StyleBox[\(\(\n\)\(Probability\ \[Beta]\  > \ \[Beta]\&^\ given\ \
\(Ho : \ coefficients\ are\ simultaneously\ \(zero : \ \(\(<\)\(.001\)\)\)\)\n
              
              Reject\ \(Ho : \ \[Beta]\)\  = \ 0\)\),
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Contrasts", "Subsubsection"],

Cell[TextData[{
  " Contrasts can be tested for reference cell coded designs, i.e. 0 or 1 \
dummy variables.  \nIf c = vector of contrasts then c\[Beta] is the test of \
differences in coefficients.  This linear combination is Normally distributed \
with mean c\[Beta] and variance ",
  Cell[BoxData[
      \(TraditionalForm\`\(c\^T\) \(V(\[Beta]\&^)\)\ c\)]],
  ".  The sum of c components must be equal to 0."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(c = {0, 0, 0, 1, 0, 0, 0, \(-1\)}\ \  (*\ 
      are\ spools\ Nr\ 3\ and\ Nr\ 7\ the\ \(\(same\)\(?\)\)\ *) \), "\
\[IndentingNewLine]", 
    \(c . \[Beta]\&^\), "\[IndentingNewLine]", 
    \(q = 
      Abs[c . \[Beta]\&^]\/\@\(c . varCov\[Beta] . c\)\), \
"\[IndentingNewLine]", 
    \(2 \((1 - CDF[NormalDistribution[0, 1], q])\)\)}], "Input"],

Cell[BoxData[
    \({0, 0, 0, 1, 0, 0, 0, \(-1\)}\)], "Output"],

Cell[BoxData[
    \(\(-0.5742848425545439`\)\)], "Output"],

Cell[BoxData[
    \(1.2679661266712103`\)], "Output"],

Cell[BoxData[
    \(0.20481004742593845`\)], "Output"]
}, Open  ]],

Cell["\<\
Spool Nr 3 could be considered as similar to Spool Nr 7 in its \
effect on survivability.\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Stratification by Spool", "Subsection"],

Cell[TextData[{
  StyleBox["If the Proportional Hazards assumption is valid then stratified \
subpopulation cumulative hazard functions ",
    FontFamily->"Times New Roman"],
  Cell[BoxData[
      \(TraditionalForm\`H\_0\)]],
  StyleBox[" should be roughly parallel.",
    FontFamily->"Times New Roman"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Beta]nameList\)], "Input"],

Cell[BoxData[
    \({"logStress", "Spool1", "Spool2", "Spool3", "Spool4", "Spool5", 
      "Spool6", "Spool7"}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(spoolSelectData[spoolNr_] := 
        Cases[inputData, 
          y_ /; MatchQ[covariatesf[y], 
              Join[{_}, fx4[spoolNr]]]];\)\)], "Input"],

Cell["\<\
Pull off the individual data populations by spool number; keyed by \
covariate pattern\
\>", "BulletedList"],

Cell[BoxData[
    \(\(spoolphData = Map[spoolSelectData, spoolList];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\[Beta]\), "\[IndentingNewLine]", 
    \(\[Beta]stress = 
      Join[{\[Beta]\[LeftDoubleBracket]1\[RightDoubleBracket]}, 
        fx4[8]]\)}], "Input"],

Cell[BoxData[
    \({\[Beta]x1, \[Beta]x2, \[Beta]x3, \[Beta]x4, \[Beta]x5, \[Beta]x6, \
\[Beta]x7, \[Beta]x8}\)], "Output"],

Cell[BoxData[
    \({\[Beta]x1, 0, 0, 0, 0, 0, 0, 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(logHs = 
        Map[\(Last[
                boxedPH[
                  spoolphData\[LeftDoubleBracket]#\[RightDoubleBracket], \
\[Beta]stress]]\)\[LeftDoubleBracket]2\[RightDoubleBracket] &, 
          spoolList];\)\)], "Input"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-15.622769532817003`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-24.721217553492945`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -15.622769532817003, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -24.721217553492945],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{22.70867199593736`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {22.708671995937362, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{1.6653345369377348`*^-16}\),
      SequenceForm[ "Gradient vector ", {1.6653345369377348*^-16}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{55.9195015830646`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{55.919501583064601}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{7.4779343125668465`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {7.4779343125668465}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9722749123921606`, 
          0.9681089946480498`, 0.9664541105850222`, 0.9595561481820836`, 
          0.95020873045374`, 0.9326465532870722`, 0.8361100700896141`, 
          0.5273399860256537`, 0.27732564471840154`, 0.1460468444974718`, 
          0.019072573581467255`}\),
      SequenceForm[ 
      "\[Alpha] ", {0.97227491239216057, 0.96810899464804978, 
        0.96645411058502217, 0.95955614818208357, 0.95020873045373999, 
        0.93264655328707224, 0.83611007008961413, 0.52733998602565368, 
        0.27732564471840154, 0.14604684449747179, 0.019072573581467255}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-28.937962305565478`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-48.47118135183523`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -28.937962305565478, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -48.471181351835227],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{47.538857516312724`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {47.538857516312724, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{2.211818853070646`*^-9}\),
      SequenceForm[ "Gradient vector ", {2.2118188530706462*^-09}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{189.59000246860552`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{189.59000246860552}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{13.769168546742593`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {13.769168546742593}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9984069417225739`, 
          0.9981692264578075`, 0.9978479111388635`, 0.9973892840254998`, 
          0.9966807266916266`, 0.9954381869474824`, 0.9944380235226953`, 
          0.9925231407649865`, 0.977599490436702`, 0.9311389019128103`, 
          0.9168297950179726`, 0.894972947858072`, 0.8573689998548244`, 
          0.7766398402667987`, 0.43078833532778305`, 0.04330458430963894`, 
          0.021498348209577446`, 0.007119602508681276`, 
          0.0009535411174119876`, 7.290171339096044`*^-6, 1.`*^-6, 1.`*^-6}\),
      
      SequenceForm[ 
      "\[Alpha] ", {0.99840694172257394, 0.99816922645780748, 
        0.99784791113886351, 0.99738928402549976, 0.99668072669162655, 
        0.99543818694748243, 0.99443802352269528, 0.99252314076498649, 
        0.97759949043670202, 0.93113890191281035, 0.91682979501797257, 
        0.89497294785807202, 0.8573689998548244, 0.77663984026679866, 
        0.43078833532778305, 0.04330458430963894, 0.021498348209577446, 
        0.007119602508681276, 0.0009535411174119876, 7.2901713390960438*^-06, 
        9.9999999999999995*^-07, 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-11.830220139156776`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-17.502307845873887`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -11.830220139156776, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -17.502307845873887],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{21.819544931880436`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {21.819544931880436, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{2.7755575615628914`*^-17}\),
      SequenceForm[ "Gradient vector ", {2.7755575615628914*^-17}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{67.88034992172918`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{67.880349921729177}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{8.238953205458154`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {8.238953205458154}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9700452176782592`, 
          0.9612553207490692`, 0.9450551274584016`, 0.9281996876632214`, 
          0.9193936324007427`, 0.9081229759093887`, 0.8170219713099537`, 
          0.42979662805728147`, 0.0993919610254906`, 0.000574868905892798`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.97004521767825924, 0.96125532074906916, 
        0.94505512745840159, 0.92819968766322136, 0.91939363240074268, 
        0.90812297590938873, 0.81702197130995369, 0.42979662805728147, 
        0.099391961025490597, 0.00057486890589279803, 
        9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-16.366440688259477`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-24.721217553492945`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -16.366440688259477, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -24.721217553492945],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{20.795029802942647`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {20.795029802942647, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{3.3306690738754696`*^-16}\),
      SequenceForm[ "Gradient vector ", {3.3306690738754696*^-16}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{53.51195714139884`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{53.511957141398838}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{7.315186746857447`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {7.3151867468574467}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.973653379877045`, 
          0.9704875561831625`, 0.9661990766555919`, 0.96084849327377`, 
          0.9584211014306948`, 0.9492006466362086`, 0.9213987111203846`, 
          0.8158147464468377`, 0.4849167083777912`, 0.19553540862603497`, 
          0.04171955653272541`}\),
      SequenceForm[ 
      "\[Alpha] ", {0.97365337987704503, 0.97048755618316251, 
        0.9661990766555919, 0.96084849327376998, 0.95842110143069481, 
        0.94920064663620862, 0.92139871112038463, 0.81581474644683771, 
        0.48491670837779122, 0.19553540862603497, 0.04171955653272541}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-6.472212212839288`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-10.60460290274525`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -6.4722122128392883, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -10.604602902745251],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{19.188731446729914`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {19.188731446729914, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{2.5174307083375425`*^-14}\),
      SequenceForm[ "Gradient vector ", {2.5174307083375425*^-14}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{113.44476984998582`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{113.44476984998582}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{10.651045481547143`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {10.651045481547143}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9535524878370588`, 
          0.935785400046623`, 0.8952378294183315`, 0.6491043432100623`, 
          0.11810421226607584`, 0.01748160097159942`, 
          0.000011320488367760449`, 1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.95355248783705882, 0.93578540004662303, 
        0.89523782941833152, 0.64910434321006227, 0.11810421226607584, 
        0.017481600971599419, 1.1320488367760449*^-05, 
        9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-12.398489484481173`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-19.98721449566189`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -12.398489484481173, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -19.987214495661888],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{25.353857244488186`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {25.353857244488186, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{\(-1.1102230246251565`*^-16\)}\),
      SequenceForm[ "Gradient vector ", {-1.1102230246251565*^-16}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{80.01317529048511`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{80.013175290485108}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{8.945008400805731`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {8.9450084008057313}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.968691115735272`, 
          0.9531620837028598`, 0.9042611713329973`, 0.8338215993790329`, 
          0.8019779408663225`, 0.7063544822216754`, 0.41529098283532595`, 
          0.07820164804747501`, 0.028308888707259148`, 
          0.0004427140641567432`, 1.`*^-6, 1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.968691115735272, 0.95316208370285982, 
        0.90426117133299733, 0.83382159937903289, 0.80197794086632246, 
        0.70635448222167541, 0.41529098283532595, 0.078201648047475009, 
        0.028308888707259148, 0.00044271406415674321, 9.9999999999999995*^-07,
         9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    RowBox[{\(Inverse::"sing"\), \(\(:\)\(\ \)\), "\<\"Matrix \\!\\({\\({0.`}\
\\)}\\) is singular. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::sing\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"unfl"\), \(\(:\)\(\ \)\), "\<\"Underflow occurred in \
computation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::unfl\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(FindRoot::"cvmit"\), \(\(:\)\(\ \)\), "\<\"Failed to converge \
to the requested accuracy or precision within \\!\\(100\\) iterations. \\!\\(\
\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", \
ButtonFrame->None, ButtonData:>\\\"FindRoot::cvmit\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"unfl"\), \(\(:\)\(\ \)\), "\<\"Underflow occurred in \
computation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::unfl\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"unfl"\), \(\(:\)\(\ \)\), "\<\"Underflow occurred in \
computation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::unfl\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(General :: \\\"unfl\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-11.431281475929723`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-17.597618025678212`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -11.431281475929723, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -17.597618025678212],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{413.20383046057003`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {413.20383046057003, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{1.1102230246251565`*^-16}\),
      SequenceForm[ "Gradient vector ", {1.1102230246251565*^-16}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]\(-Inverse[{{0.`}}]\)\),
      SequenceForm[ "\!\(\[Beta]\&^\) Variance Covariance matrix ", 
        Times[ -1, 
          Inverse[ {{0.0}}]]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]\@Tr[\(-Inverse[{{0.`}}]\), List]\),
      SequenceForm[ "\!\(\[Beta]\&^\) Standard Error vector ", 
        Power[ 
          Tr[ 
            Times[ -1, 
              Inverse[ {{0.0}}]], List], 
          Rational[ 1, 2]]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9999990000000001`, 
          1.`, 1.`, 1.`, 1.`, 1.`, 1.`*^-6, Underflow[], Underflow[], 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.99999900000000008, 1.0, 1.0, 1.0, 1.0, 1.0, 
        9.9999999999999995*^-07, 
        Underflow[ ], 
        Underflow[ ], 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-12.602882160185292`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-23.399461713510625`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -12.602882160185292, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -23.399461713510625],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{35.7027319098318`, 0, 0, 0, 0, 0, 0, 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {35.702731909831797, 0, 0, 0, 0, 0, 0, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{4.3327841314777515`*^-13}\),
      SequenceForm[ "Gradient vector ", {4.3327841314777515*^-13}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{170.81399589736378`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{170.81399589736378}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{13.069582850931539`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {13.069582850931539}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9861833816846015`, 
          0.9829431649991708`, 0.976512790929217`, 0.9155058413055861`, 
          0.514018253134163`, 0.22075177469199841`, 0.15903094977405108`, 
          0.09540661403613084`, 0.038440089079772`, 0.004733041117977689`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98618338168460151, 0.98294316499917078, 
        0.97651279092921695, 0.9155058413055861, 0.51401825313416305, 
        0.22075177469199841, 0.15903094977405108, 0.095406614036130835, 
        0.038440089079771998, 0.0047330411179776887, 
        9.9999999999999995*^-07}],
      Editable->False]], "Print"]
}, Closed]],

Cell[BoxData[{
    \(\(levelText = 
        Map[ToString, 
          Range[Length[spoolphData]]];\)\), "\[IndentingNewLine]", 
    \(\(graphHslevels = 
        Graphics[
          Join[\[IndentingNewLine]Flatten[
              MapThread[
                Thread[Text[#1, #2]] &, {levelText, 
                  logHs}]], \[IndentingNewLine]Map[Line, 
              logHs]]];\)\)}], "Input"],

Cell[TextData[{
  StyleBox["Under the stratified model with individual populations of the \
predominant variable, in this case the spool number, the Proportional Hazards \
assumption is tested.  First note that according to ",
    FontWeight->"Bold"],
  StyleBox["Crowder, M.J., Kimber, A.C., Smith, R.L., and Sweeting, T.J., \
(1991).  ",
    FontFamily->"Times New Roman",
    FontWeight->"Bold"],
  StyleBox["Statistical Analysis of Reliability Data",
    FontFamily->"Times New Roman",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[", Chapman & Hall, London, pgs 113. these are rather small sample \
sizes and are particularly variable at the extremes.  Spool 7 data consists \
of extreme values with regard to the mean stress point.  Under the PH \
assumption the plot of ",
    FontFamily->"Times New Roman",
    FontWeight->"Bold"],
  Cell[BoxData[
      \(TraditionalForm\`H\_0\)],
    FontWeight->"Bold"],
  StyleBox[" should be roughly parallel for the stratified populations which \
is the case.  Crowder, et al use smoothed ",
    FontWeight->"Bold"],
  Cell[BoxData[
      \(TraditionalForm\`H\_0\)],
    FontWeight->"Bold"],
  StyleBox[" values.",
    FontWeight->"Bold"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[graphHslevels, Frame \[Rule] True, AspectRatio \[Rule] 1.0, 
        FrameLabel \[Rule] {"\<log time\>", "\<logH0\>", "\<Log Cumulative \
Hazard Plot\>", "\<\>"}];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0896668 0.75853 0.0531809 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.20314 -0.0125 -3 -9 ]
[.20314 -0.0125 3 0 ]
[.38248 -0.0125 -3 -9 ]
[.38248 -0.0125 3 0 ]
[.56181 -0.0125 -3 -9 ]
[.56181 -0.0125 3 0 ]
[.74114 -0.0125 -3 -9 ]
[.74114 -0.0125 3 0 ]
[.92048 -0.0125 -6 -9 ]
[.92048 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -26 -21 ]
[.5 -0.0125 26 -9 ]
[-0.0125 .09377 -30 -4.5 ]
[-0.0125 .09377 0 4.5 ]
[-0.0125 .22672 -18 -4.5 ]
[-0.0125 .22672 0 4.5 ]
[-0.0125 .35967 -24 -4.5 ]
[-0.0125 .35967 0 4.5 ]
[-0.0125 .49263 -12 -4.5 ]
[-0.0125 .49263 0 4.5 ]
[-0.0125 .62558 -24 -4.5 ]
[-0.0125 .62558 0 4.5 ]
[-0.0125 .75853 -6 -4.5 ]
[-0.0125 .75853 0 4.5 ]
[-0.0125 .89148 -18 -4.5 ]
[-0.0125 .89148 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .5 -42 -17 ]
[-0.01875 .5 -30 17 ]
[ 0 1 .125 0 ]
[.5 1.0125 -80 0 ]
[.5 1.0125 80 12 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.20314 0 m
.20314 .00625 L
s
[(2)] .20314 -0.0125 0 1 Mshowa
.38248 0 m
.38248 .00625 L
s
[(4)] .38248 -0.0125 0 1 Mshowa
.56181 0 m
.56181 .00625 L
s
[(6)] .56181 -0.0125 0 1 Mshowa
.74114 0 m
.74114 .00625 L
s
[(8)] .74114 -0.0125 0 1 Mshowa
.92048 0 m
.92048 .00625 L
s
[(10)] .92048 -0.0125 0 1 Mshowa
.125 Mabswid
.06864 0 m
.06864 .00375 L
s
.11348 0 m
.11348 .00375 L
s
.15831 0 m
.15831 .00375 L
s
.24798 0 m
.24798 .00375 L
s
.29281 0 m
.29281 .00375 L
s
.33764 0 m
.33764 .00375 L
s
.42731 0 m
.42731 .00375 L
s
.47214 0 m
.47214 .00375 L
s
.51698 0 m
.51698 .00375 L
s
.60664 0 m
.60664 .00375 L
s
.65148 0 m
.65148 .00375 L
s
.69631 0 m
.69631 .00375 L
s
.78598 0 m
.78598 .00375 L
s
.83081 0 m
.83081 .00375 L
s
.87564 0 m
.87564 .00375 L
s
.96531 0 m
.96531 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -87 -25 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(log) show
87.000 13.000 moveto
(time) show
111.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .09377 m
.00625 .09377 L
s
[(-12.5)] -0.0125 .09377 1 0 Mshowa
0 .22672 m
.00625 .22672 L
s
[(-10)] -0.0125 .22672 1 0 Mshowa
0 .35967 m
.00625 .35967 L
s
[(-7.5)] -0.0125 .35967 1 0 Mshowa
0 .49263 m
.00625 .49263 L
s
[(-5)] -0.0125 .49263 1 0 Mshowa
0 .62558 m
.00625 .62558 L
s
[(-2.5)] -0.0125 .62558 1 0 Mshowa
0 .75853 m
.00625 .75853 L
s
[(0)] -0.0125 .75853 1 0 Mshowa
0 .89148 m
.00625 .89148 L
s
[(2.5)] -0.0125 .89148 1 0 Mshowa
.125 Mabswid
0 .12036 m
.00375 .12036 L
s
0 .14695 m
.00375 .14695 L
s
0 .17354 m
.00375 .17354 L
s
0 .20013 m
.00375 .20013 L
s
0 .25331 m
.00375 .25331 L
s
0 .2799 m
.00375 .2799 L
s
0 .30649 m
.00375 .30649 L
s
0 .33308 m
.00375 .33308 L
s
0 .38626 m
.00375 .38626 L
s
0 .41285 m
.00375 .41285 L
s
0 .43945 m
.00375 .43945 L
s
0 .46604 m
.00375 .46604 L
s
0 .51922 m
.00375 .51922 L
s
0 .54581 m
.00375 .54581 L
s
0 .5724 m
.00375 .5724 L
s
0 .59899 m
.00375 .59899 L
s
0 .65217 m
.00375 .65217 L
s
0 .67876 m
.00375 .67876 L
s
0 .70535 m
.00375 .70535 L
s
0 .73194 m
.00375 .73194 L
s
0 .78512 m
.00375 .78512 L
s
0 .81171 m
.00375 .81171 L
s
0 .8383 m
.00375 .8383 L
s
0 .86489 m
.00375 .86489 L
s
0 .06718 m
.00375 .06718 L
s
0 .04059 m
.00375 .04059 L
s
0 .014 m
.00375 .014 L
s
0 .91807 m
.00375 .91807 L
s
0 .94466 m
.00375 .94466 L
s
0 .97125 m
.00375 .97125 L
s
0 .99784 m
.00375 .99784 L
s
.25 Mabswid
0 0 m
0 1 L
s
gsave
-0.01875 .5 -114 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
78 10 translate
90 rotate
-78 -10 translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(logH0) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .99375 m
.02381 1 L
s
.20314 .99375 m
.20314 1 L
s
.38248 .99375 m
.38248 1 L
s
.56181 .99375 m
.56181 1 L
s
.74114 .99375 m
.74114 1 L
s
.92048 .99375 m
.92048 1 L
s
.125 Mabswid
.06864 .99625 m
.06864 1 L
s
.11348 .99625 m
.11348 1 L
s
.15831 .99625 m
.15831 1 L
s
.24798 .99625 m
.24798 1 L
s
.29281 .99625 m
.29281 1 L
s
.33764 .99625 m
.33764 1 L
s
.42731 .99625 m
.42731 1 L
s
.47214 .99625 m
.47214 1 L
s
.51698 .99625 m
.51698 1 L
s
.60664 .99625 m
.60664 1 L
s
.65148 .99625 m
.65148 1 L
s
.69631 .99625 m
.69631 1 L
s
.78598 .99625 m
.78598 1 L
s
.83081 .99625 m
.83081 1 L
s
.87564 .99625 m
.87564 1 L
s
.96531 .99625 m
.96531 1 L
s
.25 Mabswid
0 1 m
1 1 L
s
gsave
.5 1.0125 -141 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Log) show
87.000 13.000 moveto
(Cumulative) show
153.000 13.000 moveto
(Hazard) show
195.000 13.000 moveto
(Plot) show
219.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .09377 m
1 .09377 L
s
.99375 .22672 m
1 .22672 L
s
.99375 .35967 m
1 .35967 L
s
.99375 .49263 m
1 .49263 L
s
.99375 .62558 m
1 .62558 L
s
.99375 .75853 m
1 .75853 L
s
.99375 .89148 m
1 .89148 L
s
.125 Mabswid
.99625 .12036 m
1 .12036 L
s
.99625 .14695 m
1 .14695 L
s
.99625 .17354 m
1 .17354 L
s
.99625 .20013 m
1 .20013 L
s
.99625 .25331 m
1 .25331 L
s
.99625 .2799 m
1 .2799 L
s
.99625 .30649 m
1 .30649 L
s
.99625 .33308 m
1 .33308 L
s
.99625 .38626 m
1 .38626 L
s
.99625 .41285 m
1 .41285 L
s
.99625 .43945 m
1 .43945 L
s
.99625 .46604 m
1 .46604 L
s
.99625 .51922 m
1 .51922 L
s
.99625 .54581 m
1 .54581 L
s
.99625 .5724 m
1 .5724 L
s
.99625 .59899 m
1 .59899 L
s
.99625 .65217 m
1 .65217 L
s
.99625 .67876 m
1 .67876 L
s
.99625 .70535 m
1 .70535 L
s
.99625 .73194 m
1 .73194 L
s
.99625 .78512 m
1 .78512 L
s
.99625 .81171 m
1 .81171 L
s
.99625 .8383 m
1 .8383 L
s
.99625 .86489 m
1 .86489 L
s
.99625 .06718 m
1 .06718 L
s
.99625 .04059 m
1 .04059 L
s
.99625 .014 m
1 .014 L
s
.99625 .91807 m
1 .91807 L
s
.99625 .94466 m
1 .94466 L
s
.99625 .97125 m
1 .97125 L
s
.99625 .99784 m
1 .99784 L
s
.25 Mabswid
1 0 m
1 1 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
gsave
.57048 .5686 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.57228 .60938 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.60656 .63315 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61803 .6524 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.63674 .66937 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.63881 .68622 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.65242 .71435 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.69367 .76241 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.8621 .80415 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.88005 .83588 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.95114 .8707 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.97619 .8707 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.09451 .41598 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.2157 .45667 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.22182 .48261 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.23205 .50304 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.30138 .52115 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38378 .53892 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.40628 .55475 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44642 .57057 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47815 .60113 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.49849 .64716 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.56187 .67554 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.56799 .6981 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58355 .71892 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58876 .74162 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61047 .78251 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.65451 .84094 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.69711 .87265 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.7017 .89692 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.72107 .91903 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.76074 .9433 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.79697 .96225 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.88237 .97619 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.25028 .57277 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.26421 .61705 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.2864 .64855 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.2883 .67319 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.30989 .69177 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.4045 .70726 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.43763 .72988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.46431 .77747 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.65074 .82863 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.72328 .887 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.83631 .92974 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.52036 .56585 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.63141 .60586 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.65562 .63109 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.66503 .65043 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.68174 .66536 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.68361 .67934 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.69342 .69581 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.69602 .72283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.80648 .76975 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.87659 .81454 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.94761 .8542 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.97619 .8542 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.21357 .59655 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.25585 .64301 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.42477 .67911 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.51669 .73617 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.84141 .81315 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.86396 .86078 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.91285 .91291 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.96423 .94291 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.19437 .57516 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.26663 .62406 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.46944 .66746 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.50953 .70451 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58356 .72982 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58822 .7547 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.66357 .79006 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.80783 .83681 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.8217 .8686 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.82962 .90479 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.8924 .93844 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.91286 .95889 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.14811 .02381 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.16065 .02381 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.18595 .02381 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.20914 .02381 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.26045 .02381 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.36692 .02381 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.39271 .89817 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.43511 .53119 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.59028 .57399 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.59596 .60417 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.60294 .65516 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.70741 .74724 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.74095 .80327 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.78587 .83432 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.82184 .85814 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.82875 .87973 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.84259 .90297 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.84943 .93749 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.97619 .93749 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
69.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 Mabswid
.57048 .5686 m
.57228 .60938 L
.60656 .63315 L
.61803 .6524 L
.63674 .66937 L
.63881 .68622 L
.65242 .71435 L
.69367 .76241 L
.8621 .80415 L
.88005 .83588 L
.95114 .8707 L
.97619 .8707 L
s
.09451 .41598 m
.2157 .45667 L
.22182 .48261 L
.23205 .50304 L
.30138 .52115 L
.38378 .53892 L
.40628 .55475 L
.44642 .57057 L
.47815 .60113 L
.49849 .64716 L
.56187 .67554 L
.56799 .6981 L
.58355 .71892 L
.58876 .74162 L
.61047 .78251 L
.65451 .84094 L
.69711 .87265 L
.7017 .89692 L
.72107 .91903 L
.76074 .9433 L
.79697 .96225 L
.88237 .97619 L
s
.25028 .57277 m
.26421 .61705 L
.2864 .64855 L
.2883 .67319 L
.30989 .69177 L
.4045 .70726 L
.43763 .72988 L
.46431 .77747 L
.65074 .82863 L
.72328 .887 L
.83631 .92974 L
s
.52036 .56585 m
.63141 .60586 L
.65562 .63109 L
.66503 .65043 L
.68174 .66536 L
.68361 .67934 L
.69342 .69581 L
.69602 .72283 L
.80648 .76975 L
.87659 .81454 L
.94761 .8542 L
.97619 .8542 L
s
.21357 .59655 m
.25585 .64301 L
.42477 .67911 L
.51669 .73617 L
.84141 .81315 L
.86396 .86078 L
.91285 .91291 L
.96423 .94291 L
s
.19437 .57516 m
.26663 .62406 L
.46944 .66746 L
.50953 .70451 L
.58356 .72982 L
.58822 .7547 L
.66357 .79006 L
.80783 .83681 L
.8217 .8686 L
.82962 .90479 L
.8924 .93844 L
.91286 .95889 L
s
.14811 .02381 m
.16065 .02381 L
.18595 .02381 L
.20914 .02381 L
.26045 .02381 L
.36692 .02381 L
.39271 .89817 L
s
.43511 .53119 m
.59028 .57399 L
.59596 .60417 L
.60294 .65516 L
.70741 .74724 L
.74095 .80327 L
.78587 .83432 L
.82184 .85814 L
.82875 .87973 L
.84259 .90297 L
.84943 .93749 L
.97619 .93749 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{618.75, 618.75},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009Z0002JR000`400?l00000o`00003ooooooooo
ooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo
003oooooooooooooK?ooool00?ooooooAOooool3o`000?oooooo9?ooool00?ooooooB?ooool00ol0
003oooooooooo`3oooooob7ooooo003oooooocSooooo1Ol00002ooooo`?o00000oooool4o`0000Wo
oooo0_l00002ooooo`Go000000Koooooo`000?oooooo0000ooooool00002ooooo`?o0000ooooool6
ooooo`00ooooooljooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooo`000003
ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00000oooool02ol0003ooooooooo
oooooooo0000ooooool0003oooooo`000?oooooo00000?oooooo2Oooool00?oooooo>_ooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooool000000oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Cooooo00[o0000ooooooooooooooooo`000?oooooo0000ooooool0
003ooooo1Ol0003oooooo`Gooooo003ooooooc[ooooo00Go0000ooooooooooooooooo`000003oooo
o`03o`000?oooooo000000?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`04oooo
o`0;o`000?ooooooooooooooool0003oooooo`000?oooooo0000ooooool000000oooool00ol0003o
ooooooooo`3oooooo`?ooooo003ooooooc[ooooo00?o0000ooooooooool00_ooool3o`0000?ooooo
1Ol00006ooooo`Co00000_ooool3o`0000?ooooo0_l000000ooooooo0000ooooo`02ooooo`?o0000
ooooool6ooooo`00ooooooljooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool0oooo
oolHooooo`00oooooolhooooo`?o00005_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?oooooo4Oooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo0011ooooo`;o0000
HOooool5o`0006;ooooo0ol0001Rooooo`?o0000H_ooool3o`0005oooooo0ol00004ooooo`;o0000
:_ooool0043ooooo00Co0000oooooooooooo0000HOooool01?l0003oooooooooool0001Sooooo`03
o`000?oooooooooo063ooooo00Go0000ooooooooooooooooo`00001Pooooo`05o`000?oooooooooo
ooooool00000Goooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0002Wooooo0010
ooooo`04o`000?ooooooooooo`0006;ooooo00?o0000ooooooooool0H?ooool5o`00067ooooo00Go
0000ooooooooooooooooo`00001Pooooo`05o`000?ooooooooooooooool00000Goooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0002Wooooo0010ooooo`04o`000?ooooooooooo`00
06?ooooo00?o0000ooooooooool0Goooool01?l0003oooooooooool0001Rooooo`Co0000H_ooool3
o`00063ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0000Yooooo`00@?ooool0
1?l0003oooooooooool0001Pooooo`05o`000?ooooooooooooooool00000HOooool00ol0003ooooo
o`00001Rooooo`03o`000?oooooooooo06;ooooo00Go0000ooooooooooooooooo`00001Oooooo`03
o`000?oooooooooo00;ooooo00Co0000oooooooooooo0000:Oooool0043ooooo00Co0000oooooooo
oooo0000H?ooool01Ol0003ooooooooooooooooo000006;ooooo0_l0001Sooooo`03o`000?oooooo
oooo067ooooo00Go0000ooooooooooooooooo`00001Nooooo`;o00001?ooool01?l0003ooooooooo
ool0000Yooooo`00@Oooool2o`0006;ooooo0ol0001Tooooo`03o`000?oooooooooo06;ooooo0_l0
001Rooooo`?o0000H?ooool00ol0003oooooooooo`03ooooo`;o0000:_ooool00?oooooooooooom/
ooooo`00ooooooooooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00oooo
ooooooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00ooooooooooooofco
oooo000doooooooo0000ool0000ho`000000=?ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo013ooooo0Ol0000003Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0F
ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0@
ooooo`7o0000000dooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool0H_ooool00ol0
003oooooooooo`1Rooooo`03o`000?oooooooooo06?ooooo00?o0000ooooooooool0H_ooool00ol0
003oooooooooo`1Rooooo`03o`000?oooooooooo02[ooooo0Ol0000003Cooooo00?o0000oooooooo
ool0ooooooooooooocCooooo0Ol0000003Cooooo00?o0000ooooooooool0ooooooooooooocCooooo
0Ol0000003Cooooo00?o0000ooooooooool0ooooooooooooocCooooo0Ol0000003Cooooo00?o0000
ooooooooool0ooooooooooooocCooooo0Ol0000003Cooooo0ol0003ooooooooooooo<_ooool3o`00
0000=?ooool00ol0003oooooooooo`3ooooooooooooo=?ooool1o`000000=?ooool00ol0003ooooo
ooooo`3ooooooooooooo=?ooool1o`000000=?ooool00ol0003oooooooooo`1@ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo01[ooooo00?o0000ooooooooool0>Oooool00ol0003oooooooooo`3oooooofGooooo0Ol0
000003Cooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0Jooooo`03o`000?oooooo
oooo03Wooooo00?o0000ooooooooool0oooooomUooooo`7o0000000dooooo`03o`000?oooooooooo
057oooooO?l0003oooooofKooooo0Ol0000003Cooooo00?o0000ooooooooool0DOooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`0Jooooo`03o`000?oooooooooo03Wooooo00?o0000ooooooooool0oooooomTooooo`7o
0000000dooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool06_ooool00ol0003ooooo
ooooo`0hooooo`;o0000oooooomUooooo`7o0000000dooooo`03o`000?oooooooooo04kooooo00Go
0000ooooooooooooooooo`000002ooooo`05o`000?ooooooooooooooool000002Oooool01Ol0003o
oooooooooooooooo000000Sooooo00Go0000ooooooooooooooooo`00000Hooooo`05o`000?oooooo
ooooooooool00000=oooool00ol0003oooooooooo`02o`000?ooooooIOooool1o`000000=?ooool0
0ol0003oooooooooo`1>ooooo`Go00000_ooool5o`0000Wooooo1Ol00008ooooo`Go00006?ooool5
o`0003Oooooo1Ol0003oooooofGooooo0Ol0000003Cooooo00?o0000ooooooooool0c?ooool00ol0
003oooooooooo`3oooooofCooooo0Ol0000003Cooooo00?o0000ooooooooool0c?ooool00ol0003o
ooooooooo`3oooooofCooooo0Ol0000003Cooooo00?o0000ooooooooool0c?ooool00ol0003ooooo
ooooo`3oooooofCooooo0Ol0000003Cooooo00?o0000ooooooooool0c?ooool00ol0003ooooooooo
o`3oooooofCooooo0Ol0000003Cooooo00?o0000ooooooooool0c?ooool00ol0003oooooooooo`3o
ooooofCooooo0Ol0000003Cooooo0ol0003<ooooo`03o`000?oooooooooo0?ooooooH_ooool3o`00
0000=?ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo0?ooooooI?ooool1o`000000
=?ooool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo0?ooooooI?ooool1o`000000=?oo
ool00ol0003oooooooooo`3<ooooo`03o`000?oooooooooo0?ooooooI?ooool1o`000000=?ooool0
0ol0003oooooooooo`3<ooooo`03o`000?oooooooooo0?ooooooI?ooool1o`000000=?ooool00ol0
003oooooooooo`3<ooooo`03o`000?oooooooooo0?ooooooI?ooool1o`000000=?ooool00ol0003o
ooooooooo`3<ooooo`03o`000?oooooooooo0?ooooooI?ooool1o`000000=?ooool00ol0003ooooo
ooooo`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003ooooooooo
o`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=
ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=oooo
o`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=ooooo`03
o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=ooooo`03o`00
0?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=ooooo`03o`000?oo
oooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=ooooo`03o`000?oooooo
oooo0?ooooooHoooool1o`000000=?ooool3o`000<gooooo00?o0000ooooooooool0oooooomQoooo
o`?o0000000dooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o
0000000dooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000
000dooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000d
ooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000doooo
o`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000dooooo`03
o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000dooooo`03o`00
0?oooooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000dooooo`03o`000?oo
oooooooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000dooooo`03o`000?oooooo
oooo0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000dooooo`03o`000?oooooooooo
0<gooooo00?o0000ooooooooool0oooooomSooooo`7o0000000dooooo`03o`000?oooooooooo0<go
oooo00?o0000ooooooooool0oooooomSooooo`7o0000000Fooooo`?o00000_ooool5o`0000?ooooo
00?o0000ooooooooool00_ooool3o`0000Wooooo00?o0000ooooooooool0cOooool00ol0003ooooo
ooooo`3oooooof?ooooo0Ol0000001Oooooo00?o0000ooooooooool00_ooool01?l0003ooooooooo
ool00007ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3=ooooo`03
o`000?oooooooooo0?ooooooHoooool1o`0000003oooool5o`0000?ooooo00?o0000ooooooooool0
0oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
cOooool00ol0003oooooooooo`3oooooof?ooooo0Ol0000001Oooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Kooooo1Ol0003;ooooo`03o`000?oo
oooooooo0?ooooooH?ooool4o`0000005oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool01Oooool4o`0000Wooooo00?o0000ooooooooool0cOooool00ol0003ooooooooo
o`3oooooof?ooooo0Ol0000001Kooooo0_l00003ooooo`05o`000?ooooooooooooooool000001ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0<gooooo00?o0000ooooooooool0oooo
oomSooooo`7o0000000Gooooo`03o`000?oooooooooo00;ooooo0ol00008ooooo`Go00002?ooool0
0ol0003oooooooooo`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0
003oooooooooo`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003o
ooooooooo`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003ooooo
ooooo`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003ooooooooo
o`3=ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=
ooooo`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3=oooo
o`03o`000?oooooooooo0?ooooooHoooool1o`000000=?ooool00ol0003oooooooooo`3>ooooo`03
o`000?oooooooooo0?ooooooH_ooool1o`000000=?ooool00ol0003oooooooooo`3>ooooo`03o`00
0?oooooooooo0?ooooooH_ooool1o`000000=?ooool00ol0003oooooooooo`3>ooooo`03o`000?oo
oooooooo0?ooooooH_ooool1o`000000=?ooool00ol0003oooooooooo`3>ooooo`03o`000?oooooo
oooo0?ooooooH_ooool1o`000000=?ooool00ol0003oooooooooo`3>ooooo`03o`000?oooooooooo
0?ooooooH_ooool1o`000000=?ooool3o`000<kooooo00?o0000ooooooooool0oooooomPooooo`?o
0000000dooooo`03o`000?oooooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000
000dooooo`03o`000?oooooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000d
ooooo`03o`000?oooooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000doooo
o`03o`000?oooooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03
o`000?oooooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`00
0?oooooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oo
oooooooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooo
oooo0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooooooo
0<kooooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooooooo0<ko
oooo00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooooooo0<kooooo
00?o0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooooooo0<kooooo00?o
0000ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooooooo0<kooooo00?o0000
ooooooooool0oooooomRooooo`7o0000000dooooo`03o`000?oooooooooo0<kooooo00?o0000oooo
ooooool0oooooomRooooo`7o0000000dooooo`?o0000c_ooool00ol0003oooooooooo`3oooooof3o
oooo0ol0000003Cooooo00?o0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo
0Ol0000003Cooooo00?o0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0
000003Cooooo00?o0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol00000
03Cooooo00?o0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Co
oooo00?o0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo
00?o0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o
0000ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o0000
ooooooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o0000oooo
ooooool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o0000oooooooo
ool0c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o0000ooooooooool0
c_ooool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o0000ooooooooool0c_oo
ool00ol0003oooooooooo`3oooooof;ooooo0Ol0000003Cooooo00?o0000ooooooooool0coooool0
0ol0003oooooooooo`3oooooof7ooooo0Ol0000003Cooooo00?o0000ooooooooool0coooool00ol0
003oooooooooo`3oooooof7ooooo0Ol0000003Cooooo0ol0003?ooooo`03o`000?oooooooooo0?oo
ooooGoooool3o`000000=?ooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?oooooo
HOooool1o`000000=?ooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOoo
ool1o`000000=?ooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1
o`000000=?ooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`00
0000=?ooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000
=?ooool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?oo
ool00ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool0
0ol0003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool00ol0
003oooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool00ol0003o
ooooooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool00ol0003ooooo
ooooo`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool00ol0003ooooooooo
o`3?ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool00ol0003oooooooooo`3?
ooooo`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool00ol0003oooooooooo`3?oooo
o`03o`000?oooooooooo0?ooooooHOooool1o`000000=?ooool3o`000<oooooo00?o0000oooooooo
ool0oooooomOooooo`?o0000000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0
oooooomQooooo`7o0000000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooo
oomQooooo`7o0000000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQ
ooooo`7o0000000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQoooo
o`7o0000000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o
0000000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000
000dooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000000d
ooooo`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000000doooo
o`03o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000000dooooo`03
o`000?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000000dooooo`03o`00
0?oooooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000000Rooooo`?o00001?oo
ool2o`0000Wooooo00?o0000ooooooooool0coooool00ol0003oooooooooo`3oooooof7ooooo0Ol0
000002?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00008ooooo`03o`000?oo
oooooooo0<oooooo00?o0000ooooooooool0oooooomQooooo`7o0000000Kooooo`Go00000oooool0
0ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Sooooo00?o0000ooooooooool0cooo
ool00ol0003oooooooooo`3oooooof7ooooo0Ol0000002?ooooo00?o0000ooooooooool00_ooool0
1?l0003oooooooooool00008ooooo`Go0000cOooool00ol0003oooooooooo`3ooooooekooooo1?l0
000002?ooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00008ooooo`03o`000?oo
oooooooo0=3ooooo00?o0000ooooooooool0oooooomPooooo`7o0000000Rooooo`;o00001?ooool0
1?l0003oooooooooool00008ooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooooooool0oooo
oomPooooo`7o0000000Sooooo`03o`000?oooooooooo00?ooooo0_l00009ooooo`03o`000?oooooo
oooo0=3ooooo00?o0000ooooooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo
0=3ooooo00?o0000ooooooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3o
oooo00?o0000ooooooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo
00?o0000ooooooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o
0000ooooooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000
ooooooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000oooo
ooooool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000oooooooo
ool0oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooooooool0
oooooomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooooooool0oooo
oomPooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooooooool0oooooomP
ooooo`7o0000000dooooo`03o`000?oooooooooo0=3ooooo00?o0000ooooooooool0oooooomPoooo
o`7o0000000dooooo`?o0000d?ooool00ol0003oooooooooo`3ooooooekooooo0ol0000003Cooooo
00?o0000ooooooooool0d?ooool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o
0000ooooooooool0d?ooool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000
ooooooooool0d?ooool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000oooo
ooooool0d?ooool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000oooooooo
ool0d?ooool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0
d?ooool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?oo
ool00ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool0
0ol0003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool00ol0
003oooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool00ol0003o
ooooooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool00ol0003ooooo
ooooo`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool00ol0003ooooooooo
o`3oooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool00ol0003oooooooooo`3o
ooooof3ooooo0Ol0000003Cooooo00?o0000ooooooooool0d?ooool00ol0003oooooooooo`3ooooo
of3ooooo0Ol0000003Cooooo0ol0003@ooooo`03o`000?oooooooooo0?ooooooG_ooool3o`000000
=?ooool00ol0003oooooooooo`3@ooooo`03o`000?oooooooooo0?ooooooH?ooool1o`000000=?oo
ool00ol0003oooooooooo`3@ooooo`03o`000?oooooooooo0?ooooooH?ooool1o`000000=?ooool0
0ol0003oooooooooo`3@ooooo`03o`000?oooooooooo0?ooooooH?ooool1o`000000=?ooool00ol0
003oooooooooo`3Aooooo`03o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003o
ooooooooo`3Aooooo`03o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003ooooo
ooooo`3Aooooo`03o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003ooooooooo
o`3Aooooo`03o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3A
ooooo`03o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3Aoooo
o`03o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3Aooooo`03
o`000?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3Aooooo`03o`00
0?oooooooooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3Aooooo`03o`000?oo
oooooooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3Aooooo`03o`000?oooooo
oooo0?ooooooGoooool1o`000000=?ooool00ol0003oooooooooo`3Aooooo`03o`000?oooooooooo
0?ooooooGoooool1o`000000=?ooool3o`000=7ooooo00?o0000ooooooooool0oooooomMooooo`?o
0000000dooooo`03o`000?oooooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000
000dooooo`03o`000?oooooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000d
ooooo`03o`000?oooooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000doooo
o`03o`000?oooooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03
o`000?oooooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`00
0?oooooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oo
oooooooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooo
oooo0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooooooo
0=7ooooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooooooo0=7o
oooo00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooooooo0=7ooooo
00?o0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooooooo0=7ooooo00?o
0000ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooooooo0=7ooooo00?o0000
ooooooooool0oooooomOooooo`7o0000000dooooo`03o`000?oooooooooo0=7ooooo00?o0000oooo
ooooool0oooooomOooooo`7o0000000dooooo`?o0000dOooool00ol0003oooooooooo`3ooooooego
oooo0ol0000003Cooooo00?o0000ooooooooool0dOooool00ol0003oooooooooo`3ooooooeoooooo
0Ol0000003Cooooo00?o0000ooooooooool0dOooool00ol0003oooooooooo`3ooooooeoooooo0Ol0
000003Cooooo00?o0000ooooooooool0dOooool00ol0003oooooooooo`3ooooooeoooooo0Ol00000
03Cooooo00?o0000ooooooooool0dOooool00ol0003oooooooooo`3ooooooeoooooo0Ol0000003Co
oooo00?o0000ooooooooool0dOooool00ol0003oooooooooo`3ooooooeoooooo0Ol0000003Cooooo
00?o0000ooooooooool0dOooool00ol0003oooooooooo`3ooooooeoooooo0Ol0000003Cooooo00?o
0000ooooooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000
ooooooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000oooo
ooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000oooooooo
ool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0
d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000001gooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`02ooooo`?o00002Oooool00ol0003oooooooooo`3Booooo`03o`000?oo
oooooooo0?ooooooG_ooool1o`0000007Oooool00ol0003oooooooooo`07ooooo`05o`000?oooooo
ooooooooool000002?ooool00ol0003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_oo
ool1o`0000005Oooool5o`0000Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo0=;ooooo00?o0000ooooooooool0oooooomNooooo`7o0000000Noooo
o`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01_ooool5o`000=3ooooo00?o0000oooo
ooooool0oooooomKooooo`Co0000000Oooooo`03o`000?oooooooooo00Gooooo1?l00009ooooo`03
o`000?oooooooooo0=;ooooo00?o0000ooooooooool0oooooomNooooo`7o0000000Kooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo0=;o
oooo00?o0000ooooooooool0oooooomNooooo`7o0000000Kooooo`Go00001oooool5o`0000Sooooo
00?o0000ooooooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o
0000ooooooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000
ooooooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000oooo
ooooool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000oooooooo
ool0d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0
d_ooool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0d_oo
ool00ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0d_ooool0
0ol0003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0d_ooool00ol0
003oooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0d_ooool00ol0003o
ooooooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0d_ooool00ol0003ooooo
ooooo`3ooooooekooooo0Ol0000003Cooooo00?o0000ooooooooool0d_ooool00ol0003ooooooooo
o`3ooooooekooooo0Ol0000003Cooooo0ol0003Booooo`03o`000?oooooooooo0?ooooooG?ooool3
o`000000=?ooool00ol0003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`00
0000=?ooool00ol0003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000
=?ooool00ol0003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?oo
ool00ol0003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?ooool0
0ol0003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?ooool00ol0
003oooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?ooool00ol0003o
ooooooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?ooool00ol0003ooooo
ooooo`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?ooool00ol0003ooooooooo
o`3Booooo`03o`000?oooooooooo0?ooooooG_ooool1o`000000=?ooool00ol0003oooooooooo`3C
ooooo`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003oooooooooo`3Coooo
o`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003oooooooooo`3Cooooo`03
o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003oooooooooo`3Cooooo`03o`00
0?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003oooooooooo`3Cooooo`03o`000?oo
oooooooo0?ooooooGOooool1o`000000=?ooool3o`0002oooooo1Ol0002Oooooo`03o`000?oooooo
oooo0?ooooooFoooool3o`000000=?ooool00ol0003oooooooooo`0`ooooo`04o`000?oooooooooo
o`0009oooooo00?o0000ooooooooool0oooooomMooooo`7o0000000dooooo`03o`000?oooooooooo
037ooooo1?l0002Nooooo`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003o
ooooooooo`0booooo`03o`000?oooooooooo00?o0000Voooool00ol0003oooooooooo`3ooooooego
oooo0Ol0000003Cooooo00?o0000ooooooooool0;oooool01Ol0003ooooooooooooooooo000000Co
oooo0ol0002Hooooo`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003ooooo
ooooo`0_ooooo`05o`000?ooooooooooooooool000001oooool3o`0009Gooooo00?o0000oooooooo
ool0oooooomMooooo`7o0000000dooooo`03o`000?oooooooooo033ooooo0ol0000;ooooo`?o0000
T_ooool00ol0003oooooooooo`3ooooooegooooo0Ol0000003Cooooo00?o0000ooooooooool0@Ooo
ool3o`0008oooooo00?o0000ooooooooool0oooooomMooooo`7o0000000dooooo`03o`000?oooooo
oooo04Cooooo0ol0002<ooooo`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0
003oooooooooo`17ooooo`?o0000ROooool00ol0003oooooooooo`3ooooooegooooo0Ol0000003Co
oooo00?o0000ooooooooool0B_ooool3o`0008Kooooo00?o0000ooooooooool0oooooomMooooo`7o
0000000dooooo`03o`000?oooooooooo04gooooo0ol00023ooooo`03o`000?oooooooooo0?oooooo
GOooool1o`000000=?ooool00ol0003oooooooooo`1@ooooo`?o0000P?ooool00ol0003ooooooooo
o`3ooooooegooooo0Ol0000003Cooooo00?o0000ooooooooool0Doooool3o`0007gooooo00?o0000
ooooooooool0oooooomMooooo`7o0000000dooooo`03o`000?oooooooooo05Kooooo0ol0001joooo
o`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool3o`0005Wooooo0ol0001gooooo`03
o`000?oooooooooo0?ooooooFoooool3o`000000=?ooool00ol0003oooooooooo`1Looooo`?o0000
M?ooool00ol0003oooooooooo`3ooooooegooooo0Ol0000003Cooooo00?o0000ooooooooool0Gooo
ool3o`00077ooooo00?o0000ooooooooool0oooooomMooooo`7o0000000dooooo`03o`000?oooooo
oooo06;ooooo0ol0001^ooooo`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0
003oooooooooo`1Uooooo`?o0000Joooool00ol0003oooooooooo`3ooooooegooooo0Ol0000003Co
oooo00?o0000ooooooooool0J?ooool3o`0006Sooooo00?o0000ooooooooool0oooooomMooooo`7o
0000000dooooo`03o`000?oooooooooo06_ooooo0ol0001Uooooo`03o`000?oooooooooo0?oooooo
GOooool1o`000000=?ooool00ol0003oooooooooo`1^ooooo`?o0000H_ooool00ol0003ooooooooo
o`3ooooooegooooo0Ol0000003Cooooo00?o0000ooooooooool0LOooool8o`0005[ooooo00?o0000
ooooooooool0oooooomMooooo`7o0000000dooooo`03o`000?oooooooooo07Cooooo0ol000000ooo
oooo0000ooooo`1Iooooo`03o`000?oooooooooo0?ooooooGOooool1o`000000=?ooool00ol0003o
ooooooooo`1fooooo`;o0000Foooool00ol0003oooooooooo`3ooooooegooooo0Ol0000003Cooooo
00?o0000ooooooooool0Moooool00ol0003oooooooooo`1Iooooo`03o`000?oooooooooo0?oooooo
GOooool1o`000000=?ooool00ol0003oooooooooo`1dooooo`03o`000?oooooooooo00;o0000F_oo
ool00ol0003oooooooooo`3ooooooegooooo0Ol0000003Cooooo00?o0000ooooooooool0M?ooool0
1Ol0003ooooooooooooooooo000005_ooooo00?o0000ooooooooool0oooooomLooooo`7o0000000d
ooooo`03o`000?oooooooooo07Gooooo1?l0001Kooooo`03o`000?oooooooooo0?ooooooG?ooool1
o`000000=?ooool3o`0007Sooooo00?o0000ooooooooool0FOooool00ol0003oooooooooo`3ooooo
oe[ooooo0ol0000003Cooooo00?o0000ooooooooool0N?ooool00ol0003oooooooooo`1Iooooo`03
o`000?oooooooooo0?ooooooG?ooool1o`000000=?ooool00ol0003oooooooooo`1hooooo`03o`00
0?oooooooooo05Wooooo00?o0000ooooooooool0oooooomLooooo`7o0000000dooooo`03o`000?oo
oooooooo07Wooooo00?o0000ooooooooool0F?ooool00ol0003oooooooooo`3ooooooecooooo0Ol0
000003Cooooo00?o0000ooooooooool0NOooool00ol0003oooooooooo`1Hooooo`03o`000?oooooo
oooo0?ooooooG?ooool1o`000000=?ooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo
05Sooooo00?o0000ooooooooool0oooooomLooooo`7o00000002ooooo`03on2aROnOd_;ooooo00;o
oooo00?oooogoiQ1Coo2l_l0:_ooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo05So
oooo00?o0000ooooooooool0oooooomLooooo`7o00000002ooooo`03olR2;_mLV<;oemOB00;od];B
00?oemO2og0^Coo8l_l0:_ooool00ol0003oooooooooo`1gooooo`Go0000F?ooool00ol0003ooooo
ooooo`3ooooooecooooo0Ol0000000;ooooo00?oj/RUog1`L?m`L7000_m`L7000om`L6Ko001?olSb
o`0Zooooo`03o`000?oooooooooo07Sooooo00Co0000ooooool0003o0000F?ooool00ol0003ooooo
ooooo`3ooooooecooooo0Ol0000000Oooooo00?oooogoi4^@Oo2l_l0:_ooool00ol0003ooooooooo
o`1iooooo`;o0000FOooool00ol0003oooooooooo`3ooooooecooooo0Ol0000000Oooooo00?ooook
olfa]ooPmol0:_ooool00ol0003oooooooooo`1jooooo`03o`000?oooooooooo05Oooooo00?o0000
ooooooooool0oooooomLooooo`7o00000005ooooo`04oo;Pb?nUV9SoYK78oo;oob_ooooo00?o0000
ooooooooool0Moooool01Ol0003ooooooooooooooooo000005Sooooo00?o0000ooooooooool0oooo
oomLooooo`7o00000004ooooo`06oo;BV?l0003oIX:9og1?0?l0@ISok_oo7_ooool3o`0000Wooooo
00?o0000ooooooooool0Moooool01Ol0003ooooooooooooooooo000005Sooooo00?o0000oooooooo
ool0oooooomLooooo`7o00000004ooooo`06olR9Con9b?;oooooooool_nA@Doo`^ko7Oooool01Ol0
003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0N?ooool3o`000003ooooool0003o
oooo05Kooooo00?o0000ooooooooool0oooooomLooooo`7o00000004ooooo`06olR9G?nUg?_ooooo
oooooon[G5co`^ko5oooool5o`0000Gooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`1looooo`03o`000?oooooooooo05Gooooo00?o0000ooooooooool0oooooomLooooo`7o00000004
ooooo`06on2aL?l007Wo`]OLolR[NOl0073og?_o8Oooool00ol0003oooooooooo`06ooooo`Go0000
Noooool00ol0003oooooooooo`1Dooooo`03o`000?oooooooooo0?ooooooFOooool4o`0000001?oo
ool01OooooOob:F2obh00?l^CgWob>Gg01kooooo1?l00009ooooo`03o`000?oooooooooo07gooooo
00?o0000ooooooooool0E?ooool00ol0003oooooooooo`3ooooooecooooo0Ol0000000Gooooo00?o
ooOZom;=cOoGiO807oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo07kooooo00?o
0000ooooooooool0Doooool00ol0003oooooooooo`3ooooooecooooo0Ol0000000Cooooo00SonnFg
obh00?m1G5co0000ofJ[g?ooooooj^3Uoo_ooa_ooooo1Ol00008ooooo`03o`000?oooooooooo07ko
oooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`3ooooooecooooo0Ol0000000Cooooo
00SocI5?ofJah?ooooooonZgobh^TOogon[oN@0^ol;bobSooooo00?o0000ooooooooool0OOooool5
o`0005;ooooo00?o0000ooooooooool0oooooomLooooo`7o00000004ooooo`08om:HG?m`/N3ooooo
oooZ]om1CjGonooPofH0Coo=molXooooo`03o`000?oooooooooo07kooooo0_l000000ooooooo0000
ooooo`1Aooooo`03o`000?oooooooooo0?ooooooG?ooool1o`0000001?ooool01ooLYFKo0000odmV
I_l^003o0000od400?l^P[d0:Oooool00ol0003oooooooooo`1oooooo`Co0000DOooool00ol0003o
ooooooooo`3ooooooecooooo0Ol0000000Cooooo00?odYQVoh:ad_oUh>000_oPh>000ooPh>[onooo
ooooo`0Xooooo`03o`000?oooooooooo083ooooo00?o0000ooooooooool01?l0001=ooooo`03o`00
0?oooooooooo0?ooooooG?ooool1o`0000000_ooool00oooooOod/;=onkoo`03ooooo`03omO2`_oU
nooooooo02Wooooo00?o0000ooooooooool0OOooool01Ol0003ooooooooooooooooo000000Gooooo
1?l00019ooooo`03o`000?oooooooooo0?ooooooG?ooool1o`0000000_ooool02?oooo;oTBh0o`00
0?l002ko;P00o`000?l0047ob?;o:_ooool00ol0003oooooooooo`1mooooo`05o`000?oooooooooo
ooooool000002Oooool4o`0004Gooooo00?o0000ooooooooool0oooooomLooooo`7o00000002oooo
o`08ooool_n[NGWocO;gol9i@Omi_N3ooo_Zoim`NOo=l_lZooooo`03o`000?oooooooooo07kooooo
0ol0000>ooooo`Co0000@Oooool00ol0003oooooooooo`3ooooooecooooo0Ol0000000;ooooo00So
ooogokfU/OoboooodY5?ohW=mooooooo`YnUomcgob[ooooo00?o0000ooooooooool0Toooool3o`00
03kooooo00?o0000ooooooooool0oooooomLooooo`7o00000002ooooo`08ooool_nA;P3o02i1o`00
0?l002ko@D4^o`00;_o8l_lZooooo`03o`000?oooooooooo09Kooooo1?l0000jooooo`03o`000?oo
oooooooo0?ooooooG?ooool1o`0000000_ooool02?oooo;o/HVAolSPj_oZj^[oiNGUon[Zg?nONHWo
d_Oo:_ooool00ol0003oooooooooo`2Jooooo`Co0000=_ooool00ol0003oooooooooo`3ooooooeco
oooo0Ol0000003Cooooo00?o0000ooooooooool0W_ooool4o`0000;ooooo1Ol0000[ooooo`03o`00
0?oooooooooo0?ooooooG?ooool1o`0000000oooool01_oG]iSo@@00o`000?l0003o02iLojG=iB_o
oooo0ol0002Rooooo`Co00000_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo0?oo
ooooF_ooool3o`0000000_ooool02?ogdYSo001`olSLiOobmoOomo;^on3G]om?02ko_N[o:_ooool0
0ol0003oooooooooo`2Vooooo`Co0000:oooool00ol0003oooooooooo`3ooooooe_ooooo0Ol00000
00;ooooo00?ol/f2o`11YOokool00_ooool00oooonkoTBh0oioLm`0Zooooo`03o`000?oooooooooo
0:Oooooo00?o0000ooooooooool01Ol0000Vooooo`03o`000?oooooooooo0?ooooooFoooool1o`00
00000_ooool02?ooon[oYG0^o`000?l^@D7o@Bh0o`000?m?RKgomooo:_ooool00ol0003ooooooooo
o`2Tooooo`05o`000?ooooooooooooooool000001_ooool5o`00027ooooo00?o0000ooooooooool0
oooooomKooooo`7o00000004ooooo`04ooO^j_oLg=Oog=cPonkbnbcooooo00?o0000ooooooooool0
Y?ooool01Ol0003ooooooooooooooooo000000_ooooo1?l0000Mooooo`03o`000?oooooooooo0?oo
ooooFoooool1o`000000=?ooool00ol0003oooooooooo`2Uooooo`?o00004?ooool5o`0001Sooooo
00?o0000ooooooooool06Oooool3o`000?oooooo?oooool1o`000000=?ooool00ol0003ooooooooo
o`2mooooo`Go00004oooool00ol0003oooooooooo`0Hooooo`05o`000?ooooooooooooooool00000
oooooolnooooo`7o0000000dooooo`03o`000?oooooooooo0<;ooooo1Ol0000>ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool00ol0003oooooocgooooo0Ol0000003Cooooo00?o0000
ooooooooool0aoooool4o`0000[ooooo00?o0000ooooooooool06Oooool3o`0000;ooooo1?l0003o
ooooocWooooo0Ol0000003Cooooo00?o0000ooooooooool0boooool5o`0000?ooooo1Ol0000Hoooo
o`05o`000?ooooooooooooooool000001Oooool3o`000?oooooo=_ooool1o`000000=?ooool00ol0
003oooooooooo`3@ooooo`Ko000000?oooooo`000?ooool05oooool01Ol0003ooooooooooooooooo
000000Sooooo1?l0003ooooooc;ooooo0Ol0000003Cooooo00?o0000ooooooooool0eOooool3o`00
01Wooooo0ol0000=ooooo`Co0000ooooool^ooooo`7o0000000dooooo`03o`000?oooooooooo0=Go
oooo0_l000000ooooooo0000ooooo`0[ooooo`?o0000ooooool[ooooo`7o0000000dooooo`03o`00
0?oooooooooo0=?ooooo00Ko0000ooooool0003oooooo`000?ooool2o`0002gooooo1?l0003ooooo
obOooooo0Ol0000003Cooooo00?o0000ooooooooool0doooool01Ol0003oooooo`000?oooooo0000
00?ooooo00?o0000ooooooooool0;_ooool4o`000?oooooo8oooool1o`000000=?ooool3o`000=Co
oooo0ol00005ooooo`;o0000<_ooool3o`000?oooooo7_ooool3o`000000=?ooool00ol0003ooooo
ooooo`3Eooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0<_ooool4o`000?oooooo
7?ooool1o`000000=?ooool00ol0003oooooooooo`3Eooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0=Oooool4o`000?oooooo6?ooool1o`000000=?ooool00ol0003oooooooooo`3E
ooooo`03o`000?oooooooooo00Sooooo1Ol0000fooooo`?o0000oooooolEooooo`7o0000000doooo
o`03o`000?oooooooooo0=Gooooo00?o0000ooooooooool02Oooool2o`000003ooooool0003ooooo
03Sooooo1?l0003ooooooa7ooooo0Ol0000003Cooooo00?o0000ooooooooool0eOooool00ol0003o
ooooooooo`0:ooooo`?o0000?Oooool4o`000?oooooo3Oooool1o`000000=?ooool00ol0003ooooo
ooooo`3Eooooo`03o`000?oooooooooo00_ooooo00?o0000ooooool000000_l0000nooooo`?o0000
ooooool:ooooo`7o0000000dooooo`03o`000?oooooooooo0=Gooooo00?o0000ooooooooool02?oo
ool01Ol0003ooooooooooooooooo000000?ooooo0_l0000oooooo`Co0000ooooool6ooooo`7o0000
000dooooo`03o`000?oooooooooo0=Gooooo00?o0000ooooooooool02?ooool01Ol0003ooooooooo
oooooooo000000Gooooo0ol00010ooooo`Co0000ooooool2ooooo`7o0000000dooooo`03o`000?oo
oooooooo0=Gooooo00?o0000ooooooooool02Oooool3o`0000Wooooo0_l0000cooooo`?o00003?oo
ool3o`000?kooooo0Ol0000003Cooooo00?o0000ooooooooool0eOooool00ol0003oooooooooo`0G
ooooo`;o0000<_ooool00ol0003oooooooooo`0>ooooo`Co0000n_ooool1o`000000=?ooool00ol0
003oooooooooo`3Eooooo`03o`000?oooooooooo01Wooooo0ol0000/ooooo`Go00004oooool4o`00
0004ooooool0003o0000o`000?;ooooo0Ol0000003Cooooo00?o0000ooooooooool0eOooool00ol0
003oooooooooo`0Looooo`Oo00009Oooool01Ol0003oooooooooool0003ooooo00?o00005?ooool3
o`000??ooooo0Ol0000003Cooooo00?o0000ooooooooool0ROooool3o`0004Wooooo00?o0000oooo
ooooool07_ooool3o`000003ooooool0003ooooo02Gooooo00?o0000ooooool000001?ooool3o`00
01?ooooo1Ol0003_ooooo`7o0000000dooooo`03o`000?oooooooooo08Sooooo00Go0000oooooooo
ooooooooo`000018ooooo`03o`000?oooooooooo023ooooo0ol0000Wooooo`;o00001oooool3o`00
013ooooo0_l00003ooooo`Co00000_ooool3o`000>Kooooo0Ol0000003Cooooo0ol0001Yooooo`?o
00007oooool2o`0004Sooooo00?o0000ooooooooool08Oooool00ol0003oooooo`00000Wooooo`03
o`000?oooooooooo00Sooooo0_l0000>ooooo`;o00001oooool3o`0000;ooooo00?o0000oooooooo
ool0hOooool3o`000000=?ooool00ol0003oooooooooo`1Xooooo`05o`000?ooooooooooooooool0
00007Oooool2o`0004Wooooo00?o0000ooooooooool07_ooool01ol0003ooooooooooooooooo0000
ooooool00000<oooool3o`0000[ooooo0ol00008ooooo`03o`000?oooooo000000;o0000iOooool1
o`000000=?ooool00ol0003oooooooooo`1Xooooo`03o`000?oooooooooo00;o00007_ooool2o`00
04Sooooo00?o0000ooooooooool07_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000
ooooooooool0<oooool3o`0000Sooooo0_l00009ooooo`?o0000i_ooool1o`000000=?ooool00ol0
003oooooooooo`1Xooooo`Co000000?oooooo`000?ooool06Oooool01Ol0003ooooooooooooooooo
000004Sooooo00?o0000ooooooooool07oooool3o`0000Cooooo00?o0000ooooooooool0=Oooool3
o`0000Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02o`000>Gooooo0Ol00000
03Cooooo00?o0000ooooooooool0J?ooool00ol0003oooooooooo`03ooooo`;o00006Oooool4o`00
04Wooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0gooooo`;o00001?ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00;o0000iOooool1o`000000=?ooool00ol0003o
ooooooooo`1Yooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`17ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0>?ooool3o`000003
ooooool0003ooooo00Sooooo1?l0003Uooooo`7o0000000dooooo`03o`000?oooooooooo06[ooooo
0_l00005ooooo`;o00006_ooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo02Sooooo
00?o0000ooooooooool0>_ooool3o`0000_ooooo00?o0000ooooooooool0hoooool1o`000000=?oo
ool00ol0003oooooooooo`1cooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0A_oo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo03[ooooo00?o0000ooooool000000_l0
0008ooooo`03o`000?oooooooooo0>?ooooo0Ol0000003Cooooo00?o0000ooooooooool0M?ooool2
o`0001Oooooo00?o0000ooooooooool0A_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo03Wooooo00?o0000ooooooooool00_ooool2o`0000Kooooo00?o0000ooooooooool0hoooool1
o`000000=?ooool00ol0003oooooooooo`1fooooo`03o`000?oooooooooo01Cooooo00?o0000oooo
ooooool0A_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo03Sooooo00?o0000oooo
ooooool01?ooool3o`0000?ooooo00?o0000ooooooooool0hoooool1o`000000=?ooool00ol0003o
ooooooooo`1gooooo`;o00005Oooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo02co
oooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`06ooooo`?o000000?oooooo`000?oo
ool0hoooool1o`000000=?ooool00ol0003oooooooooo`1iooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool0AOooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo03Oooooo
00?o0000ooooooooool02Oooool2o`000>Cooooo0Ol0000003Cooooo00?o0000ooooooooool0M?oo
ool3o`0000?ooooo0_l0000Booooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool0;_oo
ool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo00[ooooo1?l0003Qooooo`7o0000000d
ooooo`03o`000?oooooooooo07?ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oo
oooooooo013ooooo00?o0000ooooooooool0A?ooool00ol0003oooooooooo`0_ooooo`03o`000?oo
oooooooo03Gooooo00?o0000ooooooooool02_ooool01?l0003oooooooooooooool3o`000=kooooo
0Ol0000003Cooooo00?o0000ooooooooool0M_ooool2o`0000Gooooo0_l0000@ooooo`03o`000?oo
oooooooo04Cooooo00?o0000ooooooooool0;oooool5o`0003?ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`04ooooo`?o0000foooool1o`000000=?ooool3o`0007Kooooo0_l00007
ooooo`;o00003_ooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo033ooooo0_l00000
0ooooooo0000ooooo`0booooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool01oooool2
o`000=Oooooo0ol0000003Cooooo00?o0000ooooooooool0Loooool5o`0000Wooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`14ooooo`03o`000?oooooooooo037ooooo0_l0000doooo
o`03o`000?oooooooooo00Wooooo0ol0000:ooooo`?o0000e_ooool1o`000000=?ooool00ol0003o
ooooooooo`1cooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool2o`0000co
oooo00?o0000ooooooooool0@oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02o`0000cooooo0ol00002ooooo`?o
0000c_ooool1o`000000=?ooool00ol0003oooooooooo`1cooooo`Go000000?oooooo`000?ooool0
2Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo04?ooooo00?o0000ooooooooool0
;oooool01Ol0003ooooooooooooooooo000003?ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`02o`0000oooooo1?l0003?ooooo`7o0000000dooooo`03o`000?oooooooooo07[ooooo
00?o0000ooooooooool02?ooool2o`0000Wooooo00?o0000ooooooooool0@oooool00ol0003ooooo
ooooo`0_ooooo`05o`000?ooooooooooooooool00000<Oooool3o`0000_ooooo0ol0000@ooooo`Go
0000c_ooool1o`000000=?ooool00ol0003oooooooooo`1kooooo`03o`000?oooooooooo00Wooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`13ooooo`03o`000?oooooooooo033ooooo
0ol000000ooooooo0000ooooo`0`ooooo`;o00002_ooool00ol0003oooooooooo`02o`0000oooooo
00?o0000ooooooooool00_l0003>ooooo`7o0000000dooooo`03o`000?oooooooooo07cooooo00?o
0000ooooooooool02Oooool2o`0000Oooooo00?o0000ooooooooool0@_ooool00ol0003ooooooooo
o`0dooooo`03o`000?oooooooooo02oooooo0ol00009ooooo`03o`000?oooooooooo00;o00004?oo
ool01Ol0003oooooo`000?oooooo00000<gooooo0Ol0000003Cooooo00?o0000ooooooooool0OOoo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0@_oo
ool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo02kooooo00Co0000oooooooooooo0000
2Oooool3o`0001;ooooo0_l00002ooooo`03o`000?oooooooooo0<[ooooo0Ol0000003Cooooo00?o
0000ooooooooool0O_ooool00ol0003oooooooooo`0:ooooo`;o00000oooool3o`0004?ooooo00?o
0000ooooooooool0=Oooool00ol0003oooooooooo`0^ooooo`04o`000?ooooooooooooooo`;o0000
2_ooool00ol0003oooooooooo`0@ooooo`05o`000?ooooooooooooooool00000boooool1o`000000
=?ooool00ol0003oooooooooo`1oooooo`03o`000?oooooooooo00_ooooo00?o0000ooooool00000
0_ooool2o`0004;ooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0]ooooo`;o0000
1Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool0
b?ooool1o`000000=?ooool00ol0003oooooooooo`20ooooo`03o`000?oooooooooo00_ooooo0_l0
0002ooooo`;o0000@_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool01?ooool2o`0000Oooooo00?o0000ooooooooool05_ooool00ol0003ooooooooo
o`37ooooo`7o0000000dooooo`03o`000?oooooooooo087ooooo00?o0000ooooooooool03?ooool3
o`0004?ooooo00?o0000ooooooooool0=_ooool00ol0003oooooooooo`0fooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`36ooooo`7o0000000doooo
o`03o`000?oooooooooo08;ooooo00?o0000ooooooooool03?ooool4o`00047ooooo00?o0000oooo
ooooool0=oooool00ol0003oooooooooo`0fooooo`;o00001?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo0<Gooooo0Ol0000001_ooooo1Ol00003ooooo`03o`000?oooooooooo00;o
oooo0ol00009ooooo`03o`000?oooooooooo08;ooooo00?o0000ooooooooool02_ooool01?l0003o
ooooo`000?ooool3o`00043ooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0hoooo
o`;o00000_ooool00ol0003oooooooooo`0Iooooo`03o`000?oooooooooo0<Cooooo0Ol0000001co
oooo00Co0000oooooooooooo00001oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000
ooooooooool0Poooool00ol0003oooooooooo`0:ooooo`?o000000Coooooo`000?l0003o0000?ooo
ool00ol0003oooooooooo`0hooooo`03o`000?oooooooooo03Wooooo00?o0000ooooool000007?oo
ool00ol0003oooooooooo`33ooooo`7o0000000Eooooo`Go00000oooool00ol0003oooooooooo`0;
ooooo`03o`000?oooooooooo00Kooooo1Ol00022ooooo`03o`000?oooooooooo00[ooooo1Ol00000
0ooooooo0000o`000003o`0003[ooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`0j
ooooo`?o00007?ooool00ol0003oooooooooo`2oooooo`Co0000000Nooooo`03o`000?oooooooooo
00[ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`25ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`Co0000=_ooool00ol0
003oooooooooo`0iooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool06oooool4o`00
0<3ooooo0Ol0000001_ooooo00Go0000ooooooooooooooooo`000007ooooo`Co00002Oooool00ol0
003oooooooooo`26ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`06ooooo`Go0000<Oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo
03_ooooo1Ol0000Jooooo`;o0000`Oooool1o`0000006oooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`27ooooo`03o`000?oooooooooo
00Wooooo0_l00002ooooo`03o`000?oooooooooo00_ooooo1Ol0000/ooooo`03o`000?oooooooooo
03[ooooo00?o0000ooooooooool0>_ooool01?l0003oooooooooool0000Iooooo`Go0000`?ooool1
o`0000007?ooool3o`0000Sooooo1Ol00008ooooo`03o`000?oooooooooo08Sooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0?ooooo`Co0000:?ooool00ol0003oooooooooo`0joooo
o`03o`000?oooooooooo03[ooooo00?o0000ooooooooool00_l0000Hooooo`04o`000?oooooooooo
o`000<7ooooo0Ol0000003Cooooo00?o0000ooooooooool0ROooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo01;ooooo1Ol0000Sooooo`03o`000?oooooooooo03_ooooo00?o0000oooo
ooooool0>Oooool00ol0003oooooooooo`02o`0001Wooooo00Co0000ooooool0003o0000`?ooool1
o`000000=?ooool00ol0003oooooooooo`2:ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool05_ooool4o`0001oooooo00?o0000ooooooooool0>oooool00ol0003oooooooooo`0ioooo
o`06o`000?ooooooooooo`000?oooooo00006Oooool3o`000<3ooooo0Ol0000003Cooooo00?o0000
ooooooooool0Roooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo01[ooooo1Ol0000K
ooooo`03o`000?oooooooooo03[ooooo00?o0000ooooooooool0>_ooool3o`000003ooooool0003o
oooo01Wooooo00?o0000ooooool00000_oooool1o`000000=?ooool00ol0003oooooooooo`2<oooo
o`?o00003?ooool00ol0003oooooooooo`0Nooooo`Co00005oooool00ol0003oooooooooo`0koooo
o`03o`000?oooooooooo03Wooooo00?o0000ooooool000000_ooool00ol0003oooooooooo`0Ioooo
o`03o`000?oooooooooo0;gooooo0Ol0000003Cooooo00?o0000ooooooooool0Roooool01Ol0003o
ooooo`000?oooooo000000cooooo00?o0000ooooooooool08Oooool5o`0001;ooooo00?o0000oooo
ooooool0>oooool00ol0003oooooooooo`0iooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool06_ooool00ol0003oooooooooo`2looooo`7o0000000dooooo`03o`000?oooooooooo08ko
oooo0ol0000;ooooo`03o`000?oooooooooo02Kooooo1?l0000>ooooo`03o`000?oooooooooo03[o
oooo1Ol0000hooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool06Oooool00ol0003o
ooooooooo`2looooo`7o0000000dooooo`03o`000?oooooooooo08oooooo00?o0000ooooool00000
1?l00007ooooo`?o0000:Oooool5o`0000Wooooo00?o0000ooooooooool0>oooool2o`000003oooo
ool0003ooooo03Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo0;cooooo0Ol0000003Cooooo00?o0000ooooooooool0Roooool4o`0000Oooooo1Ol0
00001_oooooo0000ooooool0003oooooo`0002gooooo1Ol00004ooooo`03o`000?oooooooooo03co
oooo0ol0000hooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool06Oooool3o`000;_o
oooo0Ol0000003Cooooo00?o0000ooooooooool0Roooool00ol0003oooooooooo`0=ooooo`Ko0000
<_ooool5o`0003oooooo00Co0000ooooool0003o0000=_ooool00ol0003oooooooooo`04ooooo`?o
00006Oooool2o`000;cooooo0Ol0000003Cooooo00?o0000ooooooooool0Roooool5o`0000kooooo
1_l0000cooooo`Go0000>?ooool01Ol0003ooooooooooooooooo000000;ooooo0ol0000dooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool05_ooool5o`000;_ooooo0Ol0000003Cooooo
0ol0002Oooooo`;o00000oooool5o`0002kooooo00?o0000ooooooooool00_ooool4o`0003Cooooo
00Go0000ooooooooooooooooo`000005ooooo`;o0000<?ooool3o`0000Kooooo0ol0000Fooooo`03
o`000?oooooooooo00;o0000^Oooool3o`000000=?ooool00ol0003oooooooooo`2Looooo`03o`00
0?oooooooooo00;o00002?ooool5o`0002Wooooo00?o0000ooooooooool01_ooool5o`00033ooooo
0ol00008ooooo`;o0000;Oooool00ol0003oooooooooo`02o`0000Gooooo00Co0000oooooooooooo
00005_ooool01Ol0003oooooo`000?oooooo00000;[ooooo0Ol0000003Cooooo00?o0000oooooooo
ool0WOooool3o`0000kooooo1Ol0000Tooooo`03o`000?oooooooooo00_ooooo1?l0000iooooo`;o
0000:oooool00ol0003oooooooooo`02o`0000Gooooo00Go0000ooooooooooooooooo`00000Foooo
o`;o00000_ooool00ol0003oooooooooo`2gooooo`7o0000000dooooo`03o`000?oooooooooo09oo
oooo00?o0000ooooooooool04Oooool4o`00023ooooo00?o0000ooooooooool03oooool5o`0003Ko
oooo0ol0000Yooooo`?o000000?oooooo`000?ooool00_ooool2o`0000Cooooo00?o0000oooooooo
ool05?ooool01Ol0003ooooooooooooooooo00000;Sooooo0Ol0000003Cooooo00?o0000oooooooo
ool0Woooool00ol0003oooooooooo`0Eooooo`Go00006oooool00ol0003oooooooooo`0Dooooo`Co
0000=Oooool2o`0002Kooooo00Oo0000ooooooooooooooooo`000?oooooo000000?ooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0;Gooooo0Ol00000
03Cooooo00?o0000ooooooooool0Woooool00ol0003oooooooooo`0Jooooo`Go00005_ooool00ol0
003oooooooooo`0Hooooo`Go0000<_ooool2o`0002Cooooo00Go0000ooooooooooooooooo`000002
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`2d
ooooo`7o0000000dooooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool07_ooool5o`00
017ooooo00?o0000ooooooooool07Oooool5o`0002oooooo0_l0000Sooooo`?o00001?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo01Sooooo1?l0002booooo`7o0000000dooooo`03
o`000?oooooooooo0:3ooooo00?o0000ooooooooool08oooool4o`0000gooooo00?o0000oooooooo
ool08_ooool4o`0000Cooooo0ol0000Vooooo`?o0000:?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo01Sooooo0_l0002cooooo`7o0000000dooooo`03o`000?oooooooooo0:3ooooo
00?o0000ooooooooool09oooool5o`0000Sooooo00?o0000ooooooooool09_ooool5o`0000;ooooo
00?o0000ooooooooool09_ooool2o`0002Oooooo00?o0000ooooooooool01oooool3o`0001Gooooo
1Ol0002booooo`7o0000000dooooo`03o`000?oooooooooo0:3ooooo00?o0000ooooooooool0;?oo
ool5o`0000?ooooo00?o0000ooooooooool0:Oooool00ol0003oooooo`000002o`0002[ooooo0_l0
000Vooooo`;o00002?ooool00ol0003oooooooooo`0Dooooo`04o`000?ooooooooooo`000;?ooooo
0Ol0000003Cooooo00?o0000ooooooooool0W_ooool3o`0003?ooooo1Ol0000Zooooo`Co000000?o
ooooo`000?ooool0:_ooool2o`0002Kooooo00?o0000ooooooooool01Oooool2o`0001Kooooo00?o
0000ooooool00000/oooool1o`000000=?ooool00ol0003oooooooooo`2Mooooo`03o`000?oooooo
oooo00;o0000=Oooool00ol0003oooooo`000003o`0002Kooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`0Zooooo`Oo00008?ooool00ol0003oooooooooo`04ooooo`;o00005oooool2
o`000;?ooooo0Ol0000003Cooooo00?o0000ooooooooool0X?ooool2o`0003Gooooo00?o0000oooo
ooooool00oooool5o`0002;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0/oooo
o`;o000000?oooooo`000?ooool08?ooool00ol0003oooooooooo`03ooooo`;o00006?ooool2o`00
0;;ooooo0Ol0000003Cooooo00?o0000ooooooooool0Woooool2o`000003ooooool0003ooooo03?o
oooo00?o0000ooooooooool02?ooool5o`0000Cooooo0ol0000Gooooo`;o00001?ooool00ol0003o
ooooooooo`0/ooooo`;o00008oooool01?l0003oooooooooooooool3o`0001Sooooo0ol0002aoooo
o`7o0000000dooooo`03o`000?oooooooooo0:7ooooo00?o0000ooooool00000<oooool00ol0003o
ooooooooo`0=ooooo`Go00000_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo02co
oooo00?o0000ooooooooool08_ooool01?l0003oooooooooooooool2o`0001Wooooo00?o0000oooo
ooooool0/?ooool1o`000000=?ooool3o`0009gooooo00Go0000ooooooooooooooooo`000002oooo
o`03o`000?oooooooooo033ooooo00?o0000ooooooooool04_ooool3o`0001kooooo00?o0000oooo
ooooool0:?ooool00ol0003oooooooooo`02o`0002Cooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0Cooooo`Go0000[oooool3o`000000=?ooool00ol0003oooooooooo`2Nooooo`?o
00001?ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooooooo01Cooooo0_l0000Nooooo`03
o`000?oooooooooo02Oooooo00Go0000ooooooooooooooooo`00000Uooooo`05o`000?oooooooooo
ooooool000005Oooool01?l0003oooooooooool0002booooo`7o0000000dooooo`03o`000?oooooo
oooo0:Kooooo0_l0000_ooooo`03o`000?oooooooooo013ooooo1?l00002ooooo`;o00007Oooool0
0ol0003oooooooooo`0Wooooo`Co00009_ooool4o`0001Kooooo00Co0000ooooool0003o0000/Ooo
ool1o`000000=?ooool00ol0003oooooooooo`2Xooooo`03o`000?oooooooooo02cooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`05ooooo`;o00007?ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo02Kooooo0_l0000Gooooo`;o000000?oooooo`000?ooool0[oooool1
o`000000=?ooool00ol0003oooooooooo`2Yooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool04?ooool5o`0000Gooooo00?o0000ooooooooool06_ooool2o`0002Wooooo00?o0000oooo
ooooool09_ooool2o`0001Sooooo00?o0000ooooool00000/?ooool1o`000000=?ooool00ol0003o
ooooooooo`2Zooooo`?o0000:_ooool00ol0003oooooooooo`0Kooooo`;o00007?ooool00ol0003o
ooooooooo`0Wooooo`03o`000?oooooooooo02Gooooo0ol0000Jooooo`03o`000?oooooooooo0:go
oooo0Ol0000003Cooooo00?o0000ooooooooool0ZOooool01Ol0003oooooo`000?oooooo000002Wo
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool09Oooool01?l0003oooooo`000?l0000Iooooo`03o`000?oooooooooo
0:gooooo0Ol0000003Cooooo00?o0000ooooooooool0[?ooool4o`0002Oooooo00?o0000oooooooo
ool07_ooool2o`0001_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Tooooo`;o
000000Coooooo`000?oooooo00006Oooool00ol0003oooooooooo`2/ooooo`7o0000000dooooo`03
o`000?oooooooooo0:_ooooo0_l00003ooooo`Ko00008Oooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo01Wooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Uooooo`06
o`000?ooooooooooo`000?oooooo00006Oooool3o`000:_ooooo0Ol0000003Cooooo00?o0000oooo
ooooool0[Oooool00ol0003oooooooooo`06ooooo`Ko00006oooool00ol0003oooooooooo`0Qoooo
o`;o00006_ooool00ol0003oooooooooo`0Qooooo`Go0000:?ooool00ol0003oooooooooo`02o`00
01Oooooo0_l0002/ooooo`7o0000000dooooo`03o`000?oooooooooo0:Wooooo00Go0000oooooooo
ooooooooo`00000>ooooo`Ko00005_ooool00ol0003oooooooooo`0Rooooo`;o00006Oooool00ol0
003oooooooooo`0Qooooo`04o`000?oooooo0000o`0002Wooooo00Go0000ooooooooooooooooo`00
000Dooooo`Go0000Zoooool1o`000000=?ooool00ol0003oooooooooo`2Zooooo`?o00005Oooool6
o`00013ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo027ooooo0_l0000Zooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04Oooool0
1?l0003oooooooooool0002/ooooo`7o0000000dooooo`03o`000?oooooooooo0<Sooooo1_l0000:
ooooo`03o`000?oooooooooo02Gooooo0_l0000Hooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooool00000[?ooool1o`000000=?ooool00ol0003oooooooooo`3>ooooo`Ko00001?ooool00ol0
003oooooooooo`0Wooooo`03o`000?oooooooooo01Kooooo0ol0000Mooooo`05o`000?oooooooooo
ooooool00000:_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo017ooooo0_l0002/
ooooo`7o0000000dooooo`03o`000?oooooooooo0=Cooooo1_l00006ooooo`?o00008?ooool2o`00
01Gooooo00Go0000ooooool0003oooooo`00000Looooo`04o`000?ooooooooooooooo`;o0000:_oo
ool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0Z_oo
ool1o`000000=?ooool3o`000=Sooooo00?o0000ooooool000001Ol00003ooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`03o`0001cooooo0ol00002
ooooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo0:Sooooo0ol0000003Cooooo00?o0000ooooooooool0f?ooool00ol0
003oooooooooo`05ooooo`Co00008_ooool2o`0001;ooooo1?l00002ooooo`?o00007_ooool00ol0
003oooooooooo`0Xooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03oooool00ol0
003oooooooooo`2Zooooo`7o0000000dooooo`03o`000?oooooooooo0=Sooooo00?o0000oooooooo
ool01_ooool2o`000003ooooool0003ooooo02;ooooo0_l0000@ooooo`03o`000?oooooooooo00Ko
oooo0ol0000Looooo`03o`000?oooooooooo02Oooooo00?o0000ooooooooool01Oooool2o`0000oo
oooo00?o0000ooooooooool0Z_ooool1o`000000=?ooool00ol0003oooooooooo`3Hooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooool000009?ooool00ol0003oooooooooo`0>ooooo`03o`00
0?oooooooooo00Sooooo0ol0000Jooooo`03o`000?oooooooooo02Kooooo0ol00007ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool0ZOooool1o`000000=?ooool00ol0003ooooooooo
o`3Hooooo`03o`000?oooooooooo00Cooooo00Go0000ooooooooooooooooo`000002ooooo`;o0000
8oooool2o`0000oooooo0_l0000;ooooo`?o00006?ooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`2Yooooo`7o0000
000dooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool01Oooool3o`0000Gooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`0Looooo`?o00005Oooool00ol0003ooooooooo
o`0Vooooo`;o00002Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo0:Wooooo0Ol0
000003Cooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0>ooooo`;o00008oooool2
o`0001oooooo0ol0000Booooo`Go00009?ooool2o`0000[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`2Yooooo`7o0000000dooooo`03o`000?oooooooooo0=Sooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo01oooooo0ol0000@oooo
o`;o000000?oooooo`000?ooool08oooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool0ZOooool1o`000000=?ooool00ol0003oooooooooo`3Hooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool08_ooool2o`0002;ooooo0ol0000>ooooo`;o
00009?ooool2o`0000;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`?o
0000Z_ooool1o`000000=?ooool00ol0003oooooooooo`3Hooooo`03o`000?oooooooooo01;ooooo
0_l0000Tooooo`;o00008oooool3o`0000cooooo00?o0000ooooooooool08oooool01Ol0003ooooo
oooooooooooo000000[ooooo0_l00008ooooo`03o`000?oooooooooo0:Wooooo0Ol0000003Cooooo
00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo02?ooooo
00?o0000ooooooooool08oooool3o`0000Kooooo00?o0000ooooooooool00_l0000Yooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool00_ooool5o`000:[ooooo0Ol0000003Cooooo00?o
0000ooooooooool0f?ooool00ol0003oooooooooo`0Eooooo`;o00009?ooool2o`0002Kooooo0ol0
0003ooooo`05o`000?ooooooooooooooool00000:_ooool00ol0003oooooooooo`09ooooo`05o`00
0?ooooooooooooooool000000_ooool00ol0003oooooo`000002o`000:Oooooo0Ol0000003Cooooo
00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Gooooo`?o00008oooool00ol0003ooooo
ooooo`0Vooooo`?o000000?oooooo`000?l000000_l0000[ooooo`03o`000?oooooooooo00Wooooo
00Oo0000ooooooooooooooooo`000?oooooo000000Cooooo0_l0002Uooooo`7o0000000dooooo`03
o`000?oooooooooo0=Sooooo00?o0000ooooooooool05_ooool01Ol0003oooooo`000?oooooo0000
02?ooooo0_l0000Yooooo`?o000000?oooooo`000?ooool0:_ooool00ol0003oooooooooo`0:oooo
o`04o`000?ooooooooooooooo`;o00001_ooool2o`000:?ooooo0Ol0000003Cooooo00?o0000oooo
ooooool0f?ooool00ol0003oooooooooo`0Iooooo`;o00009Oooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo00;o0000;?ooool00ol0003oooooooooo`0:ooooo`05o`000?oooooooooo
ooooool000002?ooool3o`000:3ooooo0Ol0000003Cooooo0ol0003Hooooo`03o`000?oooooooooo
01Sooooo0_l0000Wooooo`;o00009_ooool4o`000003ooooool0003ooooo02_ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`0<ooooo`;o0000W?ooool3o`000000=?ooool00ol0003o
ooooooooo`3Hooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool09_ooool4o`0002;o
oooo00Ko0000oooooooooooo0000ooooool0000]ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool03Oooool2o`0009cooooo0Ol0000003Cooooo00?o0000ooooooooool0f?ooool00ol0
003oooooooooo`0Fooooo`05o`000?ooooooooooooooool00000:?ooool01Ol0003oooooo`000?oo
oooo000002;ooooo00Go0000ooooool0003oooooo`00000^ooooo`03o`000?oooooooooo00[ooooo
0_l0000?ooooo`?o0000VOooool1o`000000=?ooool00ol0003oooooooooo`3Hooooo`03o`000?oo
oooooooo01Oooooo0ol000000ooooooo0000ooooo`0Yooooo`?o00008_ooool4o`0002oooooo00?o
0000ooooooooool02oooool00ol0003oooooooooo`0?ooooo`;o0000Uoooool1o`000000=?ooool0
0ol0003oooooooooo`3Hooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0:?ooool0
0ol0003oooooo`000003o`0001oooooo1Ol0000^ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool04?ooool2o`0009Gooooo0Ol0000003Cooooo00?o0000ooooooooool0f?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo02Cooooo1?l00006ooooo`Go00006oooool01?l0
003oooooo`000?l0000^ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool04Oooool3
o`0009;ooooo0Ol0000003Cooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo02?ooooo00?o0000ooooooooool03?ooool4o`0001Oooooo0ol0000`oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool04oooool2o`00093ooooo0Ol0000003Co
oooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo02?o
oooo1Ol0000>ooooo`Co00004oooool00ol0003oooooo`00000aooooo`03o`000?oooooooooo00co
oooo0ol0000Dooooo`;o0000S_ooool1o`000000=?ooool00ol0003oooooooooo`3Hooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0>Oooool5o`0000gooooo0_l00002ooooo`03o`00
0?oooooooooo02oooooo00?o0000ooooooooool02_ooool01Ol0003oooooo`000?oooooo000001Go
oooo0ol0002;ooooo`7o0000000dooooo`03o`000?oooooooooo0=Sooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`0nooooo`Co00002Oooool2o`0000;ooooo00?o0000ooooooooool0
<?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00;o00006?ooool2o`0008Wooooo
0Ol0000003Cooooo00?o0000ooooooooool0f?ooool00ol0003oooooooooo`0Oooooo`03o`000?oo
oooooooo047ooooo1?l00006ooooo`?o000000?oooooo`000?ooool0<Oooool00ol0003ooooooooo
o`09ooooo`?o00006oooool2o`0008Oooooo0Ol0000003Cooooo00?o0000ooooooooool0f?ooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo04Gooooo1?l000001?oooooo0000o`000?l0
0002ooooo`03o`000?oooooooooo033ooooo00?o0000ooooooooool02?ooool01Ol0003ooooooooo
oooooooo000001cooooo0ol00024ooooo`7o0000000dooooo`03o`000?oooooooooo0=Sooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`18ooooo`Go00000_ooool00ol0003ooooooooo
o`0`ooooo`03o`000?oooooooooo00Oooooo00Co0000oooooooooooooooo0_l0000Nooooo`;o0000
P_ooool1o`000000:Oooool2o`0000Wooooo00?o0000ooooooooool0fOooool00ol0003ooooooooo
o`0Pooooo`03o`000?oooooooooo04Oooooo00?o0000ooooooooool01_l0000booooo`03o`000?oo
oooooooo00Oooooo0ol000000ooooooo0000ooooo`0Oooooo`;o0000P?ooool1o`000000:?ooool0
1?l0003oooooooooool00008ooooo`03o`000?oooooooooo0=Wooooo00?o0000ooooooooool08?oo
ool00ol0003oooooooooo`17ooooo`Co000000Coooooo`000?l0003ooooo1Ol0000_ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool07oooool3o`0007gooooo0Ol0000002Sooooo00Co
0000oooooooooooo00002?ooool5o`000=Oooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`16ooooo`03o`000?oooooooooo00Cooooo0_l00004ooooo`Co0000;?ooool3o`0000[ooooo
00?o0000ooooooooool08_ooool2o`0007Sooooo1?l0000002Sooooo00Co0000oooooooooooo0000
2?ooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
Aoooool00ol0003oooooooooo`05ooooo`?o00001Oooool5o`0002Sooooo00?o0000ooooooooool0
2_ooool00ol0003oooooooooo`0Sooooo`;o0000NOooool1o`000000:?ooool01?l0003ooooooooo
ool00008ooooo`03o`000?oooooooooo0=Wooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`17ooooo`;o00001Oooool00ol0003oooooooooo`02o`0000Sooooo1?l0000Tooooo`Co0000
2_ooool00ol0003oooooooooo`0Tooooo`?o0000M_ooool1o`000000:?ooool01?l0003ooooooooo
ool00008ooooo`03o`000?oooooooooo0=Wooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`1?ooooo`04o`000?ooooooooooooooo`;o00002_ooool4o`00023ooooo00Co0000oooooooo
oooooooo1?l00006ooooo`03o`000?oooooooooo02Oooooo0_l0001dooooo`7o0000000Yooooo`;o
00002Oooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo02?ooooo00?o0000oooooooo
ool0Coooool00ol0003oooooooooo`02ooooo`;o00003?ooool5o`0001_ooooo00?o0000oooooooo
ool01Oooool4o`0000?ooooo00?o0000ooooooooool0:?ooool2o`0007;ooooo0Ol0000003Cooooo
00?o0000ooooooooool0fOooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo04oooooo
00?o0000ooooooooool01?ooool2o`0000oooooo1?l0000Fooooo`;o00002oooool4o`0002cooooo
0ol000001?oooooo0000o`000?l0001[ooooo`7o0000000dooooo`03o`000?oooooooooo0=Wooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Gooooo
0_l0000Aooooo`Co00004oooool00ol0003oooooooooo`0=ooooo`Co0000:oooool3o`0006cooooo
0Ol0000003Cooooo00?o0000ooooooooool0fOooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool01oooool2o`0001?ooooo1?l0000Pooooo`03o`000?oo
oooooooo00Co00009_ooool5o`0006_ooooo0Ol0000003Cooooo00?o0000ooooooooool0fOooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool02?ooool3
o`0001Cooooo1Ol0000Kooooo`03o`000?oooooooooo00Cooooo1?l0000Rooooo`06o`000?oooooo
ooooo`000?oooooo0000J_ooool1o`000000=?ooool00ol0003oooooooooo`3Iooooo`03o`000?oo
oooooooo02Gooooo0ol0001?ooooo`03o`000?oooooooooo00_ooooo0_l0000Gooooo`Co00006?oo
ool00ol0003oooooooooo`07ooooo`Co00007oooool00ol0003oooooo`000002ooooo`;o0000J?oo
ool1o`000000=?ooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo02Cooooo00Go0000
ooooool0003oooooo`00001?ooooo`03o`000?oooooooooo00cooooo0_l0000Iooooo`Co00005Ooo
ool00ol0003oooooooooo`0:ooooo`Co00007?ooool2o`0000Cooooo00?o0000ooooooooool0IOoo
ool1o`000000=?ooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo02Oooooo0ol0001>
ooooo`03o`000?oooooooooo00kooooo0_l0000Kooooo`Go00004?ooool00ol0003oooooooooo`0>
ooooo`Co00006Oooool00ol0003oooooooooo`03ooooo`;o0000IOooool1o`000000=?ooool00ol0
003oooooooooo`3Iooooo`03o`000?oooooooooo02Kooooo0_l00002ooooo`?o0000B_ooool5o`00
00oooooo0_l0000Nooooo`Co00003Oooool00ol0003oooooooooo`0Aooooo`Co00007Oooool2o`00
06?ooooo0Ol0000003Cooooo00?o0000ooooooooool0fOooool00ol0003oooooooooo`0Xooooo`03
o`000?oooooooooo00;ooooo1?l00017ooooo`;o000000?oooooo`000?ooool04?ooool2o`00023o
oooo1?l00009ooooo`03o`000?oooooooooo01Gooooo1?l0000Kooooo`03o`000?oooooooooo063o
oooo0Ol0000003Cooooo00?o0000ooooooooool0fOooool00ol0003oooooooooo`0Tooooo`05o`00
0?ooooooooooooooool000002?ooool4o`0004Cooooo0_l0000Dooooo`;o00008_ooool4o`0000Ko
oooo00?o0000ooooooooool06?ooool3o`0001Wooooo0_l0001Pooooo`7o0000000dooooo`?o0000
fOooool00ol0003oooooooooo`0Uooooo`?o00003Oooool3o`0004;ooooo00?o0000ooooooooool0
5?ooool3o`0002?ooooo1Ol00002ooooo`03o`000?oooooooooo01[ooooo1?l0000Gooooo`03o`00
0?oooooooooo05_ooooo0ol0000003Cooooo00?o0000ooooooooool0fOooool00ol0003ooooooooo
o`0hooooo`Co0000>oooool01Ol0003ooooooooooooooooo000001Sooooo1Ol0000Sooooo`Co0000
7oooool4o`0001Cooooo0_l0001Mooooo`7o0000000dooooo`03o`000?oooooooooo0=Wooooo00?o
0000ooooooooool0??ooool4o`0003Oooooo00Co0000oooooooooooooooo0_l0000Hooooo`?o0000
00?oooooo`000?ooool09?ooool5o`0001oooooo1?l0000Booooo`03o`000?oooooooooo05[ooooo
0Ol0000003Cooooo00?o0000ooooooooool0fOooool00ol0003oooooooooo`10ooooo`?o0000=Ooo
ool3o`0000;ooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`03o`0002Cooooo00?o
0000ooooooooool00_ooool5o`0001kooooo1?l0000?ooooo`;o0000F_ooool1o`000000=?ooool0
0ol0003oooooooooo`3Iooooo`03o`000?oooooooooo04?ooooo1?l0000fooooo`03o`000?oooooo
oooo01Gooooo1?l00002ooooo`?o00008_ooool00ol0003oooooooooo`06ooooo`Co00007_ooool4
o`0000gooooo0_l0001Hooooo`7o0000000dooooo`03o`000?oooooooooo0=Wooooo00?o0000oooo
ooooool0Aoooool4o`0003?ooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`06oooo
o`?o00008?ooool00ol0003oooooooooo`09ooooo`Co00007_ooool4o`0000_ooooo00?o0000oooo
ooooool0EOooool1o`000000=?ooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo04_o
oooo0ol0000aooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02?ooool3o`0001go
oooo00?o0000ooooooooool03Oooool4o`0001kooooo1?l00008ooooo`;o0000EOooool1o`000000
=?ooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo04kooooo1?l0000^ooooo`03o`00
0?oooooooooo01Cooooo0_l0000;ooooo`?o00006oooool00ol0003oooooooooo`0@ooooo`Go0000
7Oooool4o`0000Kooooo00?o0000ooooooooool0D_ooool1o`000000=?ooool00ol0003ooooooooo
o`3Iooooo`03o`000?oooooooooo05;ooooo1?l0000Zooooo`03o`000?oooooooooo02Cooooo0ol0
000Hooooo`?o00005Oooool4o`0001gooooo1?l00003ooooo`;o0000D_ooool1o`000000=?ooool0
0ol0003oooooooooo`3Iooooo`03o`000?oooooooooo05Kooooo0ol0000Xooooo`03o`000?oooooo
oooo02Kooooo1?l0000Cooooo`05o`000?oooooo0000ooooool000006?ooool4o`0001gooooo1?l0
00000ooooooo0000ooooo`03o`0004gooooo0Ol0000003Cooooo00?o0000ooooooooool0fOooool0
0ol0003oooooooooo`1Iooooo`Co00009Oooool00ol0003oooooooooo`0Yooooo`?o00004?ooool0
0ol0003oooooooooo`02o`0001cooooo1?l0000Mooooo`Go0000C_ooool1o`000000=?ooool00ol0
003oooooooooo`3Iooooo`03o`000?oooooooooo05gooooo1?l0000Rooooo`03o`000?oooooooooo
02_ooooo0ol0000>ooooo`?o000000?oooooo`000?ooool07_ooool5o`0001cooooo0_l0001=oooo
o`7o0000000dooooo`03o`000?oooooooooo0=Wooooo00?o0000ooooooooool0HOooool3o`0001oo
oooo00?o0000ooooooooool0;_ooool3o`0000[ooooo00Oo0000ooooooooooooooooo`000?oooooo
000002?ooooo1?l0000Hooooo`?o0000C?ooool1o`000000=?ooool00ol0003oooooooooo`3Ioooo
o`03o`000?oooooooooo06Cooooo1?l0000Looooo`03o`000?oooooooooo033ooooo0ol00007oooo
o`05o`000?ooooooooooooooool000000_ooool2o`0002Gooooo1?l0000Dooooo`03o`000?oooooo
000000;o0000B_ooool1o`000000=?ooool00ol0003oooooooooo`3Iooooo`03o`000?oooooooooo
06Sooooo1?l0000Iooooo`03o`000?oooooooooo03;ooooo0ol00005ooooo`?o00001Oooool00ol0
003oooooooooo`0Vooooo`Go00000oooool3o`0000Sooooo0_l000001Ooooooo0000oooooooooooo
000004Wooooo0Ol0000003Cooooo0ol0003Iooooo`03o`000?oooooooooo06cooooo0ol0000Goooo
o`03o`000?oooooooooo03Cooooo0ol0000;ooooo`;o0000:oooool4o`0000;ooooo00?o0000oooo
ooooool01_ooool01?l0003oooooooooool00002ooooo`Go0000@_ooool3o`000000=?ooool00ol0
003oooooooooo`3Jooooo`03o`000?oooooooooo06kooooo1?l0000Dooooo`03o`000?oooooooooo
03Kooooo1?l00009ooooo`03o`000?oooooooooo02cooooo0ol0000<ooooo`04o`000?oooooooooo
ooooo`;o0000AOooool1o`000000=?ooool00ol0003oooooooooo`3Jooooo`03o`000?oooooooooo
07;ooooo1?l0000@ooooo`03o`000?oooooooooo03[ooooo0ol00007ooooo`03o`000?oooooooooo
02cooooo0_l0000<ooooo`03o`000?oooooo000000Co0000A?ooool1o`000000=?ooool00ol0003o
ooooooooo`3Jooooo`03o`000?oooooooooo07Kooooo0ol0000>ooooo`03o`000?oooooooooo03co
oooo0ol00005ooooo`;o0000:Oooool5o`0000gooooo0_l00002ooooo`04o`000?oooooo0000o`00
04;ooooo0Ol0000003Cooooo00?o0000ooooooooool0f_ooool00ol0003oooooooooo`1iooooo`Co
00002oooool00ol0003oooooooooo`0nooooo`?o00001?ooool00ol0003oooooooooo`0Vooooo`05
o`000?ooooooooooooooool000003Oooool01Ol0003oooooo`000?oooooo000000?ooooo0_l00010
ooooo`7o0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000ooooooooool0OOooool4o`00
00Sooooo00?o0000ooooooooool0@?ooool3o`0000;ooooo0_l0000Vooooo`Ko00003Oooool01?l0
003oooooo`000?l00005ooooo`;o0000?_ooool1o`000000=?ooool00ol0003oooooooooo`3Joooo
o`03o`000?oooooooooo087ooooo0ol00005ooooo`03o`000?oooooooooo04?ooooo0ol000000ooo
oooo0000ooooo`0Yooooo`03o`000?oooooooooo00_ooooo00Co0000oooooooooooo00001oooool0
0ol0003oooooooooo`0kooooo`7o0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000oooo
ooooool0Q?ooool4o`0000;ooooo00?o0000ooooooooool0AOooool4o`0002Sooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`08ooooo`;o0000>oooool1o`000000=?ooool00ol0003o
ooooooooo`3Jooooo`03o`000?oooooooooo08Sooooo1?l00002ooooo`?o0000A?ooool4o`0002Ko
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`;o0000>Oooool1o`000000
=?ooool00ol0003oooooooooo`3Jooooo`03o`000?oooooooooo08cooooo0ol00002ooooo`03o`00
0?oooooooooo04?ooooo00?o0000ooooool000000_l0000Sooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool02oooool2o`0003Oooooo0Ol0000003Cooooo00?o0000ooooooooool0f_oo
ool00ol0003oooooooooo`2<ooooo`03o`000?oooooooooo00?o0000A_ooool2o`0000;ooooo0ol0
000Qooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool2o`0003Gooooo0Ol0
000003Cooooo00?o0000ooooooooool0f_ooool00ol0003oooooooooo`2=ooooo`06o`000?oooooo
0000o`000?oooooo0000Aoooool3o`0000;ooooo0ol0000Nooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool03_ooool2o`0003?ooooo0Ol0000003Cooooo00?o0000ooooooooool0f_oo
ool00ol0003oooooooooo`2>ooooo`06o`000?ooooooooooo`000?oooooo0000AOooool01Ol0003o
ooooo`000?oooooo000000Cooooo0ol00002ooooo`?o00005oooool00ol0003oooooooooo`0;oooo
o`?o00004?ooool2o`00037ooooo0Ol0000003Cooooo00?o0000ooooooooool0f_ooool00ol0003o
ooooooooo`2=ooooo`05o`000?oooooo0000ooooool000000_ooool00ol0003oooooooooo`12oooo
o`03o`000?oooooooooo00;o00001oooool3o`0000;ooooo00?o0000ooooooooool05?ooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0;_ooool1o`00
0000=?ooool00ol0003oooooooooo`3Jooooo`03o`000?oooooooooo08kooooo0ol00004ooooo`;o
0000@oooool3o`000003ooooool0003ooooo00Kooooo00?o0000ooooool000000_l0000Gooooo`03
o`000?oooooooooo00_ooooo0ol0000Booooo`;o0000;_ooool1o`000000=?ooool3o`000=[ooooo
00?o0000ooooooooool0Soooool5o`0000?ooooo00?o0000ooooooooool0?oooool01_l0003ooooo
oooooooooooo0000ooooo`;o00001Oooool4o`0001Sooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`02o`0001;ooooo0_l0000Zooooo`?o0000000dooooo`03o`000?oooooooooo0=[o
oooo00?o0000ooooooooool0T?ooool2o`000003ooooool0003ooooo00?ooooo00?o0000oooooooo
ool0?_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool00_ooool01Ol0
003ooooooooooooooooo000001Oooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`02
ooooo`;o00004_ooool2o`0002[ooooo0Ol0000003Cooooo00?o0000ooooooooool0f_ooool00ol0
003oooooooooo`2Aooooo`?o00001Oooool00ol0003oooooooooo`0nooooo`?o00001Oooool2o`00
00?ooooo00Co0000oooooooooooo00006?ooool00ol0003oooooooooo`09ooooo`;o00001_ooool2
o`0001;ooooo0_l0000Xooooo`7o0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000oooo
ooooool0T_ooool00ol0003oooooo`000005ooooo`;o0000B?ooool01?l0003oooooooooooooool3
o`0001Sooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`06ooooo`;o00004_ooool2
o`0002Kooooo0Ol0000003Cooooo00?o0000ooooooooool0f_ooool00ol0003oooooooooo`2?oooo
o`07o`000?ooooooooooooooool0003oooooo`000006ooooo`03o`000?oooooooooo04Kooooo0_l0
0004ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05?ooool2o`0001;ooooo0_l0
000Tooooo`7o0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000ooooooooool0Soooool0
1Ol0003ooooooooooooooooo000000;ooooo0_l00005ooooo`03o`000?oooooooooo04Oooooo0_l0
0002ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool05_ooool2o`0001;ooooo00?o
0000ooooooooool08Oooool1o`000000=?ooool00ol0003oooooooooo`3Jooooo`03o`000?oooooo
oooo093ooooo0ol00005ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0B?ooool0
1?l0003oooooooooool0000Hooooo`03o`000?oooooooooo01Oooooo0_l0000Aooooo`;o00008Ooo
ool1o`000000=?ooool00ol0003oooooooooo`3Jooooo`03o`000?oooooooooo09Wooooo00?o0000
ooooooooool00oooool2o`0004Wooooo0ol0000Hooooo`03o`000?oooooooooo01Wooooo0_l0000A
ooooo`;o000000Coooooo`000?l0003o00003Oooool3o`0000_ooooo0Ol0000003Cooooo00?o0000
ooooooooool0f_ooool00ol0003oooooooooo`2Jooooo`;o00001Oooool00ol0003oooooooooo`18
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool06_ooool2o`00017ooooo0ol0000?
ooooo`03o`000?oooooooooo00[ooooo0Ol0000003Cooooo00?o0000ooooooooool0f_ooool00ol0
003oooooooooo`2Looooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0B?ooool4o`00
01Gooooo00?o0000ooooooooool07?ooool3o`0000gooooo5Ol0000;ooooo`7o0000000dooooo`03
o`000?oooooooooo0=[ooooo00?o0000ooooooooool0WOooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo04Oooooo00Go0000ooooool0003oooooo`00000Dooooo`03o`000?oooooooooo
01oooooo0_l0000;ooooo`04o`000?ooooooooooo`0000cooooo00Co0000oooooooooooo00003?oo
ool1o`000000=?ooool00ol0003oooooooooo`3Jooooo`03o`000?oooooooooo09kooooo0_l00004
ooooo`;o0000Aoooool00ol0003oooooooooo`02o`0001Cooooo0ol0000Qooooo`;o00002_ooool0
0ol0003oooooo`00000=ooooo`03o`000?oooooo000000cooooo0Ol0000003Cooooo00?o0000oooo
ooooool0f_ooool00ol0003oooooooooo`2Pooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0AOooool3o`0001Cooooo00Go0000ooooool0003oooooo`00000Rooooo`;o00002Oooool2
o`0000kooooo0_l0000<ooooo`7o0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000oooo
ooooool0XOooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04?ooooo0_l000000ooo
oooo0000o`00000Fooooo`;o00009?ooool2o`0000Sooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0:ooooo`7o0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000oooooooo
ool0X_ooool2o`0000Cooooo00?o0000ooooooooool0@_ooool01Ol0003oooooo`000?oooooo0000
01Kooooo0_l0000Vooooo`;o00008oooool1o`000000=?ooool3o`000=[ooooo00?o0000oooooooo
ool0Y?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo04;ooooo1?l0000Cooooo`Go
0000:?ooool2o`0001oooooo0ol0000003Cooooo00?o0000ooooooooool0f_ooool00ol0003ooooo
ooooo`2Uooooo`03o`000?oooooooooo00;ooooo0_l00011ooooo`05o`000?oooooo0000ooooool0
00004oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02Oooooo0_l0000Oooooo`7o
0000000dooooo`03o`000?oooooooooo0=[ooooo00?o0000ooooooooool0Y_ooool2o`0000Cooooo
00?o0000ooooooooool0?_ooool00ol0003oooooooooo`03o`0001;ooooo1Ol000000ooooooo0000
ooooo`0Yooooo`Go00002oooool3o`0000cooooo0Ol0000003Cooooo00?o0000ooooooooool0f_oo
ool00ol0003oooooooooo`2Wooooo`Go000000?oooooo`000?ooool0?_ooool4o`000003ooooool0
003ooooo01Sooooo00?o0000ooooooooool0:Oooool2o`0000gooooo00?o0000ooooooooool02ooo
ool1o`000000=?ooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo0:Oooooo0_l00000
1Ooooooo0000oooooooooooo000003kooooo00Ko0000oooooooooooo0000ooooool0000Jooooo`03
o`000?oooooooooo02Wooooo4?l0000<ooooo`7o0000000dooooo`03o`000?oooooooooo0=_ooooo
00?o0000ooooooooool0Z?ooool2o`0000Cooooo0_l0000mooooo`06o`000?ooooooooooo`000?oo
oooo00006_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo00_ooooo00?o0000oooo
ooooool02oooool1o`000000=?ooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo0:Wo
oooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0kooooo`?o000000?oooooo`000?oo
ool06_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo00_ooooo00?o0000oooooooo
ool02oooool1o`000000=?ooool00ol0003oooooooooo`3Kooooo`03o`000?oooooooooo0:Kooooo
00?o0000ooooooooool00_l00006ooooo`03o`000?oooooooooo03cooooo1?l0000Kooooo`03o`00
0?oooooooooo02Gooooo0_l0000<ooooo`;o00003Oooool1o`000000=?ooool00ol0003ooooooooo
o`3Kooooo`03o`000?oooooooooo0:Kooooo00Go0000ooooooooooooooooo`000007ooooo`03o`00
0?oooooooooo03_ooooo00?o0000ooooooooool00_l0000Kooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`7o0000000dooooo`03o`000?oo
oooooooo0=_ooooo00?o0000ooooooooool0Yoooool4o`0000Sooooo0_l0000kooooo`;o000000?o
ooooo`000?l000007?ooool00ol0003oooooooooo`10ooooo`7o0000000dooooo`03o`000?oooooo
oooo0=_ooooo00?o0000ooooooooool0Z_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo03Wooooo0ol0000Nooooo`03o`000?oooooooooo03oooooo0Ol0000003Cooooo00?o0000oooo
ooooool0foooool00ol0003oooooooooo`2Zooooo`03o`000?oooooooooo00Wooooo0ol0000goooo
o`;o00000_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo03kooooo0Ol0000003Co
oooo00?o0000ooooooooool0foooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo00Oo
oooo00Go0000ooooool0003oooooo`00000fooooo`;o00000_ooool2o`0001kooooo00?o0000oooo
ooooool0?Oooool1o`0000006oooool5o`0000?ooooo00?o0000ooooooooool00_ooool3o`0000Wo
oooo00?o0000ooooooooool0foooool00ol0003oooooooooo`2[ooooo`03o`000?oooooooooo00[o
oooo0_l0000gooooo`?o000000?oooooo`000?ooool07_ooool00ol0003oooooooooo`0looooo`7o
0000000Looooo`04o`000?ooooooooooo`0000Oooooo00Go0000ooooooooooooooooo`000008oooo
o`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0Zoooool00ol0003oooooooooo`09oooo
o`;o000000Coooooo`000?l0003o0000=Oooool01Ol0003ooooooooooooooooo000001oooooo00?o
0000ooooooooool0>oooool1o`0000007Oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00Kooooo1Ol0003Iooooo`03o`000?oooooooooo0:_ooooo00?o0000ooooooooool02oooool0
1?l0003oooooooooooooool3o`0003;ooooo00Go0000ooooooooooooooooo`00000Pooooo`03o`00
0?oooooooooo03Oooooo1?l0000001kooooo00?o0000ooooooooool02_ooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0ZOooool5o`0000Oooooo00Go
0000ooooooooooooooooo`000006ooooo`;o0000<?ooool00ol0003oooooooooo`02ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0>Oooool1o`0000006oooool01Ol0003ooooooooo
oooooooo000000Oooooo1?l00009ooooo`03o`000?oooooooooo0=[ooooo0_l0002/ooooo`04o`00
0?oooooo0000o`0000Sooooo0ol00009ooooo`?o0000;Oooool00ol0003oooooooooo`03ooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool0>?ooool1o`0000006oooool01Ol0003ooooo
oooooooooooo000000Oooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3Jooooo`;o
0000[Oooool2o`0001Sooooo0ol0000[ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0gooooo`7o0000000Looooo`?o00002?ooool5o`0000Sooooo
00?o0000ooooooooool0foooool00ol0003oooooooooo`2/ooooo`03o`000?oooooooooo01Wooooo
0_l0000Yooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool07oooool00ol0003ooooo
ooooo`0fooooo`7o0000000dooooo`03o`000?oooooooooo0=_ooooo00?o0000ooooooooool0ZOoo
ool01Ol0003ooooooooooooooooo000001cooooo0ol0000Vooooo`03o`000?oooooooooo00?ooooo
0ol0000Pooooo`03o`000?oooooooooo03Gooooo0Ol0000003Cooooo00?o0000ooooooooool0g?oo
ool00ol0003oooooooooo`2Xooooo`04o`000?ooooooooooooooo`;o00007_ooool3o`0002;ooooo
0ol00003ooooo`05o`000?oooooo0000ooooool000008?ooool00ol0003oooooooooo`0dooooo`7o
0000000dooooo`03o`000?oooooooooo0=Sooooo00Go0000ooooooooooooooooo`00002[ooooo`?o
00000_ooool00ol0003oooooooooo`0Nooooo`;o00007oooool00ol0003oooooooooo`02o`0000;o
oooo00?o0000ooooooooool00_l0000Qooooo`03o`000?oooooooooo03?ooooo0Ol0000003Cooooo
00?o0000ooooooooool0f?ooool5o`000;7ooooo00?o0000ooooooooool07oooool3o`0001cooooo
00?o0000ooooooooool00_l00003ooooo`?o00008oooool00ol0003oooooooooo`0booooo`7o0000
000dooooo`03o`000?oooooooooo0?ooooooT?ooool00ol0003oooooooooo`0Qooooo`?o00006Ooo
ool4o`000004ooooool0003o0000o`0000;ooooo0_l0000Sooooo`03o`000?oooooooooo037ooooo
0Ol0000003Cooooo00?o0000ooooooooool0oooooonAooooo`03o`000?oooooooooo02?ooooo0_l0
000Gooooo`03o`000?oooooooooo00Cooooo0_l00002ooooo`03o`000?oooooooooo02;ooooo0ol0
000`ooooo`7o0000000dooooo`03o`000?oooooooooo0?ooooooTOooool00ol0003oooooooooo`0U
ooooo`?o00005Oooool00ol0003oooooooooo`04ooooo`Co00008oooool01Ol0003oooooo`000?oo
oooo000002oooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonBooooo`03o`000?oooooo
oooo02Oooooo0ol0000Cooooo`;o00001_ooool2o`0002Kooooo0_l0000_ooooo`7o0000000doooo
o`03o`000?oooooooooo0?ooooooToooool00ol0003oooooooooo`0Yooooo`;o00006_ooool3o`00
02Gooooo0ol0000]ooooo`7o0000000dooooo`03o`000?oooooooooo0?ooooooToooool5o`0002Wo
oooo0ol0000Gooooo`03o`000?oooooooooo00;o00007oooool4o`0000?ooooo00?o0000oooooooo
ool0:_ooool1o`000000=?ooool3o`000?ooooooU?ooool2o`000003ooooool0003ooooo02_ooooo
0ol0000Eooooo`04o`000?ooooooooooooooo`;o00007Oooool00ol0003oooooooooo`05ooooo`;o
0000:?ooool3o`000000=?ooool00ol0003oooooooooo`3ooooooiGooooo0ol0000_ooooo`;o0000
4oooool00ol0003oooooooooo`03ooooo`;o00006oooool5o`0000Gooooo0_l0000Xooooo`7o0000
000dooooo`03o`000?oooooooooo0?ooooooU_ooool00ol0003oooooo`00000`ooooo`?o00004?oo
ool00ol0003oooooooooo`05ooooo`;o00009Oooool00ol0003oooooooooo`0Uooooo`7o0000000d
ooooo`03o`000?oooooooooo0?ooooooToooool01_l0003ooooooooooooooooo0000ooooo`;o0000
<Oooool3o`0000gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Sooooo`;o0000
9Oooool1o`000000=?ooool00ol0003oooooooooo`3ooooooi?ooooo00Go0000oooooooooooooooo
o`000003ooooo`;o0000<_ooool2o`0000_ooooo00?o0000ooooooooool02?ooool2o`0002Gooooo
0_l0000Sooooo`7o0000000dooooo`03o`000?oooooooooo0?ooooooU?ooool3o`0000Kooooo00?o
0000ooooooooool0<Oooool3o`000004ooooool0003o0000o`0000Gooooo00?o0000ooooooooool0
2Oooool2o`0002Gooooo0_l0000Qooooo`7o0000000dooooo`03o`000?oooooooooo0?ooooooW_oo
ool2o`0003Cooooo0ol000000ooooooo0000ooooo`03ooooo`03o`000?oooooooooo00_ooooo0_l0
000Uooooo`03o`000?oooooooooo01kooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonP
ooooo`03o`000?oooooooooo03Cooooo0_l00004ooooo`03o`000?oooooooooo00gooooo0_l0000T
ooooo`;o00007_ooool1o`000000=?ooool00ol0003oooooooooo`3ooooooj7ooooo0_l0000coooo
o`;o00001Oooool00ol0003oooooooooo`0?ooooo`;o00009?ooool2o`0001cooooo0Ol0000003Co
oooo00?o0000ooooooooool0oooooonSooooo`03o`000?oooooooooo03;ooooo00Co0000oooooooo
oooooooo0ol0000Booooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool02_ooool3o`00
00cooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonTooooo`;o0000;_ooool01Ol0003o
oooooooooooooooo000000;ooooo00?o0000ooooooooool00_l0000Booooo`Go00008Oooool2o`00
00Wooooo00Go0000ooooooooooooooooo`00000;ooooo`7o0000000dooooo`03o`000?oooooooooo
0?ooooooY_ooool2o`0002gooooo0ol00003ooooo`03o`000?oooooooooo04[o00002oooool1o`00
0000=?ooool00ol0003oooooooooo`3oooooojSooooo00?o0000ooooooooool0<Oooool3o`0001Co
oooo00?o0000ooooooooool00_l0000Tooooo`Co00001?ooool3o`0000cooooo0Ol0000003Cooooo
00?o0000ooooooooool0oooooonYooooo`Go0000;Oooool01Ol0003ooooooooooooooooo000001?o
oooo1?l000000ooooooo0000ooooo`0Rooooo`?o000000Goooooo`000?ooooooooooo`000003oooo
o`03o`000?oooooooooo00Wooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonZooooo`;o
000000?oooooo`000?ooool0;?ooool01Ol0003ooooooooooooooooo000001?ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0Sooooo`;o00000_ooool01Ol0003ooooooooooooooooo
000000_ooooo0Ol0000003Cooooo0ol0003ooooooj_ooooo0ol0000^ooooo`?o00005Oooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo02?ooooo00Co0000oooooooooooooooo0ol0000:
ooooo`?o0000000dooooo`03o`000?oooooooooo0?oooooo[?ooool01?l0003oooooo`000?l00015
ooooo`;o00001?ooool00ol0003oooooooooo`0Nooooo`Co00004oooool1o`000000=?ooool00ol0
003oooooooooo`3oooooojWooooo00Go0000ooooooooooooooooo`000002ooooo`;o0000B_ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01Cooooo0Ol0000003Cooooo00?o0000oooo
ooooool0oooooonYooooo`05o`000?ooooooooooooooool000001?ooool2o`0004Wooooo00?o0000
ooooooooool07?ooool5o`0001;ooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonZoooo
o`?o00001oooool2o`0004Sooooo00?o0000ooooooooool0<_ooool1o`000000=?ooool00ol0003o
ooooooooo`3ooooookKooooo0_l00017ooooo`03o`000?oooooooooo037ooooo0Ol0000003Cooooo
00?o0000ooooooooool0oooooonhooooo`;o0000A_ooool3o`00033ooooo0Ol0000003Cooooo00?o
0000ooooooooool0oooooonjooooo`;o0000@oooool01Ol0003oooooo`000?oooooo000002oooooo
0Ol0000003Cooooo00?o0000ooooooooool0oooooonlooooo`Ko0000?Oooool00ol0003ooooooooo
o`02o`0002oooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonnooooo`;o000000?ooooo
o`000?ooool0??ooool4o`00033ooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonooooo
o`Go0000>oooool00ol0003oooooooooo`0aooooo`7o0000000dooooo`03o`000?oooooooooo0?oo
oooo`?ooool01?l0003oooooooooooooool6o`0003Kooooo00?o0000ooooooooool0<?ooool1o`00
0000=?ooool00ol0003oooooooooo`3ooooookgooooo00Go0000ooooooooooooooooo`000008oooo
o`Ko0000<Oooool2o`00033ooooo0Ol0000003Cooooo00?o0000ooooooooool0oooooonmooooo`05
o`000?ooooooooooooooool000003_ooool6o`0005gooooo0Ol0000003Cooooo00?o0000oooooooo
ool0oooooonnooooo`?o00005Oooool7o`0005Kooooo0Ol0000003Cooooo0ol0003oooooomgooooo
1_l0001>ooooo`?o0000000dooooo`03o`000?oooooooooo0?oooooohoooool6o`0000Gooooo1Ol0
0010ooooo`7o0000000dooooo`03o`000?oooooooooo0?oooooojOooool7o`0000;ooooo00?o0000
ooooooooool0?_ooool1o`000000=?ooool00ol0003oooooooooo`3oooooonoooooo0ol00011oooo
o`7o0000000dooooo`03o`000?oooooooooo0?oooooolOooool00ol0003oooooooooo`0oooooo`7o
0000000dooooo`03o`000?oooooooooo0?ooooook_ooool01Ol0003ooooooooooooooooo0000043o
oooo0Ol0000003Cooooo00?o0000ooooooooool0ooooooo^ooooo`05o`000?ooooooooooooooool0
0000@?ooool1o`000000=?ooool00ol0003oooooooooo`3oooooonoooooo0ol00011ooooo`7o0000
000dooooo`03o`000?oooooooooo0?ooooooooooooldooooo`7o0000000dooooo`03o`000?oooooo
oooo0?ooooooooooooldooooo`7o0000000dooooo`03o`000?oooooooooo0?ooooooooooooldoooo
o`7o0000000dooooo`03o`000?oooooooooo0?ooooooooooooldooooo`7o0000000dooooo`03o`00
0?oooooooooo0?ooooooooooooldooooo`7o0000000dooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool0H_ooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo06?ooooo00?o
0000ooooooooool0H_ooool00ol0003oooooooooo`1Rooooo`03o`000?oooooooooo02[ooooo0Ol0
000003Cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`1Rooooo`03o`000?oooooo
oooo06;ooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`1Rooooo`03o`000?oooooo
oooo06;ooooo00?o0000ooooooooool0:_ooool1o`000000=?ooool3o`0000_ooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool05_ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool03_ooool3o`000000=?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Ko
oooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo013o
oooo0Ol0000003Coooooool0003oo`0003So0000003oooooooooooooK?ooool00?oooooooooooom/
ooooo`00ooooooooooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00oooo
ooooooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00ooooool?ooooo`?o
0000oooooomJooooo`00oooooolBooooo`03o`000?oooooooooo0?ooooooEoooool00?oooooo0_oo
ool5o`0000;ooooo0ol00003ooooo`Co00002Oooool2o`0000Cooooo0_l000001ooooooo0000o`00
0?oooooo0000ooooool000000oooool2o`000003ooooool0003o000000Co00000_ooool4o`0000?o
oooo0_l00002ooooo`Go00000oooool00ol0003oooooooooo`02ooooo`?o00002?ooool3o`000004
ooooool0003o0000ooooo`Co000000?oooooo`000?l000000ol00002ooooo`Co000000Coooooo`00
0?l0003o00001?ooool4o`0000Oooooo0ol00003ooooo`Go00000_ooool3o`0000Cooooo0_l0003?
ooooo`00ooooool3ooooo`06o`000?ooooooooooo`000?oooooo00000oooool00ol0003oooooo`00
0003ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooo00000_ooool02_l0003ooooo
ooooool0003oooooo`000?oooooo0000ooooool00002ooooo`04o`000?ooooooooooo`0000?ooooo
00Go0000ooooooooooooooooo`000002ooooo`05o`000?ooooooooooooooool000000_ooool01Ol0
003ooooooooooooooooo000000Gooooo00Go0000ooooooooooooooooo`00000<ooooo`06o`000?oo
ooooooooo`000?oooooo00000_ooool01Ol0003ooooooooooooooooo000000;ooooo00?o0000oooo
ool000000_ooool01Ol0003ooooooooooooooooo000000Cooooo00Co0000oooooooooooo00002Ooo
ool00ol0003oooooooooo`04ooooo`05o`000?ooooooooooooooool000000oooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo0<cooooo003oooooo`?ooooo00?o0000ooooooooool0
0_ooool01ol0003ooooooooooooooooo0000ooooool000000oooool00ol0003oooooooooo`05oooo
o`03o`000?oooooooooo00Cooooo00[o0000oooooooooooo0000ooooool0003oooooo`000?oooooo
00000_ooool01?l0003oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo0ol00003oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003oooooo`000002oooo
o`Go00002?ooool01?l0003oooooooooool00002ooooo`?o00001?ooool00ol0003oooooooooo`02
ooooo`?o00000oooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000Wooooo00?o
0000ooooooooool01?ooool01Ol0003ooooooooooooooooo000000?ooooo00Co0000oooooooooooo
0000dOooool00?oooooo0oooool00ol0003oooooooooo`02ooooo`07o`000?ooooooooooooooool0
003oooooo`000003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01?ooool02_l0
003oooooooooool0003oooooo`000?oooooo0000ooooool00002ooooo`04o`000?ooooooooooo`00
00?ooooo00Go0000ooooooooooooooooo`000002ooooo`05o`000?ooooooooooooooool000001_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooo000000;ooooo00Go0000oooooooooooooooo
o`000008ooooo`Co000000Goooooo`000?ooooooooooo`000002ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000oooool2o`0000?ooooo00Co0000oooooooooooo00002Ooo
ool3o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`04o`000?ooooooooooo`000=7o
oooo003oooooo`?ooooo00?o0000ooooooooool00oooool3o`0000?ooooo1Ol00006ooooo`03o`00
0?oooooooooo00?ooooo0_l000001?oooooo0000o`000?ooool2o`000004ooooool0003ooooooooo
o`;o000000?oooooo`000?l000000oooool00ol0003oooooooooo`02ooooo`;o00000oooool4o`00
00;ooooo0ol00003ooooo`;o000000?oooooo`000?l000000_ooool3o`0000Wooooo00Co0000oooo
oooooooo00000_ooool2o`0000?ooooo1Ol00002ooooo`;o00000oooool2o`000003ooooool0003o
000000;ooooo0ol00009ooooo`04o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_oo
ool3o`0000;ooooo1?l0003?ooooo`00ooooool3ooooo`03o`000?oooooooooo01Gooooo00Co0000
oooooooooooo00005Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01_ooooo00Co
0000oooooooooooo00007?ooool00ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000?o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3?ooooo`00ooooool2ooooo`?o0000
5oooool3o`0001?ooooo0ol0000:ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
4oooool3o`000003ooooool0003o000001[ooooo0_l00008ooooo`Co00000_ooool3o`0000[ooooo
00?o0000ooooooooool0coooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo003ooooo
ooooooooK?ooool00?oooooooooooom/ooooo`00\
\>"],
  ImageRangeCache->{{{0, 617.75}, {617.75, 0}} -> {-1.30369, -15.2903, \
0.0197379, 0.0332795}}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lung Tumor Data set", "Section"],

Cell[TextData[{
  StyleBox["The third problem demonstrated is the lung cancer survival data \
for patients assigned to one of two chemotherapy treatment given in Table \
6.3.1 of  Lawless, J.F. (1982).  ",
    FontFamily->"Times New Roman"],
  StyleBox["Statistical Models and Methods for Lifetime Data",
    FontFamily->"Times New Roman",
    FontSlant->"Italic"],
  StyleBox[".  John Wiley & Sons, Inc. New York, pgs 367-371.",
    FontFamily->"Times New Roman"]
}], "Text"],

Cell["Demonstrates", "Text"],

Cell["\<\
Numerical and category variables requiring transformations and \
group indicators followed by building new model variables and constructing a \
phDataPt set\
\>", "BulletedList"],

Cell["\<\
Establishing a new basis set and solving for the coefficients\
\>", \
"BulletedList"],

Cell["\<\
Testing submodels of the full model for investigating variable \
relevance\
\>", "BulletedList"],

Cell[CellGroupData[{

Cell["Read in Data, and Select Model", "Subsection"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[BoxData[
    \(\(filePath = "\</File Organizer/OR Tools/Proportional Hazards \
testing/Lawless table 6-3-1.txt\>";\)\)], "Input",
  CellOpen->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({titleLine, pattVars, dataFile, fnAbbr, rowForm, vars} = 
        readDataFile[filePath, abbr \[Rule] "\<lawless\>"];\)\)], "Input",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    \({"Time", "CensorIndicator", "PerfStatus", "Age", "EntryDelay", 
      "TumorType", "TreatmentType"}\)], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("lawless\[EmptyVerySmallSquare]rowForm ="\
\[InvisibleSpace]{"number", "number", "number", "number", "number", "word", 
          "word"}\),
      SequenceForm[ 
      "lawless\[EmptyVerySmallSquare]rowForm =", {"number", "number", 
        "number", "number", "number", "word", "word"}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("lawless\[EmptyVerySmallSquare]patt ="\
\[InvisibleSpace]{e1_?NumberQ, e2_?NumberQ, e3_?NumberQ, e4_?NumberQ, 
          e5_?NumberQ, e6_?StringQ, e7_?StringQ}\),
      SequenceForm[ "lawless\[EmptyVerySmallSquare]patt =", {
        PatternTest[ 
          Pattern[ e1, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e2, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e3, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e4, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e5, 
            Blank[ ]], NumberQ], 
        PatternTest[ 
          Pattern[ e6, 
            Blank[ ]], StringQ], 
        PatternTest[ 
          Pattern[ e7, 
            Blank[ ]], StringQ]}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    InterpretationBox[\("lawless\[EmptyVerySmallSquare]vars ="\
\[InvisibleSpace]{"lawless\[EmptyVerySmallSquare]Time", 
          "lawless\[EmptyVerySmallSquare]CensorIndicator", 
          "lawless\[EmptyVerySmallSquare]PerfStatus", 
          "lawless\[EmptyVerySmallSquare]Age", 
          "lawless\[EmptyVerySmallSquare]EntryDelay", 
          "lawless\[EmptyVerySmallSquare]TumorType", 
          "lawless\[EmptyVerySmallSquare]TreatmentType"}\),
      SequenceForm[ 
      "lawless\[EmptyVerySmallSquare]vars =", {
        "lawless\[EmptyVerySmallSquare]Time", 
        "lawless\[EmptyVerySmallSquare]CensorIndicator", 
        "lawless\[EmptyVerySmallSquare]PerfStatus", 
        "lawless\[EmptyVerySmallSquare]Age", 
        "lawless\[EmptyVerySmallSquare]EntryDelay", 
        "lawless\[EmptyVerySmallSquare]TumorType", 
        "lawless\[EmptyVerySmallSquare]TreatmentType"}],
      Editable->False]], "Print",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell["\<\
PerfStatus is a measure of the general medical condition on a scale \
of 0 to 100\
\>", "BulletedList"],

Cell["Age of the patient", "BulletedList"],

Cell["\<\
Number of months from diagnosis of cancer to entry into the study\
\
\>", "BulletedList"],

Cell["One of two chemotherapy treatments", "BulletedList"],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[Take[dataFile, {1, 10}]]\)], "Input",
  CellTags->{"Data Routines", "close Data Routines"}],

Cell[BoxData[
    TagBox[GridBox[{
          {"411", "1", "70", "64", 
            "5", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"126", "1", "60", "63", 
            "9", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"118", "1", "70", "65", 
            "11", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"82", "1", "40", "69", 
            "10", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"8", "1", "40", "63", 
            "58", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"25", "0", "80", "52", 
            "9", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"11", "1", "70", "48", 
            "11", "\<\"Squamous\"\>", "\<\"Standard\"\>"},
          {"54", "1", "80", "63", "4", "\<\"Small\"\>", "\<\"Standard\"\>"},
          {"153", "1", "60", "63", 
            "14", "\<\"Small\"\>", "\<\"Standard\"\>"},
          {"16", "1", "30", "53", "4", "\<\"Small\"\>", "\<\"Standard\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ BoxForm`e$]]]], "Output",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[BoxData[
    \(\(setVarsToRules[fnAbbr, vars];\)\)], "Input"],

Cell[BoxData[{
    \(\(timeColumnName = "\<Time\>";\)\), "\n", 
    \(\(censorColumnName = "\<CensorIndicator\>";\)\)}], "Input"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell["\<\
Center the variables to ensure the mean is used in the data to find \
the coefficient, especially when large values are found in the data.\
\>", \
"Text",
  CellOpen->False],

Cell["\<\
The covariate names define the model in that main effects and \
interaction effects can be described by the xNames list.  For example {\
\[Alpha]_String,\[Beta]_String,\[Alpha]*\[Beta]_String} where \
\[Alpha],\[Beta] and \[Alpha]*\[Beta] are the column names from the titleLine \
identifying the variables.
Note: Interaction name separator can be any of the following \
{comma,dash,plus,asterisk,or \[EmptyVerySmallSquare]}\
\>", "Text",
  CellOpen->False,
  FontFamily->"Century Schoolbook",
  FontSize->14,
  FontTracking->"Extended"],

Cell[BoxData[
    \(\(covariateNames = {"\<PerfStatus\>", "\<Age\>", "\<EntryDelay\>", \
"\<TumorType\>", "\<TreatmentType\>"};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({phLayout, {\[Beta], \[Beta]nameList}} = 
        setupPHlayout[titleLine, timeColumnName, censorColumnName, 
          covariateNames, 
          CenteredDataList \[Rule] {"\<PerfStatus\>", "\<Age\>", \
"\<EntryDelay\>"}, 
          TransformedDataList \[Rule] {"\<TumorType\>", \
"\<TreatmentType\>"}];\)\), "\n", 
    \(phLayout\), "\n", 
    \(\[Beta]\), "\n", 
    \(\[Beta]nameList\)}], "Input"],

Cell[BoxData[
    \({e1, 
      e2, {}, {e3 - offset3, e4 - offset4, e5 - offset5, fx6[e6], 
        fx7[e7]}}\)], "Output"],

Cell[BoxData[
    \({\[Beta]1, \[Beta]2, \[Beta]3, \[Beta]4, \[Beta]5}\)], "Output"],

Cell[BoxData[
    \({"\[CapitalDelta]PerfStatus", "\[CapitalDelta]Age", 
      "\[CapitalDelta]EntryDelay", "fxTumorType", 
      "fxTreatmentType"}\)], "Output"]
}, Open  ]],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["For any centered variables the corresponding offset \
must be assigned. \nFor any transformed variables the corresponding \
transforming function must be defined.  \nNote that the grouping function can \
also be used to apply transformations on the group name's data.",
  FontSize->14,
  FontColor->RGBColor[1, 0, 0],
  Background->RGBColor[1, 0.879942, 0.832074]]], "Subsection",
  CellOpen->False],

Cell["\<\
Category variables can be separated into groups by expanding the \
basis variables, \[Beta]\
\>", "BulletedList"],

Cell["\<\
Piecewise functions entered with esc pw esc and ctrl comma and ctrl \
rtn can easily be used to put in group conditions.\
\>", "Text",
  CellOpen->False],

Cell[CellGroupData[{

Cell[BoxData[{
    \(tumorList = 
      Union[dataFile /. 
          lawless\[EmptyVerySmallSquare]TumorType]\), "\[IndentingNewLine]", 
    \(treatmentList = 
      Union[dataFile /. 
          lawless\[EmptyVerySmallSquare]TreatmentType]\)}], "Input"],

Cell[BoxData[
    \({"Adeno", "Large", "Small", "Squamous"}\)], "Output"],

Cell[BoxData[
    \({"Standard", "Test"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(baseTumorType = "\<Large\>";\)\), "\[IndentingNewLine]", 
    \(\(\(basisTumorType = 
      Delete[tumorList, 
        Position[tumorList, baseTumorType]]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(\(baseTreatmentType = "\<Standard\>";\)\), "\[IndentingNewLine]", 
    \(\(\(basisTreatmentType = 
      Delete[treatmentList, 
        Position[treatmentList, baseTreatmentType]]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(varNames = 
      Join[{"\<\[CapitalDelta]PerfStatus\>", "\<\[CapitalDelta]Age\>", "\<\
\[CapitalDelta]EntryDelay\>"}, basisTumorType, 
        basisTreatmentType]\)}], "Input"],

Cell[BoxData[
    \({"Adeno", "Small", "Squamous"}\)], "Output"],

Cell[BoxData[
    \({"Test"}\)], "Output"],

Cell[BoxData[
    \({"\[CapitalDelta]PerfStatus", "\[CapitalDelta]Age", 
      "\[CapitalDelta]EntryDelay", "Adeno", "Small", "Squamous", 
      "Test"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(offset3 = 
      Mean[dataFile /. lawless\[EmptyVerySmallSquare]PerfStatus] // 
        N\), "\[IndentingNewLine]", 
    \(offset4 = 
      Mean[dataFile /. lawless\[EmptyVerySmallSquare]Age] // 
        N\), "\[IndentingNewLine]", 
    \(offset5 = 
      Mean[dataFile /. lawless\[EmptyVerySmallSquare]EntryDelay] // 
        N\), "\[IndentingNewLine]", 
    \(\(fx6[y_] := 
        Map[If[# \[Equal] y, 1, 0] &, 
          basisTumorType];\)\), "\[IndentingNewLine]", 
    \(\(fx7[y_] := 
        Map[If[# \[Equal] y, 1, 0] &, basisTreatmentType];\)\)}], "Input"],

Cell[BoxData[
    \(56.75`\)], "Output"],

Cell[BoxData[
    \(56.675`\)], "Output"],

Cell[BoxData[
    \(15.65`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(formatInputData = pattVars \[Rule] phLayout\)], "Input"],

Cell[BoxData[
    \({e1_?NumberQ, e2_?NumberQ, e3_?NumberQ, e4_?NumberQ, e5_?NumberQ, 
        e6_?StringQ, e7_?StringQ} \[Rule] {e1, 
        e2, {}, {\(-56.75`\) + e3, \(-56.675`\) + e4, \(-15.65`\) + 
            e5, {If["Adeno" \[Equal] e6, 1, 0], 
            If["Small" \[Equal] e6, 1, 0], 
            If["Squamous" \[Equal] e6, 1, 0]}, {If["Test" \[Equal] e7, 1, 
              0]}}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(inputData = 
        Map[make\[Ellipsis]phDataPt, 
          dataFile /. formatInputData];\)\)], "Input"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(First[inputData]\), "\[IndentingNewLine]", 
    \(Last[inputData]\), "\[IndentingNewLine]", 
    \(\(With[{nrXis = Length[covariatesf[First[inputData]]], 
          len\[Beta] = Length[\[Beta]]}, 
        Print[covariatesf[First[inputData]], "\<  has length of \>", 
          nrXis]; \[IndentingNewLine]Print[\[Beta], "\<  has length of \>", 
          len\[Beta]]; \[IndentingNewLine]If[
          nrXis \[NotEqual] 
            len\[Beta], \((StylePrint[
              StyleForm["\<\[Beta]'s must be adjusted\>", 
                FontFamily \[Rule] "\<CopperPlate\>", FontSize \[Rule] 24, 
                FontWeight \[Rule] "\<Bold\>"]]; \[IndentingNewLine]\[Beta] = 
              Map[makeVariable["\<\[Beta]x\>" <> ToString[#]] &, 
                Range[nrXis]])\), \[IndentingNewLine]Print["\<\[Beta]'s are \
OK\>"]]; \[IndentingNewLine]If[
          Length[\[Beta]nameList] \[NotEqual] 
            nrXis, \((StylePrint[
              StyleForm["\<\[Beta]nameList must be adjusted\>", 
                FontFamily \[Rule] "\<CopperPlate\>", FontSize \[Rule] 24, 
                FontWeight \[Rule] "\<Bold\>"]]; \
\[IndentingNewLine]\[Beta]nameList = 
              Map["\<x\>" <> ToString[#] &, 
                Range[nrXis]])\), \[IndentingNewLine]Print["\<\[Beta]nameList \
is OK\>"]]];\)\), "\[IndentingNewLine]", 
    \(\(Print["\<\[Beta] = \>", \[Beta]];\)\), "\[IndentingNewLine]", 
    \(\(Print["\<\[Beta]nameList = \>", \[Beta]nameList];\)\), "\
\[IndentingNewLine]", 
    \(TableForm[Take[inputData, {1, 10}]]\), "\[IndentingNewLine]", 
    \(lastTimePt = {Max[Map[timef, inputData]], 0}\), "\[IndentingNewLine]", 
    \(\(maxKMdata = lastTimePt;\)\)}], "Input",
  CellOpen->False],

Cell[BoxData[
    \(phDataPt[411, 
      True, {}, {13.25`, 7.325000000000003`, \(-10.65`\), 0, 0, 1, 
        0}]\)], "Output"],

Cell[BoxData[
    \(phDataPt[231, 
      True, {}, {13.25`, 10.325000000000003`, 2.3499999999999996`, 0, 0, 0, 
        1}]\)], "Output"],

Cell[BoxData[
    InterpretationBox[\({13.25`, 7.325000000000003`, \(-10.65`\), 0, 0, 1, 
          0}\[InvisibleSpace]"  has length of "\[InvisibleSpace]7\),
      SequenceForm[ {13.25, 7.3250000000000028, -10.65, 0, 0, 1, 0}, 
        "  has length of ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\({\[Beta]1, \[Beta]2, \[Beta]3, \[Beta]4, \[Beta]5}\
\[InvisibleSpace]"  has length of "\[InvisibleSpace]5\),
      SequenceForm[ {\[Beta]1, \[Beta]2, \[Beta]3, \[Beta]4, \[Beta]5}, 
        "  has length of ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      StyleBox["\<\"\[Beta]'s must be adjusted\"\>",
        FontFamily->"CopperPlate",
        FontSize->24,
        FontWeight->"Bold"],
      (StyleForm[ #, FontFamily -> "CopperPlate", FontSize -> 24, FontWeight -> 
        "Bold"]&)]], "Output"],

Cell[BoxData[
    TagBox[
      StyleBox["\<\"\[Beta]nameList must be adjusted\"\>",
        FontFamily->"CopperPlate",
        FontSize->24,
        FontWeight->"Bold"],
      (StyleForm[ #, FontFamily -> "CopperPlate", FontSize -> 24, FontWeight -> 
        "Bold"]&)]], "Output"],

Cell[BoxData[
    InterpretationBox[\("\[Beta] = "\[InvisibleSpace]{\[Beta]x1, \[Beta]x2, \
\[Beta]x3, \[Beta]x4, \[Beta]x5, \[Beta]x6, \[Beta]x7}\),
      SequenceForm[ 
      "\[Beta] = ", {\[Beta]x1, \[Beta]x2, \[Beta]x3, \[Beta]x4, \[Beta]x5, \
\[Beta]x6, \[Beta]x7}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Beta]nameList = "\[InvisibleSpace]{"x1", "x2", 
          "x3", "x4", "x5", "x6", "x7"}\),
      SequenceForm[ 
      "\[Beta]nameList = ", {"x1", "x2", "x3", "x4", "x5", "x6", "x7"}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(phDataPt[411, 
              True, {}, {13.25`, 7.325000000000003`, \(-10.65`\), 0, 0, 1, 
                0}]\)},
          {\(phDataPt[126, 
              True, {}, {3.25`, 6.325000000000003`, \(-6.65`\), 0, 0, 1, 
                0}]\)},
          {\(phDataPt[118, 
              True, {}, {13.25`, 8.325000000000003`, \(-4.65`\), 0, 0, 1, 
                0}]\)},
          {\(phDataPt[82, 
              True, {}, {\(-16.75`\), 12.325000000000003`, \(-5.65`\), 0, 0, 
                1, 0}]\)},
          {\(phDataPt[8, 
              True, {}, {\(-16.75`\), 6.325000000000003`, 42.35`, 0, 0, 1, 
                0}]\)},
          {\(phDataPt[25, 
              False, {}, {23.25`, \(-4.674999999999997`\), \(-6.65`\), 0, 0, 
                1, 0}]\)},
          {\(phDataPt[11, 
              True, {}, {13.25`, \(-8.674999999999997`\), \(-4.65`\), 0, 0, 
                1, 0}]\)},
          {\(phDataPt[54, 
              True, {}, {23.25`, 6.325000000000003`, \(-11.65`\), 0, 1, 0, 
                0}]\)},
          {\(phDataPt[153, 
              True, {}, {3.25`, 6.325000000000003`, \(-1.6500000000000004`\), 
                0, 1, 0, 0}]\)},
          {\(phDataPt[16, 
              True, {}, {\(-26.75`\), \(-3.674999999999997`\), \(-11.65`\), 
                0, 1, 0, 0}]\)}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {
        phDataPt[ 
        411, True, {}, {13.25, 7.3250000000000028, -10.65, 0, 0, 1, 0}], 
        phDataPt[ 
        126, True, {}, {3.25, 6.3250000000000028, -6.6500000000000004, 0, 0, 
          1, 0}], 
        phDataPt[ 
        118, True, {}, {13.25, 8.3250000000000028, -4.6500000000000004, 0, 0, 
          1, 0}], 
        phDataPt[ 
        82, True, {}, {-16.75, 12.325000000000003, -5.6500000000000004, 0, 0, 
          1, 0}], 
        phDataPt[ 
        8, True, {}, {-16.75, 6.3250000000000028, 42.350000000000001, 0, 0, 1,
           0}], 
        phDataPt[ 
        25, False, {}, {23.25, -4.6749999999999972, -6.6500000000000004, 0, 0,
           1, 0}], 
        phDataPt[ 
        11, True, {}, {13.25, -8.6749999999999972, -4.6500000000000004, 0, 0, 
          1, 0}], 
        phDataPt[ 
        54, True, {}, {23.25, 6.3250000000000028, -11.65, 0, 1, 0, 0}], 
        phDataPt[ 
        153, True, {}, {3.25, 6.3250000000000028, -1.6500000000000004, 0, 1, 
          0, 0}], 
        phDataPt[ 
        16, True, {}, {-26.75, -3.6749999999999972, -11.65, 0, 1, 0, 
          0}]}]]], "Output"],

Cell[BoxData[
    \({999, 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Beta]nameList = 
      replace\[Beta]nameList[\[Beta]nameList, varNames]\)], "Input"],

Cell[BoxData[
    \({"\[CapitalDelta]PerfStatus", "\[CapitalDelta]Age", 
      "\[CapitalDelta]EntryDelay", "Adeno", "Small", "Squamous", 
      "Test"}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(Clear[addLastPt];\)\), "\[IndentingNewLine]", 
    \(\(addLastPt[spts : {{_?NumberQ, _?NumberQ} .. }, 
          lastPt : \({_?NumberQ, _?NumberQ} : lastTimePt\)] := 
        With[{diff = lastPt - Last[spts]}, 
          If[First[diff] > 0, 
            Append[spts, 
              lastPt - {0, diff\[LeftDoubleBracket]2\[RightDoubleBracket]}], 
            spts]];\)\)}], "Input",
  CellOpen->False]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Semi-Parametric Proportional Hazards Analysis of the Lung Tumor \
dataset\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["Empirival Survival Plot (Kaplan-Meier Plot)", "Subsubsection",
  FontFamily->"Century Schoolbook"],

Cell["", "GraphicNoMagnification",
  CellDingbat->"\[FilledDiamond]",
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(ES = 
        surv\[EmptyVerySmallSquare]data[
          inputData /. time\[Delta]f];\)\), "\n", 
    \(\(empsurv = ES\[LeftDoubleBracket]1\[RightDoubleBracket];\)\), "\n", 
    \(\(p = 
        empsurv\[LeftDoubleBracket]All, 5\[RightDoubleBracket];\)\), "\n", 
    \(\(q = 1 - p;\)\), "\n", 
    \(\(event\[EmptyVerySmallSquare]t = 
        N[empsurv\[LeftDoubleBracket]All, 
            1\[RightDoubleBracket]];\)\), "\n", 
    \(\(kmData = 
        MapThread[{#1, #2} &, {empsurv\[LeftDoubleBracket]All, 
              1\[RightDoubleBracket], 
            empsurv\[LeftDoubleBracket]All, 
              4\[RightDoubleBracket]}];\)\), "\[IndentingNewLine]", 
    \(\(empSplot = 
        ListPlot[
          addLastPt[
            Transpose[{event\[EmptyVerySmallSquare]t, q}]]];\)\)}], "Input",
  CellOpen->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0017022 0.0147151 0.588604 [
[.19403 .00222 -9 -9 ]
[.19403 .00222 9 0 ]
[.36425 .00222 -9 -9 ]
[.36425 .00222 9 0 ]
[.53447 .00222 -9 -9 ]
[.53447 .00222 9 0 ]
[.70469 .00222 -9 -9 ]
[.70469 .00222 9 0 ]
[.87491 .00222 -9 -9 ]
[.87491 .00222 9 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.19403 .01472 m
.19403 .02097 L
s
[(100)] .19403 .00222 0 1 Mshowa
.36425 .01472 m
.36425 .02097 L
s
[(200)] .36425 .00222 0 1 Mshowa
.53447 .01472 m
.53447 .02097 L
s
[(300)] .53447 .00222 0 1 Mshowa
.70469 .01472 m
.70469 .02097 L
s
[(400)] .70469 .00222 0 1 Mshowa
.87491 .01472 m
.87491 .02097 L
s
[(500)] .87491 .00222 0 1 Mshowa
.125 Mabswid
.05785 .01472 m
.05785 .01847 L
s
.0919 .01472 m
.0919 .01847 L
s
.12594 .01472 m
.12594 .01847 L
s
.15999 .01472 m
.15999 .01847 L
s
.22807 .01472 m
.22807 .01847 L
s
.26212 .01472 m
.26212 .01847 L
s
.29616 .01472 m
.29616 .01847 L
s
.33021 .01472 m
.33021 .01847 L
s
.39829 .01472 m
.39829 .01847 L
s
.43234 .01472 m
.43234 .01847 L
s
.46638 .01472 m
.46638 .01847 L
s
.50043 .01472 m
.50043 .01847 L
s
.56851 .01472 m
.56851 .01847 L
s
.60256 .01472 m
.60256 .01847 L
s
.6366 .01472 m
.6366 .01847 L
s
.67065 .01472 m
.67065 .01847 L
s
.73873 .01472 m
.73873 .01847 L
s
.77278 .01472 m
.77278 .01847 L
s
.80682 .01472 m
.80682 .01847 L
s
.84087 .01472 m
.84087 .01847 L
s
.90895 .01472 m
.90895 .01847 L
s
.943 .01472 m
.943 .01847 L
s
.97704 .01472 m
.97704 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.02551 .59596 Mdot
.02721 .58125 Mdot
.03743 .55917 Mdot
.04083 .5371 Mdot
.04253 .52239 Mdot
.04424 .50031 Mdot
.04934 .47824 Mdot
.05104 .46353 Mdot
.05445 .44881 Mdot
.05615 .4341 Mdot
.05785 .41938 Mdot
.05956 .40467 Mdot
.097 .38966 Mdot
.09871 .37435 Mdot
.11062 .35905 Mdot
.11573 .34374 Mdot
.11913 .32844 Mdot
.16339 .31314 Mdot
.16679 .29783 Mdot
.17701 .28253 Mdot
.19403 .26723 Mdot
.22467 .25141 Mdot
.23829 .23509 Mdot
.28425 .21876 Mdot
.30297 .20244 Mdot
.3251 .18612 Mdot
.36425 .16979 Mdot
.36595 .15347 Mdot
.41702 .13714 Mdot
.44936 .11946 Mdot
.51234 .10042 Mdot
.60256 .08137 Mdot
.72341 .06233 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00>oooool3o`0000Cooooo0_l00004ooooo`;o00007oooool5o`0000?ooooo0_l00004oooo
o`;o00007oooool3o`0000Cooooo0_l00004ooooo`;o00008?ooool3o`0000?ooooo0_l00004oooo
o`;o00007oooool3o`0000Cooooo0_l00004ooooo`;o00007Oooool003cooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001oooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001go
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00008?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001cooooo000looooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Pooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Qoooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`0Kooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00027o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo01[ooooo000looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Qooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo01gooooo0_l00003ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00007Oooool01?l0003oooooooooool00003ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00008Oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06_ooool003cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001kooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00008Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool07?ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00007Oooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Looooo`00>oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Nooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001gooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007oooool2o`0000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Mooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Looooo`00??ooool0
0ol0003oooooooooo`03ooooo`;o00001?ooool2o`00023ooooo0ol00004ooooo`;o00001?ooool2
o`0001oooooo0ol00004ooooo`;o00001?ooool2o`00027ooooo00?o0000ooooooooool00_ooool2
o`0000Cooooo0_l0000Nooooo`Go00000oooool2o`0000Cooooo0_l0000Mooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000?
oooooooo00004Ol00001ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Gooooo000Eooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?ooool00ol0003o
ooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0Qooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03
o`000?oooooooooo0;_ooooo0_l0001;ooooo`005Oooool00ol0003oooooooooo`2kooooo`;o0000
Boooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3o
ooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000Eooooo`03o`000?oooooooooo09[ooooo0_l0001/ooooo`005Oooool00ol0003ooooooooo
o`2Jooooo`;o0000K?ooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
00?o0000ooooooooool0POooool2o`0008Gooooo000Eooooo`;o0000P_ooool2o`0008Gooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo073ooooo
0_l0002Fooooo`000_ooool2o`0000Cooooo00Co0000oooooooooooooooo1Ol00004ooooo`03o`00
0?oooooooooo073ooooo0_l0002Fooooo`0000Goooooo`000?ooooooooooo`000008ooooo`04o`00
0?ooooooooooo`0000Cooooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`000?oooooo
ooooo`000009ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0ooooool9ooooo`00
00Goooooo`000?ooooooooooo`00000:ooooo`03o`000?oooooooooo00?ooooo0ol0003oooooo`Wo
oooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004oooo
o`03o`000?oooooooooo06Oooooo0_l0002Oooooo`0000Goooooo`000?ooooooooooo`000007oooo
o`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`1Wooooo`;o0000Woooool0
00;ooooo0_l00009ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03
o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0FOooool2o`000:gooooo
000Eooooo`03o`000?oooooooooo05Wooooo0_l0002]ooooo`005Oooool00ol0003oooooooooo`3o
ooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000Eooooo`03o`000?oooooooooo05Wooooo0_l0002]ooooo`005Oooool00ol0003ooooooooo
o`1Iooooo`;o0000[Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo04kooooo0_l0002hooooo`00
5Oooool00ol0003oooooooooo`1>ooooo`;o0000^?ooool001Gooooo0_l0003oooooo`[ooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`18ooooo`;o0000__ooool001Gooooo00?o0000ooooooooool0
B?ooool2o`000;kooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`13ooooo`;o0000`oooool001Go
oooo0_l00014ooooo`;o0000`oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Ooo
ool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo03Oooooo0_l0003?
ooooo`005Oooool00ol0003oooooooooo`0gooooo`;o0000coooool000;ooooo0_l00004ooooo`03
o`000?oooooooooo00?ooooo0ol00004ooooo`03o`000?oooooooooo0?oooooo2Oooool00005oooo
ool0003oooooooooool000002_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oo
oooo2Oooool00005ooooool0003oooooooooool000001oooool5o`0000Cooooo00?o0000oooooooo
ool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`000007ooooo`04o`000?ooooooooooo`00
00Gooooo0ol0000cooooo`;o0000doooool00005ooooool0003oooooooooool000002?ooool00ol0
003oooooo`000005ooooo`03o`000?oooooooooo03?ooooo0_l0003Cooooo`0000Goooooo`000?oo
ooooooooo`000009ooooo`;o00001Oooool00ol0003oooooooooo`3oooooo`Wooooo0002ooooo`;o
00002oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
00?o0000ooooooooool0:oooool2o`000=_ooooo000Eooooo`03o`000?oooooooooo02_ooooo0_l0
003Kooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
0?oooooo2Oooool001Gooooo0_l0000Wooooo`;o0000h?ooool001Gooooo00?o0000ooooooooool0
9_ooool2o`000>3ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`0Sooooo`;o0000hoooool001Go
oooo00?o0000ooooooooool08oooool2o`000>?ooooo000Eooooo`03o`000?oooooooooo0?oooooo
2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_ooool0
01Gooooo00?o0000ooooooooool08_ooool2o`000>Cooooo000Eooooo`03o`000?oooooooooo02;o
oooo0_l0003Tooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool05_ooool2o`000?3ooooo000Eoooo
o`03o`000?oooooooooo01Kooooo0_l0003`ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wo
oooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003oooooooooo`0Eooooo`;o0000lOoo
ool001Gooooo00?o0000ooooooooool05Oooool2o`000?7ooooo000Eooooo`03o`000?oooooooooo
0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`000_ooool2o`0000Cooooo
00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool05?ooool2o`000?;ooooo
00001Ooooooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03
o`000?oooooooooo01Cooooo0_l0003booooo`0000Goooooo`000?ooooooooooo`000007ooooo`05
o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo
0000oooooooooooo000000Oooooo1?l00005ooooo`?o0000ooooool9ooooo`0000Goooooo`000?oo
ooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool04Oooool2o`00
0?Gooooo00001Ooooooo0000oooooooooooo000000Sooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`0Aooooo`;o0000mOooool000;ooooo0_l0000:ooooo`;o00001Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o
0000ooooooooool04?ooool2o`000?Kooooo000Eooooo`03o`000?oooooooooo013ooooo0_l0003f
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`00
5Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo00Kooooo0_l0
003oooooo`7ooooo000Eooooo`03o`000?oooooooooo00Kooooo0_l0003oooooo`7ooooo000Eoooo
o`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`00
5Oooool00ol0003oooooooooo`06ooooo`;o0000ooooool1ooooo`005Oooool00ol0003ooooooooo
o`06ooooo`;o0000ooooool1ooooo`005Oooool2o`000?oooooo2_ooool001Gooooo00?o0000oooo
ooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`05ooooo`;o0000ooooool2ooooo`00
5Oooool00ol0003oooooooooo`05ooooo`;o0000ooooool2ooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool01Oooool2o`000?oooooo0_ooool001Gooooo00?o0000ooooooooool01Oooool2o`000?oo
oooo0_ooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool01?ooool2o`000?oooooo0oooool001Gooooo00?o0000oooo
ooooool01?ooool2o`000?oooooo0oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`00
0_ooool2o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000ooooooooool0
ooooool9ooooo`0000Goooooo`000?ooooooooooo`000007ooooo`05o`000?ooooooooooooooool0
00001?ooool00ol0003oooooooooo`03ooooo`;o0000ooooool4ooooo`0000Goooooo`000?oooooo
ooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`03oooo
o`;o0000ooooool4ooooo`0000Goooooo`000?ooooooooooo`000008ooooo`?o00001Oooool3o`00
0?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo
000000Cooooo00?o0000ooooooooool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`000007
ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3oooooo`Wooooo0002
ooooo`;o00002Oooool3o`0000Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0
003oooooooooo`02ooooo`;o0000ooooool5ooooo`005Oooool00ol0003oooooooooo`02ooooo`;o
0000ooooool5ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooooooo
0?oooooo2Oooool001Gooooo00?o0000ooooooooool00_ooool2o`000?oooooo1Oooool001Gooooo
00?o0000ooooooooool00_ooool2o`000?oooooo1Oooool001Gooooo00?o0000ooooooooool0oooo
ool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`04o`000?oooooooooo
ooooo`;o0000ooooool6ooooo`005Oooool01?l0003oooooooooooooool2o`000?oooooo1_ooool0
01Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo00;o0000ooooool7ooooo`005Oooool00ol0003oooooooooo`02o`00
0?oooooo1oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003ooooo
ooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003oooooooooo`3o
ooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool2o`000?oooooo2_ooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`003Oooool3o`0000Gooooo00?o0000ooooooooool0oooo
ool9ooooo`003_ooool00ol0003oooooooooo`04ooooo`;o0000ooooool:ooooo`003_ooool00ol0
003oooooooooo`04ooooo`;o0000ooooool:ooooo`003_ooool00ol0003oooooooooo`03ooooo`Co
0000ooooool9ooooo`003_ooool00ol0003oooooooooo`03ooooo`;o0000ooooool;ooooo`003Ooo
ool2o`0000Kooooo00?o0000ooooooooool0ooooool9ooooo`003_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9oooo
o`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-46.4302, -0.07747, 2.16067, \
0.00624851}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solution of partial likelihood equation", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({{valuelogL\[Beta]0, maxLogL\[Beta], \[Beta]hat}, {varCov\[Beta], 
            stdErr\[Beta]}, {s0, logH0}} = 
        boxedPH[inputData, \[Beta]];\)\)], "Input"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-87.73678427404455`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -87.736784274044552, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.059586896310596396`\), \(-0.011938178967023315`\), 
          0.0006603283493803548`, 
          1.0477098980006065`, \(-0.026216930205873578`\), \
\(-0.3220582015916352`\), \(-0.4073017885555561`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059586896310596396, -0.011938178967023315, 
        0.00066032834938035479, 
        1.0477098980006065, -0.026216930205873578, -0.32205820159163517, \
-0.4073017885555561}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{\(-1.2434497875801753`*^-13\), \
\(-3.774758283725532`*^-15\), 
          1.567634910770721`*^-13, \(-1.3877787807814457`*^-14\), 
          1.049160758270773`*^-14, 
          2.3592239273284576`*^-15, \(-5.2735593669694936`*^-15\)}\),
      SequenceForm[ 
      "Gradient vector ", {-1.2434497875801753*^-13, -3.7747582837255322*^-15,
         1.567634910770721*^-13, -1.3877787807814457*^-14, 
        1.0491607582707729*^-14, 
        2.3592239273284576*^-15, -5.2735593669694936*^-15}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00019031952107252502`, 0.00001961512516380052`, 
            0.00003340268905497539`, 0.0004582572140010782`, 
            0.0009956301633156127`, 
            0.00046573392787641955`, \(-0.00017630052780453982`\)}, \
{0.000019615125163800522`, 
            0.00043027753924314364`, \(-0.00004335904207300532`\), \
\(-0.0029971296569828937`\), \(-0.000781825496371049`\), \
\(-0.001697386392249066`\), 
            0.00303529486962365`}, {0.000033402689054975394`, \
\(-0.00004335904207300533`\), 0.00013930786922561678`, 
            0.000588718983508426`, \(-0.001810391820661074`\), 
            0.0008200362345802014`, \(-0.001700653588625703`\)}, \
{0.0004582572140010779`, \(-0.0029971296569828937`\), 0.0005887189835084259`, 
            0.39453855978524366`, 0.12290848334653602`, 
            0.11867188979616963`, \(-0.0653555247947807`\)}, \
{0.0009956301633156123`, \(-0.000781825496371049`\), \
\(-0.0018103918206610744`\), 0.12290848334653602`, 0.25574440937393683`, 
            0.09751044634839501`, 
            0.018711318312275314`}, {0.00046573392787641944`, \
\(-0.0016973863922490665`\), 0.0008200362345802013`, 0.11867188979616962`, 
            0.09751044634839502`, 
            0.23593698989221512`, \(-0.0396902020032419`\)}, \
{\(-0.00017630052780453988`\), 
            0.00303529486962365`, \(-0.0017006535886257032`\), \
\(-0.0653555247947807`\), 0.018711318312275314`, \(-0.0396902020032419`\), 
            0.16615255916843913`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00019031952107252502, 1.9615125163800518*^-05, 
        3.3402689054975387*^-05, 0.0004582572140010782, 
        0.00099563016331561272, 
        0.00046573392787641955, -0.00017630052780453982}, {
        1.9615125163800522*^-05, 
        0.00043027753924314364, -4.335904207300532*^-05, \
-0.0029971296569828937, -0.00078182549637104896, -0.0016973863922490661, 
        0.00303529486962365}, {
        3.3402689054975394*^-05, -4.3359042073005327*^-05, 
        0.00013930786922561678, 0.00058871898350842597, -0.001810391820661074,
         0.00082003623458020141, -0.001700653588625703}, {
        0.00045825721400107793, -0.0029971296569828937, 
        0.00058871898350842586, 0.39453855978524366, 0.12290848334653602, 
        0.11867188979616963, -0.065355524794780698}, {
        0.00099563016331561229, -0.00078182549637104896, \
-0.0018103918206610744, 0.12290848334653602, 0.25574440937393683, 
        0.097510446348395008, 0.018711318312275314}, {
        0.00046573392787641944, -0.0016973863922490665, 0.0008200362345802013,
         0.11867188979616962, 0.097510446348395022, 
        0.23593698989221512, -0.039690202003241901}, {-0.00017630052780453988,
         0.00303529486962365, -0.0017006535886257032, -0.065355524794780698, 
        0.018711318312275314, -0.039690202003241901, 0.16615255916843913}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013795634130859118`, 0.020743132339238055`, 
          0.011802875464293299`, 0.6281230450996395`, 0.5057117848873376`, 
          0.4857334556031889`, 0.4076181536296429`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013795634130859118, 
        0.020743132339238055, 0.011802875464293299, 0.62812304509963945, 
        0.50571178488733759, 0.48573345560318892, 0.40761815362964288}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9869457847224118`, 
          0.9864170312255897`, 0.965716460897011`, 0.9779195844441776`, 
          0.9772433910878194`, 0.9512639385810924`, 0.9729980533439117`, 
          0.9706310665914578`, 0.9659435328573517`, 0.9602415423961592`, 
          0.9535244944794949`, 0.9460940384342972`, 0.9403199025146135`, 
          0.9386078196333919`, 0.9307034865771531`, 0.9216026041440929`, 
          0.9200009971764534`, 0.9129767572294522`, 0.9042660919601805`, 
          0.8930484455632454`, 0.8749496553728644`, 0.856373934193189`, 
          0.8470074664004742`, 0.8301123910863718`, 0.8145253440828054`, 
          0.7806317091710359`, 0.7353517957388406`, 0.7196870368708181`, 
          0.7032316761942597`, 0.5559333753725098`, 0.3950701527564212`, 
          0.22819090202719183`, 0.10142630292011395`, 0.0017910916610552417`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98694578472241179, 0.98641703122558966, 
        0.96571646089701102, 0.97791958444417759, 0.97724339108781944, 
        0.95126393858109237, 0.97299805334391165, 0.97063106659145781, 
        0.96594353285735168, 0.96024154239615922, 0.95352449447949494, 
        0.94609403843429718, 0.9403199025146135, 0.9386078196333919, 
        0.93070348657715307, 0.9216026041440929, 0.92000099717645345, 
        0.91297675722945215, 0.90426609196018048, 0.89304844556324536, 
        0.8749496553728644, 0.85637393419318897, 0.8470074664004742, 
        0.8301123910863718, 0.81452534408280541, 0.78063170917103586, 
        0.73535179573884057, 0.71968703687081814, 0.70323167619425975, 
        0.55593337537250975, 0.39507015275642121, 0.22819090202719183, 
        0.10142630292011395, 0.0017910916610552417, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[s0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0017022 0.0147151 0.588604 [
[.19403 .00222 -9 -9 ]
[.19403 .00222 9 0 ]
[.36425 .00222 -9 -9 ]
[.36425 .00222 9 0 ]
[.53447 .00222 -9 -9 ]
[.53447 .00222 9 0 ]
[.70469 .00222 -9 -9 ]
[.70469 .00222 9 0 ]
[.87491 .00222 -9 -9 ]
[.87491 .00222 9 0 ]
[.01131 .13244 -18 -4.5 ]
[.01131 .13244 0 4.5 ]
[.01131 .25016 -18 -4.5 ]
[.01131 .25016 0 4.5 ]
[.01131 .36788 -18 -4.5 ]
[.01131 .36788 0 4.5 ]
[.01131 .4856 -18 -4.5 ]
[.01131 .4856 0 4.5 ]
[.01131 .60332 -6 -4.5 ]
[.01131 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.19403 .01472 m
.19403 .02097 L
s
[(100)] .19403 .00222 0 1 Mshowa
.36425 .01472 m
.36425 .02097 L
s
[(200)] .36425 .00222 0 1 Mshowa
.53447 .01472 m
.53447 .02097 L
s
[(300)] .53447 .00222 0 1 Mshowa
.70469 .01472 m
.70469 .02097 L
s
[(400)] .70469 .00222 0 1 Mshowa
.87491 .01472 m
.87491 .02097 L
s
[(500)] .87491 .00222 0 1 Mshowa
.125 Mabswid
.05785 .01472 m
.05785 .01847 L
s
.0919 .01472 m
.0919 .01847 L
s
.12594 .01472 m
.12594 .01847 L
s
.15999 .01472 m
.15999 .01847 L
s
.22807 .01472 m
.22807 .01847 L
s
.26212 .01472 m
.26212 .01847 L
s
.29616 .01472 m
.29616 .01847 L
s
.33021 .01472 m
.33021 .01847 L
s
.39829 .01472 m
.39829 .01847 L
s
.43234 .01472 m
.43234 .01847 L
s
.46638 .01472 m
.46638 .01847 L
s
.50043 .01472 m
.50043 .01847 L
s
.56851 .01472 m
.56851 .01847 L
s
.60256 .01472 m
.60256 .01847 L
s
.6366 .01472 m
.6366 .01847 L
s
.67065 .01472 m
.67065 .01847 L
s
.73873 .01472 m
.73873 .01847 L
s
.77278 .01472 m
.77278 .01847 L
s
.80682 .01472 m
.80682 .01847 L
s
.84087 .01472 m
.84087 .01847 L
s
.90895 .01472 m
.90895 .01847 L
s
.943 .01472 m
.943 .01847 L
s
.97704 .01472 m
.97704 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .13244 m
.03006 .13244 L
s
[(0.2)] .01131 .13244 1 0 Mshowa
.02381 .25016 m
.03006 .25016 L
s
[(0.4)] .01131 .25016 1 0 Mshowa
.02381 .36788 m
.03006 .36788 L
s
[(0.6)] .01131 .36788 1 0 Mshowa
.02381 .4856 m
.03006 .4856 L
s
[(0.8)] .01131 .4856 1 0 Mshowa
.02381 .60332 m
.03006 .60332 L
s
[(1)] .01131 .60332 1 0 Mshowa
.125 Mabswid
.02381 .04415 m
.02756 .04415 L
s
.02381 .07358 m
.02756 .07358 L
s
.02381 .10301 m
.02756 .10301 L
s
.02381 .16187 m
.02756 .16187 L
s
.02381 .1913 m
.02756 .1913 L
s
.02381 .22073 m
.02756 .22073 L
s
.02381 .27959 m
.02756 .27959 L
s
.02381 .30902 m
.02756 .30902 L
s
.02381 .33845 m
.02756 .33845 L
s
.02381 .39731 m
.02756 .39731 L
s
.02381 .42674 m
.02756 .42674 L
s
.02381 .45617 m
.02756 .45617 L
s
.02381 .51503 m
.02756 .51503 L
s
.02381 .54446 m
.02756 .54446 L
s
.02381 .57389 m
.02756 .57389 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .60332 Mdot
.02551 .59564 Mdot
.02721 .58774 Mdot
.03743 .5681 Mdot
.04083 .55588 Mdot
.04253 .54357 Mdot
.04424 .51779 Mdot
.04934 .50421 Mdot
.05104 .48983 Mdot
.05445 .47365 Mdot
.05615 .4554 Mdot
.05785 .43492 Mdot
.05956 .41227 Mdot
.097 .38854 Mdot
.09871 .36559 Mdot
.11062 .34128 Mdot
.11573 .31568 Mdot
.11913 .2916 Mdot
.16339 .26751 Mdot
.16679 .24331 Mdot
.17701 .21886 Mdot
.19403 .19333 Mdot
.22467 .16768 Mdot
.23829 .14427 Mdot
.28425 .12226 Mdot
.30297 .10232 Mdot
.3251 .0831 Mdot
.36425 .065 Mdot
.36595 .05091 Mdot
.41702 .04017 Mdot
.44936 .02886 Mdot
.51234 .0203 Mdot
.60256 .01599 Mdot
.72341 .01484 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00>oooool3o`0000Cooooo0_l00004ooooo`;o00007oooool5o`0000?ooooo0_l00004oooo
o`;o00007oooool3o`0000Cooooo0_l00004ooooo`;o00008?ooool3o`0000?ooooo0_l00004oooo
o`;o00007oooool3o`0000Cooooo0_l00004ooooo`;o00007Oooool003cooooo00?o0000oooooooo
ool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001oooooo00Co0000
oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001go
oooo00Go0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000
oooooooooooo00008?ooool01Ol0003ooooooooooooooooo000000;ooooo00Co0000oooooooooooo
00000_ooool00ol0003oooooooooo`0Kooooo`05o`000?ooooooooooooooool000000_ooool01?l0
003oooooooooool00002ooooo`04o`000?ooooooooooo`0001cooooo000looooo`03o`000?oooooo
oooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Pooooo`03o`00
0?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Qoooo
o`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_ooool00ol0003ooooooooo
o`0Kooooo`Go00000_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`00027o
oooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
oooo01[ooooo000looooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Qooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`03o`000?oooooooooo01gooooo0_l00003ooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00007Oooool01?l0003oooooooooool00003ooooo`04o`000?oo
ooooooooo`0000;ooooo00Co0000oooooooooooo00008Oooool01?l0003oooooooooool00002oooo
o`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06_ooool003cooooo00?o0000oooo
ooooool00_ooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001kooooo00Go
0000ooooooooooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooo
oooo00008Oooool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o
0000ooooooooool07?ooool00ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo
00Co0000oooooooooooo00007Oooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0
003oooooooooool0000Looooo`00>oooool2o`0000Cooooo00Co0000oooooooooooo00000_ooool0
1?l0003oooooooooool0000Nooooo`05o`000?ooooooooooooooool000000_ooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0001gooooo00Go0000ooooooooooooooooo`000002
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007oooool2o`0000?ooooo
00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Mooooo`03o`000?oooooooooo
00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Looooo`00??ooool0
0ol0003oooooooooo`03ooooo`;o00001?ooool2o`00023ooooo0ol00004ooooo`;o00001?ooool2
o`0001oooooo0ol00004ooooo`;o00001?ooool2o`00027ooooo00?o0000ooooooooool00_ooool2
o`0000Cooooo0_l0000Nooooo`Go00000oooool2o`0000Cooooo0_l0000Mooooo`005Oooool00ol0
003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000?
oooooooo00004Ol00001ooooo`005Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00Co0000ooooool0003o00001Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Kooooo0_l00008ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`02ooooo`;o00000_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Gooooo000Eooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;?ooool00ol0
003oooooooooo`0Tooooo`;o00001Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool08Oooool001Gooooo00?o0000ooooooooool0L?ooool2o`0009Ko
oooo000Eooooo`03o`000?oooooooooo073ooooo0_l0002Fooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo06Oooooo0_l0002Oooooo`005Oooool00ol0
003oooooooooo`1Wooooo`;o0000Woooool001Gooooo0_l0003oooooo`[ooooo000Eooooo`03o`00
0?oooooooooo05Wooooo0_l0002]ooooo`005Oooool00ol0003oooooooooo`1Iooooo`;o0000[Ooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo05Wooooo0_l0002]ooooo`005Oooool00ol0003ooooo
ooooo`1Iooooo`;o0000[Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2
o`000?oooooo2_ooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003o
ooooooooo`1>ooooo`;o0000^?ooool001Gooooo00?o0000ooooooooool0C_ooool2o`000;Sooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo04So
oooo0_l0002nooooo`005Oooool2o`0004Wooooo0_l0002nooooo`005Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo0002ooooo`;o0000
1?ooool01?l0003oooooooooooooool5o`0000Cooooo00?o0000ooooooooool0@oooool2o`000<?o
oooo00001Ooooooo0000oooooooooooo000000Sooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`13ooooo`;o0000`oooool00005ooooool0003oooooooooool000002Oooool00ol0
003oooooooooo`04ooooo`03o`000?oooooooooo0?oooooo2Oooool00005ooooool0003ooooooooo
ool000002_ooool00ol0003oooooooooo`03ooooo`?o0000ooooool9ooooo`0000Goooooo`000?oo
ooooooooo`000007ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`3o
ooooo`Wooooo00001Ooooooo0000oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`00
0004ooooo`03o`000?oooooooooo0?oooooo2Oooool000;ooooo0_l00009ooooo`?o00001Oooool0
0ol0003oooooooooo`0gooooo`;o0000coooool001Gooooo00?o0000ooooooooool0=oooool2o`00
0<oooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0
ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:
ooooo`005Oooool00ol0003oooooooooo`0cooooo`;o0000doooool001Gooooo00?o0000oooooooo
ool0<oooool2o`000=?ooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o
0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eoooo
o`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`00
5Oooool2o`0002cooooo0_l0003Kooooo`005Oooool00ol0003oooooooooo`0[ooooo`;o0000fooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0
ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooo
oooo02Kooooo0_l0003Pooooo`005Oooool2o`0002Oooooo0_l0003Pooooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o
0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo0002oooo
o`;o00001?ooool00ol0003oooooooooo`03ooooo`?o00001?ooool00ol0003oooooooooo`3ooooo
o`Wooooo00001Ooooooo0000oooooooooooo000000[ooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`0Sooooo`;o0000hoooool00005ooooool0003oooooooooool000001oooool5o`00
00Cooooo00?o0000ooooooooool08oooool2o`000>?ooooo00001Ooooooo0000oooooooooooo0000
00Oooooo00Co0000oooooooooooo00001Oooool3o`000?oooooo2Oooool00005ooooool0003ooooo
ooooool000002?ooool00ol0003oooooo`000005ooooo`03o`000?oooooooooo0?oooooo2Oooool0
0005ooooool0003oooooooooool000002Oooool2o`0000Gooooo00?o0000ooooooooool0ooooool9
ooooo`000_ooool2o`0000_ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooo
o`Wooooo000Eooooo`03o`000?oooooooooo02;ooooo0_l0003Tooooo`005Oooool00ol0003ooooo
ooooo`0Rooooo`;o0000i?ooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool00ol0003o
ooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o
0000ooooooooool05_ooool2o`000?3ooooo000Eooooo`03o`000?oooooooooo01Kooooo0_l0003`
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oo
oooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_oo
ool001Gooooo00?o0000ooooooooool05Oooool2o`000?7ooooo000Eooooo`03o`000?oooooooooo
01Gooooo0_l0003aooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Go
oooo0_l0000Eooooo`;o0000l_ooool001Gooooo00?o0000ooooooooool05?ooool2o`000?;ooooo
000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9
ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo0002ooooo`;o00001?ooool00ol0003o
ooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooooooo0000
oooooooooooo000000Oooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
0?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo
000000Cooooo00?o0000ooooooooool04Oooool2o`000?Gooooo00001Ooooooo0000oooooooooooo
000000Oooooo1?l00005ooooo`?o00004Oooool2o`000?Gooooo00001Ooooooo0000oooooooooooo
000000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`3oooooo`Wooooo00001Ooo
oooo0000oooooooooooo000000Sooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
ooooo`Wooooo0002ooooo`;o00002_ooool2o`0000Gooooo00?o0000ooooooooool0ooooool9oooo
o`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo013ooooo
0_l0003fooooo`005Oooool00ol0003oooooooooo`0@ooooo`;o0000m_ooool001Gooooo00?o0000
ooooooooool0ooooool9ooooo`005Oooool2o`000?oooooo2_ooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oo
oooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool01_ooool2o`000?oooooo0Oooool0
01Gooooo00?o0000ooooooooool01_ooool2o`000?oooooo0Oooool001Gooooo00?o0000oooooooo
ool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000oooo
ool:ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
00Kooooo0_l0003oooooo`7ooooo000Eooooo`03o`000?oooooooooo00Kooooo0_l0003oooooo`7o
oooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0oooo
ool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo
00Gooooo0_l0003oooooo`;ooooo000Eooooo`;o00001_ooool2o`000?oooooo0_ooool001Gooooo
00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`3oooooo`Wooooo000E
ooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool01Oooool2o`00
0?oooooo0_ooool000;ooooo0_l00004ooooo`03o`000?oooooooooo00;ooooo0ol00005ooooo`03
o`000?oooooooooo00Gooooo0_l0003oooooo`;ooooo00001Ooooooo0000oooooooooooo000000Oo
oooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo0?oooooo2Oooool00005
ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool0ooooool9ooooo`0000Goooooo`000?ooooooooooo`000008ooooo`?o00001Oooool3
o`000?oooooo2Oooool00005ooooool0003oooooooooool000001oooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool01?ooool2o`000?oooooo0oooool00005ooooool0003o
ooooooooool000001oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
1?ooool2o`000?oooooo0oooool000;ooooo0_l00009ooooo`?o00001Oooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool00oooool2o`000?oooooo1?ooool001Gooooo00?o0000ooooooooool00oooool2o`000?oo
oooo1?ooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool2o`0000?ooooo0_l0
003oooooo`Gooooo000Eooooo`03o`000?oooooooooo00;ooooo0_l0003oooooo`Gooooo000Eoooo
o`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`00
5Oooool00ol0003oooooooooo`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Ooo
ool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool00ol0003oooooooooo`02oooo
o`;o0000ooooool5ooooo`005Oooool2o`0000?ooooo0_l0003oooooo`Gooooo000Eooooo`03o`00
0?oooooooooo0?oooooo2Oooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
1?l0003oooooooooooooool2o`000?oooooo1_ooool001Gooooo00Co0000oooooooooooooooo0_l0
003oooooo`Kooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool001Gooooo00?o0000oooo
ooooool00_l0003oooooo`Oooooo000Eooooo`03o`000?oooooooooo00;o0000ooooool7ooooo`00
5Oooool2o`000?oooooo2_ooool001Gooooo00?o0000ooooooooool0ooooool9ooooo`005Oooool0
0ol0003oooooooooo`3oooooo`Wooooo000Eooooo`;o0000ooooool:ooooo`005Oooool2o`000?oo
oooo2_ooool000gooooo0ol00005ooooo`;o0000ooooool:ooooo`003_ooool00ol0003ooooooooo
o`04ooooo`;o0000ooooool:ooooo`003_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo0?oooooo2Oooool000kooooo00?o0000ooooooooool00oooool4o`000?oooooo2Oooool000ko
oooo00?o0000ooooooooool00oooool2o`000?oooooo2oooool000gooooo0_l00006ooooo`03o`00
0?oooooooooo0?oooooo2Oooool000kooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`3oooooo`Wooooo000Eooooo`03o`000?oooooooooo0?oooooo2Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-46.4302, -0.07747, 2.16067, \
0.00624851}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[logH0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.001716 0.346549 0.0765992 [
[.19541 .33405 -9 -9 ]
[.19541 .33405 9 0 ]
[.36701 .33405 -9 -9 ]
[.36701 .33405 9 0 ]
[.53861 .33405 -9 -9 ]
[.53861 .33405 9 0 ]
[.71021 .33405 -9 -9 ]
[.71021 .33405 9 0 ]
[.88181 .33405 -9 -9 ]
[.88181 .33405 9 0 ]
[.01131 .04015 -12 -4.5 ]
[.01131 .04015 0 4.5 ]
[.01131 .19335 -12 -4.5 ]
[.01131 .19335 0 4.5 ]
[.01131 .49975 -6 -4.5 ]
[.01131 .49975 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.19541 .34655 m
.19541 .3528 L
s
[(100)] .19541 .33405 0 1 Mshowa
.36701 .34655 m
.36701 .3528 L
s
[(200)] .36701 .33405 0 1 Mshowa
.53861 .34655 m
.53861 .3528 L
s
[(300)] .53861 .33405 0 1 Mshowa
.71021 .34655 m
.71021 .3528 L
s
[(400)] .71021 .33405 0 1 Mshowa
.88181 .34655 m
.88181 .3528 L
s
[(500)] .88181 .33405 0 1 Mshowa
.125 Mabswid
.05813 .34655 m
.05813 .3503 L
s
.09245 .34655 m
.09245 .3503 L
s
.12677 .34655 m
.12677 .3503 L
s
.16109 .34655 m
.16109 .3503 L
s
.22973 .34655 m
.22973 .3503 L
s
.26405 .34655 m
.26405 .3503 L
s
.29837 .34655 m
.29837 .3503 L
s
.33269 .34655 m
.33269 .3503 L
s
.40133 .34655 m
.40133 .3503 L
s
.43565 .34655 m
.43565 .3503 L
s
.46997 .34655 m
.46997 .3503 L
s
.50429 .34655 m
.50429 .3503 L
s
.57293 .34655 m
.57293 .3503 L
s
.60725 .34655 m
.60725 .3503 L
s
.64157 .34655 m
.64157 .3503 L
s
.67589 .34655 m
.67589 .3503 L
s
.74453 .34655 m
.74453 .3503 L
s
.77885 .34655 m
.77885 .3503 L
s
.81317 .34655 m
.81317 .3503 L
s
.84749 .34655 m
.84749 .3503 L
s
.91613 .34655 m
.91613 .3503 L
s
.95045 .34655 m
.95045 .3503 L
s
.98477 .34655 m
.98477 .3503 L
s
.25 Mabswid
0 .34655 m
1 .34655 L
s
.02381 .04015 m
.03006 .04015 L
s
[(-4)] .01131 .04015 1 0 Mshowa
.02381 .19335 m
.03006 .19335 L
s
[(-2)] .01131 .19335 1 0 Mshowa
.02381 .49975 m
.03006 .49975 L
s
[(2)] .01131 .49975 1 0 Mshowa
.125 Mabswid
.02381 .07845 m
.02756 .07845 L
s
.02381 .11675 m
.02756 .11675 L
s
.02381 .15505 m
.02756 .15505 L
s
.02381 .23165 m
.02756 .23165 L
s
.02381 .26995 m
.02756 .26995 L
s
.02381 .30825 m
.02756 .30825 L
s
.02381 .38485 m
.02756 .38485 L
s
.02381 .42315 m
.02756 .42315 L
s
.02381 .46145 m
.02756 .46145 L
s
.02381 .00185 m
.02756 .00185 L
s
.02381 .53805 m
.02756 .53805 L
s
.02381 .57635 m
.02756 .57635 L
s
.02381 .61465 m
.02756 .61465 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02553 .01472 Mdot
.02724 .06936 Mdot
.03754 .13319 Mdot
.04097 .15684 Mdot
.04269 .17539 Mdot
.0444 .20473 Mdot
.04955 .21704 Mdot
.05127 .22852 Mdot
.0547 .24001 Mdot
.05641 .25157 Mdot
.05813 .26324 Mdot
.05985 .2749 Mdot
.0976 .28605 Mdot
.09931 .29606 Mdot
.11133 .30602 Mdot
.11647 .31596 Mdot
.11991 .32494 Mdot
.16452 .33367 Mdot
.16795 .34228 Mdot
.17825 .35094 Mdot
.19541 .36004 Mdot
.2263 .3694 Mdot
.24003 .3783 Mdot
.28636 .38719 Mdot
.30523 .39591 Mdot
.32754 .40528 Mdot
.36701 .4155 Mdot
.36873 .42511 Mdot
.42021 .43422 Mdot
.45281 .44735 Mdot
.5163 .46438 Mdot
.60725 .48549 Mdot
.72909 .50978 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{35, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`;o0000
ooooool@ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooo
oooo0?oooooo3oooool000oooooo0_l0003ooooooa3ooooo000?ooooo`;o0000ooooool@ooooo`00
3oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3ooo
ool000oooooo00?o0000ooooooooool0ooooool?ooooo`002?ooool3o`0000Cooooo00?o0000oooo
ooooool0ooooool?ooooo`002Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo0?oo
oooo3oooool000Go000000?oooooo`000?l000000ol00004ooooo`?o0000ooooool?ooooo`001_oo
ool01?l0003oooooooooool00005ooooo`03o`000?oooooooooo0?oooooo3oooool000Oooooo00?o
0000ooooool000001Oooool00ol0003oooooooooo`3oooooo`oooooo0008ooooo`;o00001Oooool0
0ol0003oooooooooo`3oooooo`oooooo0009ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`00
0?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool2
o`000?oooooo4?ooool000oooooo0_l0003ooooooa3ooooo000?ooooo`03o`000?oooooooooo0?oo
oooo3oooool000oooooo0_l0003ooooooa3ooooo000?ooooo`03o`000?oooooooooo0?oooooo3ooo
ool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3ooooo
o`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0
ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooo
oooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003o
ooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo0_l0
003ooooooa3ooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`00
0?oooooooooo00;o0000ooooool=ooooo`003oooool00ol0003oooooooooo`02o`000?oooooo3Ooo
ool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3ooooo
o`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0
ooooool?ooooo`003oooool2o`0000;ooooo0_l0003oooooo`cooooo000?ooooo`04o`000?oooooo
ooooooooo`;o0000ooooool<ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?oooo
o`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`00
3oooool00ol0003oooooooooo`02ooooo`;o0000ooooool;ooooo`003oooool00ol0003ooooooooo
o`02ooooo`;o0000ooooool;ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo0006oooo
o`Go00001?ooool00ol0003oooooooooo`3oooooo`oooooo0007ooooo`04o`000?ooooooooooo`00
00Cooooo00?o0000ooooooooool0ooooool?ooooo`001Ol00003ooooo`03o`000?oooooooooo00Co
oooo00?o0000ooooooooool0ooooool?ooooo`002Oooool00ol0003oooooooooo`03ooooo`?o0000
ooooool?ooooo`001_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
ooooool?ooooo`001_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
ooooool?ooooo`001oooool3o`0000Gooooo00?o0000ooooooooool00_ooool2o`000?oooooo2ooo
ool000oooooo00?o0000ooooooooool00_ooool2o`000?oooooo2oooool000oooooo00?o0000oooo
ooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`04ooooo`;o0000ooooool9ooooo`00
3oooool00ol0003oooooooooo`04ooooo`;o0000ooooool9ooooo`003oooool00ol0003ooooooooo
o`3oooooo`oooooo000?ooooo`03o`000?oooooooooo00Cooooo0_l0003oooooo`Wooooo000?oooo
o`03o`000?oooooooooo00Cooooo0_l0003oooooo`Wooooo000?ooooo`;o0000ooooool@ooooo`00
3oooool00ol0003oooooooooo`05ooooo`;o0000ooooool8ooooo`003oooool00ol0003ooooooooo
o`05ooooo`;o0000ooooool8ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?oooo
o`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool01Oooool2o`000?oo
oooo2?ooool000oooooo00?o0000ooooooooool01Oooool2o`000?oooooo2?ooool000oooooo00?o
0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`06ooooo`;o0000ooooool7
ooooo`003oooool00ol0003oooooooooo`06ooooo`;o0000ooooool7ooooo`003oooool2o`000?oo
oooo4?ooool000oooooo00?o0000ooooooooool01_ooool2o`000?oooooo1oooool000oooooo00?o
0000ooooooooool01_ooool2o`000?oooooo1oooool000oooooo00?o0000ooooooooool0ooooool?
ooooo`003oooool00ol0003oooooooooo`0Aooooo`;o0000noooool000oooooo00?o0000oooooooo
ool04Oooool2o`000?_ooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o
0000ooooooooool04Oooool2o`000?_ooooo000?ooooo`03o`000?oooooooooo017ooooo0_l0003k
ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo01Go
oooo0_l0000>ooooo`?o00001?ooool2o`0000Cooooo0_l0000Oooooo`Go00000oooool2o`0000Co
oooo0_l0000Qooooo`?o00001?ooool2o`0000Cooooo0_l0000Rooooo`?o00000oooool2o`0000Co
oooo0_l0000Qooooo`?o00001?ooool2o`0000Cooooo0_l0000Kooooo`003oooool2o`0001Kooooo
0_l0000?ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00000_ooool01?l0003o
ooooooooool0000Oooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00000_oo
ool01?l0003oooooooooool0000Oooooo`05o`000?ooooooooooooooool000000_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0002;ooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool07Oooool01Ol0003ooooo
oooooooooooo000000;ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000J
ooooo`003oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00;ooooo00Co0000oooo
oooooooo00000_ooool01?l0003oooooooooool0000Pooooo`03o`000?oooooooooo00;ooooo00Co
0000oooooooooooo00000_ooool01?l0003oooooooooool0000Sooooo`04o`000?ooooooooooo`00
00;ooooo00Co0000oooooooooooo00000_ooool00ol0003oooooooooo`0Mooooo`Go00000_ooool0
1?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0002?ooooo00Co0000oooooooooooo
00000_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01Sooooo000?ooooo`03
o`000?oooooooooo01Kooooo0_l0000>ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Qooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`03o`000?oooooooooo01oooooo0_l00003ooooo`04o`00
0?ooooooooooo`0000;ooooo00Co0000oooooooooooo00007oooool01?l0003oooooooooool00003
ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00008oooool01?l0003ooooo
ooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool06?ooool000oo
oooo00?o0000ooooooooool05_ooool2o`0000kooooo00?o0000ooooooooool00_ooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0001kooooo00Go0000ooooooooooooooooo`00
0002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00008oooool01?l0003o
ooooooooool00002ooooo`04o`000?ooooooooooo`0000;ooooo00?o0000ooooooooool07_ooool0
0ol0003oooooo`000003ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo0000
7oooool4o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Joooo
o`003oooool00ol0003oooooooooo`0Gooooo`;o00003?ooool2o`0000Cooooo00Co0000oooooooo
oooo00000_ooool01?l0003oooooooooool0000Nooooo`05o`000?ooooooooooooooool000000_oo
ool01?l0003oooooooooool00002ooooo`04o`000?ooooooooooo`0001oooooo00Go0000oooooooo
ooooooooo`000002ooooo`04o`000?ooooooooooo`0000;ooooo00Co0000oooooooooooo00008Ooo
ool2o`0000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000Oooooo`03
o`000?oooooooooo00Cooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool0000J
ooooo`003oooool00ol0003oooooooooo`0Gooooo`;o00003Oooool00ol0003oooooooooo`03oooo
o`;o00001?ooool2o`00023ooooo0ol00004ooooo`;o00001?ooool2o`00027ooooo0ol00004oooo
o`;o00001?ooool2o`0002?ooooo00?o0000ooooooooool00_ooool2o`0000Cooooo0_l0000Poooo
o`Go00000oooool2o`0000Cooooo0_l0000Kooooo`003oooool00ol0003oooooooooo`0Tooooo`;o
0000j?ooool000oooooo00?o0000ooooooooool09?ooool2o`000>Sooooo000?ooooo`03o`000?oo
oooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool09Oooool2o`000>Oooooo0008oooo
oooo00006Ol0000000oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool2o`00
00Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00?ooooo000?ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00Co0000oooooooooooooooo0_l00004oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03oooo
o`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo02cooooo
0_l0003Pooooo`003oooool00ol0003oooooooooo`0/ooooo`;o0000h?ooool000oooooo00?o0000
ooooooooool0=Oooool2o`000=Oooooo000?ooooo`03o`000?oooooooooo03Gooooo0_l0003Goooo
o`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo03Wooooo
0_l0003Cooooo`003oooool00ol0003oooooooooo`0iooooo`;o0000doooool000oooooo0_l00016
ooooo`;o0000aoooool000oooooo00?o0000ooooooooool0AOooool2o`000<Oooooo000?ooooo`03
o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0Boooool2o`000<7ooooo
000?ooooo`03o`000?oooooooooo04_ooooo0_l00031ooooo`003oooool00ol0003oooooooooo`1A
ooooo`;o0000^oooool000oooooo00?o0000ooooooooool0DOooool2o`000;_ooooo000?ooooo`03
o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0G?ooool2o`000;3ooooo
000?ooooo`03o`000?oooooooooo05cooooo0_l0002`ooooo`003oooool00ol0003oooooooooo`3o
ooooo`oooooo000?ooooo`;o0000GOooool2o`000;3ooooo000?ooooo`03o`000?oooooooooo05co
oooo0_l0002`ooooo`003oooool00ol0003oooooooooo`1[ooooo`;o0000XOooool000oooooo00?o
0000ooooooooool0Joooool2o`000:7ooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool0
00oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`1dooooo`;o
0000V?ooool000oooooo00?o0000ooooooooool0M?ooool2o`0009Sooooo000?ooooo`03o`000?oo
oooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool2o`00
0?oooooo4?ooool000oooooo00?o0000ooooooooool0QOooool2o`0008Oooooo000?ooooo`03o`00
0?oooooooooo08Gooooo0_l00027ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?
ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?oooo
o`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo09oooooo
0_l0001]ooooo`003oooool00ol0003oooooooooo`2Oooooo`;o0000KOooool000Kooooo1Ol00004
ooooo`03o`000?oooooooooo0?oooooo3oooool000Oooooo00Co0000oooooooooooo00001?ooool0
0ol0003oooooooooo`3oooooo`oooooo0008ooooo`03o`000?oooooooooo00Cooooo0ol0003ooooo
o`oooooo0009ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0ooooool?ooooo`00
1_ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0`Oooool2o`0004_o
oooo0006ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`31ooooo`;o
0000Boooool000Oooooo0ol00005ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o
0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?oooo
o`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`00
3oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3ooo
ool000oooooo0_l0003ooooooa3ooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oo
oooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo
000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?
ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oo
oooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003ooooooooo
o`3oooooo`oooooo000?ooooo`;o0000ooooool@ooooo`003oooool00ol0003oooooooooo`3ooooo
o`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o0000ooooooooool0
ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooo
oooo0?oooooo3oooool000oooooo00?o0000ooooooooool0ooooool?ooooo`003oooool00ol0003o
ooooooooo`3oooooo`oooooo000?ooooo`03o`000?oooooooooo0?oooooo3oooool000oooooo00?o
0000ooooooooool0ooooool?ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo000?oooo
o`;o0000ooooool@ooooo`003oooool00ol0003oooooooooo`3oooooo`oooooo003oooooob7ooooo
003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-32.4287, -4.64239, 2.09515, \
0.0469362}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\[Beta]\&^ = \[Beta] /. \[Beta]hat\), "\[IndentingNewLine]", 
    \(stdErr\[Beta]\)}], "Input"],

Cell[BoxData[
    \({\(-0.059586896310596396`\), \(-0.011938178967023315`\), 
      0.0006603283493803548`, 
      1.0477098980006065`, \(-0.026216930205873578`\), \(-0.3220582015916352`\
\), \(-0.4073017885555561`\)}\)], "Output"],

Cell[BoxData[
    \({0.013795634130859118`, 0.020743132339238055`, 0.011802875464293299`, 
      0.6281230450996395`, 0.5057117848873376`, 0.4857334556031889`, 
      0.4076181536296429`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(zScores = \(stdVar = \[Beta]\&^/stdErr\[Beta]\)\)], "Input"],

Cell[BoxData[
    \({\(-4.319257508961325`\), \(-0.5755244083575968`\), 
      0.05594639639959059`, 
      1.6680010487983414`, \(-0.0518416437768287`\), \
\(-0.6630348350036953`\), \(-0.9992238690272509`\)}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(\(\[Alpha]lpha = 0.05;\)\), "\n", 
    \(\(q = 
        Quantile[NormalDistribution[0, 1], 1 - \[Alpha]lpha/2];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(pValues = 
      Map[2\ \((1 - \ CDF[NormalDistribution[0, 1], Abs[#]])\) &, 
        zScores]\)], "Input"],

Cell[BoxData[
    \({0.000015655502338507432`, 0.5649366879046531`, 0.9553845097020404`, 
      0.09531551858348308`, 0.9586548732102473`, 0.5073082440699714`, 
      0.3176862555686477`}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " 95% Confidence Interval for ",
  Cell[BoxData[
      \(\[Beta]\&^\)]],
  " "
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ci95 = 
      Transpose[{\[Beta]\&^ - q\ stdErr\[Beta], \[Beta]\&^ + 
            q\ stdErr\[Beta]}]\)], "Input"],

Cell[BoxData[
    \({{\(-0.08662584235097179`\), \(-0.032547950270221`\)}, \
{\(-0.05259397127847798`\), 
        0.028717613344431347`}, {\(-0.022472882474645975`\), 
        0.023793539173406687`}, {\(-0.18338864825431478`\), 
        2.278808444255528`}, {\(-1.0173938151425224`\), 
        0.9649599547307752`}, {\(-1.2740782806600706`\), 
        0.6299618774768003`}, {\(-1.2062186891143707`\), 
        0.3916151120032586`}}\)], "Output"]
}, Open  ]],

Cell["Significance Test", "BulletedList"],

Cell["\<\
Log partial likelihood ratio test can be used to test the full \
model against reduced models.  The basic test is full model vs no covariates.\
\
\>", "Text"],

Cell[BoxData[{
    \(\(\[Lambda] = 
        2\ \((maxLogL\[Beta] - 
              valuelogL\[Beta]0)\);\)\), "\[IndentingNewLine]", 
    \(\(note1 = \*"\"\<Probability \[Beta] > \!\(\[Beta]\&^\) given Ho: \
coefficients are simultaneously zero: \>\"" <> 
          numberForm[
            pTest = \((1 - 
                  CDF[ChiSquareDistribution[
                      Length[\[Beta]]], \[Lambda]])\)];\)\), "\
\[IndentingNewLine]", 
    \(\(note2 = 
        If[pTest \[LessEqual] 
            0.05, "\<Reject Ho: \[Beta] = 0\>", "\<Accept Ho: \[Beta] = \
0\>"];\)\)}], "Input",
  ShowSelection->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Table of Estimated Coefficients and Confidence Intervals", \
"Subsubsection",
  ShowSelection->True,
  ShowClosedCellArea->True],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(tableTitle = "\<\nProportional Hazards Model Solution of Estimated \
Coefficients\>";\)\), "\n", 
    \(\(\(tableColumnLabels = {"\<Variable \>", "\<Coefficent\>", "\< Std \
Error \>", "\< z \>", "\< P >|z| \>", "\< 95% CI\>"};\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(blankRow = setshowTableOpts[Length[tableColumnLabels]];\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(showData = 
        numberForm[
          Transpose[{\[Beta]nameList, \[Beta] /. \[Beta]hat, stdErr\[Beta], 
              zScores, pValues, ci95}]];\)\), "\[IndentingNewLine]", 
    \(\(tableData = Join[{tableColumnLabels}, showData];\)\), "\n", 
    \(\(notes = {note1, note2};\)\), "\[IndentingNewLine]", 
    \(showTable[tableTitle, tableData, notes, 
      ColumnSpacings \[Rule] {4, 3, 3, 3, 3, 5}]\)}], "Input",
  ShowCellBracket->True,
  ShowSelection->True,
  ShowClosedCellArea->False],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            StyleBox[\(\(\n\)\(Proportional\ Hazards\ Model\ Solution\ of\ \
Estimated\ Coefficients\)\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Variable\)\(\ \)\), 
                    "Coefficent", \(\(\ \)\(\(Std\)\(\ \)\(Error\)\(\ \)\)\), \
\(\(\ \)\(z\)\(\ \)\), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\ \
\)\)\), \(\(\ \)\(95  %\ CI\)\)},
                  {"\[CapitalDelta]PerfStatus", \(-0.06\), 
                    "0.014", \(-4.319\), \(\(<\)\(.001\)\), \({"-0.087", 
                      "-0.033"}\)},
                  {"\[CapitalDelta]Age", \(-0.012\), "0.021", \(-0.576\), 
                    "0.565", \({"-0.053", "0.029"}\)},
                  {"\[CapitalDelta]EntryDelay", \(\(<\)\(.001\)\), "0.012", 
                    "0.056", "0.955", \({"-0.022", "0.024"}\)},
                  {"Adeno", "1.048", "0.628", "1.668", 
                    "0.095", \({"-0.183", "2.279"}\)},
                  {"Small", \(-0.026\), "0.506", \(-0.052\), 
                    "0.959", \({"-1.017", "0.965"}\)},
                  {"Squamous", \(-0.322\), "0.486", \(-0.663\), 
                    "0.507", \({"-1.274", "0.63"}\)},
                  {"Test", \(-0.407\), "0.408", \(-0.999\), 
                    "0.318", \({"-1.206", "0.392"}\)}
                  },
                RowSpacings->3,
                ColumnSpacings->{4, 3, 3, 3, 3, 5},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            
            StyleBox[\(\(\n\)\(Probability\ \[Beta]\  > \ \[Beta]\&^\ given\ \
\(Ho : \ coefficients\ are\ simultaneously\ \(zero : \ \(\(<\)\(.001\)\)\)\)\n
              
              Reject\ \(Ho : \ \[Beta]\)\  = \ 0\)\),
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Output", "Subsubsection"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            
            StyleBox[\(\(\n\)\(Proportional\ Hazards\ Model\ Solution\ of\ \
Estimated\ Coefficients\)\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Variable\)\(\ \)\), 
                    "Coefficent", \(\(\ \)\(\(Std\)\(\ \)\(Error\)\(\ \)\)\), \
\(\(\ \)\(z\)\(\ \)\), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\ \
\)\)\), \(\(\ \)\(95  %\ CI\)\)},
                  {"\[CapitalDelta]PerfStatus", \(-0.06\), 
                    "0.014", \(-4.319\), \(\(<\)\(.001\)\), \({"-0.087", 
                      "-0.033"}\)},
                  {"\[CapitalDelta]Age", \(-0.012\), "0.021", \(-0.576\), 
                    "0.565", \({"-0.053", "0.029"}\)},
                  {"\[CapitalDelta]EntryDelay", \(\(<\)\(.001\)\), "0.012", 
                    "0.056", "0.955", \({"-0.022", "0.024"}\)},
                  {"Adeno", "1.048", "0.628", "1.668", 
                    "0.095", \({"-0.183", "2.279"}\)},
                  {"Small", \(-0.026\), "0.506", \(-0.052\), 
                    "0.959", \({"-1.017", "0.965"}\)},
                  {"Squamous", \(-0.322\), "0.486", \(-0.663\), 
                    "0.507", \({"-1.274", "0.63"}\)},
                  {"Test", \(-0.407\), "0.408", \(-0.999\), 
                    "0.318", \({"-1.206", "0.392"}\)}
                  },
                RowSpacings->3,
                ColumnSpacings->{4, 3, 3, 3, 3, 5},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            
            StyleBox[\(\(\n\)\(Probability\ \[Beta]\  > \ \[Beta]\&^\ given\ \
\(Ho : \ coefficients\ are\ simultaneously\ \(zero : \ \(\(<\)\(.001\)\)\)\)\n
              
              Reject\ \(Ho : \ \[Beta]\)\  = \ 0\)\),
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Submodel Significance Tests", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\[Beta]nameList\)], "Input"],

Cell[BoxData[
    \({"\[CapitalDelta]PerfStatus", "\[CapitalDelta]Age", 
      "\[CapitalDelta]EntryDelay", "Adeno", "Small", "Squamous", 
      "Test"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(ml\[Beta]x1 = \(boxedPH[
          inputData, \[Beta] /. \[Beta]x1 \[Rule] 0]\)\[LeftDoubleBracket]1, 
        2\[RightDoubleBracket]\), "\[IndentingNewLine]", 
    \(ml\[Beta]x2 = \(boxedPH[
          inputData, \[Beta] /. \[Beta]x2 \[Rule] 0]\)\[LeftDoubleBracket]1, 
        2\[RightDoubleBracket]\), "\[IndentingNewLine]", 
    \(ml\[Beta]x3 = \(boxedPH[
          inputData, \[Beta] /. \[Beta]x3 \[Rule] 0]\)\[LeftDoubleBracket]1, 
        2\[RightDoubleBracket]\), "\[IndentingNewLine]", 
    \(ml\[Beta]x4 = \(boxedPH[
          inputData, \[Beta] /. {\[Beta]x4 \[Rule] 0, \[Beta]x5 \[Rule] 
                0, \[Beta]x6 \[Rule] 0}]\)\[LeftDoubleBracket]1, 
        2\[RightDoubleBracket]\), "\[IndentingNewLine]", 
    \(ml\[Beta]x5 = \(boxedPH[
          inputData, \[Beta] /. \[Beta]x7 \[Rule] 0]\)\[LeftDoubleBracket]1, 
        2\[RightDoubleBracket]\)}], "Input"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-97.69039011371004`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -97.690390113710038, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) "\[InvisibleSpace]{0, \
\(-0.0006532873917902892`\), 0.016960940610208048`, 1.3335793188070089`, 
          0.2253476046037035`, \(-0.2558829778990897`\), \
\(-0.6114843484896069`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {0, -0.00065328739179028924, 0.016960940610208048, 
        1.3335793188070089, 
        0.22534760460370351, -0.2558829778990897, -0.61148434848960687}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{\(-1.3921450658926915`*^-9\), \
\(-3.9247775251993744`*^-8\), 
          1.2067263854831367`*^-10, \(-3.7872988079001857`*^-10\), 
          9.858303062770801`*^-11, \(-2.997691539441405`*^-10\)}\),
      SequenceForm[ 
      "Gradient vector ", {-1.3921450658926915*^-09, -3.9247775251993744*^-08,
         1.2067263854831367*^-10, -3.7872988079001857*^-10, 
        9.8583030627708013*^-11, -2.997691539441405*^-10}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.0003709785536928013`, \(-0.000018269468192957837`\), \
\(-0.00176522548780379`\), \(-0.0008588914416759644`\), \
\(-0.0008840891427013463`\), 
            0.0012835843909318999`}, {\(-0.000018269468192957837`\), 
            0.00016419234517822006`, 
            0.0010927143977313173`, \(-0.0025290879854969178`\), 
            0.0003406080036849694`, \(-0.0020546836306850336`\)}, \
{\(-0.00176522548780379`\), 0.0010927143977313176`, 0.3785985129463586`, 
            0.09509565367212314`, 
            0.11381083098072416`, \(-0.0767502495697181`\)}, \
{\(-0.0008588914416759643`\), \(-0.0025290879854969173`\), 
            0.09509565367212314`, 0.2547228782878048`, 0.09757219658919422`, 
            0.04759185667611546`}, {\(-0.0008840891427013464`\), 
            0.0003406080036849697`, 0.11381083098072417`, 
            0.09757219658919422`, 
            0.22125491967346583`, \(-0.01956958401238486`\)}, \
{0.0012835843909318996`, \(-0.0020546836306850336`\), \
\(-0.0767502495697181`\), 0.04759185667611546`, \(-0.019569584012384858`\), 
            0.1653610508343105`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.0003709785536928013, -1.8269468192957837*^-05, \
-0.00176522548780379, -0.00085889144167596444, -0.0008840891427013463, 
        0.0012835843909318999}, {-1.8269468192957837*^-05, 
        0.00016419234517822006, 0.0010927143977313173, -0.0025290879854969178,
         0.00034060800368496938, -0.0020546836306850336}, \
{-0.00176522548780379, 0.0010927143977313176, 0.3785985129463586, 
        0.095095653672123137, 
        0.11381083098072416, -0.076750249569718099}, \
{-0.00085889144167596433, -0.0025290879854969173, 0.095095653672123137, 
        0.25472287828780482, 0.097572196589194221, 
        0.047591856676115457}, {-0.00088408914270134641, 
        0.0003406080036849697, 0.11381083098072417, 0.097572196589194221, 
        0.22125491967346583, -0.019569584012384861}, {
        0.0012835843909318996, -0.0020546836306850336, -0.076750249569718099, 
        0.047591856676115457, -0.019569584012384858, 0.16536105083431049}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.01926080355781662`, 0.01281375609172502`, 
          0.6153035941276133`, 0.5047007809462998`, 0.47037742258049103`, 
          0.40664610023251235`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.019260803557816619, 
        0.012813756091725021, 0.61530359412761326, 0.50470078094629978, 
        0.47037742258049103, 0.40664610023251235}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9761488231508936`, 
          0.9757355449234841`, 0.9478644163185352`, 0.970959642830009`, 
          0.9700364848024966`, 0.9364054620852861`, 0.9652511558261974`, 
          0.9643582497692399`, 0.9625235605901692`, 0.9609596990669749`, 
          0.9601350717301381`, 0.9588155595189511`, 0.956218249326251`, 
          0.9553371465107763`, 0.952454855579011`, 0.9484518708250941`, 
          0.9453301545291707`, 0.9423734199564365`, 0.9380804979564632`, 
          0.9292795203039075`, 0.9201994917061367`, 0.9084875711900255`, 
          0.9022274401495444`, 0.8921000712387411`, 0.8810513377199313`, 
          0.8689932146658739`, 0.8498447564795555`, 0.8315102286206719`, 
          0.8146566870696688`, 0.7673313928946589`, 0.6760276197262894`, 
          0.5426971603670687`, 0.38539536761869775`, 0.1666121279596088`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.97614882315089357, 0.97573554492348413, 
        0.94786441631853524, 0.97095964283000902, 0.9700364848024966, 
        0.93640546208528608, 0.96525115582619736, 0.96435824976923989, 
        0.96252356059016919, 0.96095969906697487, 0.96013507173013812, 
        0.95881555951895114, 0.95621824932625099, 0.95533714651077628, 
        0.95245485557901099, 0.94845187082509408, 0.94533015452917069, 
        0.94237341995643653, 0.9380804979564632, 0.92927952030390748, 
        0.92019949170613669, 0.90848757119002554, 0.90222744014954437, 
        0.89210007123874113, 0.88105133771993127, 0.86899321466587387, 
        0.84984475647955549, 0.83151022862067192, 0.81465668706966876, 
        0.7673313928946589, 0.67602761972628944, 0.54269716036706872, 
        0.38539536761869775, 0.16661212795960881, 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\(-97.69039011371004`\)\)], "Output"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-87.90102219388996`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -87.901022193889958, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.05916541516284664`\), 0, \(-0.0005163105473799427`\), 
          0.9714639779133313`, \(-0.040993408013745174`\), \
\(-0.36134503104621357`\), \(-0.32522016193346703`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059165415162846638, 0, -0.00051631054737994266,
         0.97146397791333128, -0.040993408013745174, -0.36134503104621357, \
-0.32522016193346703}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{\(-9.349321317131398`*^-11\), 
          1.0403233829947567`*^-10, \(-1.1997569604460523`*^-11\), 
          5.162426042204515`*^-12, 
          2.835481849317034`*^-12, \(-5.709266392983636`*^-12\)}\),
      SequenceForm[ 
      "Gradient vector ", {-9.3493213171313982*^-11, 
        1.0403233829947567*^-10, -1.1997569604460523*^-11, 
        5.1624260422045154*^-12, 
        2.8354818493170342*^-12, -5.7092663929836363*^-12}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00019229894632496282`, 0.00003761965995453939`, 
            0.0006903918295084796`, 0.0010426985008054968`, 
            0.0005988622038415893`, \(-0.0004484285337414155`\)}, \
{0.0000376196599545394`, 0.00013692327045148093`, 
            0.00040368201480817627`, \(-0.0018981485902024677`\), 
            0.0006517201476565339`, \(-0.001413511953551848`\)}, \
{0.0006903918295084796`, 0.00040368201480817654`, 0.3753033328148184`, 
            0.11636155989302421`, 
            0.10670482342844974`, \(-0.043576629060667886`\)}, \
{0.001042698500805497`, \(-0.0018981485902024677`\), 0.11636155989302426`, 
            0.25539499164298457`, 0.09534833084502922`, 
            0.027307371992491447`}, {0.0005988622038415895`, 
            0.0006517201476565341`, 0.10670482342844974`, 
            0.09534833084502922`, 
            0.22655425169693624`, \(-0.021649496696824932`\)}, \
{\(-0.00044842853374141555`\), \(-0.0014135119535518483`\), \
\(-0.043576629060667886`\), 0.02730737199249145`, \(-0.021649496696824935`\), 
            0.14430279615050376`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00019229894632496282, 3.7619659954539388*^-05, 
        0.00069039182950847964, 0.0010426985008054968, 
        0.00059886220384158925, -0.0004484285337414155}, {
        3.7619659954539402*^-05, 0.00013692327045148093, 
        0.00040368201480817627, -0.0018981485902024677, 
        0.00065172014765653387, -0.001413511953551848}, {
        0.00069039182950847964, 0.00040368201480817654, 0.37530333281481842, 
        0.11636155989302421, 0.10670482342844974, -0.043576629060667886}, {
        0.001042698500805497, -0.0018981485902024677, 0.11636155989302426, 
        0.25539499164298457, 0.095348330845029222, 0.027307371992491447}, {
        0.00059886220384158947, 0.00065172014765653408, 0.10670482342844974, 
        0.095348330845029222, 
        0.22655425169693624, -0.021649496696824932}, \
{-0.00044842853374141555, -0.0014135119535518483, -0.043576629060667886, 
        0.027307371992491451, -0.021649496696824935, 0.14430279615050376}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013867189561153436`, 0.011701421727785087`, 
          0.6126200558378891`, 0.505366195587897`, 0.4759771545956132`, 
          0.3798720786666266`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013867189561153436, 
        0.011701421727785087, 0.61262005583788914, 0.50536619558789697, 
        0.47597715459561318, 0.37987207866662659}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9868950546490107`, 
          0.9863374839551788`, 0.965935796459083`, 0.9782319459972673`, 
          0.9775298440928317`, 0.9517201076581799`, 0.9731947808588325`, 
          0.9710375968349155`, 0.9661824391172656`, 0.9603989032592052`, 
          0.9541018163130686`, 0.9468270926086115`, 0.9413788982209808`, 
          0.9395884608061128`, 0.9317777455379465`, 0.9229112387330654`, 
          0.9214373067296048`, 0.9140930564792561`, 0.9045993707595059`, 
          0.8940096562476226`, 0.8788480525193486`, 0.8643790072042398`, 
          0.8555620285985527`, 0.8396255769952401`, 0.8240391901170636`, 
          0.7887779988571729`, 0.744216737619554`, 0.7313560616015796`, 
          0.7137852324757714`, 0.5758638683213154`, 0.4203520973783516`, 
          0.24395771263751082`, 0.10419029281193286`, 0.0018508451466793998`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98689505464901073, 0.98633748395517884, 
        0.96593579645908301, 0.97823194599726726, 0.97752984409283172, 
        0.95172010765817994, 0.97319478085883249, 0.97103759683491553, 
        0.96618243911726565, 0.96039890325920518, 0.95410181631306856, 
        0.94682709260861153, 0.94137889822098075, 0.9395884608061128, 
        0.93177774553794646, 0.92291123873306535, 0.92143730672960478, 
        0.91409305647925609, 0.90459937075950592, 0.89400965624762263, 
        0.87884805251934861, 0.86437900720423977, 0.85556202859855268, 
        0.8396255769952401, 0.82403919011706361, 0.78877799885717292, 
        0.74421673761955398, 0.73135606160157962, 0.71378523247577141, 
        0.57586386832131542, 0.42035209737835161, 0.24395771263751082, 
        0.10419029281193286, 0.0018508451466793998, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \(\(-87.90102219388996`\)\)], "Output"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-87.73834235845811`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -87.738342358458112, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.05974359522693455`\), \(-0.011733422173115184`\), 0, 
          1.0449767946620456`, \(-0.017707825830230332`\), \
\(-0.3259381039236014`\), \(-0.3993161479415043`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059743595226934551, -0.011733422173115184, 0, 
        1.0449767946620456, -0.017707825830230332, -0.3259381039236014, \
-0.39931614794150427}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{4.973799150320701`*^-14, \(-3.1086244689504383`*^-15\), 
          8.881784197001252`*^-16, \(-2.609024107869118`*^-15\), 
          8.326672684688674`*^-17, \(-2.3869795029440866`*^-15\)}\),
      SequenceForm[ 
      "Gradient vector ", {4.9737991503207013*^-14, -3.1086244689504383*^-15, 
        8.8817841970012523*^-16, -2.6090241078691179*^-15, 
        8.3266726846886741*^-17, -2.3869795029440866*^-15}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.0001824671036616506`, 0.000029332741961656654`, 
            0.0003159072628191094`, 0.0014209960122020175`, 
            0.00027933748914052236`, 
            0.00022151661947810938`}, {0.000029332741961656648`, 
            0.00041663892720981906`, \(-0.0028290696160767673`\), \
\(-0.0013287531091810928`\), \(-0.0014309564021222413`\), 
            0.0025114694026462494`}, {0.0003159072628191091`, \
\(-0.0028290696160767673`\), 0.3920174944504417`, 0.13021120166107278`, 
            0.11501288690251743`, \(-0.05819581462871534`\)}, \
{0.001420996012202017`, \(-0.0013287531091810928`\), 0.13021120166107283`, 
            0.2318614814946395`, 
            0.10793417502212228`, \(-0.0027315771808776664`\)}, \
{0.00027933748914052225`, \(-0.0014309564021222413`\), 0.11501288690251746`, 
            0.10793417502212228`, 
            0.23100950334981726`, \(-0.029538377048303473`\)}, \
{0.00022151661947810943`, 
            0.0025114694026462494`, \(-0.05819581462871534`\), \
\(-0.0027315771808776677`\), \(-0.029538377048303473`\), 
            0.14552241010315217`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00018246710366165059, 2.9332741961656654*^-05, 
        0.00031590726281910939, 0.0014209960122020175, 0.00027933748914052236,
         0.00022151661947810938}, {2.9332741961656648*^-05, 
        0.00041663892720981906, -0.0028290696160767673, \
-0.0013287531091810928, -0.0014309564021222413, 0.0025114694026462494}, {
        0.00031590726281910912, -0.0028290696160767673, 0.39201749445044171, 
        0.13021120166107278, 0.11501288690251743, -0.058195814628715342}, {
        0.0014209960122020171, -0.0013287531091810928, 0.13021120166107283, 
        0.2318614814946395, 0.10793417502212228, -0.0027315771808776664}, {
        0.00027933748914052225, -0.0014309564021222413, 0.11501288690251746, 
        0.10793417502212228, 0.23100950334981726, -0.029538377048303473}, {
        0.00022151661947810943, 
        0.0025114694026462494, -0.058195814628715342, -0.0027315771808776677, \
-0.029538377048303473, 0.14552241010315217}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013508038483127392`, 0.020411735036733627`, 
          0.6261130045370737`, 0.4815199699852951`, 0.48063447998434033`, 
          0.38147399662775466`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013508038483127392, 
        0.020411735036733627, 0.62611300453707375, 0.48151996998529512, 
        0.48063447998434033, 0.38147399662775466}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9870175447893969`, 
          0.9864912710352947`, 0.9659576742557581`, 0.9781137653965065`, 
          0.9774450322364856`, 0.9516994701417831`, 0.9732479285941735`, 
          0.9708817613664616`, 0.9661800717920663`, 0.9604518832165626`, 
          0.95365295415889`, 0.9460733083516989`, 0.9401969164179196`, 
          0.9384623585996114`, 0.9307275801375756`, 0.9218591711036737`, 
          0.9202541409550585`, 0.9132384099043681`, 0.9045241049207533`, 
          0.893353717318429`, 0.8753996177426484`, 0.8569514546311879`, 
          0.8476582029405401`, 0.8307887507467874`, 0.8151639876514132`, 
          0.7813794670777742`, 0.7363622049978883`, 0.7209117613507401`, 
          0.7045728748429724`, 0.5572745390810618`, 0.3967806337879107`, 
          0.22969411976200046`, 0.10245353876773804`, 0.0018306320902652835`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98701754478939685, 0.98649127103529466, 
        0.96595767425575807, 0.97811376539650652, 0.9774450322364856, 
        0.95169947014178313, 0.97324792859417353, 0.97088176136646165, 
        0.96618007179206633, 0.96045188321656261, 0.95365295415888995, 
        0.94607330835169889, 0.94019691641791958, 0.93846235859961136, 
        0.93072758013757562, 0.92185917110367366, 0.92025414095505853, 
        0.91323840990436811, 0.9045241049207533, 0.89335371731842905, 
        0.87539961774264841, 0.85695145463118794, 0.84765820294054006, 
        0.83078875074678737, 0.81516398765141318, 0.78137946707777417, 
        0.73636220499788829, 0.72091176135074009, 0.70457287484297237, 
        0.55727453908106184, 0.39678063378791067, 0.22969411976200046, 
        0.10245353876773804, 0.0018306320902652835, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \(\(-87.73834235845811`\)\)], "Output"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-89.89801154600923`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -89.898011546009229, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.05990524481294424`\), \(-0.008285850185575627`\), 
          0.0003039615968570847`, 0, 0, 0, \(-0.33021388175290617`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059905244812944243, -0.0082858501855756269, 
        0.0003039615968570847, 0, 0, 0, -0.33021388175290617}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{1.0599912059205963`*^-9, \(-1.57240664933056`*^-10\), \
\(-4.428157396318966`*^-9\), \(-3.287609073865383`*^-11\)}\),
      SequenceForm[ 
      "Gradient vector ", {
        1.0599912059205963*^-09, -1.57240664933056*^-10, \
-4.4281573963189658*^-09, -3.2876090738653829*^-11}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00017795291052650344`, 0.00001776031284173356`, 
            0.000033074000824360405`, 
            0.000021298039572009516`}, {0.000017760312841733556`, 
            0.0004286633458291928`, \(-0.000042651810816739645`\), 
            0.0031783470000552013`}, {0.000033074000824360405`, \
\(-0.000042651810816739645`\), 
            0.00010266473665913985`, \(-0.0011230774781168333`\)}, \
{0.00002129803957200946`, 0.003178347000055201`, \(-0.0011230774781168333`\), 
            0.15134379485827903`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00017795291052650344, 1.776031284173356*^-05, 
        3.3074000824360405*^-05, 2.1298039572009516*^-05}, {
        1.7760312841733556*^-05, 
        0.00042866334582919278, -4.2651810816739645*^-05, 
        0.0031783470000552013}, {
        3.3074000824360405*^-05, -4.2651810816739645*^-05, 
        0.00010266473665913985, -0.0011230774781168333}, {
        2.1298039572009459*^-05, 
        0.0031783470000552008, -0.0011230774781168333, 0.15134379485827903}}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013339899194765433`, 0.02070418667393609`, 
          0.010132360863053578`, 0.3890292982003785`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013339899194765433, 
        0.02070418667393609, 0.010132360863053578, 0.38902929820037851}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.983461208961119`, 
          0.9822618797895214`, 0.9598667962038505`, 0.9765639847031975`, 
          0.9757187611719793`, 0.9493216174368588`, 0.9725452679291864`, 
          0.9698731276572782`, 0.9664633561275201`, 0.9627322770732802`, 
          0.9564432013041199`, 0.9494379349823237`, 0.944007277430326`, 
          0.9421319301248012`, 0.9340222887670234`, 0.9249452892390088`, 
          0.9234726592693917`, 0.9142015239860805`, 0.9037230084876222`, 
          0.8998548757738934`, 0.8911092501503257`, 0.8767065762637191`, 
          0.8667721941163498`, 0.8513326025837515`, 0.8386138496157215`, 
          0.8122245604029646`, 0.7790454737773992`, 0.7670952271488009`, 
          0.7531696570599439`, 0.6098802358383268`, 0.4849055064794017`, 
          0.3483471989951946`, 0.205108958970181`, 0.013057306422905842`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98346120896111899, 0.9822618797895214, 
        0.95986679620385051, 0.9765639847031975, 0.97571876117197931, 
        0.94932161743685883, 0.97254526792918639, 0.96987312765727818, 
        0.9664633561275201, 0.96273227707328024, 0.95644320130411986, 
        0.94943793498232365, 0.94400727743032598, 0.94213193012480123, 
        0.93402228876702342, 0.92494528923900876, 0.9234726592693917, 
        0.91420152398608046, 0.90372300848762221, 0.89985487577389345, 
        0.89110925015032572, 0.87670657626371906, 0.86677219411634976, 
        0.85133260258375154, 0.8386138496157215, 0.81222456040296465, 
        0.77904547377739919, 0.76709522714880085, 0.75316965705994388, 
        0.60988023583832685, 0.48490550647940173, 0.34834719899519462, 
        0.205108958970181, 0.013057306422905842, 9.9999999999999995*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\(-89.89801154600923`\)\)], "Output"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-88.24574705297411`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -88.24574705297411, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.06023629545302396`\), \(-0.004524192663519176`\), \
\(-0.003408557391424531`\), 0.8986048640742351`, 
          0.03223501560096165`, \(-0.4087740248426947`\), 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.060236295453023961, -0.004524192663519176, \
-0.0034085573914245308, 0.89860486407423512, 
        0.032235015600961647, -0.40877402484269471, 0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{1.3492851280716422`*^-10, \(-2.1084023416051423`*^-11\), \
\(-5.683626902452943`*^-10\), 
          1.6265322422270856`*^-12, \(-5.372091660404976`*^-12\), 
          1.4788448243763241`*^-12}\),
      SequenceForm[ 
      "Gradient vector ", {
        1.3492851280716422*^-10, -2.1084023416051423*^-11, \
-5.6836269024529429*^-10, 1.6265322422270856*^-12, -5.3720916604049762*^-12, 
        1.4788448243763241*^-12}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00018762590828202237`, 8.750551197695723`*^-6, 
            0.000029751559332708937`, 0.00033437048355920674`, 
            0.0011855473992414389`, 
            0.0005865363216926758`}, {8.750551197695723`*^-6, 
            0.000374283909502701`, \(-0.00001530363032074314`\), \
\(-0.0016270291626879361`\), \(-0.0006987091553805113`\), \
\(-0.0002603574095089451`\)}, {0.000029751559332708934`, \
\(-0.000015303630320743143`\), 
            0.00011986577729450546`, \(-0.00006164376894643163`\), \
\(-0.0016206933033345449`\), 
            0.0004252914489150651`}, {0.00033437048355920685`, \
\(-0.0016270291626879361`\), \(-0.0000616437689464316`\), 
            0.35905454894887423`, 0.1274078130050322`, 
            0.09728801515255235`}, {0.001185547399241439`, \
\(-0.0006987091553805112`\), \(-0.001620693303334545`\), 0.1274078130050322`, 
            0.25399736320388777`, 
            0.09830926017206341`}, {0.0005865363216926758`, \
\(-0.00026035740950894505`\), 0.0004252914489150648`, 0.09728801515255234`, 
            0.09830926017206341`, 0.22303072492599685`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00018762590828202237, 8.7505511976957228*^-06, 
        2.9751559332708937*^-05, 0.00033437048355920674, 
        0.0011855473992414389, 0.00058653632169267578}, {
        8.7505511976957228*^-06, 
        0.00037428390950270101, -1.5303630320743139*^-05, \
-0.0016270291626879361, -0.00069870915538051135, -0.00026035740950894511}, {
        2.9751559332708934*^-05, -1.5303630320743143*^-05, 
        0.00011986577729450546, -6.1643768946431627*^-05, \
-0.0016206933033345449, 0.00042529144891506512}, {
        0.00033437048355920685, -0.0016270291626879361, \
-6.16437689464316*^-05, 0.35905454894887423, 0.12740781300503221, 
        0.097288015152552351}, {
        0.0011855473992414391, -0.00069870915538051124, \
-0.0016206933033345451, 0.12740781300503221, 0.25399736320388777, 
        0.098309260172063415}, {
        0.00058653632169267578, -0.00026035740950894505, 
        0.00042529144891506479, 0.097288015152552337, 0.098309260172063415, 
        0.22303072492599685}}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013697660686483017`, 0.019346418518751757`, 
          0.01094832303572129`, 0.5992116061533473`, 0.5039815107758298`, 
          0.47226128882854335`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013697660686483017, 
        0.019346418518751757, 0.01094832303572129, 0.59921160615334734, 
        0.50398151077582976, 0.47226128882854335}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.988304174252566`, 
          0.9876924785368519`, 0.9703778549192447`, 0.9818879194770946`, 
          0.9813939610807656`, 0.9606604976044927`, 0.9785754340620546`, 
          0.9769265373937449`, 0.9731611474711558`, 0.967892713101855`, 
          0.9609928627756005`, 0.9535387001424149`, 0.9486053910118796`, 
          0.9467166179930807`, 0.9390933741340832`, 0.9303982427081804`, 
          0.929086668042045`, 0.9234687075685993`, 0.9159587649296497`, 
          0.9051447177709908`, 0.8900901096015721`, 0.87511621771553`, 
          0.8682078939796802`, 0.8550095978234526`, 0.8406504200338201`, 
          0.8117436429550566`, 0.7776261754521164`, 0.7666228601359376`, 
          0.7493555814305825`, 0.6014091722931213`, 0.4653996553922882`, 
          0.29759287325081984`, 0.16004892288200454`, 0.00904592584696796`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.988304174252566, 0.98769247853685194, 
        0.97037785491924466, 0.98188791947709464, 0.9813939610807656, 
        0.96066049760449268, 0.97857543406205461, 0.97692653739374491, 
        0.97316114747115579, 0.96789271310185498, 0.96099286277560048, 
        0.95353870014241493, 0.94860539101187957, 0.94671661799308071, 
        0.93909337413408323, 0.93039824270818039, 0.92908666804204498, 
        0.92346870756859933, 0.91595876492964967, 0.90514471777099081, 
        0.89009010960157209, 0.87511621771553005, 0.86820789397968023, 
        0.85500959782345265, 0.84065042003382007, 0.81174364295505663, 
        0.77762617545211643, 0.76662286013593761, 0.74935558143058245, 
        0.6014091722931213, 0.46539965539228823, 0.29759287325081984, 
        0.16004892288200454, 0.0090459258469679608, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print"],

Cell[BoxData[
    \(\(-88.24574705297411`\)\)], "Output"],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-97.69039011371004`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -97.690390113710038, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) "\[InvisibleSpace]{0, \
\(-0.0006532873917902892`\), 0.016960940610208048`, 1.3335793188070089`, 
          0.2253476046037035`, \(-0.2558829778990897`\), \
\(-0.6114843484896069`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {0, -0.00065328739179028924, 0.016960940610208048, 
        1.3335793188070089, 
        0.22534760460370351, -0.2558829778990897, -0.61148434848960687}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{\(-1.3921450658926915`*^-9\), \
\(-3.9247775251993744`*^-8\), 
          1.2067263854831367`*^-10, \(-3.7872988079001857`*^-10\), 
          9.858303062770801`*^-11, \(-2.997691539441405`*^-10\)}\),
      SequenceForm[ 
      "Gradient vector ", {-1.3921450658926915*^-09, -3.9247775251993744*^-08,
         1.2067263854831367*^-10, -3.7872988079001857*^-10, 
        9.8583030627708013*^-11, -2.997691539441405*^-10}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.0003709785536928013`, \(-0.000018269468192957837`\), \
\(-0.00176522548780379`\), \(-0.0008588914416759644`\), \
\(-0.0008840891427013463`\), 
            0.0012835843909318999`}, {\(-0.000018269468192957837`\), 
            0.00016419234517822006`, 
            0.0010927143977313173`, \(-0.0025290879854969178`\), 
            0.0003406080036849694`, \(-0.0020546836306850336`\)}, \
{\(-0.00176522548780379`\), 0.0010927143977313176`, 0.3785985129463586`, 
            0.09509565367212314`, 
            0.11381083098072416`, \(-0.0767502495697181`\)}, \
{\(-0.0008588914416759643`\), \(-0.0025290879854969173`\), 
            0.09509565367212314`, 0.2547228782878048`, 0.09757219658919422`, 
            0.04759185667611546`}, {\(-0.0008840891427013464`\), 
            0.0003406080036849697`, 0.11381083098072417`, 
            0.09757219658919422`, 
            0.22125491967346583`, \(-0.01956958401238486`\)}, \
{0.0012835843909318996`, \(-0.0020546836306850336`\), \
\(-0.0767502495697181`\), 0.04759185667611546`, \(-0.019569584012384858`\), 
            0.1653610508343105`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.0003709785536928013, -1.8269468192957837*^-05, \
-0.00176522548780379, -0.00085889144167596444, -0.0008840891427013463, 
        0.0012835843909318999}, {-1.8269468192957837*^-05, 
        0.00016419234517822006, 0.0010927143977313173, -0.0025290879854969178,
         0.00034060800368496938, -0.0020546836306850336}, \
{-0.00176522548780379, 0.0010927143977313176, 0.3785985129463586, 
        0.095095653672123137, 
        0.11381083098072416, -0.076750249569718099}, \
{-0.00085889144167596433, -0.0025290879854969173, 0.095095653672123137, 
        0.25472287828780482, 0.097572196589194221, 
        0.047591856676115457}, {-0.00088408914270134641, 
        0.0003406080036849697, 0.11381083098072417, 0.097572196589194221, 
        0.22125491967346583, -0.019569584012384861}, {
        0.0012835843909318996, -0.0020546836306850336, -0.076750249569718099, 
        0.047591856676115457, -0.019569584012384858, 0.16536105083431049}}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.01926080355781662`, 0.01281375609172502`, 
          0.6153035941276133`, 0.5047007809462998`, 0.47037742258049103`, 
          0.40664610023251235`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.019260803557816619, 
        0.012813756091725021, 0.61530359412761326, 0.50470078094629978, 
        0.47037742258049103, 0.40664610023251235}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9761488231508936`, 
          0.9757355449234841`, 0.9478644163185352`, 0.970959642830009`, 
          0.9700364848024966`, 0.9364054620852861`, 0.9652511558261974`, 
          0.9643582497692399`, 0.9625235605901692`, 0.9609596990669749`, 
          0.9601350717301381`, 0.9588155595189511`, 0.956218249326251`, 
          0.9553371465107763`, 0.952454855579011`, 0.9484518708250941`, 
          0.9453301545291707`, 0.9423734199564365`, 0.9380804979564632`, 
          0.9292795203039075`, 0.9201994917061367`, 0.9084875711900255`, 
          0.9022274401495444`, 0.8921000712387411`, 0.8810513377199313`, 
          0.8689932146658739`, 0.8498447564795555`, 0.8315102286206719`, 
          0.8146566870696688`, 0.7673313928946589`, 0.6760276197262894`, 
          0.5426971603670687`, 0.38539536761869775`, 0.1666121279596088`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.97614882315089357, 0.97573554492348413, 
        0.94786441631853524, 0.97095964283000902, 0.9700364848024966, 
        0.93640546208528608, 0.96525115582619736, 0.96435824976923989, 
        0.96252356059016919, 0.96095969906697487, 0.96013507173013812, 
        0.95881555951895114, 0.95621824932625099, 0.95533714651077628, 
        0.95245485557901099, 0.94845187082509408, 0.94533015452917069, 
        0.94237341995643653, 0.9380804979564632, 0.92927952030390748, 
        0.92019949170613669, 0.90848757119002554, 0.90222744014954437, 
        0.89210007123874113, 0.88105133771993127, 0.86899321466587387, 
        0.84984475647955549, 0.83151022862067192, 0.81465668706966876, 
        0.7673313928946589, 0.67602761972628944, 0.54269716036706872, 
        0.38539536761869775, 0.16661212795960881, 9.9999999999999995*^-07}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \(\(-97.69039011371004`\)\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-87.90102219388996`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -87.901022193889958, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.05916541516284664`\), 0, \(-0.0005163105473799427`\), 
          0.9714639779133313`, \(-0.040993408013745174`\), \
\(-0.36134503104621357`\), \(-0.32522016193346703`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059165415162846638, 0, -0.00051631054737994266,
         0.97146397791333128, -0.040993408013745174, -0.36134503104621357, \
-0.32522016193346703}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{\(-9.349321317131398`*^-11\), 
          1.0403233829947567`*^-10, \(-1.1997569604460523`*^-11\), 
          5.162426042204515`*^-12, 
          2.835481849317034`*^-12, \(-5.709266392983636`*^-12\)}\),
      SequenceForm[ 
      "Gradient vector ", {-9.3493213171313982*^-11, 
        1.0403233829947567*^-10, -1.1997569604460523*^-11, 
        5.1624260422045154*^-12, 
        2.8354818493170342*^-12, -5.7092663929836363*^-12}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00019229894632496282`, 0.00003761965995453939`, 
            0.0006903918295084796`, 0.0010426985008054968`, 
            0.0005988622038415893`, \(-0.0004484285337414155`\)}, \
{0.0000376196599545394`, 0.00013692327045148093`, 
            0.00040368201480817627`, \(-0.0018981485902024677`\), 
            0.0006517201476565339`, \(-0.001413511953551848`\)}, \
{0.0006903918295084796`, 0.00040368201480817654`, 0.3753033328148184`, 
            0.11636155989302421`, 
            0.10670482342844974`, \(-0.043576629060667886`\)}, \
{0.001042698500805497`, \(-0.0018981485902024677`\), 0.11636155989302426`, 
            0.25539499164298457`, 0.09534833084502922`, 
            0.027307371992491447`}, {0.0005988622038415895`, 
            0.0006517201476565341`, 0.10670482342844974`, 
            0.09534833084502922`, 
            0.22655425169693624`, \(-0.021649496696824932`\)}, \
{\(-0.00044842853374141555`\), \(-0.0014135119535518483`\), \
\(-0.043576629060667886`\), 0.02730737199249145`, \(-0.021649496696824935`\), 
            0.14430279615050376`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00019229894632496282, 3.7619659954539388*^-05, 
        0.00069039182950847964, 0.0010426985008054968, 
        0.00059886220384158925, -0.0004484285337414155}, {
        3.7619659954539402*^-05, 0.00013692327045148093, 
        0.00040368201480817627, -0.0018981485902024677, 
        0.00065172014765653387, -0.001413511953551848}, {
        0.00069039182950847964, 0.00040368201480817654, 0.37530333281481842, 
        0.11636155989302421, 0.10670482342844974, -0.043576629060667886}, {
        0.001042698500805497, -0.0018981485902024677, 0.11636155989302426, 
        0.25539499164298457, 0.095348330845029222, 0.027307371992491447}, {
        0.00059886220384158947, 0.00065172014765653408, 0.10670482342844974, 
        0.095348330845029222, 
        0.22655425169693624, -0.021649496696824932}, \
{-0.00044842853374141555, -0.0014135119535518483, -0.043576629060667886, 
        0.027307371992491451, -0.021649496696824935, 0.14430279615050376}}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013867189561153436`, 0.011701421727785087`, 
          0.6126200558378891`, 0.505366195587897`, 0.4759771545956132`, 
          0.3798720786666266`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013867189561153436, 
        0.011701421727785087, 0.61262005583788914, 0.50536619558789697, 
        0.47597715459561318, 0.37987207866662659}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9868950546490107`, 
          0.9863374839551788`, 0.965935796459083`, 0.9782319459972673`, 
          0.9775298440928317`, 0.9517201076581799`, 0.9731947808588325`, 
          0.9710375968349155`, 0.9661824391172656`, 0.9603989032592052`, 
          0.9541018163130686`, 0.9468270926086115`, 0.9413788982209808`, 
          0.9395884608061128`, 0.9317777455379465`, 0.9229112387330654`, 
          0.9214373067296048`, 0.9140930564792561`, 0.9045993707595059`, 
          0.8940096562476226`, 0.8788480525193486`, 0.8643790072042398`, 
          0.8555620285985527`, 0.8396255769952401`, 0.8240391901170636`, 
          0.7887779988571729`, 0.744216737619554`, 0.7313560616015796`, 
          0.7137852324757714`, 0.5758638683213154`, 0.4203520973783516`, 
          0.24395771263751082`, 0.10419029281193286`, 0.0018508451466793998`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98689505464901073, 0.98633748395517884, 
        0.96593579645908301, 0.97823194599726726, 0.97752984409283172, 
        0.95172010765817994, 0.97319478085883249, 0.97103759683491553, 
        0.96618243911726565, 0.96039890325920518, 0.95410181631306856, 
        0.94682709260861153, 0.94137889822098075, 0.9395884608061128, 
        0.93177774553794646, 0.92291123873306535, 0.92143730672960478, 
        0.91409305647925609, 0.90459937075950592, 0.89400965624762263, 
        0.87884805251934861, 0.86437900720423977, 0.85556202859855268, 
        0.8396255769952401, 0.82403919011706361, 0.78877799885717292, 
        0.74421673761955398, 0.73135606160157962, 0.71378523247577141, 
        0.57586386832131542, 0.42035209737835161, 0.24395771263751082, 
        0.10419029281193286, 0.0018508451466793998, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \(\(-87.90102219388996`\)\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-87.73834235845811`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -87.738342358458112, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.05974359522693455`\), \(-0.011733422173115184`\), 0, 
          1.0449767946620456`, \(-0.017707825830230332`\), \
\(-0.3259381039236014`\), \(-0.3993161479415043`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059743595226934551, -0.011733422173115184, 0, 
        1.0449767946620456, -0.017707825830230332, -0.3259381039236014, \
-0.39931614794150427}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{4.973799150320701`*^-14, \(-3.1086244689504383`*^-15\), 
          8.881784197001252`*^-16, \(-2.609024107869118`*^-15\), 
          8.326672684688674`*^-17, \(-2.3869795029440866`*^-15\)}\),
      SequenceForm[ 
      "Gradient vector ", {4.9737991503207013*^-14, -3.1086244689504383*^-15, 
        8.8817841970012523*^-16, -2.6090241078691179*^-15, 
        8.3266726846886741*^-17, -2.3869795029440866*^-15}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.0001824671036616506`, 0.000029332741961656654`, 
            0.0003159072628191094`, 0.0014209960122020175`, 
            0.00027933748914052236`, 
            0.00022151661947810938`}, {0.000029332741961656648`, 
            0.00041663892720981906`, \(-0.0028290696160767673`\), \
\(-0.0013287531091810928`\), \(-0.0014309564021222413`\), 
            0.0025114694026462494`}, {0.0003159072628191091`, \
\(-0.0028290696160767673`\), 0.3920174944504417`, 0.13021120166107278`, 
            0.11501288690251743`, \(-0.05819581462871534`\)}, \
{0.001420996012202017`, \(-0.0013287531091810928`\), 0.13021120166107283`, 
            0.2318614814946395`, 
            0.10793417502212228`, \(-0.0027315771808776664`\)}, \
{0.00027933748914052225`, \(-0.0014309564021222413`\), 0.11501288690251746`, 
            0.10793417502212228`, 
            0.23100950334981726`, \(-0.029538377048303473`\)}, \
{0.00022151661947810943`, 
            0.0025114694026462494`, \(-0.05819581462871534`\), \
\(-0.0027315771808776677`\), \(-0.029538377048303473`\), 
            0.14552241010315217`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00018246710366165059, 2.9332741961656654*^-05, 
        0.00031590726281910939, 0.0014209960122020175, 0.00027933748914052236,
         0.00022151661947810938}, {2.9332741961656648*^-05, 
        0.00041663892720981906, -0.0028290696160767673, \
-0.0013287531091810928, -0.0014309564021222413, 0.0025114694026462494}, {
        0.00031590726281910912, -0.0028290696160767673, 0.39201749445044171, 
        0.13021120166107278, 0.11501288690251743, -0.058195814628715342}, {
        0.0014209960122020171, -0.0013287531091810928, 0.13021120166107283, 
        0.2318614814946395, 0.10793417502212228, -0.0027315771808776664}, {
        0.00027933748914052225, -0.0014309564021222413, 0.11501288690251746, 
        0.10793417502212228, 0.23100950334981726, -0.029538377048303473}, {
        0.00022151661947810943, 
        0.0025114694026462494, -0.058195814628715342, -0.0027315771808776677, \
-0.029538377048303473, 0.14552241010315217}}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013508038483127392`, 0.020411735036733627`, 
          0.6261130045370737`, 0.4815199699852951`, 0.48063447998434033`, 
          0.38147399662775466`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013508038483127392, 
        0.020411735036733627, 0.62611300453707375, 0.48151996998529512, 
        0.48063447998434033, 0.38147399662775466}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.9870175447893969`, 
          0.9864912710352947`, 0.9659576742557581`, 0.9781137653965065`, 
          0.9774450322364856`, 0.9516994701417831`, 0.9732479285941735`, 
          0.9708817613664616`, 0.9661800717920663`, 0.9604518832165626`, 
          0.95365295415889`, 0.9460733083516989`, 0.9401969164179196`, 
          0.9384623585996114`, 0.9307275801375756`, 0.9218591711036737`, 
          0.9202541409550585`, 0.9132384099043681`, 0.9045241049207533`, 
          0.893353717318429`, 0.8753996177426484`, 0.8569514546311879`, 
          0.8476582029405401`, 0.8307887507467874`, 0.8151639876514132`, 
          0.7813794670777742`, 0.7363622049978883`, 0.7209117613507401`, 
          0.7045728748429724`, 0.5572745390810618`, 0.3967806337879107`, 
          0.22969411976200046`, 0.10245353876773804`, 0.0018306320902652835`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98701754478939685, 0.98649127103529466, 
        0.96595767425575807, 0.97811376539650652, 0.9774450322364856, 
        0.95169947014178313, 0.97324792859417353, 0.97088176136646165, 
        0.96618007179206633, 0.96045188321656261, 0.95365295415888995, 
        0.94607330835169889, 0.94019691641791958, 0.93846235859961136, 
        0.93072758013757562, 0.92185917110367366, 0.92025414095505853, 
        0.91323840990436811, 0.9045241049207533, 0.89335371731842905, 
        0.87539961774264841, 0.85695145463118794, 0.84765820294054006, 
        0.83078875074678737, 0.81516398765141318, 0.78137946707777417, 
        0.73636220499788829, 0.72091176135074009, 0.70457287484297237, 
        0.55727453908106184, 0.39678063378791067, 0.22969411976200046, 
        0.10245353876773804, 0.0018306320902652835, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \(\(-87.73834235845811`\)\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-89.89801154600923`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -89.898011546009229, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.05990524481294424`\), \(-0.008285850185575627`\), 
          0.0003039615968570847`, 0, 0, 0, \(-0.33021388175290617`\)}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.059905244812944243, -0.0082858501855756269, 
        0.0003039615968570847, 0, 0, 0, -0.33021388175290617}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{1.0599912059205963`*^-9, \(-1.57240664933056`*^-10\), \
\(-4.428157396318966`*^-9\), \(-3.287609073865383`*^-11\)}\),
      SequenceForm[ 
      "Gradient vector ", {
        1.0599912059205963*^-09, -1.57240664933056*^-10, \
-4.4281573963189658*^-09, -3.2876090738653829*^-11}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00017795291052650344`, 0.00001776031284173356`, 
            0.000033074000824360405`, 
            0.000021298039572009516`}, {0.000017760312841733556`, 
            0.0004286633458291928`, \(-0.000042651810816739645`\), 
            0.0031783470000552013`}, {0.000033074000824360405`, \
\(-0.000042651810816739645`\), 
            0.00010266473665913985`, \(-0.0011230774781168333`\)}, \
{0.00002129803957200946`, 0.003178347000055201`, \(-0.0011230774781168333`\), 
            0.15134379485827903`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00017795291052650344, 1.776031284173356*^-05, 
        3.3074000824360405*^-05, 2.1298039572009516*^-05}, {
        1.7760312841733556*^-05, 
        0.00042866334582919278, -4.2651810816739645*^-05, 
        0.0031783470000552013}, {
        3.3074000824360405*^-05, -4.2651810816739645*^-05, 
        0.00010266473665913985, -0.0011230774781168333}, {
        2.1298039572009459*^-05, 
        0.0031783470000552008, -0.0011230774781168333, 0.15134379485827903}}],
      
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013339899194765433`, 0.02070418667393609`, 
          0.010132360863053578`, 0.3890292982003785`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013339899194765433, 
        0.02070418667393609, 0.010132360863053578, 0.38902929820037851}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.983461208961119`, 
          0.9822618797895214`, 0.9598667962038505`, 0.9765639847031975`, 
          0.9757187611719793`, 0.9493216174368588`, 0.9725452679291864`, 
          0.9698731276572782`, 0.9664633561275201`, 0.9627322770732802`, 
          0.9564432013041199`, 0.9494379349823237`, 0.944007277430326`, 
          0.9421319301248012`, 0.9340222887670234`, 0.9249452892390088`, 
          0.9234726592693917`, 0.9142015239860805`, 0.9037230084876222`, 
          0.8998548757738934`, 0.8911092501503257`, 0.8767065762637191`, 
          0.8667721941163498`, 0.8513326025837515`, 0.8386138496157215`, 
          0.8122245604029646`, 0.7790454737773992`, 0.7670952271488009`, 
          0.7531696570599439`, 0.6098802358383268`, 0.4849055064794017`, 
          0.3483471989951946`, 0.205108958970181`, 0.013057306422905842`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.98346120896111899, 0.9822618797895214, 
        0.95986679620385051, 0.9765639847031975, 0.97571876117197931, 
        0.94932161743685883, 0.97254526792918639, 0.96987312765727818, 
        0.9664633561275201, 0.96273227707328024, 0.95644320130411986, 
        0.94943793498232365, 0.94400727743032598, 0.94213193012480123, 
        0.93402228876702342, 0.92494528923900876, 0.9234726592693917, 
        0.91420152398608046, 0.90372300848762221, 0.89985487577389345, 
        0.89110925015032572, 0.87670657626371906, 0.86677219411634976, 
        0.85133260258375154, 0.8386138496157215, 0.81222456040296465, 
        0.77904547377739919, 0.76709522714880085, 0.75316965705994388, 
        0.60988023583832685, 0.48490550647940173, 0.34834719899519462, 
        0.205108958970181, 0.013057306422905842, 9.9999999999999995*^-07}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \(\(-89.89801154600923`\)\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \("All Eigenvalues of the infoMatrix are negative => solution is a \
MAXIMUM"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) "\
\[InvisibleSpace]\(-88.24574705297411`\)\[InvisibleSpace]"    ObsLog\[Beta] \
at \[Beta]=0 "\[InvisibleSpace]\(-102.40056551567265`\)\),
      SequenceForm[ 
      "Max ObsLog\[Beta] (at \!\(\[Beta]\&^\)) ", -88.24574705297411, 
        "    ObsLog\[Beta] at \[Beta]=0 ", -102.40056551567265],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) \
"\[InvisibleSpace]{\(-0.06023629545302396`\), \(-0.004524192663519176`\), \
\(-0.003408557391424531`\), 0.8986048640742351`, 
          0.03223501560096165`, \(-0.4087740248426947`\), 0}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) ", {-0.060236295453023961, -0.004524192663519176, \
-0.0034085573914245308, 0.89860486407423512, 
        0.032235015600961647, -0.40877402484269471, 0}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("Gradient vector \
"\[InvisibleSpace]{1.3492851280716422`*^-10, \(-2.1084023416051423`*^-11\), \
\(-5.683626902452943`*^-10\), 
          1.6265322422270856`*^-12, \(-5.372091660404976`*^-12\), 
          1.4788448243763241`*^-12}\),
      SequenceForm[ 
      "Gradient vector ", {
        1.3492851280716422*^-10, -2.1084023416051423*^-11, \
-5.6836269024529429*^-10, 1.6265322422270856*^-12, -5.3720916604049762*^-12, 
        1.4788448243763241*^-12}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Variance Covariance matrix "\
\[InvisibleSpace]{{0.00018762590828202237`, 8.750551197695723`*^-6, 
            0.000029751559332708937`, 0.00033437048355920674`, 
            0.0011855473992414389`, 
            0.0005865363216926758`}, {8.750551197695723`*^-6, 
            0.000374283909502701`, \(-0.00001530363032074314`\), \
\(-0.0016270291626879361`\), \(-0.0006987091553805113`\), \
\(-0.0002603574095089451`\)}, {0.000029751559332708934`, \
\(-0.000015303630320743143`\), 
            0.00011986577729450546`, \(-0.00006164376894643163`\), \
\(-0.0016206933033345449`\), 
            0.0004252914489150651`}, {0.00033437048355920685`, \
\(-0.0016270291626879361`\), \(-0.0000616437689464316`\), 
            0.35905454894887423`, 0.1274078130050322`, 
            0.09728801515255235`}, {0.001185547399241439`, \
\(-0.0006987091553805112`\), \(-0.001620693303334545`\), 0.1274078130050322`, 
            0.25399736320388777`, 
            0.09830926017206341`}, {0.0005865363216926758`, \
\(-0.00026035740950894505`\), 0.0004252914489150648`, 0.09728801515255234`, 
            0.09830926017206341`, 0.22303072492599685`}}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Variance Covariance matrix ", {{
        0.00018762590828202237, 8.7505511976957228*^-06, 
        2.9751559332708937*^-05, 0.00033437048355920674, 
        0.0011855473992414389, 0.00058653632169267578}, {
        8.7505511976957228*^-06, 
        0.00037428390950270101, -1.5303630320743139*^-05, \
-0.0016270291626879361, -0.00069870915538051135, -0.00026035740950894511}, {
        2.9751559332708934*^-05, -1.5303630320743143*^-05, 
        0.00011986577729450546, -6.1643768946431627*^-05, \
-0.0016206933033345449, 0.00042529144891506512}, {
        0.00033437048355920685, -0.0016270291626879361, \
-6.16437689464316*^-05, 0.35905454894887423, 0.12740781300503221, 
        0.097288015152552351}, {
        0.0011855473992414391, -0.00069870915538051124, \
-0.0016206933033345451, 0.12740781300503221, 0.25399736320388777, 
        0.098309260172063415}, {
        0.00058653632169267578, -0.00026035740950894505, 
        0.00042529144891506479, 0.097288015152552337, 0.098309260172063415, 
        0.22303072492599685}}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\!\(\[Beta]\&^\) Standard Error vector "\
\[InvisibleSpace]{0.013697660686483017`, 0.019346418518751757`, 
          0.01094832303572129`, 0.5992116061533473`, 0.5039815107758298`, 
          0.47226128882854335`}\),
      SequenceForm[ 
      "\!\(\[Beta]\&^\) Standard Error vector ", {0.013697660686483017, 
        0.019346418518751757, 0.01094832303572129, 0.59921160615334734, 
        0.50398151077582976, 0.47226128882854335}],
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    InterpretationBox[\("\[Alpha] "\[InvisibleSpace]{0.988304174252566`, 
          0.9876924785368519`, 0.9703778549192447`, 0.9818879194770946`, 
          0.9813939610807656`, 0.9606604976044927`, 0.9785754340620546`, 
          0.9769265373937449`, 0.9731611474711558`, 0.967892713101855`, 
          0.9609928627756005`, 0.9535387001424149`, 0.9486053910118796`, 
          0.9467166179930807`, 0.9390933741340832`, 0.9303982427081804`, 
          0.929086668042045`, 0.9234687075685993`, 0.9159587649296497`, 
          0.9051447177709908`, 0.8900901096015721`, 0.87511621771553`, 
          0.8682078939796802`, 0.8550095978234526`, 0.8406504200338201`, 
          0.8117436429550566`, 0.7776261754521164`, 0.7666228601359376`, 
          0.7493555814305825`, 0.6014091722931213`, 0.4653996553922882`, 
          0.29759287325081984`, 0.16004892288200454`, 0.00904592584696796`, 
          1.`*^-6}\),
      SequenceForm[ 
      "\[Alpha] ", {0.988304174252566, 0.98769247853685194, 
        0.97037785491924466, 0.98188791947709464, 0.9813939610807656, 
        0.96066049760449268, 0.97857543406205461, 0.97692653739374491, 
        0.97316114747115579, 0.96789271310185498, 0.96099286277560048, 
        0.95353870014241493, 0.94860539101187957, 0.94671661799308071, 
        0.93909337413408323, 0.93039824270818039, 0.92908666804204498, 
        0.92346870756859933, 0.91595876492964967, 0.90514471777099081, 
        0.89009010960157209, 0.87511621771553005, 0.86820789397968023, 
        0.85500959782345265, 0.84065042003382007, 0.81174364295505663, 
        0.77762617545211643, 0.76662286013593761, 0.74935558143058245, 
        0.6014091722931213, 0.46539965539228823, 0.29759287325081984, 
        0.16004892288200454, 0.0090459258469679608, 9.9999999999999995*^-07}],
      
      Editable->False]], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False],

Cell[BoxData[
    \(\(-88.24574705297411`\)\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[BoxData[
    \(\(submodelData = 
        Map[{#\[LeftDoubleBracket]3\[RightDoubleBracket], #\
\[LeftDoubleBracket]1\[RightDoubleBracket], 
              2*\((maxLogL\[Beta] - #\[LeftDoubleBracket]1\
\[RightDoubleBracket])\), #\[LeftDoubleBracket]2\[RightDoubleBracket], 
              1 - CDF[ChiSquareDistribution[#\[LeftDoubleBracket]2\
\[RightDoubleBracket]], 
                  2*\((maxLogL\[Beta] - #\[LeftDoubleBracket]1\
\[RightDoubleBracket])\)]} &, {{ml\[Beta]x1, 1, "\<Perf\>"}, {ml\[Beta]x2, 
              1, "\<Age\>"}, {ml\[Beta]x3, 1, "\<Months\>"}, {ml\[Beta]x4, 
              3, "\<Tumor Type\>"}, {ml\[Beta]x5, 
              1, "\<Test type\>"}}];\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Table Of Submodels Tested for Variable Relevance", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(tableTitle = "\<Signifance Tests of Submodels\>";\)\), "\n", 
    \(\(\(tableColumnLabels = {"\<Deleted Variables \>", "\<log L\>", "\< \
\[CapitalLambda]  \>", "\<d.f.\>", "\< P >|z| \>"};\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(\(blankRow = 
        setshowTableOpts[Length[tableColumnLabels]];\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(\(showData = numberForm[submodelData];\)\), "\[IndentingNewLine]", 
    \(\(tableData = Join[{tableColumnLabels}, showData];\)\), "\n", 
    \(showTable[tableTitle, tableData, 
      ColumnSpacings \[Rule] {5, 4, 4, 3, 4}]\)}], "Input",
  ShowCellBracket->True,
  ShowSelection->True,
  ShowClosedCellArea->False],

Cell[BoxData[
    TagBox[GridBox[{
          {
            StyleBox[\(Signifance\ Tests\ of\ Submodels\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Deleted\)\(\ \)\(Variables\)\(\ \)\), \(log\ L\), \(\(\
\ \)\(\[CapitalLambda]\)\(\ \ \)\), \(d . 
                      f . \), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\
\ \)\)\)},
                  {"Perf", \(-97.69\), "19.907", "1.", \(\(<\)\(.001\)\)},
                  {"Age", \(-87.901\), "0.328", "1.", "0.567"},
                  {"Months", \(-87.738\), "0.003", "1.", "0.955"},
                  {\(Tumor\ Type\), \(-89.898\), "4.322", "3.", "0.229"},
                  {\(Test\ type\), \(-88.246\), "1.018", "1.", "0.313"}
                  },
                RowSpacings->3,
                ColumnSpacings->{5, 4, 4, 3, 4},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            StyleBox["",
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Output", "Subsubsection"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            StyleBox[\(Signifance\ Tests\ of\ Submodels\),
              FontSize->12,
              FontWeight->"Bold"]},
          {""},
          {
            StyleBox[GridBox[{
                  {\(\(Deleted\)\(\ \)\(Variables\)\(\ \)\), \(log\ L\), \(\(\
\ \)\(\[CapitalLambda]\)\(\ \ \)\), \(d . 
                      f . \), \(\(\ \)\(\(\(P\)\(\ \)\(>\)\)\(|\)\(z\)\(|\)\(\
\ \)\)\)},
                  {"Perf", \(-97.69\), "19.907", "1.", \(\(<\)\(.001\)\)},
                  {"Age", \(-87.901\), "0.328", "1.", "0.567"},
                  {"Months", \(-87.738\), "0.003", "1.", "0.955"},
                  {\(Tumor\ Type\), \(-89.898\), "4.322", "3.", "0.229"},
                  {\(Test\ type\), \(-88.246\), "1.018", "1.", "0.313"}
                  },
                RowSpacings->3,
                ColumnSpacings->{5, 4, 4, 3, 4},
                RowAlignments->Center,
                ColumnAlignments->{Center},
                RowLines->True],
              FontFamily->"Bell MT",
              FontSize->12]},
          {
            StyleBox["",
              FontFamily->"Bell MT",
              FontSize->12]}
          },
        ColumnAlignments->{Left}],
      DisplayForm]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Conclusions", "Section"],

Cell[TextData[{
  StyleBox["Mathematica",
    FontFamily->"Times New Roman",
    FontSlant->"Italic"],
  StyleBox[" is an excellent application program for solving \
distribution-free problems in survival analysis using the Proportional \
Hazards model with its flexible symbolic and numerical environment, and \
standard statistical toolset.   ",
    FontFamily->"Times New Roman"],
  StyleBox["Mathematica",
    FontFamily->"Times New Roman",
    FontSlant->"Italic"],
  StyleBox[" provides the means for getting data into a format that fits \
model assumptions and then constructs model variables dynamically.  This \
demonstration shows that continuous time survival data is easily handled with \
fast, accurate and robust calculations turned into presentation quality \
results. The tools used here can be quickly customized to fit the problem, \
not putting the burden on the practitioner to mold the problem into one that \
fits the tool.",
    FontFamily->"Times New Roman"]
}], "Text"],

Cell[CellGroupData[{

Cell["Acknowledgement", "Subsection"],

Cell["\<\
This work was supported by the U.S. Navy at Naval Undersea Warfare \
Center, Newport Division, Code 1516.\
\>", "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 941}},
AutoGeneratedPackage->None,
ScreenStyleEnvironment->"Presentation",
PrintingStyleEnvironment->"Printout",
WindowToolbars->{"RulerBar", "EditBar"},
WindowSize->{1040, 907},
WindowMargins->{{28, Automatic}, {Automatic, 36}},
PrintingCopies->1,
PrintingPageRange->{2, Automatic},
PrintingOptions->{"PrintingMargins"->{{54, 54}, {72, 72}},
"PrintCellBrackets"->False,
"PrintRegistrationMarks"->True,
"PrintMultipleHorizontalPages"->False},
ShowSelection->True,
Magnification->1,
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Wolfram Reseller Conference 2006", "Title"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of \
all cells in a given style.  Make modifications to any definition using \
commands in the Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    CellBracketOptions->{"Color"->RGBColor[0.269993, 0.308507, 0.6]},
    CellLabelMargins->{{12, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->12],
  
  Cell[StyleData[All, "SlideShow"],
    PageWidth->WindowWidth,
    ScrollingOptions->{"PagewiseDisplay"->True,
    "VerticalScrollRange"->Fit},
    ShowCellBracket->False,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    CellLabelMargins->{{2, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the \
Notebook level.\
\>", "Text"],
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    CellFrameLabelMargins->6,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellMargins->{{27, Inherited}, {10, 30}},
    CellGroupingRules->{"TitleGrouping", 0},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LineSpacing->{1, 11},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->36,
    FontWeight->"Bold",
    FontColor->RGBColor[0.894118, 0.435294, 0]],
  
  Cell[StyleData["Title", "Presentation"],
    CellMargins->{{72, 50}, {10, 80}},
    LineSpacing->{1, 0},
    FontSize->45],
  
  Cell[StyleData["Title", "SlideShow"],
    CellMargins->{{72, 50}, {10, 80}},
    FontSize->45],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{2, 10}, {12, 30}},
    FontSize->24]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{27, Inherited}, {20, 2}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->24],
  
  Cell[StyleData["Subtitle", "Presentation"],
    CellMargins->{{72, 50}, {20, 2}},
    LineSpacing->{1, 0},
    FontSize->30],
  
  Cell[StyleData["Subtitle", "SlideShow"],
    CellMargins->{{72, 50}, {30, 2}},
    FontSize->30],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{2, 10}, {12, 8}},
    FontSize->18]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    CellMargins->{{27, Inherited}, {8, 2}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->16],
  
  Cell[StyleData["Subsubtitle", "Presentation"],
    CellMargins->{{54, 10}, {20, 20}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Subsubtitle", "SlideShow"],
    CellMargins->{{72, 25}, {30, 10}}],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{2, 10}, {12, 8}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellMargins->{{27, Inherited}, {8, 34}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->4,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LineSpacing->{1, 2},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->20,
    FontWeight->"Bold",
    FontColor->RGBColor[0.847059, 0.192004, 0.182818]],
  
  Cell[StyleData["Section", "Presentation"],
    CellFrame->{{0, 0}, {0, 2}},
    ShowGroupOpenCloseIcon->True,
    CellMargins->{{72, 50}, {11, 30}},
    CellFrameColor->RGBColor[1, 0.796078, 0.501961],
    FontSize->30],
  
  Cell[StyleData["Section", "SlideShow"],
    CellMargins->{{71, 50}, {11, 35}},
    FontSize->30],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{2, 0}, {7, 22}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellMargins->{{60, Inherited}, {8, 12}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.858824, 0.411765, 0.364706]],
  
  Cell[StyleData["Subsection", "Presentation"],
    CellMargins->{{72, 50}, {6, 15}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Subsection", "SlideShow"],
    CellMargins->{{99, 50}, {8, 12}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{21, 0}, {8, 22}},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellMargins->{{60, Inherited}, {2, 12}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Subsubsection",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->RGBColor[0.929198, 0.518471, 0.354726]],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    CellMargins->{{72, 50}, {6, 20}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "SlideShow"],
    CellMargins->{{99, 50}, {6, 20}},
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{2, 0}, {7, 14}},
    FontSize->11]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Body Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{60, 10}, {7, 7}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    FontFamily->"Helvetica"],
  
  Cell[StyleData["Text", "Presentation"],
    CellMargins->{{72, 50}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->17],
  
  Cell[StyleData["Text", "SlideShow"],
    CellMargins->{{100, 50}, {10, 10}},
    FontSize->17],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->0.5,
    Hyphenation->True,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{60, 10}, {6, 6}},
    DefaultNewInlineCellStyle->"None",
    LineSpacing->{1, 3},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"SmallText",
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Presentation"],
    CellMargins->{{72, 50}, {8, 8}},
    LineSpacing->{1, 5},
    FontSize->10],
  
  Cell[StyleData["SmallText", "SlideShow"],
    CellMargins->{{100, 50}, {8, 8}},
    LineSpacing->{1, 5},
    FontSize->10],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    TextJustification->0.5,
    Hyphenation->True,
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). \
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    CellMargins->{{66, 10}, {5, 7}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Mathematica",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    FontWeight->"Bold"],
  
  Cell[StyleData["Input", "Presentation"],
    CellMargins->{{72, 50}, {8, 10}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Input", "SlideShow"],
    CellMargins->{{100, 50}, {8, 10}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Input", "Printout"],
    CellMargins->{{39, 0}, {4, 6}},
    LinebreakAdjustments->{0.85, 2, 10, 1, 1},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InputOnly"],
    CellMargins->{{66, 10}, {7, 7}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    DefaultFormatType->DefaultInputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Mathematica",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["InputOnly", "Presentation"],
    CellMargins->{{72, Inherited}, {8, 10}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["InputOnly", "SlideShow"],
    CellMargins->{{100, Inherited}, {8, 10}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["InputOnly", "Printout"],
    CellMargins->{{39, 0}, {4, 6}},
    LinebreakAdjustments->{0.85, 2, 10, 1, 1},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    CellMargins->{{66, 10}, {7, 5}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Output"],
  
  Cell[StyleData["Output", "Presentation"],
    CellMargins->{{72, 50}, {10, 8}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Output", "SlideShow"],
    CellMargins->{{100, 50}, {10, 8}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Output", "Printout"],
    CellMargins->{{39, 0}, {6, 4}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    CellMargins->{{66, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    AutoStyleOptions->{"UnmatchedBracketStyle"->None},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontColor->RGBColor[0, 0.376471, 0.490196]],
  
  Cell[StyleData["Message", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0},
    FontSize->14],
  
  Cell[StyleData["Message", "SlideShow"],
    CellMargins->{{100, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0},
    FontSize->14],
  
  Cell[StyleData["Message", "Printout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    CellMargins->{{66, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Print", "SlideShow"],
    CellMargins->{{100, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Print", "Printout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    CellMargins->{{4, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    LanguageCategory->None,
    FormatType->InputForm,
    CounterIncrements->"Graphics",
    ImageMargins->{{43, Inherited}, {Inherited, 0}},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->10],
  
  Cell[StyleData["Graphics", "Presentation"],
    ImageMargins->{{62, Inherited}, {Inherited, 0}}],
  
  Cell[StyleData["Graphics", "SlideShow"],
    ImageMargins->{{100, Inherited}, {Inherited, 0}}],
  
  Cell[StyleData["Graphics", "Printout"],
    ImageMargins->{{30, Inherited}, {Inherited, 0}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->RGBColor[0.24416, 0.602594, 0.809735]],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["CellLabel", "SlideShow"],
    FontSize->12],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic"]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FrameLabel"],
    LanguageCategory->None,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["FrameLabel", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["FrameLabel", "SlideShow"],
    FontSize->12],
  
  Cell[StyleData["FrameLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Presentation Specific", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BulletedList"],
    CellMargins->{{45, 10}, {7, 7}},
    CellFrameLabels->{{
      Cell[ "\[FilledSmallSquare]", "BulletedList", CellBaseline -> Baseline],
           Inherited}, {Inherited, Inherited}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    CounterIncrements->"BulletedList",
    FontFamily->"Helvetica"],
  
  Cell[StyleData["BulletedList", "Presentation"],
    CellMargins->{{56, 50}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->18],
  
  Cell[StyleData["BulletedList", "SlideShow"],
    CellMargins->{{85, 50}, {10, 10}},
    FontSize->18],
  
  Cell[StyleData["BulletedList", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->0.5,
    Hyphenation->True,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Author"],
    CellMargins->{{139, 27}, {2, 20}},
    FontFamily->"Times",
    FontSize->24,
    FontSlant->"Italic"],
  
  Cell[StyleData["Author", "Presentation"],
    CellMargins->{{198, 27}, {2, 25}},
    FontSize->32],
  
  Cell[StyleData["Author", "SlideShow"],
    CellMargins->{{198, 27}, {2, 50}},
    FontSize->32],
  
  Cell[StyleData["Author", "Printout"],
    CellMargins->{{100, 27}, {2, 20}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Affiliation"],
    CellMargins->{{141, 27}, {30, 12}},
    FontFamily->"Times",
    FontSize->24,
    FontSlant->"Italic"],
  
  Cell[StyleData["Affiliation", "Presentation"],
    CellMargins->{{198, 27}, {35, 10}},
    FontSize->32],
  
  Cell[StyleData["Affiliation", "SlideShow"],
    CellMargins->{{198, 27}, {100, 10}},
    FontSize->32],
  
  Cell[StyleData["Affiliation", "Printout"],
    CellMargins->{{100, 27}, {2, 12}},
    FontSize->14]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Header Graphic", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ConferenceGraphicCell"],
    ShowCellBracket->True,
    CellMargins->{{0, 0}, {0, 0}},
    Evaluatable->False,
    PageBreakBelow->False,
    ImageMargins->{{0, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    Background->GrayLevel[1],
    Magnification->1],
  
  Cell[StyleData["ConferenceGraphicCell", "Presentation"],
    ShowCellBracket->False],
  
  Cell[StyleData["ConferenceGraphicCell", "SlideShow"],
    ShowCellBracket->False],
  
  Cell[StyleData["ConferenceGraphicCell", "Printout"],
    FontSize->8,
    Magnification->0.75]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GraphicNoMagnification"],
    CellMargins->{{60, 10}, {7, 7}},
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    FontFamily->"Helvetica",
    Magnification->1],
  
  Cell[StyleData["GraphicNoMagnification", "Presentation"],
    CellMargins->{{72, 50}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->17],
  
  Cell[StyleData["GraphicNoMagnification", "SlideShow"],
    CellMargins->{{100, 50}, {10, 10}},
    FontSize->17],
  
  Cell[StyleData["GraphicNoMagnification", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Formatting", "Section"],
  
  Cell["\<\
These styles are for modifying individual words or letters in a \
cell exclusive of the cell tag.\
\>", "Text"],
  
  Cell[StyleData["RM"],
    StyleMenuListing->None,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["BF"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["IT"],
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["TR"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["TI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["TB"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["TBI"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["MR"],
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MO"],
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["MB"],
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["MBO"],
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SR"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SB"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBO"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SO10"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SO10", "Printout"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->7,
    FontWeight->"Plain",
    FontSlant->"Italic"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineFormula"],
    CellMargins->{{10, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->1,
    SingleLetterItalics->True,
    StyleMenuListing->None],
  
  Cell[StyleData["InlineFormula", "Presentation"],
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["InlineFormula", "SlideShow"],
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["InlineFormula", "Printout"],
    CellMargins->{{2, 0}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{60, Inherited}, {Inherited, Inherited}},
    CellHorizontalScrolling->True,
    DefaultFormatType->DefaultInputFormatType,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Formula",
    ScriptLevel->0,
    SingleLetterItalics->True,
    UnderoverscriptBoxOptions->{LimitsPositioning->True}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["DisplayFormula", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["DisplayFormula", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellFrame->{{0, 0}, {0.5, 0.5}},
    CellMargins->{{60, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    Hyphenation->False,
    LanguageCategory->"Formula",
    ScriptLevel->1,
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    CellMargins->{{72, 50}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["Program", "SlideShow"],
    CellMargins->{{100, 50}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->16],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{2, 0}, {6, 6}},
    FontSize->9]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlink Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0.376471, 0.490196],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None",
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["Hyperlink", "SlideShow"]],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontSize->10,
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell["\<\
The following styles are for linking automatically to the on-line \
help system.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["MainBookLink", "SlideShow"]],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["AddOnsLink", "SlideShow"]],
  
  Cell[StyleData["AddOnsLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["RefGuideLink", "SlideShow"]],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLinkText"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLinkText", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["RefGuideLinkText", "SlideShow"]],
  
  Cell[StyleData["RefGuideLinkText", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["GettingStartedLink", "SlideShow"]],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DemosLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Demos", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["DemosLink", "SlideShow"]],
  
  Cell[StyleData["DemosLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TourLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Tour", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["TourLink", "SlideShow"]],
  
  Cell[StyleData["TourLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Presentation"],
    FontSize->16],
  
  Cell[StyleData["OtherInformationLink", "SlideShow"]],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MasterIndexLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0.269993, 0.308507, 0.6],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MasterIndex", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MasterIndexLink", "SlideShow"]],
  
  Cell[StyleData["MasterIndexLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headers and Footers", "Section"],
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {4, 1}},
    DefaultNewInlineCellStyle->"None",
    LanguageCategory->"NaturalLanguage",
    StyleMenuListing->None,
    FontSize->10,
    FontSlant->"Italic"],
  
  Cell[StyleData["Footer"],
    CellMargins->{{0, 0}, {0, 4}},
    DefaultNewInlineCellStyle->"None",
    LanguageCategory->"NaturalLanguage",
    StyleMenuListing->None,
    FontSize->9,
    FontSlant->"Italic"],
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Palette Styles", "Section"],
  
  Cell["\<\
The cells below define styles that define standard \
ButtonFunctions, for use in palette buttons.\
\>", "Text"],
  
  Cell[StyleData["Paste"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, Placeholder]}]&)}],
  
  Cell[StyleData["Evaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["EvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionMove[ 
          FrontEnd`InputNotebook[ ], All, Cell, 1], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluate"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluate[ 
          FrontEnd`InputNotebook[ ], All]}]&)}],
  
  Cell[StyleData["CopyEvaluateCell"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`SelectionCreateCell[ 
          FrontEnd`InputNotebook[ ], All], 
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, All], 
        FrontEnd`SelectionEvaluateCreateCell[ 
          FrontEnd`InputNotebook[ ], All]}]&)}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Placeholder Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making placeholder \
objects in palette templates.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Placeholder"],
    Placeholder->True,
    StyleMenuListing->None,
    FontSlant->"Italic",
    FontColor->RGBColor[0.951324, 0.721569, 0.178317],
    TagBoxOptions->{Editable->False,
    Selectable->False,
    StripWrapperBoxes->False}],
  
  Cell[StyleData["Placeholder", "Presentation"]],
  
  Cell[StyleData["Placeholder", "SlideShow"]],
  
  Cell[StyleData["Placeholder", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PrimaryPlaceholder"],
    StyleMenuListing->None,
    DrawHighlighted->True,
    FontSlant->"Italic",
    Background->RGBColor[0.984314, 0.871046, 0.349798],
    TagBoxOptions->{Editable->False,
    Selectable->False,
    StripWrapperBoxes->False}],
  
  Cell[StyleData["PrimaryPlaceholder", "Presentation"]],
  
  Cell[StyleData["PrimaryPlaceholder", "SlideShow"]],
  
  Cell[StyleData["PrimaryPlaceholder", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["FormatType Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are mixed in with the styles \
of most cells.  If a cell's FormatType matches the name of one of the styles \
defined below, then that style is applied between the cell's style and its \
own options. This is particularly true of Input and Output.\
\>", "Text"],
  
  Cell[StyleData["CellExpression"],
    PageWidth->Infinity,
    CellMargins->{{6, Inherited}, {Inherited, Inherited}},
    ShowCellLabel->False,
    ShowSpecialCharacters->False,
    AllowInlineCells->False,
    Hyphenation->False,
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    Background->GrayLevel[1]],
  
  Cell[StyleData["InputForm"],
    InputAutoReplacements->{},
    AllowInlineCells->False,
    Hyphenation->False,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["OutputForm"],
    PageWidth->Infinity,
    TextAlignment->Left,
    LineSpacing->{0.6, 1},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["StandardForm"],
    InputAutoReplacements->{
      "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
        ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
        Inherited},
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    LineSpacing->{1.25, 0},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["TraditionalForm"],
    InputAutoReplacements->{
      "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
        ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
        Inherited},
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    LineSpacing->{1.25, 0},
    SingleLetterItalics->True,
    TraditionalFunctionNotation->True,
    DelimiterMatching->None,
    StyleMenuListing->None],
  
  Cell["\<\
The style defined below is mixed in to any cell that is in an \
inline cell within another.\
\>", "Text"],
  
  Cell[StyleData["InlineCell"],
    LanguageCategory->"Formula",
    ScriptLevel->1,
    StyleMenuListing->None],
  
  Cell[StyleData["InlineCellEditing"],
    StyleMenuListing->None,
    Background->RGBColor[0.984314, 0.916869, 0.563256]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Automatic Styles", "Section"],
  
  Cell["\<\
The cells below define styles that are used to affect the display \
of certain types of objects in typeset expressions.  For example, \
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and \
parenthesis characters are displayed (typically by coloring them to make them \
stand out).\
\>", "Text"],
  
  Cell[StyleData["UnmatchedBracket"],
    StyleMenuListing->None,
    FontColor->RGBColor[0.52549, 0.737255, 0.882353]],
  
  Cell[StyleData["Completions"],
    StyleMenuListing->None,
    FontFamily->"Courier"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles from HelpBrowser", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MathCaption"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{66, 12}, {2, 24}},
    PageBreakBelow->False,
    CellFrameMargins->{{8, 8}, {8, 2}},
    CellFrameColor->GrayLevel[0.700008],
    CellFrameLabelMargins->4,
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontColor->GrayLevel[0.2]],
  
  Cell[StyleData["MathCaption", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["MathCaption", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["MathCaption", "Printout"],
    CellMargins->{{39, 0}, {0, 14}},
    Hyphenation->True,
    FontSize->9,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ObjectName"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["ObjectName", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["ObjectName", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["ObjectName", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Usage"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Usage", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["Usage", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["Usage", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Notes"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Notes", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["Notes", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["Notes", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InlineOutput"],
    ShowCellBracket->True,
    CellMargins->{{66, 4}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelAutoDelete->False,
    CellLabelMargins->{{14, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    ShowSpecialCharacters->Automatic,
    "TwoByteSyntaxCharacterAutoReplacement"->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    LanguageCategory->"Mathematica",
    FormatType->StandardForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["InlineOutput", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["InlineOutput", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["InlineOutput", "Printout"],
    ShowCellBracket->False,
    CellMargins->{{39, 0}, {6, 6}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Emphasis Boxes and Pictures", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Box"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["Box", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["Box", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["Box", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DoubleBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->2,
    RowAlignments->Top}],
  
  Cell[StyleData["DoubleBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["DoubleBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["DoubleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["1ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["1ColumnBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["1ColumnBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["1ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    SingleLetterItalics->False,
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.31, 0.67}}],
  
  Cell[StyleData["2ColumnBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["2ColumnBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["2ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.46}],
  
  Cell[StyleData["2ColumnEvenBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["2ColumnEvenBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["2ColumnEvenBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnSmallBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1.5,
    ColumnWidths->0.35,
    ColumnAlignments->{Right, Left}}],
  
  Cell[StyleData["2ColumnSmallBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["2ColumnSmallBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["2ColumnSmallBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.32}],
  
  Cell[StyleData["3ColumnBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["3ColumnBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["3ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnSmallBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnSpacings->1.5,
    ColumnWidths->0.24,
    ColumnAlignments->{Right, Center, Left}}],
  
  Cell[StyleData["3ColumnSmallBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["3ColumnSmallBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["3ColumnSmallBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["4ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    SingleLetterItalics->False,
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.13, 0.35, 0.13, 0.35}}],
  
  Cell[StyleData["4ColumnBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["4ColumnBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["4ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["5ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->0.202}],
  
  Cell[StyleData["5ColumnBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["5ColumnBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["5ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["6ColumnBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxFrame->0.5,
    BoxMargins->True},
    GridBoxOptions->{ColumnWidths->{0.12, 0.22, 0.12, 0.12, 0.22, 0.12}}],
  
  Cell[StyleData["6ColumnBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["6ColumnBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["6ColumnBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FramedBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["FramedBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["FramedBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["FramedBox", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.4, 0.6},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["DefinitionBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["DefinitionBox", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox3Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.35, 0.2, 0.45},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox3Col", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["DefinitionBox3Col", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["DefinitionBox3Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox4Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.15, 0.35, 0.15, 0.35},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox4Col", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["DefinitionBox4Col", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["DefinitionBox4Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox5Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->0.2,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox5Col", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["DefinitionBox5Col", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["DefinitionBox5Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DefinitionBox6Col"],
    CellFrame->0.5,
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.13, 0.24, 0.13, 0.13, 0.24, 0.13},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["DefinitionBox6Col", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["DefinitionBox6Col", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["DefinitionBox6Col", "Printout"],
    CellMargins->{{2, 4}, {0, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 12}, {0, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["TopBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["TopBox", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["MiddleBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["MiddleBox", "Printout"],
    CellMargins->{{2, 0}, {0, 2}},
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["BottomBox"],
    CellFrame->{{0.5, 0.5}, {0.5, 0}},
    CellMargins->{{27, 12}, {0, -7}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.31, 0.62},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["BottomBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["BottomBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["BottomBox", "Printout"],
    CellMargins->{{2, 0}, {0, -5}},
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->2.2}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TopSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0.5}},
    CellMargins->{{27, 12}, {-2, 8}},
    CellHorizontalScrolling->True,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TopSpanBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["TopSpanBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["TopSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-2, 8}},
    FontSize->10,
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MiddleSpanBox"],
    CellFrame->{{0.5, 0.5}, {0, 0}},
    CellMargins->{{27, 12}, {0, 0}},
    CellHorizontalScrolling->True,
    PageBreakAbove->False,
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    AutoIndent->False,
    AutoSpacing->False,
    LineIndent->0,
    StyleMenuListing->None,
    FontWeight->"Plain",
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    GridBoxOptions->{RowSpacings->1.5,
    ColumnSpacings->1,
    ColumnWidths->{0.9, 0.03},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["MiddleSpanBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["MiddleSpanBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["MiddleSpanBox", "Printout"],
    CellMargins->{{2, 0}, {-5, 0}},
    FontSize->10,
    Background->GrayLevel[1],
    GridBoxOptions->{RowMinHeight->1.8}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Picture"],
    CellMargins->{{27, Inherited}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["Picture", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["Picture", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["Picture", "Printout"],
    CellMargins->{{2, Inherited}, {4, 4}},
    Magnification->0.65]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OpenCloseItemizedPicture"],
    CellMargins->{{88, 4}, {4, 4}},
    PrivateCellOptions->{"DefaultCellGroupOpen"->False},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["OpenCloseItemizedPicture", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["OpenCloseItemizedPicture", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["OpenCloseItemizedPicture", "Printout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ItemizedPicture"],
    CellMargins->{{88, 4}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ItemizedPicture", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["ItemizedPicture", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["ItemizedPicture", "Printout"],
    CellMargins->{{77, 2}, {4, -4}},
    Magnification->0.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListGraphic"],
    CellMargins->{{88, 4}, {4, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["ListGraphic", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["ListGraphic", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["ListGraphic", "Printout"],
    CellMargins->{{77, 2}, {4, -4}},
    Magnification->0.5]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ListNoteBox"],
    CellFrame->0.5,
    CellMargins->{{88, 12}, {8, 8}},
    CellHorizontalScrolling->True,
    CellFrameColor->RGBColor[0.74902, 0.694118, 0.552941],
    LineIndent->0,
    StyleMenuListing->None,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FrameBoxOptions->{BoxMargins->{{1, 1}, {1.5, 1.5}}},
    GridBoxOptions->{ColumnSpacings->1}],
  
  Cell[StyleData["ListNoteBox", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["ListNoteBox", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["ListNoteBox", "Printout"],
    CellMargins->{{77, 4}, {6, 2}},
    FontSize->10,
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureGroup"],
    CellMargins->{{41, 4}, {0, 4}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    StyleMenuListing->None],
  
  Cell[StyleData["PictureGroup", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["PictureGroup", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["PictureGroup", "Printout"],
    CellMargins->{{76, 2}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->1,
    "ClosedCellHeight"->0},
    CellOpen->False]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Sound"],
    ShowCellBracket->True,
    CellMargins->{{27, Inherited}, {0, 8}},
    StyleMenuListing->None],
  
  Cell[StyleData["Sound", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["Sound", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["Sound", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Tables", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->{0.34, 0.64},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["2ColumnTable", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["2ColumnTable", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["2ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["2ColumnEvenTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.49,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["2ColumnEvenTable", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["2ColumnEvenTable", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["2ColumnEvenTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["3ColumnTable"],
    CellMargins->{{35, 4}, {0, 8}},
    CellHorizontalScrolling->True,
    LineIndent->0,
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->{0.28, 0.28, 0.43},
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["3ColumnTable", "Presentation"],
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontSize->18],
  
  Cell[StyleData["3ColumnTable", "SlideShow"],
    CellMargins->{{100, 50}, {Inherited, Inherited}}],
  
  Cell[StyleData["3ColumnTable", "Printout"],
    CellMargins->{{2, 0}, {0, 8}},
    FontSize->9]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Slide Show Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowNavigationBar"],
    CellFrame->True,
    CellMargins->{{0, 0}, {3, 50}},
    CellElementSpacings->{"CellMinHeight"->0.8125},
    CellGroupingRules->{"SectionGrouping", 0},
    CellFrameMargins->False,
    CellFrameColor->GrayLevel[1],
    CellFrameLabelMargins->False,
    CounterIncrements->"SlideShowNavigationBar",
    StyleMenuListing->None,
    FontSize->10,
    Background->GrayLevel[1],
    Magnification->1,
    GridBoxOptions->{GridBaseline->Center,
    RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->{3.5, 3.5, 3.5, 3.5, 40, 5, 4},
    RowAlignments->Baseline,
    ColumnAlignments->{
      Center, Center, Center, Center, Center, Center, Right, Center}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Presentation"],
    FontSize->10,
    Magnification->1],
  
  Cell[StyleData["SlideShowNavigationBar", "SlideShow"],
    Deletable->False,
    ShowCellBracket->False,
    CellMargins->{{-1, -1}, {-1, -1}},
    PageBreakAbove->True,
    CellFrameMargins->{{1, 1}, {0, 0}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Printout"],
    CellOpen->False,
    FontSize->1]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowSection"],
    CellFrame->{{0, 0}, {0, 0.5}},
    CellMargins->{{0, 0}, {10, 0}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CellFrameMargins->{{12, 4}, {6, 12}},
    InputAutoReplacements->{"TeX"->StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "LaTeX"->StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.36, -0.1}, {0, 0}}, 
                  BoxBaselineShift -> -0.2], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.075, -0.085}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}]], "mma"->"Mathematica", "Mma"->"Mathematica", 
        "MMA"->"Mathematica", "gridMathematica"->FormBox[ 
            RowBox[ {"grid", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], 
        "webMathematica"->FormBox[ 
            RowBox[ {"web", 
              AdjustmentBox[ 
                StyleBox[ "Mathematica", FontSlant -> "Italic"], 
                BoxMargins -> {{-0.175, 0}, {0, 0}}]}], TextForm], Inherited},
    
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->24,
    FontWeight->"Plain",
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.8, 0.396078]],
  
  Cell[StyleData["SlideShowSection", "Presentation"],
    CellFrameMargins->{{20, 10}, {10, 18}},
    FontSize->27],
  
  Cell[StyleData["SlideShowSection", "SlideShow"],
    ShowCellBracket->False,
    PageBreakAbove->True],
  
  Cell[StyleData["SlideShowSection", "Printout"],
    CellMargins->{{18, 30}, {0, 30}},
    CellFrameMargins->5,
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideHyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontSize->26,
    FontColor->GrayLevel[0.400015],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMinHeight->0.85,
    ButtonMargins->0.5,
    ButtonNote->None}],
  
  Cell[StyleData["SlideHyperlink", "Presentation"],
    CellMargins->{{14, 10}, {6, 12}}],
  
  Cell[StyleData["SlideHyperlink", "SlideShow"]],
  
  Cell[StyleData["SlideHyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlidePreviousNextLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Helvetica",
    FontSize->16,
    FontColor->GrayLevel[0.500008],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMinHeight->0.85,
    ButtonMargins->0.5,
    ButtonNote->None}],
  
  Cell[StyleData["SlidePreviousNextLink", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["SlidePreviousNextLink", "SlideShow"]],
  
  Cell[StyleData["SlidePreviousNextLink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PreviousNext"],
    CellMargins->{{60, 10}, {7, 7}},
    TextAlignment->0.75,
    LineSpacing->{1, 3},
    CounterIncrements->"PreviousNext",
    FontFamily->"Helvetica",
    FontSize->14,
    FontColor->GrayLevel[0.500008]],
  
  Cell[StyleData["PreviousNext", "Presentation"],
    CellMargins->{{24, 50}, {10, 10}},
    LineSpacing->{1, 5},
    FontSize->12],
  
  Cell[StyleData["PreviousNext", "SlideShow"],
    CellMargins->{{50, 50}, {50, 15}},
    FontSize->14],
  
  Cell[StyleData["PreviousNext", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->0.5,
    Hyphenation->True,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOCLink"],
    CellMargins->{{24, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Helvetica",
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMargins->1.5,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["SlideTOCLink", "Presentation"],
    CellMargins->{{35, 10}, {8, 8}},
    FontSize->18],
  
  Cell[StyleData["SlideTOCLink", "SlideShow"]],
  
  Cell[StyleData["SlideTOCLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideTOC"],
    CellDingbat->"\[Bullet]",
    CellMargins->{{18, Inherited}, {Inherited, Inherited}},
    StyleMenuListing->None,
    FontFamily->"Helvetica"],
  
  Cell[StyleData["SlideTOC", "Presentation"],
    CellMargins->{{25, 10}, {10, 5}},
    FontSize->18],
  
  Cell[StyleData["SlideTOC", "SlideShow"],
    FontSize->14],
  
  Cell[StyleData["SlideTOC", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Data Routines"->{
    Cell[486655, 6455, 204, 3, 61, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[486862, 6460, 144, 2, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[487009, 6464, 382, 8, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[487394, 6474, 921, 25, 53, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[488318, 6501, 754, 14, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[489109, 6520, 166, 3, 38, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[489278, 6525, 5141, 139, 243, "Output",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[590700, 9200, 206, 3, 61, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[590909, 9205, 125, 2, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[591037, 9209, 347, 7, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[591387, 9218, 617, 17, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[592007, 9237, 621, 13, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[592665, 9255, 121, 2, 38, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[592789, 9259, 677, 19, 243, "Output",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926018, 18600, 208, 3, 61, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926229, 18605, 186, 3, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926418, 18610, 414, 8, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926835, 18620, 911, 27, 53, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[927749, 18649, 989, 19, 53, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[929099, 18687, 121, 2, 38, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[929223, 18691, 1196, 27, 243, "Output",
      CellTags->{"Data Routines", "close Data Routines"}]},
  "close Data Routines"->{
    Cell[486655, 6455, 204, 3, 61, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[486862, 6460, 144, 2, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[487009, 6464, 382, 8, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[487394, 6474, 921, 25, 53, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[488318, 6501, 754, 14, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[489109, 6520, 166, 3, 38, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[489278, 6525, 5141, 139, 243, "Output",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[590700, 9200, 206, 3, 61, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[590909, 9205, 125, 2, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[591037, 9209, 347, 7, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[591387, 9218, 617, 17, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[592007, 9237, 621, 13, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[592665, 9255, 121, 2, 38, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[592789, 9259, 677, 19, 243, "Output",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926018, 18600, 208, 3, 61, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926229, 18605, 186, 3, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926418, 18610, 414, 8, 29, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[926835, 18620, 911, 27, 53, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[927749, 18649, 989, 19, 53, "Print",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[929099, 18687, 121, 2, 38, "Input",
      CellTags->{"Data Routines", "close Data Routines"}],
    Cell[929223, 18691, 1196, 27, 243, "Output",
      CellTags->{"Data Routines", "close Data Routines"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Data Routines", 1164843, 25077},
  {"close Data Routines", 1167059, 25120}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 451296, 5575, 169, 451181, 5571, "GraphicsData", "Bitmap", \
"Graphics",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[453075, 5630, 104, 3, 249, "Title"],
Cell[453182, 5635, 31, 0, 66, "Author"],
Cell[453216, 5637, 80, 3, 123, "Affiliation"],

Cell[CellGroupData[{
Cell[453321, 5644, 31, 0, 84, "Section"],
Cell[453355, 5646, 131, 3, 47, "BulletedList"],
Cell[453489, 5651, 96, 3, 47, "BulletedList"],
Cell[453588, 5656, 113, 3, 47, "BulletedList"],
Cell[453704, 5661, 397, 11, 121, "BulletedList"],
Cell[454104, 5674, 218, 8, 47, "BulletedList"],
Cell[454325, 5684, 1263, 25, 199, "Text"],
Cell[455591, 5711, 964, 13, 170, "Text"],
Cell[456558, 5726, 452, 6, 95, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[457047, 5737, 68, 1, 64, "Section",
  InitializationCell->True],
Cell[457118, 5740, 45, 0, 30, "BulletedList"],
Cell[457166, 5742, 344, 7, 84, "BulletedList"],

Cell[CellGroupData[{
Cell[457535, 5753, 33, 0, 47, "Subsubsection"],
Cell[457571, 5755, 102, 2, 38, "Input",
  InitializationCell->True],
Cell[457676, 5759, 223, 4, 84, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[457936, 5768, 73, 1, 31, "Subsubsection",
  InitializationCell->True],
Cell[458012, 5771, 266, 5, 84, "Input",
  InitializationCell->True],
Cell[458281, 5778, 212, 5, 61, "Input",
  InitializationCell->True],
Cell[458496, 5785, 469, 8, 153, "Input",
  InitializationCell->True],
Cell[458968, 5795, 435, 9, 130, "Input",
  InitializationCell->True],
Cell[459406, 5806, 236, 5, 61, "Input",
  InitializationCell->True],
Cell[459645, 5813, 641, 12, 176, "Input",
  InitializationCell->True],
Cell[460289, 5827, 174, 4, 61, "Input",
  InitializationCell->True],
Cell[460466, 5833, 231, 5, 61, "Input",
  InitializationCell->True],
Cell[460700, 5840, 1712, 31, 475, "Input",
  InitializationCell->True],
Cell[462415, 5873, 503, 10, 153, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[462955, 5888, 152, 4, 68, "Subsection",
  InitializationCell->True],
Cell[463110, 5894, 362, 5, 89, "Text"],
Cell[463475, 5901, 502, 18, 43, "Text"],

Cell[CellGroupData[{
Cell[464002, 5923, 78, 1, 47, "Subsubsection",
  InitializationCell->True],
Cell[464083, 5926, 200, 6, 43, "Text",
  InitializationCell->True],
Cell[464286, 5934, 259, 5, 84, "Input",
  InitializationCell->True],
Cell[464548, 5941, 593, 13, 176, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[465178, 5959, 63, 1, 47, "Subsubsection",
  InitializationCell->True],
Cell[465244, 5962, 1091, 19, 383, "Input",
  InitializationCell->True],
Cell[466338, 5983, 213, 5, 66, "Text",
  InitializationCell->True],
Cell[466554, 5990, 162, 4, 38, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[466753, 5999, 101, 1, 47, "Subsubsection",
  InitializationCell->True],
Cell[466857, 6002, 143, 3, 38, "Input",
  InitializationCell->True],
Cell[467003, 6007, 141, 3, 38, "Input",
  InitializationCell->True],
Cell[467147, 6012, 1040, 15, 360, "Input",
  InitializationCell->True],
Cell[468190, 6029, 163, 3, 38, "Input",
  InitializationCell->True],
Cell[468356, 6034, 3940, 70, 1165, "Input",
  InitializationCell->True],
Cell[472299, 6106, 264, 5, 61, "Input",
  InitializationCell->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[472612, 6117, 96, 3, 39, "Subsection"],
Cell[472711, 6122, 116, 3, 47, "BulletedList"],
Cell[472830, 6127, 2194, 57, 308, "Text"],
Cell[475027, 6186, 1477, 30, 327, "Text"],
Cell[476507, 6218, 95, 3, 47, "BulletedList"],
Cell[476605, 6223, 1775, 43, 264, "Text"],
Cell[478383, 6268, 199, 5, 67, "Text"],

Cell[CellGroupData[{
Cell[478607, 6277, 121, 3, 47, "Subsubsection"],
Cell[478731, 6282, 6454, 119, 1762, "Input",
  InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[485246, 6408, 36, 0, 79, "Section"],
Cell[485285, 6410, 669, 16, 95, "Text"],
Cell[485957, 6428, 28, 0, 43, "Text"],
Cell[485988, 6430, 85, 1, 47, "BulletedList"],
Cell[486076, 6433, 79, 0, 47, "BulletedList"],
Cell[486158, 6435, 136, 3, 47, "BulletedList"],

Cell[CellGroupData[{
Cell[486319, 6442, 52, 0, 50, "Subsection"],
Cell[486374, 6444, 97, 2, 43, "GraphicNoMagnification"],
Cell[486474, 6448, 156, 3, 23, "Input",
  CellOpen->False],

Cell[CellGroupData[{
Cell[486655, 6455, 204, 3, 61, "Input",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[486862, 6460, 144, 2, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[487009, 6464, 382, 8, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[487394, 6474, 921, 25, 53, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[488318, 6501, 754, 14, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[489109, 6520, 166, 3, 38, "Input",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[489278, 6525, 5141, 139, 243, "Output",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],
Cell[494434, 6667, 66, 1, 38, "Input"],
Cell[494503, 6670, 120, 2, 61, "Input"],
Cell[494626, 6674, 164, 4, 66, "Text"],
Cell[494793, 6680, 97, 2, 43, "GraphicNoMagnification"],
Cell[494893, 6684, 547, 12, 25, "Text",
  CellOpen->False],

Cell[CellGroupData[{
Cell[495465, 6700, 42, 1, 38, "Input"],
Cell[495510, 6703, 91, 1, 39, "Output"]
}, Open  ]],
Cell[495616, 6707, 118, 2, 38, "Input"],

Cell[CellGroupData[{
Cell[495759, 6713, 294, 6, 153, "Input"],
Cell[496056, 6721, 90, 1, 39, "Output"],
Cell[496149, 6724, 64, 1, 39, "Output"],
Cell[496216, 6727, 120, 2, 39, "Output"]
}, Open  ]],
Cell[496351, 6732, 97, 2, 43, "GraphicNoMagnification"]
}, Open  ]],

Cell[CellGroupData[{
Cell[496485, 6739, 423, 7, 26, "Subsection",
  CellOpen->False],

Cell[CellGroupData[{
Cell[496933, 6750, 284, 7, 84, "Input"],
Cell[497220, 6759, 40, 1, 39, "Output"],
Cell[497263, 6762, 36, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[497336, 6768, 76, 1, 38, "Input"],
Cell[497415, 6771, 254, 4, 63, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[497706, 6780, 1829, 33, 498, "Input"],
Cell[499538, 6815, 67, 1, 39, "Output"],
Cell[499608, 6818, 76, 1, 39, "Output"],
Cell[499687, 6821, 205, 4, 29, "Print"],
Cell[499895, 6827, 236, 4, 29, "Print"],
Cell[500134, 6833, 51, 1, 29, "Print"],
Cell[500188, 6836, 56, 1, 29, "Print"],
Cell[500247, 6839, 203, 4, 29, "Print"],
Cell[500453, 6845, 344, 7, 29, "Print"],
Cell[500800, 6854, 1210, 27, 243, "Output"],
Cell[502013, 6883, 41, 1, 39, "Output"]
}, Open  ]],
Cell[502069, 6887, 97, 2, 43, "GraphicNoMagnification"],
Cell[502169, 6891, 423, 9, 23, "Input",
  CellOpen->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[502629, 6905, 97, 3, 50, "Subsection"],

Cell[CellGroupData[{
Cell[502751, 6912, 104, 1, 48, "Subsubsection"],
Cell[502858, 6915, 97, 2, 43, "GraphicNoMagnification"],

Cell[CellGroupData[{
Cell[502980, 6921, 839, 20, 23, "Input",
  CellOpen->False],
Cell[503822, 6943, 16395, 422, 186, 3813, 262, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[520266, 7371, 44, 0, 47, "Subsubsection"],

Cell[CellGroupData[{
Cell[520335, 7375, 184, 3, 61, "Input"],
Cell[520522, 7380, 108, 2, 29, "Print"],
Cell[520633, 7384, 411, 7, 31, "Print"],
Cell[521047, 7393, 323, 7, 31, "Print"],
Cell[521373, 7402, 335, 7, 30, "Print"],
Cell[521711, 7411, 758, 15, 55, "Print"],
Cell[522472, 7428, 359, 7, 31, "Print"],
Cell[522834, 7437, 1459, 22, 101, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[524330, 7464, 45, 1, 38, "Input"],
Cell[524378, 7467, 16377, 422, 186, 3815, 262, "GraphicsData", "PostScript", \
"Graphics"],
Cell[540758, 7891, 130, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[540925, 7899, 48, 1, 38, "Input"],
Cell[540976, 7902, 15157, 402, 186, 3629, 255, "GraphicsData", "PostScript", \
"Graphics"],
Cell[556136, 8306, 130, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[556303, 8314, 116, 2, 65, "Input"],
Cell[556422, 8318, 113, 2, 39, "Output"],
Cell[556538, 8322, 107, 2, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[556682, 8329, 80, 1, 42, "Input"],
Cell[556765, 8332, 108, 2, 39, "Output"]
}, Open  ]],
Cell[556888, 8337, 148, 3, 61, "Input"],

Cell[CellGroupData[{
Cell[557061, 8344, 127, 3, 38, "Input"],
Cell[557191, 8349, 112, 2, 39, "Output"]
}, Open  ]],
Cell[557318, 8354, 108, 5, 44, "Text"],

Cell[CellGroupData[{
Cell[557451, 8363, 133, 3, 45, "Input"],
Cell[557587, 8368, 195, 3, 39, "Output"]
}, Open  ]],
Cell[557797, 8374, 41, 0, 47, "BulletedList"],
Cell[557841, 8376, 168, 4, 66, "Text"],
Cell[558012, 8382, 604, 15, 133, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[558653, 8402, 134, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[558812, 8409, 904, 18, 314, "Input"],
Cell[559719, 8429, 1613, 40, 233, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[561381, 8475, 31, 0, 31, "Subsubsection"],
Cell[561415, 8477, 1613, 40, 233, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[563077, 8523, 40, 0, 50, "Subsection"],
Cell[563120, 8525, 197, 4, 75, "Input"],
Cell[563320, 8531, 144, 3, 61, "Input"],
Cell[563467, 8536, 335, 6, 107, "Input"],

Cell[CellGroupData[{
Cell[563827, 8546, 361, 10, 84, "Input"],
Cell[564191, 8558, 910, 14, 159, "Output"],
Cell[565104, 8574, 437, 7, 87, "Output"]
}, Open  ]],
Cell[565556, 8584, 97, 2, 43, "GraphicNoMagnification"],

Cell[CellGroupData[{
Cell[565678, 8590, 631, 13, 23, "Input",
  CellOpen->False],
Cell[566312, 8605, 23139, 544, 186, 4506, 309, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[589512, 9156, 37, 0, 53, "Section"],
Cell[589552, 9158, 441, 10, 70, "Text"],
Cell[589996, 9170, 28, 0, 43, "Text"],
Cell[590027, 9172, 83, 1, 47, "BulletedList"],
Cell[590113, 9175, 95, 3, 47, "BulletedList"],
Cell[590211, 9180, 141, 3, 74, "BulletedList"],

Cell[CellGroupData[{
Cell[590377, 9187, 52, 0, 50, "Subsection"],
Cell[590432, 9189, 97, 2, 43, "GraphicNoMagnification"],
Cell[590532, 9193, 143, 3, 23, "Input",
  CellOpen->False],

Cell[CellGroupData[{
Cell[590700, 9200, 206, 3, 61, "Input",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[590909, 9205, 125, 2, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[591037, 9209, 347, 7, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[591387, 9218, 617, 17, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[592007, 9237, 621, 13, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[592665, 9255, 121, 2, 38, "Input",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[592789, 9259, 677, 19, 243, "Output",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],
Cell[593481, 9281, 66, 1, 38, "Input"],
Cell[593550, 9284, 121, 2, 61, "Input"],
Cell[593674, 9288, 97, 2, 43, "GraphicNoMagnification"],
Cell[593774, 9292, 183, 5, 25, "Text",
  CellOpen->False],
Cell[593960, 9299, 547, 12, 25, "Text",
  CellOpen->False],
Cell[594510, 9313, 82, 1, 38, "Input"],

Cell[CellGroupData[{
Cell[594617, 9318, 338, 8, 153, "Input"],
Cell[594958, 9328, 71, 1, 39, "Output"],
Cell[595032, 9331, 54, 1, 39, "Output"],
Cell[595089, 9334, 57, 1, 39, "Output"]
}, Open  ]],
Cell[595161, 9338, 97, 2, 43, "GraphicNoMagnification"]
}, Open  ]],

Cell[CellGroupData[{
Cell[595295, 9345, 423, 7, 26, "Subsection",
  CellOpen->False],

Cell[CellGroupData[{
Cell[595743, 9356, 110, 2, 38, "Input"],
Cell[595856, 9360, 53, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[595946, 9366, 184, 4, 61, "Input"],
Cell[596133, 9372, 58, 1, 39, "Output"]
}, Open  ]],
Cell[596206, 9376, 220, 3, 84, "Input"],

Cell[CellGroupData[{
Cell[596451, 9383, 76, 1, 38, "Input"],
Cell[596530, 9386, 385, 6, 87, "Output"]
}, Open  ]],
Cell[596930, 9395, 127, 3, 38, "Input"],
Cell[597060, 9400, 97, 2, 43, "GraphicNoMagnification"],

Cell[CellGroupData[{
Cell[597182, 9406, 1720, 31, 23, "Input",
  CellOpen->False],
Cell[598905, 9439, 124, 2, 39, "Output"],
Cell[599032, 9443, 140, 3, 39, "Output"],
Cell[599175, 9448, 279, 5, 29, "Print"],
Cell[599457, 9455, 216, 4, 29, "Print"],
Cell[599676, 9461, 276, 7, 41, "Output"],
Cell[599955, 9470, 282, 7, 41, "Output"],
Cell[600240, 9479, 328, 6, 29, "Print"],
Cell[600571, 9487, 278, 6, 29, "Print"],
Cell[600852, 9495, 2517, 57, 243, "Output"],
Cell[603372, 9554, 58, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[603467, 9560, 189, 4, 61, "Input"],
Cell[603659, 9566, 124, 2, 39, "Output"]
}, Open  ]],
Cell[603798, 9571, 97, 2, 43, "GraphicNoMagnification"],
Cell[603898, 9575, 423, 9, 23, "Input",
  CellOpen->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[604358, 9589, 102, 3, 50, "Subsection"],

Cell[CellGroupData[{
Cell[604485, 9596, 104, 1, 48, "Subsubsection"],
Cell[604592, 9599, 97, 2, 43, "GraphicNoMagnification"],

Cell[CellGroupData[{
Cell[604714, 9605, 839, 20, 23, "Input",
  CellOpen->False],
Cell[605556, 9627, 16852, 455, 186, 4762, 301, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[622457, 10088, 64, 0, 47, "Subsubsection"],
Cell[622524, 10090, 313, 7, 68, "Text"],

Cell[CellGroupData[{
Cell[622862, 10101, 184, 3, 61, "Input"],
Cell[623049, 10106, 108, 2, 29, "Print"],
Cell[623160, 10110, 410, 7, 31, "Print"],
Cell[623573, 10119, 539, 9, 31, "Print"],
Cell[624115, 10130, 634, 11, 54, "Print"],
Cell[624752, 10143, 3541, 52, 271, "Print"],
Cell[628296, 10197, 591, 10, 55, "Print"],
Cell[628890, 10209, 4820, 68, 317, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[633747, 10282, 45, 1, 38, "Input"],
Cell[633795, 10285, 16701, 453, 186, 4753, 301, "GraphicsData", "PostScript", \
"Graphics"],
Cell[650499, 10740, 130, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[650666, 10748, 48, 1, 38, "Input"],
Cell[650717, 10751, 16631, 472, 186, 5036, 324, "GraphicsData", "PostScript", \
"Graphics"],
Cell[667351, 11225, 130, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[667518, 11233, 116, 2, 65, "Input"],
Cell[667637, 11237, 219, 3, 39, "Output"],
Cell[667859, 11242, 217, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[668113, 11250, 80, 1, 42, "Input"],
Cell[668196, 11253, 223, 3, 39, "Output"]
}, Open  ]],
Cell[668434, 11259, 148, 3, 61, "Input"],

Cell[CellGroupData[{
Cell[668607, 11266, 127, 3, 38, "Input"],
Cell[668737, 11271, 222, 3, 64, "Output"]
}, Open  ]],
Cell[668974, 11277, 108, 5, 44, "Text"],

Cell[CellGroupData[{
Cell[669107, 11286, 133, 3, 45, "Input"],
Cell[669243, 11291, 457, 8, 87, "Output"]
}, Open  ]],
Cell[669715, 11302, 41, 0, 47, "BulletedList"],
Cell[669759, 11304, 168, 4, 66, "Text"],
Cell[669930, 11310, 604, 15, 133, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[670571, 11330, 134, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[670730, 11337, 904, 18, 314, "Input"],
Cell[671637, 11357, 2160, 49, 367, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[673846, 11412, 31, 0, 31, "Subsubsection"],
Cell[673880, 11414, 2160, 49, 367, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[676077, 11468, 34, 0, 47, "Subsubsection"],
Cell[676114, 11470, 423, 8, 91, "Text"],

Cell[CellGroupData[{
Cell[676562, 11482, 366, 8, 163, "Input"],
Cell[676931, 11492, 63, 1, 39, "Output"],
Cell[676997, 11495, 58, 1, 39, "Output"],
Cell[677058, 11498, 53, 1, 39, "Output"],
Cell[677114, 11501, 54, 1, 39, "Output"]
}, Open  ]],
Cell[677183, 11505, 113, 3, 43, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[677345, 11514, 45, 0, 50, "Subsection"],
Cell[677393, 11516, 315, 8, 70, "Text"],

Cell[CellGroupData[{
Cell[677733, 11528, 48, 1, 38, "Input"],
Cell[677784, 11531, 124, 2, 39, "Output"]
}, Open  ]],
Cell[677923, 11536, 173, 4, 61, "Input"],
Cell[678099, 11542, 118, 3, 47, "BulletedList"],
Cell[678220, 11547, 83, 1, 38, "Input"],

Cell[CellGroupData[{
Cell[678328, 11552, 173, 4, 61, "Input"],
Cell[678504, 11558, 124, 2, 39, "Output"],
Cell[678631, 11562, 66, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[678734, 11568, 251, 6, 38, "Input"],
Cell[678988, 11576, 108, 2, 29, "Print"],
Cell[679099, 11580, 411, 7, 31, "Print"],
Cell[679513, 11589, 246, 5, 31, "Print"],
Cell[679762, 11596, 206, 4, 30, "Print"],
Cell[679971, 11602, 268, 6, 31, "Print"],
Cell[680242, 11610, 249, 5, 31, "Print"],
Cell[680494, 11617, 681, 11, 53, "Print"],
Cell[681178, 11630, 108, 2, 29, "Print"],
Cell[681289, 11634, 410, 7, 31, "Print"],
Cell[681702, 11643, 247, 5, 31, "Print"],
Cell[681952, 11650, 204, 4, 30, "Print"],
Cell[682159, 11656, 270, 6, 31, "Print"],
Cell[682432, 11664, 249, 5, 31, "Print"],
Cell[682684, 11671, 1218, 19, 77, "Print"],
Cell[683905, 11692, 108, 2, 29, "Print"],
Cell[684016, 11696, 411, 7, 31, "Print"],
Cell[684430, 11705, 247, 5, 31, "Print"],
Cell[684680, 11712, 206, 4, 30, "Print"],
Cell[684889, 11718, 269, 6, 31, "Print"],
Cell[685161, 11726, 247, 5, 31, "Print"],
Cell[685411, 11733, 687, 12, 53, "Print"],
Cell[686101, 11747, 108, 2, 29, "Print"],
Cell[686212, 11751, 411, 7, 31, "Print"],
Cell[686626, 11760, 247, 5, 31, "Print"],
Cell[686876, 11767, 206, 4, 30, "Print"],
Cell[687085, 11773, 269, 6, 31, "Print"],
Cell[687357, 11781, 248, 5, 31, "Print"],
Cell[687608, 11788, 677, 11, 53, "Print"],
Cell[688288, 11801, 108, 2, 29, "Print"],
Cell[688399, 11805, 409, 7, 31, "Print"],
Cell[688811, 11814, 247, 5, 31, "Print"],
Cell[689061, 11821, 206, 4, 30, "Print"],
Cell[689270, 11827, 270, 6, 31, "Print"],
Cell[689543, 11835, 249, 5, 31, "Print"],
Cell[689795, 11842, 545, 10, 53, "Print"],
Cell[690343, 11854, 108, 2, 29, "Print"],
Cell[690454, 11858, 410, 7, 31, "Print"],
Cell[690867, 11867, 247, 5, 31, "Print"],
Cell[691117, 11874, 212, 4, 30, "Print"],
Cell[691332, 11880, 269, 6, 31, "Print"],
Cell[691604, 11888, 248, 5, 31, "Print"],
Cell[691855, 11895, 723, 12, 53, "Print"],
Cell[692581, 11909, 277, 4, 24, "Message"],
Cell[692861, 11915, 269, 4, 24, "Message"],
Cell[693133, 11921, 328, 4, 24, "Message"],
Cell[693464, 11927, 269, 4, 24, "Message"],
Cell[693736, 11933, 269, 4, 24, "Message"],
Cell[694008, 11939, 331, 5, 24, "Message"],
Cell[694342, 11946, 411, 7, 31, "Print"],
Cell[694756, 11955, 247, 5, 31, "Print"],
Cell[695006, 11962, 206, 4, 30, "Print"],
Cell[695215, 11968, 281, 6, 31, "Print"],
Cell[695499, 11976, 358, 9, 32, "Print"],
Cell[695860, 11987, 409, 9, 30, "Print"],
Cell[696272, 11998, 108, 2, 29, "Print"],
Cell[696383, 12002, 411, 7, 31, "Print"],
Cell[696797, 12011, 245, 5, 31, "Print"],
Cell[697045, 12018, 206, 4, 30, "Print"],
Cell[697254, 12024, 270, 6, 31, "Print"],
Cell[697527, 12032, 249, 5, 31, "Print"],
Cell[697779, 12039, 685, 12, 53, "Print"]
}, Closed]],
Cell[698479, 12054, 388, 10, 101, "Input"],
Cell[698870, 12066, 1212, 30, 189, "Text"],

Cell[CellGroupData[{
Cell[700107, 12100, 205, 3, 61, "Input"],
Cell[700315, 12105, 224338, 6441, 627, 135195, 5336, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[924714, 18553, 38, 0, 53, "Section"],
Cell[924755, 18555, 476, 10, 95, "Text"],
Cell[925234, 18567, 28, 0, 43, "Text"],
Cell[925265, 18569, 188, 4, 74, "BulletedList"],
Cell[925456, 18575, 95, 3, 47, "BulletedList"],
Cell[925554, 18580, 106, 3, 47, "BulletedList"],

Cell[CellGroupData[{
Cell[925685, 18587, 52, 0, 50, "Subsection"],
Cell[925740, 18589, 97, 2, 43, "GraphicNoMagnification"],
Cell[925840, 18593, 153, 3, 23, "Input",
  CellOpen->False],

Cell[CellGroupData[{
Cell[926018, 18600, 208, 3, 61, "Input",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[926229, 18605, 186, 3, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[926418, 18610, 414, 8, 29, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[926835, 18620, 911, 27, 53, "Print",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[927749, 18649, 989, 19, 53, "Print",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],
Cell[928753, 18671, 113, 3, 47, "BulletedList"],
Cell[928869, 18676, 42, 0, 47, "BulletedList"],
Cell[928914, 18678, 99, 3, 47, "BulletedList"],
Cell[929016, 18683, 58, 0, 47, "BulletedList"],

Cell[CellGroupData[{
Cell[929099, 18687, 121, 2, 38, "Input",
  CellTags->{"Data Routines", "close Data Routines"}],
Cell[929223, 18691, 1196, 27, 243, "Output",
  CellTags->{"Data Routines", "close Data Routines"}]
}, Open  ]],
Cell[930434, 18721, 66, 1, 38, "Input"],
Cell[930503, 18724, 129, 2, 61, "Input"],
Cell[930635, 18728, 97, 2, 43, "GraphicNoMagnification"],
Cell[930735, 18732, 183, 5, 25, "Text",
  CellOpen->False],
Cell[930921, 18739, 547, 12, 25, "Text",
  CellOpen->False],
Cell[931471, 18753, 142, 2, 61, "Input"],

Cell[CellGroupData[{
Cell[931638, 18759, 424, 10, 176, "Input"],
Cell[932065, 18771, 124, 3, 39, "Output"],
Cell[932192, 18776, 84, 1, 39, "Output"],
Cell[932279, 18779, 162, 3, 39, "Output"]
}, Open  ]],
Cell[932456, 18785, 97, 2, 43, "GraphicNoMagnification"]
}, Open  ]],

Cell[CellGroupData[{
Cell[932590, 18792, 423, 7, 26, "Subsection",
  CellOpen->False],
Cell[933016, 18801, 123, 3, 47, "BulletedList"],
Cell[933142, 18806, 163, 4, 25, "Text",
  CellOpen->False],

Cell[CellGroupData[{
Cell[933330, 18814, 253, 6, 61, "Input"],
Cell[933586, 18822, 73, 1, 39, "Output"],
Cell[933662, 18825, 54, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[933753, 18831, 648, 14, 222, "Input"],
Cell[934404, 18847, 64, 1, 39, "Output"],
Cell[934471, 18850, 42, 1, 39, "Output"],
Cell[934516, 18853, 166, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[934719, 18861, 586, 14, 130, "Input"],
Cell[935308, 18877, 40, 1, 39, "Output"],
Cell[935351, 18880, 41, 1, 39, "Output"],
Cell[935395, 18883, 40, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[935472, 18889, 76, 1, 38, "Input"],
Cell[935551, 18892, 405, 7, 111, "Output"]
}, Open  ]],
Cell[935971, 18902, 127, 3, 38, "Input"],
Cell[936101, 18907, 97, 2, 43, "GraphicNoMagnification"],

Cell[CellGroupData[{
Cell[936223, 18913, 1720, 31, 23, "Input",
  CellOpen->False],
Cell[937946, 18946, 128, 3, 39, "Output"],
Cell[938077, 18951, 137, 3, 39, "Output"],
Cell[938217, 18956, 294, 5, 29, "Print"],
Cell[938514, 18963, 285, 5, 29, "Print"],
Cell[938802, 18970, 276, 7, 41, "Output"],
Cell[939081, 18979, 282, 7, 41, "Output"],
Cell[939366, 18988, 306, 6, 29, "Print"],
Cell[939675, 18996, 259, 5, 29, "Print"],
Cell[939937, 19003, 2620, 65, 243, "Output"],
Cell[942560, 19070, 42, 1, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[942639, 19076, 107, 2, 38, "Input"],
Cell[942749, 19080, 166, 3, 39, "Output"]
}, Open  ]],
Cell[942930, 19086, 423, 9, 23, "Input",
  CellOpen->False]
}, Open  ]],

Cell[CellGroupData[{
Cell[943390, 19100, 103, 3, 79, "Subsection"],

Cell[CellGroupData[{
Cell[943518, 19107, 104, 1, 48, "Subsubsection"],
Cell[943625, 19110, 97, 2, 43, "GraphicNoMagnification"],

Cell[CellGroupData[{
Cell[943747, 19116, 839, 20, 23, "Input",
  CellOpen->False],
Cell[944589, 19138, 16913, 425, 186, 3789, 258, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[961551, 19569, 64, 0, 47, "Subsubsection"],

Cell[CellGroupData[{
Cell[961640, 19573, 184, 3, 61, "Input"],
Cell[961827, 19578, 108, 2, 29, "Print"],
Cell[961938, 19582, 410, 7, 31, "Print"],
Cell[962351, 19591, 545, 11, 31, "Print"],
Cell[962899, 19604, 601, 12, 54, "Print"],
Cell[963503, 19618, 3023, 52, 247, "Print"],
Cell[966529, 19672, 551, 9, 55, "Print"],
Cell[967083, 19683, 1845, 28, 125, "Print"]
}, Open  ]],

Cell[CellGroupData[{
Cell[968965, 19716, 45, 1, 38, "Input"],
Cell[969013, 19719, 16887, 424, 186, 3784, 258, "GraphicsData", "PostScript", \
"Graphics"],
Cell[985903, 20145, 130, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[986070, 20153, 48, 1, 38, "Input"],
Cell[986121, 20156, 16265, 402, 186, 3450, 239, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1002389, 20560, 130, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1002556, 20568, 116, 2, 65, "Input"],
Cell[1002675, 20572, 231, 4, 63, "Output"],
Cell[1002909, 20578, 201, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1003147, 20586, 80, 1, 42, "Input"],
Cell[1003230, 20589, 222, 4, 39, "Output"]
}, Open  ]],
Cell[1003467, 20596, 148, 3, 61, "Input"],

Cell[CellGroupData[{
Cell[1003640, 20603, 127, 3, 38, "Input"],
Cell[1003770, 20608, 201, 3, 39, "Output"]
}, Open  ]],
Cell[1003986, 20614, 108, 5, 44, "Text"],

Cell[CellGroupData[{
Cell[1004119, 20623, 133, 3, 45, "Input"],
Cell[1004255, 20628, 445, 8, 87, "Output"]
}, Open  ]],
Cell[1004715, 20639, 41, 0, 47, "BulletedList"],
Cell[1004759, 20641, 168, 4, 66, "Text"],
Cell[1004930, 20647, 604, 15, 133, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1005571, 20667, 134, 3, 57, "Subsubsection"],

Cell[CellGroupData[{
Cell[1005730, 20674, 904, 18, 155, "Input"],
Cell[1006637, 20694, 2108, 48, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1008794, 20748, 31, 0, 31, "Subsubsection"],
Cell[1008828, 20750, 2108, 48, 341, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1010973, 20803, 52, 0, 47, "Subsubsection"],

Cell[CellGroupData[{
Cell[1011050, 20807, 48, 1, 38, "Input"],
Cell[1011101, 20810, 166, 3, 39, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1011304, 20818, 897, 16, 130, "Input"],
Cell[1012204, 20836, 108, 2, 29, "Print"],
Cell[1012315, 20840, 410, 7, 31, "Print"],
Cell[1012728, 20849, 478, 9, 31, "Print"],
Cell[1013209, 20860, 529, 10, 54, "Print"],
Cell[1013741, 20872, 2259, 38, 175, "Print"],
Cell[1016003, 20912, 506, 9, 55, "Print"],
Cell[1016512, 20923, 1834, 27, 125, "Print"],
Cell[1018349, 20952, 57, 1, 39, "Output"],
Cell[1018409, 20955, 108, 2, 29, "Print"],
Cell[1018520, 20959, 410, 7, 31, "Print"],
Cell[1018933, 20968, 489, 9, 31, "Print"],
Cell[1019425, 20979, 542, 11, 54, "Print"],
Cell[1019970, 20992, 2253, 37, 175, "Print"],
Cell[1022226, 21031, 505, 9, 55, "Print"],
Cell[1022734, 21042, 1849, 28, 125, "Print"],
Cell[1024586, 21072, 57, 1, 39, "Output"],
Cell[1024646, 21075, 108, 2, 29, "Print"],
Cell[1024757, 21079, 410, 7, 31, "Print"],
Cell[1025170, 21088, 482, 9, 31, "Print"],
Cell[1025655, 21099, 522, 9, 54, "Print"],
Cell[1026180, 21110, 2253, 37, 175, "Print"],
Cell[1028436, 21149, 508, 9, 31, "Print"],
Cell[1028947, 21160, 1848, 28, 125, "Print"],
Cell[1030798, 21190, 57, 1, 39, "Output"],
Cell[1030858, 21193, 108, 2, 29, "Print"],
Cell[1030969, 21197, 410, 7, 31, "Print"],
Cell[1031382, 21206, 400, 7, 31, "Print"],
Cell[1031785, 21215, 389, 8, 30, "Print"],
Cell[1032177, 21225, 1209, 23, 127, "Print"],
Cell[1033389, 21250, 403, 7, 31, "Print"],
Cell[1033795, 21259, 1832, 27, 125, "Print"],
Cell[1035630, 21288, 57, 1, 39, "Output"],
Cell[1035690, 21291, 108, 2, 29, "Print"],
Cell[1035801, 21295, 409, 7, 31, "Print"],
Cell[1036213, 21304, 481, 9, 31, "Print"],
Cell[1036697, 21315, 528, 11, 54, "Print"],
Cell[1037228, 21328, 2300, 41, 199, "Print"],
Cell[1039531, 21371, 508, 9, 55, "Print"],
Cell[1040042, 21382, 1842, 28, 125, "Print"],
Cell[1041887, 21412, 57, 1, 39, "Output"],
Cell[1041947, 21415, 160, 4, 29, "Print"],
Cell[1042110, 21421, 462, 9, 31, "Print"],
Cell[1042575, 21432, 530, 11, 31, "Print"],
Cell[1043108, 21445, 581, 12, 54, "Print"],
Cell[1043692, 21459, 2311, 40, 175, "Print"],
Cell[1046006, 21501, 558, 11, 55, "Print"],
Cell[1046567, 21514, 1886, 29, 125, "Print"],
Cell[1048456, 21545, 109, 3, 39, "Output"],
Cell[1048568, 21550, 160, 4, 29, "Print"],
Cell[1048731, 21556, 462, 9, 31, "Print"],
Cell[1049196, 21567, 541, 11, 31, "Print"],
Cell[1049740, 21580, 594, 13, 54, "Print"],
Cell[1050337, 21595, 2305, 39, 175, "Print"],
Cell[1052645, 21636, 557, 11, 55, "Print"],
Cell[1053205, 21649, 1901, 30, 125, "Print"],
Cell[1055109, 21681, 109, 3, 39, "Output"],
Cell[1055221, 21686, 160, 4, 29, "Print"],
Cell[1055384, 21692, 462, 9, 31, "Print"],
Cell[1055849, 21703, 534, 11, 31, "Print"],
Cell[1056386, 21716, 574, 11, 54, "Print"],
Cell[1056963, 21729, 2305, 39, 175, "Print"],
Cell[1059271, 21770, 560, 11, 31, "Print"],
Cell[1059834, 21783, 1900, 30, 125, "Print"],
Cell[1061737, 21815, 109, 3, 39, "Output"],
Cell[1061849, 21820, 160, 4, 29, "Print"],
Cell[1062012, 21826, 462, 9, 31, "Print"],
Cell[1062477, 21837, 452, 9, 31, "Print"],
Cell[1062932, 21848, 441, 10, 30, "Print"],
Cell[1063376, 21860, 1261, 25, 127, "Print"],
Cell[1064640, 21887, 455, 9, 31, "Print"],
Cell[1065098, 21898, 1884, 29, 125, "Print"],
Cell[1066985, 21929, 109, 3, 39, "Output"],
Cell[1067097, 21934, 160, 4, 29, "Print"],
Cell[1067260, 21940, 461, 9, 31, "Print"],
Cell[1067724, 21951, 533, 11, 31, "Print"],
Cell[1068260, 21964, 580, 13, 54, "Print"],
Cell[1068843, 21979, 2352, 43, 199, "Print"],
Cell[1071198, 22024, 560, 11, 55, "Print"],
Cell[1071761, 22037, 1894, 30, 125, "Print"],
Cell[1073658, 22069, 109, 3, 39, "Output"]
}, Closed]],
Cell[1073782, 22075, 687, 12, 124, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1074506, 22092, 73, 0, 47, "Subsubsection"],

Cell[CellGroupData[{
Cell[1074604, 22096, 691, 14, 139, "Input"],
Cell[1075298, 22112, 1259, 32, 70, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1076606, 22150, 31, 0, 31, "Subsubsection"],
Cell[1076640, 22152, 1259, 32, 235, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1077960, 22191, 30, 0, 53, "Section"],
Cell[1077993, 22193, 994, 20, 170, "Text"],

Cell[CellGroupData[{
Cell[1079012, 22217, 37, 0, 50, "Subsection"],
Cell[1079052, 22219, 129, 3, 43, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

